/*
Copyright (c) 2010, Geomatics and Cartographic Research Centre, 
Carleton University, Canada
All rights reserved.

Released under New BSD License.
Details at:
   https://svn.gcrc.carleton.ca/nunaliit2/trunk/sdk/license.txt
   
$Id: license.txt 8178 2012-06-04 20:46:29Z jpfiset $   
*/


var Handlebars=(function(){var __module4__=(function(){"use strict";var __exports__;function SafeString(string){this.string=string;}
SafeString.prototype.toString=function(){return""+this.string;};__exports__=SafeString;return __exports__;})();var __module3__=(function(__dependency1__){"use strict";var __exports__={};var SafeString=__dependency1__;var escape={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"};var badChars=/[&<>"'`]/g;var possible=/[&<>"'`]/;function escapeChar(chr){return escape[chr]||"&amp;";}
function extend(obj,value){for(var key in value){if(Object.prototype.hasOwnProperty.call(value,key)){obj[key]=value[key];}}}
__exports__.extend=extend;var toString=Object.prototype.toString;__exports__.toString=toString;var isFunction=function(value){return typeof value==='function';};if(isFunction(/x/)){isFunction=function(value){return typeof value==='function'&&toString.call(value)==='[object Function]';};}
var isFunction;__exports__.isFunction=isFunction;var isArray=Array.isArray||function(value){return(value&&typeof value==='object')?toString.call(value)==='[object Array]':false;};__exports__.isArray=isArray;function escapeExpression(string){if(string instanceof SafeString){return string.toString();}else if(!string&&string!==0){return"";}
string=""+string;if(!possible.test(string)){return string;}
return string.replace(badChars,escapeChar);}
__exports__.escapeExpression=escapeExpression;function isEmpty(value){if(!value&&value!==0){return true;}else if(isArray(value)&&value.length===0){return true;}else{return false;}}
__exports__.isEmpty=isEmpty;return __exports__;})(__module4__);var __module5__=(function(){"use strict";var __exports__;var errorProps=['description','fileName','lineNumber','message','name','number','stack'];function Exception(message,node){var line;if(node&&node.firstLine){line=node.firstLine;message+=' - '+line+':'+node.firstColumn;}
var tmp=Error.prototype.constructor.call(this,message);for(var idx=0;idx<errorProps.length;idx++){this[errorProps[idx]]=tmp[errorProps[idx]];}
if(line){this.lineNumber=line;this.column=node.firstColumn;}}
Exception.prototype=new Error();__exports__=Exception;return __exports__;})();var __module2__=(function(__dependency1__,__dependency2__){"use strict";var __exports__={};var Utils=__dependency1__;var Exception=__dependency2__;var VERSION="1.3.0";__exports__.VERSION=VERSION;var COMPILER_REVISION=4;__exports__.COMPILER_REVISION=COMPILER_REVISION;var REVISION_CHANGES={1:'<= 1.0.rc.2',2:'== 1.0.0-rc.3',3:'== 1.0.0-rc.4',4:'>= 1.0.0'};__exports__.REVISION_CHANGES=REVISION_CHANGES;var isArray=Utils.isArray,isFunction=Utils.isFunction,toString=Utils.toString,objectType='[object Object]';function HandlebarsEnvironment(helpers,partials){this.helpers=helpers||{};this.partials=partials||{};registerDefaultHelpers(this);}
__exports__.HandlebarsEnvironment=HandlebarsEnvironment;HandlebarsEnvironment.prototype={constructor:HandlebarsEnvironment,logger:logger,log:log,registerHelper:function(name,fn,inverse){if(toString.call(name)===objectType){if(inverse||fn){throw new Exception('Arg not supported with multiple helpers');}
Utils.extend(this.helpers,name);}else{if(inverse){fn.not=inverse;}
this.helpers[name]=fn;}},registerPartial:function(name,str){if(toString.call(name)===objectType){Utils.extend(this.partials,name);}else{this.partials[name]=str;}}};function registerDefaultHelpers(instance){instance.registerHelper('helperMissing',function(arg){if(arguments.length===2){return undefined;}else{throw new Exception("Missing helper: '"+arg+"'");}});instance.registerHelper('blockHelperMissing',function(context,options){var inverse=options.inverse||function(){},fn=options.fn;if(isFunction(context)){context=context.call(this);}
if(context===true){return fn(this);}else if(context===false||context==null){return inverse(this);}else if(isArray(context)){if(context.length>0){return instance.helpers.each(context,options);}else{return inverse(this);}}else{return fn(context);}});instance.registerHelper('each',function(context,options){var fn=options.fn,inverse=options.inverse;var i=0,ret="",data;if(isFunction(context)){context=context.call(this);}
if(options.data){data=createFrame(options.data);}
if(context&&typeof context==='object'){if(isArray(context)){for(var j=context.length;i<j;i++){if(data){data.index=i;data.first=(i===0);data.last=(i===(context.length-1));}
ret=ret+fn(context[i],{data:data});}}else{for(var key in context){if(context.hasOwnProperty(key)){if(data){data.key=key;data.index=i;data.first=(i===0);}
ret=ret+fn(context[key],{data:data});i++;}}}}
if(i===0){ret=inverse(this);}
return ret;});instance.registerHelper('if',function(conditional,options){if(isFunction(conditional)){conditional=conditional.call(this);}
if((!options.hash.includeZero&&!conditional)||Utils.isEmpty(conditional)){return options.inverse(this);}else{return options.fn(this);}});instance.registerHelper('unless',function(conditional,options){return instance.helpers['if'].call(this,conditional,{fn:options.inverse,inverse:options.fn,hash:options.hash});});instance.registerHelper('with',function(context,options){if(isFunction(context)){context=context.call(this);}
if(!Utils.isEmpty(context))return options.fn(context);});instance.registerHelper('log',function(context,options){var level=options.data&&options.data.level!=null?parseInt(options.data.level,10):1;instance.log(level,context);});}
var logger={methodMap:{0:'debug',1:'info',2:'warn',3:'error'},DEBUG:0,INFO:1,WARN:2,ERROR:3,level:3,log:function(level,obj){if(logger.level<=level){var method=logger.methodMap[level];if(typeof console!=='undefined'&&console[method]){console[method].call(console,obj);}}}};__exports__.logger=logger;function log(level,obj){logger.log(level,obj);}
__exports__.log=log;var createFrame=function(object){var obj={};Utils.extend(obj,object);return obj;};__exports__.createFrame=createFrame;return __exports__;})(__module3__,__module5__);var __module6__=(function(__dependency1__,__dependency2__,__dependency3__){"use strict";var __exports__={};var Utils=__dependency1__;var Exception=__dependency2__;var COMPILER_REVISION=__dependency3__.COMPILER_REVISION;var REVISION_CHANGES=__dependency3__.REVISION_CHANGES;function checkRevision(compilerInfo){var compilerRevision=compilerInfo&&compilerInfo[0]||1,currentRevision=COMPILER_REVISION;if(compilerRevision!==currentRevision){if(compilerRevision<currentRevision){var runtimeVersions=REVISION_CHANGES[currentRevision],compilerVersions=REVISION_CHANGES[compilerRevision];throw new Exception("Template was precompiled with an older version of Handlebars than the current runtime. "+"Please update your precompiler to a newer version ("+runtimeVersions+") or downgrade your runtime to an older version ("+compilerVersions+").");}else{throw new Exception("Template was precompiled with a newer version of Handlebars than the current runtime. "+"Please update your runtime to a newer version ("+compilerInfo[1]+").");}}}
__exports__.checkRevision=checkRevision;function template(templateSpec,env){if(!env){throw new Exception("No environment passed to template");}
var invokePartialWrapper=function(partial,name,context,helpers,partials,data){var result=env.VM.invokePartial.apply(this,arguments);if(result!=null){return result;}
if(env.compile){var options={helpers:helpers,partials:partials,data:data};partials[name]=env.compile(partial,{data:data!==undefined},env);return partials[name](context,options);}else{throw new Exception("The partial "+name+" could not be compiled when running in runtime-only mode");}};var container={escapeExpression:Utils.escapeExpression,invokePartial:invokePartialWrapper,programs:[],program:function(i,fn,data){var programWrapper=this.programs[i];if(data){programWrapper=program(i,fn,data);}else if(!programWrapper){programWrapper=this.programs[i]=program(i,fn);}
return programWrapper;},merge:function(param,common){var ret=param||common;if(param&&common&&(param!==common)){ret={};Utils.extend(ret,common);Utils.extend(ret,param);}
return ret;},programWithDepth:env.VM.programWithDepth,noop:env.VM.noop,compilerInfo:null};return function(context,options){options=options||{};var namespace=options.partial?options:env,helpers,partials;if(!options.partial){helpers=options.helpers;partials=options.partials;}
var result=templateSpec.call(container,namespace,context,helpers,partials,options.data);if(!options.partial){env.VM.checkRevision(container.compilerInfo);}
return result;};}
__exports__.template=template;function programWithDepth(i,fn,data){var args=Array.prototype.slice.call(arguments,3);var prog=function(context,options){options=options||{};return fn.apply(this,[context,options.data||data].concat(args));};prog.program=i;prog.depth=args.length;return prog;}
__exports__.programWithDepth=programWithDepth;function program(i,fn,data){var prog=function(context,options){options=options||{};return fn(context,options.data||data);};prog.program=i;prog.depth=0;return prog;}
__exports__.program=program;function invokePartial(partial,name,context,helpers,partials,data){var options={partial:true,helpers:helpers,partials:partials,data:data};if(partial===undefined){throw new Exception("The partial "+name+" could not be found");}else if(partial instanceof Function){return partial(context,options);}}
__exports__.invokePartial=invokePartial;function noop(){return"";}
__exports__.noop=noop;return __exports__;})(__module3__,__module5__,__module2__);var __module1__=(function(__dependency1__,__dependency2__,__dependency3__,__dependency4__,__dependency5__){"use strict";var __exports__;var base=__dependency1__;var SafeString=__dependency2__;var Exception=__dependency3__;var Utils=__dependency4__;var runtime=__dependency5__;var create=function(){var hb=new base.HandlebarsEnvironment();Utils.extend(hb,base);hb.SafeString=SafeString;hb.Exception=Exception;hb.Utils=Utils;hb.VM=runtime;hb.template=function(spec){return runtime.template(spec,hb);};return hb;};var Handlebars=create();Handlebars.create=create;__exports__=Handlebars;return __exports__;})(__module2__,__module4__,__module5__,__module3__,__module6__);var __module7__=(function(__dependency1__){"use strict";var __exports__;var Exception=__dependency1__;function LocationInfo(locInfo){locInfo=locInfo||{};this.firstLine=locInfo.first_line;this.firstColumn=locInfo.first_column;this.lastColumn=locInfo.last_column;this.lastLine=locInfo.last_line;}
var AST={ProgramNode:function(statements,inverseStrip,inverse,locInfo){var inverseLocationInfo,firstInverseNode;if(arguments.length===3){locInfo=inverse;inverse=null;}else if(arguments.length===2){locInfo=inverseStrip;inverseStrip=null;}
LocationInfo.call(this,locInfo);this.type="program";this.statements=statements;this.strip={};if(inverse){firstInverseNode=inverse[0];if(firstInverseNode){inverseLocationInfo={first_line:firstInverseNode.firstLine,last_line:firstInverseNode.lastLine,last_column:firstInverseNode.lastColumn,first_column:firstInverseNode.firstColumn};this.inverse=new AST.ProgramNode(inverse,inverseStrip,inverseLocationInfo);}else{this.inverse=new AST.ProgramNode(inverse,inverseStrip);}
this.strip.right=inverseStrip.left;}else if(inverseStrip){this.strip.left=inverseStrip.right;}},MustacheNode:function(rawParams,hash,open,strip,locInfo){LocationInfo.call(this,locInfo);this.type="mustache";this.strip=strip;if(open!=null&&open.charAt){var escapeFlag=open.charAt(3)||open.charAt(2);this.escaped=escapeFlag!=='{'&&escapeFlag!=='&';}else{this.escaped=!!open;}
if(rawParams instanceof AST.SexprNode){this.sexpr=rawParams;}else{this.sexpr=new AST.SexprNode(rawParams,hash);}
this.sexpr.isRoot=true;this.id=this.sexpr.id;this.params=this.sexpr.params;this.hash=this.sexpr.hash;this.eligibleHelper=this.sexpr.eligibleHelper;this.isHelper=this.sexpr.isHelper;},SexprNode:function(rawParams,hash,locInfo){LocationInfo.call(this,locInfo);this.type="sexpr";this.hash=hash;var id=this.id=rawParams[0];var params=this.params=rawParams.slice(1);var eligibleHelper=this.eligibleHelper=id.isSimple;this.isHelper=eligibleHelper&&(params.length||hash);},PartialNode:function(partialName,context,strip,locInfo){LocationInfo.call(this,locInfo);this.type="partial";this.partialName=partialName;this.context=context;this.strip=strip;},BlockNode:function(mustache,program,inverse,close,locInfo){LocationInfo.call(this,locInfo);if(mustache.sexpr.id.original!==close.path.original){throw new Exception(mustache.sexpr.id.original+" doesn't match "+close.path.original,this);}
this.type='block';this.mustache=mustache;this.program=program;this.inverse=inverse;this.strip={left:mustache.strip.left,right:close.strip.right};(program||inverse).strip.left=mustache.strip.right;(inverse||program).strip.right=close.strip.left;if(inverse&&!program){this.isInverse=true;}},ContentNode:function(string,locInfo){LocationInfo.call(this,locInfo);this.type="content";this.string=string;},HashNode:function(pairs,locInfo){LocationInfo.call(this,locInfo);this.type="hash";this.pairs=pairs;},IdNode:function(parts,locInfo){LocationInfo.call(this,locInfo);this.type="ID";var original="",dig=[],depth=0;for(var i=0,l=parts.length;i<l;i++){var part=parts[i].part;original+=(parts[i].separator||'')+part;if(part===".."||part==="."||part==="this"){if(dig.length>0){throw new Exception("Invalid path: "+original,this);}else if(part===".."){depth++;}else{this.isScoped=true;}}else{dig.push(part);}}
this.original=original;this.parts=dig;this.string=dig.join('.');this.depth=depth;this.isSimple=parts.length===1&&!this.isScoped&&depth===0;this.stringModeValue=this.string;},PartialNameNode:function(name,locInfo){LocationInfo.call(this,locInfo);this.type="PARTIAL_NAME";this.name=name.original;},DataNode:function(id,locInfo){LocationInfo.call(this,locInfo);this.type="DATA";this.id=id;},StringNode:function(string,locInfo){LocationInfo.call(this,locInfo);this.type="STRING";this.original=this.string=this.stringModeValue=string;},IntegerNode:function(integer,locInfo){LocationInfo.call(this,locInfo);this.type="INTEGER";this.original=this.integer=integer;this.stringModeValue=Number(integer);},BooleanNode:function(bool,locInfo){LocationInfo.call(this,locInfo);this.type="BOOLEAN";this.bool=bool;this.stringModeValue=bool==="true";},CommentNode:function(comment,locInfo){LocationInfo.call(this,locInfo);this.type="comment";this.comment=comment;}};__exports__=AST;return __exports__;})(__module5__);var __module9__=(function(){"use strict";var __exports__;var handlebars=(function(){var parser={trace:function trace(){},yy:{},symbols_:{"error":2,"root":3,"statements":4,"EOF":5,"program":6,"simpleInverse":7,"statement":8,"openInverse":9,"closeBlock":10,"openBlock":11,"mustache":12,"partial":13,"CONTENT":14,"COMMENT":15,"OPEN_BLOCK":16,"sexpr":17,"CLOSE":18,"OPEN_INVERSE":19,"OPEN_ENDBLOCK":20,"path":21,"OPEN":22,"OPEN_UNESCAPED":23,"CLOSE_UNESCAPED":24,"OPEN_PARTIAL":25,"partialName":26,"partial_option0":27,"sexpr_repetition0":28,"sexpr_option0":29,"dataName":30,"param":31,"STRING":32,"INTEGER":33,"BOOLEAN":34,"OPEN_SEXPR":35,"CLOSE_SEXPR":36,"hash":37,"hash_repetition_plus0":38,"hashSegment":39,"ID":40,"EQUALS":41,"DATA":42,"pathSegments":43,"SEP":44,"$accept":0,"$end":1},terminals_:{2:"error",5:"EOF",14:"CONTENT",15:"COMMENT",16:"OPEN_BLOCK",18:"CLOSE",19:"OPEN_INVERSE",20:"OPEN_ENDBLOCK",22:"OPEN",23:"OPEN_UNESCAPED",24:"CLOSE_UNESCAPED",25:"OPEN_PARTIAL",32:"STRING",33:"INTEGER",34:"BOOLEAN",35:"OPEN_SEXPR",36:"CLOSE_SEXPR",40:"ID",41:"EQUALS",42:"DATA",44:"SEP"},productions_:[0,[3,2],[3,1],[6,2],[6,3],[6,2],[6,1],[6,1],[6,0],[4,1],[4,2],[8,3],[8,3],[8,1],[8,1],[8,1],[8,1],[11,3],[9,3],[10,3],[12,3],[12,3],[13,4],[7,2],[17,3],[17,1],[31,1],[31,1],[31,1],[31,1],[31,1],[31,3],[37,1],[39,3],[26,1],[26,1],[26,1],[30,2],[21,1],[43,3],[43,1],[27,0],[27,1],[28,0],[28,2],[29,0],[29,1],[38,1],[38,2]],performAction:function anonymous(yytext,yyleng,yylineno,yy,yystate,$$,_$){var $0=$$.length-1;switch(yystate){case 1:return new yy.ProgramNode($$[$0-1],this._$);break;case 2:return new yy.ProgramNode([],this._$);break;case 3:this.$=new yy.ProgramNode([],$$[$0-1],$$[$0],this._$);break;case 4:this.$=new yy.ProgramNode($$[$0-2],$$[$0-1],$$[$0],this._$);break;case 5:this.$=new yy.ProgramNode($$[$0-1],$$[$0],[],this._$);break;case 6:this.$=new yy.ProgramNode($$[$0],this._$);break;case 7:this.$=new yy.ProgramNode([],this._$);break;case 8:this.$=new yy.ProgramNode([],this._$);break;case 9:this.$=[$$[$0]];break;case 10:$$[$0-1].push($$[$0]);this.$=$$[$0-1];break;case 11:this.$=new yy.BlockNode($$[$0-2],$$[$0-1].inverse,$$[$0-1],$$[$0],this._$);break;case 12:this.$=new yy.BlockNode($$[$0-2],$$[$0-1],$$[$0-1].inverse,$$[$0],this._$);break;case 13:this.$=$$[$0];break;case 14:this.$=$$[$0];break;case 15:this.$=new yy.ContentNode($$[$0],this._$);break;case 16:this.$=new yy.CommentNode($$[$0],this._$);break;case 17:this.$=new yy.MustacheNode($$[$0-1],null,$$[$0-2],stripFlags($$[$0-2],$$[$0]),this._$);break;case 18:this.$=new yy.MustacheNode($$[$0-1],null,$$[$0-2],stripFlags($$[$0-2],$$[$0]),this._$);break;case 19:this.$={path:$$[$0-1],strip:stripFlags($$[$0-2],$$[$0])};break;case 20:this.$=new yy.MustacheNode($$[$0-1],null,$$[$0-2],stripFlags($$[$0-2],$$[$0]),this._$);break;case 21:this.$=new yy.MustacheNode($$[$0-1],null,$$[$0-2],stripFlags($$[$0-2],$$[$0]),this._$);break;case 22:this.$=new yy.PartialNode($$[$0-2],$$[$0-1],stripFlags($$[$0-3],$$[$0]),this._$);break;case 23:this.$=stripFlags($$[$0-1],$$[$0]);break;case 24:this.$=new yy.SexprNode([$$[$0-2]].concat($$[$0-1]),$$[$0],this._$);break;case 25:this.$=new yy.SexprNode([$$[$0]],null,this._$);break;case 26:this.$=$$[$0];break;case 27:this.$=new yy.StringNode($$[$0],this._$);break;case 28:this.$=new yy.IntegerNode($$[$0],this._$);break;case 29:this.$=new yy.BooleanNode($$[$0],this._$);break;case 30:this.$=$$[$0];break;case 31:$$[$0-1].isHelper=true;this.$=$$[$0-1];break;case 32:this.$=new yy.HashNode($$[$0],this._$);break;case 33:this.$=[$$[$0-2],$$[$0]];break;case 34:this.$=new yy.PartialNameNode($$[$0],this._$);break;case 35:this.$=new yy.PartialNameNode(new yy.StringNode($$[$0],this._$),this._$);break;case 36:this.$=new yy.PartialNameNode(new yy.IntegerNode($$[$0],this._$));break;case 37:this.$=new yy.DataNode($$[$0],this._$);break;case 38:this.$=new yy.IdNode($$[$0],this._$);break;case 39:$$[$0-2].push({part:$$[$0],separator:$$[$0-1]});this.$=$$[$0-2];break;case 40:this.$=[{part:$$[$0]}];break;case 43:this.$=[];break;case 44:$$[$0-1].push($$[$0]);break;case 47:this.$=[$$[$0]];break;case 48:$$[$0-1].push($$[$0]);break;}},table:[{3:1,4:2,5:[1,3],8:4,9:5,11:6,12:7,13:8,14:[1,9],15:[1,10],16:[1,12],19:[1,11],22:[1,13],23:[1,14],25:[1,15]},{1:[3]},{5:[1,16],8:17,9:5,11:6,12:7,13:8,14:[1,9],15:[1,10],16:[1,12],19:[1,11],22:[1,13],23:[1,14],25:[1,15]},{1:[2,2]},{5:[2,9],14:[2,9],15:[2,9],16:[2,9],19:[2,9],20:[2,9],22:[2,9],23:[2,9],25:[2,9]},{4:20,6:18,7:19,8:4,9:5,11:6,12:7,13:8,14:[1,9],15:[1,10],16:[1,12],19:[1,21],20:[2,8],22:[1,13],23:[1,14],25:[1,15]},{4:20,6:22,7:19,8:4,9:5,11:6,12:7,13:8,14:[1,9],15:[1,10],16:[1,12],19:[1,21],20:[2,8],22:[1,13],23:[1,14],25:[1,15]},{5:[2,13],14:[2,13],15:[2,13],16:[2,13],19:[2,13],20:[2,13],22:[2,13],23:[2,13],25:[2,13]},{5:[2,14],14:[2,14],15:[2,14],16:[2,14],19:[2,14],20:[2,14],22:[2,14],23:[2,14],25:[2,14]},{5:[2,15],14:[2,15],15:[2,15],16:[2,15],19:[2,15],20:[2,15],22:[2,15],23:[2,15],25:[2,15]},{5:[2,16],14:[2,16],15:[2,16],16:[2,16],19:[2,16],20:[2,16],22:[2,16],23:[2,16],25:[2,16]},{17:23,21:24,30:25,40:[1,28],42:[1,27],43:26},{17:29,21:24,30:25,40:[1,28],42:[1,27],43:26},{17:30,21:24,30:25,40:[1,28],42:[1,27],43:26},{17:31,21:24,30:25,40:[1,28],42:[1,27],43:26},{21:33,26:32,32:[1,34],33:[1,35],40:[1,28],43:26},{1:[2,1]},{5:[2,10],14:[2,10],15:[2,10],16:[2,10],19:[2,10],20:[2,10],22:[2,10],23:[2,10],25:[2,10]},{10:36,20:[1,37]},{4:38,8:4,9:5,11:6,12:7,13:8,14:[1,9],15:[1,10],16:[1,12],19:[1,11],20:[2,7],22:[1,13],23:[1,14],25:[1,15]},{7:39,8:17,9:5,11:6,12:7,13:8,14:[1,9],15:[1,10],16:[1,12],19:[1,21],20:[2,6],22:[1,13],23:[1,14],25:[1,15]},{17:23,18:[1,40],21:24,30:25,40:[1,28],42:[1,27],43:26},{10:41,20:[1,37]},{18:[1,42]},{18:[2,43],24:[2,43],28:43,32:[2,43],33:[2,43],34:[2,43],35:[2,43],36:[2,43],40:[2,43],42:[2,43]},{18:[2,25],24:[2,25],36:[2,25]},{18:[2,38],24:[2,38],32:[2,38],33:[2,38],34:[2,38],35:[2,38],36:[2,38],40:[2,38],42:[2,38],44:[1,44]},{21:45,40:[1,28],43:26},{18:[2,40],24:[2,40],32:[2,40],33:[2,40],34:[2,40],35:[2,40],36:[2,40],40:[2,40],42:[2,40],44:[2,40]},{18:[1,46]},{18:[1,47]},{24:[1,48]},{18:[2,41],21:50,27:49,40:[1,28],43:26},{18:[2,34],40:[2,34]},{18:[2,35],40:[2,35]},{18:[2,36],40:[2,36]},{5:[2,11],14:[2,11],15:[2,11],16:[2,11],19:[2,11],20:[2,11],22:[2,11],23:[2,11],25:[2,11]},{21:51,40:[1,28],43:26},{8:17,9:5,11:6,12:7,13:8,14:[1,9],15:[1,10],16:[1,12],19:[1,11],20:[2,3],22:[1,13],23:[1,14],25:[1,15]},{4:52,8:4,9:5,11:6,12:7,13:8,14:[1,9],15:[1,10],16:[1,12],19:[1,11],20:[2,5],22:[1,13],23:[1,14],25:[1,15]},{14:[2,23],15:[2,23],16:[2,23],19:[2,23],20:[2,23],22:[2,23],23:[2,23],25:[2,23]},{5:[2,12],14:[2,12],15:[2,12],16:[2,12],19:[2,12],20:[2,12],22:[2,12],23:[2,12],25:[2,12]},{14:[2,18],15:[2,18],16:[2,18],19:[2,18],20:[2,18],22:[2,18],23:[2,18],25:[2,18]},{18:[2,45],21:56,24:[2,45],29:53,30:60,31:54,32:[1,57],33:[1,58],34:[1,59],35:[1,61],36:[2,45],37:55,38:62,39:63,40:[1,64],42:[1,27],43:26},{40:[1,65]},{18:[2,37],24:[2,37],32:[2,37],33:[2,37],34:[2,37],35:[2,37],36:[2,37],40:[2,37],42:[2,37]},{14:[2,17],15:[2,17],16:[2,17],19:[2,17],20:[2,17],22:[2,17],23:[2,17],25:[2,17]},{5:[2,20],14:[2,20],15:[2,20],16:[2,20],19:[2,20],20:[2,20],22:[2,20],23:[2,20],25:[2,20]},{5:[2,21],14:[2,21],15:[2,21],16:[2,21],19:[2,21],20:[2,21],22:[2,21],23:[2,21],25:[2,21]},{18:[1,66]},{18:[2,42]},{18:[1,67]},{8:17,9:5,11:6,12:7,13:8,14:[1,9],15:[1,10],16:[1,12],19:[1,11],20:[2,4],22:[1,13],23:[1,14],25:[1,15]},{18:[2,24],24:[2,24],36:[2,24]},{18:[2,44],24:[2,44],32:[2,44],33:[2,44],34:[2,44],35:[2,44],36:[2,44],40:[2,44],42:[2,44]},{18:[2,46],24:[2,46],36:[2,46]},{18:[2,26],24:[2,26],32:[2,26],33:[2,26],34:[2,26],35:[2,26],36:[2,26],40:[2,26],42:[2,26]},{18:[2,27],24:[2,27],32:[2,27],33:[2,27],34:[2,27],35:[2,27],36:[2,27],40:[2,27],42:[2,27]},{18:[2,28],24:[2,28],32:[2,28],33:[2,28],34:[2,28],35:[2,28],36:[2,28],40:[2,28],42:[2,28]},{18:[2,29],24:[2,29],32:[2,29],33:[2,29],34:[2,29],35:[2,29],36:[2,29],40:[2,29],42:[2,29]},{18:[2,30],24:[2,30],32:[2,30],33:[2,30],34:[2,30],35:[2,30],36:[2,30],40:[2,30],42:[2,30]},{17:68,21:24,30:25,40:[1,28],42:[1,27],43:26},{18:[2,32],24:[2,32],36:[2,32],39:69,40:[1,70]},{18:[2,47],24:[2,47],36:[2,47],40:[2,47]},{18:[2,40],24:[2,40],32:[2,40],33:[2,40],34:[2,40],35:[2,40],36:[2,40],40:[2,40],41:[1,71],42:[2,40],44:[2,40]},{18:[2,39],24:[2,39],32:[2,39],33:[2,39],34:[2,39],35:[2,39],36:[2,39],40:[2,39],42:[2,39],44:[2,39]},{5:[2,22],14:[2,22],15:[2,22],16:[2,22],19:[2,22],20:[2,22],22:[2,22],23:[2,22],25:[2,22]},{5:[2,19],14:[2,19],15:[2,19],16:[2,19],19:[2,19],20:[2,19],22:[2,19],23:[2,19],25:[2,19]},{36:[1,72]},{18:[2,48],24:[2,48],36:[2,48],40:[2,48]},{41:[1,71]},{21:56,30:60,31:73,32:[1,57],33:[1,58],34:[1,59],35:[1,61],40:[1,28],42:[1,27],43:26},{18:[2,31],24:[2,31],32:[2,31],33:[2,31],34:[2,31],35:[2,31],36:[2,31],40:[2,31],42:[2,31]},{18:[2,33],24:[2,33],36:[2,33],40:[2,33]}],defaultActions:{3:[2,2],16:[2,1],50:[2,42]},parseError:function parseError(str,hash){throw new Error(str);},parse:function parse(input){var self=this,stack=[0],vstack=[null],lstack=[],table=this.table,yytext="",yylineno=0,yyleng=0,recovering=0,TERROR=2,EOF=1;this.lexer.setInput(input);this.lexer.yy=this.yy;this.yy.lexer=this.lexer;this.yy.parser=this;if(typeof this.lexer.yylloc=="undefined")
this.lexer.yylloc={};var yyloc=this.lexer.yylloc;lstack.push(yyloc);var ranges=this.lexer.options&&this.lexer.options.ranges;if(typeof this.yy.parseError==="function")
this.parseError=this.yy.parseError;function popStack(n){stack.length=stack.length-2*n;vstack.length=vstack.length-n;lstack.length=lstack.length-n;}
function lex(){var token;token=self.lexer.lex()||1;if(typeof token!=="number"){token=self.symbols_[token]||token;}
return token;}
var symbol,preErrorSymbol,state,action,a,r,yyval={},p,len,newState,expected;while(true){state=stack[stack.length-1];if(this.defaultActions[state]){action=this.defaultActions[state];}else{if(symbol===null||typeof symbol=="undefined"){symbol=lex();}
action=table[state]&&table[state][symbol];}
if(typeof action==="undefined"||!action.length||!action[0]){var errStr="";if(!recovering){expected=[];for(p in table[state])
if(this.terminals_[p]&&p>2){expected.push("'"+this.terminals_[p]+"'");}
if(this.lexer.showPosition){errStr="Parse error on line "+(yylineno+1)+":\n"+this.lexer.showPosition()+"\nExpecting "+expected.join(", ")+", got '"+(this.terminals_[symbol]||symbol)+"'";}else{errStr="Parse error on line "+(yylineno+1)+": Unexpected "+(symbol==1?"end of input":"'"+(this.terminals_[symbol]||symbol)+"'");}
this.parseError(errStr,{text:this.lexer.match,token:this.terminals_[symbol]||symbol,line:this.lexer.yylineno,loc:yyloc,expected:expected});}}
if(action[0]instanceof Array&&action.length>1){throw new Error("Parse Error: multiple actions possible at state: "+state+", token: "+symbol);}
switch(action[0]){case 1:stack.push(symbol);vstack.push(this.lexer.yytext);lstack.push(this.lexer.yylloc);stack.push(action[1]);symbol=null;if(!preErrorSymbol){yyleng=this.lexer.yyleng;yytext=this.lexer.yytext;yylineno=this.lexer.yylineno;yyloc=this.lexer.yylloc;if(recovering>0)
recovering--;}else{symbol=preErrorSymbol;preErrorSymbol=null;}
break;case 2:len=this.productions_[action[1]][1];yyval.$=vstack[vstack.length-len];yyval._$={first_line:lstack[lstack.length-(len||1)].first_line,last_line:lstack[lstack.length-1].last_line,first_column:lstack[lstack.length-(len||1)].first_column,last_column:lstack[lstack.length-1].last_column};if(ranges){yyval._$.range=[lstack[lstack.length-(len||1)].range[0],lstack[lstack.length-1].range[1]];}
r=this.performAction.call(yyval,yytext,yyleng,yylineno,this.yy,action[1],vstack,lstack);if(typeof r!=="undefined"){return r;}
if(len){stack=stack.slice(0,-1*len*2);vstack=vstack.slice(0,-1*len);lstack=lstack.slice(0,-1*len);}
stack.push(this.productions_[action[1]][0]);vstack.push(yyval.$);lstack.push(yyval._$);newState=table[stack[stack.length-2]][stack[stack.length-1]];stack.push(newState);break;case 3:return true;}}
return true;}};function stripFlags(open,close){return{left:open.charAt(2)==='~',right:close.charAt(0)==='~'||close.charAt(1)==='~'};}
var lexer=(function(){var lexer=({EOF:1,parseError:function parseError(str,hash){if(this.yy.parser){this.yy.parser.parseError(str,hash);}else{throw new Error(str);}},setInput:function(input){this._input=input;this._more=this._less=this.done=false;this.yylineno=this.yyleng=0;this.yytext=this.matched=this.match='';this.conditionStack=['INITIAL'];this.yylloc={first_line:1,first_column:0,last_line:1,last_column:0};if(this.options.ranges)this.yylloc.range=[0,0];this.offset=0;return this;},input:function(){var ch=this._input[0];this.yytext+=ch;this.yyleng++;this.offset++;this.match+=ch;this.matched+=ch;var lines=ch.match(/(?:\r\n?|\n).*/g);if(lines){this.yylineno++;this.yylloc.last_line++;}else{this.yylloc.last_column++;}
if(this.options.ranges)this.yylloc.range[1]++;this._input=this._input.slice(1);return ch;},unput:function(ch){var len=ch.length;var lines=ch.split(/(?:\r\n?|\n)/g);this._input=ch+this._input;this.yytext=this.yytext.substr(0,this.yytext.length-len-1);this.offset-=len;var oldLines=this.match.split(/(?:\r\n?|\n)/g);this.match=this.match.substr(0,this.match.length-1);this.matched=this.matched.substr(0,this.matched.length-1);if(lines.length-1)this.yylineno-=lines.length-1;var r=this.yylloc.range;this.yylloc={first_line:this.yylloc.first_line,last_line:this.yylineno+1,first_column:this.yylloc.first_column,last_column:lines?(lines.length===oldLines.length?this.yylloc.first_column:0)+oldLines[oldLines.length-lines.length].length-lines[0].length:this.yylloc.first_column-len};if(this.options.ranges){this.yylloc.range=[r[0],r[0]+this.yyleng-len];}
return this;},more:function(){this._more=true;return this;},less:function(n){this.unput(this.match.slice(n));},pastInput:function(){var past=this.matched.substr(0,this.matched.length-this.match.length);return(past.length>20?'...':'')+past.substr(-20).replace(/\n/g,"");},upcomingInput:function(){var next=this.match;if(next.length<20){next+=this._input.substr(0,20-next.length);}
return(next.substr(0,20)+(next.length>20?'...':'')).replace(/\n/g,"");},showPosition:function(){var pre=this.pastInput();var c=new Array(pre.length+1).join("-");return pre+this.upcomingInput()+"\n"+c+"^";},next:function(){if(this.done){return this.EOF;}
if(!this._input)this.done=true;var token,match,tempMatch,index,col,lines;if(!this._more){this.yytext='';this.match='';}
var rules=this._currentRules();for(var i=0;i<rules.length;i++){tempMatch=this._input.match(this.rules[rules[i]]);if(tempMatch&&(!match||tempMatch[0].length>match[0].length)){match=tempMatch;index=i;if(!this.options.flex)break;}}
if(match){lines=match[0].match(/(?:\r\n?|\n).*/g);if(lines)this.yylineno+=lines.length;this.yylloc={first_line:this.yylloc.last_line,last_line:this.yylineno+1,first_column:this.yylloc.last_column,last_column:lines?lines[lines.length-1].length-lines[lines.length-1].match(/\r?\n?/)[0].length:this.yylloc.last_column+match[0].length};this.yytext+=match[0];this.match+=match[0];this.matches=match;this.yyleng=this.yytext.length;if(this.options.ranges){this.yylloc.range=[this.offset,this.offset+=this.yyleng];}
this._more=false;this._input=this._input.slice(match[0].length);this.matched+=match[0];token=this.performAction.call(this,this.yy,this,rules[index],this.conditionStack[this.conditionStack.length-1]);if(this.done&&this._input)this.done=false;if(token)return token;else return;}
if(this._input===""){return this.EOF;}else{return this.parseError('Lexical error on line '+(this.yylineno+1)+'. Unrecognized text.\n'+this.showPosition(),{text:"",token:null,line:this.yylineno});}},lex:function lex(){var r=this.next();if(typeof r!=='undefined'){return r;}else{return this.lex();}},begin:function begin(condition){this.conditionStack.push(condition);},popState:function popState(){return this.conditionStack.pop();},_currentRules:function _currentRules(){return this.conditions[this.conditionStack[this.conditionStack.length-1]].rules;},topState:function(){return this.conditionStack[this.conditionStack.length-2];},pushState:function begin(condition){this.begin(condition);}});lexer.options={};lexer.performAction=function anonymous(yy,yy_,$avoiding_name_collisions,YY_START){function strip(start,end){return yy_.yytext=yy_.yytext.substr(start,yy_.yyleng-end);}
var YYSTATE=YY_START
switch($avoiding_name_collisions){case 0:if(yy_.yytext.slice(-2)==="\\\\"){strip(0,1);this.begin("mu");}else if(yy_.yytext.slice(-1)==="\\"){strip(0,1);this.begin("emu");}else{this.begin("mu");}
if(yy_.yytext)return 14;break;case 1:return 14;break;case 2:this.popState();return 14;break;case 3:strip(0,4);this.popState();return 15;break;case 4:return 35;break;case 5:return 36;break;case 6:return 25;break;case 7:return 16;break;case 8:return 20;break;case 9:return 19;break;case 10:return 19;break;case 11:return 23;break;case 12:return 22;break;case 13:this.popState();this.begin('com');break;case 14:strip(3,5);this.popState();return 15;break;case 15:return 22;break;case 16:return 41;break;case 17:return 40;break;case 18:return 40;break;case 19:return 44;break;case 20:break;case 21:this.popState();return 24;break;case 22:this.popState();return 18;break;case 23:yy_.yytext=strip(1,2).replace(/\\"/g,'"');return 32;break;case 24:yy_.yytext=strip(1,2).replace(/\\'/g,"'");return 32;break;case 25:return 42;break;case 26:return 34;break;case 27:return 34;break;case 28:return 33;break;case 29:return 40;break;case 30:yy_.yytext=strip(1,2);return 40;break;case 31:return'INVALID';break;case 32:return 5;break;}};lexer.rules=[/^(?:[^\x00]*?(?=(\{\{)))/,/^(?:[^\x00]+)/,/^(?:[^\x00]{2,}?(?=(\{\{|\\\{\{|\\\\\{\{|$)))/,/^(?:[\s\S]*?--\}\})/,/^(?:\()/,/^(?:\))/,/^(?:\{\{(~)?>)/,/^(?:\{\{(~)?#)/,/^(?:\{\{(~)?\/)/,/^(?:\{\{(~)?\^)/,/^(?:\{\{(~)?\s*else\b)/,/^(?:\{\{(~)?\{)/,/^(?:\{\{(~)?&)/,/^(?:\{\{!--)/,/^(?:\{\{![\s\S]*?\}\})/,/^(?:\{\{(~)?)/,/^(?:=)/,/^(?:\.\.)/,/^(?:\.(?=([=~}\s\/.)])))/,/^(?:[\/.])/,/^(?:\s+)/,/^(?:\}(~)?\}\})/,/^(?:(~)?\}\})/,/^(?:"(\\["]|[^"])*")/,/^(?:'(\\[']|[^'])*')/,/^(?:@)/,/^(?:true(?=([~}\s)])))/,/^(?:false(?=([~}\s)])))/,/^(?:-?[0-9]+(?=([~}\s)])))/,/^(?:([^\s!"#%-,\.\/;->@\[-\^`\{-~]+(?=([=~}\s\/.)]))))/,/^(?:\[[^\]]*\])/,/^(?:.)/,/^(?:$)/];lexer.conditions={"mu":{"rules":[4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32],"inclusive":false},"emu":{"rules":[2],"inclusive":false},"com":{"rules":[3],"inclusive":false},"INITIAL":{"rules":[0,1,32],"inclusive":true}};return lexer;})()
parser.lexer=lexer;function Parser(){this.yy={};}Parser.prototype=parser;parser.Parser=Parser;return new Parser;})();__exports__=handlebars;return __exports__;})();var __module8__=(function(__dependency1__,__dependency2__){"use strict";var __exports__={};var parser=__dependency1__;var AST=__dependency2__;__exports__.parser=parser;function parse(input){if(input.constructor===AST.ProgramNode){return input;}
parser.yy=AST;return parser.parse(input);}
__exports__.parse=parse;return __exports__;})(__module9__,__module7__);var __module10__=(function(__dependency1__){"use strict";var __exports__={};var Exception=__dependency1__;function Compiler(){}
__exports__.Compiler=Compiler;Compiler.prototype={compiler:Compiler,disassemble:function(){var opcodes=this.opcodes,opcode,out=[],params,param;for(var i=0,l=opcodes.length;i<l;i++){opcode=opcodes[i];if(opcode.opcode==='DECLARE'){out.push("DECLARE "+opcode.name+"="+opcode.value);}else{params=[];for(var j=0;j<opcode.args.length;j++){param=opcode.args[j];if(typeof param==="string"){param="\""+param.replace("\n","\\n")+"\"";}
params.push(param);}
out.push(opcode.opcode+" "+params.join(" "));}}
return out.join("\n");},equals:function(other){var len=this.opcodes.length;if(other.opcodes.length!==len){return false;}
for(var i=0;i<len;i++){var opcode=this.opcodes[i],otherOpcode=other.opcodes[i];if(opcode.opcode!==otherOpcode.opcode||opcode.args.length!==otherOpcode.args.length){return false;}
for(var j=0;j<opcode.args.length;j++){if(opcode.args[j]!==otherOpcode.args[j]){return false;}}}
len=this.children.length;if(other.children.length!==len){return false;}
for(i=0;i<len;i++){if(!this.children[i].equals(other.children[i])){return false;}}
return true;},guid:0,compile:function(program,options){this.opcodes=[];this.children=[];this.depths={list:[]};this.options=options;var knownHelpers=this.options.knownHelpers;this.options.knownHelpers={'helperMissing':true,'blockHelperMissing':true,'each':true,'if':true,'unless':true,'with':true,'log':true};if(knownHelpers){for(var name in knownHelpers){this.options.knownHelpers[name]=knownHelpers[name];}}
return this.accept(program);},accept:function(node){var strip=node.strip||{},ret;if(strip.left){this.opcode('strip');}
ret=this[node.type](node);if(strip.right){this.opcode('strip');}
return ret;},program:function(program){var statements=program.statements;for(var i=0,l=statements.length;i<l;i++){this.accept(statements[i]);}
this.isSimple=l===1;this.depths.list=this.depths.list.sort(function(a,b){return a-b;});return this;},compileProgram:function(program){var result=new this.compiler().compile(program,this.options);var guid=this.guid++,depth;this.usePartial=this.usePartial||result.usePartial;this.children[guid]=result;for(var i=0,l=result.depths.list.length;i<l;i++){depth=result.depths.list[i];if(depth<2){continue;}
else{this.addDepth(depth-1);}}
return guid;},block:function(block){var mustache=block.mustache,program=block.program,inverse=block.inverse;if(program){program=this.compileProgram(program);}
if(inverse){inverse=this.compileProgram(inverse);}
var sexpr=mustache.sexpr;var type=this.classifySexpr(sexpr);if(type==="helper"){this.helperSexpr(sexpr,program,inverse);}else if(type==="simple"){this.simpleSexpr(sexpr);this.opcode('pushProgram',program);this.opcode('pushProgram',inverse);this.opcode('emptyHash');this.opcode('blockValue');}else{this.ambiguousSexpr(sexpr,program,inverse);this.opcode('pushProgram',program);this.opcode('pushProgram',inverse);this.opcode('emptyHash');this.opcode('ambiguousBlockValue');}
this.opcode('append');},hash:function(hash){var pairs=hash.pairs,pair,val;this.opcode('pushHash');for(var i=0,l=pairs.length;i<l;i++){pair=pairs[i];val=pair[1];if(this.options.stringParams){if(val.depth){this.addDepth(val.depth);}
this.opcode('getContext',val.depth||0);this.opcode('pushStringParam',val.stringModeValue,val.type);if(val.type==='sexpr'){this.sexpr(val);}}else{this.accept(val);}
this.opcode('assignToHash',pair[0]);}
this.opcode('popHash');},partial:function(partial){var partialName=partial.partialName;this.usePartial=true;if(partial.context){this.ID(partial.context);}else{this.opcode('push','depth0');}
this.opcode('invokePartial',partialName.name);this.opcode('append');},content:function(content){this.opcode('appendContent',content.string);},mustache:function(mustache){this.sexpr(mustache.sexpr);if(mustache.escaped&&!this.options.noEscape){this.opcode('appendEscaped');}else{this.opcode('append');}},ambiguousSexpr:function(sexpr,program,inverse){var id=sexpr.id,name=id.parts[0],isBlock=program!=null||inverse!=null;this.opcode('getContext',id.depth);this.opcode('pushProgram',program);this.opcode('pushProgram',inverse);this.opcode('invokeAmbiguous',name,isBlock);},simpleSexpr:function(sexpr){var id=sexpr.id;if(id.type==='DATA'){this.DATA(id);}else if(id.parts.length){this.ID(id);}else{this.addDepth(id.depth);this.opcode('getContext',id.depth);this.opcode('pushContext');}
this.opcode('resolvePossibleLambda');},helperSexpr:function(sexpr,program,inverse){var params=this.setupFullMustacheParams(sexpr,program,inverse),name=sexpr.id.parts[0];if(this.options.knownHelpers[name]){this.opcode('invokeKnownHelper',params.length,name);}else if(this.options.knownHelpersOnly){throw new Exception("You specified knownHelpersOnly, but used the unknown helper "+name,sexpr);}else{this.opcode('invokeHelper',params.length,name,sexpr.isRoot);}},sexpr:function(sexpr){var type=this.classifySexpr(sexpr);if(type==="simple"){this.simpleSexpr(sexpr);}else if(type==="helper"){this.helperSexpr(sexpr);}else{this.ambiguousSexpr(sexpr);}},ID:function(id){this.addDepth(id.depth);this.opcode('getContext',id.depth);var name=id.parts[0];if(!name){this.opcode('pushContext');}else{this.opcode('lookupOnContext',id.parts[0]);}
for(var i=1,l=id.parts.length;i<l;i++){this.opcode('lookup',id.parts[i]);}},DATA:function(data){this.options.data=true;if(data.id.isScoped||data.id.depth){throw new Exception('Scoped data references are not supported: '+data.original,data);}
this.opcode('lookupData');var parts=data.id.parts;for(var i=0,l=parts.length;i<l;i++){this.opcode('lookup',parts[i]);}},STRING:function(string){this.opcode('pushString',string.string);},INTEGER:function(integer){this.opcode('pushLiteral',integer.integer);},BOOLEAN:function(bool){this.opcode('pushLiteral',bool.bool);},comment:function(){},opcode:function(name){this.opcodes.push({opcode:name,args:[].slice.call(arguments,1)});},declare:function(name,value){this.opcodes.push({opcode:'DECLARE',name:name,value:value});},addDepth:function(depth){if(depth===0){return;}
if(!this.depths[depth]){this.depths[depth]=true;this.depths.list.push(depth);}},classifySexpr:function(sexpr){var isHelper=sexpr.isHelper;var isEligible=sexpr.eligibleHelper;var options=this.options;if(isEligible&&!isHelper){var name=sexpr.id.parts[0];if(options.knownHelpers[name]){isHelper=true;}else if(options.knownHelpersOnly){isEligible=false;}}
if(isHelper){return"helper";}
else if(isEligible){return"ambiguous";}
else{return"simple";}},pushParams:function(params){var i=params.length,param;while(i--){param=params[i];if(this.options.stringParams){if(param.depth){this.addDepth(param.depth);}
this.opcode('getContext',param.depth||0);this.opcode('pushStringParam',param.stringModeValue,param.type);if(param.type==='sexpr'){this.sexpr(param);}}else{this[param.type](param);}}},setupFullMustacheParams:function(sexpr,program,inverse){var params=sexpr.params;this.pushParams(params);this.opcode('pushProgram',program);this.opcode('pushProgram',inverse);if(sexpr.hash){this.hash(sexpr.hash);}else{this.opcode('emptyHash');}
return params;}};function precompile(input,options,env){if(input==null||(typeof input!=='string'&&input.constructor!==env.AST.ProgramNode)){throw new Exception("You must pass a string or Handlebars AST to Handlebars.precompile. You passed "+input);}
options=options||{};if(!('data'in options)){options.data=true;}
var ast=env.parse(input);var environment=new env.Compiler().compile(ast,options);return new env.JavaScriptCompiler().compile(environment,options);}
__exports__.precompile=precompile;function compile(input,options,env){if(input==null||(typeof input!=='string'&&input.constructor!==env.AST.ProgramNode)){throw new Exception("You must pass a string or Handlebars AST to Handlebars.compile. You passed "+input);}
options=options||{};if(!('data'in options)){options.data=true;}
var compiled;function compileInput(){var ast=env.parse(input);var environment=new env.Compiler().compile(ast,options);var templateSpec=new env.JavaScriptCompiler().compile(environment,options,undefined,true);return env.template(templateSpec);}
return function(context,options){if(!compiled){compiled=compileInput();}
return compiled.call(this,context,options);};}
__exports__.compile=compile;return __exports__;})(__module5__);var __module11__=(function(__dependency1__,__dependency2__){"use strict";var __exports__;var COMPILER_REVISION=__dependency1__.COMPILER_REVISION;var REVISION_CHANGES=__dependency1__.REVISION_CHANGES;var log=__dependency1__.log;var Exception=__dependency2__;function Literal(value){this.value=value;}
function JavaScriptCompiler(){}
JavaScriptCompiler.prototype={nameLookup:function(parent,name){var wrap,ret;if(parent.indexOf('depth')===0){wrap=true;}
if(/^[0-9]+$/.test(name)){ret=parent+"["+name+"]";}else if(JavaScriptCompiler.isValidJavaScriptVariableName(name)){ret=parent+"."+name;}
else{ret=parent+"['"+name+"']";}
if(wrap){return'('+parent+' && '+ret+')';}else{return ret;}},compilerInfo:function(){var revision=COMPILER_REVISION,versions=REVISION_CHANGES[revision];return"this.compilerInfo = ["+revision+",'"+versions+"'];\n";},appendToBuffer:function(string){if(this.environment.isSimple){return"return "+string+";";}else{return{appendToBuffer:true,content:string,toString:function(){return"buffer += "+string+";";}};}},initializeBuffer:function(){return this.quotedString("");},namespace:"Handlebars",compile:function(environment,options,context,asObject){this.environment=environment;this.options=options||{};log('debug',this.environment.disassemble()+"\n\n");this.name=this.environment.name;this.isChild=!!context;this.context=context||{programs:[],environments:[],aliases:{}};this.preamble();this.stackSlot=0;this.stackVars=[];this.registers={list:[]};this.hashes=[];this.compileStack=[];this.inlineStack=[];this.compileChildren(environment,options);var opcodes=environment.opcodes,opcode;this.i=0;for(var l=opcodes.length;this.i<l;this.i++){opcode=opcodes[this.i];if(opcode.opcode==='DECLARE'){this[opcode.name]=opcode.value;}else{this[opcode.opcode].apply(this,opcode.args);}
if(opcode.opcode!==this.stripNext){this.stripNext=false;}}
this.pushSource('');if(this.stackSlot||this.inlineStack.length||this.compileStack.length){throw new Exception('Compile completed with content left on stack');}
return this.createFunctionContext(asObject);},preamble:function(){var out=[];if(!this.isChild){var namespace=this.namespace;var copies="helpers = this.merge(helpers, "+namespace+".helpers);";if(this.environment.usePartial){copies=copies+" partials = this.merge(partials, "+namespace+".partials);";}
if(this.options.data){copies=copies+" data = data || {};";}
out.push(copies);}else{out.push('');}
if(!this.environment.isSimple){out.push(", buffer = "+this.initializeBuffer());}else{out.push("");}
this.lastContext=0;this.source=out;},createFunctionContext:function(asObject){var locals=this.stackVars.concat(this.registers.list);if(locals.length>0){this.source[1]=this.source[1]+", "+locals.join(", ");}
if(!this.isChild){for(var alias in this.context.aliases){if(this.context.aliases.hasOwnProperty(alias)){this.source[1]=this.source[1]+', '+alias+'='+this.context.aliases[alias];}}}
if(this.source[1]){this.source[1]="var "+this.source[1].substring(2)+";";}
if(!this.isChild){this.source[1]+='\n'+this.context.programs.join('\n')+'\n';}
if(!this.environment.isSimple){this.pushSource("return buffer;");}
var params=this.isChild?["depth0","data"]:["Handlebars","depth0","helpers","partials","data"];for(var i=0,l=this.environment.depths.list.length;i<l;i++){params.push("depth"+this.environment.depths.list[i]);}
var source=this.mergeSource();if(!this.isChild){source=this.compilerInfo()+source;}
if(asObject){params.push(source);return Function.apply(this,params);}else{var functionSource='function '+(this.name||'')+'('+params.join(',')+') {\n  '+source+'}';log('debug',functionSource+"\n\n");return functionSource;}},mergeSource:function(){var source='',buffer;for(var i=0,len=this.source.length;i<len;i++){var line=this.source[i];if(line.appendToBuffer){if(buffer){buffer=buffer+'\n    + '+line.content;}else{buffer=line.content;}}else{if(buffer){source+='buffer += '+buffer+';\n  ';buffer=undefined;}
source+=line+'\n  ';}}
return source;},blockValue:function(){this.context.aliases.blockHelperMissing='helpers.blockHelperMissing';var params=["depth0"];this.setupParams(0,params);this.replaceStack(function(current){params.splice(1,0,current);return"blockHelperMissing.call("+params.join(", ")+")";});},ambiguousBlockValue:function(){this.context.aliases.blockHelperMissing='helpers.blockHelperMissing';var params=["depth0"];this.setupParams(0,params);var current=this.topStack();params.splice(1,0,current);this.pushSource("if (!"+this.lastHelper+") { "+current+" = blockHelperMissing.call("+params.join(", ")+"); }");},appendContent:function(content){if(this.pendingContent){content=this.pendingContent+content;}
if(this.stripNext){content=content.replace(/^\s+/,'');}
this.pendingContent=content;},strip:function(){if(this.pendingContent){this.pendingContent=this.pendingContent.replace(/\s+$/,'');}
this.stripNext='strip';},append:function(){this.flushInline();var local=this.popStack();this.pushSource("if("+local+" || "+local+" === 0) { "+this.appendToBuffer(local)+" }");if(this.environment.isSimple){this.pushSource("else { "+this.appendToBuffer("''")+" }");}},appendEscaped:function(){this.context.aliases.escapeExpression='this.escapeExpression';this.pushSource(this.appendToBuffer("escapeExpression("+this.popStack()+")"));},getContext:function(depth){if(this.lastContext!==depth){this.lastContext=depth;}},lookupOnContext:function(name){this.push(this.nameLookup('depth'+this.lastContext,name,'context'));},pushContext:function(){this.pushStackLiteral('depth'+this.lastContext);},resolvePossibleLambda:function(){this.context.aliases.functionType='"function"';this.replaceStack(function(current){return"typeof "+current+" === functionType ? "+current+".apply(depth0) : "+current;});},lookup:function(name){this.replaceStack(function(current){return current+" == null || "+current+" === false ? "+current+" : "+this.nameLookup(current,name,'context');});},lookupData:function(){this.pushStackLiteral('data');},pushStringParam:function(string,type){this.pushStackLiteral('depth'+this.lastContext);this.pushString(type);if(type!=='sexpr'){if(typeof string==='string'){this.pushString(string);}else{this.pushStackLiteral(string);}}},emptyHash:function(){this.pushStackLiteral('{}');if(this.options.stringParams){this.push('{}');this.push('{}');}},pushHash:function(){if(this.hash){this.hashes.push(this.hash);}
this.hash={values:[],types:[],contexts:[]};},popHash:function(){var hash=this.hash;this.hash=this.hashes.pop();if(this.options.stringParams){this.push('{'+hash.contexts.join(',')+'}');this.push('{'+hash.types.join(',')+'}');}
this.push('{\n    '+hash.values.join(',\n    ')+'\n  }');},pushString:function(string){this.pushStackLiteral(this.quotedString(string));},push:function(expr){this.inlineStack.push(expr);return expr;},pushLiteral:function(value){this.pushStackLiteral(value);},pushProgram:function(guid){if(guid!=null){this.pushStackLiteral(this.programExpression(guid));}else{this.pushStackLiteral(null);}},invokeHelper:function(paramSize,name,isRoot){this.context.aliases.helperMissing='helpers.helperMissing';this.useRegister('helper');var helper=this.lastHelper=this.setupHelper(paramSize,name,true);var nonHelper=this.nameLookup('depth'+this.lastContext,name,'context');var lookup='helper = '+helper.name+' || '+nonHelper;if(helper.paramsInit){lookup+=','+helper.paramsInit;}
this.push('('
+lookup
+',helper '
+'? helper.call('+helper.callParams+') '
+': helperMissing.call('+helper.helperMissingParams+'))');if(!isRoot){this.flushInline();}},invokeKnownHelper:function(paramSize,name){var helper=this.setupHelper(paramSize,name);this.push(helper.name+".call("+helper.callParams+")");},invokeAmbiguous:function(name,helperCall){this.context.aliases.functionType='"function"';this.useRegister('helper');this.emptyHash();var helper=this.setupHelper(0,name,helperCall);var helperName=this.lastHelper=this.nameLookup('helpers',name,'helper');var nonHelper=this.nameLookup('depth'+this.lastContext,name,'context');var nextStack=this.nextStack();if(helper.paramsInit){this.pushSource(helper.paramsInit);}
this.pushSource('if (helper = '+helperName+') { '+nextStack+' = helper.call('+helper.callParams+'); }');this.pushSource('else { helper = '+nonHelper+'; '+nextStack+' = typeof helper === functionType ? helper.call('+helper.callParams+') : helper; }');},invokePartial:function(name){var params=[this.nameLookup('partials',name,'partial'),"'"+name+"'",this.popStack(),"helpers","partials"];if(this.options.data){params.push("data");}
this.context.aliases.self="this";this.push("self.invokePartial("+params.join(", ")+")");},assignToHash:function(key){var value=this.popStack(),context,type;if(this.options.stringParams){type=this.popStack();context=this.popStack();}
var hash=this.hash;if(context){hash.contexts.push("'"+key+"': "+context);}
if(type){hash.types.push("'"+key+"': "+type);}
hash.values.push("'"+key+"': ("+value+")");},compiler:JavaScriptCompiler,compileChildren:function(environment,options){var children=environment.children,child,compiler;for(var i=0,l=children.length;i<l;i++){child=children[i];compiler=new this.compiler();var index=this.matchExistingProgram(child);if(index==null){this.context.programs.push('');index=this.context.programs.length;child.index=index;child.name='program'+index;this.context.programs[index]=compiler.compile(child,options,this.context);this.context.environments[index]=child;}else{child.index=index;child.name='program'+index;}}},matchExistingProgram:function(child){for(var i=0,len=this.context.environments.length;i<len;i++){var environment=this.context.environments[i];if(environment&&environment.equals(child)){return i;}}},programExpression:function(guid){this.context.aliases.self="this";if(guid==null){return"self.noop";}
var child=this.environment.children[guid],depths=child.depths.list,depth;var programParams=[child.index,child.name,"data"];for(var i=0,l=depths.length;i<l;i++){depth=depths[i];if(depth===1){programParams.push("depth0");}
else{programParams.push("depth"+(depth-1));}}
return(depths.length===0?"self.program(":"self.programWithDepth(")+programParams.join(", ")+")";},register:function(name,val){this.useRegister(name);this.pushSource(name+" = "+val+";");},useRegister:function(name){if(!this.registers[name]){this.registers[name]=true;this.registers.list.push(name);}},pushStackLiteral:function(item){return this.push(new Literal(item));},pushSource:function(source){if(this.pendingContent){this.source.push(this.appendToBuffer(this.quotedString(this.pendingContent)));this.pendingContent=undefined;}
if(source){this.source.push(source);}},pushStack:function(item){this.flushInline();var stack=this.incrStack();if(item){this.pushSource(stack+" = "+item+";");}
this.compileStack.push(stack);return stack;},replaceStack:function(callback){var prefix='',inline=this.isInline(),stack,createdStack,usedLiteral;if(inline){var top=this.popStack(true);if(top instanceof Literal){stack=top.value;usedLiteral=true;}else{createdStack=!this.stackSlot;var name=!createdStack?this.topStackName():this.incrStack();prefix='('+this.push(name)+' = '+top+'),';stack=this.topStack();}}else{stack=this.topStack();}
var item=callback.call(this,stack);if(inline){if(!usedLiteral){this.popStack();}
if(createdStack){this.stackSlot--;}
this.push('('+prefix+item+')');}else{if(!/^stack/.test(stack)){stack=this.nextStack();}
this.pushSource(stack+" = ("+prefix+item+");");}
return stack;},nextStack:function(){return this.pushStack();},incrStack:function(){this.stackSlot++;if(this.stackSlot>this.stackVars.length){this.stackVars.push("stack"+this.stackSlot);}
return this.topStackName();},topStackName:function(){return"stack"+this.stackSlot;},flushInline:function(){var inlineStack=this.inlineStack;if(inlineStack.length){this.inlineStack=[];for(var i=0,len=inlineStack.length;i<len;i++){var entry=inlineStack[i];if(entry instanceof Literal){this.compileStack.push(entry);}else{this.pushStack(entry);}}}},isInline:function(){return this.inlineStack.length;},popStack:function(wrapped){var inline=this.isInline(),item=(inline?this.inlineStack:this.compileStack).pop();if(!wrapped&&(item instanceof Literal)){return item.value;}else{if(!inline){if(!this.stackSlot){throw new Exception('Invalid stack pop');}
this.stackSlot--;}
return item;}},topStack:function(wrapped){var stack=(this.isInline()?this.inlineStack:this.compileStack),item=stack[stack.length-1];if(!wrapped&&(item instanceof Literal)){return item.value;}else{return item;}},quotedString:function(str){return'"'+str.replace(/\\/g,'\\\\').replace(/"/g,'\\"').replace(/\n/g,'\\n').replace(/\r/g,'\\r').replace(/\u2028/g,'\\u2028').replace(/\u2029/g,'\\u2029')+'"';},setupHelper:function(paramSize,name,missingParams){var params=[],paramsInit=this.setupParams(paramSize,params,missingParams);var foundHelper=this.nameLookup('helpers',name,'helper');return{params:params,paramsInit:paramsInit,name:foundHelper,callParams:["depth0"].concat(params).join(", "),helperMissingParams:missingParams&&["depth0",this.quotedString(name)].concat(params).join(", ")};},setupOptions:function(paramSize,params){var options=[],contexts=[],types=[],param,inverse,program;options.push("hash:"+this.popStack());if(this.options.stringParams){options.push("hashTypes:"+this.popStack());options.push("hashContexts:"+this.popStack());}
inverse=this.popStack();program=this.popStack();if(program||inverse){if(!program){this.context.aliases.self="this";program="self.noop";}
if(!inverse){this.context.aliases.self="this";inverse="self.noop";}
options.push("inverse:"+inverse);options.push("fn:"+program);}
for(var i=0;i<paramSize;i++){param=this.popStack();params.push(param);if(this.options.stringParams){types.push(this.popStack());contexts.push(this.popStack());}}
if(this.options.stringParams){options.push("contexts:["+contexts.join(",")+"]");options.push("types:["+types.join(",")+"]");}
if(this.options.data){options.push("data:data");}
return options;},setupParams:function(paramSize,params,useRegister){var options='{'+this.setupOptions(paramSize,params).join(',')+'}';if(useRegister){this.useRegister('options');params.push('options');return'options='+options;}else{params.push(options);return'';}}};var reservedWords=("break else new var"+" case finally return void"+" catch for switch while"+" continue function this with"+" default if throw"+" delete in try"+" do instanceof typeof"+" abstract enum int short"+" boolean export interface static"+" byte extends long super"+" char final native synchronized"+" class float package throws"+" const goto private transient"+" debugger implements protected volatile"+" double import public let yield").split(" ");var compilerWords=JavaScriptCompiler.RESERVED_WORDS={};for(var i=0,l=reservedWords.length;i<l;i++){compilerWords[reservedWords[i]]=true;}
JavaScriptCompiler.isValidJavaScriptVariableName=function(name){if(!JavaScriptCompiler.RESERVED_WORDS[name]&&/^[a-zA-Z_$][0-9a-zA-Z_$]*$/.test(name)){return true;}
return false;};__exports__=JavaScriptCompiler;return __exports__;})(__module2__,__module5__);var __module0__=(function(__dependency1__,__dependency2__,__dependency3__,__dependency4__,__dependency5__){"use strict";var __exports__;var Handlebars=__dependency1__;var AST=__dependency2__;var Parser=__dependency3__.parser;var parse=__dependency3__.parse;var Compiler=__dependency4__.Compiler;var compile=__dependency4__.compile;var precompile=__dependency4__.precompile;var JavaScriptCompiler=__dependency5__;var _create=Handlebars.create;var create=function(){var hb=_create();hb.compile=function(input,options){return compile(input,options,hb);};hb.precompile=function(input,options){return precompile(input,options,hb);};hb.AST=AST;hb.Compiler=Compiler;hb.JavaScriptCompiler=JavaScriptCompiler;hb.Parser=Parser;hb.parse=parse;return hb;};Handlebars=create();Handlebars.create=create;__exports__=Handlebars;return __exports__;})(__module1__,__module7__,__module8__,__module10__,__module11__);return __module0__;})();var Tiles={};(function($){var Tile=Tiles.Tile=function(tileId,element){this.id=tileId;this.top=0;this.left=0;this.width=0;this.height=0;this.$el=$(element||document.createElement('div'));};Tile.prototype.appendTo=function($parent,fadeIn,delay,duration){this.$el.hide().appendTo($parent);if(fadeIn){this.$el.delay(delay).fadeIn(duration);}
else{this.$el.show();}};Tile.prototype.remove=function(animate,duration){if(animate){this.$el.fadeOut({complete:function(){$(this).remove();}});}
else{this.$el.remove();}};Tile.prototype.resize=function(cellRect,pixelRect,animate,duration,onComplete){var cssChanges={},changed=false;if(this.left!==pixelRect.x){cssChanges.left=pixelRect.x;this.left=pixelRect.x;changed=true;}
if(this.top!==pixelRect.y){cssChanges.top=pixelRect.y;this.top=pixelRect.y;changed=true;}
if(this.width!==pixelRect.width){cssChanges.width=pixelRect.width;this.width=pixelRect.width;changed=true;}
if(this.height!==pixelRect.height){cssChanges.height=pixelRect.height;this.height=pixelRect.height;changed=true;}
var tile=this,validateChangesAndComplete=function(){var el=tile.$el[0];if(tile.left!==el.offsetLeft){tile.$el.css('left',tile.left);}
if(tile.top!==el.offsetTop){tile.$el.css('top',tile.top);}
if(onComplete){onComplete();}};if(animate&&changed){this.$el.animate(cssChanges,{duration:duration,easing:'swing',complete:validateChangesAndComplete});}
else{if(changed){this.$el.css(cssChanges);}
setTimeout(validateChangesAndComplete,duration);}};})(jQuery);(function($){var parseCells=function(rows){var cells=[],numRows=rows.length,x,y,row,rowLength,cell;for(y=0;y<numRows;y++){row=rows[y];cells[y]=[];for(x=0,rowLength=row.length;x<rowLength;x++){cell=row[x];if(cell!==' '){cells[y].push(cell);}}}
return cells;};function Rectangle(x,y,width,height){this.x=x;this.y=y;this.width=width;this.height=height;}
Rectangle.prototype.copy=function(){return new Rectangle(this.x,this.y,this.width,this.height);};Tiles.Rectangle=Rectangle;var parseRects=function(cells){var rects=[],numRows=cells.length,numCols=numRows===0?0:cells[0].length,cell,height,width,x,y,rectX,rectY;cells=cells.slice();for(y=0;y<numRows;y++){cells[y]=cells[y].slice();}
for(y=0;y<numRows;y++){for(x=0;x<numCols;x++){cell=cells[y][x];if(cell==null){continue;}
width=1;height=1;if(cell!==Tiles.Template.SINGLE_CELL){while(width+x<numCols&&cell===cells[y][x+width]){width++;}
while(height+y<numRows&&cell===cells[y+height][x]){height++;}}
for(rectY=0;rectY<height;rectY++){for(rectX=0;rectX<width;rectX++){cells[y+rectY][x+rectX]=null;}}
rects.push(new Rectangle(x,y,width,height));}}
return rects;};Tiles.Template=function(rects,numCols,numRows){this.rects=rects;this.numTiles=this.rects.length;this.numRows=numRows;this.numCols=numCols;};Tiles.Template.prototype.copy=function(){var copyRects=[],len,i;for(i=0,len=this.rects.length;i<len;i++){copyRects.push(this.rects[i].copy());}
return new Tiles.Template(copyRects,this.numCols,this.numRows);};Tiles.Template.prototype.append=function(other){if(this.numCols!==other.numCols){throw'Appended templates must have the same number of columns';}
var startY=this.numRows,i,len,rect;for(i=0,len=other.rects.length;i<len;i++){rect=other.rects[i];this.rects.push(new Rectangle(rect.x,startY+rect.y,rect.width,rect.height));}
this.numRows+=other.numRows;};Tiles.Template.fromJSON=function(rows){var cells=parseCells(rows),rects=parseRects(cells);return new Tiles.Template(rects,cells.length>0?cells[0].length:0,cells.length);};Tiles.Template.prototype.toJSON=function(){var LABELS='ABCDEFGHIJKLMNOPQRSTUVWXYZ',NUM_LABELS=LABELS.length,labelIndex=0,rows=[],i,len,rect,x,y,label;for(y=0;y<this.numRows;y++){rows[y]=[];for(x=0;x<this.numCols;x++){rows[y][x]=Tiles.Template.SINGLE_CELL;}}
for(i=0,len=this.rects.length;i<len;i++){rect=this.rects[i];if(rect.width>1||rect.height>1){label=LABELS[labelIndex];for(y=0;y<rect.height;y++){for(x=0;x<rect.width;x++){rows[rect.y+y][rect.x+x]=label;}}
labelIndex=(labelIndex+1)%NUM_LABELS;}}
for(y=0;y<this.numRows;y++){rows[y]=rows[y].join('');}
return rows;};Tiles.Template.SINGLE_CELL='.';})(jQuery);Tiles.UniformTemplates={get:function(numCols,targetTiles){var numRows=Math.ceil(targetTiles/numCols),rects=[],x,y;for(y=0;y<numRows;y++){for(x=0;x<numCols;x++){rects.push(new Tiles.Rectangle(x,y,1,1));}}
return new Tiles.Template(rects,numCols,numRows);}};(function($){var Grid=Tiles.Grid=function(element){this.$el=$(element);this.animationDuration=500;this.cellSizeMin=150;this.templateFactory=Tiles.UniformTemplates;this.priorityPageSize=Number.MAX_VALUE;this.cellPadding=10;this.cellSize=0;this.numCols=1;this.template=null;this.isDirty=true;this.tiles=[];this.tilesAdded=[];this.tilesRemoved=[];};Grid.prototype.getContentWidth=function(){return this.$el.width();};Grid.prototype.resizeColumns=function(){var panelWidth=this.getContentWidth();return Math.max(1,Math.floor((panelWidth+this.cellPadding)/(this.cellSizeMin+this.cellPadding)));};Grid.prototype.resizeCellSize=function(){var panelWidth=this.getContentWidth();return Math.ceil((panelWidth+this.cellPadding)/this.numCols)-
this.cellPadding;};Grid.prototype.resize=function(){var newCols=this.resizeColumns();if(this.numCols!==newCols&&newCols>0){this.numCols=newCols;this.isDirty=true;}
var newCellSize=this.resizeCellSize();if(this.cellSize!==newCellSize&&newCellSize>0){this.cellSize=newCellSize;this.isDirty=true;}};Grid.prototype.updateTiles=function(newTileIds){newTileIds=uniques(newTileIds);var numTiles=newTileIds.length,newTiles=[],i,tile,tileId,index;for(i=this.tiles.length-1;i>=0;i--){tile=this.tiles[i];index=$.inArray(tile.id,newTileIds);if(index<0){this.tilesRemoved.push(tile);}
else{newTiles[index]=tile;}}
this.tiles=[];for(i=0;i<numTiles;i++){tile=newTiles[i];if(!tile){tileId=newTileIds[i];if(this.createTile){tile=this.createTile(tileId);if(!tile){continue;}}else{tile=new Tiles.Tile(tileId);}
this.tilesAdded.push(tile);}
this.tiles.push(tile);}};function uniques(items){var results=[],numItems=items?items.length:0,i,item;for(i=0;i<numItems;i++){item=items[i];if($.inArray(item,results)===-1){results.push(item);}}
return results;}
Grid.prototype.insertTiles=function(newTileIds){this.addTiles(newTileIds,true);};Grid.prototype.addTiles=function(newTileIds,prepend){if(!newTileIds||newTileIds.length===0){return;}
var prevTileIds=[],prevTileCount=this.tiles.length,i;for(i=0;i<prevTileCount;i++){prevTileIds.push(this.tiles[i].id);}
var tileIds=prepend?newTileIds.concat(prevTileIds):prevTileIds.concat(newTileIds);this.updateTiles(tileIds);};Grid.prototype.removeTiles=function(removeTileIds){if(!removeTileIds||removeTileIds.length===0){return;}
var updateTileIds=[],i,len,id;for(i=0,len=this.tiles.length;i<len;i++){id=this.tiles[i].id;if($.inArray(id,removeTileIds)===-1){updateTileIds.push(id);}}
this.updateTiles(updateTileIds);};Grid.prototype.createTemplate=function(numCols,targetTiles){numCols=Math.max(1,numCols);var template=this.templateFactory.get(numCols,targetTiles);if(!template){template=Tiles.UniformTemplates.get(numCols,targetTiles);}
return template;};Grid.prototype.ensureTemplate=function(numTiles){if(!this.template||this.template.numCols!==this.numCols){this.template=this.createTemplate(this.numCols,numTiles);this.isDirty=true;}else{var missingRects=numTiles-this.template.rects.length;if(missingRects>0){this.template.append(this.createTemplate(this.numCols,missingRects));this.isDirty=true;}}};function wasOrWillBeVisible(viewRect,tile,newRect){var viewMaxY=viewRect.y+viewRect.height,viewMaxX=viewRect.x+viewRect.width;if(tile){if(!((tile.top>viewMaxY)||(tile.top+tile.height<viewRect.y)||(tile.left>viewMaxX)||(tile.left+tile.width<viewRect.x))){return true;}}
if(newRect){if(!((newRect.y>viewMaxY)||(newRect.y+newRect.height<viewRect.y)||(newRect.x>viewMaxX)||(newRect.x+newRect.width<viewRect.x))){return true;}}
return false;}
Grid.prototype.shouldRedraw=function(){if(this.cellSize<=0){this.resize();}
this.ensureTemplate(this.tiles.length);var shouldRedraw=(this.isDirty||this.tilesAdded.length>0||this.tilesRemoved.length>0);return shouldRedraw;};Grid.prototype.redraw=function(animate,onComplete){if(!this.shouldRedraw()){if(onComplete){onComplete(false);}
return;}
var numTiles=this.tiles.length,pageSize=this.priorityPageSize,duration=this.animationDuration,cellPlusPadding=this.cellSize+this.cellPadding,tileIndex=0,appendDelay=0,viewRect=new Tiles.Rectangle(this.$el.scrollLeft(),this.$el.scrollTop(),this.$el.width(),this.$el.height()),tile,added,pageRects,pageTiles,i,len,cellRect,pixelRect,animateTile,priorityRects,priorityTiles;for(tileIndex=0;tileIndex<numTiles;tileIndex+=pageSize){pageRects=this.template.rects.slice(tileIndex,tileIndex+pageSize);pageTiles=this.tiles.slice(tileIndex,tileIndex+pageSize);priorityRects=pageRects.slice(0);priorityTiles=pageTiles.slice(0);if(this.prioritizePage){this.prioritizePage(priorityRects,priorityTiles);}
for(i=0,len=priorityTiles.length;i<len;i++){tile=priorityTiles[i];added=$.inArray(tile,this.tilesAdded)>=0;cellRect=priorityRects[i];pixelRect=new Tiles.Rectangle(cellRect.x*cellPlusPadding,cellRect.y*cellPlusPadding,(cellRect.width*cellPlusPadding)-this.cellPadding,(cellRect.height*cellPlusPadding)-this.cellPadding);tile.resize(cellRect,pixelRect,animate&&!added&&wasOrWillBeVisible(viewRect,tile,pixelRect),duration);if(added){animateTile=animate&&wasOrWillBeVisible(viewRect,null,pixelRect);if(animateTile&&this.getAppendDelay){appendDelay=this.getAppendDelay(cellRect,pageRects,priorityRects,tile,pageTiles,priorityTiles);}else{appendDelay=0;}
tile.appendTo(this.$el,animateTile,appendDelay,duration);}}}
for(i=0,len=this.tilesRemoved.length;i<len;i++){tile=this.tilesRemoved[i];animateTile=animate&&wasOrWillBeVisible(viewRect,tile,null);tile.remove(animateTile,duration);}
this.tilesRemoved=[];this.tilesAdded=[];this.isDirty=false;if(onComplete){setTimeout(function(){onComplete(true);},duration+10);}};})(jQuery);;(function(){if(typeof(nunaliit2)==='function')return;nunaliit2=function(){};if(typeof(nunaliit2CoreScript)==='undefined')nunaliit2CoreScript='nunaliit2.js';})();;(function($n2){$n2.log=function(){if(typeof window==='object'&&window.console&&typeof window.console.log==='function'){try{window.console.log.apply(window.console,arguments);}
catch(e){};};};if(typeof window!=='undefined'){if(typeof(window.log)==='undefined'){window.log=$n2.log;};};var nativeArrayIndexOf=null;if(typeof Array!=='undefined'&&Array.prototype){nativeArrayIndexOf=Array.prototype.indexOf;};var nativeStringTrim=null;if(typeof String!=='undefined'&&String.prototype){nativeStringTrim=String.prototype.trim;};var cachedBrowserInfo=null;$n2.ERROR_NO_SUPRESS={};var reportedErrors={};$n2.reportError=function(id,str){if(arguments.length<1)return;if(arguments.length<2)str=id;$n2.log(id,str,arguments);if(id===$n2.ERROR_NO_SUPRESS){alert(str);}else if(reportedErrors[id]){}else{reportedErrors[id]=1;alert(str);};};$n2.reportErrorForced=function(str){$n2.reportError($n2.ERROR_NO_SUPRESS,str);};$n2.isDefined=function(_v){return('undefined'!=typeof(_v)&&null!=_v);};if(typeof window!=='undefined'){if(typeof(window.isDefined)==='undefined'){window.isDefined=$n2.isDefined;};};$n2.isArray=function(o){if(o===null)return false;if(o===undefined)return false;if(typeof(o)!=='object')return false;if(typeof(o.length)!=='number')return false;if(typeof(o.push)!=='function')return false;if(typeof(o.pop)!=='function')return false;if(typeof(o.concat)!=='function')return false;if(typeof(o.join)!=='function')return false;if(typeof(o.slice)!=='function')return false;if(typeof(o.reverse)!=='function')return false;if(typeof(o.splice)!=='function')return false;if(typeof(o.sort)!=='function')return false;return true;};$n2.inArray=function(elem,arr,index){var len;if(arr){if(nativeArrayIndexOf){return nativeArrayIndexOf.call(arr,elem,index);};len=arr.length;index=index?index:0;index=index<0?Math.max(0,len+index):index;for(;index<len;++index){if(index in arr&&arr[index]===elem){return index;};};};return-1;};var n2UniqueId=0;$n2.getUniqueId=function(){var id='nunaliit2_uniqueId_'+n2UniqueId;++n2UniqueId;return id;};$n2.getMediaType=function(filename,mimetype){var mediaType=null;if(typeof(mimetype)!='undefined'&&null!=mimetype&&''!=mimetype){var mimeClass=mimetype.split('/');if('image'===mimeClass[0]||'video'===mimeClass[0]||'audio'===mimeClass[0]){mediaType=mimeClass[0];};if(null===mediaType&&'application/ogg'===mimetype){mediaType='audio';};};if(null===mediaType&&typeof(filename)!='undefined'&&null!=filename&&''!=filename){var fileFrags=filename.split('.');var ext=fileFrags[fileFrags.length-1];if('mp3'===ext.toLowerCase()){mediaType='audio';}else if('ogg'===ext.toLowerCase()){mediaType='audio';}else if('jpg'===ext.toLowerCase()){mediaType='image';}else if('png'===ext.toLowerCase()){mediaType='image';}else if('jpeg'===ext.toLowerCase()){mediaType='image';}else if('bmp'===ext.toLowerCase()){mediaType='image';}else if('mov'===ext.toLowerCase()){mediaType='video';};};return(mediaType);};var longLatRe=/^\s*([0-9]{1,2})(°|d|\u00B0)\s*([0-9]{1,2})['m]\s*([0-9]{1,2}(\.[0-9]+)?)["s]\s*([NS])\s*,?\s*([0-9]{1,3})(°|d|\u00B0)\s*([0-9]{1,2})['m]\s*([0-9]{1,2}(\.[0-9]+)?)["s]\s*([WE])\s*$/;$n2.parseLongLatText=function(text){var result={};$n2.log('longLat text',text,longLatRe);var matchObj=text.match(longLatRe);if(null==matchObj){return null;};$n2.log('longLat',matchObj);var longMult=1;if('S'===matchObj[6]){longMult=-1;};result.lng=longMult*(1*matchObj[1]
+(1*matchObj[3]/60)
+(1*matchObj[4]/3600));var latMult=1;if('W'===matchObj[12]){latMult=-1;};result.lat=latMult*(1*matchObj[7]
+(1*matchObj[9]/60)
+(1*matchObj[10]/3600));$n2.log('parseLongLatText',text,result);return result;};$n2.generateHyperlinkHTML=function(text,url,cls){function catStrings(ar){var out='';var spc='';for(var i=0;i<ar.length;i++){out.concat(spc,ar[i]);spc=' ';};return out;};var clsString='';if($n2.isArray(cls)){clsString=catStrings(cls);}else{clsString=cls;};var classSpec='';if(''!==clsString){classSpec=' class="'+clsString+'"';};var uTxt=url;if(!$n2.isDefined(uTxt)||uTxt===''){uTxt='';};var label=text;if(!$n2.isDefined(label)||label===''){label=uTxt;};var out='';if(uTxt!==''){out='<a'+classSpec+' href="'+uTxt+'" target="_blank">'+label+'</a>';}else{out='<div'+classSpec+'>'+label+'</div>';};return out;};$n2.extend=function(){var target=arguments[0]||{},deep=false;var i=1;if(typeof target==='boolean'){deep=target;target=arguments[1]||{};i=2;}
for(var e=arguments.length;i<e;++i){var options=arguments[i];if(null!=options){for(var name in options){var src=target[name];var copy=options[name];if(target===copy){continue;}
if(deep&&copy&&$n2.isArray(copy)){var clone=(src&&$n2.isArray(src))?src:[];target[name]=$n2.extend(deep,clone,copy);}else if(deep&&copy&&typeof(copy)==='object'){var clone=('object'==typeof(src))?src:{};target[name]=$n2.extend(deep,clone,copy);}else if(copy!==undefined){target[name]=copy;}}}}
return target;};$n2.deepCopy=function(o){if(null===o){return o;}else if(typeof o==='undefined'){return o;}else if($n2.isArray(o)){var c=[];for(var i=0,e=o.length;i<e;++i){c[i]=$n2.deepCopy(o[i]);};return c;}else if(typeof(o)==='object'){var c={};for(var i in o){c[i]=$n2.deepCopy(o[i]);};return c;}else{return o;};};$n2.loc=function(str,packageName,args){if($n2.l10n&&$n2.l10n.getLocalizedString){return $n2.l10n.getLocalizedString(str,packageName,args);};return str;};var reLeftWhite=/^[\s\t\x0d\x0a]+/;var reRightWhite=/[\s\t\x0d\x0a]+$/;$n2.trim=function(text){if(null===text){return'';};if(nativeStringTrim){return nativeStringTrim.call(text);};return text.toString().replace(reLeftWhite,'').replace(reRightWhite,'');};$n2.utils={_callbacks:{},stringToHtmlId:function(s){var res=[];for(var i=0,e=s.length;i<e;++i){var c=s[i];if(c>='a'&&c<='z'){res.push(c);}
else if(c>='A'&&c<='Z'){res.push(c);}
else if(c>='0'&&c<='9'){res.push(c);}
else{var code=c.charCodeAt(0);var o0=(code&0x07)+0x30;var o1=((code>>3)&0x07)+0x30;var o2=((code>>6)&0x07)+0x30;res.push('_');res.push(String.fromCharCode(o2));res.push(String.fromCharCode(o1));res.push(String.fromCharCode(o0));};};return res.join('');},unescapeHtmlId:function(s){var res=[];for(var i=0,e=s.length;i<e;++i){var c=s[i];if(c==='_'){++i;var o2=s.charCodeAt(i);++i;var o1=s.charCodeAt(i);++i;var o0=s.charCodeAt(i);var b=((o2-0x30)<<6)+((o1-0x30)<<3)+(o0-0x30);res.push(String.fromCharCode(b));}else{res.push(c);};};return res.join('');},getBrowserInfo:function(){if(cachedBrowserInfo){return cachedBrowserInfo;};var dataBrowser=[{string:navigator.userAgent,subString:"Chrome",identity:"Chrome"},{string:navigator.userAgent,subString:"OmniWeb",versionSearch:"OmniWeb/",identity:"OmniWeb"},{string:navigator.vendor,subString:"Apple",identity:"Safari",versionSearch:"Version"},{prop:window.opera,identity:"Opera",versionSearch:"Version"},{string:navigator.vendor,subString:"iCab",identity:"iCab"},{string:navigator.vendor,subString:"KDE",identity:"Konqueror"},{string:navigator.userAgent,subString:"Firefox",identity:"Firefox"},{string:navigator.vendor,subString:"Camino",identity:"Camino"},{string:navigator.userAgent,subString:"Netscape",identity:"Netscape"},{string:navigator.userAgent,subString:"MSIE",identity:"Explorer",versionSearch:"MSIE"},{string:navigator.userAgent,subString:"Gecko",identity:"Mozilla",versionSearch:"rv"},{string:navigator.userAgent,subString:"Mozilla",identity:"Netscape",versionSearch:"Mozilla"}];var dataOS=[{string:navigator.platform,subString:"Win",identity:"Windows"},{string:navigator.platform,subString:"Mac",identity:"Mac"},{string:navigator.userAgent,subString:"iPhone",identity:"iPhone/iPod"},{string:navigator.platform,subString:"Linux",identity:"Linux"}];var browserInfo={};var versionSearchString;init();cachedBrowserInfo=browserInfo;return browserInfo;function init(){browserInfo.browser=searchString(dataBrowser)||"An unknown browser";browserInfo.version=searchVersion(navigator.userAgent)||searchVersion(navigator.appVersion)||"an unknown version";browserInfo.OS=searchString(dataOS)||"an unknown OS";};function searchString(data){for(var i=0;i<data.length;i++){var dataString=data[i].string;var dataProp=data[i].prop;versionSearchString=data[i].versionSearch||data[i].identity;if(dataString){if(dataString.indexOf(data[i].subString)!=-1)
return data[i].identity;}
else if(dataProp)
return data[i].identity;}};function searchVersion(dataString){var index=dataString.indexOf(versionSearchString);if(index==-1)return;return parseFloat(dataString.substring(index+versionSearchString.length+1));};},isNumber:function(n){return!isNaN(parseFloat(n))&&isFinite(n);},findJavascriptDeclaration:function(javascriptFileName){var scriptLocation=null;var scriptElem=null;var pattern=new RegExp('(^|(.*?\\/))'+javascriptFileName+'$');var scripts=document.getElementsByTagName('script');for(var loop=0;loop<scripts.length;++loop){var src=scripts[loop].getAttribute('src');if(src){var match=src.match(pattern);if(match){scriptLocation=match[1];scriptElem=scripts[loop];break;}}};var result=null;if(null!=scriptElem){result={element:scriptElem,location:scriptLocation,name:javascriptFileName};};return result;},insertJavascriptDeclarations:function(declarationDescription,names,callback){var scriptLocation=declarationDescription.location;var allScriptTags=new Array();for(var i=0;i<names.length;++i){allScriptTags.push('<script type="text/javascript" src="');allScriptTags.push(scriptLocation);allScriptTags.push(names[i]);allScriptTags.push('"></script>');};var cbId=$n2.getUniqueId();$n2.utils._callbacks[cbId]=function(){delete $n2.utils._callbacks[cbId];if(typeof(callback)==='function'){callback();};};allScriptTags.push('<script type="text/javascript">if( typeof(nunaliit2.utils._callbacks["');allScriptTags.push(cbId);allScriptTags.push('"]) === "function" ){ nunaliit2.utils._callbacks["');allScriptTags.push(cbId);allScriptTags.push('"](); };');allScriptTags.push('</script>');document.write(allScriptTags.join(''));},formatString:function(format,args){return format.replace(/{([^}]+)}/g,function(match,name){name=$n2.trim(name);if(''===name)return match;return typeof args[name]!=='undefined'?args[name]:match;});},getCurrentTime:Date.now||function(){return+new Date();},formatDate:function(date,format){var str=format.replace('%Y',''+date.getFullYear());var monthNumStr=''+(date.getMonth()+1);if(monthNumStr.length<2)monthNumStr='0'+monthNumStr;str=str.replace('%m',monthNumStr);var dateNumStr=''+date.getDate();if(dateNumStr.length<2)dateNumStr='0'+dateNumStr;str=str.replace('%d',dateNumStr);var hoursNumStr=''+date.getHours();if(hoursNumStr.length<2)hoursNumStr='0'+hoursNumStr;str=str.replace('%H',hoursNumStr);var minutesNumStr=''+date.getMinutes();if(minutesNumStr.length<2)minutesNumStr='0'+minutesNumStr;str=str.replace('%M',minutesNumStr);var secondsNumStr=''+date.getSeconds();if(secondsNumStr.length<2)secondsNumStr='0'+secondsNumStr;str=str.replace('%S',secondsNumStr);return str;},parseHttpJsonError:function(xmlHttpRequest,defaultText){if(!JSON||typeof(JSON.parse)!=='function'){return createDefault();};var text=xmlHttpRequest.responseText;if(!text)return createDefault();var error=JSON.parse(text);if(!error)return createDefault();return error;function createDefault(){return{error:defaultText,reason:defaultText};};},debounce:function(func,wait,immediate){var timeout=null;return function(){var context=this,args=arguments;var later=function(){timeout=null;if(!immediate)func.apply(context,args);};if(immediate&&!timeout)func.apply(context,args);clearTimeout(timeout);timeout=setTimeout(later,wait);};},getElementIdentifier:function(elem){var $elem=$(elem);var id=$elem.attr('id');if(!id){id=$n2.getUniqueId();$elem.attr('id',id);};return id;}};var htmlEscapeCharMap={'&':'&amp;','<':'&lt;','>':'&gt;','"':'&quot;',"'":'&#x27;','`':'&#x60;'};var reHtmlCharSelect=/[&<>"'`]/g;var reHtmlCharTest=/[&<>"'`]/;var htmlEscapeCharFn=function(match){return htmlEscapeCharMap[match]||"";};$n2.utils.escapeHtml=function(str){if(typeof(str)!=='string'){return"";};if(!reHtmlCharTest.test(str)){return str;};return str.replace(reHtmlCharSelect,htmlEscapeCharFn);};})(nunaliit2);;(function($n2){function getCookies(){var cookies={};if(typeof document!=='undefined'&&document.cookie){var rawCookies=document.cookie.split(';');for(var i=0,e=rawCookies.length;i<e;++i){var c=rawCookies[i].split('=');if(c.length&&c.length>1){var key=decodeURIComponent($n2.trim(c[0]));var value=decodeURIComponent($n2.trim(c[1]));cookies[key]=value;};};};return cookies;};function getCookie(name){var cookies=getCookies();if(typeof(cookies[name])==='undefined')return null;return cookies[name];};function setCookie(opt_){var opt=$n2.extend({name:null,value:null,end:null,path:null,domain:null,secure:false},opt_);var cookie=[escape(opt.name),'=',escape(opt.value)];if(null!==opt.end){switch(typeof(opt.end)){case"number":cookie.push('; max-age='+opt.end);break;case"string":cookie.push('; expires='+opt.end);break;case"object":if(opt.end.hasOwnProperty("toGMTString")){cookie.push('; expires='+opt.end.toGMTString());};break;};};if(opt.domain){cookie.push('; domain='+opt.domain);};if(opt.path){cookie.push('; path='+opt.path);};if(opt.secure){cookie.push('; secure');};document.cookie=cookie.join('');};function deleteCookie(name){document.cookie=name+'=;expires=Thu, 01 Jan 1970 00:00:01 GMT;';};$n2.cookie={getCookies:getCookies,getCookie:getCookie,setCookie:setCookie,deleteCookie:deleteCookie};})(nunaliit2);;(function($n2){function getScriptLocation(scriptName){var result=null;if(typeof document==='object'){var pattern=new RegExp("(^|(.*?\\/))"+scriptName+"$");var scripts=document.getElementsByTagName('script');for(var loop=0;loop<scripts.length;++loop){var src=scripts[loop].getAttribute('src');if(src){var match=src.match(pattern);if(match){result={location:match[1],elem:scripts[loop]};break;};};};};return result;};function getCoreScriptLocation(){return getScriptLocation(nunaliit2CoreScript);};function loadScript(scriptUrl,refLocation){var scriptElem=document.getElementsByTagName('script')[0];if(refLocation&&refLocation.elem){scriptElem=refLocation.elem;};var s=document.createElement('script');s.src=scriptUrl;s.type='text/javascript';scriptElem.parentNode.insertBefore(s,scriptElem);};$n2.scripts={getScriptLocation:getScriptLocation,getCoreScriptLocation:getCoreScriptLocation,loadScript:loadScript};})(nunaliit2);;(function($n2){var EmptyInit=function(){};$n2.Class=function(){var proto={};var vars={};var className=null;var Class=function(){for(var key in vars){if(vars[key]===null){this[key]=vars[key];}else if($n2.isArray(vars[key])){this[key]=$n2.extend(true,[],vars[key]);}else if(typeof(vars[key])==='object'){this[key]=$n2.extend(true,{},vars[key]);}else if(typeof(vars[key])==='function'){}else{this[key]=vars[key];};};if(typeof(className)==='string'){this._classname=className;};this.initialize.apply(this,arguments);};for(var i=0,len=arguments.length;i<len;++i){if(i===0&&typeof(arguments[i])==='string'){Class._classname=className=arguments[i];}else if(typeof(arguments[i])==='function'){var parent=arguments[i].prototype;for(var key in parent){if(typeof(parent[key])==='function'){proto[key]=parent[key];}else{vars[key]=parent[key];};};if(arguments[i]._vars){$n2.extend(vars,arguments[i]._vars);};}else{var def=arguments[i];for(var key in def){if(typeof(def[key])==='function'){proto[key]=def[key];}else{vars[key]=def[key];};};};}
if(!proto.initialize){proto.initialize=EmptyInit;};proto.getClass=function(){return Class;};Class.prototype=proto;Class._vars=vars;return Class;};})(nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var sessionStorage=null;var localStorage=null;function getSessionStorage(){if(!sessionStorage){if(window.sessionStorage){sessionStorage=new Storage(window.sessionStorage);}else{sessionStorage=new FallbackStorage();};};return sessionStorage;};function getLocalStorage(){if(!localStorage){if(window.localStorage){localStorage=new Storage(window.localStorage);}else{localStorage=new FallbackStorage();};};return localStorage;};var Storage=$n2.Class({browserObj:null,initialize:function(browserObj){this.browserObj=browserObj;},getKeys:function(){var keys=[];var s=this.browserObj.length;for(var i=0;i<s;++i){keys.push(this.browserObj.key(i));};return keys;},getItem:function(key){return this.browserObj.getItem(key);},setItem:function(key,value){this.browserObj.setItem(key,value);},removeItem:function(key){this.browserObj.removeItem(key,value);},clear:function(){this.browserObj.clear();}});var FallbackStorage=$n2.Class({store:null,initialize:function(){this.store={};},getKeys:function(){var keys=[];for(var key in this.store){keys.push(key);};return keys;},getItem:function(key){if(this.store[key]){return this.store[key];};return null;},setItem:function(key,value){this.store[key]=value;},removeItem:function(key){delete this.store[key];},clear:function(){this.store={};}});$n2.storage={getSessionStorage:getSessionStorage,getLocalStorage:getLocalStorage,Storage:Storage};})(nunaliit2);;(function($n2){var Url=$n2.Class({options:null,initialize:function(options_){this.options=$n2.extend({url:null},options_);},getUrl:function(){return this.options.url;},getUrlWithoutHash:function(){var href=this.getUrl();var index=href.indexOf('#');if(index>=0){href=href.substr(0,index);};return href;},getUrlWithoutParams:function(){var href=this.getUrlWithoutHash();var index=href.indexOf('?');if(index>=0){href=href.substr(0,index);};return href;},getParams:function(){var result={};var href=this.getUrlWithoutHash();var paramsString=href.slice(href.indexOf('?')+1);var params=paramsString.split('&');for(var loop=0;loop<params.length;++loop){var s=params[loop].split('=');var key=decodeURIComponent(s[0]);var value=decodeURIComponent(s[1]);if(null==result[key]){result[key]=[];}
result[key].push(value);}
return result;},getParam:function(name){var params=this.getParams();if(null==params[name]){return[];}
return params[name];},getParamValue:function(name,defaultValue){var params=this.getParams();if(null==params[name]){return defaultValue;}
return params[name][0];}});$n2.url={Url:Url,getCurrentLocation:function(){if(typeof window==='object'&&window.location&&window.location.href){return new Url({url:window.location.href});};return null;},getUrlWithoutHash:function(){var loc=$n2.url.getCurrentLocation();return loc?loc.getUrlWithoutHash():null;},getUrlWithoutParams:function(){var loc=$n2.url.getCurrentLocation();return loc?loc.getUrlWithoutParams():null;},getParams:function(){var loc=$n2.url.getCurrentLocation();return loc?loc.getParams():{};},getParam:function(name){var loc=$n2.url.getCurrentLocation();return loc?loc.getParam(name):null;},getParamValue:function(name,defaultValue){var loc=$n2.url.getCurrentLocation();return loc?loc.getParamValue(name,defaultValue):defaultValue;}};})(nunaliit2);;(function($,$n2){var browserInfo=$n2.utils.getBrowserInfo();if(browserInfo&&browserInfo.browser==='Explorer'){if(typeof(browserInfo.version)==='number'){if(browserInfo.version<9){if($.ajaxSetup){$.ajaxSetup({cache:false});};if(!Array.prototype.indexOf){Array.prototype.indexOf=function(elt){var len=this.length>>>0;var from=Number(arguments[1])||0;from=(from<0)?Math.ceil(from):Math.floor(from);if(from<0)from+=len;for(;from<len;++from){if(from in this&&this[from]===elt){return from;};};return-1;};};};};};$.widget('nunaliit.menuselector',{options:{menuClass:null},_create:function(){var _this=this;this.wrapper=$('<span>').addClass('nunaliit-menuselector').insertAfter(this.element);var classes=this.element.attr('class');var text=this.element.find('option').first().text();this.button=$('<select>').appendTo(this.wrapper).mousedown(function(e){_this._toggleMenu();return false;});if(classes){this.button.attr('class',classes);};$('<option>').text(text).appendTo(this.button);this.menu=$('<div>').addClass('nunaliit-menuselector').css('position','absolute').css('left','0px').css('top','0px').css('display','block').css('z-index',1000).hide().appendTo(this.wrapper);this.element.hide();},_createMenu:function(wrapper){var _this=this;var $menu=$('<ul>').appendTo(wrapper).addClass('nunaliit-menuselector-menu');if(this.options.menuClass){$menu.addClass(this.options.menuClass);};this.element.find('option').each(function(){var $opt=$(this);var value=$opt.val();if(value){var $li=$('<li>').appendTo($menu);$('<a>').appendTo($li).attr('href','#').text($opt.text()).click(createClickHandler(value));};});$menu.menu();function createClickHandler(value){return function(){_this._click(value);return false;};};},_toggleMenu:function(){var wrapper=this.wrapper,menu=wrapper.children('div');if(menu.is(':visible')){menu.empty();menu.hide();}else{this._createMenu(menu);menu.show();menu.position({my:'left top',at:'left bottom',of:this.button});};},_click:function(value){this._toggleMenu();this.element.val(value);this.element.trigger('change');},_destroy:function(){this.wrapper.remove();this.element.show();}});})(jQuery,nunaliit2);;(function($n2){if(!$n2.l10n)$n2.l10n={};if(!$n2.l10n.strings)$n2.l10n.strings={};if(!$n2.l10n.strings['en'])$n2.l10n.strings['en']={};var reLangCountry=/^([a-z][a-z])-([a-zA-Z][a-zA-Z])$/;var reLang=/^([a-z][a-z])$/;var strings=$n2.l10n.strings;var cachedLocale=null;var translationRequests={};function getLocale(){if(cachedLocale)return cachedLocale;if(null==cachedLocale&&$n2.cookie){var lang=$n2.cookie.getCookie('nunaliit-l10n');if(lang){cachedLocale=createLocaleFromLanguage(lang);};};if(null==cachedLocale&&$n2.url){var lang=$n2.url.getParamValue('lang',null);if(lang){cachedLocale=createLocaleFromLanguage(lang);};};if(null==cachedLocale&&typeof navigator==='object'){if(navigator.language){cachedLocale=createLocaleFromLanguage(navigator.language);}else if(navigator.browserLanguage){cachedLocale=createLocaleFromLanguage(navigator.browserLanguage);}else if(navigator.systemLanguage){cachedLocale=createLocaleFromLanguage(navigator.systemLanguage);}else if(navigator.userLanguage){cachedLocale=createLocaleFromLanguage(navigator.userLanguage);};};if(null==cachedLocale){cachedLocale=createLocaleFromLanguage('en-US');};return cachedLocale;function createLocaleFromLanguage(lang){if(null==lang)return null;var mLangCountry=lang.match(reLangCountry);if(mLangCountry){return{locale:lang,lang:mLangCountry[1],country:mLangCountry[2]};};var mLang=lang.match(reLang);if(mLang){return{locale:lang,lang:mLang[1],country:null};};$n2.log('Locale specified, but not in xx-YY format. Ignored.',lang);return null;};};function getDictionaryFromLang(lang){if(null==strings[lang]){strings[lang]={};}
return strings[lang];};function getStringForLang(str,lang){var result={str:null,lang:null,fallback:false};if(typeof(str)==='string'){result.str=str;}else if(typeof(str)==='object'&&str.nunaliit_type==='localized'){if(typeof(str[lang])==='string'){result.str=str[lang];result.lang=lang;}else if(typeof(str.en)==='string'){result.str=str.en;result.lang=lang;result.fallback=true;}else{for(var fbLang in str){if('nunaliit_type'===fbLang){}else{result.str=str[fbLang];result.lang=fbLang;result.fallback=true;break;};};};};return result;};function getStringForLocale(str){var locale=getLocale();var lang=locale.lang;return getStringForLang(str,lang);};function getLocalizedString(str,packageName,args){var locale=getLocale();var lang=locale.lang;var lookupStr=str;var lookupLang='en';if(str.nunaliit_type==='localized'){lookupStr=null;if(typeof(str[lang])==='string'){lookupStr=str[lang];lookupLang=lang;}else if(typeof(str.en)==='string'){lookupStr=str.en;lookupLang=lang;}else{for(var fbLang in str){if('nunaliit_type'===fbLang){}else{lookupStr=str[fbLang];lookupLang=fbLang;break;};};};};var dic=getDictionaryFromLang(lang);var langStr=dic[lookupStr];if(null==langStr){langStr=lookupStr;if(lookupLang!==lang){requestTranslation(lookupStr,lang,packageName);dic[lookupStr]=langStr;};};if(args){return $n2.utils.formatString(langStr,args);};return langStr;};function addLocalizedString(enStr,lang,langStr){var dict=getDictionaryFromLang(lang);dict[enStr]=langStr;};function getTranslationRequestsFromLang(lang){var dic=translationRequests[lang];if(null==dic){dic={};translationRequests[lang]=dic;};return dic;};function requestTranslation(str,lang,packageName){var dic=getTranslationRequestsFromLang(lang);var request=dic[str];if(null==request){request={lang:lang,str:str,packageName:packageName};dic[str]=request;if($n2.l10n.sendTranslationRequest){$n2.l10n.sendTranslationRequest(request);};};};$n2.l10n.getLocale=getLocale;$n2.l10n.getLocalizedString=getLocalizedString;$n2.l10n.getStringForLang=getStringForLang;$n2.l10n.getStringForLocale=getStringForLocale;$n2.l10n.requestTranslation=requestTranslation;$n2.l10n.translationRequests=translationRequests;$n2.l10n.addLocalizedString=addLocalizedString;if($n2.scripts){var locale=getLocale();var coreLocation=$n2.scripts.getCoreScriptLocation();if(coreLocation){if('en'!==locale.lang){var url=coreLocation.location+'nunaliit2.'+locale.lang+'.js';$n2.scripts.loadScript(url,coreLocation);};var langUrl=coreLocation.location+'../nunaliit_lang.'+locale.lang+'.js';$n2.scripts.loadScript(langUrl,coreLocation);};if(typeof jQuery!=='undefined'){jQuery('body').addClass('nunaliit_language_'+locale.lang);};};})(nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var Interval=$n2.Class({min:null,max:null,initialize:function(opts_){var opts=$n2.extend({min:null,max:null},opts_);if(typeof opts.min!=='number'){throw _loc('Interval min must be a number');};if(typeof opts.max!=='number'){throw _loc('Interval max must be a number');};if(opts.min>opts.max){throw _loc('Interval min can not be greater than max');};this.min=opts.min;this.max=opts.max;},size:function(){return(this.max-this.min);},equals:function(interval){if(!interval){return false;};if(typeof interval.min!=='number'){return false;};if(typeof interval.max!=='number'){return false;};if(this.min===interval.min&&this.max===interval.max){return true;};return false;},isIncludedIn:function(interval){if(!interval){return false;};if(typeof interval.min!=='number'){return false;};if(typeof interval.max!=='number'){return false;};if(this.min>=interval.min&&this.max<=interval.max){return true;};return false;},extendTo:function(interval){var min=this.min;var max=this.max;if(interval){if(min>interval.min){min=interval.min;};if(max<interval.max){max=interval.max;};};var myClass=this.getClass();return new myClass({min:min,max:max});},intersectsWith:function(interval){if(!interval){return false;};if(this.min>interval.max){return false;};if(this.max<interval.min){return false;};return true;},intersection:function(interval){if(!this.intersectsWith(interval)){return null;};var min=this.min;var max=this.max;if(min<interval.min){min=interval.min;};if(max>interval.max){max=interval.max;};var myClass=this.getClass();return new myClass({min:min,max:max});}});$n2.Interval=Interval;$n2.interval={Interval:Interval};})(nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var DateInterval=$n2.Class($n2.Interval,{dateStr:null,initialize:function(opts_){$n2.Interval.prototype.initialize.call(this,opts_);this.dateStr=opts_.dateStr;},getDateString:function(){return this.dateStr;},getDocumentStructure:function(){var obj={nunaliit_type:'date',date:this.dateStr,min:this.min,max:this.max};return obj;}});var reYear=/^\s*(\d\d\d\d)\s*$/;var reYearMonth=/^\s*(\d\d\d\d)-(\d\d)\s*$/;var reYearMonthDay=/^\s*(\d\d\d\d)(\d\d)(\d\d)\s*$/;var reYearMonthDay2=/^\s*(\d\d\d\d)-(\d\d)-(\d\d)\s*$/;var reYearMonthDayHM=/^\s*(\d\d\d\d)(\d\d)(\d\d)( +|T)(\d\d):(\d\d)\s*$/;var reYearMonthDayHM2=/^\s*(\d\d\d\d)-(\d\d)-(\d\d)( +|T)(\d\d):(\d\d)\s*$/;var reYearMonthDayHMS=/^\s*(\d\d\d\d)(\d\d)(\d\d)( +|T)(\d\d):(\d\d):(\d\d)\s*$/;var reYearMonthDayHMS2=/^\s*(\d\d\d\d)-(\d\d)-(\d\d)( +|T)(\d\d):(\d\d):(\d\d)\s*$/;var rePeriod=/^([^\/]*)\/([^\/]*)$/;function parseUserDate(dateStr){var matchPeriod=rePeriod.exec(dateStr);var matchYear=reYear.exec(dateStr);var matchYearMonth=reYearMonth.exec(dateStr);var matchYearMonthDay=reYearMonthDay.exec(dateStr);var matchYearMonthDay2=reYearMonthDay2.exec(dateStr);var matchYearMonthDayHM=reYearMonthDayHM.exec(dateStr);var matchYearMonthDayHM2=reYearMonthDayHM2.exec(dateStr);var matchYearMonthDayHMS=reYearMonthDayHMS.exec(dateStr);var matchYearMonthDayHMS2=reYearMonthDayHMS2.exec(dateStr);if(matchPeriod){var startDateStr=matchPeriod[1];var endDateStr=matchPeriod[2];var startDate=null;var endDate=null;try{startDate=parseUserDate(startDateStr);endDate=parseUserDate(endDateStr);}catch(e){};if(startDate&&endDate){var exDate=startDate.extendTo(endDate);exDate.dateStr=dateStr;return exDate;};};if(matchYear){var year=1*matchYear[1];var min=(new Date(year,0,1)).getTime();var max=(new Date(year+1,0,1)).getTime();return new DateInterval({min:min,max:max-1000,dateStr:matchYear[0]});}else if(matchYearMonth){var year=1*matchYearMonth[1];var month=1*matchYearMonth[2];if(month<1||month>12){throw _loc('Month must be an integer between 1 and 12');};var min=(new Date(year,month-1,1)).getTime();var max=(new Date(year,month,1)).getTime();return new DateInterval({min:min,max:max-1000,dateStr:matchYearMonth[0]});}else if(matchYearMonthDay){var year=1*matchYearMonthDay[1];var month=1*matchYearMonthDay[2];var day=1*matchYearMonthDay[3];if(month<1||month>12){throw _loc('Month must be an integer between 1 and 12');};if(day<1||day>31){throw _loc('Day must be an integer between 1 and 31');};var min=(new Date(year,month-1,day)).getTime();var max=(new Date(year,month-1,day+1)).getTime();return new DateInterval({min:min,max:max-1000,dateStr:matchYearMonthDay[0]});}else if(matchYearMonthDay2){var year=1*matchYearMonthDay2[1];var month=1*matchYearMonthDay2[2];var day=1*matchYearMonthDay2[3];if(month<1||month>12){throw _loc('Month must be an integer between 1 and 12');};if(day<1||day>31){throw _loc('Day must be an integer between 1 and 31');};var min=(new Date(year,month-1,day)).getTime();var max=(new Date(year,month-1,day+1)).getTime();return new DateInterval({min:min,max:max-1000,dateStr:matchYearMonthDay2[0]});}else if(matchYearMonthDayHM){var year=1*matchYearMonthDayHM[1];var month=1*matchYearMonthDayHM[2];var day=1*matchYearMonthDayHM[3];var hour=1*matchYearMonthDayHM[5];var minutes=1*matchYearMonthDayHM[6];if(month<1||month>12){throw _loc('Month must be an integer between 1 and 12');};if(day<1||day>31){throw _loc('Day must be an integer between 1 and 31');};if(hour<0||hour>23){throw _loc('Hour must be an integer between 0 and 23');};if(minutes<0||minutes>59){throw _loc('Minutes must be an integer between 0 and 59');};var min=(new Date(year,month-1,day,hour,minutes)).getTime();var max=(new Date(year,month-1,day,hour,minutes+1)).getTime();return new DateInterval({min:min,max:max-1000,dateStr:matchYearMonthDayHM[0]});}else if(matchYearMonthDayHM2){var year=1*matchYearMonthDayHM2[1];var month=1*matchYearMonthDayHM2[2];var day=1*matchYearMonthDayHM2[3];var hour=1*matchYearMonthDayHM2[5];var minutes=1*matchYearMonthDayHM2[6];if(month<1||month>12){throw _loc('Month must be an integer between 1 and 12');};if(day<1||day>31){throw _loc('Day must be an integer between 1 and 31');};if(hour<0||hour>23){throw _loc('Hour must be an integer between 0 and 23');};if(minutes<0||minutes>59){throw _loc('Minutes must be an integer between 0 and 59');};var min=(new Date(year,month-1,day,hour,minutes)).getTime();var max=(new Date(year,month-1,day,hour,minutes+1)).getTime();return new DateInterval({min:min,max:max-1000,dateStr:matchYearMonthDayHM2[0]});}else if(matchYearMonthDayHMS){var year=1*matchYearMonthDayHMS[1];var month=1*matchYearMonthDayHMS[2];var day=1*matchYearMonthDayHMS[3];var hour=1*matchYearMonthDayHMS[5];var minutes=1*matchYearMonthDayHMS[6];var secs=1*matchYearMonthDayHMS[7];if(month<1||month>12){throw _loc('Month must be an integer between 1 and 12');};if(day<1||day>31){throw _loc('Day must be an integer between 1 and 31');};if(hour<0||hour>23){throw _loc('Hour must be an integer between 0 and 23');};if(minutes<0||minutes>59){throw _loc('Minutes must be an integer between 0 and 59');};if(secs<0||secs>59){throw _loc('Seconds must be an integer between 0 and 59');};var min=(new Date(year,month-1,day,hour,minutes,secs)).getTime();var max=(new Date(year,month-1,day,hour,minutes,secs+1)).getTime();return new DateInterval({min:min,max:max-1000,dateStr:matchYearMonthDayHMS[0]});}else if(matchYearMonthDayHMS2){var year=1*matchYearMonthDayHMS2[1];var month=1*matchYearMonthDayHMS2[2];var day=1*matchYearMonthDayHMS2[3];var hour=1*matchYearMonthDayHMS2[5];var minutes=1*matchYearMonthDayHMS2[6];var secs=1*matchYearMonthDayHMS2[7];if(month<1||month>12){throw _loc('Month must be an integer between 1 and 12');};if(day<1||day>31){throw _loc('Day must be an integer between 1 and 31');};if(hour<0||hour>23){throw _loc('Hour must be an integer between 0 and 23');};if(minutes<0||minutes>59){throw _loc('Minutes must be an integer between 0 and 59');};if(secs<0||secs>59){throw _loc('Seconds must be an integer between 0 and 59');};var min=(new Date(year,month-1,day,hour,minutes,secs)).getTime();var max=(new Date(year,month-1,day,hour,minutes,secs+1)).getTime();return new DateInterval({min:min,max:max-1000,dateStr:matchYearMonthDayHMS2[0]});}else{throw _loc('Can not parse date');};};var rFindYear=/(\d\d\d\d)/;var rFindMonthDay=/^-(\d\d)-(\d\d)/;var rFindMonthDay2=/^(\d\d)(\d\d)/;var rFindMonth=/^-?(\d\d)/;var rFindHMS=/^( +|T)(\d\d):(\d\d)(:(\d\d))?/;var rFindHMS2=/^( +|T)(\d\d)(\d\d)(\d\d)?/;var rDurationSeparator=/^\s*\/\s*?/;function findDateString(str,index){var result=null;var index=index?index:0;var next=(index>0)?str.substr(index):str;var mFindYear=rFindYear.exec(next);if(mFindYear){result={input:str,index:mFindYear.index+index,year:1*mFindYear[1]};index=index+mFindYear.index+mFindYear[1].length;var next=str.substr(index);var parseTime=false;var mFindMonthDay=rFindMonthDay.exec(next);if(mFindMonthDay){result.month=1*mFindMonthDay[1];result.day=1*mFindMonthDay[2];if(result.month<1||result.month>12||result.day<1||result.day>31){return findDateString(str,index);};index+=mFindMonthDay[0].length;parseTime=true;next=str.substr(index);}else{var mFindMonthDay2=rFindMonthDay2.exec(next);if(mFindMonthDay2){result.month=1*mFindMonthDay2[1];result.day=1*mFindMonthDay2[2];if(result.month<1||result.month>12||result.day<1||result.day>31){return findDateString(str,index);};index+=mFindMonthDay2[0].length;parseTime=true;next=str.substr(index);}else{var mFindMonth=rFindMonth.exec(next);if(mFindMonth){result.month=1*mFindMonth[1];if(result.month<1||result.month>12){return findDateString(str,index);};index+=mFindMonth[0].length;};};};if(parseTime){var mFindHMS=rFindHMS.exec(next);var mFindHMS2=rFindHMS2.exec(next);if(mFindHMS){result.hours=1*mFindHMS[2];result.minutes=1*mFindHMS[3];if(typeof mFindHMS[5]!=='undefined'){result.seconds=1*mFindHMS[5];};if(result.hours>23||result.minutes>59){return findDateString(str,index);};if(typeof result.seconds!=='undefined'){if(result.seconds>59){return findDateString(str,index);};};index+=mFindHMS[0].length;}else if(mFindHMS2){result.hours=1*mFindHMS2[2];result.minutes=1*mFindHMS2[3];if(typeof mFindHMS2[4]!=='undefined'){result.seconds=1*mFindHMS2[4];};if(result.hours>23||result.minutes>59){return findDateString(str,index);};if(typeof result.seconds!=='undefined'){if(result.seconds>59){return findDateString(str,index);};};index+=mFindHMS2[0].length;};};var l=index-result.index;result.str=str.substr(result.index,l);if(typeof result.seconds!=='undefined'){var min=(new Date(result.year,result.month-1,result.day,result.hours,result.minutes,result.seconds)).getTime();var max=(new Date(result.year,result.month-1,result.day,result.hours,result.minutes,result.seconds+1)).getTime();result.interval=new DateInterval({min:min,max:max-1000,dateStr:result.str});}else if(typeof result.minutes!=='undefined'){var min=(new Date(result.year,result.month-1,result.day,result.hours,result.minutes)).getTime();var max=(new Date(result.year,result.month-1,result.day,result.hours,result.minutes+1)).getTime();result.interval=new DateInterval({min:min,max:max-1000,dateStr:result.str});}else if(typeof result.hours!=='undefined'){var min=(new Date(result.year,result.month-1,result.day,result.hours)).getTime();var max=(new Date(result.year,result.month-1,result.day,result.hours+1)).getTime();result.interval=new DateInterval({min:min,max:max-1000,dateStr:result.str});}else if(typeof result.day!=='undefined'){var min=(new Date(result.year,result.month-1,result.day)).getTime();var max=(new Date(result.year,result.month-1,result.day+1)).getTime();result.interval=new DateInterval({min:min,max:max-1000,dateStr:result.str});}else if(typeof result.month!=='undefined'){var min=(new Date(result.year,result.month-1,1)).getTime();var max=(new Date(result.year,result.month,1)).getTime();result.interval=new DateInterval({min:min,max:max-1000,dateStr:result.str});}else{var min=(new Date(result.year,0,1)).getTime();var max=(new Date(result.year+1,0,1)).getTime();result.interval=new DateInterval({min:min,max:max-1000,dateStr:result.str});};var start=result.index+result.str.length;var another=findDateString(str,start);if(another){var sepStr=str.substr(start,another.index-start);var mDurationSeparator=rDurationSeparator.exec(sepStr);if(mDurationSeparator){result.str=str.substr(result.index,another.index+another.str.length-result.index);result.interval=result.interval.extendTo(another.interval);if(typeof result.year!=='undefined')delete result.year;if(typeof result.month!=='undefined')delete result.month;if(typeof result.day!=='undefined')delete result.day;if(typeof result.hours!=='undefined')delete result.hours;if(typeof result.minutes!=='undefined')delete result.minutes;if(typeof result.seconds!=='undefined')delete result.seconds;};};};return result;};function findAllDateStrings(str){var results=[];var d=findDateString(str);while(d){results.push(d);var index=d.index+d.str.length;d=findDateString(str,index);};return results;};function parseDateStructure(obj){if(!obj||typeof obj.date!=='string'){throw _loc('Invalid date structure');};var dateInt=parseUserDate(obj.date);return dateInt;};$n2.date={DateInterval:DateInterval,parseUserDate:parseUserDate,parseDateStructure:parseDateStructure,findDateString:findDateString,findAllDateStrings:findAllDateStrings};})(nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var DateService=$n2.Class({url:null,initialize:function(opts_){var opts=$n2.extend({url:null},opts_);this.url=opts.url;},getDocIdsFromInterval:function(opts_){var opts=$n2.extend({interval:null,onSuccess:function(docIds){},onError:function(err){}},opts_);if(!opts.interval||typeof opts.interval.min!=='number'||typeof opts.interval.max!=='number'){opts.onError('Interval must be supplied');};var min=opts.interval.min;var max=opts.interval.max;$.ajax({url:this.url+'docIdsFromInterval',type:'get',async:true,data:{min:min,max:max},dataType:'json',success:function(res){if(res.docIds){opts.onSuccess(res.docIds);}else{opts.onError('Malformed response for doc ids from interval('+min+','+max+')');};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=$n2.utils.parseHttpJsonError(XMLHttpRequest,textStatus);var errStr=err.error;opts.onError('Error obtaining doc ids from interval('+min+','+max+'): '+errStr);}});}});$n2.dateService={DateService:DateService};})(jQuery,nunaliit2);;(function($n2){var codex="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";$n2.Base64={encode:function(input){var output=[];var index=0;while(index<input.length){var chr1=input.charCodeAt(index++);var chr2=input.charCodeAt(index++);var chr3=input.charCodeAt(index++);var enc1=chr1>>2;var enc2=((chr1&3)<<4)|(chr2>>4);var enc3=((chr2&15)<<2)|(chr3>>6);var enc4=chr3&63;if(isNaN(chr2)){enc3=enc4=64;}else if(isNaN(chr3)){enc4=64;}
output.push(codex.charAt(enc1)+codex.charAt(enc2)+codex.charAt(enc3)+codex.charAt(enc4));};return output.join('');},decode:function(input){var output=[];input=input.replace(/[^A-Za-z0-9\+\/\=]/g,"");var i=0;while(i<input.length){var enc1=codex.indexOf(input.charAt(i++));var enc2=codex.indexOf(input.charAt(i++));var enc3=codex.indexOf(input.charAt(i++));var enc4=codex.indexOf(input.charAt(i++));var chr1=(enc1<<2)|(enc2>>4);var chr2=((enc2&15)<<4)|(enc3>>2);var chr3=((enc3&3)<<6)|enc4;output.push(String.fromCharCode(chr1));if(enc3!=64){output.push(String.fromCharCode(chr2));}
if(enc4!=64){output.push(String.fromCharCode(chr3));}}
return output.join('');}};})(nunaliit2);;(function($,$n2){var noopFn=function(){}
var BlindWidget=$n2.Class({options:null,id:null,initialize:function($elem,opts_){var _this=this;this.options=$n2.extend({time:500,data:null,onBeforeOpen:noopFn,onAfterOpen:noopFn,onBeforeClose:noopFn,onAfterClose:noopFn},opts_);var id=$elem.attr('id');if(null===id||typeof(id)==='undefined'){id=$n2.getUniqueId();$elem.attr('id',id);};this.id=id;var $header=$elem.children().first();var $div=$header.next();$elem.addClass('n2Blind ui-accordion ui-widget ui-helper-reset ui-accordion-icons');var headerText=$header.text();$header.empty().append($('<span class="ui-icon ui-icon-triangle-1-e"></span>')).append($('<a class="n2BlindA" href="#"></a>')).click(function(){_this._headerClicked();return false;});$header.find('a').text(headerText);$header.addClass('ui-accordion-header ui-helper-reset ui-state-default ui-corner-top');$div.addClass('ui-accordion-content ui-helper-reset ui-widget-content ui-corner-bottom ui-accordion-content-active').css('display','none');},setText:function(t){var $elem=$('#'+this.id);var $header=$elem.children().first();$header.find('a').text(t);},setHtml:function(h){var $elem=$('#'+this.id);var $header=$elem.children().first();$header.find('a').html(h);},_headerClicked:function(){var _this=this;var $sections=$('#'+this.id);if($sections.length<1){return;};var $header=$sections.children().first();var $a=$header.find('a');var $div=$header.next();var info={data:this.options.data,link:$a,content:$div};if($div.hasClass('n2uiActive')){$header.removeClass('ui-state-active ');$header.find('span').removeClass('ui-icon-triangle-1-s').addClass('ui-icon-triangle-1-e');$div.removeClass('n2uiActive');this.options.onBeforeClose(info);$div.hide('blind',{},this.options.time,function(){_this.options.onAfterClose(info);});}else{$header.addClass('ui-state-active ');$header.find('span').removeClass('ui-icon-triangle-1-e').addClass('ui-icon-triangle-1-s');$div.addClass('n2uiActive');this.options.onBeforeOpen(info);$div.show('blind',{},this.options.time,function(){_this.options.onAfterOpen(info);});};}});$n2.blindWidget=function($jq,options){return new BlindWidget($jq.first(),options);};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var defaultErrorFn=function(err){$n2.reportError(err);};var defaultSuccessFn=function(){};var typeClassStringPrefix='n2s_type_';var HTML=':html';var INPUT=':input';var FIELD=':field';var ITERATE=':iterate';var EMPTY=':empty';var CONTEXT=':context';var PARENT=':parent';var SELECT=':selector';var LOCALIZE=':localize';var ARRAY=':array';function getDataFromObjectSelector(o,selectors){if(typeof(selectors)==='string'){selectors=selectors.split('.');}
return findDataFromObject(o,selectors,0);};function findDataFromObject(o,selectors,selectorIndex){if(selectorIndex>=selectors.length){return o;};if(null==o||typeof(o)==='number'||typeof(o)==='string'||typeof(o)==='undefined'||typeof(o)==='function'){return null;};if($n2.isArray(o)){var index=1*selectors[selectorIndex];if(index>=o.length){return null;};return findDataFromObject(o[index],selectors,(selectorIndex+1));}
if(typeof(o)==='object'){var key=selectors[selectorIndex];var value=o[key];if(value===undefined){return null;};return findDataFromObject(value,selectors,(selectorIndex+1));};return null;};function _localizeString(){var args=[];args.push.apply(args,arguments);var options=args.pop();var text=options.fn(this);var splits=text.split(',');var key=splits[0];var opts={};for(var i=1,e=splits.length;i<e;++i){var optStr=splits[i];var optSplit=optStr.split('=');if(optSplit.length>1){var valSplits=optSplit[1].split('+');if(valSplits.length>1){opts[optSplit[0]]=valSplits;}else{opts[optSplit[0]]=[optSplit[1]];};}else{opts[optSplit[0]]=[];};};if('.'===key){var s=this;}else{s=getDataFromObjectSelector(this,key);};if(s&&typeof(s)==='object'&&s.nunaliit_type==='localized'){var lang='en';if($n2.l10n&&$n2.l10n.getLocale){lang=$n2.l10n.getLocale().lang;};if(s[lang]){if(opts.html){return s[lang];};var escaped=$n2.utils.escapeHtml(s[lang]);return escaped;}else{var fbLang='en';if(!s[fbLang]){fbLang=null;for(var l in s){if(l.length>0&&l[0]===':'){}else if(l==='nunaliit_type'){}else if(s[l]){fbLang=l;break;};};};if(fbLang){var result=[];result.push('<span class="n2_localized_string n2_localize_fallback">');result.push('<span class="n2_localize_fallback_lang">(');result.push(fbLang);result.push(')</span>');if(s[fbLang]){if(opts.html){result.push(''+s[fbLang]);}else{var escaped=$n2.utils.escapeHtml(s[fbLang]);result.push(escaped);};};result.push('</span>');return result.join('');}else{return'';};};}else if(typeof(s)==='undefined'){return'';}else if(s===null){return'';}else{if(opts.html){return''+s;};var escaped=$n2.utils.escapeHtml(''+s);return escaped;};};function _formSingleField(r,obj,sels,options){if(options.textarea){r.push('<textarea class="');}else if(options.checkbox){r.push('<input type="checkbox" class="');}else{r.push('<input type="text" class="');};r.push('n2s_input');var selector=obj[SELECT];if(selector){var completeSelector=selector.slice(0);completeSelector.push.apply(completeSelector,sels);var selClass=createClassStringFromSelector(completeSelector);r.push(' '+selClass);};if(options.reference){r.push(' '+typeClassStringPrefix+'reference');}else if(options.date){r.push(' '+typeClassStringPrefix+'date');}else if(options.numeric){r.push(' '+typeClassStringPrefix+'numeric');}else if(options.layers){r.push(' '+typeClassStringPrefix+'layers');}else if(options.localized){r.push(' '+typeClassStringPrefix+'localized');};if(options.textarea){r.push('"></textarea>');}else if(options.checkbox){r.push('"/>');}else{r.push('"/>');};};function _formField(){var args=[];args.push.apply(args,arguments);var options=args.pop();var text=options.fn(this);var obj,sels;var splits=text.split(',');var identifier=splits[0];if('.'===identifier){obj=this;sels=[];}else{sels=identifier.split('.');obj=getDataFromObjectSelector(this,sels);};if(obj&&!obj[SELECT]&&options&&options.data&&options.data.n2_selector){obj[SELECT]=options.data.n2_selector;};var opts={};for(var i=1,e=splits.length;i<e;++i){var optStr=splits[i];var optSplit=optStr.split('=');if(optSplit.length>1){var valSplits=optSplit[1].split('+');if(valSplits.length>1){opts[optSplit[0]]=valSplits;}else{opts[optSplit[0]]=[optSplit[1]];};}else{opts[optSplit[0]]=[];};};var r=[];r.push('<div class="n2s_field_wrapper">');if(obj&&obj.nunaliit_type==='localized'){var langs=[];for(var lang in obj){if(lang==='nunaliit_type'||lang[0]===':'){}else if($.inArray(lang,langs)<0){langs.push(lang);};};if(opts.localized&&opts.localized.length){for(var i=0,e=opts.localized.length;i<e;++i){var lang=opts.localized[i];if($.inArray(lang,langs)<0){langs.push(lang);};};};langs.sort();if(!opts.localized){opts.localized=[];};for(var i=0,e=langs.length;i<e;++i){var lang=langs[i];r.push('<div class="n2s_field_container n2s_field_container_localized">');r.push('<span class="n2_localize_lang">('+lang+')</span>');_formSingleField(r,obj,[lang],opts);r.push('</div>');};}else if(!obj&&opts.localized){var langs=opts.localized.slice();langs.sort();for(var i=0,e=langs.length;i<e;++i){var lang=langs[i];var langSel=sels.slice();langSel.push(lang);r.push('<div class="n2s_field_container n2s_field_container_localized">');r.push('<span class="n2_localize_lang">('+lang+')</span>');_formSingleField(r,this,langSel,opts);r.push('</div>');};}else if(obj&&obj.doc&&opts.reference){var selector=obj[SELECT];var selClass=null;if(selector){selClass=createClassStringFromSelector(selector);};r.push('<span class="n2_briefDisplay ');r.push(typeClassStringPrefix+'reference');r.push('">');r.push(obj.doc);r.push('</span>');r.push('<div class="');if(selClass)r.push(selClass);r.push(' n2schema_referenceDelete');r.push('">');r.push('</div>');}else{r.push('<div class="n2s_field_container">');_formSingleField(r,this,sels,opts);r.push('</div>');};r.push('</div>');return r.join('');};function _inputField(){var args=[];args.push.apply(args,arguments);var options=args.pop();var text=options.fn(this);var splits=text.split(',');var key=splits[0];var completeSelectors=null;if(options&&options.data&&options.data.n2_selector){completeSelectors=options.data.n2_selector.slice(0);}else if(this[SELECT]){completeSelectors=this[SELECT].slice(0);}else{return'';};if('.'===key){}else{var sels=key.split('.');completeSelectors.push.apply(completeSelectors,sels);};var cl='n2s_input '+createClassStringFromSelector(completeSelectors);var type='';if(splits[1]){type=' n2s_type_'+splits[1];};return cl+type;};function _arrayField(){var args=[];args.push.apply(args,arguments);var options=args.pop();var obj=args[0];var newType=null;if(args.length>1){newType=args[1];};var r=[];r.push('<div class="n2s_array">');if(obj&&obj.length){for(var i=0,e=obj.length;i<e;++i){var item=obj[i];var completeSelectors=obj[SELECT].slice(0);completeSelectors.push(i);var cl=createClassStringFromSelector(completeSelectors);r.push('<div class="n2s_array_item">');r.push('<div class="n2s_array_item_delete '+cl+'"></div>');r.push('<div class="n2s_array_item_down '+cl+'"></div>');r.push('<div class="n2s_array_item_wrapper">');r.push(options.fn(item,{data:{n2_selector:completeSelectors}}));r.push('</div></div>');};};if(obj){var arraySelector=obj[SELECT]
var arrayClass=createClassStringFromSelector(arraySelector);r.push('<div class="n2s_array_add '+arrayClass+'"');if(newType){r.push('n2_array_new_type="'+newType+'"');};r.push('></div>');};r.push('</div>');return r.join('');};if(typeof(Handlebars)!=='undefined'&&Handlebars.registerHelper){Handlebars.registerHelper(LOCALIZE,_localizeString);Handlebars.registerHelper(FIELD,_formField);Handlebars.registerHelper(INPUT,_inputField);Handlebars.registerHelper(ARRAY,_arrayField);}else{$n2.log('Unable to register helper functions with Handlebars. Schemas will not work properly.');};var ObjectQueryResults=$n2.Class({objects:null,length:0,initialize:function(obj){if(null===obj){this.objects=[];}else if(typeof(obj)==='undefined'){this.objects=[];}else if($n2.isArray(obj)){this.objects=obj;}else if(typeof(obj)==='object'){this.objects=[obj];}else{this.objects=[];};this.length=this.objects.length;},query:function(selectors){if(null===selectors){var interim=this._selectInterim(null,this.objects);return new ObjectQueryResults(interim);}else if(typeof(selectors)==='string'){var interim=this._selectInterim(selectors,this.objects);return new ObjectQueryResults(interim);}else if(typeof(selectors)==='undefined'){return ObjectQueryResultsEmpty;}else if($n2.isArray(selectors)){var interim=this.objects;for(var i=0,e=selectors.length;i<e;++i){var sel=selectors[i];interim=this._selectInterim(sel,interim);};return new ObjectQueryResults(interim);}else{return ObjectQueryResultsEmpty;}},each:function(f){for(var i=0,e=this.objects.length;i<e;++i){var obj=this.objects[i];f(obj,i);};},_selectInterim:function(sel,arr){var result=[];for(var i=0,e=arr.length;i<e;++i){this._selectFromObject(arr[i],sel,result);};return result;},_selectFromObject:function(obj,sel,result){if(null===sel){for(var key in obj){var value=obj[key];result.push(value);};}else if('string'===typeof(sel)){if(typeof(obj[sel])!=='undefined'){result.push(obj[sel]);};}else if('function'===typeof(sel)){for(var key in obj){if(sel(obj,key)){result.push(obj[key]);};};};}});var ObjectQueryResultsEmpty=new ObjectQueryResults();$n2.ObjectQuery=function(obj,query){var result=new ObjectQueryResults(obj);return result.query(query);}
var SchemaRepositoryFunctions=$n2.Class({onCreateFns:null,initialize:function(){this.onCreateFns=[];},addOnDocumentCreateFunction:function(fn){if(typeof(fn)==='function'){this.onCreateFns.push(fn);};},onDocumentCreate:function(doc,schema){for(var i=0,e=this.onCreateFns.length;i<e;++i){var f=this.onCreateFns[i];f(doc,schema);};}});var SchemaRepository=$n2.Class({schemasByName:null,loadSchemasFn:null,rootSchemasQueried:false,repositoryFunctions:null,initialize:function(){this.schemasByName={};this.repositoryFunctions=new SchemaRepositoryFunctions();},addSchemas:function(opt_){var opt=$n2.extend({schemas:null,onSuccess:defaultSuccessFn,onError:defaultErrorFn},opt_);var schemas=opt.schemas;if(!$n2.isArray(schemas)){schemas=[schemas];};for(var i=0,e=schemas.length;i<e;++i){var schema=schemas[i];if(schema.isSchema){var schemaObj=schema;schemaObj.repositoryFunctions=this.repositoryFunctions;}else{var schemaObj=new Schema(this,schema);};var name=schemaObj.name;this.schemasByName[name]=schemaObj;};this._resolveSchemaDependencies(opt);},getSchema:function(opt_){var _this=this;var opt=$n2.extend({name:null,onSuccess:defaultSuccessFn,onError:defaultErrorFn},opt_);if(this.schemasByName[opt.name]){if(this.schemasByName[opt.name]._error){opt.onError('Schema "'+opt.name+'" not found');}else{opt.onSuccess(this.schemasByName[opt.name]);};return;};if(this.loadSchemasFn){this._loadSchemaDefinitions({names:[opt.name],onSuccess:function(){if(_this.schemasByName[opt.name]._error){opt.onError('Schema "'+opt.name+'" not found');}else{opt.onSuccess(_this.schemasByName[opt.name]);};},onError:opt.onError});return;};opt.onError('Can not find schema named: '+opt.name);},getSchemas:function(opt_){var _this=this;var opt=$n2.extend({names:null,onSuccess:defaultSuccessFn,onError:defaultErrorFn},opt_);var resultSchemas=[];var namesToQuery=null;for(var i=0,e=opt.names.length;i<e;++i){var n=opt.names[i];var s=this.schemasByName[n];if(s&&s._error){}else if(s){resultSchemas[resultSchemas.length]=s;}else{if(null===namesToQuery)namesToQuery=[];namesToQuery[namesToQuery.length]=n;};};if(null===namesToQuery){opt.onSuccess(resultSchemas);return;};if(this.loadSchemasFn){this._loadSchemaDefinitions({names:namesToQuery,onSuccess:function(){for(var i=0,e=namesToQuery.length;i<e;++i){var s=_this.schemasByName[namesToQuery[i]];if(s&&!s._error){resultSchemas[resultSchemas.length]=s;};};opt.onSuccess(resultSchemas);},onError:opt.onError});return;};opt.onError('Can not find requested schemas: '+namesToQuery);},getRootSchemas:function(opt_){var opt=$n2.extend({onSuccess:defaultSuccessFn,onError:defaultErrorFn},opt_);var _this=this;if(!this.rootSchemasQueried&&this.loadSchemasFn){var _this=this;this._loadSchemaDefinitions({rootSchemas:true,onSuccess:function(){_this.rootSchemasQueried=true;_this.getRootSchemas(opt_);},onError:opt.onError});return;};var schemas=[];for(var name in this.schemasByName){var schema=this.schemasByName[name];if(schema._error){}else if(schema.isRootSchema){schemas.push(schema);};};opt.onSuccess(schemas);},reset:function(){this.schemasByName={};this.rootSchemasQueried=false;},getRepositoryFunctions:function(){return this.repositoryFunctions;},_loadSchemaDefinitions:function(opt){var _this=this;var loadingOpt={names:opt.names,onSuccess:loaded,onError:opt.onError};this.loadSchemasFn(loadingOpt);function loaded(schemaDefinitions){if(opt.names){for(var i=0,e=opt.names.length;i<e;++i){var name=opt.names[i];var def=findSchemaDefinition(name,schemaDefinitions);if(!def){schemaDefinitions.push({name:name,isRootSchema:false,display:'',form:'',brief:'',create:{},extensions:[],nunaliit_type:'schema',_error:true});$n2.log('schema definition not found: '+name);};};};_this.addSchemas({schemas:schemaDefinitions,onSuccess:opt.onSuccess,onError:opt.onError});};function findSchemaDefinition(name,definitions){for(var i=0,e=definitions.length;i<e;++i){var def=definitions[i];if(def.name===name){return def;};};return null;};},_resolveSchemaDependencies:function(opt_){var _this=this;var missingSchemas={};var currentSchemas=this.schemasByName;for(var name in this.schemasByName){var schema=this.schemasByName[name];schema._resolveSchemaDependencies(currentSchemas,missingSchemas);};var missingSchemasArr=[];for(var missingSchemaName in missingSchemas){missingSchemasArr.push(missingSchemaName);};if(missingSchemasArr.length<1){opt_.onSuccess();return;};if(missingSchemasArr.length>0&&!this.loadSchemasFn){opt_.onError('Can not find missing dependencies');return;};this._loadSchemaDefinitions({names:missingSchemasArr,onSuccess:opt_.onSuccess,onError:opt_.onError});},_getSchemaMap:function(){return this.schemasByName;}});var SchemaExtension=$n2.Class({selector:null,create:null,schemaName:null,dependentSchema:null,initialize:function(jsonDefinition){this.selector=jsonDefinition.selector;this.schemaName=jsonDefinition.schemaName;this.create=false;if(typeof(jsonDefinition.create)==='boolean'){this.create=jsonDefinition.create;};},createObject:function(obj,defValues){var targetDefValues=defValues;for(var i=0,e=this.selector.length-1;i<e;++i){var keyName=this.selector[i];if(targetDefValues){targetDefValues=targetDefValues[keyName];};};var keyName=this.selector[i];if(targetDefValues){targetDefValues=targetDefValues[keyName];};if(!this.create&&!targetDefValues){return;};var targetObj=obj;for(var i=0,e=this.selector.length-1;i<e;++i){var keyName=this.selector[i];if(targetObj[keyName]){targetObj=targetObj[keyName];}else{targetObj[keyName]={};targetObj=targetObj[keyName];};};var keyName=this.selector[i];targetObj[keyName]=this.dependentSchema.createObject(targetDefValues);},_resolveSchemaDependencies:function(currentSchemas,missingSchemas){if(!this.dependentSchema&&this.schemaName){if(currentSchemas[this.schemaName]){this.dependentSchema=currentSchemas[this.schemaName];}else{missingSchemas[this.schemaName]=1;};}}});var Schema=$n2.Class({isSchema:null,isRootSchema:false,name:null,repositoryFunctions:null,displayTemplate:null,briefTemplate:null,popupTemplate:null,formTemplate:null,relatedSchemaNames:null,extensions:null,extensionsByName:null,cachedDisplay:null,cachedBrief:null,cachedPopup:null,csvExport:null,label:null,options:null,_error:null,initialize:function(repository,jsonDefinition){this.repositoryFunctions=repository.getRepositoryFunctions();this.name=jsonDefinition.name;this.displayTemplate=jsonDefinition.display;this.briefTemplate=jsonDefinition.brief;this.popupTemplate=jsonDefinition.popup;this.formTemplate=jsonDefinition.form;this.create=jsonDefinition.create;this.csvExport=jsonDefinition.csvExport;this.label=jsonDefinition.label;this.options=jsonDefinition.options;if(jsonDefinition.isRootSchema){this.isRootSchema=true;};if(jsonDefinition._error){this._error=true;};this.relatedSchemaNames=jsonDefinition.relatedSchemas;if(!this.relatedSchemaNames){this.relatedSchemaNames=[];};this.extensions=[];this.extensionsByName={};if(jsonDefinition.extensions){if($n2.isArray(jsonDefinition.extensions)){for(var i=0,e=jsonDefinition.extensions.length;i<e;++i){var attr=new SchemaExtension(jsonDefinition.extensions[i]);this.extensions.push(attr);this.extensionsByName[attr.schemaName]=attr;};}else{for(var key in jsonDefinition.extensions){var attr=new SchemaExtension(jsonDefinition.extensions[key]);this.extensions.push(attr);this.extensionsByName[attr.schemaName]=attr;};};};this.isSchema=true;},getLabel:function(){if(this.label){return _loc(this.label);};return this.name;},createObject:function(defValues){var result={};if(this.create){$n2.extend(true,result,this.create);};if(defValues){for(var name in defValues){if(!this.extensionsByName[name]){result[name]=defValues[name];};};};for(var i=0,e=this.extensions.length;i<e;++i){var attr=this.extensions[i];attr.createObject(result,defValues);};this.repositoryFunctions.onDocumentCreate(result,this);return result;},display:function(obj,$elem,ctxt_){if(!this.displayTemplate)return;if(!this.cachedDisplay){this.cachedDisplay=new Display(this,'displayTemplate');};this.cachedDisplay.display(obj,$elem,ctxt_);},brief:function(obj,$elem,ctxt_){if(!this.briefTemplate)return;if(!this.cachedBrief){this.cachedBrief=new Display(this,'briefTemplate');};this.cachedBrief.display(obj,$elem,ctxt_);},popup:function(obj,$elem,ctxt_){if(!this.popupTemplate)return;if(!this.cachedPopup){this.cachedPopup=new Display(this,'popupTemplate');};this.cachedPopup.display(obj,$elem,ctxt_);},form:function(obj,$elem,ctxt_,callback,functionMap){var form=new Form(this);form.form(obj,$elem,ctxt_,callback,functionMap);return form;},_resolveSchemaDependencies:function(currentSchemas,missingSchemas){for(var i=0,e=this.extensions.length;i<e;++i){var attr=this.extensions[i];attr._resolveSchemaDependencies(currentSchemas,missingSchemas);}}});function computeViewObj(origObj,context,parent){if(null===origObj){return origObj;}else if(typeof(origObj)==='undefined'){return null;}else if($n2.isArray(origObj)){var view=[];view[CONTEXT]=context;view[PARENT]=parent;for(var i=0,e=origObj.length;i<e;++i){var value=computeViewObj(origObj[i],context,view);view.push(value);};return view;}else if(typeof(origObj)==='object'){var view={};view[ITERATE]=[];view[CONTEXT]=context;view[PARENT]=parent;for(var key in origObj){if('__n2Source'===key)continue;var value=computeViewObj(origObj[key],context,view);view[key]=value;view[ITERATE].push({key:key,value:value});};view[EMPTY]=(0==view[ITERATE].length);view[ITERATE].sort(function(a,b){if(a.key<b.key){return-1;};if(a.key>b.key){return 1;};return 0;});return view;}else{return origObj};};function DisplaySelectAny(obj,key){if(EMPTY===key||ITERATE===key||CONTEXT===key){return false;};return true;};var DisplayExtension=$n2.Class({schemaExtension:null,subDisplay:null,selector:null,initialize:function(schemaExtension,templateName){this.schemaExtension=schemaExtension;this.templateName=templateName;var subSchema=this.schemaExtension.dependentSchema;this.subDisplay=new Display(subSchema,templateName);this.selector=[];for(var i=0,e=schemaExtension.selector.length;i<e;++i){var sel=schemaExtension.selector[i];if(null===sel){this.selector.push(DisplaySelectAny);}else{this.selector.push(sel);};};},getName:function(){return this.schemaExtension.name;},_setHtml:function(parentObj){var subDisplay=this.subDisplay;$n2.ObjectQuery(parentObj,this.selector).each(function(obj){subDisplay._setHtml(obj);});}});var Display=$n2.Class({schema:null,templateName:null,extensions:null,initialize:function(schema,templateName){this.schema=schema;this.templateName=templateName;if(!this.templateName){this.templateName='displayTemplate';};this.extensions=[];for(var i=0,e=schema.extensions.length;i<e;++i){var attr=new DisplayExtension(schema.extensions[i],this.templateName);this.extensions.push(attr);};},display:function(obj,$elem,ctxt_){var context={root:obj};$n2.extend(context,ctxt_);var view=computeViewObj(obj,context);this._setHtml(view);if(view[HTML]){$elem.html(view[HTML]);}},_setHtml:function(obj){if(null==obj){return;};for(var i=0,e=this.extensions.length;i<e;++i){var attr=this.extensions[i];attr._setHtml(obj);};var compiledTemplate=this.schema[this.templateName+'__compiled'];if(!compiledTemplate){var displayTemplate=this.schema[this.templateName];if(displayTemplate){compiledTemplate=Handlebars.compile(displayTemplate);this.schema[this.templateName+'__compiled']=compiledTemplate;};};if(compiledTemplate){obj[HTML]=compiledTemplate(obj);};}});var selectorClassStringPrefix='n2s_selector';function escapeSelector(sel){var res=[];for(var i=0,e=sel.length;i<e;++i){var c=sel[i];if(c>='a'&&c<='z'){res.push(c);}
else if(c>='A'&&c<='Z'){res.push(c);}
else if(c>='0'&&c<='9'){res.push(c);}
else{var code=c.charCodeAt(0);var o0=(code&0x07)+0x30;var o1=((code>>3)&0x07)+0x30;var o2=((code>>6)&0x07)+0x30;res.push('_');res.push(String.fromCharCode(o2));res.push(String.fromCharCode(o1));res.push(String.fromCharCode(o0));};};return res.join('');};function unescapeSelector(sel){var res=[];for(var i=0,e=sel.length;i<e;++i){var c=sel[i];if(c==='_'){++i;var o2=sel.charCodeAt(i);++i;var o1=sel.charCodeAt(i);++i;var o0=sel.charCodeAt(i);var b=((o2-0x30)<<6)+((o1-0x30)<<3)+(o0-0x30);res.push(String.fromCharCode(b));}else{res.push(c);};};return res.join('');};function createClassStringFromSelector(selector,key){var cs=[selectorClassStringPrefix];for(var i=0,e=selector.length;i<e;++i){cs.push('-');cs.push(escapeSelector(''+selector[i]));};if(key){cs.push('-');cs.push(escapeSelector(key));};return cs.join('');};function createSelectorFromClassString(classString){if(selectorClassStringPrefix===classString.substr(0,selectorClassStringPrefix.length)){var selectorString=classString.substr(selectorClassStringPrefix.length+1);var selector=selectorString.split('-');var res=[];for(var i=0,e=selector.length;i<e;++i){res.push(unescapeSelector(selector[i]));};return res;};return null;};function parseClassNames(classNames){var parsed={};for(var i=0,e=classNames.length;i<e;++i){var className=classNames[i];var selector=createSelectorFromClassString(className);if(selector){parsed.selector=selector;};if(typeClassStringPrefix===className.substr(0,typeClassStringPrefix.length)){var typeString=className.substr(typeClassStringPrefix.length);parsed.type=typeString;};};return parsed;};function computeFormObj(origObj,context,selector,parent){if(null===origObj){return origObj;}else if(typeof(origObj)==='undefined'){return null;}else if($n2.isArray(origObj)){var view=[];view[CONTEXT]=context;view[PARENT]=parent;view[SELECT]=selector.slice(0);for(var i=0,e=origObj.length;i<e;++i){selector.push(i);var value=computeFormObj(origObj[i],context,selector,view);view.push(value);selector.pop();};return view;}else if(typeof(origObj)==='object'){var view={};view[ITERATE]=[];view[CONTEXT]=context;view[PARENT]=parent;view[SELECT]=selector.slice(0);for(var key in origObj){if('__n2Source'===key)continue;selector.push(key);var value=computeFormObj(origObj[key],context,selector,view);view[key]=value;view[ITERATE].push({key:key,value:value});selector.pop();};view[EMPTY]=(0==view[ITERATE].length);view[ITERATE].sort(function(a,b){if(a.key<b.key){return-1;};if(a.key>b.key){return 1;};return 0;});return view;}else{return origObj;};};var FormExtension=$n2.Class({schemaExtension:null,innerForm:null,selector:null,initialize:function(schemaExtension){this.schemaExtension=schemaExtension;var subSchema=this.schemaExtension.dependentSchema;this.innerForm=new Form(subSchema);this.selector=[];for(var i=0,e=schemaExtension.selector.length;i<e;++i){var sel=schemaExtension.selector[i];if(null===sel){this.selector.push(DisplaySelectAny);}else{this.selector.push(sel);};};},getName:function(){return this.schemaExtension.name;},_setHtml:function(parentObj){var innerForm=this.innerForm;$n2.ObjectQuery(parentObj,this.selector).each(function(obj){innerForm._setHtml(obj);});}});var Form=$n2.Class({schema:null,extensions:null,obj:null,elemId:null,context:null,callback:null,initialize:function(schema){this.schema=schema;this.extensions=[];for(var i=0,e=schema.extensions.length;i<e;++i){var attr=new FormExtension(schema.extensions[i]);this.extensions.push(attr);};},form:function(obj,$elem,ctxt_,callback,functionMap){this.obj=obj;this.context=$n2.extend({root:obj},ctxt_);this.callback=callback;if(!this.callback){this.callback=function(obj,selector,value){};};this.functionMap={};if(functionMap){for(var fName in functionMap){this.functionMap[fName]=functionMap[fName];};};var unique=$elem.attr('id');if(typeof(unique)==='undefined'){unique=$n2.getUniqueId();$elem.attr('id',unique);};this.elemId=$elem.attr('id');this.refresh($elem);},refresh:function($elem){if(typeof($elem)==='undefined'){$elem=$('#'+this.elemId);};if($elem.length>0){var view=computeFormObj(this.obj,this.context,[]);this._setHtml(view);var $divEvent=$('<div class="n2s_schemaEditorEvent"></div>');$elem.empty().append($divEvent);if(view[HTML]){$divEvent.html(view[HTML]);var _this=this;$divEvent.find('.n2s_input').each(function(){_this._installHandlers($elem,$(this),_this.obj,_this.callback);});$divEvent.click(function(e){var $clicked=$(e.target);var classString=$clicked.attr('class');var classNames=null;if(classString){classNames=classString.split(' ');}else{classNames=[];};var classInfo=parseClassNames(classNames);if($clicked.hasClass('n2s_array_add')){var newType=$clicked.attr('n2_array_new_type');var ary=getDataFromObjectSelector(_this.obj,classInfo.selector);if(ary){var newItem='';if(newType){try{eval('newItem = '+newType);}catch(e){$n2.log('Error creating a new item: '+e);};};ary.push(newItem);};_this.refresh($elem);_this.callback(_this.obj,classInfo.selector,ary);}else if($clicked.hasClass('n2s_array_item_delete')){var parentSelector=classInfo.selector.slice(0);var itemIndex=1*(parentSelector.pop());var ary=getDataFromObjectSelector(_this.obj,parentSelector);ary.splice(itemIndex,1);_this.refresh($elem);_this.callback(_this.obj,classInfo.selector,ary);}else if($clicked.hasClass('n2s_array_item_down')){var parentSelector=classInfo.selector.slice(0);var itemIndex=1*(parentSelector.pop());if(itemIndex>0){var ary=getDataFromObjectSelector(_this.obj,parentSelector);var removedItems=ary.splice(itemIndex,1);ary.splice(itemIndex-1,0,removedItems[0]);_this.refresh($elem);_this.callback(_this.obj,classInfo.selector,ary);};}else if($clicked.hasClass('n2schema_referenceDelete')){var parentSelector=classInfo.selector.slice(0);var referenceKey=parentSelector.pop();var parentObj=getDataFromObjectSelector(_this.obj,parentSelector);if(parentObj[referenceKey]){delete parentObj[referenceKey];_this.refresh($elem);_this.callback(_this.obj,classInfo.selector,null);};};});};};},_setHtml:function(obj){if(!obj)return;for(var i=0,e=this.extensions.length;i<e;++i){var attr=this.extensions[i];attr._setHtml(obj);};var compiledTemplate=this.schema.formTemplate__compiled;if(!compiledTemplate){var formTemplate=this.schema.formTemplate;if(formTemplate){compiledTemplate=Handlebars.compile(formTemplate);this.schema.formTemplate__compiled=compiledTemplate;};};if(compiledTemplate){obj[HTML]=compiledTemplate(obj);};},_installHandlers:function($elem,$input,obj,callback){var _this=this;var classNames=$input.attr('class').split(' ');var classInfo=parseClassNames(classNames);var selector=classInfo.selector;if(null!=selector){var parentSelector=[];for(var i=0,e=selector.length-1;i<e;++i){parentSelector.push(selector[i]);};var key=selector[i];var handler=this._createChangeHandler(obj,selector,parentSelector,classInfo.type,key,function(obj,selector,value){if('reference'===classInfo.type){_this.refresh($elem);};callback(obj,selector,value);});$input.change(handler);if($n2.schema.GlobalAttributes.disableKeyUpEvents){}else{if('date'!==classInfo.type){$input.keyup(handler);};};var value=getDataFromObjectSelector(obj,selector);var type=$input.attr('type');if('checkbox'===type){if(value){$input.attr('checked',true);}else{$input.attr('checked',false);};}else if('reference'===classInfo.type){if(value){value=value.doc;};$input.val(value);var getDocumentIdFn=this.functionMap['getDocumentId'];if(getDocumentIdFn&&$input.is('input')){$input.focus(function(e,eventParam){if(eventParam&&eventParam.inhibitCallback){return true;};getDocumentIdFn({onSelected:function(docId){var value=getDataFromObjectSelector(obj,selector);if(!value){var p=getDataFromObjectSelector(obj,parentSelector);if(p){value={nunaliit_type:'reference'};p[key]=value;};};if(value){value.doc=docId;$input.val(docId);handler.call($input);};$input.trigger('focus',{inhibitCallback:true});},onReset:function(){$input.trigger('focus',{inhibitCallback:true});}});return true;});};}else if('date'===classInfo.type){if(value){value=value.date;};$input.val(value);$input.attr('n2OriginalDate',value);if($input.datepicker){$input.datepicker({dateFormat:'yy-mm-dd',gotoCurrent:true,changeYear:true,constrainInput:false,onSelect:function(){var $input=$(this);handler.call($input);}});};}else if('numeric'===classInfo.type){$input.val(value);$input.keydown(function(event){var $input=$(this);var val=$input.val();$input.attr('n2Numeric',val);});$input.keyup(function(event){var $input=$(this);var previous=$input.attr('n2Numeric');var val=$input.val();if(''===val||'+'===val||'-'===val){}else if($n2.utils.isNumber(val)){}else if(event.keyCode===46||event.keyCode===8||event.keyCode===9||event.keyCode===27||(event.keyCode===65&&event.ctrlKey)||(event.keyCode>=35&&event.keyCode<=36)||(event.keyCode===37)||(event.keyCode===39)||(event.keyCode>=16&&event.keyCode<=18)){}else{$input.val(previous);}
return true;});}else if('layers'===classInfo.type){if($n2.isArray(value)){value=value.join(',');};$input.val(value);var getLayersFn=this.functionMap['getLayers'];if(getLayersFn&&$input.is('input')){$input.focus(function(e,eventParam){if(eventParam&&eventParam.inhibitCallback){return true;};var layerValue=getDataFromObjectSelector(obj,selector);getLayersFn({currentLayers:layerValue,onSelected:function(layers){var p=getDataFromObjectSelector(obj,parentSelector);if(p){p[key]=layers;if(!layers||layers.length===0){delete p[key];};};if(layers){$input.val(layers.join(','));handler.call($input);};$input.trigger('focus',{inhibitCallback:true});},onReset:function(){$input.trigger('focus',{inhibitCallback:true});}});return true;});};}else{$input.val(value);};};},_createChangeHandler:function(obj,selector,parentSelector,keyType,key,callback){return function(e){var $input=$(this);var parentObj=getDataFromObjectSelector(obj,parentSelector);var effectiveKey=key;var effectiveSelector=selector;if(!parentObj){if('localized'===keyType){var gpSel=parentSelector.slice();var parentKey=gpSel.pop();var gpObj=getDataFromObjectSelector(obj,gpSel);if(gpObj){parentObj={'nunaliit_type':'localized'};gpObj[parentKey]=parentObj;};};};if(null!=parentObj){var assignValue=true;var type=$input.attr('type');if('checkbox'===type){if($input.is(':checked')){var value=true;}else{value=false;};}else if('reference'===keyType){value=$input.val();if(null===value||value===''){assignValue=false;if(parentObj[effectiveKey]){delete parentObj[effectiveKey];};}else{if(!parentObj[effectiveKey]){parentObj[effectiveKey]={nunaliit_type:'reference'};}else{parentObj[effectiveKey].nunaliit_type='reference';};parentObj=parentObj[effectiveKey];effectiveKey='doc';};}else if('date'===keyType){assignValue=false;var dateStr=$input.val();if(!dateStr){if(parentObj[effectiveKey]){delete parentObj[effectiveKey];};}else{var trimmedDateStr=$n2.trim(dateStr);if(''===trimmedDateStr){if(parentObj[effectiveKey]){delete parentObj[effectiveKey];};}else{var dateInt=null;try{dateInt=$n2.date.parseUserDate(dateStr);}catch(e){var msg=_loc('Invalid date: {err}',{err:e});$n2.log(msg);alert(msg);var original=$input.attr('n2OriginalDate');$input.val(original);};if(dateInt){parentObj[effectiveKey]=dateInt.getDocumentStructure();};};};value=parentObj[effectiveKey];}else if('numeric'===keyType){value=$input.val();if(false==$n2.utils.isNumber(value)){assignValue=false;}else{value=1*value;};}else if('layers'===keyType){value=$input.val();if(null===value||value===''){assignValue=false;if(parentObj[effectiveKey]){delete parentObj[effectiveKey];};}else{value=value.split(',');for(var i=0,e=value.length;i<e;++i){value[i]=$n2.trim(value[i]);};};}else{value=$input.val();};if(assignValue){parentObj[effectiveKey]=value;};callback(obj,effectiveSelector,value);};};}});$n2.schema={Schema:Schema,SchemaRepository:SchemaRepository,Display:Display,Form:Form,GlobalAttributes:{disableKeyUpEvents:false}};})(jQuery,nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var Dispatcher=$n2.Class({options:null,listeners:null,handles:null,dispatching:null,queue:null,initialize:function(options_){this.options=$n2.extend({logging:false,loggingIncludesMessage:false},options_);this.listeners={};this.handles={};this.dispatching=false;this.queue=[];},getHandle:function(name){var h=this.handles[name];if(!h){h={dispatch:true,name:name,receives:{},sends:{}};this.handles[name]=h;};return h;},register:function(handle,type,l){if(typeof(handle)==='string'){handle=this.getHandle(handle);};if(!this.listeners[type]){this.listeners[type]=[];};var address={type:type,id:$n2.getUniqueId()};this.listeners[type].push({handle:handle,fn:l,address:address});handle.receives[type]=true;return address;},deregister:function(address){if(address){var type=address.type;var id=address.id;if(type&&id){var list=this.listeners[type];if(list){var index=-1;for(var i=0,e=list.length;i<e;++i){var l=list[i];if(l.address&&l.address.id===id){index=i;break;};};if(index>=0){this.listeners[type].splice(index,1);};};};};},isEventTypeRegistered:function(type){var listeners=this.listeners[type];if(listeners&&listeners.length>0){return true;};return false;},send:function(handle,m){if(typeof(handle)==='string'){handle=this.getHandle(handle);};if(this.dispatching){this.queue.push({h:handle,m:m});}else{this._sendImmediate(handle,m);while(this.queue.length>0){var i=this.queue.splice(0,1)[0];this._sendImmediate(i.h,i.m);};};},_sendImmediate:function(h,m){var logging=this.options.logging;var loggingIncludesMessage=this.options.loggingIncludesMessage;var t=m.type;h.sends[t]=true;this.dispatching=true;var listeners=this.listeners[t];if(listeners){for(var i=0,e=listeners.length;i<e;++i){var l=listeners[i];if(logging){if(loggingIncludesMessage){$n2.log(''+h.name+' >'+t+'> '+l.handle.name,m);}else{$n2.log(''+h.name+' >'+t+'> '+l.handle.name);};};try{l.fn(m,l.address,this);}catch(e){$n2.log('Error while dispatching: '+e);if(e.stack){$n2.log('Stack',e.stack);};};};}else if(typeof listeners==='undefined'){listeners=[];this.listeners[t]=listeners;};if(!listeners||listeners.length<1){if(logging){if(loggingIncludesMessage){$n2.log(''+h.name+' >'+t+' not observed',m);}else{$n2.log(''+h.name+' >'+t+' not observed');};};};this.dispatching=false;},synchronousCall:function(handle,m){if(typeof(handle)==='string'){handle=this.getHandle(handle);};var previous=this.dispatching;this._sendImmediate(handle,m);this.dispatching=previous;if(!previous){while(this.queue.length>0){var i=this.queue.splice(0,1)[0];this._sendImmediate(i.h,i.m);};};}});$n2.dispatch={Dispatcher:Dispatcher};})(nunaliit2);;(function($n2){var CustomService=$n2.Class({custom:null,initialize:function(options_){if(typeof(window.nunaliit_custom)==='undefined'){window.nunaliit_custom={};};this.custom=window.nunaliit_custom;this._check();},setOption:function(optionName,optionValue){this._check();this.custom.options[optionName]=optionValue;if(!this.custom.info[optionName]){this.custom.info[optionName]={reads:0,writes:1};}else{++this.custom.info[optionName].writes;};},getOption:function(optionName,defaultValue){this._check();if(!this.custom.info[optionName]){this.custom.info[optionName]={reads:1,writes:0};}else{++this.custom.info[optionName].writes;};if(typeof(this.custom.options[optionName])==='undefined'){return defaultValue;};return this.custom.options[optionName];},updateOption:function(optionsMap,optionName){this._check();if(typeof(this.custom.options[optionName])!=='undefined'){optionsMap[optionName]=this.custom.options[optionName];};},_check:function(){if(!this.custom.options)this.custom.options={};if(!this.custom.info)this.custom.info={};}});$n2.custom={CustomService:CustomService};})(nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var TYPE_SELECTED='x';var TYPE_MULTI_SELECTED='m';var TYPE_SEARCH='s';var Monitor=$n2.Class({options:null,initialize:function(opts_){this.options=$n2.extend({directory:null},opts_);var _this=this;if(window&&'onhashchange'in window){$(window).bind('hashchange',function(e){_this._hashChange(e);});};var d=this._getDispatcher();if(d){var f=function(m){_this._handle(m);};var h=d.getHandle('n2.history');d.register(h,'historyBack',f)
d.register(h,'historyForward',f)
d.register(h,'setHash',f)
d.register(h,'replaceHash',f)};},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;},_dispatch:function(m){var d=this._getDispatcher();if(d){var h=d.getHandle('n2.history');d.send(h,m);};},_hashChange:function(e){var hash=window.location.hash;if(hash){hash=hash.substr(1);};var m={type:'hashChanged',hash:hash};this._dispatch(m);},_handle:function(m){if('historyBack'===m.type){if(window.history.back){window.history.back();};}else if('historyForward'===m.type){if(window.history.forward){window.history.forward();};}else if('setHash'===m.type){var hash=m.hash;if(window.history.pushState){if(hash){window.history.pushState({},'','#'+hash);}else{window.history.pushState({},'','#');};}else{if(hash){window.location='#'+hash;}else{window.location='#';};};}else if('replaceHash'===m.type){var hash=m.hash;if(window.history.replaceState){if(hash){window.history.replaceState({},'','#'+hash);}else{window.history.replaceState({},'','#');};}else{if(hash){window.location='#'+hash;}else{window.location='#';};};};}});var Tracker=$n2.Class({options:null,last:null,initialize:function(opts_){this.options=$n2.extend({directory:null,disabled:false},opts_);var _this=this;this.last={};var d=this._getDispatcher();if(d){var f=function(m){_this._handle(m);};var h=d.getHandle('n2.history.Tracker');d.register(h,'start',f);d.register(h,'hashChanged',f);d.register(h,'userSelect',f);d.register(h,'unselected',f);d.register(h,'documentDeleted',f);d.register(h,'searchInitiate',f);d.register(h,'editInitiate',f);d.register(h,'editClosed',f);};},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;},_dispatch:function(m){var d=this._getDispatcher();if(d){var h=d.getHandle('n2.history.Tracker');d.send(h,m);};},_handle:function(m){if(this.options.disabled){return;};if('start'===m.type){var hash=window.location.hash;if(hash&&hash!==''){hash=hash.substr(1);this._dispatch({type:'hashChanged',hash:hash});};}else if('userSelect'===m.type){if(m.docId){this.last={selected:m.docId};if(!m._suppressHashChange){var type='setHash';if(m._replaceHash)type='replaceHash';var j=JSON.stringify({t:TYPE_SELECTED,i:m.docId});var u=$n2.Base64.encode(j);this._dispatch({type:type,hash:u});};}else if(m.docIds){this.last={multi_selected:m.docIds};if(!m._suppressHashChange){var type='setHash';if(m._replaceHash)type='replaceHash';var ts=(new Date()).getTime();saveStorageInfo(ts,{docIds:m.docIds});var j=JSON.stringify({t:TYPE_MULTI_SELECTED,s:ts});var u=$n2.Base64.encode(j);this._dispatch({type:type,hash:u});};};}else if('unselected'===m.type){this.last={unselected:true};if(!m._suppressHashChange){this._dispatch({type:'setHash',hash:null});};}else if('documentDeleted'===m.type){var deletedDocId=m.docId;if(this.last.selected===deletedDocId){this.last={deleted:deletedDocId};this._dispatch({type:'historyBack'});};}else if('searchInitiate'===m.type){this.last={search:m.searchLine};if(!m._suppressHashChange){var j=JSON.stringify({t:TYPE_SEARCH,l:m.searchLine});var u=$n2.Base64.encode(j);this._dispatch({type:'setHash',hash:u});};}else if('editInitiate'===m.type){this.last={edit:true};this._dispatch({type:'setHash',hash:'nostate'});}else if('editClosed'===m.type){var lastIsEditInitiate=false;if(this.last.edit){lastIsEditInitiate=true;};this.last={editClosed:true};if(m.inserted){this._dispatch({type:'userSelect',docId:m.doc._id,_replaceHash:true});}else if(m.saved){if(lastIsEditInitiate){this._dispatch({type:'historyBack'});};}else{if(lastIsEditInitiate){this._dispatch({type:'historyBack'});};};}else if('hashChanged'===m.type){var o=null;if('nostate'===m.hash){}else if(this.last.edit){if(confirm(_loc('Do you wish to leave document editor?'))){this.last={editClosed:true};this._dispatch({type:'editCancel'});this._reloadHash(m.hash);}else{this._dispatch({type:'historyForward'});};}else if(''===m.hash||!m.hash){if(!this.last.unselected){this._dispatch({type:'unselected',_suppressHashChange:true});};}else{this._reloadHash(m.hash);};};},_reloadHash:function(hash){var o=null;try{var d=$n2.Base64.decode(hash);o=JSON.parse(d);}catch(s){};if(o){if(TYPE_SELECTED===o.t){var docId=o.i;if(docId!==this.last.selected){this._dispatch({type:'userSelect',docId:docId,_suppressHashChange:true});};}else if(TYPE_MULTI_SELECTED===o.t){var timestamp=o.s;var info=getStorageInfo(timestamp);var docIds=info.docIds;if(!docIds){docIds=[];};this._dispatch({type:'userSelect',docIds:docIds,_suppressHashChange:true});}else if(TYPE_SEARCH===o.t){var searchLine=o.l;this._dispatch({type:'searchInitiate',searchLine:searchLine,_suppressHashChange:true});};};}});function getStorageInfo(timestamp){var storage=$n2.storage.getSessionStorage();var value=storage.getItem('n2_history');if(!value){return{};};var raw=null;try{raw=JSON.parse(value);}catch(e){raw={};};if(!raw){raw={};};var info=raw[''+timestamp];if(!info){return{};};return info;};function saveStorageInfo(timestamp,info){var storage=$n2.storage.getSessionStorage();var value=storage.getItem('n2_history');var raw=null;try{raw=JSON.parse(value);}catch(e){raw={};};if(!raw){raw={};};raw[''+timestamp]=info;var newValue=JSON.stringify(raw);while(newValue.length>2000000){_removeOldestEntry(raw);newValue=JSON.stringify(raw);};storage.setItem('n2_history',newValue);return value;};function _removeOldestEntry(raw){var oldestKey=null;for(var key in raw){if(!oldestKey){oldestKey=key;}else if(key<oldestKey){oldestKey=key;};};if(oldestKey){delete raw[oldestKey];};};$n2.history={Monitor:Monitor,Tracker:Tracker};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var treeUuid=1;function findTreeRoot($elem){if(!$elem.jquery){$elem=$(elem);};if($elem.length>1){$elem=$(elem).first();};if($elem.hasClass('tree')){return $elem;};var parent=$elem.parent();if(parent.length>0){return findTreeRoot(parent);}
return null;};function getTreeUuid(elem){var $tree=findTreeRoot(elem);if(!$tree){return-1;}
return $tree[0]['treeUuid'];};function getTreeId(elem){var $tree=findTreeRoot(elem);if(!$tree){$n2.log('tree getTreeId(): can not find tree root');return null;}
return $tree.attr('id');};function findLiFromElement(elem){if(!elem.jquery){elem=$(elem);};if(elem.length<1){return null;};if(elem[0].nodeName.toLowerCase()==='li'){return elem;};return findLiFromElement(elem.parent());}
function toggleHideChildren($li){var isHidden=$li.hasClass('treeHideChildren');if(isHidden){$li.removeClass('treeHideChildren');$li.addClass('treeShowChildren');}else{$li.addClass('treeHideChildren');$li.removeClass('treeShowChildren');};};function liOpenClose(){var $li=findLiFromElement(this);toggleHideChildren($li);};function keyClicked(span,opt){var $li=findLiFromElement(span);var toggle=opt.onKeyClick($li);if(toggle){toggleHideChildren($li);};};var treeDefaultOptions={allClosed:true,onKeyClick:function($li){return true;}};function tree_init($tree,opt){$tree.each(function(){var uuid=this['treeUuid'];if(!uuid){uuid=treeUuid;++treeUuid;this['treeUuid']=uuid;};var $this=$(this);var id=$this.attr('id');if(!id||typeof(id)==='undefined'){id='tree_'+uuid;$this.attr('id',id);};});tree_refresh($tree,opt);};function tree_refresh($tree,opt){$tree.find('li').each(function(j,li){var $li=$(li);if(false==$li.hasClass('treeEditAdd')){var divSymbol=$li.children('div.treeExpand');if(divSymbol.length<1){divSymbol=$('<div class="treeExpand"></div>');$li.prepend(divSymbol);};if(false==divSymbol.hasClass('treeClickInstalled')){divSymbol.click(liOpenClose);divSymbol.addClass('treeClickInstalled');};var firstSpan=$li.children('span').first();if(false==firstSpan.hasClass('treeKey')){firstSpan.addClass('treeKey');};if(false==firstSpan.hasClass('treeClickInstalled')){firstSpan.click(function(){keyClicked(this,opt);});firstSpan.addClass('treeClickInstalled');};$li.children('ul').addClass('treeChildren');if($li.children('.treeChildren').length>0){$li.removeClass('treeNoChildren');}else{$li.addClass('treeNoChildren');};if(false==$li.hasClass('treeHideChildren')&&false==$li.hasClass('treeShowChildren')){if(opt.allClosed){$li.addClass('treeHideChildren');}else{$li.addClass('treeShowChildren');};};};});};var Tree=$n2.Class({treeId:null,options:null,initialize:function($tree,opt_){this.options=$.extend({},treeDefaultOptions,opt_);tree_init($tree,this.options);this.treeId=getTreeId($tree);},getRoot:function(){var $tree=$('#'+this.treeId);if($tree.length!=1){$n2.log('Tree.getRoot(): id not found: '+this.treeId);return null;};return $tree;},getId:function(){return this.treeId;},refresh:function(){var $tree=this.getRoot();if($tree){tree_refresh($tree,this.options);};}});function computeSelectors($li){if($li.length!=1)return null;var selectors=[];if(false==innerCompute($li,selectors)){return null;};return selectors;function innerCompute($li,selectors){var $ul=$li.parent();if($ul.length>0&&false==$ul.hasClass('tree')){var $parentLi=$ul.parent();if(false==innerCompute($parentLi,selectors)){return false;};};var liElem=$li[0];if(typeof(liElem['treeArrayIndex'])!=='undefined'){selectors.push(1*liElem['treeArrayIndex']);return true;}else if(typeof(liElem['treeObjectKey'])!=='undefined'){selectors.push(liElem['treeObjectKey']);return true;}else{return false;};};};function stringToHtmlId(s){if(typeof(s)==='string'){var res=[];for(var i=0,e=s.length;i<e;++i){var c=s[i];if(c>='a'&&c<='z'){res.push(c);}
else if(c>='A'&&c<='Z'){res.push(c);}
else if(c>='0'&&c<='9'){res.push(c);}
else{var code=c.charCodeAt(0);var o0=(code&0x07)+0x30;var o1=((code>>3)&0x07)+0x30;var o2=((code>>6)&0x07)+0x30;res.push('_');res.push(String.fromCharCode(o2));res.push(String.fromCharCode(o1));res.push(String.fromCharCode(o0));};};return res.join('');}else if(typeof(s)==='number'){return''+s;}else{return'';};};function computeId(uuid,selectors){var escapedSelectors=[];for(var i=0,e=selectors.length;i<e;++i){escapedSelectors.push(stringToHtmlId(selectors[i]));};var id='tree'+uuid+'_'+escapedSelectors.join('_');return id;};function computeClass(selectors){var escapedSelectors=[];for(var i=0,e=selectors.length;i<e;++i){escapedSelectors.push(stringToHtmlId(selectors[i]));};var cName='tree_sel_'+escapedSelectors.join('_');return cName;};function fixIds($allLis){var uuid=null;$allLis.each(function(){var $li=$(this);var selectors=computeSelectors($li);if(!uuid){uuid=getTreeUuid($li);};var id=computeId(uuid,selectors);$li.attr('id',id);});}
function findLiFromSelectors($tree,selectors){var uuid=getTreeUuid($tree);var id=computeId(uuid,selectors);var $li=$tree.find('#'+id);return $li;}
function findDataFromObject(o,selectors){if(null===selectors||0===selectors.length){return o;};if(null==o||typeof(o)==='number'||typeof(o)==='string'||typeof(o)==='undefined'||typeof(o)==='function'){return null;};if($n2.isArray(o)){var index=1*selectors[0];if(index>=o.length){return null;};if(selectors.length<2){return o[index];};return findDataFromObject(o[index],selectors.slice(1));}
if(typeof(o)==='object'){var key=selectors[0];var value=o[key];if(value===undefined){return null;};if(selectors.length<2){return value;};return findDataFromObject(value,selectors.slice(1));};return null;};function setObjectData(o,selectors,data){if(null===selectors||0===selectors.length){return false;};if($n2.isArray(o)){var index=1*selectors[0];if(index>=o.length){return false;};if(selectors.length>1){return setObjectData(o[index],selectors.slice(1),data);};o[index]=data;return true;}
if(typeof(o)==='object'){var key=selectors[0];if(selectors.length==1){o[key]=data;return true;}
var value=o[key];if(value===undefined){return false;};return setObjectData(value,selectors.slice(1),data);};return false;};function deleteObjectData(o,selectors){if(null===selectors||0===selectors.length){return false;};if(o===null){return false;};if($n2.isArray(o)){var index=1*selectors[0];if(index>=o.length){return false;};if(selectors.length>1){return deleteObjectData(o[index],selectors.slice(1));};o.splice(index,1);return true;}
if(typeof(o)==='object'){var key=selectors[0];var value=o[key];if(value===undefined){return false;};if(selectors.length>1){return deleteObjectData(value,selectors.slice(1));};delete o[key];return true;};return false;};function print(data,maxLen){var arr=[];innerPrint(data,arr,0,maxLen);return arr.join('');function innerPrint(data,arr,len,max){if(data===null){var value='null';arr.push(value);return value.length;}else if(typeof(data)==='number'){var value=''+data;arr.push(value);return value.length;}else if(typeof(data)==='string'){var value='"'+data+'"';arr.push(value);return value.length;}else if(typeof(data)==='boolean'){var value=''+data;arr.push(value);return value.length;}else if($n2.isArray(data)){var myLen=1;arr.push('[');for(var i=0,e=data.length;i<e;++i){if(0!=i){arr.push(',');++myLen;};var obj=data[i];var innerLen=innerPrint(obj,arr,len+myLen,max);myLen+=innerLen;if(myLen+len>=maxLen)return myLen;}
arr.push(']');++myLen;return myLen;}else if(typeof(data)==='object'){var myLen=1;arr.push('{');var keys=[];for(var key in data){keys.push(key);}
keys.sort();for(var i=0,e=keys.length;i<e;++i){if(0!=i){arr.push(',');++myLen;};var key=keys[i];arr.push(key);arr.push(':');myLen+=key.length+1;var obj=data[key];var innerLen=innerPrint(obj,arr,len+myLen,max);myLen+=innerLen;if(myLen+len>=maxLen)return myLen;}
arr.push('}');++myLen;return myLen;}
return 0;}}
function createDisplayFromData(data,opt){var result={truncated:false};var frags=[];if(opt.valueSeparator){frags.push(opt.valueSeparator);};var maxLen=opt.valueMaxLen-opt.valueEllipsis.length;var value=print(data,maxLen);if(value.length>maxLen){value=value.substr(0,maxLen)+opt.valueEllipsis;result.truncated=true;};frags.push(value);result.str=frags.join('');return result;};function refreshUlFromObject(o,selectors,$ul,opt,ancestors){var uuid=getTreeUuid($ul);$ul.children('li').each(function(i,elem){if($(this).hasClass('treeEditAdd')){}else{var key=this['treeObjectKey'];if(null==key){$(this).remove();}else if(typeof(o[key])==='undefined'){$(this).remove();};};});var keys=[];for(var key in o){keys.push(key);};keys.sort();for(var i=0,e=keys.length;i<e;++i){var key=keys[i];var value=o[key];if(ancestors.indexOf(value)>=0){}else{selectors.push(key);ancestors.push(value);var id=computeId(uuid,selectors);var cName=computeClass(selectors);var $li=$ul.children('#'+id);if($li.length<1){$li=$('<li>').attr('id',id).addClass('tree_sel '+cName);$('<span>').addClass('treeKey').text(key).appendTo($li);$li[0]['treeObjectKey']=key;$ul.append($li);};refreshLiFromData(value,selectors,$li,opt,ancestors);ancestors.pop();selectors.pop();};};};function refreshUlFromArray(arr,selectors,$ul,opt,ancestors){var uuid=getTreeUuid($ul);$ul.children('li').each(function(i,elem){if($(this).hasClass('treeEditAdd')){}else{var index=this['treeArrayIndex'];if(typeof(index)!='number'){$(this).remove();}else if(index>=arr.length||index<0){$(this).remove();};};});for(var key=0,e=arr.length;key<e;++key){var value=arr[key];if(ancestors.indexOf(value)>=0){}else{selectors.push(key);ancestors.push(value);var id=computeId(uuid,selectors);var cName=computeClass(selectors);var $li=$ul.children('#'+id);if($li.length<1){$li=$('<li>').attr('id',id).addClass('tree_sel '+cName);$('<span>').addClass('treeKey').text(key).appendTo($li);$li[0]['treeArrayIndex']=key;$ul.append($li);};refreshLiFromData(value,selectors,$li,opt,ancestors);ancestors.pop();selectors.pop();};};};function refreshLiFromData(data,selectors,$li,opt,ancestors){var disp=null;if(opt.valueDisplayFn){disp=opt.valueDisplayFn(data,opt);};var $valueSpan=$li.children('span.treeValue');if(disp){if($valueSpan.length>0){$valueSpan.text(disp.str);}else{$valueSpan=$('<span class="treeValue"></span>');$valueSpan.text(disp.str);var $keySpan=$li.children('.treeKey');$valueSpan.insertAfter($keySpan);};}else{$valueSpan.remove();};if(data===null){var $childrenElem=$li.children('.treeChildren');$childrenElem.remove();}else if(typeof(data)==='string'){$li.children('.treeChildren').remove();if(disp){if(disp.truncated){var ul=$('<div class="treeChildren"></div>');ul.text(data);$li.append(ul);};};}else if(typeof(data)==='number'||typeof(data)==='boolean'){$li.children('.treeChildren').remove();if(disp){if(disp.truncated){var ul=$('<div class="treeChildren">'+data+'</div>');$li.append(ul);};};}else if($n2.isArray(data)){var $ul=$li.children('.treeChildren');if($ul.length>0){if($ul[0].nodeName.toLowerCase()!=='ul'){$ul.remove();$ul=null;};};if(!$ul||$ul.length<1){$ul=$('<ul class="treeChildren"></ul>');$li.append($ul);};refreshUlFromArray(data,selectors,$ul,opt,ancestors);}else if(typeof(data)==='object'){var $ul=$li.children('.treeChildren');if($ul.length>0){if($ul[0].nodeName.toLowerCase()!=='ul'){$ul.remove();$ul=null;};};if(!$ul||$ul.length<1){$ul=$('<ul class="treeChildren"></ul>');$li.append($ul);};refreshUlFromObject(data,selectors,$ul,opt,ancestors);}else{$li.children('.treeChildren').remove();};};var createFromObjDefaultOptions={valueDisplayFn:createDisplayFromData,valueSeparator:' : ',valueEllipsis:'...',valueMaxLen:30};function createTreeFromObject($treeContainer,o,opt){$treeContainer.empty();var $tree=$('<ul class="tree"></ul>').appendTo($treeContainer);tree_init($tree,opt);var selectors=[];refreshUlFromObject(o,selectors,$tree,opt,[]);tree_refresh($tree,opt);return $tree;};function refreshTreeFromObject($tree,o,opt){var selectors=[];refreshUlFromObject(o,selectors,$tree,opt,[]);tree_refresh($tree,opt);return $tree;};var ObjectTree=$n2.Class({treeId:null,options:null,obj:null,initialize:function($treeContainer,obj,opt_){this.options=$.extend({},treeDefaultOptions,createFromObjDefaultOptions,opt_);this.obj=obj;if(this.obj){var $tree=createTreeFromObject($treeContainer,this.obj,this.options);this.treeId=getTreeId($tree);}else{this.treeId=$treeContainer.find('ul.tree').attr('id');};},getRoot:function(){var $tree=$('#'+this.treeId);if($tree.length!=1){$n2.log('ObjectTree.getRoot(): id not found: '+this.treeId);return null;};return $tree;},getId:function(){return this.treeId;},getObject:function(){return this.obj;},refresh:function(){var $tree=this.getRoot();if($tree){refreshTreeFromObject($tree,this.obj,this.options);};},findLiFromSelectors:function(selectors){var $tree=this.getRoot();if($tree){return findLiFromSelectors($tree,selectors);}else{return null;};}});function defaultCreateNewKey(cbAddKeyToObject,obj,selectors,data){var index=0;var key='newkey_'+index;while(data[key]!==undefined){++index;key='newkey_'+index;if(index>100)return;};cbAddKeyToObject(selectors,key,null);}
function defaultGetDeleteConfirmation(cbDeleteKey,obj,selectors){if(confirm(_loc('Do you wish to delete this element?'))){cbDeleteKey();};}
function defaultGetAbortConfirmation(actionFn){if(confirm(_loc('This object is being modified. Do you wish to continue and revert current changes?'))){actionFn();};}
var createEditorDefaultOptions={onObjectChanged:function(obj){},beforeValueChanged:function(obj,selectors,data){},afterValueChanged:function(obj,selectors,data){},beforeKeyChanged:function(obj,selectors,fromKey,toKey){},afterKeyChanged:function(obj,selectors,fromKey,toKey){},beforeKeyAdded:function(obj,selectors,key){},afterKeyAdded:function(obj,selectors,key){},beforeKeyDeleted:function(obj,selectors){},afterKeyDeleted:function(obj,selectors){},beforeIndexSwap:function(obj,selectors,index){},afterIndexSwap:function(obj,selectors,index){},createNewKey:defaultCreateNewKey,getDeleteConfirmation:defaultGetDeleteConfirmation,getAbortConfirmation:defaultGetAbortConfirmation,isKeyEditingAllowed:function(obj,selectors,data){return true;},isValueEditingAllowed:function(obj,selectors,data){return true;},isKeyDeletionAllowed:function(obj,selectors,data){return true;}};var ObjectTreeEditor=$n2.Class({$tree:null,obj:null,options:null,initialize:function($tree,obj,opt_){if(!$tree){$n2.log('ObjectTreeEditor.initialize(): null tree');};if($tree.getRoot){$tree=$tree.getRoot();if(!$tree){$n2.log('ObjectTreeEditor.initialize(): null root');};};this.options=$.extend({},treeDefaultOptions,createFromObjDefaultOptions,createEditorDefaultOptions,opt_);this.$tree=$tree;this.obj=obj;this._installEditors();},destroy:function(){this._removeEditors();this.$tree=null;this.obj=null;this.options=null;},getRoot:function(){return this.$tree;},getId:function(){return getTreeId(this.$tree);},getObject:function(){return this.obj;},refresh:function(selectors){if(null==selectors||selectors.length<1){refreshUlFromObject(this.obj,[],this.$tree,this.options,[]);}else{var data=findDataFromObject(this.obj,selectors);var $li=findLiFromSelectors(this.$tree,selectors);refreshLiFromData(data,selectors,$li,this.options,[]);};this._installEditors();tree_refresh(this.$tree,this.options);},isEditing:function(){if(this.$tree.find('.treeEditingValue').length>0){return true;};if(this.$tree.find('.treeEditingKey').length>0){return true;};return false;},cancelEditing:function(){this.$tree.find('.treeEditingValue').removeClass('treeEditingValue');this.$tree.find('.treeEditingKey').removeClass('treeEditingKey');this.$tree.find('.treeValueEditor').remove();this.$tree.find('.treeKeyEditor').remove();},_installEditors:function(){var editor=this;var $allLiElems=this.$tree.find('li');$allLiElems.each(function(i,liElem){var $li=$(this);if(false==$li.hasClass('treeEditAdd')){var selectors=computeSelectors($li);var data=findDataFromObject(editor.obj,selectors);var isKeyEditingPermitted=editor.options.isKeyEditingAllowed(editor.obj,selectors,data);var isValueEditingPermitted=editor.options.isValueEditingAllowed(editor.obj,selectors,data);var isKeyDeletionPermitted=editor.options.isKeyDeletionAllowed(editor.obj,selectors,data);var $divChild=$li.children('div.treeChildren');if($divChild.length>0&&isValueEditingPermitted&&false==$divChild.hasClass('treeEditorClickInstalled')){$divChild.click(function(){editor._initiateValueEdit(this);});$divChild.addClass('treeEditorClickInstalled');};if(liElem['treeObjectKey']){var $key=$li.children('span.treeKey');if($key.length>0&&isKeyEditingPermitted&&false==$key.hasClass('treeEditorClickInstalled')){$key.unbind('click');$key.click(function(){editor._initiateKeyEdit(this);});$key.addClass('treeEditorClickInstalled');};};var $value=$li.children('span.treeValue');if($value.length>0&&isValueEditingPermitted&&false==$value.hasClass('treeEditorClickInstalled')){$value.click(function(){editor._initiateValueEdit(this);});$value.addClass('treeEditorClickInstalled');};var $delBtn=$li.children('.treeEditDelete');if($delBtn.length<1&&isKeyDeletionPermitted){$delBtn=$('<div class="treeEditDelete treeEditorClickInstalled"></div>');$value.after($delBtn);$delBtn.click(function(){editor._initiateDeleteKey(this);});};if(typeof(liElem['treeArrayIndex'])==='number'){var $dnBtn=$li.children('.treeEditDown');if($dnBtn.length<1){$dnBtn=$('<div class="treeEditDown treeEditorClickInstalled"></div>');$value.after($dnBtn);$dnBtn.click(function(){editor._initiateSwapKeys(this,1);});};var $upBtn=$li.children('.treeEditUp');if($upBtn.length<1){$upBtn=$('<div class="treeEditUp treeEditorClickInstalled"></div>');$value.after($upBtn);$upBtn.click(function(){editor._initiateSwapKeys(this,-1);});};};};});this.$tree.each(installAddButton);this.$tree.find('ul').each(installAddButton);function installAddButton(){var $ul=$(this);var $li=$ul.children('li.treeEditAdd');$li.remove();$li=$('<li class="treeEditAdd"></li>');var $addBtn=$('<div><div/>');$addBtn.click(function(){editor._initiateAddKey(this);});$li.append($addBtn);$ul.append($li);};},_removeEditors:function(){this.cancelEditing();this.$tree.find('li.treeEditAdd').remove();this.$tree.find('.treeEditorClickInstalled').unbind('click').removeClass('treeEditorClickInstalled').removeClass('treeClickInstalled');this.$tree.find('.treeEditDelete').remove();this.$tree.find('.treeEditUp').remove();this.$tree.find('.treeEditDown').remove();tree_refresh(this.$tree,this.options);},_continueWithEditing:function(actionFn){if(false==this.isEditing()){actionFn();}else{var editor=this;this.options.getAbortConfirmation(function(){editor.cancelEditing();actionFn();});};},_initiateValueEdit:function(spanValueElem){var editor=this;this._continueWithEditing(function(){editor._startValueEdit(spanValueElem);});},_startValueEdit:function(spanValueElem){var editor=this;var $li=findLiFromElement(spanValueElem);$li.addClass('treeEditingValue');var selectors=computeSelectors($li);var data=findDataFromObject(this.obj,selectors);var json=JSON.stringify(data);var $editDiv=$li.children('div.treeValueEditor');if($editDiv.length<1){$editDiv=$('<div class="treeValueEditor"><br/></div>');var $delBtn=$li.children('.treeEditDelete');$delBtn.after($editDiv);var $textArea=$('<textarea></textarea>');$editDiv.prepend($textArea);$textArea.keydown(function(evt){editor._valueEditKeyDown(evt,this);});var $okButton=$('<input type="button" value="OK"/>');$editDiv.append($okButton);$okButton.click(function(){editor._acceptValueEdit(this);});var $cancelButton=$('<input type="button" value="Cancel"/>');$editDiv.append($cancelButton);$cancelButton.click(function(){editor.cancelEditing();});};$li.children('.treeValueEditor').find('textarea').val(json).focus();},_acceptValueEdit:function(okButton){var $li=findLiFromElement(okButton);var selectors=computeSelectors($li);var json=$li.children('.treeValueEditor').find('textarea').val();try{var data=JSON.parse(json);}catch(e){$n2.log('JSON error',e);alert(_loc('Unable to parse JSON string: ')+e);return;}
$li.removeClass('treeEditingValue');this._beforeValueChanged(selectors,data);setObjectData(this.obj,selectors,data);this._afterValueChanged(selectors,data);this.cancelEditing();this.refresh();},_valueEditKeyDown:function(evt,textarea){if(evt&&evt.keyCode==13){this._acceptValueEdit(textarea);}else if(evt&&evt.keyCode==27){this.cancelEditing();};},_initiateAddKey:function(addButton){var editor=this;this._continueWithEditing(function(){editor._startAddKey(addButton);});},_startAddKey:function(addButton){var editor=this;var $ul=$(addButton).parents('ul').first();if($ul.length!=1)return;if($ul[0].treeUuid){var data=this.obj;var selectors=[];}else{var $li=findLiFromElement($ul);var selectors=computeSelectors($li);var data=findDataFromObject(this.obj,selectors);};if(null==data){this.refresh();}else if($n2.isArray(data)){var index=data.length;this._beforeKeyAdded(selectors,index);data.push(null);this._afterKeyAdded(selectors,index);this.refresh();}else if(typeof(data)==='object'){function cbAddKeyToObject(selectors,newKey,newData){editor._acceptNewObjectKey(selectors,newKey,newData);};this.options.createNewKey(cbAddKeyToObject,this.obj,selectors,data);};},_acceptNewObjectKey:function(selectors,newKey,newData){var data=findDataFromObject(this.obj,selectors);if(data){this._beforeKeyAdded(selectors,newKey);data[newKey]=newData;this._afterKeyAdded(selectors,newKey);this.refresh();};},_initiateDeleteKey:function(deleteButton){var editor=this;this._continueWithEditing(function(){editor._startDeleteKey(deleteButton);});},_startDeleteKey:function(deleteButton){var $li=findLiFromElement(deleteButton);var editor=this;var selectors=computeSelectors($li);function cbDeleteKey(){editor._acceptDeleteKey(selectors);};this.options.getDeleteConfirmation(cbDeleteKey,this.obj,selectors);},_acceptDeleteKey:function(selectors){this._beforeKeyDeleted(selectors);deleteObjectData(this.obj,selectors);this._afterKeyDeleted(selectors);this.refresh();},_initiateSwapKeys:function(btn,direction){var editor=this;this._continueWithEditing(function(){editor._acceptSwapKeys(btn,direction);});},_acceptSwapKeys:function(btn,direction){var editor=this;var $li=findLiFromElement(btn);var selectors=computeSelectors($li);var key=1*selectors.pop();var arr=findDataFromObject(this.obj,selectors);var swapKey=key+direction;if(swapKey<0){return;}else if(swapKey>=arr.length){return;};var uuid=getTreeUuid($li);if(direction<0){this._beforeIndexSwap(selectors,swapKey);}else{this._beforeIndexSwap(selectors,key);};var $swapLi=$('#tree'+uuid+'_'+selectors.join('_')+'_'+swapKey);if($swapLi.length==1){if(direction<0){$li.after($swapLi);}else{$swapLi.after($li);};$li.children('span.treeKey').empty().text(swapKey);$swapLi.children('span.treeKey').empty().text(key);$li[0]['treeArrayIndex']=swapKey;$swapLi[0]['treeArrayIndex']=key;var $swapElems=$swapLi.find('span.treeKey').parent();$swapElems.removeAttr('id');fixIds($li.find('span.treeKey').parent());fixIds($swapElems);var tmp=arr[key];arr[key]=arr[swapKey];arr[swapKey]=tmp;};if(direction<0){this._afterIndexSwap(selectors,swapKey);}else{this._afterIndexSwap(selectors,key);};},_initiateKeyEdit:function(spanKeyElem){var editor=this;this._continueWithEditing(function(){editor._startKeyEdit(spanKeyElem);});},_startKeyEdit:function(spanKeyElem){var editor=this;var $li=findLiFromElement(spanKeyElem);$li.addClass('treeEditingKey');var selectors=computeSelectors($li);var key=selectors.pop();var data=findDataFromObject(this.obj,selectors);$n2.log('Key editing',key,data,selectors);var $keySpan=$li.children('span.treeKey');var $keyEditor=$('<span class="treeKeyEditor"></span>');var $textInput=$('<input class="treeEditorKeyInput" type="text"/>');$textInput.val(key);$keyEditor.append($textInput);$textInput.keydown(function(evt){editor._keyEditKeyDown(evt,this);});var $ok=$('<div class="treeEditOk"></div>');$keyEditor.append($ok);$ok.click(function(){editor._acceptKeyEdit(this);});var $cancel=$('<div class="treeEditCancel"></div>');$keyEditor.append($cancel);$cancel.click(function(){editor.cancelEditing();});$keySpan.after($keyEditor);$textInput.focus();},_acceptKeyEdit:function(okButton){var $li=findLiFromElement(okButton);var selectors=computeSelectors($li);var currentKey=selectors.pop();var data=findDataFromObject(this.obj,selectors);var modifiedKey=$li.children('.treeKeyEditor').find('input').val();try{JSON.parse('{"'+modifiedKey+'":0}');}catch(e){$n2.log('parsing error',e);alert(_loc('Unable to parse key: ')+e);return;}
if(modifiedKey===currentKey){this.cancelEditing();return;};if(data[modifiedKey]!==undefined){alert(_loc('Key already in use: ')+modifiedKey);return;};this._beforeKeyChanged(selectors,currentKey,modifiedKey);data[modifiedKey]=data[currentKey];delete data[currentKey];this._afterKeyChanged(selectors,currentKey,modifiedKey);selectors.push(modifiedKey);$li.children('span.treeKey').empty().text(modifiedKey);$li[0]['treeObjectKey']=modifiedKey;fixIds($li.find('span.treeKey').parent());this.cancelEditing();this.refresh();},_keyEditKeyDown:function(evt,input){if(evt&&evt.keyCode==13){this._acceptKeyEdit(input);}else if(evt&&evt.keyCode==27){this.cancelEditing();};},_beforeValueChanged:function(selectors,data){this.options.beforeValueChanged(this.obj,selectors,data);},_afterValueChanged:function(selectors,data){this.options.afterValueChanged(this.obj,selectors,data);this.options.onObjectChanged(this.obj);},_beforeKeyChanged:function(selectors,fromKey,toKey){this.options.beforeKeyChanged(this.obj,selectors,fromKey,toKey);},_afterKeyChanged:function(selectors,fromKey,toKey){this.options.afterKeyChanged(this.obj,selectors,fromKey,toKey);this.options.onObjectChanged(this.obj);},_beforeKeyAdded:function(selectors,key){this.options.beforeKeyAdded(this.obj,selectors,key);},_afterKeyAdded:function(selectors,key){this.options.afterKeyAdded(this.obj,selectors,key);this.options.onObjectChanged(this.obj);},_beforeKeyDeleted:function(selectors){this.options.beforeKeyDeleted(this.obj,selectors);},_afterKeyDeleted:function(selectors){this.options.afterKeyDeleted(this.obj,selectors);this.options.onObjectChanged(this.obj);},_beforeIndexSwap:function(selectors,index){this.options.beforeIndexSwap(this.obj,selectors,index);},_afterIndexSwap:function(selectors,index){this.options.afterIndexSwap(this.obj,selectors,index);this.options.onObjectChanged(this.obj);}});$n2.tree={Tree:Tree,ObjectTree:ObjectTree,ObjectTreeEditor:ObjectTreeEditor,support:{findDataFromObject:findDataFromObject,setObjectData:setObjectData,deleteObjectData:deleteObjectData}};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};function findDataFromObject(o,selectors){if(null===selectors||0===selectors.length){return o;};if(null==o||typeof(o)==='number'||typeof(o)==='string'||typeof(o)==='undefined'||typeof(o)==='function'){return null;};if($n2.isArray(o)){var index=1*selectors[0];if(index>=o.length){return null;};if(selectors.length<2){return o[index];};return findDataFromObject(o[index],selectors.slice(1));}
if(typeof(o)==='object'){var key=selectors[0];var value=o[key];if(value===undefined){return null;};if(selectors.length<2){return value;};return findDataFromObject(value,selectors.slice(1));};return null;};function setObjectData(o,selectors,data){if(null===selectors||0===selectors.length){return false;};if($n2.isArray(o)){var index=1*selectors[0];if(index>=o.length){return false;};if(selectors.length>1){return setObjectData(o[index],selectors.slice(1),data);};o[index]=data;return true;}
if(typeof(o)==='object'){var key=selectors[0];if(selectors.length==1){o[key]=data;return true;}
var value=o[key];if(value===undefined){return false;};return setObjectData(value,selectors.slice(1),data);};return false;};function deleteObjectData(o,selectors){if(null===selectors||0===selectors.length){return false;};if(o===null){return false;};if($n2.isArray(o)){var index=1*selectors[0];if(index>=o.length){return false;};if(selectors.length>1){return deleteObjectData(o[index],selectors.slice(1));};o.splice(index,1);return true;}
if(typeof(o)==='object'){var key=selectors[0];var value=o[key];if(value===undefined){return false;};if(selectors.length>1){return deleteObjectData(value,selectors.slice(1));};delete o[key];return true;};return false;};function arrayRemove(arr,elem){for(var i=0,e=arr.length;i<e;++i){if(arr[i]===elem){arr.splice(i,1);return;};};};function defaultCreateNewKey(cbAddKeyToObject,obj,selectors,data){var index=0;var key='newkey_'+index;while(data[key]!==undefined){++index;key='newkey_'+index;if(index>100)return;};cbAddKeyToObject(selectors,key,'');}
function defaultGetDeleteConfirmation(cbDeleteKey){if(confirm(_loc('Do you wish to delete this element?'))){cbDeleteKey();};}
function defaultObjectKeySort(objFrag){var temp=[];for(var key in objFrag){temp.push(key);};temp.sort();var keyOrder=[];if(objFrag.n2se_keyorder){for(var i=0,e=objFrag.n2se_keyorder.length;i<e;++i){var key=objFrag.n2se_keyorder[i];if(typeof(objFrag[key])!=='undefined'){arrayRemove(temp,key);keyOrder.push(key);};};};for(var i=0,e=temp.length;i<e;++i){var key=temp[i];keyOrder.push(key);};return keyOrder;};function defaultObjectKeyOrderSave(objFrag,orderArray){objFrag.n2se_keyorder=orderArray;};function defaultIsKeyDisplayed(obj,selectors,data){if(selectors.length>0){var key=selectors[selectors.length-1];if(key==='n2se_keyorder'){return false;};};return true;};var createEditorDefaultOptions={onObjectChanged:function(obj){},objectKeySortAllowed:true,objectKeySort:defaultObjectKeySort,objectKeyOrderSave:defaultObjectKeyOrderSave,getDeleteConfirmation:defaultGetDeleteConfirmation,isKeyDisplayed:defaultIsKeyDisplayed,isKeyEditingAllowed:function(obj,selectors,data){return true;},isValueEditingAllowed:function(obj,selectors,data){return true;},isKeyDeletionAllowed:function(obj,selectors,data){return true;},createNewKey:defaultCreateNewKey};var SlideEditor=$n2.Class({divId:null,obj:null,options:null,currentSelectors:null,initialize:function($div,obj,opt_){this.options=$.extend({},createEditorDefaultOptions,opt_);var divId=$div.attr('id');if(!divId){divId=$n2.getUniqueId();$div.attr('id',divId);};this.divId=divId;this.obj=obj;this.currentSelectors=[];this._installEditors();},destroy:function(){this._removeEditors();this.divId=null;this.obj=null;this.options=null;},getDiv:function(){if(this.divId){var $div=$('#'+this.divId);if($div.length>1){return $div.first();}else if($div.length>0){return $div;};};return null;},getId:function(){return this.divId;},getObject:function(){return this.obj;},refresh:function(){var currentSelectors=this.currentSelectors;var objFrag=findDataFromObject(this.obj,currentSelectors);if(null!==objFrag){this._refresh();}else{while(!objFrag){currentSelectors.pop();objFrag=findDataFromObject(this.obj,currentSelectors);};this._refresh({back:true});};},_refresh:function(opt_){this._refreshHistory(opt_);this._refreshDisplay(opt_);},_refreshHistory:function(){var editor=this;var currentSelectors=this.currentSelectors;var $div=this.getDiv();if($div){var $history=$div.find('.n2se_history');$history.empty();var $back=$('<span class="n2se_history_back"><span class="n2se_btn"></span><span class="n2se_label">'+_loc('Back')+'</span></span>');$history.append($back);$back.click(function(e){editor._backClicked(e);});var $head=$('<span class="n2se_history_head"></span>');$history.append($head);var $top=$('<span class="n2se_history_level">'+_loc('top')+'</span>');$history.append($top);$top.click(createHistoryCallback(editor,0));for(var i=0,e=currentSelectors.length;i<e;++i){var $inter=$('<span class="n2se_history_inter"></span>');$history.append($inter);var selector=currentSelectors[i];var $level=$('<span class="n2se_history_level">'+selector+'</span>');$history.append($level);$level.click(createHistoryCallback(editor,i+1));};var $tail=$('<span class="n2se_history_tail"></span>');$history.append($tail);};function createHistoryCallback(editor,index){var cb=function(){editor._historyClicked(index);};return cb;}},_refreshDisplay:function(opt_){var currentSelectors=this.currentSelectors;var $div=this.getDiv();if($div){var objFrag=findDataFromObject(this.obj,currentSelectors);var currentSelectorsCopy=[];currentSelectorsCopy.push.apply(currentSelectorsCopy,currentSelectors);if(opt_&&opt_.back){var $main=$div.find('.n2se_main');var $previousDisplayDivs=$main.find('.n2se_display');var $display=$('<div class="n2se_display"></div>');if($previousDisplayDivs.length>0){$previousDisplayDivs.first().before($display);}else{$main.append($display);};this._drawDisplayPage($display,this.obj,currentSelectorsCopy,objFrag);$display.effect('slide',{mode:'show',direction:'left'},500,null);$previousDisplayDivs.effect('slide',{mode:'hide',direction:'right'},500,function(){$previousDisplayDivs.remove();});}else if(opt_&&opt_.forward){var $main=$div.find('.n2se_main');var $previousDisplayDivs=$main.find('.n2se_display');var $display=$('<div class="n2se_display"></div>');$main.append($display);this._drawDisplayPage($display,this.obj,currentSelectorsCopy,objFrag);$previousDisplayDivs.effect('slide',{mode:'hide',direction:'left'},500,function(){$previousDisplayDivs.remove();});$display.effect('slide',{mode:'show',direction:'right'},500,null);}else{var $display=$div.find('.n2se_display');$display.empty();this._drawDisplayPage($display,this.obj,currentSelectorsCopy,objFrag);};};},_drawDisplayPage:function($display,obj,selectors,objFrag){var editor=this;var isArray=false;var addBarNeeded=false;if(typeof(objFrag)==='string'){var isValueEditingAllowed=this.options.isValueEditingAllowed(obj,selectors,objFrag);var stringKey=selectors.pop();var stringParentObj=findDataFromObject(obj,selectors);var $keyDiv=$('<textarea class="n2se_textarea"></textarea>')
$display.append($keyDiv);$keyDiv.val(objFrag);if(isValueEditingAllowed){$keyDiv.keyup(function(e){var $textarea=$(this);var newValue=$textarea.val();var currentValue=stringParentObj[stringKey];if(currentValue!==newValue){stringParentObj[stringKey]=newValue;editor._reportObjectChange();};});}else{$keyDiv.attr('disabled','disabled');};}else if($n2.isArray(objFrag)){addBarNeeded=true;isArray=true;var $entries=$('<div class="n2se_entries"></div>');$display.append($entries);for(var key=0,e=objFrag.length;key<e;++key){var $keyDiv=$('<div class="n2se_entry"></div>')
$entries.append($keyDiv);selectors.push(key);var isValueEditingAllowed=this.options.isValueEditingAllowed(obj,selectors,objFrag[key]);var isKeyDeletionAllowed=this.options.isKeyDeletionAllowed(obj,selectors,objFrag[key]);selectors.pop();addKeyValue(editor,$keyDiv,objFrag,key,isArray,false,isValueEditingAllowed,isKeyDeletionAllowed);};$entries.sortable();$entries.bind('sortupdate',function(){editor._resortArray($display,objFrag);});}else{addBarNeeded=true;var $entries=$('<div class="n2se_entries"></div>');$display.append($entries);var keyOrder=this.options.objectKeySort(objFrag);for(var i=0,e=keyOrder.length;i<e;++i){var key=keyOrder[i];selectors.push(key);var isKeyDisplayed=this.options.isKeyDisplayed(obj,selectors,objFrag[key]);var isKeyEditingAllowed=this.options.isKeyEditingAllowed(obj,selectors,objFrag[key]);var isValueEditingAllowed=this.options.isValueEditingAllowed(obj,selectors,objFrag[key]);var isKeyDeletionAllowed=this.options.isKeyDeletionAllowed(obj,selectors,objFrag[key]);selectors.pop();if(isKeyDisplayed){var $keyDiv=$('<div class="n2se_entry"></div>')
$entries.append($keyDiv);addKeyValue(editor,$keyDiv,objFrag,key,isArray,isKeyEditingAllowed,isValueEditingAllowed,isKeyDeletionAllowed);};};if(this.options.objectKeySortAllowed){$entries.sortable();$entries.bind('sortupdate',function(){editor._resortObject($display,objFrag);});};};if(addBarNeeded){var $addBar=$('<div class="n2se_addbar"></div>');$display.append($addBar);var $addButton=$('<span class="n2se_addbar_addButton"><span class="n2se_btn"></span><span class="n2se_label">'+_loc('Add')+'</span></span>');$addBar.append($addButton);$addButton.click(function(){if(isArray){objFrag.push('');editor._refreshDisplay();editor._reportObjectChange();}else{editor.options.createNewKey(function(selectors,newKey,newValue){objFrag[newKey]=newValue;editor._refreshDisplay();editor._reportObjectChange();},obj,selectors,objFrag);};});};function addKeyValue(editor,$keyDiv,objFrag,key,isArray,isKeyEditingAllowed,isValueEditingAllowed,isKeyDeletionAllowed){var value=objFrag[key];var $del=$('<span class="n2se_entry_delete"></span>');$keyDiv.append($del);if(isKeyDeletionAllowed){$del.click(function(){editor.options.getDeleteConfirmation(function(){if(isArray){objFrag.splice(key,1);}else{delete objFrag[key];}
editor._refreshDisplay();editor._reportObjectChange();});});}else{$del.addClass('n2se_entry_delete_disabled');};if(isArray){var $keyInput=$('<span class="n2se_entry_key">'+key+'</span>');$keyDiv.append($keyInput);}else{var $keyInput=$('<input class="n2se_entry_key" type="text"/>');$keyDiv.append($keyInput);$keyInput.val(key);if(isKeyEditingAllowed){$keyInput.change(function(e){var $keyInput=$(this);var newKey=$keyInput.val();if(key!=newKey){if(objFrag[newKey]){$keyInput.val(key);}else{objFrag[newKey]=objFrag[key];delete objFrag[key];$keyDiv.empty();addKeyValue(editor,$keyDiv,objFrag,newKey,isArray,isKeyEditingAllowed,isValueEditingAllowed,isKeyDeletionAllowed);editor._reportObjectChange();};};});}else{$keyInput.attr('disabled','disabled');};};$keyDiv.append($('<span class="n2se_entry_is"> '+_loc('is')+' </span>'));var $select=$('<select class="n2se_entry_select"></select>');$keyDiv.append($select);$select.append($('<option value="string">'+_loc('a String')+'</option>'));$select.append($('<option value="number">'+_loc('a Number')+'</option>'));$select.append($('<option value="boolean">'+_loc('a Checkbox')+'</option>'));$select.append($('<option value="array">'+_loc('an Array')+'</option>'));$select.append($('<option value="object">'+_loc('an Object')+'</option>'));$select.append($('<option value="null">'+_loc('empty')+'</option>'));var requiresTextBox=false;var requiresCheckBox=false;var requiresForwardButton=false;if(value===null){$select.val('null');}else if(typeof(value)==='undefined'){$select.val('null');}else if($n2.isArray(value)){$select.val('array');requiresForwardButton=true;}else if(typeof(value)==='object'){$select.val('object');requiresForwardButton=true;}else if(typeof(value)==='string'){$select.val('string');requiresTextBox=true;requiresForwardButton=true;}else if(typeof(value)==='number'){$select.val('number');requiresTextBox=true;}else if(typeof(value)==='boolean'){$select.val('boolean');requiresCheckBox=true;}else{$select.val('string');requiresTextBox=true;requiresForwardButton=true;};if(isValueEditingAllowed){$select.change(function(e){var $select=$(this);var newType=$select.val();if('string'===newType){if(typeof(objFrag[key])==='object'){objFrag[key]='';}else{objFrag[key]=''+objFrag[key];};}else if('array'===newType){objFrag[key]=[objFrag[key]];}else if('object'===newType){objFrag[key]={};}else if('number'===newType){objFrag[key]=1*objFrag[key];if(isNaN(objFrag[key])){objFrag[key]=0;};}else if('boolean'===newType){objFrag[key]=false;}else if('null'===newType){objFrag[key]=null;}else{objFrag[key]='';};$keyDiv.empty();addKeyValue(editor,$keyDiv,objFrag,key,isArray,isKeyEditingAllowed,isValueEditingAllowed,isKeyDeletionAllowed);editor._reportObjectChange();});}else{$select.attr('disabled','disabled');};if(requiresForwardButton){var $forwardButton=$('<span class="n2se_entry_forward"></span>');$keyDiv.append($forwardButton);$forwardButton.click(function(e){editor._forwardClicked(key);});};if(requiresTextBox){var $textBox=$('<input class="n2se_entry_text" type="text"/>');$keyDiv.append($textBox);$textBox.val(value);if(isValueEditingAllowed){$textBox.keyup(function(e){var $textBox=$(this);var newVal=$textBox.val();if(typeof(objFrag[key])==='number'){newVal=1*newVal;if(isNaN(newVal)){$textBox.val(objFrag[key]);}else{objFrag[key]=newVal;editor._reportObjectChange();};}else{objFrag[key]=newVal;editor._reportObjectChange();};});}else{$textBox.attr('disabled','disabled');};}else if(requiresCheckBox){var $checkBox=$('<input class="n2se_entry_cb" type="checkbox"/>');$keyDiv.append($checkBox);if(value){$checkBox.attr('checked','checked');}
if(isValueEditingAllowed){$checkBox.click(function(e){var $checkBox=$(this);var newVal=$checkBox.is(':checked');objFrag[key]=newVal;editor._reportObjectChange();});}else{$checkBox.attr('disabled','disabled');};};};},_installEditors:function(){var editor=this;var $div=this.getDiv();if($div){$div.empty();var $root=$('<div class="n2se_root"></div>');$div.append($root);var $history=$('<div class="n2se_history"></div>');$root.append($history);var $main=$('<div class="n2se_main"></div>');$root.append($main);var $back=$('<div class="n2se_back"></div>');$main.append($back);$back.click(function(e){editor._backClicked(e);});var $display=$('<div class="n2se_display"></div>');$main.append($display);this._refresh();};},_removeEditors:function(){var $div=this.getDiv();if($div){$div.empty();this.divId=null;};},_backClicked:function(e){if(this.currentSelectors.length>0){this.currentSelectors.pop();this._refresh({back:true});};},_forwardClicked:function(key){this.currentSelectors.push(key);this._refresh({forward:true});},_historyClicked:function(selectorIndex){var howManyRemoved=this.currentSelectors.length-selectorIndex;if(howManyRemoved>0){this.currentSelectors.splice(selectorIndex,howManyRemoved);this._refresh({back:true});};},_reportObjectChange:function(){try{this.options.onObjectChanged(this.obj);}catch(e){$n2.log('Error reported on object refresh',e);}},_resortArray:function($display,objFrag){var $keys=$display.find(".n2se_entry_key");$n2.log('$keys',$keys);var nextArray=[];$keys.each(function(i,elem){var key=1*$(elem).text();nextArray.push(objFrag[key]);});objFrag.splice(0,objFrag.length);for(var i=0,e=nextArray.length;i<e;++i){objFrag.push(nextArray[i]);};this._refresh();this._reportObjectChange();},_resortObject:function($display,objFrag){var $keys=$display.find(".n2se_entry_key");var orderArray=[];$keys.each(function(i,elem){var key=$(elem).val();orderArray.push(key);});this.options.objectKeyOrderSave(objFrag,orderArray);this._refresh();this._reportObjectChange();}});$n2.slideEditor={Editor:SlideEditor,support:{findDataFromObject:findDataFromObject,setObjectData:setObjectData,deleteObjectData:deleteObjectData}};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};function setDataFromObjectSelector(o,selectors,value){if(typeof(selectors)==='string'){selectors=selectors.split('.');}
return setDataOnObject(o,selectors,0,value);};function setDataOnObject(o,selectors,selectorIndex,value){if(selectorIndex>=selectors.length){return false;};if(null==o||typeof(o)==='number'||typeof(o)==='string'||typeof(o)==='undefined'||typeof(o)==='function'){return false;};if(selectorIndex==(selectors.length-1)){if($n2.isArray(o)){var index=1*selectors[selectorIndex];if(index>=o.length){return false;};o[index]=value;return true;}
if(typeof(o)==='object'){var key=selectors[selectorIndex];o[key]=value;return true;};return false;};if($n2.isArray(o)){var index=1*selectors[selectorIndex];if(index>=o.length){return false;};return setDataOnObject(o[index],selectors,(selectorIndex+1),value);}
if(typeof(o)==='object'){var key=selectors[selectorIndex];var obj=o[key];if(obj===undefined){return false;};return setDataOnObject(obj,selectors,(selectorIndex+1),value);};return false;};function getDataFromObjectSelector(o,selectors){if(typeof(selectors)==='string'){selectors=selectors.split('.');}
return findDataFromObject(o,selectors,0);};function findDataFromObject(o,selectors,selectorIndex){if(selectorIndex>=selectors.length){return o;};if(null==o||typeof(o)==='number'||typeof(o)==='string'||typeof(o)==='undefined'||typeof(o)==='function'){return null;};if($n2.isArray(o)){var index=1*selectors[selectorIndex];if(index>=o.length){return null;};return findDataFromObject(o[index],selectors,(selectorIndex+1));}
if(typeof(o)==='object'){var key=selectors[selectorIndex];var value=o[key];if(value===undefined){return null;};return findDataFromObject(value,selectors,(selectorIndex+1));};return null;};var FormAttribute=$n2.Class({defaultValue:null,name:null,label:null,selector:null,type:'text',className:null,options:null,initialize:function(schema){$.extend(this,schema);if(null==this.label){this.label=this.name;}
if(null==this.selector){this.selector=this.name;}},isHidden:function(){return(this.type==='hidden');}});var FormButton=$n2.Class({name:null,label:null,initialize:function(name,label){this.name=name;this.label=label;}});var FormSchema=$n2.Class({attributes:[],title:'',okButton:false,okButtonLabel:_loc('OK'),cancelButton:false,cancelButtonLabel:_loc('Cancel'),resetButton:false,resetButtonLabel:_loc('Reset'),buttons:null,initialize:function(schema){if(schema.title)this.title=schema.title;if(schema.okButton)this.okButton=schema.okButton;if(schema.okButtonLabel)this.okButtonLabel=schema.okButtonLabel;if(schema.cancelButton)this.cancelButton=schema.cancelButton;if(schema.cancelButtonLabel)this.cancelButtonLabel=schema.cancelButtonLabel;if(schema.resetButton)this.resetButton=schema.resetButton;if(schema.resetButtonLabel)this.resetButtonLabel=schema.resetButtonLabel;if(schema.attributes){this.attributes=[];for(var i=0,e=schema.attributes.length;i<e;++i){var a=schema.attributes[i];this.attributes.push(new FormAttribute(a));};};if(schema.buttons){this.buttons=[];for(var i=0,e=schema.buttons.length;i<e;++i){var b=schema.buttons[i];this.buttons.push(new FormButton(b.name,b.label));};};},createForm:function(jQuerySet,data,options_){return new Form(this,jQuerySet,data,options_);},getTitle:function(){if(this.formSchema&&this.formSchema.title){return this.formSchema.title;};return null;}});var FormInput=$n2.Class({uniqueId:null,attribute:null,jQuerySet:null,data:null,input:null,initialValue:null,onChanged:null,initialize:function(uniqueId,attribute,data,jQuerySet,onChanged){this.uniqueId=uniqueId;this.attribute=attribute;this.data=data;this.jQuerySet=jQuerySet;this.onChanged=onChanged;this.render();},render:function(){var attr=this.attribute;var inputHtml=[];if('select'==attr.type){inputHtml.push('<select id="');inputHtml.push(this.uniqueId);if(attr.name){inputHtml.push('" name="');inputHtml.push(attr.name);}
if(attr.className){inputHtml.push('" class="');inputHtml.push(attr.className);}
inputHtml.push('">');for(var i=0,e=attr.options.length;i<e;++i){var opt=attr.options[i];if(typeof(opt)==='string'){opt={value:opt};};var label=opt.label?opt.label:opt.value;inputHtml.push('<option value="');inputHtml.push(opt.value);inputHtml.push('">');inputHtml.push(label);inputHtml.push('</option>');};inputHtml.push('</select>');}else if('date'==attr.type){inputHtml.push('<input id="');inputHtml.push(this.uniqueId);inputHtml.push('" type="text');if(attr.name){inputHtml.push('" name="');inputHtml.push(attr.name);}
if(attr.className){inputHtml.push('" class="');inputHtml.push(attr.className);}
inputHtml.push('"/>');}else if('file'==attr.type){inputHtml.push('<input id="');inputHtml.push(this.uniqueId);inputHtml.push('" type="file');if(attr.name){inputHtml.push('" name="');inputHtml.push(attr.name);}
if(attr.className){inputHtml.push('" class="');inputHtml.push(attr.className);}
inputHtml.push('"/>');}else if('textarea'==attr.type){inputHtml.push('<textarea id="');inputHtml.push(this.uniqueId);if(attr.name){inputHtml.push('" name="');inputHtml.push(attr.name);}
if(attr.className){inputHtml.push('" class="');inputHtml.push(attr.className);}
inputHtml.push('"></textarea>');}else if('array'==attr.type){inputHtml.push('<div id="');inputHtml.push(this.uniqueId);inputHtml.push('"/>');}else{inputHtml.push('<input id="');inputHtml.push(this.uniqueId);if(attr.type){inputHtml.push('" type="');inputHtml.push(attr.type);}
if(attr.name){inputHtml.push('" name="');inputHtml.push(attr.name);}
if(attr.className){inputHtml.push('" class="');inputHtml.push(attr.className);}
inputHtml.push('"/>');};this.input=$(inputHtml.join(''));this.input.change(this.onChanged);var initialValue=null;if(this.data){initialValue=this.getData();};if(null==initialValue&&this.attribute.defaultValue){initialValue=this.attribute.defaultValue;};if(null==initialValue){initialValue='';};this.input.val(initialValue);this.initialValue=initialValue;this.jQuerySet.append(this.input);if('date'==attr.type&&$.ui&&$.ui.datepicker){var dpOptions=$.extend({dateFormat:'yy-mm-dd',gotoCurrent:true,changeYear:true},attr.datePicker);this.input.datepicker(dpOptions);}else if('array'==attr.type){};},refreshFromData:function(){var v=this.getData();if(null==v){v='';}
this.setCurrentValue(v);},getName:function(){return this.attribute.name;},getCurrentValue:function(){return this.input.val();},setCurrentValue:function(value){this.input.val(value);},resetValue:function(){this.input.val(this.initialValue);},hasValueChanged:function(){var current=this.getCurrentValue();return(current!=this.initialValue);},getInputElement:function(){return this.input;},getData:function(){return getDataFromObjectSelector(this.data,this.attribute.selector);},setData:function(value){return setDataFromObjectSelector(this.data,this.attribute.selector,value);},refreshObject:function(){var value=this.getCurrentValue();var set=this.setData(value);}});var stubFunction=function(form){return true;};var defaultPreCancel=function(form){if(form.hasAnyValueChanged()){if(!window.confirm('Form has changed. Are you sure you want to cancel?')){return false;}}
return true;};var defaultPreReset=function(form){if(form.hasAnyValueChanged()){if(!window.confirm('Form has changed. Are you sure you want to reset it?')){return false;}}
return true;};var defaultFormOptions={formClass:'n2Form',preCancel:defaultPreCancel,postCancel:stubFunction,preReset:defaultPreReset,postReset:stubFunction,preOK:stubFunction,postOK:stubFunction,buttonPressed:stubFunction,onChanged:stubFunction,action:null,enctype:null,method:null,target:null,title:null,titleClass:null};var Form=$n2.Class({schema:null,inputs:null,inputsById:null,inputsByName:null,elem:null,data:null,form:null,options:null,inputChangedCallback:null,initialize:function(schema,jQuerySet,data,options_){this.options=$.extend(true,{},defaultFormOptions,options_);this.schema=schema;this.data=data;this.elem=$(jQuerySet[0]);this.inputs=[];this.inputsByName={};this.inputsById={};var _this=this;this.inputChangedCallback=function(evt){var $input=$(this);var inputId=$input.attr('id');_this._inputChanged(inputId);};this.render();},render:function(){this.elem.empty();var recv=this;var formHtml=[];formHtml.push('<form');if(this.options.formClass){formHtml.push(' class="');formHtml.push(this.options.formClass);formHtml.push('"');};if(this.options.action){formHtml.push(' action="');formHtml.push(this.options.action);formHtml.push('"');};if(this.options.enctype){formHtml.push(' enctype="');formHtml.push(this.options.enctype);formHtml.push('"');};if(this.options.method){formHtml.push(' method="');formHtml.push(this.options.method);formHtml.push('"');};if(this.options.target){formHtml.push(' target="');formHtml.push(this.options.target);formHtml.push('"');};formHtml.push('></form>');var $f=$(formHtml.join(''));this.form=$f[0];if(this.options.title){var $title=$('<div>'+this.options.title+'</div>');if(this.options.titleClass){$title.addClass(this.options.titleClass);};$f.append($title);};var $t=$('<table></table>');$f.append($t);var formSchema=this.schema;for(var i=0,e=formSchema.attributes.length;i<e;++i){var attr=formSchema.attributes[i];if(!attr.isHidden()){var $r=$('<tr></tr>');$t.append($r);var $d=$('<td>'+attr.label+'</td>');$r.append($d);$d=$('<td></td>');$r.append($d);this._addInput(attr,$d);};};var buttonsPresent=false;if(formSchema.resetButton||formSchema.okButton||formSchema.cancelButton){buttonsPresent=true;}else if(formSchema.buttons&&formSchema.buttons.length>0){buttonsPresent=true;};if(buttonsPresent){var $r=$('<tr></tr>');$t.append($r);var $d=$('<td></td>');$r.append($d);$d=$('<td></td>');$r.append($d);if(formSchema.okButton){var $b=$('<button>'+formSchema.okButtonLabel+'</button>');if($b.button){$b.button({icons:{primary:'ui-icon-check'}});};$d.append($b);$b.click(function(){recv._ok();return false;});};if(formSchema.cancelButton){var $b=$('<button>'+formSchema.cancelButtonLabel+'</button>');if($b.button){$b.button({icons:{primary:'ui-icon-cancel'}});};$d.append($b);$b.click(function(){recv._cancel();return false;});};if(formSchema.resetButton){var $rb=$('<button>'+formSchema.resetButtonLabel+'</button>');if($rb.button){$rb.button({icons:{primary:'ui-icon-arrowrefresh-1-s'}});};$d.append($rb);$rb.click(function(){recv._reset();return false;});};if(formSchema.buttons){for(var i=0,e=formSchema.buttons.length;i<e;++i){var button=formSchema.buttons[i];var $b=$('<button>'+button.label+'</button>');if($b.button){$b.button();};$d.append($b);$b.click(createButtonPressedCallback(this,button.name));};};};for(var i=0,e=formSchema.attributes.length;i<e;++i){var attr=formSchema.attributes[i];if(attr.isHidden()){this._addInput(attr,$f);};};this.elem.append($f);function createButtonPressedCallback(self,name){return function(){self._buttonPressed(name);return false;};};},refreshFromData:function(){for(var i=0,e=this.inputs.length;i<e;++i){this.inputs[i].refreshFromData();};},getInputFromName:function(name){return this.inputsByName[name];},_addInput:function(attr,$parent){var inputUniqueId=$n2.getUniqueId();var input=new FormInput(inputUniqueId,attr,this.data,$parent,this.inputChangedCallback);this.inputs.push(input);this.inputsByName[attr.name]=input;this.inputsById[inputUniqueId]=input;},_ok:function(){var okToProceed=this.options.preOK(this);if(okToProceed){this.form.submit();this.options.postOK(this);};},_cancel:function(){var okToProceed=this.options.preCancel(this);if(okToProceed){this.elem.empty();this.form=null;this.inputs=[];this.inputsbyName={};this.options.postCancel(this);};},_reset:function(){var okToProceed=this.options.preReset(this);if(okToProceed){for(var i=0,e=this.inputs.length;i<e;++i){this.inputs[i].resetValue();};this.options.postReset(this);};},_buttonPressed:function(name){this.options.buttonPressed(this,name);},_inputChanged:function(inputUniqueId){var input=this.inputsById[inputUniqueId];input.refreshObject();this.options.onChanged();},getFormElement:function(){return this.form;},getInputElements:function(){var result=[];for(var i=0,e=this.inputs.length;i<e;++i){result.push(this.inputs[i].getInputElement());};return result;},hasAnyValueChanged:function(){for(var i=0,e=this.inputs.length;i<e;++i){if(this.inputs[i].hasValueChanged())return true;};return false;}});$n2.form={Schema:FormSchema,Form:Form};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var DEFAULT_VIDEO_HEIGHT=240;var DEFAULT_VIDEO_WIDTH=320;var DEFAULT_VIDEO_CONTROLLER_HEIGHT=16;var DEFAULT_VIDEO_DIALOG_EXTRA_WIDTH=40;var DEFAULT_VIDEO_DIALOG_EXTRA_HEIGHT=56;var MEDIAELEMENT_DIALOG_EXTRA_WIDTH=25;var defaultDialogTitle=_loc('View Media');var baseDialogOptions={autoOpen:true,modal:true,dialogClass:'n2MediaDisplayDialog'};$n2.MediaDisplay=$n2.Class({initialize:function(){},displayMedia:function(opts_){var opts=$n2.extend({type:null,url:null,mimeType:null,title:null,author:null,description:null,width:null,height:null,onClose:function(opts){},onError:function(err){$n2.reportError(err);}},opts_);var onCloseHook=function(event,ui){opts.onClose(opts);};opts.onCloseHook=onCloseHook;if(null==opts.url){opts.onError('URL must be provided to display a media');};if('image'===opts.type){this._displayImage(opts);}else if('photosphere'===opts.type){this._displayPhotosphere(opts);}else if('audio'===opts.type){if($.fn&&$.fn.mediaelementplayer){this._displayAudioMediaElement(opts);}else{this._displayAudio(opts);};}else if('video'===opts.type){if($.fn&&$.fn.mediaelementplayer){this._displayVideoMediaElement(opts);}else{this._displayVideo(opts);};}else{this._displayUnknown(opts);};},_displayImage:function(opts){if($.lightBox){var lightBoxOptions={};var title='';if(opts.metaDataHtml){title=opts.metaDataHtml;}else{if(opts.title){title+=opts.title;};if(opts.author){title+=' (by '+opts.author+')';};if(opts.description){title+=' <br />'+opts.description;};};$.lightBox(lightBoxOptions,[{href:opts.url,title:title}]);}else{var dialogTitle=defaultDialogTitle;if(opts.title){dialogTitle=opts.title;};var mediaDialogId=$n2.getUniqueId();var alt='image';if(opts.title){alt=opts.title;};var $mediaDialog=$('<div id="'+mediaDialogId+'"><img alt="'+alt+'"/></div>');var $metaDataDiv=$('<div class="n2_dialogMetaData"></div>');$mediaDialog.append($metaDataDiv);this._addMetaData(opts,$metaDataDiv);var dialogOptions=$n2.extend({},baseDialogOptions,{title:dialogTitle,width:360,height:360,close:function(){$('#'+mediaDialogId).remove();opts.onCloseHook();}});$mediaDialog.dialog(dialogOptions);var objImagePreloader=new Image();objImagePreloader.onload=function(){var $d=$('#'+mediaDialogId);$d.find('img').attr('src',opts.url);var width=objImagePreloader.width;var height=objImagePreloader.height;objImagePreloader.onload=function(){};var $md=$d.find('.n2_dialogMetaData');var mdWidth=$md.width()||0;var mdHeight=$md.height()||0;var dWidth=width;if(dWidth<mdWidth){dWidth=mdWidth;};var dHeight=height+mdHeight;$d.dialog('option','width',dWidth+30);$d.dialog('option','height',dHeight+60);};objImagePreloader.src=opts.url;}},_displayPhotosphere:function(opts){if($n2.photosphere.IsAvailable()){var dialogTitle=defaultDialogTitle;if(opts.title){dialogTitle=opts.title;};var mediaDialogId=$n2.getUniqueId();var alt='image';if(opts.title){alt=opts.title;};var $mediaDialog=$('<div>').attr('id',mediaDialogId);var $panoDiv=$('<div>').addClass('n2MediaDisplayPhotosphere').appendTo($mediaDialog);var $metaDataDiv=$('<div>').addClass('n2_dialogMetaData').appendTo($mediaDialog);this._addMetaData(opts,$metaDataDiv);var dialogOptions=$n2.extend({},baseDialogOptions,{title:dialogTitle,width:1024,height:600,close:function(){$('#'+mediaDialogId).remove();opts.onCloseHook();}});$mediaDialog.dialog(dialogOptions);new $n2.photosphere.PhotosphereDisplay({elem:$panoDiv,url:opts.url});}else{this._displayImage(opts);};},_displayVideo:function(opts){var dialogTitle=defaultDialogTitle;if(opts.title){dialogTitle=opts.title;};var mediaDialogId=$n2.getUniqueId();var mkup=[];mkup.push('<div id="'+mediaDialogId+'">');var browserInfo=$n2.utils.getBrowserInfo();if("Safari"===browserInfo.browser&&5.0<=browserInfo.version){var embedHtml=this.generateHtml5Tag({url:opts.url,sourceType:'video',mimeType:opts.mimeType,autoplay:true,loop:false,controller:true});}else{var embedOptions=$n2.extend({},{url:opts.url,sourceType:'video',mimeType:opts.mimeType,controller:true});if(opts.mediaDisplayVideoWidth){embedOptions.width=opts.mediaDisplayVideoWidth;}else if(opts.width){embedOptions.width=opts.width;}else{embedOptions.width=DEFAULT_VIDEO_WIDTH;};if(opts.mediaDisplayVideoHeight){embedOptions.height=opts.mediaDisplayVideoHeight+DEFAULT_VIDEO_CONTROLLER_HEIGHT;}else if(opts.height){embedOptions.height=opts.height+DEFAULT_VIDEO_CONTROLLER_HEIGHT;}else{embedOptions.height=DEFAULT_VIDEO_HEIGHT+DEFAULT_VIDEO_CONTROLLER_HEIGHT;};var embedHtml=this.generateEmbedMarkup(embedOptions);};mkup.push(embedHtml);mkup.push('</div>');var $mediaDialog=$(mkup.join(''));this._addMetaData(opts,$mediaDialog);var dialogOptions=$n2.extend({},baseDialogOptions,{title:dialogTitle,close:function(){$('#'+mediaDialogId).remove();opts.onCloseHook();}});if(opts.mediaDisplayVideoWidth){dialogOptions.width=opts.mediaDisplayVideoWidth+DEFAULT_VIDEO_DIALOG_EXTRA_WIDTH;}else if(opts.width){dialogOptions.width=opts.width+DEFAULT_VIDEO_DIALOG_EXTRA_WIDTH;}else{dialogOptions.width=DEFAULT_VIDEO_WIDTH+DEFAULT_VIDEO_DIALOG_EXTRA_WIDTH;};if(opts.mediaDisplayVideoHeight){dialogOptions.height=opts.mediaDisplayVideoHeight+DEFAULT_VIDEO_DIALOG_EXTRA_HEIGHT;};$mediaDialog.dialog(dialogOptions);},_displayVideoMediaElement:function(opts){var dialogTitle=defaultDialogTitle;if(opts.title){dialogTitle=opts.title;};var mediaDialogId=$n2.getUniqueId();var videoId=$n2.getUniqueId();var width=DEFAULT_VIDEO_WIDTH;if(opts.mediaDisplayVideoWidth){width=opts.mediaDisplayVideoWidth;}else if(opts.width){width=opts.width;};var height=DEFAULT_VIDEO_HEIGHT;if(opts.mediaDisplayVideoHeight){height=opts.mediaDisplayVideoHeight+DEFAULT_VIDEO_CONTROLLER_HEIGHT;}else if(opts.height){height=opts.height+DEFAULT_VIDEO_CONTROLLER_HEIGHT;};var mkup=[];mkup.push('<div id="'+mediaDialogId+'">');mkup.push('<video id="'+videoId+'" controls="controls"  width="'+width+'" height="'+height+'">');mkup.push('<source src="'+opts.url+'"');if(opts.mimeType){mkup.push(' type="'+opts.mimeType+'"');};mkup.push('>');mkup.push('</video>');var $mediaDialog=$(mkup.join(''));this._addMetaData(opts,$mediaDialog);var dialogOptions=$n2.extend({},baseDialogOptions,{title:dialogTitle,width:width+MEDIAELEMENT_DIALOG_EXTRA_WIDTH,close:function(){$('#'+mediaDialogId).remove();opts.onCloseHook();}});$mediaDialog.dialog(dialogOptions);$('#'+videoId).mediaelementplayer({features:['playpause','progress','volume','sourcechooser','fullscreen']});},_displayAudio:function(opts){var dialogTitle=defaultDialogTitle;if(opts.title){dialogTitle=opts.title;};var mediaDialogId=$n2.getUniqueId();if($.jPlayer){var $mediaDialog=$('<div id="'+mediaDialogId+'"></div>');var $player=$('<div class="n2Media_jPlayer"></div>');$mediaDialog.append($player);}else{var browserInfo=$n2.utils.getBrowserInfo();var mkup=[];mkup.push('<div id="'+mediaDialogId+'">');if("Safari"===browserInfo.browser&&5.0<=browserInfo.version){var embedHtml=this.generateHtml5Tag({url:opts.url,sourceType:'audio',mimeType:opts.mimeType,autoplay:true,loop:false,controller:true});}else{var embedHtmlOpts={url:opts.url,sourceType:'audio',mimeType:opts.mimeType,controller:true};var embedHtml=this.generateEmbedMarkup(embedHtmlOpts);};mkup.push(embedHtml);mkup.push('</div>');var $mediaDialog=$(mkup.join(''));};this._addMetaData(opts,$mediaDialog);var dialogOptions=$n2.extend({},baseDialogOptions,{title:dialogTitle,width:320,close:function(){$('#'+mediaDialogId).remove();opts.onCloseHook();}});$mediaDialog.dialog(dialogOptions);if($.jPlayer){var $player=$mediaDialog.find('.n2Media_jPlayer');$player.jPlayer({ready:function(){var $m=$(this);$m.jPlayer('setMedia',{mp3:opts.url});},swfPath:'./js-external/jQuery.jPlayer/',size:{width:100,height:100}});};},_displayAudioMediaElement:function(opts){var dialogTitle=defaultDialogTitle;if(opts.title){dialogTitle=opts.title;};var mediaDialogId=$n2.getUniqueId();var audioId=$n2.getUniqueId();var browserInfo=$n2.utils.getBrowserInfo();var width=300;var mkup=[];mkup.push('<div id="'+mediaDialogId+'">');mkup.push('<audio id="'+audioId+'" controls="controls" width="'+width+'">');mkup.push('<source src="'+opts.url+'"');if(opts.mimeType){mkup.push(' type="'+opts.mimeType+'"');};mkup.push('>');mkup.push('</audio>');mkup.push('</div>');var $mediaDialog=$(mkup.join(''));this._addMetaData(opts,$mediaDialog);var dialogOptions=$n2.extend({},baseDialogOptions,{title:dialogTitle,width:width+MEDIAELEMENT_DIALOG_EXTRA_WIDTH,close:function(){$('#'+mediaDialogId).remove();opts.onCloseHook();}});$mediaDialog.dialog(dialogOptions);$('#'+audioId).mediaelementplayer({features:['playpause','progress','volume','sourcechooser']});},_displayUnknown:function(opts){var dialogTitle=defaultDialogTitle;if(opts.title){dialogTitle=opts.title;};var mediaDialogId=$n2.getUniqueId();var $mediaDialog=$('<div></div>');$mediaDialog.attr('id',mediaDialogId);var $meta=$('<div></div>').appendTo($mediaDialog);this._addMetaData(opts,$mediaDialog);var $explain=$('<div class="n2Media_explain"></div>');$explain.text(_loc('You must leave the atlas to view this file.'));$mediaDialog.append($explain);var $buttons=$('<div class="n2Display_buttons"></div>').appendTo($mediaDialog);$('<a class="nunaliit_form_link"></a>').attr('href',opts.url).text(_loc('Proceed')).appendTo($buttons);var dialogOptions=$n2.extend({},baseDialogOptions,{title:dialogTitle,width:320,close:function(){$('#'+mediaDialogId).remove();opts.onCloseHook();}});$mediaDialog.dialog(dialogOptions);},_addMetaData:function(opts,$elem){$elem.append($('<br/>'));if(opts.metaDataHtml){var $meta=$('<span></span>');$meta.html(opts.metaDataHtml);$elem.append($meta);}else{if(opts.author){var $author=$('<span></span>');$author.text(_loc('(by {author})',{author:opts.author}));$elem.append($author);$elem.append($('<br/>'));};if(opts.description){var $desc=$('<span></span>');$desc.text(opts.description);$elem.append($desc);};};},generateInlineHtmlForMedia:function(opts_){var opts=$n2.extend({type:null,url:null,mimeType:null,autoplay:true,caption:null,headerHtml:null,footerHtml:null,onError:function(err){$n2.reportError(err);}},opts_);var html=[];html.push('<div><p>');if(opts.headerHtml){html.push(opts.headerHtml);html.push('</p><p>');};if(opts.type==='image'){html.push('<img src="'+opts.url+'" alt="');if(typeof(opts.caption)==='string'&&opts.caption!==''){html.push(opts.caption);}else{html.push(_loc('an image'));};html.push('"/>');}else if(opts.type==='video'){var mkup=this.generateEmbedMarkup({url:opts.url,sourceType:'video',mimeType:opts.mimeType,width:320,height:256,autoplay:opts.autoplay});html.push(mkup);}else if(opts.type==='audio'){var browserInfo=$n2.utils.getBrowserInfo();var embedOpts={url:opts.url,sourceType:'audio',mimeType:opts.mimeType,width:250,autoplay:opts.autoplay};if("Safari"===browserInfo.browser){embedOpts.height=16;};var mkup=this.generateEmbedMarkup(embedOpts);html.push(mkup);};if(opts.footerHtml){html.push('</p><p>');html.push(opts.footerHtml);};html.push('</p></div>');return html.join('');},generateEmbedMarkup:function(opts_){var opts=$n2.extend({url:null,sourceType:null,mimeType:null,width:null,height:null,autoplay:false,loop:false,controller:false},opts_);if(typeof(QT_GenerateOBJECTText)==='function'){var args=[];args.push(opts.url);args.push(opts.width);args.push(opts.height);args.push('');if(opts.autoplay){args.push('autoplay');args.push('true');};if(opts.loop){args.push('loop');args.push('true');};if(opts.controller){args.push('controller');args.push('true');};return QT_GenerateOBJECTText.apply(null,args);};var html=[];html.push('<object');if(opts.width){html.push(' width="'+opts.width+'"');};if(opts.height){html.push(' height="'+opts.height+'"');};html.push(' codebase="http://www.apple.com/qtactivex/qtplugin.cab#version=7,3,0,0"');html.push('classid="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B"');html.push('><param name="src" value="');html.push(opts.url);html.push('">');html.push('<param name="autoplay" value="');if(opts.autoplay){html.push('true">');}else{html.push('false">');};if(opts.controller){html.push('<param name="controller" value="true">');};if(opts.loop){html.push('<param name="loop" value="true">');};html.push('<embed');if(opts.width){html.push(' width="'+opts.width+'"');};if(opts.height){html.push(' height="'+opts.height+'"');};if(opts.autoplay){html.push(' autoplay="true"');}else{html.push(' autoplay="false"');};if(opts.controller){html.push(' controller="true"');};if(opts.loop){html.push(' loop="true"');};html.push(' pluginspage="http://www.apple.com/quicktime/download/" src="');html.push(opts.url);html.push('"></embed></object>');return html.join('');},generateHtml5Tag:function(opts_){var opts=$n2.extend({url:null,sourceType:null,mimeType:null,width:null,height:null,autoplay:false,loop:false,controller:false},opts_);var html=[];if('video'===opts.sourceType){html.push('<video');}else if('audio'===opts.sourceType){html.push('<audio');}else{return null;};if(opts.width){html.push(' width="'+opts.width+'"');};if(opts.height){html.push(' height="'+opts.height+'"');};if(opts.controller){html.push(' controls="controls"');};if(opts.autoplay){html.push(' autoplay="autoplay"');};html.push(' src="');html.push(opts.url);html.push('"');if(opts.mimeType){html.push(' type="'+opts.mimeType+'"');};html.push('>');html.push('<embed');if(opts.width){html.push(' width="'+opts.width+'"');};if(opts.height){html.push(' height="'+opts.height+'"');};if(opts.autoplay){html.push(' autoplay="true"');}else{html.push(' autoplay="false"');};if(opts.controller){html.push(' controller="true"');};if(opts.loop){html.push(' loop="true"');};html.push(' src="');html.push(opts.url);html.push('"></embed>');if('video'===opts.sourceType){html.push('</video>');}else if('audio'===opts.sourceType){html.push('</audio>');}else{return null;};return html.join('');}});$n2.mediaDisplay=new $n2.MediaDisplay();})(jQuery,nunaliit2);;(function($,$n2){var SpreadSheet=$n2.Class({descriptor:null,data:null,entries:null,isCellsData:null,isListData:null,initialize:function(opts_){var opts=$n2.extend({descriptor:null,data:null,isCellsData:false,isListData:false},opts_);this.descriptor=opts.descriptor;this.data=opts.data;this.isCellsData=opts.isCellsData;this.isListData=opts.isListData;this.entries=null;},getDescriptor:function(){return this.descriptor;},getTitle:function(){if(this.descriptor){return this.descriptor.title;};return null;},getData:function(){return this.data;},getEntries:function(){if(null===this.entries){if(this.isCellsData){this.entries=parseSpreadSheetCellFeed(this.data);}else if(this.isListData){this.entries=parseSpreadSheetListFeed(this.data);};};return this.entries;}});var SpreadSheetDescriptor=$n2.Class({key:null,id:null,position:null,cellsFeedUrl:null,listFeedUrl:null,title:null,initialize:function(opts_){var opts=$n2.extend({key:null,id:null,position:null,title:null,cellsFeedUrl:null,listFeedUrl:null},opts_);this.key=opts.key;this.id=opts.id;this.position=opts.position;this.title=opts.title;this.cellsFeedUrl=opts.cellsFeedUrl;this.listFeedUrl=opts.listFeedUrl;},getSpreadSheet:function(opts_){var opts=$.extend({onSuccess:function(spreadsheet){},onError:function(errMsg){}},opts_);var options={key:this.key,descriptor:this,onSuccess:opts.onSuccess,onError:function(errorMsg){opts.onError('Error loading spreadsheet at position '+this.position+': '+errorMsg);}};if(this.cellsFeedUrl){options.cellsFeedUrl=this.cellsFeedUrl;}if(this.position){options.position=this.position;}if(this.listFeedUrl){options.listFeedUrl=this.listFeedUrl;};loadSpreadSheet(options);}});var WorkBook=$n2.Class({key:null,title:null,author:null,spreadSheetDescriptors:null,initialize:function(opts_){var opts=$n2.extend({key:null,title:null},opts_);this.spreadSheetDescriptors=[];this.key=opts.key;this.title=opts.title;},getSpreadSheetDescriptors:function(){return this.spreadSheetDescriptors;},getSpreadSheetDescriptor:function(opts_){var opts=$n2.extend({id:null,position:null,title:null},opts_);for(var i=0,e=this.spreadSheetDescriptors.length;i<e;++i){var sd=this.spreadSheetDescriptors[i];if(opts.id&&opts.id===sd.id){return sd;}else if(typeof(opts.position)==='number'&&opts.position===sd.position){return sd;}else if(opts.title&&opts.title===sd.title){return sd;};};return null;},getSpreadSheet:function(opts_){var opts=$n2.extend({id:null,position:null,title:null,onSuccess:function(speadsheet){},onError:function(errMsg){}},opts_);var sd=this.getSpreadSheetDescriptor(opts);if(sd){sd.getSpreadSheet({onSuccess:opts.onSuccess,onError:opts.onError});return;};opts.onError('SpreadSheet descriptor not found: '+opts.title+'/'+opts.id+'/'+opts.position);},getAllSpreadSheets:function(opts_){var opts=$n2.extend({onSuccess:function(arr){},onError:function(errMsg){}},opts_);var descriptors=this.getSpreadSheetDescriptors();var result=[];if(descriptors.length<=0){opts.onSuccess(result);}else{var waiting=[];for(var i=0,e=descriptors.length;i<e;++i){waiting.push(descriptors[i]);};for(var i=0,e=descriptors.length;i<e;++i){var sd=descriptors[i];sd.getSpreadSheet({onSuccess:loaded,onError:opts.onError});};};function loaded(spreadSheet){var desc=spreadSheet.getDescriptor();var descIndex=waiting.indexOf(desc);if(descIndex>=0){waiting.splice(descIndex,1);};result.push(spreadSheet);if(waiting.length>0){return;};opts.onSuccess(result);};}});function getWorkBook(options_){var options=$.extend({key:null,onSuccess:function(workbook){},onError:function(errMsg){}},options_);if(!options.key){options.onError('Google Spreadsheet key required.');};$.ajax({async:true,dataType:'json',data:{alt:'json'},traditional:true,url:'https://spreadsheets.google.com/feeds/worksheets/'+options.key+'/public/basic',success:handleData,error:function(XMLHttpRequest,textStatus,errorThrown){options.onError('Unable to load workbook: '+textStatus);}});function handleData(data){var workbook=new WorkBook({key:options.key});if(data&&data.feed){var feed=data.feed;if(feed.title&&feed.title.$t){workbook.title=feed.title.$t;};if(feed.author){workbook.author={};if(feed.author.name&&feed.author.name.$t){workbook.author.name=feed.author.name.$t;};if(feed.author.email&&feed.author.email.$t){workbook.author.email=feed.author.email.$t;};};if(feed.entry){for(var i=0,e=feed.entry.length;i<e;++i){var entry=feed.entry[i];var sheet={key:options.key,position:i+1};if(entry.title){sheet.title=entry.title.$t;};if(entry.id&&entry.id.$t){var index=entry.id.$t.lastIndexOf('/');if(index>=0){sheet.id=entry.id.$t.substr(index+1);};};if(entry.link){for(var j=0,k=entry.link.length;j<k;++j){var link=entry.link[j];if(link.rel==='http://schemas.google.com/spreadsheets/2006#cellsfeed'){sheet.cellsFeedUrl=link.href;}else if(link.rel==='http://schemas.google.com/spreadsheets/2006#listfeed'){sheet.listFeedUrl=link.href;};};};var sd=new SpreadSheetDescriptor(sheet);workbook.spreadSheetDescriptors.push(sd);};};};options.onSuccess(workbook);};};function loadSpreadSheet(opts_){var opts=$.extend({key:null,position:null,cellsFeedUrl:null,listFeedUrl:null,descriptor:null,onSuccess:function(data){},onError:function(errorMsg){}},opts_);var url=null;var isCellsData=false;var isListData=false;if(opts.cellsFeedUrl){url=opts.cellsFeedUrl;isCellsData=true;}else if(opts.key&&opts.position){url='https://spreadsheets.google.com/feeds/cells/'+opts.key+'/'+opts.position+'/public/values';isCellsData=true;}else if(opts.listFeedUrl){url=opts.listFeedUrl;isListData=true;}else{opts.onError('Requested spreadsheet not identified.');return;};$.ajax({async:true,dataType:'json',data:{alt:'json'},traditional:true,url:url,success:function(data){var ss=new SpreadSheet({descriptor:opts.descriptor,data:data,isCellsData:isCellsData,isListData:isListData});opts.onSuccess(ss);},error:function(XMLHttpRequest,textStatus,errorThrown){opts.onError('Unable to load spreadsheet: '+textStatus);}});};var gsxRe=/^gsx\$(.*)$/;function parseSpreadSheetListFeed(data){var res=[];if(data&&data.feed&&data.feed.entry){var entries=data.feed.entry;for(var loop=0;loop<entries.length;++loop){var entry=entries[loop];var e={};for(var key in entry){var match=key.match(gsxRe);if(match){var value=entry[key].$t;e[match[1]]=value;};};res.push(e);};};return res;};var reIdRowCol=/\/R([0-9]+)C([0-9]+)$/;function parseSpreadSheetCellFeed(data){var res=[];if(data&&data.feed&&data.feed.entry){var cells=data.feed.entry;var entries=[];var columnByPosition=[];var columnByName={};for(var loop=0,loopEnd=cells.length;loop<loopEnd;++loop){var cell=cells[loop];if(cell.id&&cell.id['$t']){var test=reIdRowCol.exec(cell.id['$t']);if(test){cell._row=1*test[1];cell._col=1*test[2];if(cell._row===1){var name='_'+cell._col;if(cell.content&&cell.content['$t']){name=cell.content['$t'];};var column=null;if(columnByName[name]){columnByName[name].isArray=true;}else{column={name:name,isArray:false};columnByName[name]=column;};columnByPosition[cell._col]=column;}else{entries.push(cell);};};};};entries.sort(function(a,b){if(a._row<b._row)return-1;if(a._row>b._row)return 1;if(a._col<b._col)return-1;if(a._col>b._col)return 1;return 0;});var currentEntry=null;var currentRow=-1;for(var loop=0,loopEnd=entries.length;loop<loopEnd;++loop){var cell=entries[loop];if(currentRow!=cell._row){if(currentEntry){completeEntry(currentEntry);};currentRow=cell._row;currentEntry={};res.push(currentEntry);};var isArray=true;var colName='_';var column=columnByPosition[cell._col];if(column){isArray=column.isArray;colName=column.name;};var value='';if(cell.content&&cell.content['$t']){value=cell.content['$t'];};if(isArray){if(!currentEntry[colName]){currentEntry[colName]=[];};currentEntry[colName].push(value);}else{currentEntry[colName]=value;};};if(currentEntry){completeEntry(currentEntry);};};return res;function completeEntry(entry){if(entry){for(var colName in columnByName){var column=columnByName[colName];if(typeof(entry[colName])==='undefined'){if(column.isArray){entry[colName]=[];}else{entry[colName]='';};};};};};};$n2.googleDocs={getWorkBook:getWorkBook,loadSpreadSheet:loadSpreadSheet};})(jQuery,nunaliit2);;(function($,$n2){$n2.dbSearchEngine=function(options_){var defaultOptions={url:'./search',relMediaPath:'test_media/'};var options=$.extend({},defaultOptions,options_);return{getRelMediaPath:function(mediaFile){if(mediaFile){return options.relMediaPath+mediaFile;};return options.relMediaPath;},getHoverSound:function(placeId,opts_){$.ajax({type:'POST',url:options.url+'/getHoverMedia',data:{id:placeId},dataType:'json',contentType:'application/x-www-form-urlencoded; charset=utf-8',async:true,success:function(result){if(result&&result.media&&result.media.length>0){var media=result.media[0];if(media&&media.hover_audio){opts_.installSoundFn(media.hover_audio,opts_);};};}});},searchForContributions:function(searchString,callback){$.ajax({type:'POST',url:options.url+'/searchContributions',data:{content:searchString},dataType:'json',contentType:'application/x-www-form-urlencoded; charset=utf-8',async:true,success:function(result){if(result.contributions){callback(result.contributions);};}});},searchForPlaceNames:function(searchString,callback){$.ajax({type:'POST',url:options.url+'/searchFeatures',data:{content:searchString},dataType:'json',contentType:'application/x-www-form-urlencoded; charset=utf-8',async:true,success:function(result){if(result.features){callback(result.features);};}});},findGeometryCentroidFromPlaceId:function(placeId,callback){$.ajax({type:'POST',url:options.url+'/findGeometryCentroid',data:{type:'place_id',id:placeId},dataType:'json',contentType:'application/x-www-form-urlencoded; charset=utf-8',async:true,success:function(result){if(result&&result.features){callback(result.features);};}});},findGeometryCentroidFromId:function(id,callback){$.ajax({type:'POST',url:options.url+'/findGeometryCentroid',data:{type:'id',id:id},dataType:'json',contentType:'application/x-www-form-urlencoded; charset=utf-8',async:true,success:function(result){if(result&&result.features){callback(result.features);};}});},getAudioMediaFromPlaceId:function(placeId,callback){$.ajax({type:'POST',url:options.url+'/getAudioMedia',data:{id:placeId},dataType:'json',contentType:'application/x-www-form-urlencoded; charset=utf-8',async:true,success:function(result){if(result&&result.media){callback(result.media);};}});}};};})(jQuery,nunaliit2);;(function($,$n2){$n2.contributionDb=function(options_){var defaultOptions={url:'./contributions'};var options=$.extend({},defaultOptions,options_);return{getContributionsFromPlaceId:function(placeId,callback){$.getJSON('./contributions/fromName?name='+encodeURIComponent(placeId),function(result){var contributions=result.contributions;if(contributions){callback(contributions);};});}};};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};function onProgressUpdate(tracker){var progressKey=tracker.getProgressKey();var $set=$('#n2UploadProgress_'+progressKey);if($set.length<1){tracker.cancel();}else{var total=tracker.getTotal();var count=tracker.getCurrent();var percent=0;if(total!=0){percent=((count/total)*100);}
$set.find('.n2UploadProgressBar').css('width',''+percent+'%').attr('alt','File Upload '+percent+'%');$set.find('.n2UploadProgressBarBackground').attr('alt','File Upload '+percent+'%');};};var UploadDefaultOptions={url:null,progressServer:null};var Upload=$n2.Class({options:null,welcomeMessage:null,initialize:function(options_){this.options=$n2.extend({},UploadDefaultOptions,options_);},buildForm:function(jQuerySet,options_){var upload=this;var opts=$.extend({onSuccess:function(res){},onError:function(errorMsg){$n2.reportError(errorMsg);}},this.options,options_);jQuerySet.empty();if(!$.fn.ajaxSubmit){opts.onError(_loc('Can not perform file uploads unless jquery.form.js is included'));};jQuerySet.each(function(i,elem){installForm(elem,opts.docId,opts.rev);});function installForm(elem,docId,docRev){var $elem=$(elem),$form=$('<form class="n2UploadForm" method="post"></form>'),$button=$('<input class="n2UploadInputButton" type="button"/>');$form.append($('<input class="n2UploadInputFile" type="file" name="_attachments"/>'));$button.val(_loc('Upload'));$form.append($button);$elem.append($form);$button.click(uploadClicked);};function uploadClicked(evt){var $btn=$(this);var $form=$btn.parents('.n2UploadForm');$form.find('.n2UploadInputButton').attr('disabled','disabled');if(opts.progressServer){opts.progressServer.requestProgressKey(function(key){performUpload($form,key);});}else{performUpload($form,null);}};function performUpload($form,progressKey){$form.find('.n2UploadProgressId').remove();if(progressKey){$form.prepend($('<input class="n2UploadProgressId" type="hidden" name="progressId" value="'+progressKey+'"/>'));};$form.ajaxSubmit({type:'post',url:opts.url+'put',dataType:'json',success:function(res){$form.find('*').removeAttr('disabled');if(res.error){opts.onError(_loc('Error while uploading: ')+res.error,options_);}else{opts.onSuccess(res,options_);}},error:function(xhr,status,err){$form.find('*').removeAttr('disabled');opts.onError(_loc('Error while uploading: ')+err,options_);}});if(progressKey){var progressDiv=$('<div id="n2UploadProgress_'+progressKey+'" class="n2UploadProgress">'
+'<div class="n2UploadProgressBarBackground">'
+'<div class="n2UploadProgressBar">'
+'</div></div></div>');$form.after(progressDiv);upload.options.progressServer.createProgressTracker({progressKey:progressKey,onUpdate:onProgressUpdate});};};},submitForm:function(options_){var _this=this;var opts=$.extend({form:null,suppressInformationDialog:false,onSuccess:function(res){},onError:function(errorMsg){$n2.reportError(errorMsg);}},this.options,options_);if(!$.fn.ajaxSubmit){opts.onError('Can not perform file uploads unless jquery.form.js is included');return;};if(!opts.form){opts.onError('Form element is required');return;};var $form=opts.form;if(typeof($form)==='string'){$form=$('#'+$form);};$form.find('.n2UploadInputButton').attr('disabled','disabled');if(opts.progressServer){opts.progressServer.requestProgressKey(function(key){performUpload($form,key);});}else{performUpload($form,null);};function performUpload($form,progressKey){$form.find('.n2UploadProgressId').remove();if(progressKey){$form.prepend($('<input class="n2UploadProgressId" type="hidden" name="progressId" value="'+progressKey+'"/>'));};$form.ajaxSubmit({type:'post',url:opts.url+'put',dataType:'json',success:function(res){$form.find('*').removeAttr('disabled');if(res.error){opts.onError(_loc('Error while uploading: ')+res.error,options_);}else{if(!opts.suppressInformationDialog){_this._uploadSucessfulDialog();};opts.onSuccess(res,options_);}},error:function(xhr,status,err){$form.find('*').removeAttr('disabled');opts.onError(_loc('Error while uploading: ')+err,options_);}});if(progressKey){var progressDiv=$('<div id="n2UploadProgress_'+progressKey+'" class="n2UploadProgress">'
+'<div class="n2UploadProgressBarBackground">'
+'<div class="n2UploadProgressBar">'
+'</div></div></div>');$form.after(progressDiv);_this.options.progressServer.createProgressTracker({progressKey:progressKey,onUpdate:onProgressUpdate});};};},checkWelcome:function(options_){var opts=$.extend({onSuccess:function(message){},onError:function(errorMsg){$n2.reportError(errorMsg);}},this.options,options_);if(this.welcomeMessage){opts.onSuccess(this.welcomeMessage);}else{this.getWelcome(opts);};},getWelcome:function(options_){var opts=$.extend({onSuccess:function(message){},onError:function(errorMsg){$n2.reportError(errorMsg);}},this.options,options_);var _this=this;$.ajax({url:opts.url+'welcome',type:'GET',dataType:'json',success:function(data,textStatus,jqXHR){if(data&&data.ok){_this.welcomeMessage=data;opts.onSuccess(data);}else{opts.onError(data);};},error:function(jqXHR,textStatus,errorThrown){opts.onError(errorThrown);}});},_uploadSucessfulDialog:function(){if(!$.fn.button||!$.fn.dialog){return;};var infoDialogId=$n2.getUniqueId();var $dialog=$('<div id="'+infoDialogId+'"></div>');var $label=$('<span></span>');$label.text(_loc('Your file was uploaded and will become available when it has been approved.'));$dialog.append($label);$('<br/>').appendTo($dialog);var $ok=$('<button></button>');$ok.text(_loc('OK'));$ok.button({icons:{primary:'ui-icon-check'}});$dialog.append($ok);$ok.click(function(){var $diag=$('#'+infoDialogId);$diag.dialog('close');return false;});var dialogOptions={autoOpen:true,title:_loc('File Uploaded'),modal:true,width:500,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};$dialog.dialog(dialogOptions);}});$n2.upload={Upload:Upload};})(jQuery,nunaliit2);;(function($,$n2){if(typeof(OpenLayers)!=='undefined'){if(OpenLayers.Style&&OpenLayers.Style.prototype){OpenLayers.Style.prototype.addPropertyStyles=function(propertyStyles,symbolizer){var property;for(var key in symbolizer){property=symbolizer[key];if(typeof property=="string"&&property.match(/\$\{\w+(\.\w+)*\}/)){propertyStyles[key]=true;}}
return propertyStyles;};};};})(jQuery,nunaliit2);;(function($,$n2){function reportFilterError(errStr,filterObj){$n2.reportError('OL_FILTER','Filter error. Application might not work properly. '+errStr);log('Filter error: '+errStr,filterObj);};function convertFilterArray(arr,onError){var filters=[];for(var loop=0;loop<arr.length;++loop){var filter=convertToOpenLayers(arr[loop],onError);if(filter){filters.push(filter);};}
return filters;};var convertToOpenLayers=function(obj,onError){if(!onError)onError=reportFilterError;if(obj.comparison){if(null==obj.property){onError('Missing "property" from comparison filter',obj);return null;};if(null==obj.value){onError('Missing "value" from comparison filter',obj);return null;};if('='==obj.comparison){return new OpenLayers.Filter.Comparison({type:OpenLayers.Filter.Comparison.EQUAL_TO,property:obj.property,value:obj.value});};onError('Invalid comparison filter: '+obj.comparison,obj);return null;};if(obj.logical){if(null==obj.filters){onError('Missing "filters" from logical filter',obj);return null;};var filters=convertFilterArray(obj.filters,onError);if('and'==obj.logical){return new OpenLayers.Filter.Logical({type:OpenLayers.Filter.Logical.AND,filters:filters});}
if('or'==obj.logical){return new OpenLayers.Filter.Logical({type:OpenLayers.Filter.Logical.OR,filters:filters});}
onError('Invalid logical filter: '+obj.logical,obj);return null;}
onError('Unknown filter type',obj);return null;};var Filter=$n2.Class({olFilter:null,initialize:function(){},parseJsonFilter:function(opts_){var opts=$n2.extend({json:null,onError:reportFilterError},opts_);if(!opts.json){opts.onError('Invalid JSON',this);return false;};this.olFilter=convertToOpenLayers(opts.json,opts.onError);return(this.olFilter!=null);},fromFids:function(fids){this.olFilter=new OpenLayers.Filter.FeatureId({fids:fids});return true;},getOpenLayerFilter:function(){return this.olFilter;},matches:function(f){if(!this.olFilter){return true;}
return this.olFilter.evaluate(f);}});$n2.olFilter={CreateOpenLayersFilter:convertToOpenLayers,Filter:Filter,fromJson:function(json){var filter=new Filter();filter.parseJsonFilter({json:json});return filter;},fromFid:function(fid){var filter=new Filter();filter.fromFids([fid]);return filter;},fromFids:function(fids){var filter=new Filter();filter.fromFids(fids);return filter;}};})(jQuery,nunaliit2);if(typeof(OpenLayers)!='undefined'){OpenLayers.StyleMapCallback=OpenLayers.Class({callback:null,initialize:function(callback,options){this.callback=callback;OpenLayers.Util.extend(this,options);},destroy:function(){this.callback=null;},styles:{},createSymbolizer:function(feature,intent){if(!this.callback){return{display:'none'};}
return this.callback(feature,intent);},CLASS_NAME:"OpenLayers.StyleMapCallback"});};;(function($,$n2){function isValidGeom(olGeom){var vertices=olGeom.getVertices();for(var i=0,e=vertices.length;i<e;++i){var vertice=vertices[i];if(typeof(vertice.x)!=='number'||vertice.x!==vertice.x){return false;}else if(typeof(vertice.y)!=='number'||vertice.y!==vertice.y){return false;};};return true;};function sortFeatures(features){features.sort(featureSorting);};function featureSorting(a,b){var aSort=a._n2Sort;if(!aSort){aSort=prepareFeatureForSorting(a);};var bSort=b._n2Sort;if(!bSort){bSort=prepareFeatureForSorting(b);};if(aSort.isPoint&&bSort.isPoint){return 0;}else if(aSort.isPoint){return 1;}else if(bSort.isPoint){return-1;}else{if(aSort.isLineString&&bSort.isLineString){if(aSort.largestDim>bSort.largestDim){return-1;}else{return 1;};}else if(aSort.isLineString){return 1;}else if(bSort.isLineString){return-1}else{if(aSort.largestDim>bSort.largestDim){return-1;}else{return 1;};};};};function prepareFeatureForSorting(f){f._n2Sort={};var geomClass=f.geometry.CLASS_NAME;f._n2Sort.isPoint=(geomClass.indexOf('Point')>=0);if(f._n2Sort.isPoint){f._n2Sort.isLineString=false;f._n2Sort.isPolygon=false;f._n2Sort.largestDim=0;}else{f._n2Sort.isLineString=(geomClass.indexOf('LineString')>=0);f._n2Sort.isPolygon=(false==f._n2Sort.isLineString);var bounds=f.geometry.getBounds();f._n2Sort.largestDim=bounds.top-bounds.bottom;var tmp=bounds.right-bounds.left;if(f._n2Sort.largestDim<tmp){f._n2Sort.largestDim=tmp;};};return f._n2Sort;};$n2.olUtils={isValidGeom:isValidGeom,sortFeatures:sortFeatures,featureSorting:featureSorting};})(jQuery,nunaliit2);if(!window.$n2){window.$n2=window.nunaliit2;};if(typeof(OpenLayers)!=='undefined'){OpenLayers.Control.N2LoadingPanel=OpenLayers.Class(OpenLayers.Control,{counter:0,maximized:false,visible:true,initialize:function(options){OpenLayers.Control.prototype.initialize.apply(this,[options]);},setVisible:function(visible){this.visible=visible;if(visible){OpenLayers.Element.show(this.div);}else{OpenLayers.Element.hide(this.div);}},getVisible:function(){return this.visible;},hide:function(){this.setVisible(false);},show:function(){this.setVisible(true);},toggle:function(){this.setVisible(!this.getVisible());},increaseCounter:function(){this.counter++;if(this.counter>0){if(!this.maximized&&this.visible){this.maximizeControl();}}},decreaseCounter:function(){if(this.counter>0){this.counter--;}
if(this.counter==0){if(this.maximized&&this.visible){this.minimizeControl();}}},draw:function(){OpenLayers.Control.prototype.draw.apply(this,arguments);$(this.div).append($('<div class="n2LoadingPanel_overlay"></div>'));$(this.div).append($('<div class="n2LoadingPanel_outertext"><div>Loading...</div></div>'));if(this.maximized){this.maximizeControl();}else{this.minimizeControl();};return this.div;},minimizeControl:function(evt){if(this.div){this.div.style.display="none";};this.maximized=false;if(evt!=null){OpenLayers.Event.stop(evt);}},maximizeControl:function(evt){if(this.div){this.div.style.display="block";};this.maximized=true;if(evt!=null){OpenLayers.Event.stop(evt);}},destroy:function(){OpenLayers.Control.prototype.destroy.apply(this,arguments);},CLASS_NAME:"OpenLayers.Control.N2LoadingPanel"});};;(function($,$n2){if(typeof(OpenLayers)!=='undefined'&&OpenLayers.Strategy&&OpenLayers.Class){OpenLayers.Strategy.NunaliitLayerSorting=OpenLayers.Class(OpenLayers.Strategy,{sorting:false,activate:function(){var activated=OpenLayers.Strategy.prototype.activate.call(this);if(activated){this.layer.events.on({"beforefeaturesadded":this.beforeFeaturesAdded,scope:this});}
return activated;},deactivate:function(){var deactivated=OpenLayers.Strategy.prototype.deactivate.call(this);if(deactivated){this.layer.events.un({"beforefeaturesadded":this.beforeFeaturesAdded,scope:this});}
return deactivated;},beforeFeaturesAdded:function(event){var propagate=true;if(!this.sorting){this.sortFeatures(null,event.features);propagate=false;}
return propagate;},sortFeatures:function(event,newFeatures){var features=[];for(var i=0,e=this.layer.features.length;i<e;++i){var feature=this.layer.features[i];features[features.length]=feature;};if(newFeatures){for(var i=0,e=newFeatures.length;i<e;++i){features[features.length]=newFeatures[i];};};if(features&&features.length>0&&newFeatures&&newFeatures.length>0){var resortingRequired=false;for(var i=0,e=features.length-2;i<=e;++i){var c=$n2.olUtils.featureSorting(features[i],features[i+1]);if(c>0){resortingRequired=true;break;};};if(resortingRequired){$n2.olUtils.sortFeatures(features);this.layer.removeAllFeatures();this.sorting=true;this.layer.addFeatures(features);this.sorting=false;}else if(newFeatures.length>0){this.sorting=true;this.layer.addFeatures(newFeatures);this.sorting=false;};};},CLASS_NAME:"OpenLayers.Strategy.NunaliitLayerSorting"});};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};if(typeof(OpenLayers)!=='undefined'){OpenLayers.Control.NunaliitLayerSwitcher=OpenLayers.Class(OpenLayers.Control,{layerStates:null,layersDiv:null,baseLayersDiv:null,baseLayers:null,dataLbl:null,dataLayersDiv:null,dataLayers:null,minimizeDiv:null,maximizeDiv:null,ascending:true,cachedSymbols:null,initialize:function(options){var _this=this;OpenLayers.Control.prototype.initialize.apply(this,arguments);this.layerStates=[];this.cachedSymbols={};this.__baseFn=function(e){var $elem=$(this);return _this._onBaseLayerChanged($elem,e);};this.__overlayFn=function(e){var $elem=$(this);return _this._onOverlayChanged($elem,e);};},destroy:function(){this.clearLayersArray("base");this.clearLayersArray("data");this.map.events.un({addlayer:this.redraw,changelayer:this.redraw,removelayer:this.redraw,changebaselayer:this.redraw,scope:this});OpenLayers.Control.prototype.destroy.apply(this,arguments);},setMap:function(map){OpenLayers.Control.prototype.setMap.apply(this,arguments);this.map.events.on({addlayer:this.redraw,changelayer:this.redraw,removelayer:this.redraw,changebaselayer:this.redraw,scope:this});},draw:function(){var _this=this;OpenLayers.Control.prototype.draw.apply(this);this.loadContents();if(!this.outsideViewport){this.minimizeControl();}
this.redraw();$(this.div).click(function(e){var $elem=$(this);_this._onButtonClick($elem,e);if(e.stopPropagation){e.stopPropagation();}else{e.cancelBubble=true;};return true;});$(this.div).dblclick(function(e){if(e.stopPropagation){e.stopPropagation();}else{e.cancelBubble=true;};return false;});return this.div;},_onButtonClick:function($elem,evt){var $elem=$(evt.target);var layerSwitcherAttr=$elem.attr('_layer_switcher');if($elem.hasClass('minimizeDiv')){this.minimizeControl();}else if($elem.hasClass('maximizeDiv')){this.maximizeControl();};},_onBaseLayerChanged:function($elem,e){if($elem.is(':checked')){var _layer=$elem.attr('_layer');this.map.setBaseLayer(this.map.getLayer(_layer));};return true;},_onOverlayChanged:function($elem,e){this.updateMap();},_onSvgClick:function(elemId,e){var $input=$('#'+elemId);if(false==$input.is(':disabled')){if($input.is(':checked')){$input.removeAttr('checked');}else{$input.attr('checked','checked');};this.updateMap();};},clearLayersArray:function(layersType){this[layersType+"LayersDiv"].innerHTML="";this[layersType+"Layers"]=[];},checkRedraw:function(){var redraw=false;if(!this.layerStates.length||(this.map.layers.length!=this.layerStates.length)){redraw=true;}else{for(var i=0,len=this.layerStates.length;i<len;i++){var layerState=this.layerStates[i];var layer=this.map.layers[i];if((layerState.name!=layer.name)||(layerState.inRange!=layer.inRange)||(layerState.id!=layer.id)||(layerState.visibility!=layer.visibility)){redraw=true;break;}}}
return redraw;},redraw:function(){var _this=this;if(!this.checkRedraw()){return this.div;}
this.clearLayersArray("base");this.clearLayersArray("data");var containsOverlays=false;var containsBaseLayers=false;var len=this.map.layers.length;this.layerStates=new Array(len);for(var i=0;i<len;i++){var layer=this.map.layers[i];this.layerStates[i]={'name':layer.name,'visibility':layer.visibility,'inRange':layer.inRange,'id':layer.id};}
var layers=this.map.layers.slice();if(!this.ascending){layers.reverse();}
for(var i=0,len=layers.length;i<len;i++){var layer=layers[i];var baseLayer=layer.isBaseLayer;if(layer.displayInLayerSwitcher){if(baseLayer){containsBaseLayers=true;}else{containsOverlays=true;}
var checked=(baseLayer)?(layer==this.map.baseLayer):layer.getVisibility();var inputId=$n2.getUniqueId();var $input=$('<input/>').attr('id',inputId).attr('_layer',layer.id).attr('_layer_switcher',this.id).attr('defaultChecked',checked).val(layer.name).addClass('olButton');if(baseLayer){$input.attr('type','radio').attr('name',this.id+'_baseLayers');}else{$input.attr('type','checkbox').attr('name',layer.name);};if(checked){$input.attr('checked','checked');};if(!baseLayer&&!layer.inRange){$input.attr('disabled','disabled');}
var $inputDiv=$('<div class="n2layerSwitcher_input_container"></div>').append($input);var $label=$('<label/>').attr('for',inputId).addClass('labelSpan').addClass('olButton').attr('_layer_switcher',this.id).text(layer.name);if(!baseLayer&&!layer.inRange){$label.addClass('n2layerSwitcher_outOfRange');};if(baseLayer){$label.addClass('n2layerSwitcher_alignBottom');}else{$label.addClass('n2layerSwitcher_alignBaseline');};var $labelDiv=$('<div class="n2layerSwitcher_label_container"></div>').append($label);var $previewDiv=null;if(!baseLayer&&layer.styleMap){var g=new OpenLayers.Geometry.Point(0,0);var f=new OpenLayers.Feature.Vector(g);var style=layer.styleMap.createSymbolizer(f);var svg=this._createSVGNode('svg');if(svg){this._setAttr(svg,'version','1.1');this._setAttr(svg,'style','display:inline-block');this._setAttr(svg,'width',14);this._setAttr(svg,'height',14);this._setAttr(svg,'viewBox','-7 -7 14 14');this._addClass(svg,'n2layerSwitcher_svg');var $svg=$(svg);var geom=null;if(style.graphicName&&this.cachedSymbols[style.graphicName]){geom=this._createSVGNode('path');this._setAttr(geom,'d',this.cachedSymbols[style.graphicName]);}else if(style.graphicName&&OpenLayers.Renderer.symbol[style.graphicName]){var path=this._computePathFromSymbol(OpenLayers.Renderer.symbol[style.graphicName]);this.cachedSymbols[style.graphicName]=path;geom=this._createSVGNode('path');this._setAttr(geom,'d',this.cachedSymbols[style.graphicName]);}else{geom=this._createSVGNode('circle');this._setAttr(geom,'r',5);};if(geom){for(var name in style){var styleValue=style[name];if('fillColor'===name){this._setAttr(geom,'fill',styleValue);}else if('fillOpacity'===name){this._setAttr(geom,'fill-opacity',styleValue);}else if('strokeColor'===name){this._setAttr(geom,'stroke',styleValue);}else if('strokeOpacity'===name){this._setAttr(geom,'stroke-opacity',styleValue);}else if('strokeWidth'===name){this._setAttr(geom,'stroke-width',styleValue);}else if('strokeLinecap'===name){this._setAttr(geom,'stroke-linecap',styleValue);}else{this._setAttr(geom,name,styleValue);};};svg.appendChild(geom);geom.onclick=createSvgClickHandler(inputId);};$previewDiv=$('<div class="n2layerSwitcher_preview_container"></div>').append($svg);};};var groupArray=(baseLayer)?this.baseLayers:this.dataLayers;groupArray.push({'layer':layer,'inputElem':$input,'labelSpan':$label});var groupDiv=(baseLayer)?this.baseLayersDiv:this.dataLayersDiv;var $div=$('<div class="n2layerSwitcher_layer"/>').append($inputDiv).append($labelDiv).appendTo($(groupDiv));if($previewDiv){$div.append($previewDiv);};if(baseLayer){$input.change(this.__baseFn);}else{$input.change(this.__overlayFn);};};};this.dataLbl.style.display=(containsOverlays)?"":"none";this.baseLbl.style.display=(containsBaseLayers)?"":"none";return this.div;function createSvgClickHandler(elemId){return function(e){return _this._onSvgClick(elemId,e);};};},_createSVGNode:function(type,id){var node=null;if(document.createElementNS){node=document.createElementNS('http://www.w3.org/2000/svg',type);if(id){node.setAttributeNS(null,'id',id);};};return node;},_setAttr:function(node,name,value){node.setAttributeNS(null,name,value);},_addClass:function(elem,className){var classNames=[];if(elem.className){var currentClasses=''+elem.className;classNames=currentClasses.split(' ');};classNames.push(className);elem.className=classNames.join(' ');},updateMap:function(){for(var i=0,len=this.baseLayers.length;i<len;i++){var layerEntry=this.baseLayers[i];if(layerEntry.inputElem.is(':checked')){this.map.setBaseLayer(layerEntry.layer,false);};};for(var i=0,len=this.dataLayers.length;i<len;i++){var layerEntry=this.dataLayers[i];var checked=layerEntry.inputElem.is(':checked');layerEntry.layer.setVisibility(checked);};},maximizeControl:function(e){this.div.style.width="";this.div.style.height="";this.showControls(false);if(e!=null){OpenLayers.Event.stop(e);}},minimizeControl:function(e){this.div.style.width="0px";this.div.style.height="0px";this.showControls(true);if(e!=null){OpenLayers.Event.stop(e);}},showControls:function(minimize){this.maximizeDiv.style.display=minimize?"":"none";this.minimizeDiv.style.display=minimize?"none":"";this.layersDiv.style.display=minimize?"none":"";},loadContents:function(){this.layersDiv=document.createElement("div");this.layersDiv.id=this.id+"_layersDiv";OpenLayers.Element.addClass(this.layersDiv,"layersDiv");this.baseLbl=document.createElement("div");this.baseLbl.innerHTML=_loc("Base Layer");OpenLayers.Element.addClass(this.baseLbl,"baseLbl");this.baseLayersDiv=document.createElement("div");OpenLayers.Element.addClass(this.baseLayersDiv,"baseLayersDiv");this.dataLbl=document.createElement("div");this.dataLbl.innerHTML=_loc("Overlays");OpenLayers.Element.addClass(this.dataLbl,"dataLbl");this.dataLayersDiv=document.createElement("div");OpenLayers.Element.addClass(this.dataLayersDiv,"dataLayersDiv");if(this.ascending){this.layersDiv.appendChild(this.baseLbl);this.layersDiv.appendChild(this.baseLayersDiv);this.layersDiv.appendChild(this.dataLbl);this.layersDiv.appendChild(this.dataLayersDiv);}else{this.layersDiv.appendChild(this.dataLbl);this.layersDiv.appendChild(this.dataLayersDiv);this.layersDiv.appendChild(this.baseLbl);this.layersDiv.appendChild(this.baseLayersDiv);}
this.div.appendChild(this.layersDiv);var img=OpenLayers.Util.getImageLocation('layer-switcher-maximize.png');this.maximizeDiv=OpenLayers.Util.createAlphaImageDiv("OpenLayers_Control_MaximizeDiv",null,null,img,"absolute");OpenLayers.Element.addClass(this.maximizeDiv,"maximizeDiv olButton");this.maximizeDiv.style.display="none";this.div.appendChild(this.maximizeDiv);var img=OpenLayers.Util.getImageLocation('layer-switcher-minimize.png');this.minimizeDiv=OpenLayers.Util.createAlphaImageDiv("OpenLayers_Control_MinimizeDiv",null,null,img,"absolute");OpenLayers.Element.addClass(this.minimizeDiv,"minimizeDiv olButton");this.minimizeDiv.style.display="none";this.div.appendChild(this.minimizeDiv);},_computePathFromSymbol:function(symbol){var area=0,minx=undefined,maxx=undefined,miny=undefined,maxy=undefined;for(var i=0,e=symbol.length;i<e;i=i+2){var x=symbol[i];var y=symbol[i+1];if(typeof minx==='undefined'){minx=x;}else if(minx>x){minx=x;};if(typeof maxx==='undefined'){maxx=x;}else if(maxx<x){maxx=x;};if(typeof miny==='undefined'){miny=y;}else if(miny>y){miny=y;};if(typeof maxy==='undefined'){maxy=y;}else if(maxy<y){maxy=y;};};var path=[],transx=(minx+maxx)/2,transy=(miny+maxy)/2,width=maxx-minx,height=maxy-miny,factor=(width>height)?width/10:height/10;if(factor<=0){factor=1;};for(var i=0,e=symbol.length;i<e;i=i+2){var x=symbol[i];var y=symbol[i+1];var effX=(x-transx)/factor;var effY=(y-transy)/factor;effX=Math.floor(effX*100)/100;effY=Math.floor(effY*100)/100;if(0===i){path.push('M ');}else{path.push('L ');};path.push(''+effX);path.push(' '+effY+' ');};path.push('Z');return path.join('');},CLASS_NAME:"OpenLayers.Control.LayerSwitcher"});};})(jQuery,nunaliit2);;(function($,$n2){if(typeof(OpenLayers)!=='undefined'&&OpenLayers.Class&&OpenLayers.Handler){OpenLayers.Handler.NunaliitFeature=OpenLayers.Class(OpenLayers.Handler,{EVENTMAP:{'click':{'in':'click','out':'clickout'},'mousemove':{'in':'over','out':'out'},'dblclick':{'in':'dblclick','out':null},'mousedown':{'in':null,'out':null},'mouseup':{'in':null,'out':null},'touchstart':{'in':'click','out':'clickout'}},feature:null,lastFeature:null,lastClickedFeature:null,down:null,up:null,clickTolerance:4,geometryTypes:null,stopClick:true,stopDown:false,stopUp:false,initialize:function(control,layer,callbacks,options){OpenLayers.Handler.prototype.initialize.apply(this,[control,callbacks,options]);this.layer=layer;},touchstart:function(evt){this.startTouch();return OpenLayers.Event.isMultiTouch(evt)?true:this.mousedown(evt);},touchmove:function(evt){OpenLayers.Event.preventDefault(evt);},mousedown:function(evt){if(OpenLayers.Event.isLeftClick(evt)||OpenLayers.Event.isSingleTouch(evt)){this.down=evt.xy;}
return this.handle(evt)?!this.stopDown:true;},mouseup:function(evt){this.up=evt.xy;return this.handle(evt)?!this.stopUp:true;},click:function(evt){return this.handle(evt)?!this.stopClick:true;},mousemove:function(evt){if(!this.callbacks['over']&&!this.callbacks['out']){return true;}
this.handle(evt);return true;},dblclick:function(evt){return!this.handle(evt);},geometryTypeMatches:function(feature){return this.geometryTypes==null||OpenLayers.Util.indexOf(this.geometryTypes,feature.geometry.CLASS_NAME)>-1;},handle:function(evt){if(this.feature&&!this.feature.layer){this.feature=null;}
var type=evt.type;var handled=false;var previouslyIn=!!(this.feature);var click=(type=="click"||type=="dblclick"||type=="touchstart");this.feature=this.layer.getFeatureFromEvent(evt);if(this.feature&&!this.feature.layer){this.feature=null;}
if(this.lastFeature&&!this.lastFeature.layer){this.lastFeature=null;}
if(this.feature&&click){if(type==="touchstart"){OpenLayers.Event.preventDefault(evt);}
if(this.geometryTypeMatches(this.feature)){this.triggerCallback(type,'in',[this.feature]);this.lastClickedFeature=this.feature;handled=true;}else{if(this.lastClickedFeature&&this.lastClickedFeature.layer){this.triggerCallback(type,'out',[this.lastClickedFeature]);}else{this.triggerCallback(type,'out',[]);}
this.lastClickedFeature=null;}}else if(click){if(this.lastClickedFeature&&this.lastClickedFeature.layer){this.triggerCallback(type,'out',[this.lastClickedFeature]);}else{this.triggerCallback(type,'out',[]);}
this.lastClickedFeature=null;}else if(this.feature){var inNew=(this.feature!=this.lastFeature);if(this.geometryTypeMatches(this.feature)){if(previouslyIn&&inNew){if(this.lastFeature){this.triggerCallback(type,'out',[this.lastFeature]);}
this.triggerCallback(type,'in',[this.feature]);}else if(!previouslyIn){this.triggerCallback(type,'in',[this.feature]);}
this.lastFeature=this.feature;handled=true;}else{if(this.lastFeature&&(previouslyIn&&inNew)){this.triggerCallback(type,'out',[this.lastFeature]);}
this.feature=null;}}else if(this.lastFeature&&previouslyIn){this.triggerCallback(type,'out',[this.lastFeature]);}
return handled;},triggerCallback:function(type,mode,args){var triggered=false;var key=this.EVENTMAP[type][mode];if(key){if(type=='click'&&this.up&&this.down){var dpx=Math.sqrt(Math.pow(this.up.x-this.down.x,2)+
Math.pow(this.up.y-this.down.y,2));if(dpx<=this.clickTolerance){this.callback(key,args);triggered=true;}
this.up=this.down=null;}else{this.callback(key,args);triggered=true;}}
return triggered;},activate:function(){var activated=false;if(OpenLayers.Handler.prototype.activate.apply(this,arguments)){this.moveLayerToTop();this.map.events.on({"removelayer":this.handleMapEvents,"changelayer":this.handleMapEvents,scope:this});activated=true;}
return activated;},deactivate:function(){var deactivated=false;if(OpenLayers.Handler.prototype.deactivate.apply(this,arguments)){this.moveLayerBack();this.feature=null;this.lastFeature=null;this.down=null;this.up=null;this.map.events.un({"removelayer":this.handleMapEvents,"changelayer":this.handleMapEvents,scope:this});deactivated=true;}
return deactivated;},handleMapEvents:function(evt){if(evt.type=="removelayer"||evt.property=="order"){this.moveLayerToTop();}},moveLayerToTop:function(){var index=Math.max(this.map.Z_INDEX_BASE['Feature']-1,this.layer.getZIndex())+1;this.layer.setZIndex(index);},moveLayerBack:function(){var index=this.layer.getZIndex()-1;if(index>=this.map.Z_INDEX_BASE['Feature']){this.layer.setZIndex(index);}else{this.map.setLayerZIndex(this.layer,this.map.getLayerIndex(this.layer));}},CLASS_NAME:"OpenLayers.Handler.NunaliitFeature"});};})(jQuery,nunaliit2);if(!window.$n2){window.$n2=window.nunaliit2;};if(typeof(OpenLayers)!=='undefined'&&OpenLayers.Control&&OpenLayers.Class){OpenLayers.Control.NunaliitGazetteer=OpenLayers.Class(OpenLayers.Control,{activateListener:null,initialize:function(options){this.handlers={};OpenLayers.Control.prototype.initialize.apply(this,arguments);},destroy:function(){this.deactivate();OpenLayers.Control.prototype.destroy.apply(this,arguments);},activate:function(){if(typeof(this.activateListener)==='function'){this.activateListener();}else{return OpenLayers.Control.prototype.activate.apply(this,arguments);};},deactivate:function(){return OpenLayers.Control.prototype.deactivate.apply(this,arguments);},CLASS_NAME:"OpenLayers.Control.NunaliitGazetteer"});};;(function($,$n2){if(typeof(OpenLayers)!=='undefined'&&OpenLayers.Strategy&&OpenLayers.Class){OpenLayers.Strategy.NunaliitCluster=OpenLayers.Class(OpenLayers.Strategy,{distance:20,minimumPolygonPixelSize:20,minimumLinePixelSize:20,disableDynamicClustering:false,clusterPointsOnly:false,threshold:null,resolution:null,clusterId:null,initialize:function(options){OpenLayers.Strategy.prototype.initialize.apply(this,arguments);this.clusterId=1;if(typeof options.minimumPolygonPixelSize==='undefined'){this.minimumPolygonPixelSize=this.distance;};if(typeof options.minimumLinePixelSize==='undefined'){this.minimumLinePixelSize=this.distance;};},activate:function(){var activated=OpenLayers.Strategy.prototype.activate.call(this);if(activated){this.layer.events.on({"beforefeaturesadded":this.beforeFeaturesAdded,"moveend":this.cluster,scope:this});}
return activated;},deactivate:function(){var deactivated=OpenLayers.Strategy.prototype.deactivate.call(this);if(deactivated){this.layer.events.un({"beforefeaturesadded":this.beforeFeaturesAdded,"moveend":this.cluster,scope:this});}
return deactivated;},beforeFeaturesAdded:function(event){var propagate=true;var needToCluster=false;if(event&&event.features&&event.features.length){for(var i=0,e=event.features.length;i<e;++i){var f=event.features[i];if(f.cluster){}else if(this._isEligibleFeature(f)){needToCluster=true;};};};if(needToCluster){this.cluster(null,event.features);propagate=false;}
return propagate;},cluster:function(event,newFeatures){var features=[];if(newFeatures){for(var i=0,e=newFeatures.length;i<e;++i){features[features.length]=newFeatures[i];};};for(var i=0,e=this.layer.features.length;i<e;++i){var feature=this.layer.features[i];if(feature.cluster){for(var j=0,k=feature.cluster.length;j<k;++j){features[features.length]=feature.cluster[j];};}else{features[features.length]=feature;};};if((!event||event.zoomChanged)&&features){var resolution=this.layer.map.getResolution();this.resolution=resolution;var clusters=[];var featuresToAdd=[];var feature,clustered,cluster;for(var i=0;i<features.length;++i){feature=features[i];if(!this._isEligibleFeature(feature)){featuresToAdd.push(feature);}else if(feature.geometry){clustered=false;for(var j=clusters.length-1;j>=0;--j){cluster=clusters[j];if(this.shouldCluster(cluster,feature)){this.addToCluster(cluster,feature);clustered=true;break;};};if(!clustered){var c=this.createCluster(feature);clusters.push(c);featuresToAdd.push(c);};};};this.layer.removeAllFeatures();if(featuresToAdd.length>0){if(this.threshold>1){var clone=featuresToAdd.slice();featuresToAdd=[];var candidate;for(var i=0,len=clone.length;i<len;++i){candidate=clone[i];if(candidate.cluster&&candidate.cluster.length<this.threshold){Array.prototype.push.apply(featuresToAdd,candidate.cluster);}else{featuresToAdd.push(candidate);};};};this.layer.addFeatures(featuresToAdd);};};},shouldCluster:function(cluster,feature){var cc=cluster.geometry.getBounds().getCenterLonLat();var fc=feature.geometry.getBounds().getCenterLonLat();var distance=(Math.sqrt(Math.pow((cc.lon-fc.lon),2)+Math.pow((cc.lat-fc.lat),2))/this.resolution);return(distance<=this.distance);},addToCluster:function(cluster,feature){cluster.cluster.push(feature);cluster.attributes.count+=1;},createCluster:function(feature){var center=feature.geometry.getBounds().getCenterLonLat();var cluster=new OpenLayers.Feature.Vector(new OpenLayers.Geometry.Point(center.lon,center.lat),{count:1});cluster.cluster=[feature];cluster.fid='cluster_'+this.clusterId;++this.clusterId;return cluster;},_isEligibleFeature:function(feature){var eligible=true;if(!this.disableDynamicClustering){eligible=false;if(feature.geometry.CLASS_NAME.indexOf('Point')>=0){eligible=true;}else if(feature.geometry.CLASS_NAME.indexOf('Line')>=0){var bounds=feature.geometry.getBounds();var xLen=(bounds.right-bounds.left)/this.resolution;var yLen=(bounds.top-bounds.bottom)/this.resolution;if((xLen)<this.minimumLinePixelSize&&(yLen)<this.minimumLinePixelSize){eligible=true;};}else if(feature.geometry.CLASS_NAME.indexOf('Polygon')>=0){var bounds=feature.geometry.getBounds();var xLen=(bounds.right-bounds.left)/this.resolution;var yLen=(bounds.top-bounds.bottom)/this.resolution;if((xLen)<this.minimumPolygonPixelSize&&(yLen)<this.minimumPolygonPixelSize){eligible=true;};};}else if(this.clusterPointsOnly){eligible=false;if(feature.geometry.CLASS_NAME.indexOf('Point')>=0){eligible=true;};};return eligible;},CLASS_NAME:"OpenLayers.Strategy.NunaliitCluster"});};})(jQuery,nunaliit2);;(function($,$n2){$n2.SLIDER_CONSTANTS={};$n2.SLIDER_CONSTANTS.NUMERIC='numeric';$n2.SLIDER_CONSTANTS.DATE='date';$n2.SLIDER_CONSTANTS.DURATION_DAY=1000*60*60*24;$n2.SLIDER_CONSTANTS.DURATION_WEEK=$n2.SLIDER_CONSTANTS.DURATION_DAY*7;$n2.SLIDER_CONSTANTS.DURATION_YEAR=$n2.SLIDER_CONSTANTS.DURATION_DAY*365;var SLIDER_MIN=0;var SLIDER_STEP=1;var defaultOptions={containerId:'',idBase:'',valueType:$n2.SLIDER_CONSTANTS.NUMERIC,min:null,max:null,step:null,initial:null,range:false,format:'%d'};numericValueHandler=$n2.Class({options:null,initialize:function(opt){this.options=$.extend({},opt);},convertSliderValueToDomain:function(v){return(this.options.min+((v-SLIDER_MIN)*this.options.step));},convertDomainValueToSlider:function(v){return(Math.floor((v-this.options.min)/this.options.step));},toString:function(value){var target=this.options.format.slice(0);return($.format(target,[value]));},domainMaxToSliderMax:function(v){return(this.convertDomainValueToSlider(v));},equals:function(v1,v2){return(v1==v2);}});dateValueHandler=$n2.Class({options:null,initialize:function(opt){this.options=$.extend({},opt);},convertSliderValueToDomain:function(v){var newDate=new Date(this.options.min);var diff=(v-SLIDER_MIN)*this.options.step;newDate.setMilliseconds(newDate.getMilliseconds()+diff);return newDate;},convertDomainValueToSlider:function(v){return(Math.floor((v-this.options.min)/this.options.step));},toString:function(value){var target=this.options.format.slice(0);return($.datepicker.formatDate(target,value));},domainMaxToSliderMax:function(v){return(this.convertDomainValueToSlider(v));},equals:function(v1,v2){return(v1.valueOf()==v2.valueOf());}});var sliderBase=$n2.Class({options:null,configuredValue:null,valueHandler:null,computedSliderProperties:null,initialize:function(){this.options=$.extend({},defaultOptions);for(var i=0;i<arguments.length;i++){var o=arguments[i];if($n2.isDefined(o)){this.options=$.extend(true,this.options,o);};};if($n2.SLIDER_CONSTANTS.DATE==this.options.valueType){this.valueHandler=new dateValueHandler({min:this.options.min,max:this.options.max,step:this.options.step,format:this.options.format});}else{this.valueHandler=new numericValueHandler({min:this.options.min,max:this.options.max,step:this.options.step,format:this.options.format});};var prop={};prop.min=SLIDER_MIN;prop.step=SLIDER_STEP;prop.max=this.valueHandler.domainMaxToSliderMax(this.options.max);this.computedSliderProperties=prop;},changeFn:function(){},latestValue:function(){return($n2.isDefined(this.configuredValue)?this.configuredValue:this.options.initial);},_computeCallOutLeftValue:function(newVal){var percentage=(newVal-this.computedSliderProperties.min)/(this.computedSliderProperties.max-this.computedSliderProperties.min)*100;return(percentage);},_setText:function(t1,t2,value){var t=this.valueHandler.toString(value);var l=Math.floor(t.length/2);var a=new Array();var tt;if(l>0){tt=t.slice(0,l);var lastCharIndex=tt.length-1;if(tt[lastCharIndex]==' '){tt=tt.slice(0,-1)+'&nbsp;';};a.push(tt);}else{a.push('');};if((t.length-l)>0){tt=t.slice(l);if(tt[0]==' '){tt='&nbsp;'+tt.slice(1);}
a.push(tt);}else{a.push('');};$(t1).text(a[0]);$(t2).text(a[1]);},_callout_hideImmed:function(t1,t2){$(t1).hide();$(t2).hide();},_callout_fadeIn:function(t1,t2){$(t1).fadeIn('fast',function(){});$(t2).fadeIn('fast',function(){});},_callout_fadeOut:function(t1,t2,fn){$(t1).fadeOut('slow',function(){});$(t2).fadeOut('slow',fn);},_createHtml:function(){var container=$('#'+this.options.containerId).empty();var slider=$('<div>').addClass('slider_wrapper slider_wrapper_callout').appendTo(container);var sliderCallout=$('<div>').attr('id',this.options.idBase+'_callout').addClass('slider_callout').attr('style','width:0px;height:0px;padding:0px;margin:0px;border:none').appendTo(slider);$('<div>').attr('id',this.options.idBase).addClass('slider_bar').appendTo(slider);$('<div>').attr('id',this.options.idBase+'_calloutTextLeft').addClass('slider_callout_text_left').attr('style','position:absolute;right:0px;bottom:0px;text-align:right;').appendTo(sliderCallout);$('<div>').attr('id',this.options.idBase+'_calloutTextRight').addClass('slider_callout_text_right').attr('style','position:absolute;left:0px;bottom:0px;text-align:left;').appendTo(sliderCallout);return slider;},create:function(){var _self=this;var slider=this._createHtml();var c='#'+this.options.idBase+'_callout';var t1='#'+this.options.idBase+'_calloutTextLeft';var t2='#'+this.options.idBase+'_calloutTextRight';var calloutVisible=false;this._callout_hideImmed(t1,t2);var sliderOpts={min:this.computedSliderProperties.min,max:this.computedSliderProperties.max,step:this.computedSliderProperties.step,start:function(e,ui){var i=_self._positionCalloutForUpdate(c,ui);if(i>=0){calloutVisible=true;_self._callout_fadeIn(t1,t2);};},slide:function(e,ui){var i=_self._positionCalloutUpdateText(c,t1,t2,ui);if(false==calloutVisible&&i>=0){calloutVisible=true;_self._callout_fadeIn(t1,t2);}
_self._storeUpdateAndNotify(ui);},change:function(e,ui){var i=_self._positionCalloutUpdateText(c,t1,t2,ui);if(false==calloutVisible&&i>=0){calloutVisible=true;_self._callout_fadeIn(t1,t2);};if(true==calloutVisible){_self._callout_fadeOut(t1,t2,function(){calloutVisible=false;});}
_self._storeUpdateAndNotify(ui);}};if(false==this.options.range){sliderOpts.value=this.valueHandler.convertDomainValueToSlider(this.latestValue());}else if('min'==this.options.range||'max'==this.options.range){sliderOpts.range=this.options.range;sliderOpts.value=this.valueHandler.convertDomainValueToSlider(this.latestValue());}else if(true==this.options.range){sliderOpts.range=true;var l=this.latestValue();sliderOpts.values=[this.valueHandler.convertDomainValueToSlider(l[0]),this.valueHandler.convertDomainValueToSlider(l[1])];};$('#'+this.options.idBase).slider(sliderOpts);}});$n2.SingleHandleSliderWithCallout=$n2.Class(sliderBase,{setConfiguredValue:function(newValue){this.configuredValue=newValue;},getCurrentValue:function(){return(this.latestValue());},programmedUpdate:function(newValue){this.setConfiguredValue(newValue);$('#'+this.options.idBase).slider('value',this.valueHandler.convertDomainValueToSlider(this.latestValue()));},_positionCalloutForUpdate:function(c,ui){$(c).css('left',this._computeCallOutLeftValue(ui.value)+'%');return 0;},_positionCalloutUpdateText:function(c,t1,t2,ui){this._positionCalloutForUpdate(c,ui);this._setText(t1,t2,this.valueHandler.convertSliderValueToDomain(ui.value));return 0;},_storeUpdateAndNotify:function(ui){var newValue=this.valueHandler.convertSliderValueToDomain(ui.value);if(newValue!=this.configuredValue){this.configuredValue=newValue;this.options.changeFn(newValue);};}});$n2.RangeSliderWithCallout=$n2.Class(sliderBase,{setConfiguredValue:function(newValues){this.configuredValue=newValues;},getCurrentValue:function(){return(this.latestValue());},programmedUpdate:function(newValues){this.setConfiguredValue(newValues);var lower=this.valueHandler.convertDomainValueToSlider(newValues[0]);var upper=this.valueHandler.convertDomainValueToSlider(newValues[1]);$('#'+this.options.idBase).slider('values',[lower,upper]);},_whichIsChanging:function(ui){var old=this.latestValue();var convertedUi=[this.valueHandler.convertSliderValueToDomain(ui.values[0]),this.valueHandler.convertSliderValueToDomain(ui.values[1])];if(this.valueHandler.equals(old[0],convertedUi[0])&&this.valueHandler.equals(old[1],convertedUi[1])){return-1;};return(this.valueHandler.equals(old[0],convertedUi[0])?1:0);},_positionCalloutForUpdate:function(c,ui){var index=this._whichIsChanging(ui);if(index>=0){$(c).css('left',this._computeCallOutLeftValue(ui.values[index])+'%');};return index;},_positionCalloutUpdateText:function(c,t1,t2,ui){var index=this._positionCalloutForUpdate(c,ui);if(index>=0){this._setText(t1,t2,this.valueHandler.convertSliderValueToDomain(ui.values[index]));};return index;},_storeUpdateAndNotify:function(ui){var newValues=[this.valueHandler.convertSliderValueToDomain(ui.values[0]),this.valueHandler.convertSliderValueToDomain(ui.values[1])];if(!isDefined(this.configuredValue)||!this.valueHandler.equals(newValues[0],this.configuredValue[0])||!this.valueHandler.equals(newValues[1],this.configuredValue[1])){this.configuredValue=newValues;this.options.changeFn(newValues);};}});})(jQuery,nunaliit2);;(function($,$n2){var DAY_MS=1000*60*60*24;$n2.TIMELINE_DATE_MARKS_Durations_DAY=DAY_MS;$n2.TIMELINE_DATE_MARKS_Durations_WEEK=DAY_MS*7;$n2.TIMELINE_DATE_MARKS_Durations_YEAR=DAY_MS*365;var defaultOptions={containerId:'',idBase:'',min:null,max:null,base:$n2.TIMELINE_DATE_MARKS_Durations_WEEK,steps:null,format:'M d'};function range(min,max){return(Math.floor((max-min)/DAY_MS));};var debugDateFormat='yy-mm-dd';function dateAsString(f,d){var target=f.slice(0);return($.datepicker.formatDate(target,d));};function computeDatesArray(min,max,base,steps){function pkg(d,l){return{date:d,labelled:l};};var days=range(min,max);if(0>=steps){$n2.log('$n2.TimelineDateMarks: invalid steps value: '+steps);};if(0>=base){$n2.log('$n2.TimelineDateMarks: invalid base value: '+base);};if(0>=days){$n2.log('$n2.TimelineDateMarks: invalid date range: '+
dateAsString(debugDateFormat,min)+' : '+
dateAsString(debugDateFormat,max));};var baseUnits=Math.floor((days*DAY_MS)/base);var multiples=Math.floor(baseUnits/steps);var inc,labelInc;if(multiples<1){inc=base;labelInc=1;if(baseUnits<1){inc=DAY_MS;labelInc=Math.floor(days/steps);}}else{inc=base;labelInc=multiples;}
var dates=[];dates.push(pkg(new Date(min),true));var tempDate=new Date(min);var dec=labelInc;while(tempDate<max){tempDate.setMilliseconds(tempDate.getMilliseconds()+inc);if(tempDate<max){var label=false;if(--dec==0){if(labelInc<=1){label=true;}else{var adjustedCheck=Math.floor(0.75*labelInc);if((max-tempDate)>=(adjustedCheck*inc)){label=true;}}};if(label){dates.push(pkg(new Date(tempDate),true));}else{dates.push(pkg(new Date(tempDate),false));}
if(dec<=0){dec=labelInc;}}else{dates.push(pkg(new Date(max),true));};};return dates;};function computeLeftValue(d,min,max){var percentage=(d-min)/(max-min)*100;return(percentage);}
function splitText(txt){var l=Math.floor(txt.length/2);var a=new Array();var tt;if(l>0){tt=txt.slice(0,l);var lastCharIndex=tt.length-1;if(tt[lastCharIndex]==' '){tt=tt.slice(0,-1)+'&nbsp;';};a.push(tt);}else{a.push('');};if((txt.length-l)>0){tt=txt.slice(l);if(tt[0]==' '){tt='&nbsp;'+tt.slice(1);}
a.push(tt);}else{a.push('');};return a;}
function addLabel(wrapper,lft,txt,lFlag){var labelPosition=$('<div class="TimelineDateMarks_label" '+'style="width:0px;padding:0px;margin:0px;border:none"></div>');wrapper.append(labelPosition);$(labelPosition).css('left',lft+'%');if(lFlag){var txtArray=splitText(txt);labelPosition.append('<div class="TimelineDateMarks_labelLeft" '+'style="position:absolute;right:0px;bottom:0px;text-align:right;">'+
txtArray[0]+'</div>'+'<div class="TimelineDateMarks_labelRight" '+'style="position:absolute;left:0px;bottom:0px;text-align:left;">'+
txtArray[1]+'</div>');}
labelPosition.append('<div class="TimelineDateMarks_labelTick '+
(lFlag?'TimelineDateMarks_labelTick_large':'TimelineDateMarks_labelTick_small')+'" '+'style="position:absolute;left:0px;bottom:0px;text-align:left;">|</div>');}
$n2.TimelineDateMarks=$n2.Class({options:null,dates:null,initialize:function(){this.options=$.extend({},defaultOptions);for(var i=0;i<arguments.length;i++){var o=arguments[i];if($n2.isDefined(o)){this.options=$.extend(true,this.options,o);};};if($n2.isDefined(this.options.min)&&$n2.isDefined(this.options.max)&&$n2.isDefined(this.options.base)&&$n2.isDefined(this.options.steps)){this.dates=computeDatesArray(this.options.min,this.options.max,this.options.base,this.options.steps);}},setDateRangeParms:function(min,max,base,steps){this.options.min=min;this.options.max=max;this.options.base=base;this.options.steps=steps;this.dates=computeDatesArray(this.options.min,this.options.max,this.options.base,this.options.steps);},draw:function(){var wrapper=$('<div class="TimelineDateMarks_wrapper"></div>');$('#'+this.options.containerId).empty().append(wrapper);for(var i=0;i<this.dates.length;i++){var d=this.dates[i];var lft=computeLeftValue(d.date,this.options.min,this.options.max);if(d.labelled){addLabel(wrapper,lft,dateAsString(this.options.format,d.date),true);}else{addLabel(wrapper,lft,'',false);}};}});})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var ProgressKeyCache=$n2.Class({options:null,progressKeyCache:null,initialize:function(options_){this.options=options_;this.progressKeyCache=[];},getKey:function(callback){var key=this.progressKeyCache.shift();if(key){callback(key);}else{this.refresh(callback);}},refresh:function(callback){var cache=this;$.ajax({url:this.options.url+'getIds',type:'get',async:true,data:{count:20},dataType:'json',success:function(res){if(res&&res.progressIds){var key;while(key=res.progressIds.shift()){cache.progressKeyCache.push(key);};var id=cache.progressKeyCache.shift();if(id)callback(id);}else{cache.options.onError(_loc('Error occurred with progress service'));$n2.log('Progress service did not return any results');};},error:function(XMLHttpRequest,textStatus,errorThrown){cache.options.onError(_loc('Error occurred with progress service'));$n2.log('Progress service returned error',textStatus,errorThrown);}});}});var nextProgressTrackerId=0;var ProgressTrackerDefaultOptions={progressKey:null,onStart:function(tracker){},onUpdate:function(tracker){},onComplete:function(tracker){},onRemove:function(tracker){}};var ProgressTracker=$n2.Class({options:null,id:null,progressServer:null,progressKey:null,startSent:false,completedSent:false,info:{count:0,total:0,completed:false},initialize:function(progressServer,options_){this.progressServer=progressServer;this.options=options_;this.id='progressTracker'+nextProgressTrackerId;++nextProgressTrackerId;},getId:function(){return this.id;},getProgressKey:function(){return this.options.progressKey;},cancel:function(){this.progressServer._unregisterProgressTracker(this);},getTotal:function(){return this.info.total;},getCurrent:function(){return this.info.current;},isCompleted:function(){return this.info.completed;},_update:function(info){this.info=info;if(this.completedSent)return;if(false==this.startSent){this.options.onStart(this);this.startSent=true;}
this.options.onUpdate(this);if(info.completed){this.options.onComplete(this);this.completedSent=true;}}});var ProgressServerDefaultOptions={url:null,pollingIntervalInMs:750,onError:function(str){$n2.reportError(str);}};var ProgressServer=$n2.Class({options:null,progressKeyCache:null,progressTrackers:null,pollingInProgress:false,initialize:function(options_){this.options=$n2.extend({},ProgressServerDefaultOptions,options_);this.progressKeyCache=new ProgressKeyCache(this.options);this.progressTrackers={};},requestProgressKey:function(callback){this.progressKeyCache.getKey(callback);},createProgressTracker:function(options_){var opts=$n2.extend({},ProgressTrackerDefaultOptions,options_);if(!opts.progressKey){return null;}
var progressTracker=new ProgressTracker(this,opts);this._registerProgressTracker(progressTracker);return progressTracker;},_registerProgressTracker:function(progressTracker){var progressKey=progressTracker.getProgressKey();var progressTrackerId=progressTracker.getId();var keyTrackers=this.progressTrackers[progressKey];if(!keyTrackers){keyTrackers={};this.progressTrackers[progressKey]=keyTrackers;}
var tracker=keyTrackers[progressTrackerId];if(!tracker){keyTrackers[progressTrackerId]=progressTracker;}
this._initiatePolling();},_unregisterProgressTracker:function(progressTracker){var progressKey=progressTracker.getProgressKey();var progressTrackerId=progressTracker.getId();var keyTrackers=this.progressTrackers[progressKey];if(!keyTrackers){return;}
var tracker=keyTrackers[progressTrackerId];if(tracker){delete keyTrackers[progressTrackerId];}
var count=0;for(var trackerId in keyTrackers){++count;};if(count<1){delete this.progressTrackers[progressKey];};},_initiatePolling:function(){if(this.pollingInProgress)return;var keys=[];for(var key in this.progressTrackers){keys.push(key);}
if(keys.length<1)return;var server=this;$.ajax({url:this.options.url+'getProgresses',type:'get',async:true,traditional:true,data:{progressId:keys},dataType:'json',success:function(data){if(server._processProgressResults(data)){setTimeout(function(){server._initiatePolling();},server.options.pollingIntervalInMs);}else{server.pollingInProgress=false;};},error:function(XMLHttpRequest,textStatus,errorThrown){server.pollingInProgress=false;server.options.onError(_loc('Error occurred with progress service'));$n2.log('Progress service returned error on getProgresses',textStatus,errorThrown);}});},_processProgressResults:function(data){var trackingInProgress=false;if(data&&data.results){var trackersToUnregister=[];var reportedKeys={};for(var i=0,e=data.results.length;i<e;++i){var info=data.results[i];var key=info.id;reportedKeys[key]=info;var trackers=this.progressTrackers[key];if(trackers){for(var trackerId in trackers){var tracker=trackers[trackerId];if(tracker){tracker._update(info);if(info.completed){trackersToUnregister.push(tracker);}else{trackingInProgress=true;};};};};};for(var i=0,e=trackersToUnregister.length;i<e;++i){var tracker=trackersToUnregister[i];this._unregisterProgressTracker(tracker);};if(!trackingInProgress){for(var key in this.progressTrackers){var trackers=this.progressTrackers[key];if(trackers){for(var trackerId in trackers){if(!reportedKeys[key]){trackingInProgress=true;}};};};};};return trackingInProgress;}});$n2.progress={ProgressServer:ProgressServer};})(jQuery,nunaliit2);(function($){var uniqueId=0;var polling=false;var progressKeyCache=[];var trackedKeys={};var trackerElements=[];var getId=function(){var result='progress_id_'+uniqueId;++uniqueId;return result;}
var refreshProgressKeyCache=function(callback){$.get("progress/getIds?count=5",function(data){if(!data){if(window.console&&window.console.log)window.console.log('No data returned by progress service');return;}
var response;eval("response = "+data);if(!response){if(window.console&&window.console.log)window.console.log('No response returned by progress service');return;}
if(response.progressIds){var key;while(key=response.progressIds.shift()){progressKeyCache.push(key);}}
if(callback){var id=progressKeyCache.shift();if(id)callback(id);}});};var onStartDefault=function(keyInfo,options){var key=options.id+'_'+keyInfo.key;var elem=$('<div id="progress_'+key+'">'+'<div id="progressbar_'+key+'"></div>'+'<div>'+'<span class="progress-x" id="progressa_'+key+'">X</span>'+keyInfo.desc+'<span id="progresstext_'+key+'">Starting...</span>'+'</div>'+'</div>');var parent=$('#'+options.trackerId);elem.appendTo(parent);$('#progressbar_'+key).progressbar();$('#progressa_'+key).click(function(evt){$.progress.removeDisplayOn(keyInfo.key);return false;});};var onCompleteDefault=function(keyInfo,options){var key=options.id+'_'+keyInfo.key;$('#progressbar_'+key).progressbar('value',100);$('#progresstext_'+key).text('Done.');};var onUpdateDefault=function(keyInfo,options){var key=options.id+'_'+keyInfo.key;$('#progressbar_'+key).progressbar('value',keyInfo.value);$('#progresstext_'+key).text(''+keyInfo.value+'%');};var onRemoveDefault=function(key,options){var key=options.id+'_'+key;$('#progress_'+key).remove();};var createActivity=function(keyInfo,trackerOptions){if(trackerOptions.onStart){trackerOptions.onStart(keyInfo,trackerOptions);}}
var updateActivity=function(keyInfo,trackerOptions){if(trackerOptions.onUpdate){trackerOptions.onUpdate(keyInfo,trackerOptions);}}
var forEachTracker=function(callback){var loop;for(loop=0;loop<trackerElements.length;++loop){var trackerOptions=trackerElements[loop];callback(trackerOptions);};};var forEachActivity=function(callback){for(var activityKey in trackedKeys){var keyInfo=trackedKeys[activityKey];callback(activityKey,keyInfo);};};var pollProgress=function(){var params=null;for(var key in trackedKeys){if(!params){params='?progressId='+key;}else{params+='&progressId='+key;}}
if(!params){polling=false;return;};var trackerDisplayed=false;forEachTracker(function(trackerOptions){trackerDisplayed=true;});if(!trackerDisplayed){polling=false;return;};polling=true;$.get('progress/getProgresses'+params,function(data){if(!data){if(window.console&&window.console.log)window.console.log('No data');polling=false;return;}
var response;eval('response = '+data);if(!response){if(window.console&&window.console.log)window.console.log('Empty response');polling=false;return;}
var array=response.results;while(array.length>0){var info=array.shift();var key=info.id;var total=1*info.total;var current=1*info.current;var percentage=0;if(0!=total){percentage=Math.floor(100*current/total);}
if(info.chained){var chainedInfos=info.chained;for(var loop=0;loop<chainedInfos.length;++loop){var chainedInfo=chainedInfos[loop];if(!trackedKeys[chainedInfo.id]){$.progress.startProgressTrackingOn(chainedInfo.id,chainedInfo.description);}}}
var keyInfo=trackedKeys[key];if(keyInfo){if(keyInfo.value==percentage){keyInfo.duplicates=keyInfo.duplicates+1;}else{keyInfo.duplicates=0;};keyInfo.value=percentage;if(info.data){keyInfo.data=info.data;}
forEachTracker(function(trackerOptions){updateActivity(keyInfo,trackerOptions);});if(info.completed){keyInfo.completed=true;$.progress.stopProgressTrackingOn(key);}else if(keyInfo.duplicates>15){$.progress.stopProgressTrackingOn(key);};}}
setTimeout(pollProgress,750);});};$.progress={getProgressKey:function(callback){var key=progressKeyCache.shift();if(key){callback(key);}else{refreshProgressKeyCache(callback);}},startProgressTrackingOn:function(key,desc){var keyInfo=trackedKeys[key]={value:0,key:key,desc:desc,duplicates:0};forEachTracker(function(trackerOptions){createActivity(keyInfo,trackerOptions);});if(!polling){pollProgress();}},stopProgressTrackingOn:function(key){var keyInfo=trackedKeys[key];if(keyInfo){forEachTracker(function(trackerOptions){if(trackerOptions.onComplete){trackerOptions.onComplete(keyInfo,trackerOptions);}});delete trackedKeys[key];}},removeDisplayOn:function(key){$.progress.stopProgressTrackingOn(key);forEachTracker(function(trackerOptions){if(trackerOptions.onRemove){trackerOptions.onRemove(key,trackerOptions);}});},progressTrackerDefaultOptions:{onStart:onStartDefault,onUpdate:onUpdateDefault,onComplete:onCompleteDefault,onRemove:onRemoveDefault},addProgressTracker:function(trackerOptions){var options=$.extend({},$.progress.progressTrackerDefaultOptions,trackerOptions);trackerElements.push(options);forEachActivity(function(activityKey,keyInfo){createActivity(keyInfo,options);updateActivity(keyInfo,options);});if(!polling){pollProgress();};}};$.fn.progressTracker=function(options_){return this.each(function(){var self=this;var id=getId();var tracker=$('<div id="'+id+'"></div>').appendTo(this);options_.trackerId=id;$.progress.addProgressTracker(options_);});};var installButton=function(elem,currentButton,key,options){var button=$('<input type="button" value="'+options.message+'">');button.click(function(evt){options.onClick(elem,key);setTimeout(function(){$.progress.getProgressKey(function(newKey){installButton(elem,button,newKey,options);});},0);});if(currentButton){currentButton.after(button);currentButton.remove();}else{$(elem).append(button);}};var keyedButtonDefaultOptions={onClick:function(){},message:"OK"};$.fn.keyedButton=function(options_){return this.each(function(){var options=$.extend({},keyedButtonDefaultOptions,options_);var self=this;$.progress.getProgressKey(function(key){installButton(self,null,key,options);});});};})(jQuery);(function($){function CreateHolder(){var $holder=$('#progress-slider');if($holder.size()===0){$holder=$('<div id="progress-slider" class="prog-holder">'+'<div id="progress-slider-background" class="prog-background" style="position:absolute;top:0px;left:0px;width:100%;height:100%;">'+'</div>'+'</div>');$(document.body).append($holder);}
var $holder=$('#progress-slider');};function PutAway(elemId){var elem=$('#'+elemId);elem.animate({left:"0px",bottom:"0px"},function(){elem.one('click',function(){PutUp(elemId);});elem.attr('prog-slider-viewed',0);CheckReadyRemove(elemId);});};function Close(elemId){var $downElem=$('#'+elemId+'_down');if($downElem.size()>0){$downElem.slideUp(function(){PutAway(elemId);});}else{PutAway(elemId);}};function PutUp(elemId){var elem=$('#'+elemId);var win=$(window);var screenCenterX=win.width()/2;var screenCenterY=win.height()/2;var elemOffset=elem.offset();var elemWidth=elem.width();var elemHeight=elem.height();var elemFinalPosX=Math.floor(screenCenterX-(elemWidth/2));var elemFinalPosY=Math.floor(screenCenterY-(elemHeight/2));elem.attr('prog-slider-viewed',1);elem.animate({left:''+elemFinalPosX+'px',bottom:''+elemFinalPosY+'px'},function(){Open(elemId);});};function Open(elemId){var elem=$('#'+elemId);elem.one("click",function(){Close(elemId);});$('#'+elemId+'_down').slideDown();};function AddBar(id,description){CreateHolder();var newBar=$('<div id="'+id+'" title="'+description+'" class="prog-moveBar" style="position:relative;left:0px;bottom:0px;">'+'<div id="'+id+'_value" class="prog-moveBar-colour" style="width:0%"></div>'+'<div id="'+id+'_down" style="position:absolute;display:none;left:-200px;top:-2px;width:600px;margin:0px;background:#ffffff;border:1px solid #000000">'+'<div id="'+id+'_value2" class="prog-moveBar-colour" style="width:0%"></div>'+'<table class="prog-description-table"><tr><th>Description:</th><td id="'+id+'_description">'+description+'</td></tr>'+'<tr><th>Progress:</th><td id="'+id+'_percent"></td></tr>'+'<tr><th></th><td><a id="'+id+'_cancel" href="#">Cancel Reporting</a></td></tr></table>'+'</div>'+'</div>');$('#progress-slider-background').after(newBar);$('#'+id+'_cancel').click(function(evt){RemoveBar(id);return false;});newBar.one('click',function(){PutUp(id);});newBar.attr('prog-slider-viewed',0);return id;}
function RemoveBar(elemId){var $elem=$('#'+elemId);$elem.slideUp(function(){$elem.remove();});}
function SetValue(elemId,percent){if(percent>100)percent=100;if(percent<0)percent=0;$('#'+elemId+'_value').css({width:''+percent+'%'});$('#'+elemId+'_value2').css({width:''+percent+'%'});$('#'+elemId+'_percent').text(''+percent+'%');}
function CheckReadyRemove(elemId){var $elem=$('#'+elemId);if($elem.size()>0){var ready=1*$elem.attr('prog-slider-ready-remove');var viewed=1*$elem.attr('prog-slider-viewed');if(ready&&!viewed){RemoveBar(elemId);};};}
var onStartDefault=function(keyInfo,options){var key='prog-slider_'+keyInfo.key;AddBar(key,keyInfo.desc);};var onCompleteDefault=function(keyInfo,options){var key='prog-slider_'+keyInfo.key;SetValue(key,100);$('#'+key+'_percent').text('Done');$('#'+key).attr('title',keyInfo.desc+'. Done.');$('#'+key).attr('prog-slider-stopped',1).attr('prog-slider-ready-remove',0);setTimeout(function(){$('#'+key).attr('prog-slider-ready-remove',1);CheckReadyRemove(key);},5000);};var onUpdateDefault=function(keyInfo,options){var key='prog-slider_'+keyInfo.key;SetValue(key,keyInfo.value);$('#'+key).attr('title',keyInfo.desc+' ('+keyInfo.value+'%)');};var onRemoveDefault=function(key,options){var key='prog-slider_'+key;RemoveBar(key);};if($.progress&&$.progress.addProgressTracker){var trackerOptions={onStart:onStartDefault,onUpdate:onUpdateDefault,onComplete:onCompleteDefault,onRemove:onRemoveDefault};$.progress.addProgressTracker(trackerOptions);};})(jQuery);var JSON;if(!JSON){JSON={};}
(function(){"use strict";function f(n){return n<10?'0'+n:n;}
if(typeof Date.prototype.toJSON!=='function'){Date.prototype.toJSON=function(key){return isFinite(this.valueOf())?this.getUTCFullYear()+'-'+
f(this.getUTCMonth()+1)+'-'+
f(this.getUTCDate())+'T'+
f(this.getUTCHours())+':'+
f(this.getUTCMinutes())+':'+
f(this.getUTCSeconds())+'Z':null;};String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(key){return this.valueOf();};}
var cx=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,escapable=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,gap,indent,meta={'\b':'\\b','\t':'\\t','\n':'\\n','\f':'\\f','\r':'\\r','"':'\\"','\\':'\\\\'},rep;function quote(string){escapable.lastIndex=0;return escapable.test(string)?'"'+string.replace(escapable,function(a){var c=meta[a];return typeof c==='string'?c:'\\u'+('0000'+a.charCodeAt(0).toString(16)).slice(-4);})+'"':'"'+string+'"';}
function str(key,holder){var i,k,v,length,mind=gap,partial,value=holder[key];if(value&&typeof value==='object'&&typeof value.toJSON==='function'){value=value.toJSON(key);}
if(typeof rep==='function'){value=rep.call(holder,key,value);}
switch(typeof value){case'string':return quote(value);case'number':return isFinite(value)?String(value):'null';case'boolean':case'null':return String(value);case'object':if(!value){return'null';}
gap+=indent;partial=[];if(Object.prototype.toString.apply(value)==='[object Array]'){length=value.length;for(i=0;i<length;i+=1){partial[i]=str(i,value)||'null';}
v=partial.length===0?'[]':gap?'[\n'+gap+partial.join(',\n'+gap)+'\n'+mind+']':'['+partial.join(',')+']';gap=mind;return v;}
if(rep&&typeof rep==='object'){length=rep.length;for(i=0;i<length;i+=1){k=rep[i];if(typeof k==='string'){v=str(k,value);if(v){partial.push(quote(k)+(gap?': ':':')+v);}}}}else{for(k in value){if(Object.hasOwnProperty.call(value,k)){v=str(k,value);if(v){partial.push(quote(k)+(gap?': ':':')+v);}}}}
v=partial.length===0?'{}':gap?'{\n'+gap+partial.join(',\n'+gap)+'\n'+mind+'}':'{'+partial.join(',')+'}';gap=mind;return v;}}
if(typeof JSON.stringify!=='function'){JSON.stringify=function(value,replacer,space){var i;gap='';indent='';if(typeof space==='number'){for(i=0;i<space;i+=1){indent+=' ';}}else if(typeof space==='string'){indent=space;}
rep=replacer;if(replacer&&typeof replacer!=='function'&&(typeof replacer!=='object'||typeof replacer.length!=='number')){throw new Error('JSON.stringify');}
return str('',{'':value});};}
if(typeof JSON.parse!=='function'){JSON.parse=function(text,reviver){var j;function walk(holder,key){var k,v,value=holder[key];if(value&&typeof value==='object'){for(k in value){if(Object.hasOwnProperty.call(value,k)){v=walk(value,k);if(v!==undefined){value[k]=v;}else{delete value[k];}}}}
return reviver.call(holder,key,value);}
text=String(text);cx.lastIndex=0;if(cx.test(text)){text=text.replace(cx,function(a){return'\\u'+
('0000'+a.charCodeAt(0).toString(16)).slice(-4);});}
if(/^[\],:{}\s]*$/.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,'@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,']').replace(/(?:^|:|,)(?:\s*\[)+/g,''))){j=eval('('+text+')');return typeof reviver==='function'?walk({'':j},''):j;}
throw new SyntaxError('JSON.parse');};}}());(function($)
{$.Cometd=function(name)
{var _name=name||'default';var _logPriorities={debug:1,info:2,warn:3,error:4};var _logLevel='info';var _url;var _xd=false;var _transport;var _status='disconnected';var _messageId=0;var _clientId=null;var _batch=0;var _messageQueue=[];var _listeners={};var _backoff=0;var _backoffIncrement=1000;var _maxBackoff=60000;var _scheduledSend=null;var _extensions=[];var _advice={};var _handshakeProps;this.getName=function()
{return _name;};this.configure=function(cometURL)
{_configure(cometURL);};function _configure(cometURL)
{_url=cometURL;_debug('Initializing comet with url: {}',_url);var urlParts=/(^https?:)?(\/\/(([^:\/\?#]+)(:(\d+))?))?([^\?#]*)/.exec(cometURL);if(urlParts[3])_xd=urlParts[3]!=location.host;if(_xd)
_transport=newCallbackPollingTransport();else
_transport=newLongPollingTransport();_debug('Initial transport is {}',_transport.getType());};this.init=function(cometURL,handshakeProps)
{_configure(cometURL);_handshake(handshakeProps);};this.handshake=function(handshakeProps)
{_handshake(handshakeProps);};this.disconnect=function(disconnectProps)
{var bayeuxMessage={channel:'/meta/disconnect'};var message=$.extend({},disconnectProps,bayeuxMessage);_setStatus('disconnecting');_deliver([message],false);};this.startBatch=function()
{_startBatch();};this.endBatch=function()
{_endBatch(true);};this.subscribe=function(channel,scope,callback,subscribeProps)
{var subscription=this.addListener(channel,scope,callback);var bayeuxMessage={channel:'/meta/subscribe',subscription:channel};var message=$.extend({},subscribeProps,bayeuxMessage);_send(message);return subscription;};this.unsubscribe=function(subscription,unsubscribeProps)
{this.removeListener(subscription);var bayeuxMessage={channel:'/meta/unsubscribe',subscription:subscription[0]};var message=$.extend({},unsubscribeProps,bayeuxMessage);_send(message);};this.publish=function(channel,content,publishProps)
{var bayeuxMessage={channel:channel,data:content};var message=$.extend({},publishProps,bayeuxMessage);_send(message);};this.addListener=function(channel,scope,callback)
{if(!callback)
{callback=scope;scope=undefined;}
var subscription={scope:scope,callback:callback};var subscriptions=_listeners[channel];if(!subscriptions)
{subscriptions=[];_listeners[channel]=subscriptions;}
var subscriptionIndex=subscriptions.push(subscription)-1;_debug('Added listener: channel \'{}\', callback \'{}\', index {}',channel,callback.name,subscriptionIndex);return[channel,subscriptionIndex];};this.removeListener=function(subscription)
{var subscriptions=_listeners[subscription[0]];if(subscriptions)
{delete subscriptions[subscription[1]];_debug('Removed listener: channel \'{}\', index {}',subscription[0],subscription[1]);}};this.clearListeners=function()
{_listeners={};};this.getStatus=function()
{return _status;};this.setBackoffIncrement=function(period)
{_backoffIncrement=period;};this.getBackoffIncrement=function()
{return _backoffIncrement;};this.getBackoffPeriod=function()
{return _backoff;};this.setLogLevel=function(level)
{_logLevel=level;};this.registerExtension=function(name,extension)
{var existing=false;$.each(_extensions,function(index,extension)
{if(extension.name==name)
{existing=true;return false;}});if(!existing)
{_extensions.push({name:name,extension:extension});_debug('Registered extension \'{}\'',name);return true;}
else
{_info('Could not register extension with name \'{}\': another extension with the same name already exists');return false;}};this.unregisterExtension=function(name)
{var unregistered=false;$.each(_extensions,function(index,extension)
{if(extension.name==name)
{_extensions.splice(index,1);unregistered=true;_debug('Unregistered extension \'{}\'',name);return false;}});return unregistered;};function _resubscribe()
{for(var channel in _listeners){var bayeuxMessage={channel:'/meta/subscribe',subscription:channel};var message=$.extend({},bayeuxMessage);_send(message);};};function _startBatch()
{++_batch;};function _endBatch(deliverMessages)
{--_batch;if(_batch<0)_batch=0;if(deliverMessages&&_batch==0&&!_isDisconnected())
{var messages=_messageQueue;_messageQueue=[];if(messages.length>0)_deliver(messages,false);}};function _nextMessageId()
{return++_messageId;};function _convertToMessages(response)
{if(response===undefined)return[];if(response instanceof Array)return response;if(response instanceof String||typeof response=='string')return eval('('+response+')');if(response instanceof Object)return[response];throw'Conversion Error '+response+', typeof '+(typeof response);};function _setStatus(newStatus)
{_debug('{} -> {}',_status,newStatus);_status=newStatus;};function _isDisconnected()
{return _status=='disconnecting'||_status=='disconnected';};function _handshake(handshakeProps)
{_debug('Starting handshake');_clientId=null;_batch=0;_startBatch();_handshakeProps=$.extend(true,{},handshakeProps);var bayeuxMessage={version:'1.0',minimumVersion:'0.9',channel:'/meta/handshake',supportedConnectionTypes:_xd?['callback-polling']:['long-polling','callback-polling']};var message=$.extend({},handshakeProps,bayeuxMessage);_setStatus('handshaking');_deliver([message],false);};function _findTransport(handshakeResponse)
{var transportTypes=handshakeResponse.supportedConnectionTypes;if(_xd)
{if($.inArray('callback-polling',transportTypes)>=0)return _transport;}
else
{if($.inArray('long-polling',transportTypes)>=0)return _transport;if($.inArray('callback-polling',transportTypes)>=0)return newCallbackPollingTransport();}
return null;};function _delayedHandshake()
{_setStatus('handshaking');_delayedSend(function()
{_handshake(_handshakeProps);});};function _delayedConnect()
{_setStatus('connecting');_delayedSend(function()
{_connect();});};function _delayedSend(operation)
{_cancelDelayedSend();var delay=_backoff;_debug("Delayed send: backoff {}, interval {}",_backoff,_advice.interval);if(_advice.interval&&_advice.interval>0)
delay+=_advice.interval;_scheduledSend=_setTimeout(operation,delay);};function _cancelDelayedSend()
{if(_scheduledSend!==null)clearTimeout(_scheduledSend);_scheduledSend=null;};function _setTimeout(funktion,delay)
{return setTimeout(function()
{try
{funktion();}
catch(x)
{_debug('Exception during scheduled execution of function \'{}\': {}',funktion.name,x);}},delay);};function _connect()
{_debug('Starting connect');var message={channel:'/meta/connect',connectionType:_transport.getType()};_setStatus('connecting');_deliver([message],true);_setStatus('connected');};function _send(message)
{if(_batch>0)
_messageQueue.push(message);else
_deliver([message],false);};function _deliver(messages,comet)
{$.each(messages,function(index,message)
{message['id']=_nextMessageId();if(_clientId)message['clientId']=_clientId;messages[index]=_applyOutgoingExtensions(message);});var self=this;var envelope={url:_url,messages:messages,onSuccess:function(request,response)
{try
{_handleSuccess.call(self,request,response,comet);}
catch(x)
{_debug('Exception during execution of success callback: {}',x);}},onFailure:function(request,reason,exception)
{try
{_handleFailure.call(self,request,messages,reason,exception,comet);}
catch(x)
{_debug('Exception during execution of failure callback: {}',x);}}};_debug('Sending request to {}, message(s): {}',envelope.url,JSON.stringify(envelope.messages));_transport.send(envelope,comet);};function _applyIncomingExtensions(message)
{$.each(_extensions,function(index,extension)
{var callback=extension.extension.incoming;if(callback&&typeof callback==='function')
{_debug('Calling incoming extension \'{}\', callback \'{}\'',extension.name,callback.name);message=_applyExtension(extension.name,callback,message)||message;}});return message;};function _applyOutgoingExtensions(message)
{$.each(_extensions,function(index,extension)
{var callback=extension.extension.outgoing;if(callback&&typeof callback==='function')
{_debug('Calling outgoing extension \'{}\', callback \'{}\'',extension.name,callback.name);message=_applyExtension(extension.name,callback,message)||message;}});return message;};function _applyExtension(name,callback,message)
{try
{return callback(message);}
catch(x)
{_debug('Exception during execution of extension \'{}\': {}',name,x);return message;}};function _handleSuccess(request,response,comet)
{var messages=_convertToMessages(response);_debug('Received response {}',JSON.stringify(messages));var success=true;$.each(messages,function(index,message)
{message=_applyIncomingExtensions(message);if(message.advice)_advice=message.advice;var successful=message.successful;success=success&&(successful===undefined||successful);var channel=message.channel;switch(channel)
{case'/meta/handshake':_handshakeSuccess(message);break;case'/meta/connect':_connectSuccess(message);break;case'/meta/disconnect':_disconnectSuccess(message);break;case'/meta/subscribe':_subscribeSuccess(message);break;case'/meta/unsubscribe':_unsubscribeSuccess(message);break;default:_messageSuccess(message);break;}});_transport.complete(request,success,comet);};function _handleFailure(request,messages,reason,exception,comet)
{var xhr=request.xhr;_debug('Request failed, status: {}, reason: {}, exception: {}',xhr&&xhr.status,reason,exception);$.each(messages,function(index,message)
{var channel=message.channel;switch(channel)
{case'/meta/handshake':_handshakeFailure(xhr,message);break;case'/meta/connect':_connectFailure(xhr,message);break;case'/meta/disconnect':_disconnectFailure(xhr,message);break;case'/meta/subscribe':_subscribeFailure(xhr,message);break;case'/meta/unsubscribe':_unsubscribeFailure(xhr,message);break;default:_messageFailure(xhr,message);break;}});_transport.complete(request,false,comet);};function _handshakeSuccess(message)
{if(message.successful)
{_debug('Handshake successful');_clientId=message.clientId;var newTransport=_findTransport(message);if(newTransport===null)
{throw'Could not agree on transport with server';}
else
{if(_transport.getType()!=newTransport.getType())
{_debug('Changing transport from {} to {}',_transport.getType(),newTransport.getType());_transport=newTransport;}}
_notifyListeners('/meta/handshake',message);var action=_advice.reconnect?_advice.reconnect:'retry';switch(action)
{case'retry':_delayedConnect();break;default:break;}}
else
{_debug('Handshake unsuccessful');var retry=!_isDisconnected()&&_advice.reconnect!='none';if(!retry)_setStatus('disconnected');_notifyListeners('/meta/handshake',message);_notifyListeners('/meta/unsuccessful',message);if(retry)
{_increaseBackoff();_debug('Handshake failure, backing off and retrying in {} ms',_backoff);_delayedHandshake();}}};function _handshakeFailure(xhr,message)
{_debug('Handshake failure');var failureMessage={successful:false,failure:true,channel:'/meta/handshake',request:message,xhr:xhr,advice:{action:'retry',interval:_backoff}};var retry=!_isDisconnected()&&_advice.reconnect!='none';if(!retry)_setStatus('disconnected');_notifyListeners('/meta/handshake',failureMessage);_notifyListeners('/meta/unsuccessful',failureMessage);if(retry)
{_increaseBackoff();_debug('Handshake failure, backing off and retrying in {} ms',_backoff);_delayedHandshake();}};function _connectSuccess(message)
{var action=_isDisconnected()?'none':(_advice.reconnect?_advice.reconnect:'retry');if(!_isDisconnected())_setStatus(action=='retry'?'connecting':'disconnecting');if(message.successful)
{_debug('Connect successful');_endBatch(true);_notifyListeners('/meta/connect',message);switch(action)
{case'retry':_resetBackoff();_delayedConnect();break;default:_resetBackoff();_setStatus('disconnected');break;}}
else
{_debug('Connect unsuccessful');_notifyListeners('/meta/connect',message);_notifyListeners('/meta/unsuccessful',message);switch(action)
{case'retry':_increaseBackoff();_delayedConnect();break;case'handshake':if(0==_batch)_startBatch();_resubscribe();_endBatch(false);_resetBackoff();_delayedHandshake();break;case'none':_resetBackoff();_setStatus('disconnected');break;}}};function _connectFailure(xhr,message)
{_debug('Connect failure');var failureMessage={successful:false,failure:true,channel:'/meta/connect',request:message,xhr:xhr,advice:{action:'retry',interval:_backoff}};_notifyListeners('/meta/connect',failureMessage);_notifyListeners('/meta/unsuccessful',failureMessage);if(!_isDisconnected())
{var action=_advice.reconnect?_advice.reconnect:'retry';switch(action)
{case'retry':_increaseBackoff();_debug('Connect failure, backing off and retrying in {} ms',_backoff);_delayedConnect();break;case'handshake':_resetBackoff();_delayedHandshake();break;case'none':_resetBackoff();break;default:_debug('Unrecognized reconnect value: {}',action);break;}}};function _disconnectSuccess(message)
{if(message.successful)
{_debug('Disconnect successful');_disconnect(false);_notifyListeners('/meta/disconnect',message);}
else
{_debug('Disconnect unsuccessful');_disconnect(true);_notifyListeners('/meta/disconnect',message);_notifyListeners('/meta/usuccessful',message);}};function _disconnect(abort)
{_cancelDelayedSend();if(abort)_transport.abort();_clientId=null;_setStatus('disconnected');_batch=0;_messageQueue=[];_resetBackoff();};function _disconnectFailure(xhr,message)
{_debug('Disconnect failure');_disconnect(true);var failureMessage={successful:false,failure:true,channel:'/meta/disconnect',request:message,xhr:xhr,advice:{action:'none',interval:0}};_notifyListeners('/meta/disconnect',failureMessage);_notifyListeners('/meta/unsuccessful',failureMessage);};function _subscribeSuccess(message)
{if(message.successful)
{_debug('Subscribe successful');_notifyListeners('/meta/subscribe',message);}
else
{_debug('Subscribe unsuccessful');_notifyListeners('/meta/subscribe',message);_notifyListeners('/meta/unsuccessful',message);}};function _subscribeFailure(xhr,message)
{_debug('Subscribe failure');var failureMessage={successful:false,failure:true,channel:'/meta/subscribe',request:message,xhr:xhr,advice:{action:'none',interval:0}};_notifyListeners('/meta/subscribe',failureMessage);_notifyListeners('/meta/unsuccessful',failureMessage);};function _unsubscribeSuccess(message)
{if(message.successful)
{_debug('Unsubscribe successful');_notifyListeners('/meta/unsubscribe',message);}
else
{_debug('Unsubscribe unsuccessful');_notifyListeners('/meta/unsubscribe',message);_notifyListeners('/meta/unsuccessful',message);}};function _unsubscribeFailure(xhr,message)
{_debug('Unsubscribe failure');var failureMessage={successful:false,failure:true,channel:'/meta/unsubscribe',request:message,xhr:xhr,advice:{action:'none',interval:0}};_notifyListeners('/meta/unsubscribe',failureMessage);_notifyListeners('/meta/unsuccessful',failureMessage);};function _messageSuccess(message)
{if(message.successful===undefined)
{if(message.data)
{_notifyListeners(message.channel,message);}
else
{_debug('Unknown message {}',JSON.stringify(message));}}
else
{if(message.successful)
{_debug('Publish successful');_notifyListeners('/meta/publish',message);}
else
{_debug('Publish unsuccessful');_notifyListeners('/meta/publish',message);_notifyListeners('/meta/unsuccessful',message);}}};function _messageFailure(xhr,message)
{_debug('Publish failure');var failureMessage={successful:false,failure:true,channel:message.channel,request:message,xhr:xhr,advice:{action:'none',interval:0}};_notifyListeners('/meta/publish',failureMessage);_notifyListeners('/meta/unsuccessful',failureMessage);};function _notifyListeners(channel,message)
{_notify(channel,message);var channelParts=channel.split("/");var last=channelParts.length-1;for(var i=last;i>0;--i)
{var channelPart=channelParts.slice(0,i).join('/')+'/*';if(i==last)_notify(channelPart,message);channelPart+='*';_notify(channelPart,message);}};function _notify(channel,message)
{var subscriptions=_listeners[channel];if(subscriptions&&subscriptions.length>0)
{$.each(subscriptions,function(index,subscription)
{if(subscription)
{try
{_debug('Notifying subscription: channel \'{}\', callback \'{}\'',channel,subscription.callback.name);subscription.callback.call(subscription.scope,message);}
catch(x)
{_warn('Exception during execution of callback \'{}\' on channel \'{}\' for message {}, exception: {}',subscription.callback.name,channel,JSON.stringify(message),x);}}});}};function _resetBackoff()
{_backoff=0;};function _increaseBackoff()
{if(_backoff<_maxBackoff)_backoff+=_backoffIncrement;};var _error=this._error=function(text,args)
{_log('error',_format.apply(this,arguments));};var _warn=this._warn=function(text,args)
{_log('warn',_format.apply(this,arguments));};var _info=this._info=function(text,args)
{_log('info',_format.apply(this,arguments));};var _debug=this._debug=function(text,args)
{_log('debug',_format.apply(this,arguments));};function _log(level,text)
{var priority=_logPriorities[level];var configPriority=_logPriorities[_logLevel];if(!configPriority)configPriority=_logPriorities['info'];if(priority>=configPriority)
{if(window.console)window.console.log(text);}};function _format(text)
{var braces=/\{\}/g;var result='';var start=0;var count=0;while(braces.test(text))
{result+=text.substr(start,braces.lastIndex-start-2);var arg=arguments[++count];result+=arg!==undefined?arg:'{}';start=braces.lastIndex;}
result+=text.substr(start,text.length-start);return result;};function newLongPollingTransport()
{return $.extend({},new Transport('long-polling'),new LongPollingTransport());};function newCallbackPollingTransport()
{return $.extend({},new Transport('callback-polling'),new CallbackPollingTransport());};var Transport=function(type)
{var _maxRequests=2;var _requestIds=0;var _cometRequest=null;var _requests=[];var _packets=[];this.getType=function()
{return type;};this.send=function(packet,comet)
{if(comet)
_cometSend(this,packet);else
_send(this,packet);};function _cometSend(self,packet)
{if(_cometRequest!==null)throw'Concurrent comet requests not allowed, request '+_cometRequest.id+' not yet completed';var requestId=++_requestIds;_debug('Beginning comet request {}',requestId);var request={id:requestId};self.deliver(packet,request);_cometRequest=request;};function _send(self,packet)
{var requestId=++_requestIds;_debug('Beginning request {}, {} other requests, {} queued requests',requestId,_requests.length,_packets.length);var request={id:requestId};if(_requests.length<_maxRequests-1)
{_debug('Delivering request {}',requestId);self.deliver(packet,request);_requests.push(request);}
else
{_packets.push([packet,request]);_debug('Queued request {}, {} queued requests',requestId,_packets.length);}};this.complete=function(request,success,comet)
{if(comet)
_cometComplete(request);else
_complete(this,request,success);};function _cometComplete(request)
{var requestId=request.id;if(_cometRequest!==request)throw'Comet request mismatch, completing request '+requestId;_cometRequest=null;_debug('Ended comet request {}',requestId);};function _complete(self,request,success)
{var requestId=request.id;var index=$.inArray(request,_requests);if(index>=0)_requests.splice(index,1);_debug('Ended request {}, {} other requests, {} queued requests',requestId,_requests.length,_packets.length);if(_packets.length>0)
{var packet=_packets.shift();if(success)
{_debug('Dequeueing and sending request {}, {} queued requests',packet[1].id,_packets.length);_send(self,packet[0]);}
else
{_debug('Dequeueing and failing request {}, {} queued requests',packet[1].id,_packets.length);packet[0].onFailure(packet[1],'error');}}};this.abort=function()
{$.each(_requests,function(index,request)
{_debug('Aborting request {}',request.id);if(request.xhr)request.xhr.abort();});if(_cometRequest)
{_debug('Aborting comet request {}',_cometRequest.id);if(_cometRequest.xhr)_cometRequest.xhr.abort();}
_cometRequest=null;_requests=[];_packets=[];};};var LongPollingTransport=function()
{this.deliver=function(packet,request)
{request.xhr=$.ajax({url:packet.url,type:'POST',contentType:'text/json;charset=UTF-8',beforeSend:function(xhr)
{return true;},data:JSON.stringify(packet.messages),success:function(response){packet.onSuccess(request,response);},error:function(xhr,reason,exception){packet.onFailure(request,reason,exception);}});};};var CallbackPollingTransport=function()
{var _maxLength=2000;this.deliver=function(packet,request)
{var messages=JSON.stringify(packet.messages);var urlLength=packet.url.length+encodeURI(messages).length;_debug('URL length: {}',urlLength);if(urlLength>_maxLength)
{var x=packet.messages.length>1?'Too many bayeux messages in the same batch resulting in message too big '+'('+urlLength+' bytes, max is '+_maxLength+') for transport '+this.getType():'Bayeux message too big ('+urlLength+' bytes, max is '+_maxLength+') '+'for transport '+this.getType();_setTimeout(function(){packet.onFailure(request,'error',x);},0);}
else
{$.ajax({url:packet.url,type:'GET',dataType:'jsonp',jsonp:'jsonp',beforeSend:function(xhr)
{return true;},data:{message:messages},success:function(response){packet.onSuccess(request,response);},error:function(xhr,reason,exception){packet.onFailure(request,reason,exception);}});}};};};$.cometd=new $.Cometd();})(jQuery);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var loginFormSchema=new $n2.form.Schema({attributes:[{name:'user',label:_loc('E-mail'),type:'text'},{name:'password',label:_loc('Password'),type:'password'}],buttons:[{name:'ok',label:_loc('OK')},{name:'cancel',label:_loc('Cancel')}]});var loginFormSchemaWithGuest=new $n2.form.Schema({attributes:[{name:'user',label:_loc('E-mail'),type:'text'},{name:'password',label:_loc('Password'),type:'password'}],buttons:[{name:'ok',label:_loc('OK')},{name:'cancel',label:_loc('Cancel')},{name:'anonym',label:_loc('Guest Login')}]});var index=0;var loginStateListeners=[];var addListeners=function(listeners){var cUser=getCurrentUser();if(typeof listeners=="function"){addListener(listeners);}else if(listeners.constructor==Array){for(var loop=0;loop<listeners.length;++loop){var listener=listeners[loop];addListener(listener);};};function addListener(listener){loginStateListeners.push(listener);try{listener(cUser);}catch(e){log('$.NUNALIIT_AUTH: EXCEPTION caught in listener (add): '+e);};};};var notifyListeners=function(){var user=getCurrentUser();for(var loop=0;loop<loginStateListeners.length;++loop){var listener=loginStateListeners[loop];if(listener){try{listener(user);}catch(e){log('$.NUNALIIT_AUTH: EXCEPTION caught in listener (notify): '+e);};};};};var _userLogin=function(options,anonymousFlag,username,password){function doLogin(){$.ajax({type:'GET',url:options.url+'/login',dataType:'json',data:{name:username,password:password},async:true,success:onSuccess,error:onError});};var loginRetries=0;var loginRetryLimit=3;function retryLogin(){loginRetries++;if(loginRetries<=loginRetryLimit){doLogin();return(true);};return(false);};function clearLoginForm(){if(!options.autoAnonymousLogin||!anonymousFlag){options.dialog.dialog('close');};};function doErrorNotification(causeObj){if(options.autoAnonymousLogin&&anonymousFlag){var retrying=retryLogin();if(retrying){return;};};var err={message:'Invalid e-mail and/or password'};if(null!=causeObj){err.cause=causeObj;};clearLoginForm();options.onError(err,options);notifyListeners();};function onSuccess(result){log("Login successful",result,options);if(result&&result.logged){clearLoginForm();options.onSuccess(result,options);notifyListeners();}else{doErrorNotification(null);};};function onError(xmlHttpRequest,textStatus,errorThrown){log("Login error",xmlHttpRequest,textStatus,errorThrown);doErrorNotification({message:textStatus});};if(anonymousFlag){username=options.anonymousUser;password=options.anonymousPw;};doLogin();};var defaultError=function(err,options){var acc=[];if(err){acc.push(''+err.message);var cause=err.cause;while(cause){acc.push('\n>'+cause.message);cause=cause.cause;};}else{acc.push('<Unknown error>');};alert(acc.join(''));};var initOptions={};var defaultOptions={onSuccess:function(result,options){},onError:defaultError,anonymousLoginAllowed:false,anonymousUser:'anonymous',anonymousPw:'anonymous',autoAnonymousLogin:false,prompt:'Please login',url:'./auth'};var init=function(options_){initOptions=$.extend({},defaultOptions,options_);if(initOptions.listeners){addListeners(initOptions.listeners);delete initOptions.listeners;};var initOnSuccess=initOptions.onSuccess;delete initOptions.onSuccess;var initOnError=initOptions.onError;delete initOptions.onError;var optWithCallbacks=$.extend({},initOptions,{onSuccess:initOnSuccess,onError:initOnError});$.ajax({type:'GET',url:initOptions.url+'/adjust',dataType:'json',async:true,success:onSuccess,error:onError});function onSuccess(result){$n2.log("Login(adjustCookies) successful",result,initOptions);if(false==result.logged&&initOptions.autoAnonymousLogin){_userLogin(optWithCallbacks,true);}else{initOnSuccess(result,optWithCallbacks);notifyListeners();};};function onError(xmlHttpRequest,textStatus,errorThrown){log("Login(adjustCookies) error",xmlHttpRequest,textStatus,errorThrown);if(initOptions.autoAnonymousLogin){_userLogin(optWithCallbacks,true);}else{var err={message:'Problem initializing authentication library',cause:{message:textStatus}};initOnError(err,optWithCallbacks);notifyListeners();};};};var autoAnonLogin=function(options_){var options=$.extend({},defaultOptions,initOptions,options_);_userLogin(options,true);};var showLoginForm=function(options_){var options=$.extend({},defaultOptions,initOptions,options_);var myIndex=index;++index;options.index=myIndex;var $dialog=$('<div></div>');options.dialog=$dialog;$(document.body).append($dialog);var formOptions={buttonPressed:function(loginForm,buttonName){if('ok'===buttonName){var user=loginForm.getInputFromName('user').getCurrentValue();var password=loginForm.getInputFromName('password').getCurrentValue();_userLogin(options,false,user,password);}else if('cancel'===buttonName){$dialog.dialog('close');}else if('anonym'===buttonName){_userLogin(options,true);}}};if(options.anonymousLoginAllowed&&!options.autoAnonymousLogin){var $n2Form=loginFormSchemaWithGuest.createForm($dialog,{},formOptions);}else{var $n2Form=loginFormSchema.createForm($dialog,{},formOptions);};var dialogOptions={autoOpen:true,modal:true,width:'auto',close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};if(options.prompt){dialogOptions.title=options.prompt;}
$dialog.dialog(dialogOptions);};var logout=function(options_){var options=$.extend({},defaultOptions,initOptions,options_);$.ajax({type:'GET',url:options.url+'/logout',username:'_',password:'_',dataType:'json',data:{name:'_'},async:true,success:onSuccess,error:onError});function onSuccess(result){log("Logout successful",result,options);if(result&&!result.logged){options.onSuccess(result,options);notifyListeners();}else{var err={message:'Error on logout'};options.onError(err,options);notifyListeners();};};function onError(xmlHttpRequest,textStatus,errorThrown){log("Logout error",xmlHttpRequest,textStatus,errorThrown);var err={message:'Error on logout',cause:{message:textStatus}};options.onError(err,options);notifyListeners();};};var getCurrentUser=function(){var user=null;var authContext=getAuthContext();if(authContext&&authContext.logged){user=authContext.user;};return user;};var getAuthContext=function(){var context=null;var cookie=$.cookie('nunaliit-auth');if(cookie){eval('context = '+cookie+';');};if(!context){context={logged:false};};return context;};function isDeleteAllowed(){var user=getCurrentUser();return(null!=user&&user.admin);}
function isUpdateAllowed(contribCreatorDisplayName){var allowed=false;var user=getCurrentUser();if(null!=user){if(user.admin){allowed=true;}else if(!user.anonymous&&""!=contribCreatorDisplayName&&user.display==contribCreatorDisplayName){allowed=true;}}
return(allowed);}
var isLoggedIn=function(){var authContext=getAuthContext();if(authContext&&authContext.logged){return true;};return false;};var isUser=function(){if(!isLoggedIn())return false;var user=getCurrentUser();if(user.anonymous)return false;return true;};var isAdmin=function(){if(!isLoggedIn())return false;var user=getCurrentUser();if(user.admin)return true;return false;};var isAnonymous=function(){if(!isLoggedIn())return false;var user=getCurrentUser();if(user.anonymous)return true;return false;};function userLoggedInAndNotAnonymous(){var user=getCurrentUser();return(null!=user&&!user.anonymous);}
function autoAnonymousBehaviour(){return(isDefined(initOptions.autoAnonymousLogin)&&initOptions.autoAnonymousLogin);}
$.NUNALIIT_AUTH={getUser:getCurrentUser,getAuthContext:getAuthContext,init:init,login:showLoginForm,logout:logout,addListener:addListeners,isDeleteAllowed:isDeleteAllowed,isUpdateAllowed:isUpdateAllowed,isLoggedIn:isLoggedIn,isUser:isUser,isAdmin:isAdmin,isAnonymous:isAnonymous,userLoggedInAndNotAnonymous:userLoggedInAndNotAnonymous,autoAnonymousBehaviour:autoAnonymousBehaviour,autoAnonLogin:autoAnonLogin};})(jQuery,nunaliit2);;(function($){var convertXmlHttpRequestError=function(xmlHttpRequest,textStatus){try{var responseText=xmlHttpRequest.responseText;var msg=null;eval('msg = '+responseText+';');if(msg.error){return msg.error;}}catch(e){}
return{message:'Server error: '+textStatus};};var defaultOptions={url:'./dbWeb',onSuccess:function(result,options){},onError:function(result,options){}};var addTable=function(data,options){data.table=options.tableName;};var addWhereClauses=function(data,options){if(options.whereClauses){data.where=[];for(var i=0;i<options.whereClauses.length;i++){data.where.push(options.whereClauses[i]);};};};var addSelects=function(data,options){if(options.selects){data.select=[];for(var i=0;i<options.selects.length;i++){data.select.push(options.selects[i]);};};};var addGrouping=function(data,options){if(options.groupBys){data.groupBy=[];for(var i=0;i<options.groupBys.length;i++){data.groupBy.push(options.groupBys[i]);};};};var addOrder=function(data,options){if(options.orderBy){data.orderBy=options.orderBy;};};var addLimit=function(data,options){if(options.limit){data.limit=options.limit;};if(options.offset){data.offset=options.offset;};};var addSetters=function(data,options){if(options.setters){data.set=[];for(var key in options.setters){var value=options.setters[key];data.set.push(''+key+','+value);};};};var configure=function(options_){var options=$.extend({},defaultOptions,options_);defaultOptions=options;};var getCapabilities=function(options_){var options=$.extend({},defaultOptions,options_);var data={};$.ajax({type:'GET',url:options.url+'/getCapabilities',data:data,dataType:'json',async:true,success:onSuccess,error:onError});function onSuccess(result){if(result.error){options.onError(result.error,options);}else if(result.capabilities){options.onSuccess(result.capabilities,options);}else{options.onError({message:'Capabilities not returned'},options);};};function onError(xmlHttpRequest,textStatus,errorThrown){var e=convertXmlHttpRequestError(xmlHttpRequest,textStatus);options.onError(e,options);};};var getSchema=function(options_){var options=$.extend({},defaultOptions,options_);var data={};addTable(data,options);$.ajax({type:'GET',url:options.url+'/getSchema',data:data,dataType:'json',async:true,success:onSuccess,error:onError});function onSuccess(result){if(result.error){options.onError(result.error,options);}else{options.onSuccess(result,options);};};function onError(xmlHttpRequest,textStatus,errorThrown){var e=convertXmlHttpRequestError(xmlHttpRequest,textStatus);options.onError(e,options);};};var query=function(options_){var options=$.extend({},defaultOptions,options_);var data={};addTable(data,options);addWhereClauses(data,options);addSelects(data,options);addGrouping(data,options);addOrder(data,options);addLimit(data,options);$.ajax({type:'POST',url:options.url+'/query',data:data,dataType:'json',contentType:'application/x-www-form-urlencoded; charset=utf-8',async:true,traditional:true,success:onSuccess,error:onError});function onSuccess(result){if(result.error){options.onError(result.error,options);}else if(result.queried){options.onSuccess(result.queried,options);}else{options.onError({message:'Queried objects not returned'},options);};};function onError(xmlHttpRequest,textStatus,errorThrown){var e=convertXmlHttpRequestError(xmlHttpRequest,textStatus);options.onError(e,options);};};var queries=function(options_){var options=$.extend({},defaultOptions,options_);var queries=options.queries;if(null==queries){options.onError({message:'"queries" not specified'},options_);return;};var request={};for(var queryIndex=0;queryIndex<queries.length;++queryIndex){var query=queries[queryIndex];var queryObj={};request['q'+queryIndex]=queryObj;queryObj.table=query.tableName;if(!queryObj.table){options.onError({message:'Missing table name'},options_);return;}
if(query.selects){queryObj.select=query.selects;}
if(query.whereClauses){queryObj.where=query.whereClauses;}
if(query.groupBys){queryObj.groupBy=query.groupBys;}
if(query.orderBy){queryObj.orderBy=query.orderBy;}
if(query.limit){queryObj.limit=query.limit;}
if(query.offset){queryObj.offset=query.offset;}}
var jsonString=JSON.stringify(request);var data={queries:jsonString};$.ajax({type:'POST',url:options.url+'/queries',data:data,dataType:'json',contentType:'application/x-www-form-urlencoded; charset=utf-8',async:true,success:onSuccess,error:onError,traditional:true});function onSuccess(result){if(result.error){options.onError(result.error,options_);}else{for(var queryIndex=0;queryIndex<queries.length;++queryIndex){var query=queries[queryIndex];var key='q'+queryIndex;var response=result[key];if(null==response){query.error={message:'No Response'};}else if(typeof response=='object'&&typeof response.length=='number'){query.results=response;}else if(typeof response=='object'&&typeof response.message=='string'){query.error=response;}else{query.error={message:'Unrecognized response'};}};options.onSuccess(queries,options_);};};function onError(xmlHttpRequest,textStatus,errorThrown){var e=convertXmlHttpRequestError(xmlHttpRequest,textStatus);options.onError(e,options);};};var insert=function(options_){var options=$.extend({},defaultOptions,options_);var data={};addTable(data,options);addSetters(data,options);$.ajax({type:'POST',url:options.url+'/insert',data:data,dataType:'json',contentType:'application/x-www-form-urlencoded; charset=utf-8',async:true,success:onSuccess,error:onError,traditional:true});function onSuccess(result){if(result.error){options.onError(result.error,options);}else if(result.inserted){options.onSuccess(result.inserted,options);}else{options.onError({message:'Inserted objects not returned'},options);};};function onError(xmlHttpRequest,textStatus,errorThrown){var e=convertXmlHttpRequestError(xmlHttpRequest,textStatus);options.onError(e,options);};};var update=function(options_){var options=$.extend({},defaultOptions,options_);var data={};addTable(data,options);addWhereClauses(data,options);addSetters(data,options);$.ajax({type:'POST',url:options.url+'/update',data:data,dataType:'json',contentType:'application/x-www-form-urlencoded; charset=utf-8',async:true,success:onSuccess,error:onError,traditional:true});function onSuccess(result){if(result.error){options.onError(result.error,options);}else if(result.updated){options.onSuccess(result.updated,options);}else{options.onError({message:'Updated objects not returned'},options);};};function onError(xmlHttpRequest,textStatus,errorThrown){var e=convertXmlHttpRequestError(xmlHttpRequest,textStatus);options.onError(e,options);};};var remove=function(options_){var options=$.extend({},defaultOptions,options_);var data={};addTable(data,options);addWhereClauses(data,options);$.ajax({type:'POST',url:options.url+'/delete',data:data,dataType:'json',contentType:'application/x-www-form-urlencoded; charset=utf-8',async:true,success:onSuccess,error:onError,traditional:true});function onSuccess(result){if(result.error){options.onError(result.error,options);}else{options.onSuccess(result,options);};};function onError(xmlHttpRequest,textStatus,errorThrown){var e=convertXmlHttpRequestError(xmlHttpRequest,textStatus);options.onError(e,options);};};var whereComparison_eq='eq';var whereComparison_ne='ne';var whereComparison_ge='ge';var whereComparison_le='le';var whereComparison_gt='gt';var whereComparison_lt='lt';var whereStatus_null='null';var whereStatus_notNull='notNull';var orderByAscending='a';var orderByDescending='d';var formatWhereClause=function(column,compEnum,value){if(null==value){return compEnum+'('+column+')';}else{return compEnum+'('+column+')'+value;};};var formatSearchStringRecordSelector=function(searchString,column1,column2){var selector='search(';for(var loop=1;loop<arguments.length;++loop){if(1!=loop){selector+=',';}
selector+=arguments[loop];}
selector+=')';selector+=searchString;return selector;};var formatFieldSelectorColumn=function(column){return''+column;};var selectAggregator_min='min';var selectAggregator_max='max';var selectAggregator_sum='sum';var formatFieldSelectorFunction=function(column,aggEnum){if(null==aggEnum){return(column);}else{return(aggEnum+'('+column+')');};};var formatFieldSelectorScoreSubstring=function(searchString){var selector='score(';for(var loop=1;loop<arguments.length;++loop){if(1!=loop){selector+=',';}
selector+=arguments[loop];}
selector+=')';selector+=searchString;return selector;};var formatFieldSelectorCentroid=function(axis,fieldName){return'centroid('+axis+','+fieldName+')';};var formatOrderBy=function(type,fieldSelector){return type+','+fieldSelector;};$.NUNALIIT_DBWEB={getCapabilities:getCapabilities,getSchema:getSchema,query:query,queries:queries,insert:insert,update:update,remove:remove,configure:configure,whereComparison_eq:whereComparison_eq,whereComparison_ne:whereComparison_ne,whereComparison_ge:whereComparison_ge,whereComparison_le:whereComparison_le,whereComparison_gt:whereComparison_gt,whereComparison_lt:whereComparison_lt,whereStatus_null:whereStatus_null,whereStatus_notNull:whereStatus_notNull,orderByAscending:orderByAscending,orderByDescending:orderByDescending,selectAggregator_min:selectAggregator_min,selectAggregator_max:selectAggregator_max,selectAggregator_sum:selectAggregator_sum,formatWhereClause:formatWhereClause,formatSearchStringRecordSelector:formatSearchStringRecordSelector,formatFieldSelectorColumn:formatFieldSelectorColumn,formatFieldSelectorFunction:formatFieldSelectorFunction,formatFieldSelectorScoreSubstring:formatFieldSelectorScoreSubstring,formatFieldSelectorCentroid:formatFieldSelectorCentroid,formatOrderBy:formatOrderBy};$.fn.dbWebForm=function(options_){var jqSet=this;var options=$.extend({},defaultOptions,{installButtons:null,data:{},fieldOpts:{},onAlert:function(str){alert(str);},onError:printError},options_);var getSchemaOptions=$.extend({},defaultOptions,options_,{onSuccess:onGetSchemaSuccess,onError:onSchemaError});getSchema(getSchemaOptions);if(options.whereClauses){var queryOptions=$.extend({},defaultOptions,options_,{onSuccess:onQuerySuccess,onError:onQueryError});query(queryOptions);};var data={};function onGetSchemaSuccess(schema){data.schema=schema;if(schema.isQueryAllowed){}else{reportError({message:'User does not have privilege to query this data'});return;}
if(options.whereClauses){if(schema.isUpdateAllowed){}else{reportError({message:'User does not have privilege to update this data'});return;};}else{if(schema.isInsertAllowed){}else{reportError({message:'User does not have privilege to insert new data'});return;};};onDataAvailable();};function onSchemaError(cause){error={message:'Error while retrieving schema',cause:cause};options.onError(error,options);};function onQuerySuccess(queriedObjects){data.queriedObjects=queriedObjects;onDataAvailable();};function onQueryError(cause){error={message:'Error while querying for data',cause:cause};options.onError(error,options);};function reportError(error){options.onError(error,options);};function printError(error){var elem=$(jqSet.get(0));var html=[];html.push('<div class="dbweb-error">');html.push('Error: ');html.push(error.message);html.push('</div>');elem.empty();elem.html(html.join(''));};function onDataAvailable(){if(data.error){reportError(data.error);return;};if(!data.schema){return;};if(options.whereClauses){if(!data.queriedObjects){return;};if(data.queriedObjects.length<1){reportError({message:'Data can not be edited by current user.'});return;};if(data.queriedObjects.length>1){reportError({message:'Multiple records were returned. Can not proceed with editing.'});return;};data.queryData=data.queriedObjects[0];}else{data.queryData=options.data;};var elem=$(jqSet.get(0));elem.empty();var div=$('<div class="dbweb-form"></div>');elem.append(div);var form=$('<form></form>');div.append(form);var ul=$('<ul></ul>');form.append(ul);data.form={};var columns=data.schema.columns;for(var loop=0;loop<columns.length;++loop){var column=columns[loop];var columnName=column.column;if(column.write){if(options.fieldOpts[columnName]){var fieldOpts=options.fieldOpts[columnName];var mustHide=fieldOpts.hide;if(typeof mustHide==='function'){mustHide=mustHide();};if(mustHide){}else if(fieldOpts.choices){addChoicesInput(form,ul,columnName,fieldOpts);}else if(fieldOpts.select){addCallbackInput(form,ul,columnName,fieldOpts);}else if('DATE'==column.type){addDateInput(form,ul,columnName,fieldOpts);}else{addRegularInput(form,ul,columnName,fieldOpts);};}else if('DATE'==column.type){addDateInput(form,ul,columnName,{});}else{addRegularInput(form,ul,columnName,{});};};};var buttons={};if(options.whereClauses){buttons['Save']=function(saveOptions){updateRecord(data.form,saveOptions);};}else{buttons['Save']=function(saveOptions){insertRecord(data.form,saveOptions);};};if(data.schema.isDeleteAllowed&&options.whereClauses){buttons['Delete']=function(delOptions){delRecord(data.form,delOptions);};};if(options.installButtons){options.installButtons(buttons);}else{var btnDiv=$('<div class="dbweb-buttons"></div>');div.append(btnDiv);if(buttons['Save']){var btn=$('<input type="button" value="'+(options.whereClauses?'Update':'Insert')+'"/>');btn.click(function(evt){buttons['Save']();return false;});btnDiv.append(btn);}
if(buttons['Delete']){var btn=$('<input type="button" value="Delete"/>');btn.click(function(evt){buttons['Delete']();return false;});btnDiv.append(btn);}}};function retrieveDefaultValue(fieldOpts){var ret=null;if('function'==typeof(fieldOpts.defaultValue)){ret=fieldOpts.defaultValue();}else{ret=fieldOpts.defaultValue;};return ret;};function addRegularInput(formElem,ulElem,columnName,fieldOpts){var value='';var valueAttr='';if("undefined"!=typeof(data.queryData[columnName])){value=data.queryData[columnName];valueAttr=' value="'+value+'"';}else if("undefined"!=typeof(fieldOpts.defaultValue)){value=retrieveDefaultValue(fieldOpts);valueAttr=' value="'+value+'"';};var li=$('<li></li>');appendLabel(li,columnName);var input=$('<input class="dbWebFormInput" type="text" name="'+columnName+'"'+valueAttr+'/>');li.append(input);saveInput(columnName,input,value);ulElem.append(li);};function addDateInput(formElem,ulElem,columnName,fieldOpts){var value='';var valueAttr='';if(isDefined(data.queryData[columnName])&&isDefined(data.queryData[columnName].formatted)){value=data.queryData[columnName].formatted;valueAttr=' value="'+value+'"';}else if(isDefined(fieldOpts.defaultValue)){value=retrieveDefaultValue(fieldOpts);valueAttr=' value="'+value+'"';};var li=$('<li></li>');appendLabel(li,columnName);var input=$('<input class="dbWebFormInput" type="text" name="'+columnName+'"'+valueAttr+'/>');input.datepicker({dateFormat:'yy-mm-dd',gotoCurrent:true,changeYear:true});li.append(input);saveInput(columnName,input,value);ulElem.append(li);};function addChoicesInput(formElem,ulElem,columnName,fieldOpts){var value='';if("undefined"!=typeof(data.queryData[columnName])){value=data.queryData[columnName];}else if("undefined"!=typeof(fieldOpts.defaultValue)){value=retrieveDefaultValue(fieldOpts);};var li=$('<li></li>');appendLabel(li,columnName);var input=$('<select class="dbWebFormSelect"></select>');for(var loop=0;loop<fieldOpts.choices.length;++loop){var choice=fieldOpts.choices[loop];var html=[];html.push('<option value="'+choice.value);if(value==choice.value){html.push('" selected="true');};html.push('">');if(choice.label){html.push(choice.label);}else{html.push(choice.value);};html.push('</option>');input.append($(html.join('')));};li.append(input);saveInput(columnName,input,value);ulElem.append(li);};function addCallbackInput(formElem,ulElem,columnName,fieldOpts){var value='';var valueAttr='';if("undefined"!=typeof(data.queryData[columnName])){value=data.queryData[columnName];valueAttr=' value="'+value+'"';}else if("undefined"!=typeof(fieldOpts.defaultValue)){value=retrieveDefaultValue(fieldOpts);valueAttr=' value="'+value+'"';};var li=$('<li></li>');appendLabel(li,columnName);var input=$('<input class="dbWebFormInput" type="text" name="'+columnName+'"'+valueAttr+'/>');li.append(input);var button=$('<input class="dbWebFormSelectButton" type="button" value="..."/>');button.click(function(evt){fieldOpts.select(onSelect);return false;});li.append(button);saveInput(columnName,input,value);ulElem.append(li);function onSelect(value_){input.val(value_);};};function appendLabel(liElem,columnName){var label=$('<label>'+columnName+':</label>');liElem.append(label);};function saveInput(columnName,inputElem,initialValue){inputElem.attr('_initialValue',initialValue);data.form[columnName]=inputElem;};function insertRecord(form,saveOptions){var insertOptions=$.extend({},defaultOptions,options_,saveOptions);insertOptions.setters={};for(var columnName in form){var input=form[columnName];var value=input.val();insertOptions.setters[columnName]=value;};insert(insertOptions);};function updateRecord(form,saveOptions){var updateOptions=$.extend({},defaultOptions,options_,saveOptions);var updating=false;updateOptions.setters={};for(var columnName in form){var input=form[columnName];var value=input.val();var initialValue=input.attr('_initialValue');if(value!=initialValue){updateOptions.setters[columnName]=value;updating=true;};};if(!updating){options.onAlert('Data left unchanged. No updating required.');}else{update(updateOptions);};};function delRecord(form,delOptions){var removeOptions=$.extend({},defaultOptions,options_,delOptions);remove(removeOptions);};function updateData(columnName,value){if(data&&data.form&&data.form[columnName]){var input=data.form[columnName];input.val(value);};};return{updateData:updateData};};})(jQuery);NUNALIIT_CONTRIBUTIONS=null;function olkitContributions($,options_){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var _formIntroString='Contribute information about this place to the atlas. '+'Your contribution will appear along with other comments about '+'this place shown in the side panel. You can also upload '+'an audio recording, video or images about the place.';var _formUpdateNotice='If you proceed you will <i>UPDATE the following comment</i>.';var _formAddNotice='If you proceed you will <i>ADD a new comment</i>.';var defaults={db:null,putUrl:'upload/put',deleteUrl:'contributions/delete',table:'contributions',anonymousAllowed:true,formData:{formIntroText:_formIntroString,updateNotice:_formUpdateNotice,addNotice:_formAddNotice,editFields:[{name:'title',label:'Title',type:'text'},{name:'notes',label:'Comment',type:'textarea',cols:'50',rows:'10'},{name:'filename',label:'',type:'file'}]},data:{},onSuccess:function(msg,textStatus){},onError:function(xmlHttpRequest,textStatus,errorThrown){}};var contributionOptions=$.extend(true,{},defaults,options_)
var index=0;var dialog=null;var form=null;function UserSubmit(){form.remove();form.css({display:"none",postion:"absolute",top:"0px",left:"0px"});$(document.body).append(form);dialog.dialog('close');var myForm=form;form=null;_SubmitForm(myForm);};function UserCancel(){dialog.dialog('close');if(form){form.remove();form=null;}};function _SubmitForm(myForm){try{$(myForm).ajaxSubmit({beforeSubmit:BeforeFormSubmit,success:function(data,success){OnFormSuccess(data,success,myForm);},error:function(xhr,status,e){OnFormError(xhr,status,e,myForm);},iframe:true});}catch(error){OnFormError(null,'error',error,myForm);}};function _SubmitFormImmediate(options,form){try{form.ajaxSubmit({success:function(data,success){form.remove();},error:function(xhr,status,e){form.remove();},iframe:true});}catch(error){form.remove();};};function InstallKey(myForm,key){$(myForm).attr("contributions-key",key);_SubmitForm(myForm);};function BeforeFormSubmit(parmArray,form,options){var $form=$(form);var needKey=1;if(!$.progress){needKey=0;}
var key=$form.attr("contributions-key");if(key){needKey=0;}
if(needKey){$.progress.getProgressKey(function(key){InstallKey(form,key);});return false;}
if(key){$.progress.startProgressTrackingOn(key,'Submit contribution');$form.prepend('<input type="hidden" name="progressId" value="'+key+'"/>');};return true;};function OnFormSuccess(data,status,myForm){myForm.remove();};function OnFormError(xhr,status,e,myForm){myForm.remove();};function clearFileFields(oObj){oObj.filename=null;oObj.original_filename=null;oObj.mimetype=null;oObj.file_size=null;}
function createForm(options){var fileDivName='____contrib_fileDiv';var fileDeleteDivName='____contrib_fileDeleteDiv';var deleteCBName='___contrib_deleteCB';function insertFileReplaceDialog(){if(!options.data.deleteFile){$('#'+fileDeleteDivName).html('<span class="jqmContributions_input_heading">Replace attached file:</span>'+'<input class="jqmContributions_input" type="file" name="upload"/>');}else{$('#'+fileDeleteDivName).empty();}}
function insertFileDiv(){var offerFileDelete=(typeof options.data.deleteFile!='undefined');if(!offerFileDelete){var htmlString='<span class="jqmContributions_input_heading">Attach file:</span>'+'<input class="jqmContributions_input" type="file" name="upload"/>';}else{var htmlString='<span class="jqmContributions_input_heading">Delete attached file:</span>'+'<input class="jqmContributions_input" type="checkbox" id="'+deleteCBName+'"/>'+'<div id="'+fileDeleteDivName+'"></div>';}
$('#'+fileDivName).html(htmlString);if(offerFileDelete){insertFileReplaceDialog();$('#'+deleteCBName).click(function(){if($('#'+deleteCBName).attr('checked')){options.data.deleteFile=true;clearFileFields(options.data);}else{options.data.deleteFile=false;}
insertFileReplaceDialog();});}}
function isEditField(name){for(var i=0;i<options.formData.editFields.length;i++){if(name==options.formData.editFields[i].name){return(true);}}
return(false);}
function isFileDerivedField(name){return(name=='filename'||name=='mimetype'||name=='original_filename'||name=='file_size');}
if(!form){var myIndex=index;++index;var hiddenData='';for(var name in options.data){if(!options.data.isUpdate||(!isEditField(name)&&!isFileDerivedField(name)&&name!='deleteFile'&&name!='fileuse')){var value=options.data[name];hiddenData+='<input type="hidden" name="'+name+'" value="'+value+'"/>';}};$(dialog).empty();var formId='contributionForm_'+myIndex;form=$('<form id="'+formId+'" action="'+options.putUrl+'" method="post" enctype="multipart/form-data">'+hiddenData+'</form>');$(dialog).append(form);form.append('<p class="jqmContributions_instructions">'+options.formData.formIntroText+'</p>'+'<p class="jqmContributions_instructions">'+
(options.data.isUpdate?options.formData.updateNotice:options.formData.addNotice)+'</p>');for(var i=0;i<options.formData.editFields.length;i++){var inputs='';var iElem=$('<p></p>');form.append(iElem);if(options.formData.editFields[i].type!='file'){iElem.append('<span class="jqmContributions_input_heading">'+options.formData.editFields[i].label+':</span>');}
if(options.formData.editFields[i].type=='text'){inputs='<input class="jqmContributions_input" type="text" name="'+
options.formData.editFields[i].name+'"/>';}else if(options.formData.editFields[i].type=='textarea'){var _r=options.formData.editFields[i].rows;var _c=options.formData.editFields[i].cols;inputs='<textarea class="jqmContributions_input" '+'cols="'+(typeof _c!='undefined'&&_c!=null&&_c!=''?_c:'50')+'" '+'rows="'+(typeof _r!='undefined'&&_r!=null&&_r!=''?_r:'10')+'" name="'+
options.formData.editFields[i].name+'"></textarea>';}else if(options.formData.editFields[i].type=='date'){inputs='<input id="__contrib_date_'+options.formData.editFields[i].name+'" class="jqmContributions_input" name="'+options.formData.editFields[i].name+'" type="text">';}else if(options.formData.editFields[i].type=='file'){inputs='<div id="'+fileDivName+'"></div>';}else{alert('contributions::createForm: unknown field type: '+options.formData.editFields[i].type);}
iElem.append(inputs);if('file'==options.formData.editFields[i].type){insertFileDiv();}else if('date'==options.formData.editFields[i].type){var dpBaseOpts={dateFormat:'yy-mm-dd',gotoCurrent:true,changeYear:true};var dpOpt=$.extend({},dpBaseOpts,options.formData.editFields[i].dpOptionsFn());$('#__contrib_date_'+options.formData.editFields[i].name).datepicker(dpOpt);}}
form.append('<p>'+'<input class="jqmContributions_input" id="contributionSubmit_'+myIndex+'" '+'type="button" value="Submit"/>'+'<input class="jqmContributions_input" id="contributionCancel_'+myIndex+'" '+'type="button" value="Cancel"/><br/>'+'</p>');if(options.data.isUpdate){for(var i=0;i<options.formData.editFields.length;i++){var efName=options.formData.editFields[i].name;if('date'==options.formData.editFields[i].type){if(isDefined(options.data[efName])&&isDefined(options.data[efName].formatted)){$('#'+formId+' [name="'+efName+'"]').val(options.data[efName].formatted);}}else{$('#'+formId+' [name="'+efName+'"]').val(options.data[efName]);}};};$('#contributionSubmit_'+myIndex).click(function(evt){if(typeof options.data.deleteFile!='undefined'&&options.data.deleteFile){$('#'+formId).append('<input type="hidden" name="deleteFile" value="'+options.data.deleteFile+'"/>');$('#'+formId).append('<input type="hidden" name="fileuse" value=""/>');}else{$('#'+formId).append('<input type="hidden" name="fileuse" value="'+
(typeof options.data.fileuse=='undefined'?'':options.data.fileuse)+'"/>');}
UserSubmit();});$('#contributionCancel_'+myIndex).click(function(evt){UserCancel();});}};function createHiddenForm(options){var form=$('<form action="'+options.putUrl+'" method="post" enctype="multipart/form-data"></form>');for(var name in options.data){var value=options.data[name];var data=$('<input type="hidden" name="'+name+'"/>');form.append(data);data.attr('value',value);};return form;};function createDialog(options){if(!dialog){dialog=$('<div></div>');$(dialog).dialog({autoOpen:false,modal:true,width:'auto',title:_loc('Contribution'),close:function(event,ui){var diag=$(event.target);}});}
createForm(options);};return{acceptsContribution:function(options_){var options=$.extend(true,{},contributionOptions,options_);options.data.isUpdate=false;createDialog(options);$(dialog).dialog('open');},acceptsContributionUpdate:function(options_){var options=$.extend(true,{},contributionOptions,options_);function setFileFields(offerDelete){clearFileFields(options.data);if(offerDelete){options.data.deleteFile=false;}}
options.data.isUpdate=true;if(typeof options.data.filename!='undefined'&&options.data.filename!=null){if(options.data.filename!=''){setFileFields(true);}else{setFileFields(false);}}else{setFileFields(false);}
createDialog(options);$(dialog).dialog('open');},deleteContribution:function(options_){var options=$.extend(true,{},contributionOptions,options_);$.ajax({type:'GET',url:options.deleteUrl,data:options.data,dataType:'json',async:true,success:options.onSuccess,error:options.onError});},addContribution:function(options_){var options=$.extend(true,{},contributionOptions,options_);options.data.isUpdate=false;var form=createHiddenForm(options);$(document.body).append(form);_SubmitFormImmediate(options,form);},allowAnonymousContribution:function(){return(contributionOptions.anonymousAllowed);}};};function initContributionHandler($,options_){NUNALIIT_CONTRIBUTIONS=olkitContributions($,options_);};(function($){var defaultOptions={getUrl:'adhocQueries/query',onError:function(xmlHttpRequest,textStatus,errorThrown){log('olkitAdhocQueries error: ',textStatus,errorThrown);},onSuccess:function(result){}};var currentOptions=$.extend({},defaultOptions);function query(options_){var options=$.extend({},currentOptions,options_);var data={};if(typeof(options_.id)!='undefined'){data.id=options_.id;};if(typeof(options_.label)!='undefined'){data.label=options_.label;};if(typeof(options_.args)!='undefined'){data.args=options_.args.join(',');};$.ajax({type:'GET',url:options.getUrl,data:data,dataType:'json',async:true,success:success,error:options.onError});function success(resultObj){if(typeof(resultObj.results)=='undefined'){options.onError(null,'Invalid results',{});}else{options.onSuccess(resultObj.results);};};};function setDefaultOptions(options_){currentOptions=$.extend({},defaultOptions,options_)};$.NUNALIIT_ADHOC_QUERIES={query:query,setDefaultOptions:setDefaultOptions};})(jQuery);;(function($,$n2){var options=null;var feature=null;var repository={};var dbSearchEngine=null;var contributionDb=null;var NULL_RELATED_TO=-1;var cdf=null;function contributionAddClick(placeId,relatedTo){if($.NUNALIIT_AUTH){if($.NUNALIIT_AUTH.getUser()){if(NUNALIIT_CONTRIBUTIONS){var dataObj={place_id:placeId};if(relatedTo){dataObj.related_to=relatedTo;}
NUNALIIT_CONTRIBUTIONS.acceptsContribution({data:dataObj});}else{alert("Contribution module not installed.");};}else{$.NUNALIIT_AUTH.login({onSuccess:function(){contributionAddClick(placeId,relatedTo);},anonymousLoginAllowed:true});};}else{alert("Authentication module not installed.");};}
function contributionUpdateClick(contributionId){var contrib=getContribution(contributionId);if(null==contrib){return;};if($.NUNALIIT_AUTH){var dataObj=$.extend({},contrib);var allowed=false;if(null!=contrib.contributor){allowed=$.NUNALIIT_AUTH.isUpdateAllowed(contrib.contributor.display);}else{allowed=$.NUNALIIT_AUTH.isUpdateAllowed('');}
if(allowed){if(NUNALIIT_CONTRIBUTIONS){NUNALIIT_CONTRIBUTIONS.acceptsContributionUpdate({data:dataObj});}else{alert("Contribution module not installed.");};}else{$.NUNALIIT_AUTH.login({onSuccess:function(){contributionUpdateClick(contributionId,placeId);},anonymousLoginAllowed:false,prompt:'Please login.'});};}else{alert("Authentication module not installed.");};};function contributionDeleteClick(contributionId,placeId){if($.NUNALIIT_AUTH){var allowed=$.NUNALIIT_AUTH.isDeleteAllowed();if(allowed){if(NUNALIIT_CONTRIBUTIONS){if(confirm('Are you sure you want to delete this contribution?')){var options={data:{id:contributionId,placeId:placeId},onSuccess:onSuccess,onError:onError};NUNALIIT_CONTRIBUTIONS.deleteContribution(options);};}else{alert("Contribution module not installed.");};}else{$.NUNALIIT_AUTH.login({onSuccess:function(){contributionDeleteClick(contributionId,placeId);},anonymousLoginAllowed:false,prompt:'Please login with administrative credentials'});};}else{alert("Authentication module not installed.");};function onSuccess(msg,textStatus){};function onError(xmlHttpRequest,textStatus,errorThrown){alert('Error occurred while deleting a contribution. You might need to refresh your page.');};};$n2.contributionDisplayFormatter=function(aoOptions,dbSearchEngine_){var defaults={contribTableClassBase:"contrib",contributionAddClick:contributionAddClick,contribMediaClick:function(key,path,contribFormatterOptions){$n2.reportError('contribMediaClick not installed properly');},contributionDeleteClick:contributionDeleteClick,contributionUpdateClick:contributionUpdateClick,showRespondLink:false,showContribInfoIcons:false,keysAreStrings:false,showContribAuthor:true,mediaDisplayVideoWidth:320,mediaDisplayVideoHeight:240,showCreateTS:false,iconPath:'nunaliit2/images/',embedAudioDirectly:false,showLastEditInfo:true,additionalFields:[]};var options=$.extend({},defaults,aoOptions);var dbSearchEngine=dbSearchEngine_;var extensionType_basic="basic";var extensionType_startRelated="start_related";var extensionType_contRelated="cont_related";var extensionType_endRelated="end_related";function classExtensions(base,type,lastRow){var ret;if(extensionType_basic==type||extensionType_startRelated==type){ret=[base+'_fullwidth '+base+'_solid_top_border'];}else{ret=[base+'_left '+base+'_center_marker',base+'_right '+base+'_dashed_top_border'];}
if(lastRow){for(var j=0;j<ret.length;j++){ret[j]+=' '+base+'_solid_bottom_border';}}
return(ret);}
function getMediaIconClassExtension(type){return("_entry_"+type+"_icon");}
function getAltTagFromMediaType(type){return("a contributed "+type+" file");}
function formatKey(key){if(true==options.keysAreStrings){return("'"+key+"'");}else{return(key);}};function getContributorLabel(contribution){if(null==contribution||null==contribution.contributor){return('by <span class="'+options.contribTableClassBase+'_entry_contributor_unknown">Unknown</span>');};if(contribution.contributor.anonymous){return('by <span class="'+options.contribTableClassBase+'_entry_contributor_guest">Guest</span>');};if(contribution.contributor.display){return('by <span class="'+options.contribTableClassBase+'_entry_contributor_name">'+contribution.contributor.display+'</span>');};return('by <span class="'+options.contribTableClassBase+'_entry_contributor_unknown">Unknown</span>');};function getLastContributorLabel(contribution){if(null==contribution||null==contribution.lastContributor){return('Unknown');};if(contribution.lastContributor.anonymous){return('Guest');};if(contribution.lastContributor.display){return(contribution.lastContributor.display);};return('Unknown');};function formatFileSize(value_){var _1M=1048576;var _1K=1024;if(value_>_1M){return(''+(value_/_1M).toFixed(1)+'<br/>MBytes');}else if(value_>_1K){return(''+(value_/_1K).toFixed(1)+'<br/>KBytes');}
return(''+value_+'<br/>Bytes');}
function formatTimestamp(ts_){var d=new Date(ts_.raw);return(d.toString());}
return{formatAsTR:function(cont,parms,lastRow){var classExts=classExtensions(options.contribTableClassBase+"_entry",parms.rowType,lastRow);var mediaType;var isDeleteAllowed=false;var isUpdateAllowed=false;if($.NUNALIIT_AUTH){isDeleteAllowed=$.NUNALIIT_AUTH.isDeleteAllowed();if(null!=cont.contributor){isUpdateAllowed=$.NUNALIIT_AUTH.isUpdateAllowed(cont.contributor.display);}else{isUpdateAllowed=$.NUNALIIT_AUTH.isUpdateAllowed('');}};var htmlElem=$('<tr class="'+options.contribTableClassBase+'"></tr>');if(extensionType_basic==parms.rowType||extensionType_startRelated==parms.rowType){var tdElem=$('<td colspan="2" class="'+classExts[0]+'"></td>');htmlElem.append(tdElem);}else{var tdElem=$('<td class="'+classExts[0]+'"><img src="'+options.iconPath+'comment_relation.png" alt="related comment marker"/></td>');htmlElem.append(tdElem);var tdElem=$('<td class="'+classExts[1]+'"></td>');htmlElem.append(tdElem);}
mediaType=$n2.getMediaType(cont.filename,cont.mimetype);if(null!=mediaType){if(true!=options.embedAudioDirectly||'audio'!=mediaType){var htmlString='<div class="contrib_entry_media_icon_wrapper">'+'<div class="'+options.contribTableClassBase+'_entry_media_icon '+
options.contribTableClassBase+getMediaIconClassExtension(mediaType)+'"'+' alt="'+getAltTagFromMediaType(mediaType)+'">'+'</div>';if(typeof cont.file_size!='undefined'&&cont.file_size>0){htmlString+=formatFileSize(cont.file_size);}
htmlString+='</div>';var mediaIconDiv=$(htmlString);mediaIconDiv.click(function(){options.contribMediaClick(parms.key,dbSearchEngine.getRelMediaPath(),options);});tdElem.append(mediaIconDiv);}}else if(true==options.showContribInfoIcons){var mediaIconDiv=$('<div class="'+options.contribTableClassBase+'_entry_info_icon"'+' alt="'+getAltTagFromMediaType(mediaType)+'"></div>');mediaIconDiv.click(function(){options.contribMediaClick(parms.key,dbSearchEngine.getRelMediaPath(),options);});tdElem.append(mediaIconDiv);}
var titleElem=$('<p class="'+options.contribTableClassBase+'_entry_title">'+cont.title+'</p>');tdElem.append(titleElem);if(true==options.showContribAuthor){var contributorElem=$('<p class="'+options.contribTableClassBase+'_entry_contributor">'+
getContributorLabel(cont)+'</p>');tdElem.append(contributorElem);}
if(true==options.showCreateTS){var tsElem=$('<p class="'+options.contribTableClassBase+'_entry_createTS">Added: '+
formatTimestamp(cont.create_ts)+'</p>');tdElem.append(tsElem);}
if(null!=cont.notes&&""!=cont.notes){var notesElem=$('<p class="'+options.contribTableClassBase+'_entry_comment">'+cont.notes+'</p>');tdElem.append(notesElem);}
if(null!==options.additionalFields&&$n2.isArray(options.additionalFields)){for(var i=0;i<options.additionalFields.length;i++){var field=options.additionalFields[i];var fieldString=null;var textString=(!$n2.isDefined(field.text)||field.text===''?null:cont[field.text]);if($n2.isDefined(textString)&&textString!=''){if($n2.isDefined(field.leader)&&field.leader!=''){var tmp=field.leader.slice();textString=tmp.concat(textString);};};if($n2.isDefined(field.isUrl)&&true===field.isUrl){var urlString=(!$n2.isDefined(field.url)||field.url===''?null:cont[field.url]);fieldString=$n2.generateHyperlinkHTML(textString,urlString,options.contribTableClassBase+'_entry_field');}else{fieldString=$n2.generateHyperlinkHTML(textString,null,options.contribTableClassBase+'_entry_field');};if($n2.isDefined(fieldString)&&fieldString!=''){tdElem.append($(fieldString));};};};if(true==options.embedAudioDirectly&&'audio'==mediaType){var audioPara=$('<p class="'+options.contribTableClassBase+'_entry_embeddedAudio"></p>');tdElem.append(audioPara);var filePath=dbSearchEngine.getRelMediaPath()+cont.filename;var audioElem=$n2.mediaDisplay.generateInlineHtmlForMedia({type:mediaType,url:filePath,autoplay:false});audioPara.append(audioElem);}
if(true==options.showLastEditInfo){if(null!=cont.lastContributor&&null!=cont.last_edit_timestamp){var lastEditElem=$('<p class="'+options.contribTableClassBase+'_entry_last_edit">'+'Last edited by '+getLastContributorLabel(cont)+':'+
formatTimestamp(cont.last_edit_timestamp)+'</p>');tdElem.append(lastEditElem);}else if(null!=cont.lastContributor){var lastEditElem=$('<p class="'+options.contribTableClassBase+'_entry_last_edit">'+'Last edited by '+getLastContributorLabel(cont)+'</p>');tdElem.append(lastEditElem);}}
if(true==options.showRespondLink||isUpdateAllowed||isDeleteAllowed){var linkDiv=$('<div class="contrib_entry_link_group"></div>');tdElem.append(linkDiv);};if(true==options.showRespondLink){if(extensionType_basic==parms.rowType||extensionType_startRelated==parms.rowType){var respLinkElem=$('<a class="'+options.contribTableClassBase+'_entry_link" href="javascript:Respond">respond</a>');respLinkElem.click(function(){options.contributionAddClick(cont.place_id,parms.key);return false;});linkDiv.append(respLinkElem);}}
if(isUpdateAllowed){var updateLinkElem=$('<a class="'+options.contribTableClassBase+'_entry_link" href="javascript:Update">update</a>');updateLinkElem.click(function(){options.contributionUpdateClick(parms.key,cont.place_id);return false;});linkDiv.append(updateLinkElem);};if(isDeleteAllowed){var deleteLinkElem=$('<a class="'+options.contribTableClassBase+'_entry_link" href="javascript:Delete">delete</a>');deleteLinkElem.click(function(){options.contributionDeleteClick(parms.key,cont.place_id);return false;});linkDiv.append(deleteLinkElem);};return htmlElem;},getExtensionType_basic:function(){return(extensionType_basic);},getExtensionType_startRelated:function(){return(extensionType_startRelated);},getExtensionType_contRelated:function(){return(extensionType_contRelated);},getExtensionType_endRelated:function(){return(extensionType_endRelated);}};};function Configure(options_,dbSearchEngine_,contributionDb_){var defaults={displayDiv:null,attribDisplayType:'attributes',attribTableHeading:"Place Data:",attribTableDiv:null,attribTableClassBase:"attrib",attribHtmlFn:null,contribTableHeading:"Contributions:",contribAddButtonText:"Add Yours!",contribListEmptyText:"There are currently no contributions.",contribTableDiv:null,contribTableClassBase:"contrib",contribTableRespLinks:true,contribTableShowAuthor:true,contribTableShowCreateTS:true,contribEmbedAudioDirectly:false,contribShowLastEditInfo:true,contribMediaDisplayVideoHeight:240,contribMediaDisplayVideoWidth:320,contributionAddClick:contributionAddClick,contributionDeleteClick:contributionDeleteClick,contributionUpdateClick:contributionUpdateClick,contribMediaClick:contribMediaClick,contribAdditionalFields:[],contribIndexingType:'default',conribIndexField:null,contribIndexFn:null};options=$.extend({},defaults,options_);dbSearchEngine=dbSearchEngine_;contributionDb=contributionDb_;if(null===options.displayDiv||null===options.contribTableDiv||null===options.attribTableDiv){alert("$n2.placeInfo - displayDiv OR contribTableDiv OR attribTableDiv not specified.");return;}
var ddiv=document.getElementById(options.displayDiv);if(null===ddiv){alert("$n2.placeInfo - displayDiv ("+options.displayDiv+") not found.");return;}};function displayPlace(){$("#"+options.displayDiv).empty();if(options.attribDisplayType=='attributes'){genPlaceHtml_default(options.displayDiv);}else if(options.attribDisplayType=='function'&&options.attribHtmlFn!=null){options.attribHtmlFn(options.displayDiv,options,feature.attributes);}else{alert('$n2.placeInfo: unknown attribDisplayType or required parameters not defined');}}
function genPlaceHtml_default(divName){var workingHtml='<div id="'+options.attribTableDiv+'">'+'<p><table class="'+options.attribTableClassBase+'_header">'+'<tr class="'+options.attribTableClassBase+'_header">'+'<td>'+options.attribTableHeading+'</td></tr></table></p><p><table>';for(var i in feature.attributes){if(feature.attributes.hasOwnProperty(i)&&feature.attributes[i]!==null){workingHtml+='<tr><td class="label">'+i+': </td><td class="info">'+feature.attributes[i]+'</td></tr>';}}
workingHtml+='</table></p></div>';$("#"+options.displayDiv).html(workingHtml);}
function indexContributions(repository){if(options.contribIndexingType=='simple'){if(options.conribIndexField!=null){return(indexContributions_simple(options.conribIndexField,repository));}}else if(options.contribIndexingType=='function'){if(typeof options.contribIndexFn!='undefined'&&options.contribIndexFn!=null){return(options.contribIndexFn(repository));}}else{return(indexContributions_default(repository));}}
function parseTimestamp(ds){return(new Date(ds.raw));}
function indexContributions_default(rep){var rRelatedOrder=null;var skippedSome=false;var index=[];rRelatedOrder={};for(var m in rep){if(rep.hasOwnProperty(m)){if(null==rep[m].related_to||0==rep[m].related_to){var d=parseTimestamp(rep[m].create_ts);index.push({order:d,key:m,related_to:NULL_RELATED_TO,related_order:NULL_RELATED_TO});rRelatedOrder[m]=d;}else{skippedSome=true;}}}
if(!skippedSome){return index;}
for(var m in rep){if(rep.hasOwnProperty(m)){if(null!=rep[m].related_to&&0!=rep[m].related_to){index.push({order:parseTimestamp(rep[m].create_ts),key:m,related_to:(rRelatedOrder.hasOwnProperty(rep[m].related_to)?rep[m].related_to:NULL_RELATED_TO),related_order:(rRelatedOrder.hasOwnProperty(rep[m].related_to)?rRelatedOrder[rep[m].related_to]:NULL_RELATED_TO)});}}}
index.sort(function(a,b){if(NULL_RELATED_TO==a.related_to&&NULL_RELATED_TO==b.related_to){return(a.order-b.order);}else if(NULL_RELATED_TO==a.related_to&&NULL_RELATED_TO!=b.related_to){if(a.key==b.related_to){return(-1);}else{return(a.order-b.related_order);}}else if(NULL_RELATED_TO!=a.related_to&&NULL_RELATED_TO==b.related_to){if(a.related_to==b.key){return(1);}else{return(a.related_order-b.order);}}else{if(a.related_to==b.related_to){return(a.order-b.order);}else{return(a.related_order-b.related_order);}}});return index;};function indexContributions_simple(fieldName,rep){var index=[];for(var m in rep){if(rep.hasOwnProperty(m)){index.push({order:rep[m][fieldName],key:m});}}
index.sort(function(a,b){return(a.order-b.order);});return index;};function showAddContribButton(){var showIt=false;if(NUNALIIT_CONTRIBUTIONS){if(NUNALIIT_CONTRIBUTIONS.allowAnonymousContribution()){showIt=true;}else if($.NUNALIIT_AUTH){if($.NUNALIIT_AUTH.userLoggedInAndNotAnonymous()){showIt=true;}}}
return(showIt);}
function renderContributions(){var index=indexContributions(repository);if(null==cdf){cdf=$n2.contributionDisplayFormatter({contribTableClassBase:options.contribTableClassBase,contributionAddClick:options.contributionAddClick,contributionDeleteClick:options.contributionDeleteClick,contributionUpdateClick:options.contributionUpdateClick,contribMediaClick:options.contribMediaClick,showRespondLink:options.contribTableRespLinks,showContribAuthor:options.contribTableShowAuthor,showCreateTS:options.contribTableShowCreateTS,embedAudioDirectly:options.contribEmbedAudioDirectly,showLastEditInfo:options.contribShowLastEditInfo,mediaDisplayVideoWidth:options.contribMediaDisplayVideoWidth,mediaDisplayVideoHeight:options.contribMediaDisplayVideoHeight,additionalFields:options.contribAdditionalFields},dbSearchEngine);}
$("#"+options.displayDiv).append('<div id="'+options.contribTableDiv+'"> </div>')
var headElem=$('<p></p>');{var headTable=$('<table class="'+options.contribTableClassBase+'_header"></table>');headElem.append(headTable);var headTr=$('<tr class="'+options.contribTableClassBase+'_header"><td width="50%">'+options.contribTableHeading+'</td></tr>');headTable.append(headTr);if(showAddContribButton()){var headTd=$('<td align="center"></td>');headTr.append(headTd);var headButton=$('<input type="button" value="'+options.contribAddButtonText+'"></input>');headButton.click(function(){options.contributionAddClick(feature.attributes.place_id,null);});headTd.append(headButton);}}
var contribElem=null;if(0==index.length){contribElem=$('<p><table><tr><td>'+options.contribListEmptyText+'</td></tr></table></p>');}else{contribElem=$('<p></p>');var table=$('<table class="'+options.contribTableClassBase+'"></table>');contribElem.append(table);for(var i=0;i<index.length;i++){var parms={key:index[i].key};if('default'==options.contribIndexingType){if(i<index.length-1){if(NULL_RELATED_TO!=index[i].related_to){if(NULL_RELATED_TO!=index[i+1].related_to){parms.rowType=cdf.getExtensionType_contRelated();var trElem=cdf.formatAsTR(repository[parms.key],parms,((index.length-1)==i));table.append(trElem);}else{parms.rowType=cdf.getExtensionType_endRelated();var trElem=cdf.formatAsTR(repository[parms.key],parms,((index.length-1)==i));table.append(trElem);};}else{if(NULL_RELATED_TO!=index[i+1].related_to){parms.rowType=cdf.getExtensionType_startRelated();var trElem=cdf.formatAsTR(repository[parms.key],parms,((index.length-1)==i));table.append(trElem);}else{parms.rowType=cdf.getExtensionType_basic();var trElem=cdf.formatAsTR(repository[parms.key],parms,((index.length-1)==i));table.append(trElem);};};}else{if(NULL_RELATED_TO!=index[i].related_to){parms.rowType=cdf.getExtensionType_endRelated();var trElem=cdf.formatAsTR(repository[parms.key],parms,((index.length-1)==i));table.append(trElem);}else{parms.rowType=cdf.getExtensionType_basic();var trElem=cdf.formatAsTR(repository[parms.key],parms,((index.length-1)==i));table.append(trElem);};};}else{parms.rowType=cdf.getExtensionType_basic();var trElem=cdf.formatAsTR(repository[parms.key],parms,((index.length-1)==i));table.append(trElem);}};};$("#"+options.contribTableDiv).empty().append(headElem).append(contribElem);};function getContribution(key){return(repository[key]);};function contribMediaClick(key,path,contribFormatterOptions){var contrib=getContribution(key);if(null==contrib){return;};var mediaPath=path+contrib.filename;var mediaType=$n2.getMediaType(contrib.filename,contrib.mimetype);var mediaDisplayOptions={type:mediaType,url:mediaPath,mediaDisplayVideoHeight:contribFormatterOptions.mediaDisplayVideoHeight,mediaDisplayVideoWidth:contribFormatterOptions.mediaDisplayVideoWidth};if(contrib.title){mediaDisplayOptions.title=contrib.title;};if(true==contribFormatterOptions.showContribAuthor){if(contrib.contributor&&contrib.contributor.display){mediaDisplayOptions.author=contrib.contributor.display;};};$n2.mediaDisplay.displayMedia(mediaDisplayOptions);};$n2.placeInfo={Configure:Configure,setFeatureReinitDisplay:function(newFeature){feature=newFeature;repository={};displayPlace();},getPlaceId:function(){return(feature.attributes.place_id);},getFid:function(){return($n2.isDefined(feature)?feature.fid:-1);},loadAndRenderContributions:function(){if(feature.attributes.place_id){contributionDb.getContributionsFromPlaceId(feature.attributes.place_id,function(contributions){repository={};$.each(contributions,function(i,contribution){repository[contribution.id]=contribution;return(true);});renderContributions();});}},getContribution:getContribution};})(jQuery,nunaliit2);var $=window.jQuery;var $n2=window.nunaliit2;var _olkit_searchPanelHandler=null;function _olkit_searchInputKeyPressed(evt){var charCode=null;if(null!=evt&&null!=evt.which){charCode=evt.which;}else if(null!=window.event&&null!=window.event.keyCode){charCode=window.event.keyCode;}
if(13==charCode||null==charCode){_olkit_searchPanelHandler.textInputSubmitSearch();}}
var _olkit_recenterMapButtonTdId="_olkit_space_for_recenter_map_button";function _olkit_sp_mediaClick(key,path,contribFormatterOptions){if(null==_olkit_searchPanelHandler){return;}
var contrib=_olkit_searchPanelHandler.getSearchHit(key);if(null==contrib){return;}
var html='<div class="searchPanelDialog"><p><table class="attrib_header">'+'<tr class="attrib_header">'+'<td>Contribution Data:</td><td id="'+_olkit_recenterMapButtonTdId+'"></td></tr></table></p><p><table>';for(var i in contrib){var value=contrib[i];if(contrib.hasOwnProperty(i)&&null!=contrib[i]){if("score"==i||"id"==i||"related_to"==i||"contributor_id"==i){}else if("contributor"==i){if(value.anonymous){html+='<tr><td class="label">contributor:</td><td class="info">Guest</td></tr>';}else{html+='<tr><td class="label">contributor:</td><td class="info">'+value.display+'</td></tr>';};}else{html+='<tr><td class="label">'+i+': </td><td class="info">'+value+'</td></tr>';};}}
html+='</table></p>';html+=generateModalHtmlForMedia(contrib.filename,contrib.mimetype,path,contrib.title,contrib.notes);html+='</div>';var dialogOptions={autoOpen:true,modal:true,width:'auto',close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};$(html).dialog(dialogOptions);_olkit_searchPanelHandler.addTheMapRecenterButton(key);function generateModalHtmlForMedia(filename,mimetype,mediaPath,title,caption){if(null==filename||""==filename){return('');}
var type=$n2.getMediaType(filename,mimetype);if(null==type){return('');}
var mediaDisplayOptions={type:type,url:mediaPath+filename,footerHtml:null};if(typeof(caption)==='string'&&''!==caption){mediaDisplayOptions.caption=caption;};if(typeof(title)==='string'&&''!==title){mediaDisplayOptions.headerHtml=title;}
var htmlString=$n2.mediaDisplay.generateInlineHtmlForMedia(mediaDisplayOptions);return htmlString;};}
function _olkit_sp_placeClick(key){if(null==_olkit_searchPanelHandler){return;}
var place=_olkit_searchPanelHandler.getSearchHit(key);if(null==place){return;}
var workingHtml='<div class="searchPanelDialog"><p><table class="attrib_header">'+'<tr class="attrib_header">'+'<td>Place Data:</td><td id="'+_olkit_recenterMapButtonTdId+'"></td></tr></table></p><p><table>';for(var i in place){if(place.hasOwnProperty(i)&&null!=place[i]){if("score"!=i&&"id"!=i){workingHtml+='<tr><td class="label">'+i+': </td><td class="info">'+place[i]+'</td></tr>';}}}
workingHtml+='</table></p></div>';var dialogOptions={autoOpen:true,modal:true,width:'auto',close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};$(workingHtml).dialog(dialogOptions);_olkit_searchPanelHandler.addTheMapRecenterButton(key);}
function olkit_SearchPanel(aoOptions,dbSearchEngine_){var defaultOptions={panelDivName:"",textInputDivName:"",initialSearchText:"",contribTableClassBase:"",contribTableDiv:"",contribMediaClick:function(){},contribTableShowCreateTS:true,contribEmbedAudioDirectly:false,contribShowLastEditInfo:true,contribTableShowAuthor:true,contribMediaDisplayVideoHeight:240,contribMediaDisplayVideoWidth:320,ownerMapAndControls:null,markFeatureAsClicked:function(place_id){},sourceSrsName:'EPSG:4326',mapDisplaySrsName:'EPSG:900913',placeNameFieldName:'placename',subtitleStringFn:function(d){return('');}};var options=$.extend({},defaultOptions,aoOptions);var dbSearchEngine=dbSearchEngine_;var initialSearchText="search the atlas";var lastSearchedString="";var lastDisplayedString="";var searchHits={};var displayProj=new OpenLayers.Projection(options.mapDisplaySrsName);var sourceProj=new OpenLayers.Projection(options.sourceSrsName);function cKey(num){return("c"+num);}
function pKey(num){return("p"+num);}
function searchHitIsCont(key){return("c"==key.charAt(0));}
function searchHitIsPlace(key){return("p"==key.charAt(0));}
var contributionsFetched=false;var placesFetched=false;function doDisplay(searchString){if(true==contributionsFetched&&true==placesFetched){lastSearchedString=searchString;displaySearchSummmary(searchString);}}
function fetchMatchingContributions(searchString){dbSearchEngine.searchForContributions(ti.value,function(contributions){for(var i=0;i<contributions.length;i++){searchHits[cKey(i)]={score:contributions[i].score,data:contributions[i]};};contributionsFetched=true;doDisplay(searchString);});};function fetchMatchingPlaces(searchString){dbSearchEngine.searchForPlaceNames(ti.value,function(names){for(var i=0;i<names.length;i++){searchHits[pKey(i)]={score:names[i].score,data:names[i]};};placesFetched=true;doDisplay(searchString);});};function formatPlaceAsTR(key,lastRow){var tdClassBase=options.contribTableClassBase+'_entry';var tdClasses=tdClassBase+'_fullwidth '+tdClassBase+'_solid_top_border';if(true==lastRow){tdClasses+=' '+tdClassBase+'_solid_bottom_border'}
var trElem=$('<tr class="'+options.contribTableClassBase+'"></tr>');var tdElem=$('<td colspan="2" class="'+tdClasses+'">');trElem.append(tdElem);var placeNameHtml='<p class="'+options.contribTableClassBase+'_entry_title">'+
searchHits[key].data[options.placeNameFieldName];if('undefined'!=typeof options.subtitleStringFn&&null!=options.subtitleStringFn){placeNameHtml+=options.subtitleStringFn(searchHits[key].data)}
placeNameHtml+='</p>';var placeNameElem=$(placeNameHtml);tdElem.append(placeNameElem);var iconDivElem=$('<div class="'+options.contribTableClassBase+'_entry_place_icon"'+' alt="place information icon"></div>');iconDivElem.click(function(){_olkit_sp_placeClick(key);});tdElem.append(iconDivElem);return(trElem);}
var cdf=$n2.contributionDisplayFormatter({contribTableClassBase:options.contribTableClassBase,contribMediaClick:_olkit_sp_mediaClick,showRespondLink:false,showContribInfoIcons:true,keysAreStrings:true,showCreateTS:options.contribTableShowCreateTS,embedAudioDirectly:false,showLastEditInfo:options.contribShowLastEditInfo,showContribAuthor:options.contribTableShowAuthor,mediaDisplayVideoHeight:options.contribMediaDisplayVideoHeight,mediaDisplayVideoWidth:options.contribMediaDisplayVideoWidth,additionalFields:[]},dbSearchEngine);function displaySearchSummmary(searchString){$("#"+options.panelDivName).empty();$("#"+options.panelDivName).html('<div id="'+options.contribTableDiv+'"> </div>');var index=new Array();for(var k in searchHits){if(searchHits.hasOwnProperty(k)){var row=new Array();row[0]=k;row[1]=searchHits[k].score;index.push(row);}}
index.sort(function(a,b){return(a[1]-b[1]);});var htmlHeader=$('<p><table class="'+options.contribTableClassBase+'_header">'+'<tr class="'+options.contribTableClassBase+'_header">'+'<td width="50%">Search Results:</td></tr></table></p>');if(0==index.length){var htmlElem=$('<p><table><tr><td>There are no matching results.</td></tr></table></p>');}else{var htmlElem=$('<p></p>');var table=$('<table class="'+options.contribTableClassBase+'"></table>');htmlElem.append(table);for(var i=0;i<index.length;i++){if(searchHitIsPlace(index[i][0])){var tr=formatPlaceAsTR(index[i][0],((index.length-1)==i));table.append(tr);}else{var parms={key:index[i][0],rowType:cdf.getExtensionType_basic()};var tr=cdf.formatAsTR(searchHits[parms.key].data,parms,((index.length-1)==i));table.append(tr);};};};$("#"+options.contribTableDiv).empty().append(htmlHeader).html(htmlElem);lastDisplayedString=searchString;}
var inputName="_olkit_searchInput";var html='<input id="'+inputName+'" type="text" class="search_panel_input"'+' onkeypress="_olkit_searchInputKeyPressed(event)"'+' value="'+options.initialSearchText+'"></input>';$("#"+options.textInputDivName).html(html);var ti=document.getElementById(inputName);function searchedResultsAreCurrent(){return(ti.value==lastSearchedString&&""!=ti.value);}
function displayedResultsAreCurrent(){return(lastSearchedString==lastDisplayedString);}
$("#"+inputName).focus(function(){if(initialSearchText==ti.value){ti.value="";}
ti.select();});$("#"+inputName).blur(function(){if(initialSearchText==ti.value){ti.value="";}
ti.blur();});function processSearchInput(){var searchTerm=ti.value;if(null!=searchTerm&&""!=searchTerm){if(searchedResultsAreCurrent()&&!displayedResultsAreCurrent()){displaySearchSummmary();}else{searchHits={};contributionsFetched=false;fetchMatchingContributions(searchTerm);placesFetched=false;fetchMatchingPlaces(searchTerm);}}}
function addMapRecenterButtonToModalDisplay(place_id,centerX,centerY){$("#"+_olkit_recenterMapButtonTdId).append('<input type="button" value="Centre map on location"'+' onclick="_olkit_searchPanelHandler.moveMapToNewCenter('+place_id+','+centerX+','+centerY+')"/>');};function addOrphanedToModalDisplay(place_id){$("#"+_olkit_recenterMapButtonTdId).text('The place associated with this contribution was deleted.');}
return{textInputSubmitSearch:function(){processSearchInput();},getSearchHit:function(key){return(searchHits[key].data);},deactivated:function(){lastDisplayedString="";ti.blur();},moveMapToNewCenter:function(place_id,centerX,centerY){$(".searchPanelDialog").dialog('close');var ll=new OpenLayers.LonLat(centerX,centerY);ll.transform(sourceProj,displayProj);options.ownerMapAndControls.recentreMap(ll);options.markFeatureAsClicked({uniqueId:place_id});},addTheMapRecenterButton:function(key){if(searchHitIsCont(key)){dbSearchEngine.findGeometryCentroidFromPlaceId(searchHits[key].data.place_id,function(names){if(names&&names.length>0){var name=names[0];if(null==name||null==name.x||null==name.y){addOrphanedToModalDisplay(searchHits[key].data.place_id);}else{addMapRecenterButtonToModalDisplay(name.place_id,name.x,name.y)};};});}else{dbSearchEngine.findGeometryCentroidFromId(searchHits[key].data.id,function(names){if(names&&names.length>0){var name=names[0];if(null==name||null==name.x||null==name.y){addOrphanedToModalDisplay(searchHits[key].data.place_id);}else{addMapRecenterButtonToModalDisplay(name.place_id,name.x,name.y)};};});};}};};(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var DH='n2.mapAndControls';function OlkitAttributeFormManagerSidePanel(options_){var defaultOptions={tableName:'names',geomName:'the_geom',panelName:'side',selectAudioFn:function(feature_,cbFn){alert('Feature not supported');},onFeatureInsertedFn:function(fid,feature){},onFeatureUpdatedFn:function(fid,feature){},onFeatureDeletedFn:function(fid,feature){},onCancelFn:function(){},onCloseFn:function(){},uniqueIdentifier:'place_id'};var options=$.extend({},defaultOptions,options_);var defaultFieldOpts={'layer':{defaultValue:1,choices:[{value:0,label:'Admin'},{value:1,label:'Public'}]},'hover_audio':{defaultValue:'',select:function(cbFn){options.selectAudioFn(feature_,cbFn);}}};var cancelled=true;var editedFeature=null;var editedLayer=null;var originalGeometry=null;var originalStyle=null;var attributeDialog=null;var dbWebForm=null;var isInsert=0;function showAttributeForm(feature_){editedFeature=feature_;editedLayer=editedFeature.layer;cancelled=false;isInsert=false;originalGeometry=editedFeature.geometry.clone();originalStyle=editedFeature.style;editedLayer.events.register('featuremodified',editedFeature,featureModified);attributeDialog=$('#'+options.panelName);attributeDialog.empty();var dialogHeader=$('<p class="olkitAttrFormFeatureInstructions">Enter or edit the place attribute values:</p>');attributeDialog.append(dialogHeader);var attributeForm=$('<div class="olkitAttrFormFeatureAttributes"></div>');attributeDialog.append(attributeForm);var formButtons=$('<div class="olkitAttrFormButtons"></div>');installCancelButton();attributeDialog.append(formButtons);var fOpts=$.extend({},defaultFieldOpts,options.fieldOpts);var dbWebFormOptions={tableName:options.tableName,installButtons:function(buttons){formButtons.empty();if(buttons.Save){installSaveButton(buttons.Save);};if(buttons['Delete']){installDeleteButton(buttons['Delete']);};installCancelButton();},fieldOpts:fOpts,onError:onError};var ids=editedFeature.fid?editedFeature.fid.split('.'):[];if(ids.length>1){dbWebFormOptions.whereClauses=[$.NUNALIIT_DBWEB.formatWhereClause('id',$.NUNALIIT_DBWEB.whereComparison_eq,ids[1])];}else if(editedFeature.attributes[options.uniqueIdentifier]){dbWebFormOptions.whereClauses=[$.NUNALIIT_DBWEB.formatWhereClause(options.uniqueIdentifier,$.NUNALIIT_DBWEB.whereComparison_eq,editedFeature.attributes[options.uniqueIdentifier])];}else{isInsert=true;dbWebFormOptions.data=$.extend({},editedFeature.attributes);var geom=convertFeatureGeometryForDb(editedFeature);dbWebFormOptions.data[options.geomName]=''+geom;};dbWebForm=attributeForm.dbWebForm(dbWebFormOptions);function installSaveButton(cbFn){var button=$('<input type="button" value="Save"/>');button.click(function(evt){cbFn({onSuccess:onSaved,onError:function(){alert('Error occurred while saving data');}});});formButtons.append(button);};function installDeleteButton(cbFn){var button=$('<input type="button" value="Delete"/>');button.click(function(evt){if(confirm('Do you really want to delete this feature?')){cbFn({onSuccess:onDeleted,onError:function(){alert('Error occurred while deleting data');}});};});formButtons.append(button);};function installCancelButton(){var button=$('<input type="button" value="Cancel"/>');button.click(function(evt){cancelAttributeForm();});formButtons.append(button);};function onSaved(savedData){if(isInsert){var fid=options.tableName+'.'+savedData.id;options.onFeatureInsertedFn(fid,editedFeature);}else{var fid=feature_.fid;options.onFeatureUpdatedFn(fid,editedFeature);};discardAttributeForm();};function onDeleted(){var fid=feature_.fid;options.onFeatureDeletedFn(fid,feature_);discardAttributeForm();};function onError(error){attributeDialog.empty();var errorDiv=$('<div class="olkitAttrFormError"></div>');attributeDialog.append(errorDiv);formButtons.empty();installCancelButton();attributeDialog.append(formButtons);var ul=$('<ul></ul>');errorDiv.append(ul);currentError=error;while(currentError){var li=$('<li>'+currentError.message+'</li>');ul.append(li);currentError=currentError.cause;};};};function cancelAttributeForm(){if(cancelled)return;cancelled=true;options.onCancelFn(editedFeature);if(editedFeature&&originalGeometry){if(editedFeature.layer){editedFeature.layer.eraseFeatures([editedFeature]);};editedFeature.geometry=originalGeometry;};discardAttributeForm();};function discardAttributeForm(){if(null==attributeDialog){return;};attributeDialog.empty();attributeDialog=null;dbWebForm=null;if(editedFeature){editedLayer.events.unregister('featuremodified',editedFeature,featureModified);if(null!==editedFeature.layer){editedFeature.style=originalStyle;editedFeature.layer.drawFeature(editedFeature);};};options.onCloseFn(editedFeature);editedFeature=null;editedLayer=null;originalGeometry=null;originalStyle=null;};function convertFeatureGeometryForDb(feature){var proj=feature.layer.map.projection;var internalSrsName=proj.getCode();if(internalSrsName!='EPSG:4326'){var geom=editedFeature.geometry.clone();var dbProj=new OpenLayers.Projection('EPSG:4326');geom.transform(proj,dbProj);return geom;};return feature.geometry;};function featureModified(evt_){var feature=evt_.feature;var geom=convertFeatureGeometryForDb(feature);if(dbWebForm){dbWebForm.updateData(options.geomName,''+geom);};};return{showAttributeForm:showAttributeForm,cancelAttributeForm:cancelAttributeForm};};var GazetteerProcess=$n2.Class({geoNamesService:null,initialize:function(geoNamesService_){this.geoNamesService=geoNamesService_;},initiateCapture:function(mapControl){var _this=this;var dialogId=$n2.getUniqueId();var $dialog=$('<div></div>').attr('id',dialogId).addClass('n2MapAndControls_gazette_dialog');var inputId=$n2.getUniqueId();$('<div><input id="'+inputId+'" type="text"/></div>').appendTo($dialog);$('<div class="n2MapAndControls_gazette_results"></div>').appendTo($dialog);var dialogOptions={autoOpen:true,modal:true,title:_loc('Create feature from name'),width:'auto',close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};$dialog.dialog(dialogOptions);var $input=$('#'+inputId);this.geoNamesService.installAutoComplete({input:$input});var request={mapControl:mapControl,dialogId:dialogId,val:null,location:null};$input.keydown(function(e){var key=e.which;if(key===13){var $input=$('#'+inputId);var val=$input.val();if($input.autocomplete){$input.autocomplete('close');};request.name=val;_this._searchForName(request);};return true;});this._findCurrentLocation(request);},_searchForName:function(request){var _this=this;var countryBias=null;if(request.location&&request.location.countryCode){countryBias=request.location.countryCode;};$('#'+request.dialogId).find('.n2MapAndControls_gazette_results').empty();this.geoNamesService.getName({name:request.name,featureClass:$n2.GeoNames.FeatureClass.PLACES,maxRows:25,countryBias:countryBias,onSuccess:function(results){var $div=$('#'+request.dialogId).find('.n2MapAndControls_gazette_results').empty();for(var i=0,e=results.length;i<e;++i){var entry=results[i];if(entry.geonameId){var $entry=$('<div></div>').addClass('n2MapAndControls_gazette_result').appendTo($div);var name=entry.name;if(entry.adminName1){name+=', '+entry.adminName1;};if(entry.countryName){name+=', '+entry.countryName;};$('<div></div>').addClass('n2MapAndControls_gazette_result_name').text(name).appendTo($entry);_this._installOnClick(request,$entry,entry);if(entry.lng&&entry.lat){var longLat=entry.lng+','+entry.lat;$('<div></div>').addClass('n2MapAndControls_gazette_result_location').text(longLat).appendTo($entry);};};};}});},_installOnClick:function(request,$entry,entry){var _this=this;$entry.click(function(){_this._selectEntry(request,entry);});},_selectEntry:function(request,entry){var $dialog=$('#'+request.dialogId);$dialog.dialog('close');var editLayer=request.mapControl.editLayer;var map=request.mapControl.map;var geom=new OpenLayers.Geometry.Point(1*entry.lng,1*entry.lat);var mapProjection=map.projection;var gazetteProjection=new OpenLayers.Projection('EPSG:4326');if(gazetteProjection.getCode()!=mapProjection.getCode()){geom.transform(gazetteProjection,mapProjection);};var ll=new OpenLayers.LonLat(geom.x,geom.y);map.setCenter(ll);var feature=new OpenLayers.Feature.Vector(geom);feature.data.nunaliit_gazetteer={};for(var key in entry){var value=entry[key];feature.data.nunaliit_gazetteer[key]=value;};editLayer.addFeatures([feature]);},_findCurrentLocation:function(request){var map=request.mapControl.map;var ll=map.getCenter();if(ll){var mapProjection=map.projection;var gazetteProjection=new OpenLayers.Projection('EPSG:4326');if(gazetteProjection.getCode()!=mapProjection.getCode()){ll.transform(mapProjection,gazetteProjection);};this.geoNamesService.findNearby({lng:ll.lon,lat:ll.lat,maxRows:1,onSuccess:function(results){if(results&&results.length){var entry=results[0];request.location=entry;};},onError:function(err){}});};}});var zoomInClusterClickCallback=function(feature,mapAndControls){var clusterGeom=feature.geometry;var newCenter=null;if(clusterGeom){newCenter=clusterGeom.getBounds().getCenterLonLat();};if(newCenter){mapAndControls.map.setCenter(newCenter,mapAndControls.map.zoom+1);mapAndControls._endHover();};};var multiSelectClusterClickCallback=function(feature,mapAndControls){var docIds=[];if(feature.cluster){for(var i=0,e=feature.cluster.length;i<e;++i){var f=feature.cluster[i];if(f&&f.data&&f.data._id){docIds.push(f.data._id);};};};if(docIds.length){mapAndControls._dispatch({type:'userSelect',docIds:docIds});};};function basicPopupHtmlFunction(opt_){var attrs=opt_.feature.attributes;var resArray=[];resArray.push('Name: '+(attrs.placename?attrs.placename:'')+'<br/>');resArray.push('Meaning: '+(attrs.meaning?attrs.meaning:'')+'<br/>');resArray.push('Entity: '+(attrs.entity?attrs.entity:'')+'<br/>');var html=resArray.join('');opt_.onSuccess(html);};function suppressPopupHtmlFunction(opts_){var opts=$n2.extend({feature:null,layerInfo:null,onSuccess:null,onError:null},opts_);opts.onSuccess(null);};var MapAndControls=$n2.Class({options:null,dbSearchEngine:null,contributionDb:null,map:null,editLayer:null,html:null,lastMapXy:null,mapMouseMoveListeners:null,olkitDisplayOptions:null,pendingMarkInfo:null,attributeFormManagerOptions:null,attributeFormManager:null,currentPopup:null,dhtmlSoundDivId:null,initialZoomBounds:null,selectFeatureControl:null,hoverInfo:null,clickedInfo:null,focusInfo:null,findFeatureInfo:null,modes:null,currentMode:null,navigationControls:null,editControls:null,editFeatureControls:null,editModeAddFeatureEnabled:null,editModeAddFeatureCallback:null,convertToMultiGeometry:null,editFeatureFid:null,cometEnabled:null,fidChannel:null,contributionChannel:null,defaultStyleMap:null,styleFilterIndex:null,styleFilters:null,defaultLayerInfo:null,mapLayers:null,vectorLayers:null,infoLayers:null,layers:null,mapBusyCount:null,busyMapControl:null,initialize:function(options_){var _this=this;if(typeof(OpenLayers)=='undefined'){$n2.reportError('OpenLayers is required.');return null;};var defaultOptions={mapCoordinateSpecifications:{srsName:'EPSG:4326',maxExtent:[-180,-85.05,180,85.05],restrictedExtent:null,initialBounds:[-180,-90,180,90],useForMapControls:true},mapDisplay:{srsName:'EPSG:900913',background:null,maxResolution:156543.0339,units:'m'},addPointsOnly:false,placeDisplay:{attribDisplayType:'attributes',attribTableHeading:"Place Data:",attribTableDiv:"side_attrib",attribTableClassBase:"attrib",attribHtmlFn:null,contribTableDiv:"side_contrib",contribTableClassBase:"contrib",contribTableShowAuthor:true,contribTableShowCreateTS:true,contribEmbedAudioDirectly:false,contribShowLastEditInfo:true,contribMediaDisplayVideoHeight:240,contribMediaDisplayVideoWidth:320,contribAdditionalFields:[],contribIndexingType:'default',contribInsertedReloadAddContrib:true,contribInsertedReloadDataFn:null,contributionOptions:{anonymousAllowed:true}},saveFeature:{},sidePanelName:'side',filterPanelName:null,toggleClick:true,uniqueIdentifier:'place_id',layerSwitcher:{suppress:false,initiallyOpened:false},directory:null,mapIdentifier:'map',mapInteractionDivName:'map_interaction_div'};this.options=$.extend(true,{},defaultOptions,options_);this.dbSearchEngine=$n2.dbSearchEngine((options_?options_.dbSearchEngine:null));this.contributionDb=$n2.contributionDb((options_?options_.contributionDb:null));this.map=null;this.editLayer=null;this.html="";this.lastMapXy=null;this.mapMouseMoveListeners=[];this.olkitDisplayOptions={};this.pendingMarkInfo=null;this.mapBusyCount=0;this.dhtmlSoundDivId=$n2.getUniqueId();this.editFeatureFid=null;this.selectFeatureControl=null;this.hoverInfo={feature:null,endFn:[]};this.clickedInfo={features:[],endFn:[],fids:{},selectedId:null};this.focusInfo={fids:{},features:[]};this.findFeatureInfo={fid:null,features:[]};var addOrEditLabel=_loc('Add or Edit a Map Feature');var cancelLabel=_loc('Cancel Feature Editing');var customService=this._getCustomService();if(customService){var customAdd=customService.getOption('mapLabelEditFeature',null);if(customAdd){addOrEditLabel=customAdd;};var customCancel=customService.getOption('mapLabelCancelEdit',null);if(customCancel){cancelLabel=customCancel;};};this.modes={NAVIGATE:{name:"NAVIGATE",buttonValue:addOrEditLabel,onStartHover:function(feature,layer){_this._hoverFeature(feature,layer);_this._hoverFeaturePopup(feature,layer);},onStartClick:function(feature,mapFeature){_this.initAndDisplayClickedPlaceInfo(feature);},onEndClick:function(feature){},featureAdded:function(feature){}},ADD_OR_SELECT_FEATURE:{name:"ADD_OR_SELECT",buttonValue:cancelLabel,onStartHover:function(feature,layer){_this._hoverFeature(feature,layer);_this._hoverFeaturePopup(feature,layer);},onStartClick:function(feature,mapFeature){var editAllowed=true;if(mapFeature.cluster&&mapFeature.cluster.length>1){alert(_loc('This feature is a cluster and can not be edited directly. Please, zoom in to see features within cluster.'));editAllowed=false;};if(editAllowed){_this.switchToEditFeatureMode(feature.fid,mapFeature);_this._dispatch({type:'editInitiate',docId:null,feature:feature,create:true});};},onEndClick:function(feature){},featureAdded:function(feature){_this._dispatch({type:'editInitiate',docId:null,feature:feature,create:true});}},ADD_GEOMETRY:{name:"ADD_GEOMETRY",buttonValue:cancelLabel,onStartHover:function(feature,layer){_this._hoverFeature(feature,layer);_this._hoverFeaturePopup(feature,layer);},featureAdded:function(feature){var proj=null;if(feature&&feature.layer&&feature.layer.map){proj=feature.layer.map.projection;};_this._dispatch({type:'mapGeometryAdded',feature:feature,geom:feature.geometry,proj:proj,_origin:_this});}},EDIT_FEATURE:{name:"EDIT_FEATURE",buttonValue:cancelLabel,featureAdded:function(feature){}}};this.currentMode=this.modes.NAVIGATE;this.cometEnabled=true;this.fidChannel='/fid';this.contributionChannel='/contribution';this._registerDispatch('documentVersion');this._registerDispatch('documentDeleted');this._registerDispatch('cacheRetrieveDocument');this._registerDispatch('featureCreated');this._registerDispatch('featureUpdated');this._registerDispatch('addLayerToMap');this._registerDispatch('selected');this._registerDispatch('selectedSupplement');this._registerDispatch('unselected');this._registerDispatch('focusOn');this._registerDispatch('focusOff');this._registerDispatch('focusOnSupplement');this._registerDispatch('findIsAvailable');this._registerDispatch('find');this._registerDispatch('searchInitiate');this._registerDispatch('editInitiate');this._registerDispatch('editCancel');this._registerDispatch('editClosed');this._registerDispatch('editGeometryModified');this._registerDispatch('mapRedrawLayer');this._registerDispatch('mapSetInitialExtent');this._registerDispatch('mapSetExtent');this._registerDispatch('mapResetExtent');this._registerDispatch('mapGetLayers');this._registerDispatch('setMapLayerVisibility');this._registerDispatch('mapSwitchToEditMode');this.defaultLayerInfo={sourceSrsName:'EPSG:4326',featurePrefix:null,featureType:null,featureNS:null,name:null,filter:null,featurePopupHtmlFn:null,featurePopupDelay:0,visibility:true,styleMapFn:function(layerInfo){return _this._createStyleMapFromLayerInfo(layerInfo);},styleMap:null,selectListener:function(isSelected,layerInfo){},clusterClickCallback:null};this.infoLayers=[];if(typeof(this.options.layerInfo)==='object'&&!$n2.isArray(this.options.layerInfo)){this.options.layerInfo=[this.options.layerInfo];};this.attributeFormManagerOptions={selectAudioFn:function(feature,onSelectCallback){_this.selectAudioMedia(feature,onSelectCallback);},onFeatureInsertedFn:function(fid,feature){_this.onAttributeFormInserted(fid,feature);},onFeatureUpdatedFn:function(fid,feature){_this.onAttributeFormUpdated(fid,feature);},onFeatureDeletedFn:function(fid,feature){_this.onAttributeFormDeleted(fid,feature);},onCancelFn:function(editedFeature){_this.onAttributeFormCancelled(editedFeature);},onCloseFn:function(editedFeature){_this.onAttributeFormClosed(editedFeature);},uniqueIdentifier:this.options.uniqueIdentifier,panelName:null};this.attributeFormManagerOptions.panelName=this.options.sidePanelName;if(this.options.saveFeature&&this.options.saveFeature.isFormEditor){this.attributeFormManager=this.options.saveFeature;}else{var afmOpts=$.extend({},this.attributeFormManagerOptions,(null!=this.options.saveFeature?this.options.saveFeature:{}));var attributeFormManagerCreateFn=afmOpts.createFn;if(!attributeFormManagerCreateFn){attributeFormManagerCreateFn=OlkitAttributeFormManagerSidePanel;}
this.attributeFormManager=attributeFormManagerCreateFn(afmOpts);};initContributionHandler(jQuery,this.options.placeDisplay.contributionOptions);if($.progress&&$.progress.addProgressTracker){function progressOnStopCb(keyInfo,options){if(keyInfo&&keyInfo.data&&keyInfo.data.place_id){if($n2.placeInfo.getPlaceId()==keyInfo.data.place_id){$n2.placeInfo.loadAndRenderContributions();}}};$.progress.addProgressTracker({onStart:function(){},onUpdate:function(){},onComplete:progressOnStopCb,onRemove:function(){}});}else{log('Progress module not found. Activity tracking will not be available.');};if($n2.placeInfo){this.olkitDisplayOptions=$.extend({},this.options.placeDisplay,{displayDiv:this.options.sidePanelName});$n2.placeInfo.Configure(this.olkitDisplayOptions,this.dbSearchEngine,this.contributionDb);};this.defaultStyleMap={'normal':{fillColor:"#ffffff",fillOpacity:0.4,strokeColor:"#ee9999",strokeOpacity:1,strokeWidth:1,strokeLinecap:"round",strokeDashstyle:"solid",pointRadius:6,pointerEvents:"visiblePainted"},'clicked':{fillColor:"#ffffff",fillOpacity:0.1,strokeColor:"#ff2200",strokeOpacity:1,strokeWidth:3,strokeLinecap:"round",strokeDashstyle:"solid",pointRadius:8,pointerEvents:"visiblePainted"},'hovered':{fillColor:"#0000ff",fillOpacity:0.4,strokeColor:"#0000ff",strokeOpacity:1,strokeWidth:1,strokeLinecap:"round",strokeDashstyle:"solid",pointRadius:6,pointerEvents:"visiblePainted",cursor:"pointer"},'hoveredClicked':{fillColor:"#0000ff",fillOpacity:0.4,strokeColor:"#ff2200",strokeOpacity:1,strokeWidth:3,strokeLinecap:"round",strokeDashstyle:"solid",pointRadius:8,pointerEvents:"visiblePainted",cursor:"pointer"},'filteredOut':{display:'none'}};this.styleFilterIndex=0;this.styleFilters={};this.createMapInteractionSwitch();var authService=this._getAuthService();if(authService){authService.addListeners(function(currentUser){_this.loginStateChanged(currentUser);});};this.editModeAddFeatureEnabled=true;this.editModeAddFeatureCallback=function(evt){if(_this.editModeAddFeatureEnabled){var feature=evt.feature;if(feature){feature._n2MapNewFeature=true;};var previousMode=_this.currentMode;_this.switchToEditFeatureMode(feature.fid,feature);previousMode.featureAdded(feature);};};this.convertToMultiGeometry=function(evt){for(var i=0;i<evt.features.length;++i){if(evt.features[i].geometry.CLASS_NAME===OpenLayers.Geometry.Point.prototype.CLASS_NAME){evt.features[i].geometry=new OpenLayers.Geometry.MultiPoint([evt.features[i].geometry]);}else if(evt.features[i].geometry.CLASS_NAME===OpenLayers.Geometry.LineString.prototype.CLASS_NAME){evt.features[i].geometry=new OpenLayers.Geometry.MultiLineString([evt.features[i].geometry]);}else if(evt.features[i].geometry.CLASS_NAME===OpenLayers.Geometry.Polygon.prototype.CLASS_NAME){evt.features[i].geometry=new OpenLayers.Geometry.MultiPolygon([evt.features[i].geometry]);};};};var mapProjection=new OpenLayers.Projection(this.options.mapDisplay.srsName);var userCoordProjection=new OpenLayers.Projection(this.options.mapCoordinateSpecifications.srsName);this.initialZoomBounds=new OpenLayers.Bounds(this.options.mapCoordinateSpecifications.initialBounds[0],this.options.mapCoordinateSpecifications.initialBounds[1],this.options.mapCoordinateSpecifications.initialBounds[2],this.options.mapCoordinateSpecifications.initialBounds[3]);if(userCoordProjection.getCode()!=mapProjection.getCode()){this.initialZoomBounds.transform(userCoordProjection,mapProjection);};var maxExt=new OpenLayers.Bounds(this.options.mapCoordinateSpecifications.maxExtent[0],this.options.mapCoordinateSpecifications.maxExtent[1],this.options.mapCoordinateSpecifications.maxExtent[2],this.options.mapCoordinateSpecifications.maxExtent[3]);if(userCoordProjection.getCode()!=mapProjection.getCode()){maxExt.transform(userCoordProjection,mapProjection);};var restrictedExtent=null;if(this.options.mapCoordinateSpecifications.restrictedExtent){restrictedExtent=new OpenLayers.Bounds(this.options.mapCoordinateSpecifications.restrictedExtent[0],this.options.mapCoordinateSpecifications.restrictedExtent[1],this.options.mapCoordinateSpecifications.restrictedExtent[2],this.options.mapCoordinateSpecifications.restrictedExtent[3]);if(userCoordProjection.getCode()!=mapProjection.getCode()){restrictedExtent.transform(userCoordProjection,mapProjection);};};this.map=new OpenLayers.Map(this.options.mapIdentifier,{projection:mapProjection,displayProjection:(this.options.mapCoordinateSpecifications.useForMapControls?userCoordProjection:mapProjection),units:this.options.mapDisplay.units,maxResolution:this.options.mapDisplay.maxResolution,maxExtent:maxExt,restrictedExtent:restrictedExtent,theme:null,zoomMethod:null});var navControls=this.map.getControlsByClass('OpenLayers.Control.Navigation');for(var i=0,e=navControls.length;i<e;++i){navControls[i].disableZoomWheel();};if(this.map.div){var $map=$(this.map.div);$map.find('.olControlZoomIn').attr('title',_loc('Zoom In'));$map.find('.olControlZoomOut').attr('title',_loc('Zoom Out'));};this.map.zoomToMaxExtent=function(){this.zoomToExtent(this.initialZoomBounds);};this.busyMapControl=new OpenLayers.Control.N2LoadingPanel();this.mapLayers=[];this.vectorLayers=[];this.infoLayers=[];this._genBackgroundMapLayers(this.options);var editLayerStyleMap=this._createEffectiveStyleMap(null);this.editLayer=new OpenLayers.Layer.Vector('Edit',{styleMap:editLayerStyleMap,displayInLayerSwitcher:false,projection:new OpenLayers.Projection('EPSG:4326'),renderers:['SVG','VML']});this.mapLayers.push(this.editLayer);this.vectorLayers.push(this.editLayer);var modifiedHandler=this._createFeatureModifiedHandler(this.editLayer);this.editLayer.events.register('featuremodified',null,modifiedHandler);this.layers={};if(this.options.layerInfo){for(var loop=0;loop<this.options.layerInfo.length;++loop){var layerOptions=this.options.layerInfo[loop];var lInfo=this.createLayerFromOptions(layerOptions);if(lInfo&&lInfo.olLayer){this.mapLayers.push(lInfo.olLayer);};};};if(this.options.overlays){for(var loop=0;loop<this.options.overlays.length;++loop){var layerDefinition=this.options.overlays[loop];var l=this._createOLLayerFromDefinition(layerDefinition,false);if(l){this.mapLayers.push(l);};};};var allLayersInitiallyInvisible=true;for(var i=0,e=this.infoLayers.length;i<e;++i){var olLayer=this.infoLayers[i].olLayer;if(true==olLayer.visibility){allLayersInitiallyInvisible=false;};};this.map.addLayers(this.mapLayers);this.map.addControl(new OpenLayers.Control.MousePosition({displayProjection:(this.options.mapCoordinateSpecifications.useForMapControls?userCoordProjection:mapProjection)}));var showLayerSwitcher=true;if(this.options.layerSwitcher&&this.options.layerSwitcher.suppress){showLayerSwitcher=false;};if(showLayerSwitcher){var layerSwitcherControl=null;if(OpenLayers.Control.NunaliitLayerSwitcher){layerSwitcherControl=new OpenLayers.Control.NunaliitLayerSwitcher();}else{layerSwitcherControl=new OpenLayers.Control.LayerSwitcher();};this.map.addControl(layerSwitcherControl);if(layerSwitcherControl&&layerSwitcherControl.div){layerSwitcherControl.div.setAttribute('title',_loc('Layer Selector'));};if(this.options.layerSwitcher&&this.options.layerSwitcher.initiallyOpened){layerSwitcherControl.maximizeControl();}else if(allLayersInitiallyInvisible){layerSwitcherControl.maximizeControl();};};this.map.zoomToExtent(this.initialZoomBounds);this.navigationControls={};this.editControls={};this.editFeatureControls={};this._installFeatureSelector();if(this.options.addPointsOnly){this.editControls.addPoints=new OpenLayers.Control.DrawFeature(this.editLayer,OpenLayers.Handler.Point);this.map.addControl(this.editControls.addPoints);}else{this.editControls.toolbar=new OpenLayers.Control.EditingToolbar(this.editLayer,{autoActivate:false});if(OpenLayers.Control.NunaliitGazetteer&&this.options.directory&&this.options.directory.geoNamesService){var geoNamesService=this.options.directory.geoNamesService;var gazetteerProcess=new GazetteerProcess(geoNamesService);var control=new OpenLayers.Control.NunaliitGazetteer({activateListener:function(){gazetteerProcess.initiateCapture(_this);}});this.editControls.toolbar.addControls([control]);};this.map.addControl(this.editControls.toolbar);this.editControls.toolbar.deactivate();this.editControls.toolbar.defaultControl=this.editControls.toolbar.controls[0];};this.map.addControl(this.busyMapControl);this.map.events.register('mousemove',null,function(evt){_this._handleMapMousePosition(evt);});this.initCometChannels();},getNamedLayerInfo:function(name){for(var i=0,e=this.infoLayers.length;i<e;++i){var layer=this.infoLayers[i];if(layer.name===name){return layer;}else if(layer.id===name){return layer;};}
return null;},insertSound:function(surl){var $dhtmlSoundDiv=$('#'+this.dhtmlSoundDivId);if($dhtmlSoundDiv.length<1){$dhtmlSoundDiv=$('<div></div>').attr('id',this.dhtmlSoundDivId).appendTo($('body'));};if(surl){var effectiveUrl=this.dbSearchEngine.getRelMediaPath(surl);$dhtmlSoundDiv.html('<embed src="'+effectiveUrl+'" hidden="true" autostart="true" loop="false"/>');}else{$dhtmlSoundDiv.empty();};},initAndDisplayClickedPlaceInfo:function(feature){var dispatchService=this._getDispatchService();if(dispatchService){dispatchService.send(DH,{type:'userSelect',docId:feature.data._id,doc:feature.data,feature:feature});}else{$n2.placeInfo.setFeatureReinitDisplay(feature);$n2.placeInfo.loadAndRenderContributions();};},_getMapFeaturesIncludingFid:function(fid){var features=[];for(var loop=0;loop<this.infoLayers.length;++loop){var layerInfo=this.infoLayers[loop];var feature=this._getLayerFeatureIncludingFid(layerInfo.olLayer,fid);if(feature){features.push(feature);};};return features;},_getLayerFeatureIncludingFid:function(layer,fid){if(layer&&layer.features){var loop;var features=layer.features;for(loop=0;loop<features.length;++loop){var feature=features[loop];if(feature.fid&&feature.fid===fid){return feature;}else if(feature.cluster){for(var j=0,k=feature.cluster.length;j<k;++j){var f=feature.cluster[j];if(f.fid&&f.fid===fid){return feature;};};};};};return null;},_getLayerFeaturesFromFilter:function(layer,filter){var r=[];if(layer&&layer.features){var features=layer.features;for(var i=0,e=features.length;i<e;++i){var f=features[i];if(filter.matches(f)){r.push(f);};};};return r;},_reloadFeature:function(filter,options_){var reloadInfoLayers=[];for(var loop=0;loop<this.infoLayers.length;++loop){var layerInfo=this.infoLayers[loop];var features=this._getLayerFeaturesFromFilter(layerInfo.olLayer,filter);if(features.length>0){reloadInfoLayers.push(layerInfo);};};if(0==reloadInfoLayers.length){for(var loop=0;loop<this.infoLayers.length;++loop){var layerInfo=this.infoLayers[loop];reloadInfoLayers.push(layerInfo);};};for(var loop=0;loop<reloadInfoLayers.length;++loop){var layerInfo=reloadInfoLayers[loop];this._loadFeatureOnLayer(layerInfo,filter,options_);};},_loadFeatureOnLayer:function(layerInfo,filter,options_){var _this=this;var reloadOptions=$n2.extend({onReloaded:function(feature){}},options_);var protocol=layerInfo.protocol;var olFilter=filter.getOpenLayerFilter();protocol.read({filter:olFilter,callback:createCallback(layerInfo,reloadOptions)});function createCallback(layerInfo,reloadOptions){var cb=function(resp){if(resp.code!==OpenLayers.Protocol.Response.SUCCESS){alert('Error while obtaining a new feature.\n'
+'Map might not display up-to-date information.\n'
+'You might need to refresh your page.');};var features=[];if(resp.features){for(var featureLoop=0;featureLoop<resp.features.length;++featureLoop){var feature=resp.features[featureLoop];if(null!=layerInfo.olFilter){if(false==layerInfo.olFilter.evaluate(feature.attributes)){feature=null;};};if(null!=feature){features.push(feature);};};};if(features.length>0){var remote=layerInfo.olLayer.projection;var local=layerInfo.olLayer.map.getProjectionObject();if(false==local.equals(remote)){for(var featureLoop=0;featureLoop<features.length;++featureLoop){var geom=features[featureLoop].geometry;if(null!=geom){geom.transform(remote,local);};};};};var featuresToAdd=[];var featuresToDestroy=[];for(var featureLoop=0;featureLoop<features.length;++featureLoop){var loadedFeature=features[featureLoop];featuresToAdd.push(loadedFeature);var feature=_this._getLayerFeatureIncludingFid(layerInfo.olLayer,loadedFeature.fid);if(feature){if(feature.cluster){for(var j=0,k=feature.cluster.length;j<k;++j){var cf=feature.cluster[j];if(cf.fid!==loadedFeature.fid){featuresToAdd.push(cf);};};};featuresToDestroy.push(feature);}};if(featuresToDestroy.length>0){layerInfo.olLayer.destroyFeatures(featuresToDestroy);};if(_this.currentMode===_this.modes.ADD_OR_SELECT_FEATURE||_this.currentMode===_this.modes.ADD_GEOMETRY){_this.editModeAddFeatureEnabled=false;layerInfo.olLayer.addFeatures(featuresToAdd);_this.editModeAddFeatureEnabled=true;}else{layerInfo.olLayer.addFeatures(featuresToAdd);};for(var featureLoop=0;featureLoop<features.length;++featureLoop){var loadedFeature=features[featureLoop];reloadOptions.onReloaded(loadedFeature);};};return cb;};},_removeFeature:function(fid){for(var loop=0;loop<this.vectorLayers.length;++loop){var mapLayer=this.vectorLayers[loop];var feature=this._getLayerFeatureIncludingFid(mapLayer,fid);if(feature){if(feature.fid===fid){mapLayer.destroyFeatures(feature);}else if(feature.cluster){var remainingFeatures=null;for(var j=0,k=feature.cluster.length;j<k;++j){var cf=feature.cluster[j];if(cf.fid!==fid){if(!remainingFeatures)remainingFeatures=[];remainingFeatures.push(cf);};};mapLayer.destroyFeatures(feature);if(remainingFeatures){mapLayer.addFeatures(remainingFeatures);};};};};},_centerMapOnFeature:function(feature){var geom=feature.geometry;var bbox=geom.getBounds();var x=(bbox.left+bbox.right)/2;var y=(bbox.bottom+bbox.top)/2;this._centerMapOnXY(x,y,null);},_centerMapOnXY:function(x,y,projCode){var ll=new OpenLayers.LonLat(x,y);if(projCode&&projCode!=this.map.projection.getCode()){var proj=new OpenLayers.Projection(projCode);ll.transform(proj,this.map.projection);};var z=this.map.getZoom();this.map.setCenter(ll,z,false,false);},_installGeometryEditor:function(feature){if(!feature)return;if(!feature.layer)return;this._removeGeometryEditor(false);var modifyFeatureGeometry=new OpenLayers.Control.ModifyFeature(this.editLayer,{'displayClass':'olControlMoveFeature',standalone:true,clickout:false});modifyFeatureGeometry.mode=OpenLayers.Control.ModifyFeature.RESHAPE;this.map.addControl(modifyFeatureGeometry);modifyFeatureGeometry.activate();this.editFeatureControls.modifyFeatureGeometry=modifyFeatureGeometry;if(feature._n2MapNewFeature){modifyFeatureGeometry.selectFeature(feature);}else{var featureLayer=feature.layer;if(featureLayer){featureLayer.removeFeatures([feature],{silent:true});};var effectiveFeature=null;var geom=null;var featuresToAddBack=[];if(this.editFeatureFid===feature.fid){effectiveFeature=feature;geom=feature.geometry;}else if(feature.cluster){for(var i=0,e=feature.cluster.length;i<e;++i){if(this.editFeatureFid===feature.cluster[i].fid){effectiveFeature=feature.cluster[i];geom=feature.cluster[i].geometry;}else{featuresToAddBack.push(feature.cluster[i]);};};};if(featureLayer&&featuresToAddBack.length>0){featureLayer.addFeatures(featuresToAddBack);};if(geom){var editFeature=new OpenLayers.Feature.Vector(geom.clone());editFeature.fid=effectiveFeature.fid;editFeature._n2Original={restoreGeom:false,layer:featureLayer,feature:effectiveFeature,data:$n2.document.clone(effectiveFeature.data),style:feature.style};this.editModeAddFeatureEnabled=false;this.editLayer.addFeatures([editFeature]);this.editModeAddFeatureEnabled=true;modifyFeatureGeometry.selectFeature(editFeature);};};},_removeGeometryEditor:function(reinstateOrginalGeometry){if(null!=this.editFeatureControls.modifyFeatureGeometry){var editFeature=this.editFeatureControls.modifyFeatureGeometry.feature;if(null!=editFeature){this.editFeatureControls.modifyFeatureGeometry.unselectFeature(editFeature);};this.editFeatureControls.modifyFeatureGeometry.deactivate();this.map.removeControl(this.editFeatureControls.modifyFeatureGeometry);this.editFeatureControls.modifyFeatureGeometry.destroy();this.editFeatureControls.modifyFeatureGeometry=null;if(reinstateOrginalGeometry&&editFeature){var originalLayer=null;var originalFeature=null;var originalData=null;var originalStyle=null;var restoreGeom=false;if(editFeature._n2Original){originalLayer=editFeature._n2Original.layer;originalFeature=editFeature._n2Original.feature;originalData=editFeature._n2Original.data;originalStyle=editFeature._n2Original.style;restoreGeom=editFeature._n2Original.restoreGeom;};var effectiveFeature=null;var featuresToAdd=[];if(originalFeature&&editFeature.fid===originalFeature.fid){effectiveFeature=originalFeature;featuresToAdd.push(originalFeature);}else if(originalFeature&&originalFeature.cluster){for(var i=0,e=originalFeature.cluster.length;i<e;++i){var cf=originalFeature.cluster[i];if(editFeature.fid===cf.fid){effectiveFeature=cf;};featuresToAdd.push(cf);};};if(effectiveFeature){if(restoreGeom){effectiveFeature.data=originalData;}else{effectiveFeature.geometry=editFeature.geometry.clone();};effectiveFeature.style=originalStyle;};if(editFeature.layer){editFeature.layer.destroyFeatures([editFeature]);};if(originalLayer&&featuresToAdd.length>0){originalLayer.addFeatures(featuresToAdd);};};};},convertBoundsToMapProjection:function(bounds,srsName){var mapProjection=new OpenLayers.Projection(this.options.mapDisplay.srsName);var userCoordProjection=new OpenLayers.Projection(srsName);if(userCoordProjection.getCode()!=mapProjection.getCode()){bounds.transform(userCoordProjection,mapProjection);};},redrawMap:function(){var layers=this.map.layers;for(var loop=0;loop<layers.length;++loop){if(layers[loop].isBaseLayer){}else{layers[loop].redraw();};};},_createOverlayFromDefinition:function(layerDefinition,isBaseLayer){var _this=this;var cs=this._getCustomService();var layerInfo=$.extend({},this.defaultLayerInfo,layerDefinition);layerInfo.sourceProjection=new OpenLayers.Projection(layerInfo.sourceSrsName);layerInfo.name=_loc(layerInfo.name);if(!layerInfo.featurePopupHtmlFn){if(cs){var cb=cs.getOption('mapFeaturePopupCallback');if(typeof cb==='function'){layerInfo.featurePopupHtmlFn=cb;};};};if(!layerInfo.featurePopupHtmlFn){layerInfo.featurePopupHtmlFn=$n2.mapAndControls.DefaultPopupHtmlFunction;};if(!layerInfo.clusterClickCallback){if(cs){var cb=cs.getOption('mapClusterClickCallback');if(typeof cb==='function'){layerInfo.clusterClickCallback=cb;};};};if(!layerInfo.clusterClickCallback){layerInfo.clusterClickCallback=$n2.mapAndControls.ZoomInClusterClickCallback;};var layerOptions={name:layerInfo.name,projection:layerInfo.sourceProjection,visibility:layerInfo.visibility,_layerInfo:layerInfo};if('couchdb'===layerDefinition.type){var couchProtocolOpt=$n2.extend({},layerInfo.options,{notifications:{readStart:function(){_this._mapBusyStatus(1);},readEnd:function(){_this._mapBusyStatus(-1);}},sourceProjection:layerInfo.sourceProjection});layerInfo.protocol=new OpenLayers.Protocol.Couch(couchProtocolOpt);layerOptions.protocol=layerInfo.protocol;}else if('wfs'===layerDefinition.type){var wfsProtocolOptions={url:null,featurePrefix:null,featureType:null,featureNS:null,version:'1.1.0',geometryName:'the_geom'};if(layerDefinition.options){for(var key in layerDefinition.options){if('url'===key||'featurePrefix'===key||'featureType'===key||'featureNS'===key||'version'===key||'geometryName'===key){wfsProtocolOptions[key]=layerDefinition.options[key];};};};wfsProtocolOptions.readFormat=new OpenLayers.Format.GeoJSON();wfsProtocolOptions.outputFormat='json';layerInfo.typename=layerInfo.featurePrefix+':'+layerInfo.featureType;layerInfo.schema=wfsProtocolOptions.url
+'?service=WFS&version='+wfsProtocolOptions.version
+'&request=DescribeFeatureType&typeName='+layerInfo.typename;layerInfo.protocol=new OpenLayers.Protocol.WFS(wfsProtocolOptions);layerOptions.protocol=layerInfo.protocol;}else{$n2.reportError('Unrecognized type ('+layerInfo.type+') for layer: '+layerInfo.name);};var layerStyleMap=this._createEffectiveStyleMap(layerInfo);layerOptions.styleMap=layerStyleMap;layerInfo.olFilter=null;if(layerInfo.filter){layerInfo.olFilter=$n2.olFilter.CreateOpenLayersFilter(layerInfo.filter);if(null==layerInfo.olFilter){alert('Encountered invalid filter');}else{layerOptions.filter=layerInfo.olFilter;};};if(layerInfo.useFixedStrategy){var vecSourceExtent=new OpenLayers.Bounds(options.mapCoordinateSpecifications.maxExtent[0],options.mapCoordinateSpecifications.maxExtent[1],options.mapCoordinateSpecifications.maxExtent[2],options.mapCoordinateSpecifications.maxExtent[3]);if(userCoordProjection.getCode()!=layerInfo.sourceProjection.getCode()){vecSourceExtent.transform(userCoordProjection,layerInfo.sourceProjection);}
var bboxFilter=new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.BBOX,property:layerInfo.geometryName,value:vecSourceExtent});if(null==layerOptions.filter){layerOptions.filter=bboxFilter;}else{var andFilter=new OpenLayers.Filter.Logical({type:OpenLayers.Filter.Logical.AND,filters:[layerOptions.filter,bboxFilter]});layerOptions.filter=andFilter;}
if(layerOptions.protocol){layerOptions.strategies=[new OpenLayers.Strategy.Fixed()];};}else{if(layerOptions.protocol){layerOptions.strategies=[new OpenLayers.Strategy.BBOX()];};};if(!layerOptions.strategies){layerOptions.strategies=[];}
if(layerInfo.clustering){var clusterOptions={};for(var cProp in layerInfo.clustering){var cValue=layerInfo.clustering[cProp];if('distance'===cProp||'threshold'===cProp||'disableDynamicClustering'===cProp||'minimumPolygonPixelSize'===cProp||'minimumLinePixelSize'===cProp||'clusterPointsOnly'===cProp){clusterOptions[cProp]=cValue;};};layerOptions.strategies.push(new OpenLayers.Strategy.NunaliitCluster(clusterOptions));};layerOptions.strategies.push(new OpenLayers.Strategy.NunaliitLayerSorting());layerOptions.renderers=['SVG','VML'];layerInfo.olLayer=new OpenLayers.Layer.Vector(layerInfo.name,layerOptions);this._registerLayerForEvents(layerInfo);this.infoLayers.push(layerInfo);this.vectorLayers.push(layerInfo.olLayer);if(layerInfo.id){this.layers[layerInfo.id]=layerInfo.olLayer;}else{this.layers[layerInfo.name]=layerInfo.olLayer;};return layerInfo.olLayer;},_createOLLayerFromDefinition:function(layerDefinition,isBaseLayer){var name=_loc(layerDefinition.name);if('Bing'==layerDefinition.type){var options=layerDefinition.options;if(options&&options.key){var opts=$n2.extend({name:name},options);var l=new OpenLayers.Layer.Bing(opts);return l;}else{$n2.reportError('Bad configuration for layer: '+name);return null;};}else if('Google Maps'==layerDefinition.type){var options=layerDefinition.options;if(options&&'string'===typeof(options.type)){var mapTypeId=null;if(google&&google.maps&&google.maps.MapTypeId){mapTypeId=google.maps.MapTypeId[options.type];};if(mapTypeId){options.type=mapTypeId;}else{$n2.reportError('Can not find Google map type id: '+options.type);return null;};};if(options&&options.type){var l=new OpenLayers.Layer.Google(name,options);return l;}else{$n2.reportError('Bad configuration for layer: '+name);return null;};}else if('couchdb'===layerDefinition.type||'wfs'===layerDefinition.type){if(isBaseLayer){$n2.reportError('Layer type not suitable for background: '+layerDefinition.type);}else{return this._createOverlayFromDefinition(layerDefinition,isBaseLayer);};}else if('wms'===layerDefinition.type){var options=layerDefinition.options;if(options){var wmsUrl=null;var wmsOptions={};var layerOptions={isBaseLayer:isBaseLayer};if(typeof(layerDefinition.visibility)==='boolean'){layerOptions.visibility=layerDefinition.visibility;};if($n2.isDefined(layerDefinition.gutter)){layerOptions.gutter=layerDefinition.gutter;};if($n2.isDefined(layerDefinition.displayInLayerSwitcher)){layerOptions.displayInLayerSwitcher=layerDefinition.displayInLayerSwitcher;};for(var key in options){if('url'===key){wmsUrl=options[key];}else if('opacity'===key){layerOptions.opacity=options[key];}else{wmsOptions[key]=options[key];};};var l=new OpenLayers.Layer.WMS(name,wmsUrl,wmsOptions,layerOptions);return l;}else{$n2.reportError('Bad configuration for layer: '+name);return null;};}else if('osm'===layerDefinition.type){var url=null;var layerOptions={isBaseLayer:isBaseLayer};if(typeof(layerDefinition.visibility)==='boolean'){layerOptions.visibility=layerDefinition.visibility;};var options=layerDefinition.options;if(options){for(var optionKey in options){var optionValue=options[optionKey];if(optionKey==='url'){url=optionValue;}else{layerOptions[optionKey]=optionValue;};};};var l=new OpenLayers.Layer.OSM(name,url,layerOptions);return l;}else if('stamen'===layerDefinition.type){var layerName=null;var layerOptions={isBaseLayer:isBaseLayer};if(typeof(layerDefinition.visibility)==='boolean'){layerOptions.visibility=layerDefinition.visibility;};var options=layerDefinition.options;if(options){for(var optionKey in options){var optionValue=options[optionKey];if(optionKey==='layerName'){layerName=optionValue;}else{layerOptions[optionKey]=optionValue;};};};if(OpenLayers.Layer.Stamen){if(!layerName){$n2.reportError('Option layerName must be specified for a Stamen background.');}else{var l=new OpenLayers.Layer.Stamen(layerName,layerOptions);if(name){l.name=name;};return l;};}else{$n2.log('Stamen layer can not be added since Javascript library is not included');};}else if('image'===layerDefinition.type){var url=null;var height=null;var width=null;var extent=null;var layerOptions={isBaseLayer:isBaseLayer};if(typeof(layerDefinition.visibility)==='boolean'){layerOptions.visibility=layerDefinition.visibility;};var options=layerDefinition.options;if(options){for(var optionKey in options){var optionValue=options[optionKey];if(optionKey==='url'){url=optionValue;}else if(optionKey==='height'){height=1*optionValue;}else if(optionKey==='width'){width=1*optionValue;}else if(optionKey==='extent'){extent=optionValue;}else{layerOptions[optionKey]=optionValue;};};};if(OpenLayers.Layer.Image){var effectiveExtent=null;if(extent&&$n2.isArray(extent)&&extent.length==4){effectiveExtent=new OpenLayers.Bounds(extent[0],extent[1],extent[2],extent[3]);};if(!url){$n2.reportError('Option url must be specified for an Image background.');}else if(!height){$n2.reportError('Option height must be specified for an Image background.');}else if(!width){$n2.reportError('Option width must be specified for an Image background.');}else if(!effectiveExtent){$n2.reportError('Option extent must be specified as an array of four numbers for an Image background.');}else{var size=new OpenLayers.Size(width,height);var l=new OpenLayers.Layer.Image(name,url,effectiveExtent,size,layerOptions);return l;};}else{$n2.log('Image layer can not be added since OpenLayers does not support this type of background');};}else{$n2.reportError('Unknown layer type: '+layerDefinition.type);};return null;},_registerLayerForEvents:function(layerInfo){var _this=this;layerInfo.olLayer.events.register('visibilitychanged',null,function(evt_){var selected=evt_.object.visibility;layerInfo.selectListener(selected,layerInfo);});layerInfo.olLayer.events.register('beforefeaturesadded',null,function(evt_){var features=evt_.features;if(features){for(var i=0,e=features.length;i<e;++i){var f=features[i];if(_this.clickedInfo.fids[f.fid]){var featureInfo=_this.clickedInfo.fids[f.fid];_this.clickedInfo.features.push(f);if(featureInfo.clicked){f.isClicked=true;};if(featureInfo.intent){f.n2SelectIntent=featureInfo.intent;};};if(_this.focusInfo.fids[f.fid]){_this.focusInfo.features.push(f);f.isHovered=true;};if(_this.findFeatureInfo.fid===f.fid){_this.findFeatureInfo.features.push(f);f.n2Intent='find';};if(f.cluster){for(var j=0,k=f.cluster.length;j<k;++j){var clusterFeature=f.cluster[j];if(_this.clickedInfo.fids[clusterFeature.fid]){var featureInfo=_this.clickedInfo.fids[clusterFeature.fid];_this.clickedInfo.features.push(f);if(featureInfo.clicked){f.isClicked=true;};if(featureInfo.intent){f.n2SelectIntent=featureInfo.intent;};};if(_this.focusInfo.fids[clusterFeature.fid]){_this.focusInfo.features.push(f);f.isHovered=true;};if(_this.findFeatureInfo.fid===clusterFeature.fid){_this.findFeatureInfo.features.push(f);f.n2Intent='find';};};};};};});layerInfo.olLayer.events.register('featuresadded',null,function(evt_){var layer=null;var infoLayer=null;if(evt_&&evt_.features&&evt_.features.length&&evt_.features[0]&&evt_.features[0].layer){layer=evt_.features[0].layer;};if(layer){infoLayer=layer._layerInfo;};if(infoLayer){_this._clearValueCache(infoLayer);};if(_this.currentMode===_this.modes.EDIT_FEATURE&&_this.editFeatureFid&&evt_&&evt_.features&&evt_.features.length){var editFeatureFid=_this.editFeatureFid;for(var i=0,e=evt_.features.length;i<e;++i){var f=evt_.features[i];if(f.fid===editFeatureFid){_this._installGeometryEditor(f);}else if(f.cluster){for(var j=0,k=f.cluster.length;j<k;++j){var cf=f.cluster[j];if(cf.fid===editFeatureFid){_this._installGeometryEditor(f);};};};};};});layerInfo.olLayer.events.register('featuresremoved',null,function(evt_){var layer=null;var infoLayer=null;if(evt_&&evt_.features&&evt_.features.length&&evt_.features[0]&&evt_.features[0].layer){layer=evt_.features[0].layer;};if(layer){infoLayer=layer._layerInfo;};if(infoLayer){_this._clearValueCache(infoLayer);};});this._createFeatureModifiedHandler(layerInfo.olLayer);},_createFeatureModifiedHandler:function(olLayer){var _this=this;return function(evt){var feature=evt.feature;_this._dispatch({type:'editGeometryModified',docId:feature.fid,geom:feature.geometry,proj:olLayer.map.projection,_origin:_this});};},_genBackgroundMapLayers:function(options){var bg=null;if(options&&options.mapDisplay&&options.mapDisplay.backgrounds){for(var i=0,e=options.mapDisplay.backgrounds.length;i<e;++i){var layerDefiniton=options.mapDisplay.backgrounds[i];var l=this._createOLLayerFromDefinition(layerDefiniton,true);if(l&&!bg)bg=[];if(l)bg[bg.length]=l;};}else if(options&&options.mapDisplay&&options.mapDisplay.background){var background=options.mapDisplay.background;if(typeof(background.callback)==='function'){bg=background.callback(background);}else if('Bing'==background.type){if(background.key&&OpenLayers&&OpenLayers.Layer&&OpenLayers.Layer.Bing){if(background.layers&&$n2.isArray(background.layers)){bg=[];for(var i=0,e=background.layers.length;i<e;++i){var lOpt=$n2.extend({key:background.key},background.layers[i]);var l=new OpenLayers.Layer.Bing(lOpt);bg.push(l);};}else{bg=[];bg.push(new OpenLayers.Layer.Bing({name:'Satellite',type:'Aerial',key:background.key}));bg.push(new OpenLayers.Layer.Bing({name:'Road',type:'Road',key:background.key}));bg.push(new OpenLayers.Layer.Bing({name:'Hybrid',type:'AerialWithLabels',key:background.key}));};}else{$n2.reportError('Bad configuration for background type: '+background.type);};}else if('Google Maps'==background.type){if(OpenLayers&&OpenLayers.Layer&&OpenLayers.Layer.Google){if(background.layers&&$n2.isArray(background.layers)){bg=[];for(var i=0,e=background.layers.length;i<e;++i){var lOpt=background.layers[i];var l=new OpenLayers.Layer.Google(lOpt.name,lOpt);bg.push(l);};}else{bg=getDefaultGoogleLayers();};}else{$n2.reportError('Bad configuration for background type: '+background.type);};}else{$n2.reportError('Unknown background type: '+background.type);};}else{bg=getDefaultGoogleLayers();};if(bg){for(var i=0,e=bg.length;i<e;++i){var bgLayer=bg[i];this.mapLayers.push(bgLayer);};};return(bg);function getDefaultGoogleLayers(){var bg=null;if(typeof(GMap2)==='function'){bg=[];bg.push(new OpenLayers.Layer.Google("Google Satellite",{type:G_SATELLITE_MAP,'sphericalMercator':true}));bg.push(new OpenLayers.Layer.Google("Google Physical",{type:G_PHYSICAL_MAP,'sphericalMercator':true}));bg.push(new OpenLayers.Layer.Google("Google Hybrid",{type:G_HYBRID_MAP,'sphericalMercator':true}));}else if(google&&google.maps&&google.maps.MapTypeId){if(google.maps.Map){google.maps.Map.disableDefaultUI=true;};bg=[];bg.push(new OpenLayers.Layer.Google("Google Satellite",{type:google.maps.MapTypeId.SATELLITE,numZoomLevels:20}));bg.push(new OpenLayers.Layer.Google("Google Physical",{type:google.maps.MapTypeId.TERRAIN,numZoomLevels:20}));bg.push(new OpenLayers.Layer.Google("Google Hybrid",{type:google.maps.MapTypeId.HYBRID,numZoomLevels:20}));};return bg;};},_startClicked:function(mapFeature,forced){var feature=mapFeature;if(feature&&feature.cluster&&feature.cluster.length==1){feature=feature.cluster[0];};var clickedAgain=false;if(!forced){clickedAgain=(feature&&feature.fid&&this.clickedInfo.selectedId===feature.fid);};if(!forced&&!this.options.toggleClick&&clickedAgain){return;};if(feature.cluster){var layerInfo=feature.layer._layerInfo;layerInfo.clusterClickCallback(feature,this);return;};this._endClicked();if(!forced&&this.options.toggleClick&&clickedAgain){this._dispatch({type:'userUnselect',docId:feature.fid});}else if(feature.fid){this.clickedInfo.features=[feature];this.clickedInfo.fids={};this.clickedInfo.fids[feature.fid]={clicked:true};this.clickedInfo.selectedId=feature.fid;feature.isClicked=true;if(feature.layer){feature.layer.drawFeature(feature);}
if(this.currentMode.onStartClick){this.currentMode.onStartClick(feature,mapFeature);};};},_endClicked:function(){this._endFindFeature();if(this.clickedInfo.features){for(var i=0,e=this.clickedInfo.features.length;i<e;++i){var feature=this.clickedInfo.features[i];if(feature.isClicked){feature.isClicked=false;feature.n2SelectIntent=null;if(feature.layer){feature.layer.drawFeature(feature);};if(this.currentMode.onEndClick){this.currentMode.onEndClick(feature);};};};};if(this.clickedInfo.endFn){for(var i=0,e=this.clickedInfo.endFn.length;i<e;++i){this.clickedInfo.endFn[i]();};};this.clickedInfo.endFn=[];this.clickedInfo.features=[];this.clickedInfo.fids={};this.clickedInfo.selectedId=null;},_selectedFeatures:function(features,fids){if(this.currentMode!==this.modes.NAVIGATE){this.switchMapMode(this.modes.NAVIGATE);};this._endClicked();this.clickedInfo.fids={};if(fids){for(var i=0,e=fids.length;i<e;++i){var fid=fids[i];this.clickedInfo.fids[fid]={clicked:true};if(!this.clickedInfo.selectedId){this.clickedInfo.selectedId=fid;};};};if(features){for(var i=0,e=features.length;i<e;++i){var feature=features[i];this.clickedInfo.features.push(feature);feature.isClicked=true;if(feature.layer){feature.layer.drawFeature(feature);};};};},_selectedFeaturesSupplement:function(opts){if(this.currentMode!==this.modes.NAVIGATE){this.switchMapMode(this.modes.NAVIGATE);};if(opts.fid){this.clickedInfo.fids[opts.fid]={clicked:true};if(opts.intent){this.clickedInfo.fids[opts.fid].intent=opts.intent;};};if(opts.features){for(var i=0,e=opts.features.length;i<e;++i){var f=opts.features[i];this.clickedInfo.features.push(f);f.isClicked=true;if(opts.intent){f.n2SelectIntent=opts.intent;};if(f.layer){f.layer.drawFeature(f);};};};},_unselectFeature:function(){if(this.clickedInfo.selectedId){this._dispatch({type:'userUnselect',docId:this.clickedInfo.selectedId});};this._endClicked();},_startHover:function(feature){var layer=feature.layer;if(feature&&feature.cluster&&feature.cluster.length==1){feature=feature.cluster[0];};if(this.hoverInfo.feature===feature){return;};this._endHover();this.hoverInfo.feature=feature;if(this.currentMode.onStartHover){this.currentMode.onStartHover(feature,layer);};},_endHover:function(){for(var i=0,e=this.hoverInfo.endFn.length;i<e;++i){this.hoverInfo.endFn[i]();};this.hoverInfo.feature=null;this.hoverInfo.endFn=[];},_registerEndHoverFn:function(fn){this.hoverInfo.endFn.push(fn);},_startFocus:function(features,fid){this._endFocus();this.focusInfo.origin=fid;this._addFocus({features:features,fid:fid,origin:fid});},_addFocus:function(opts){if(opts.origin&&opts.origin!==this.focusInfo.origin){return;};this.focusInfo.fids[opts.fid]=true;for(var i=0,e=opts.features.length;i<e;++i){var f=opts.features[i];if(f&&!f.isHovered){f.isHovered=true;if(opts.intent){f.n2HoverIntent=opts.intent;};if(f.layer)f.layer.drawFeature(f);this.focusInfo.features.push(f);};};},_endFocus:function(){for(var i=0,e=this.focusInfo.features.length;i<e;++i){var feature=this.focusInfo.features[i];if(feature.isHovered){feature.isHovered=false;feature.n2HoverIntent=null;if(feature.layer)feature.layer.drawFeature(feature);};};this.focusInfo.features=[];this.focusInfo.fids={};this.focusInfo.origin=null;},_startFindFeature:function(fid,features){this._endFindFeature();this.findFeatureInfo.fid=fid;this.findFeatureInfo.features=features;if(features){for(var i=0,e=features.length;i<e;++i){var f=features[i];if(f){f.n2Intent='find';if(f.layer)f.layer.drawFeature(f);};};};},_endFindFeature:function(){for(var i=0,e=this.findFeatureInfo.features.length;i<e;++i){var f=this.findFeatureInfo.features[i];if(f){f.n2Intent=null;if(f.layer)f.layer.drawFeature(f);};};this.findFeatureInfo.fid=null;this.findFeatureInfo.features=[];},activateSelectFeatureControl:function(){if(this.selectFeatureControl){this.selectFeatureControl.activate();};},deactivateSelectFeatureControl:function(){if(this.selectFeatureControl){this.selectFeatureControl.unselectAll();this.selectFeatureControl.deactivate();};this._endHover();this._endClicked();},_hoverFeature:function(feature,layer){if(null==feature){return;};if(null==layer){return;};var layerInfo=layer._layerInfo;if(null==layerInfo){return;};var dispatchService=this._getDispatchService();this._registerEndHoverFn(function(){dispatchService.send(DH,{type:'userFocusOff',docId:feature.fid,doc:feature.data,feature:feature});});dispatchService.send(DH,{type:'userFocusOn',docId:feature.fid,doc:feature.data,feature:feature});},_hoverFeaturePopup:function(feature,layer){var _this=this;if(null==feature){return;};if(null==layer){return;};var layerInfo=layer._layerInfo;if(null==layerInfo){return;};var popupHtmlFn=layerInfo.featurePopupHtmlFn;if(null==popupHtmlFn){return;};var delay=0;if(typeof(layerInfo.featurePopupDelay)==='number'){delay=Math.floor(layerInfo.featurePopupDelay);};if(delay>0){window.setTimeout(function(){if(isPopupCurrent()){initiatePopup();};},delay);}else{initiatePopup();};function isPopupCurrent(){var hoveredFid=null;if(_this.hoverInfo.feature){hoveredFid=_this.hoverInfo.feature.fid;};if(hoveredFid!==feature.fid){return false;};return true;};function computePopupPosition(){var popup_lonlat=null;var lastMapXy=_this.lastMapXy;if(null!=lastMapXy){var lonLat=_this.map.getLonLatFromPixel(lastMapXy);if(lonLat){popup_lonlat=lonLat;};};if(!popup_lonlat){popup_lonlat=feature.geometry.getBounds().getCenterLonLat();};return popup_lonlat;};function initiatePopup(){var needWaitingPopup=true;popupHtmlFn({feature:feature,layerInfo:layerInfo,onSuccess:function(html){needWaitingPopup=false;displayPopup(html);},onError:function(){}});if(needWaitingPopup){displayPopup('<div class="olkit_wait"></div>');};};function displayPopup(popupHtml){if(!isPopupCurrent()){return;};destroyCurrentPopup();if(null===popupHtml||''===popupHtml){return;};var popup_lonlat=computePopupPosition();var popup=new OpenLayers.Popup.Anchored(null,popup_lonlat,null,popupHtml,{size:new OpenLayers.Size(10,10),offset:new OpenLayers.Pixel(-5,-5)},false,onPopupClose);popup.autoSize=true;popup.panMapIfOutOfView=true;popup.setOpacity("80");_this.currentPopup=popup;_this.map.addPopup(popup);_this._registerEndHoverFn(destroyCurrentPopup);_this.addMapMousePositionListener(function(evt){if(_this.currentPopup===popup&&_this.lastMapXy){_this.currentPopup.lonlat=_this.map.getLonLatFromPixel(_this.lastMapXy);_this.currentPopup.updatePosition();return true;};return false;});};function destroyCurrentPopup(){var map=_this.map;var popup=_this.currentPopup;if(popup){map.removePopup(popup);popup.destroy();_this.currentPopup=null;};};function onPopupClose(evt){};},loginStateChanged:function(currentUser){var showLogin=false;if(null==currentUser){showLogin=true;};if(showLogin){this.hideMapInteractionSwitch();this.switchMapMode(this.modes.NAVIGATE);}else{this.showMapInteractionSwitch();};},createMapInteractionSwitch:function(){var _this=this;var mapInteractionButton=$('<input type="button" class="n2map_map_interaction_switch"/>').val(this.modes.NAVIGATE.buttonValue).click(function(evt){_this._clickedMapInteractionSwitch(evt);});$("#"+this.options.mapInteractionDivName).empty().append(mapInteractionButton);},_getMapInteractionSwitch:function(){return $("#"+this.options.mapInteractionDivName).find('.n2map_map_interaction_switch');},_clickedMapInteractionSwitch:function(e){if(this.currentMode===this.modes.NAVIGATE){this.switchToEditMode();}else if(this.currentMode===this.modes.ADD_OR_SELECT_FEATURE){this.switchMapMode(this.modes.NAVIGATE);}else if(this.currentMode===this.modes.ADD_GEOMETRY){this._cancelEditFeatureMode();}else if(this.currentMode===this.modes.EDIT_FEATURE){this._cancelEditFeatureMode();};return false;},hideMapInteractionSwitch:function(){this._getMapInteractionSwitch().hide();},showMapInteractionSwitch:function(){this._getMapInteractionSwitch().show();},activateControl:function(control){if(control)control.activate();},deactivateControl:function(control){if(control)control.deactivate();},switchMapMode:function(mode,opts){if(this.currentMode===mode){return;};if(this.currentMode===this.modes.ADD_OR_SELECT_FEATURE){this.deactivateControl(this.editControls.addPoints);this.deactivateControl(this.editControls.toolbar);this.deactivateControl(this.editControls.modifyFeature);this.editLayer.events.unregister('featureadded',null,this.editModeAddFeatureCallback);this.editLayer.events.unregister('beforefeaturesadded',null,this.convertToMultiGeometry);this.deactivateSelectFeatureControl();}else if(this.currentMode===this.modes.ADD_GEOMETRY){this.deactivateControl(this.editControls.addPoints);this.deactivateControl(this.editControls.toolbar);this.deactivateControl(this.editControls.modifyFeature);this.editLayer.events.unregister('featureadded',null,this.editModeAddFeatureCallback);this.editLayer.events.unregister('beforefeaturesadded',null,this.convertToMultiGeometry);this.deactivateSelectFeatureControl();}else if(this.currentMode===this.modes.EDIT_FEATURE){this.editFeatureFid=null;this._removeGeometryEditor(true);}else if(this.currentMode===this.modes.NAVIGATE){this.deactivateSelectFeatureControl();};this.currentMode=mode;this._getMapInteractionSwitch().val(mode.buttonValue);if(this.currentMode===this.modes.ADD_OR_SELECT_FEATURE){this.editLayer.events.register('featureadded',null,this.editModeAddFeatureCallback);this.editLayer.events.register('beforefeaturesadded',null,this.convertToMultiGeometry);this.activateControl(this.editControls.addPoints);this.activateControl(this.editControls.toolbar);this.activateControl(this.editControls.modifyFeature);this.activateSelectFeatureControl();if(this.editControls.toolbar&&this.editControls.toolbar.div){var $toolbar=$(this.editControls.toolbar.div);$toolbar.find('.olControlNavigationItemActive').attr('title',_loc('Scroll Map'));$toolbar.find('.olControlDrawFeaturePointItemInactive').attr('title',_loc('Add a point to the map'));$toolbar.find('.olControlDrawFeaturePathItemInactive').attr('title',_loc('Add a line to the map'));$toolbar.find('.olControlDrawFeaturePolygonItemInactive').attr('title',_loc('Add a polygon to the map'));$toolbar.find('.olControlNunaliitGazetteerItemInactive').attr('title',_loc('Add a feature to the map based on a gazetteer service'));};}else if(this.currentMode===this.modes.ADD_GEOMETRY){this.editFeatureFid=opts.fid;this.editLayer.events.register('featureadded',null,this.editModeAddFeatureCallback);this.editLayer.events.register('beforefeaturesadded',null,this.convertToMultiGeometry);this.activateControl(this.editControls.addPoints);this.activateControl(this.editControls.toolbar);this.activateControl(this.editControls.modifyFeature);if(this.editControls.toolbar&&this.editControls.toolbar.div){var $toolbar=$(this.editControls.toolbar.div);$toolbar.find('.olControlNavigationItemActive').attr('title',_loc('Scroll Map'));$toolbar.find('.olControlDrawFeaturePointItemInactive').attr('title',_loc('Add a point to the map'));$toolbar.find('.olControlDrawFeaturePathItemInactive').attr('title',_loc('Add a line to the map'));$toolbar.find('.olControlDrawFeaturePolygonItemInactive').attr('title',_loc('Add a polygon to the map'));$toolbar.find('.olControlNunaliitGazetteerItemInactive').attr('title',_loc('Add a feature to the map based on a gazetteer service'));};}else if(this.currentMode===this.modes.EDIT_FEATURE){this.editFeatureFid=opts.fid;var editFeature=opts.feature;if(editFeature){this._installGeometryEditor(editFeature);};}else if(this.currentMode===this.modes.NAVIGATE){this.activateSelectFeatureControl();};},switchToEditMode:function(){var _this=this;var authService=this._getAuthService();if(authService){var logInRequired=true;var userNotAnonymous=authService.isLoggedIn();if(userNotAnonymous){logInRequired=false;};if(logInRequired){authService.showLoginForm({prompt:'<p>You must log in as a registered user to add a point to the map.</p>',anonymousLoginAllowed:false,onSuccess:function(){_this.switchToEditMode();}});}else{this.switchMapMode(this.modes.ADD_OR_SELECT_FEATURE);};}else{alert("Authentication module not installed.");};},switchToEditFeatureMode:function(fid,feature){this.switchMapMode(this.modes.EDIT_FEATURE,{fid:fid,feature:feature});},switchToAddGeometryMode:function(docId){this.switchMapMode(this.modes.ADD_GEOMETRY,{fid:docId});},_cancelEditFeatureMode:function(){this._dispatch({type:'editCancel'});},createFirstContribution:function(feature,dataOptions){if(feature.attributes&&feature.attributes.place_id){if(NUNALIIT_CONTRIBUTIONS){NUNALIIT_CONTRIBUTIONS.addContribution(dataOptions);};};},_geometryModified:function(fid,olGeom,proj){if(this.currentMode!==this.modes.EDIT_FEATURE)return;var editFeature=this.editFeatureControls.modifyFeatureGeometry.feature;if(fid&&fid!==editFeature.fid)return;if(!fid&&editFeature.fid)return;if(editFeature){var mapProj=editFeature.layer.map.projection;if(mapProj.getCode()!=proj.getCode()){olGeom.transform(proj,mapProj);};};var modifyFeatureControl=this.editFeatureControls.modifyFeatureGeometry;if(modifyFeatureControl){modifyFeatureControl.unselectFeature(editFeature);editFeature.layer.eraseFeatures([editFeature]);editFeature.geometry=olGeom;editFeature.layer.drawFeature(editFeature);modifyFeatureControl.selectFeature(editFeature);};},onAttributeFormClosed:function(editedFeature){if(editedFeature&&editedFeature.state===OpenLayers.State.INSERT){this.editLayer.destroyFeatures(editedFeature);};this.switchMapMode(this.modes.NAVIGATE);},onAttributeFormCancelled:function(editedFeature){this.switchMapMode(this.modes.NAVIGATE);},onAttributeFormInserted:function(fid,feature){var _this=this;if(feature&&feature.layer){feature.layer.destroyFeatures([feature]);};this.fidAdded(fid);var filter=$n2.olFilter.fromFid(fid);this._reloadFeature(filter,{onReloaded:function(feature){if(_this.options.contribInsertedReloadAddContrib){if(_this.options.contribInsertedReloadDataFn===null){_this.createFirstContribution(feature,{data:{title:'Added point',notes:'',place_id:feature.attributes.place_id}});}else{_this.createFirstContribution(feature,_this.options.contribInsertedReloadDataFn(feature));};};}});},onAttributeFormUpdated:function(fid,feature){var fid=feature.fid;this.fidUpdated(fid);var filter=$n2.olFilter.fromFid(fid);this._reloadFeature(filter);},onAttributeFormDeleted:function(fid,feature){this.fidDeleted(fid);var layer=feature.layer;if(layer){layer.destroyFeatures([feature]);};},selectAudioMedia:function(feature,onSelectCallback){var _this=this;var placeId=null;if(feature&&feature.attributes&&feature.attributes.place_id){placeId=feature.attributes.place_id;};var selectWindow=null;if(placeId){this.insertSound();selectWindow=$('<div class="selectMedia" style="z-index:3005"></div>');var head=$('<h1>Select a hover audio file</h2>');selectWindow.append(head);var listElem=$('<div></div>');selectWindow.append(listElem);var cancelButton=$('<input type="button" value="Cancel"/>');cancelButton.click(function(){selectWindow.dialog('close');});selectWindow.append(cancelButton);var dialogOptions={autoOpen:true,modal:true,title:_loc('Select a media'),width:'auto',close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};selectWindow.dialog(dialogOptions);this.dbSearchEngine.getAudioMediaFromPlaceId(placeId,function(mediaArray){if(0==mediaArray.length){listElem.html('<span>There are no audio files available</span>');}else{var tableElem=$('<table class="mediaSelection"></table>');listElem.append(tableElem);for(var loop=0;loop<mediaArray.length;++loop){var media=mediaArray[loop];addMedia(tableElem,media);};};});}else{alert('No media to select');};function addMedia(tableElem,media){var trElem=$('<tr></tr>');var tdElem=$('<td></td>');if(media.title){var html=$('<span>'+'title: '+media.title+'</span>');tdElem.append(html);tdElem.append($('<br/>'));};if(media.mimetype){var html=$('<span>'+'MIME type: '+media.mimetype+'</span>');tdElem.append(html);tdElem.append($('<br/>'));};if(media.filename){var html=$('<span>'+'file: '+media.filename+'</span>');tdElem.append(html);tdElem.append($('<br/>'));};trElem.hover(function(){var value=media.filename?media.filename:'';_this.insertSound(value);},function(){_this.insertSound();});trElem.click(function(){var value=media.filename?media.filename:'';_this.insertSound();onSelectCallback(value);selectWindow.dialog('close');return false;});trElem.append(tdElem);tableElem.append(trElem);};},initCometChannels:function(){var _this=this;if(this.cometEnabled&&$.cometd){$.cometd.init('./cometd');$.cometd.subscribe(this.fidChannel,function(msg){_this.fidHandler(msg);});$.cometd.subscribe(this.contributionChannel,function(msg){_this.contributionHandler(msg);});}},fidHandler:function(msg){if(msg.data&&msg.data.type&&msg.data.fid){this._cacheInvalidateFeature(msg.data.fid);if(msg.data.type=='added'){var filter=$n2.olFilter.fromFid(msg.data.fid);this._reloadFeature(filter);}else if(msg.data.type=='updated'){var filter=$n2.olFilter.fromFid(msg.data.fid);this._reloadFeature(filter);}else if(msg.data.type=='deleted'){this._removeFeature(msg.data.fid);};};},fidAdded:function(fid){if(this.cometEnabled&&$.cometd){var msg={fid:fid,type:'added'};$.cometd.publish(this.fidChannel,msg);};},fidUpdated:function(fid){if(this.cometEnabled&&$.cometd){var msg={fid:fid,type:'updated'};$.cometd.publish(this.fidChannel,msg);}},fidDeleted:function(fid){if(this.cometEnabled&&$.cometd){var msg={fid:fid,type:'deleted'};$.cometd.publish(this.fidChannel,msg);};},contributionHandler:function(msg){if(msg.data){var data=msg.data;if(data.place_id&&$n2.placeInfo&&$n2.placeInfo.getPlaceId()==data.place_id){$n2.placeInfo.loadAndRenderContributions();};};},adjustFilterProperties:function(feature){feature.isFilteredIn=false;feature.isFilteredOut=false;for(var key in this.styleFilters){feature.isFilteredIn=true;var f=this.styleFilters[key].matchFn;if(!f(feature)){feature.isFilteredIn=false;feature.isFilteredOut=true;return true;};};return false;},_createStyleMap:function(styleOptions){var providedMap=styleOptions?$.extend(true,{},this.defaultStyleMap,styleOptions):this.defaultStyleMap;var normalStyle=new OpenLayers.Style(providedMap.normal);var clickedStyle=new OpenLayers.Style(providedMap.clicked);var hoveredStyle=new OpenLayers.Style(providedMap.hovered);var hoveredClickedStyle=new OpenLayers.Style(providedMap.hoveredClicked);var filteredOutStyle=new OpenLayers.Style(providedMap.filteredOut);var styles={'normal':normalStyle,'clicked':clickedStyle,'hovered':hoveredStyle,'hoveredClicked':hoveredClickedStyle,'filteredOut':filteredOutStyle};var styleMap=new OpenLayers.StyleMapCallback(function(feature,intent){var effectiveIntent=null;if(null==effectiveIntent&&feature.isFilteredOut){effectiveIntent='filteredOut';};if(null==effectiveIntent&&feature.isHovered){if(feature.isClicked){effectiveIntent='hoveredClicked';}else{effectiveIntent='hovered';};};if(null==effectiveIntent&&feature.isClicked){effectiveIntent='clicked';};var style=styles[effectiveIntent];if(null==style){style=styles.normal;};return style.createSymbolizer(feature);});return styleMap;},_createStyleMapFromLayerInfo:function(layerInfo){var styleOptions=null;if(layerInfo&&layerInfo.styleMap){styleOptions=layerInfo.styleMap;};return this._createStyleMap(styleOptions);},_createEffectiveStyleMap:function(layerInfo){var _this=this;var innerStyleMap=null;if(layerInfo){innerStyleMap=layerInfo.styleMapFn(layerInfo);}else{innerStyleMap=this._createStyleMap();};var styleMap=new OpenLayers.StyleMapCallback(function(feature,intent){if(null==feature){return{fillColor:"#0000ff",fillOpacity:0.4,strokeColor:"#0000ff",strokeOpacity:1,strokeWidth:1,strokeLinecap:"round",strokeDashstyle:"solid",pointRadius:6,pointerEvents:"visiblePainted",cursor:"pointer"};};if(feature._sketch){return{fillColor:"#0000ff",fillOpacity:0.4,strokeColor:"#0000ff",strokeOpacity:1,strokeWidth:1,strokeLinecap:"round",strokeDashstyle:"solid",pointRadius:6,pointerEvents:"visiblePainted",cursor:"pointer"};};_this.adjustFilterProperties(feature);var symbolizer=innerStyleMap.createSymbolizer(feature,intent);return symbolizer;});if(!styleMap.styles){styleMap.styles={};}
if(!styleMap.styles['temporary']){styleMap.styles['temporary']={fillColor:"#66cccc",fillOpacity:0.2,hoverFillColor:"white",hoverFillOpacity:0.8,strokeColor:"#66cccc",strokeOpacity:1,strokeLinecap:"round",strokeWidth:2,strokeDashstyle:"solid",hoverStrokeColor:"red",hoverStrokeOpacity:1,hoverStrokeWidth:0.2,pointRadius:6,hoverPointRadius:1,hoverPointUnit:"%",pointerEvents:"visiblePainted",cursor:"inherit"};};if(!styleMap.styles['delete']){styleMap.styles['delete']={display:"none"};};return styleMap;},turnOffStyleFilter:function(label){if(this.styleFilters[label]){delete this.styleFilters[label];this.redrawMap();};},removeStyleFilter:function(filter){var label=null;if(typeof(filter)==='string'){label=filter;}else if(typeof(filter)==='string'){label=filter.label;};if(null==label){return;};turnOffStyleFilter(label);$('#_olkit_styleFilter_'+label).remove();},addStyleFilter:function(filter_){var _this=this;var defaultFilter={description:'Unknown Filter',refreshFunction:function(options_){}};var filter=$.extend(defaultFilter,filter_);var filterLabel=''+this.styleFilterIndex;++this.styleFilterIndex;filter.label=filterLabel;var span=$('<span id="_olkit_styleFilter_'+filterLabel+'"></span>');var filterPanelId=this.options.filterPanelName;if(null==filterPanelId){return false;};$('#'+filterPanelId).append(span);var cb=$('<input type="checkbox"/>');var warning=$('<span></span>');var text=$('<span>'+filter.description+'</span>');var removeButton=$('<input type="button" value="Delete"/>');var br=$('<br/>');span.append(cb);span.append(removeButton);span.append(warning);span.append(text);span.append(br);cb.bind('change',function(){var checked=cb.attr('checked');if(checked){refreshFilter();}else{removeFilter();};});removeButton.click(function(){deleteFilter();return false;});refreshFilter();function onError(){warning.text('!!!');cb.attr('checked',false);disableAll(span,false);if(null!=filterLabel){this.removeStyleFilter(filterLabel);filterLabel=null;};};function refreshFilter(){warning.empty();disableAll(span,true);filter.refreshFunction({onError:onError,filterOnFids:filterFids});};function filterFids(fids){var fidMap={};for(var loop=0;loop<fids.length;++loop){fidMap[fids[loop]]=1;};filter.matchFn=function(feature){if(fidMap[feature.attributes.id]){return true;};return false;};styleFilters[filter.label]=filter;cb.attr('checked',true);disableAll(span,false);_this.redrawMap();};function removeFilter(){warning.empty();_this.turnOffStyleFilter(filterLabel);};function deleteFilter(){if(null!=filterLabel){_this.removeStyleFilter(filterLabel);filterLabel=null;};};function disableAll(jQuerySet,flag){if(flag){jQuerySet.attr('disabled',true).addClass('olkitDisabled');}else{jQuerySet.removeAttr('disabled').removeClass('olkitDisabled');};jQuerySet.children().each(function(i,elem){disableAll($(elem),flag);});};return false;},createLayerFromOptions:function(opt_){var _this=this;var cs=this._getCustomService();var layerInfo=$.extend({},this.defaultLayerInfo,opt_);if(!layerInfo.featurePopupHtmlFn){if(cs){var cb=cs.getOption('mapFeaturePopupCallback');if(typeof cb==='function'){layerInfo.featurePopupHtmlFn=cb;};};};if(!layerInfo.featurePopupHtmlFn){layerInfo.featurePopupHtmlFn=$n2.mapAndControls.DefaultPopupHtmlFunction;};layerInfo.typename=layerInfo.featurePrefix+':'+layerInfo.featureType;layerInfo.schema=layerInfo.wfsUrl
+'?service=WFS&version='+layerInfo.wfsVersion
+'&request=DescribeFeatureType&typeName='+layerInfo.typename;layerInfo.sourceProjection=new OpenLayers.Projection(layerInfo.sourceSrsName);var layerOptions={projection:layerInfo.sourceProjection,visibility:layerInfo.visibility,_layerInfo:layerInfo};if(layerInfo.couchDb){var couchProtocolOpt=$n2.extend({},layerInfo.couchDb,{notifications:{readStart:function(){_this._mapBusyStatus(1);},readEnd:function(){_this._mapBusyStatus(-1);}}});layerInfo.protocol=new OpenLayers.Protocol.Couch(couchProtocolOpt);layerOptions.protocol=layerInfo.protocol;}else if(layerInfo.wfsUrl){layerInfo.protocol=new OpenLayers.Protocol.WFS.v1_1_0({url:layerInfo.wfsUrl,featureType:layerInfo.featureType,featureNS:layerInfo.featureNS,featurePrefix:layerInfo.featurePrefix,geometryName:layerInfo.geometryName,readFormat:new OpenLayers.Format.GeoJSON(),outputFormat:'json'});layerOptions.protocol=layerInfo.protocol;}else{$n2.reportError('Unrecognized layer: '+layerInfo.name);};var layerStyleMap=this._createEffectiveStyleMap(layerInfo);layerOptions.styleMap=layerStyleMap;layerInfo.olFilter=null;if(layerInfo.filter){layerInfo.olFilter=$n2.olFilter.CreateOpenLayersFilter(layerInfo.filter);if(null==layerInfo.olFilter){alert('Encountered invalid filter');}else{layerOptions.filter=layerInfo.olFilter;};};if(layerInfo.useFixedStrategy){var vecSourceExtent=new OpenLayers.Bounds(options.mapCoordinateSpecifications.maxExtent[0],options.mapCoordinateSpecifications.maxExtent[1],options.mapCoordinateSpecifications.maxExtent[2],options.mapCoordinateSpecifications.maxExtent[3]);if(userCoordProjection.getCode()!=layerInfo.sourceProjection.getCode()){vecSourceExtent.transform(userCoordProjection,layerInfo.sourceProjection);}
var bboxFilter=new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.BBOX,property:layerInfo.geometryName,value:vecSourceExtent});if(null==layerOptions.filter){layerOptions.filter=bboxFilter;}else{var andFilter=new OpenLayers.Filter.Logical({type:OpenLayers.Filter.Logical.AND,filters:[layerOptions.filter,bboxFilter]});layerOptions.filter=andFilter;}
if(layerOptions.protocol){layerOptions.strategies=[new OpenLayers.Strategy.Fixed()];};}else{if(layerOptions.protocol){layerOptions.strategies=[new OpenLayers.Strategy.BBOX()];};};if(!layerOptions.strategies){layerOptions.strategies=[];}
layerOptions.strategies.push(new OpenLayers.Strategy.NunaliitLayerSorting());layerOptions.renderers=['SVG','VML'];layerInfo.olLayer=new OpenLayers.Layer.Vector(layerInfo.name,layerOptions);this._registerLayerForEvents(layerInfo);this.infoLayers.push(layerInfo);this.vectorLayers.push(layerInfo.olLayer);if(layerInfo.id){this.layers[layerInfo.id]=layerInfo.olLayer;}else{this.layers[layerInfo.name]=layerInfo.olLayer;};return layerInfo;},findLayerFromId:function(id){return this.layers[id];},addLayer:function(layerDefinition,isBaseLayer){var olLayer=this._createOLLayerFromDefinition(layerDefinition,isBaseLayer);this.map.addLayer(olLayer);this._installFeatureSelector();},_uninstallFeatureSelector:function(){if(this.selectFeatureControl){this.selectFeatureControl.deactivate();this.map.removeControl(this.selectFeatureControl);this.selectFeatureControl=null;};},_installFeatureSelector:function(){var _this=this;if(this.selectFeatureControl)this._uninstallFeatureSelector();var navHighlightOptions={hover:true,callbacks:{}};this.selectFeatureControl=new OpenLayers.Control.SelectFeature(this.vectorLayers,navHighlightOptions);this.selectFeatureControl.handlers.feature=new OpenLayers.Handler.NunaliitFeature({},this.selectFeatureControl.layer,{click:function(feature){_this._startClicked(feature,false);},clickout:function(feature){_this._unselectFeature();},over:function(feature){_this._startHover(feature);},out:function(feature){_this._endHover();}},{geometryTypes:this.selectFeatureControl.geometryTypes});this.map.addControl(this.selectFeatureControl);this.selectFeatureControl.activate();},_mapBusyStatus:function(delta){var previous=this.mapBusyCount;this.mapBusyCount+=delta;if(previous<1&&this.mapBusyCount>0){$n2.log('Start map busy');};if(previous>0&&this.mapBusyCount<1){$n2.log('End map busy');};if(this.busyMapControl&&delta<0){this.busyMapControl.decreaseCounter();}else if(this.busyMapControl&&delta>0){this.busyMapControl.increaseCounter();}},redefineFeatureLayerStylesAndRules:function(layerName){var layerInfo=this.getNamedLayerInfo(layerName);if(null==layerInfo){alert('redefineFeatureLayerStylesAndRules: unknown layer name: '+layerName);}else{layerInfo.olLayer.redraw();};},recentreMap:function(ll){var z=this.map.getZoom();this.map.setCenter(ll,z,false,false);},resetExtent:function(){if(this.initialZoomBounds){this.map.zoomToExtent(this.initialZoomBounds);};},setInitialExtent:function(bounds,srsName,reset){var initialExt=new OpenLayers.Bounds(bounds[0],bounds[1],bounds[2],bounds[3]);if(null!=srsName){this.convertBoundsToMapProjection(initialExt,srsName);};this.initialZoomBounds=initialExt;if(reset){this.resetExtent();};},setNewExtent:function(bounds,srsName){var maxExt=new OpenLayers.Bounds(bounds[0],bounds[1],bounds[2],bounds[3]);if(null!=srsName){this.convertBoundsToMapProjection(maxExt,srsName);};this.map.zoomToExtent(maxExt,true);},getMediaPath:function(){return this.dbSearchEngine.getRelMediaPath();},getSidePanelName:function(){return this.options.sidePanelName;},getFilterPanelName:function(){return this.options.filterPanelName;},addMapMousePositionListener:function(listener){if(typeof(listener)==='function'){this.mapMouseMoveListeners.push(listener);};},_retrieveCachedValue:function(id){for(var i=0,e=this.infoLayers.length;i<e;++i){var layerInfo=this.infoLayers[i];var valueMap=this._getCachedValueMap(layerInfo);if(valueMap&&valueMap[id]&&!valueMap[id].__n2_cache_invalid){return $n2.document.clone(valueMap[id]);};};return null;},_getCachedValueMap:function(layerInfo){if(layerInfo.cachedValues){var valueMap=layerInfo.cachedValues;}else{valueMap={};layerInfo.cachedValues=valueMap;var olLayer=layerInfo.olLayer;var features=olLayer.features;for(var i=0,e=features.length;i<e;++i){var feature=features[i];if(feature.fid){valueMap[feature.fid]=feature.data;};if(feature.cluster){for(var j=0,k=feature.cluster.length;j<k;++j){var cf=feature.cluster[j];if(cf.fid){valueMap[cf.fid]=cf.data;};};};};};return valueMap;},_clearValueCache:function(layerInfo){layerInfo.cachedValues=null;},_cacheInvalidateFeature:function(id){for(var i=0,e=this.infoLayers.length;i<e;++i){var layerInfo=this.infoLayers[i];var valueMap=this._getCachedValueMap(layerInfo);if(valueMap&&valueMap[id]){valueMap[id].__n2_cache_invalid=true;};};},_cacheUpdateDocumentVersion:function(id,rev){for(var i=0,e=this.infoLayers.length;i<e;++i){var layerInfo=this.infoLayers[i];var valueMap=this._getCachedValueMap(layerInfo);if(valueMap&&valueMap[id]){if(valueMap[id]._rev!==rev){valueMap[id].__n2_cache_invalid=true;};};};},_handleMapMousePosition:function(evt){if(null==evt){this.lastMapXy=null;}else{this.lastMapXy=this.map.events.getMousePosition(evt);};var newListeners=[];for(var i=0,e=this.mapMouseMoveListeners.length;i<e;++i){var l=this.mapMouseMoveListeners[i];try{var keep=l(evt,this);if(keep){newListeners.push(l);};}catch(e){};};this.mapMouseMoveListeners=newListeners;},_getAuthService:function(){var auth=null;if(this.options.directory){auth=this.options.directory.authService;};return auth;},_getCustomService:function(){var cs=null;if(this.options.directory){cs=this.options.directory.customService;};return cs;},_getDispatchService:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;},_dispatch:function(m){var dispatcher=this._getDispatchService();if(dispatcher){dispatcher.send(DH,m);};},_registerDispatch:function(event,fn){var dispatcher=this._getDispatchService();if(dispatcher){var _this=this;if(!fn){fn=this._handleDispatch_;};if(!fn){fn=function(m){_this._handleDispatch(m);};};dispatcher.register(DH,event,fn);};},_handleDispatch:function(m){var type=m.type;if('documentVersion'===type){this._cacheUpdateDocumentVersion(m.docId,m.rev);}else if('documentDeleted'===type){this._removeFeature(m.docId);}else if('cacheRetrieveDocument'===type){var doc=this._retrieveCachedValue(m.docId);if(doc){m.doc=doc;};}else if('featureCreated'===type){var doc=m.doc;var layerIdMap={};if(doc&&doc.nunaliit_layers){for(var i=0,e=doc.nunaliit_layers.length;i<e;++i){layerIdMap[doc.nunaliit_layers[i]]=true;};};for(var i=0,e=this.infoLayers.length;i<e;++i){var infoLayer=this.infoLayers[i];var layerId=infoLayer.id;if(layerIdMap[layerId]){var feature=this._getLayerFeatureIncludingFid(infoLayer.olLayer,doc._id);var mustLoad=true;if(feature&&feature.data){if(feature.data._rev===doc._rev){mustLoad=false;};};if(mustLoad){var filter=$n2.olFilter.fromFid(m.docId);this._loadFeatureOnLayer(infoLayer,filter);};};};}else if('featureUpdated'===type){var doc=m.doc;var layerIdMap={};if(doc&&doc.nunaliit_layers){for(var i=0,e=doc.nunaliit_layers.length;i<e;++i){layerIdMap[doc.nunaliit_layers[i]]=true;};};for(var i=0,e=this.infoLayers.length;i<e;++i){var infoLayer=this.infoLayers[i];var layerId=infoLayer.id;if(!layerIdMap[layerId]){var feature=this._getLayerFeatureIncludingFid(infoLayer.olLayer,doc._id);if(feature){var featuresToAdd=null;if(feature.cluster){for(var j=0,k=feature.cluster.length;j<k;++j){var cf=feature.cluster[j];if(cf.fid!==doc._id){if(!featuresToAdd)featuresToAdd=[];featuresToAdd.push(cf);};};};infoLayer.olLayer.destroyFeatures(feature);if(featuresToAdd){infoLayer.olLayer.addFeatures(featuresToAdd);};};};};for(var i=0,e=this.infoLayers.length;i<e;++i){var infoLayer=this.infoLayers[i];var layerId=infoLayer.id;if(layerIdMap[layerId]){var mustUpdate=true;if(doc&&doc._rev){var feature=this._getLayerFeatureIncludingFid(infoLayer.olLayer,doc._id);if(feature&&feature.fid===doc._id&&feature.data&&feature.data._rev===doc._rev){mustUpdate=false;}else if(feature&&feature.cluster){for(var j=0,k=feature.cluster.length;j<k;++j){var cf=feature.cluster[j];if(cf&&cf.fid===doc._id&&cf.data&&cf.data._rev===doc._rev){mustUpdate=false;};};};};if(mustUpdate){var filter=$n2.olFilter.fromFid(m.docId);this._loadFeatureOnLayer(infoLayer,filter);};};};}else if('addLayerToMap'===type){this._handleAddLayerToMap(m);}else if('selected'===type){if(m.docId){var features=this._getMapFeaturesIncludingFid(m.docId);this._selectedFeatures(features,[m.docId]);}else if(m.docIds){var features=[];for(var i=0,e=m.docIds.length;i<e;++i){var feats=this._getMapFeaturesIncludingFid(m.docIds[i]);for(var j=0,k=feats.length;j<k;++j){var f=feats[j];if(features.indexOf(f)<0){features.push(f);};};};this._selectedFeatures(features,m.docIds);};}else if('selectedSupplement'===type){var fid=m.docId;if(fid){var features=this._getMapFeaturesIncludingFid(fid);this._selectedFeaturesSupplement({fid:fid,features:features,intent:m.intent});};}else if('unselected'===type){this._endClicked();}else if('focusOn'===type){var fid=m.docId;var features=this._getMapFeaturesIncludingFid(fid);this._startFocus(features,fid);}else if('focusOff'===type){this._endFocus();}else if('focusOnSupplement'===type){var fid=m.docId;if(fid){var features=this._getMapFeaturesIncludingFid(fid);this._addFocus({fid:fid,features:features,intent:m.intent,origin:m.origin});};}else if('findIsAvailable'===type){var doc=m.doc;if(doc.nunaliit_geom&&doc.nunaliit_layers){for(var i=0,e=this.infoLayers.length;i<e;++i){var infoLayer=this.infoLayers[i];var layerId=infoLayer.id;if(doc.nunaliit_layers.indexOf(layerId)>=0){m.isAvailable=true;break;};};};}else if('find'===type){var doc=m.doc;if(doc&&doc.nunaliit_geom){var x=(doc.nunaliit_geom.bbox[0]+doc.nunaliit_geom.bbox[2])/2;var y=(doc.nunaliit_geom.bbox[1]+doc.nunaliit_geom.bbox[3])/2;this._centerMapOnXY(x,y,'EPSG:4326');};var fid=m.docId;var features=this._getMapFeaturesIncludingFid(fid);this._startFindFeature(fid,features);if(doc&&doc.nunaliit_layers){var visible=false;var olLayerToTurnOn=null;for(var i=0,e=this.infoLayers.length;i<e;++i){var infoLayer=this.infoLayers[i];var layerId=infoLayer.id;var olLayer=infoLayer.olLayer;if(doc.nunaliit_layers.indexOf(layerId)>=0&&olLayer){if(olLayer.visibility){visible=true;}else{olLayerToTurnOn=olLayer;};};};if(!visible&&olLayerToTurnOn){olLayerToTurnOn.setVisibility(true);};};}else if('searchInitiate'===type){this._endClicked();}else if('editInitiate'===type){var fid=m.docId;if(fid){var features=this._getMapFeaturesIncludingFid(fid);var feature=null;if(features.length>0){feature=features[0];};if(feature){this._centerMapOnFeature(feature);}else{if(m.doc&&m.doc.nunaliit_geom&&m.doc.nunaliit_geom.bbox&&m.doc.nunaliit_geom.bbox.length>=4){var bbox=m.doc.nunaliit_geom.bbox;var x=(bbox[0]+bbox[2])/2;var y=(bbox[1]+bbox[3])/2;this._centerMapOnXY(x,y,'EPSG:4326');};};if(m.doc&&!m.doc.nunaliit_geom){this.switchToAddGeometryMode(fid);}else{this.switchToEditFeatureMode(fid,feature);};};}else if('editCancel'===type){if(this.currentMode===this.modes.EDIT_FEATURE){if(this.editFeatureControls.modifyFeatureGeometry){var editFeature=this.editFeatureControls.modifyFeatureGeometry.feature;if(editFeature&&editFeature._n2Original){editFeature._n2Original.restoreGeom=true;};};this.switchMapMode(this.modes.NAVIGATE);};}else if('editClosed'===type){if(this.currentMode!==this.modes.NAVIGATE){this.switchMapMode(this.modes.NAVIGATE);};var deleted=m.deleted;if(!deleted){var docId=m.docId;if(docId){var features=this._getMapFeaturesIncludingFid(docId);this._selectedFeatures(features,[docId]);};};}else if('editGeometryModified'===type){if(m._origin!==this){this._geometryModified(m.docId,m.geom,m.proj);};}else if('mapRedrawLayer'===type){var layerId=m.layerId;this.redefineFeatureLayerStylesAndRules(layerId);}else if('mapSetInitialExtent'===type){var extent=m.extent;var srsName=m.srsName;var reset=m.reset;this.setInitialExtent(extent,srsName,reset);}else if('mapSetExtent'===type){var extent=m.extent;var srsName=m.srsName;this.setNewExtent(extent,srsName);}else if('mapResetExtent'===type){this.resetExtent();}else if('mapGetLayers'===type){if(!m.layers){m.layers={};};for(var i=0,e=this.infoLayers.length;i<e;++i){var infoLayer=this.infoLayers[i];var layerId=infoLayer.id;var olLayer=infoLayer.olLayer;var report=m.layers[layerId];if(!report){report={id:layerId};m.layers[layerId]=report;};if(olLayer&&olLayer.visibility){report.visible=true;};};}else if('setMapLayerVisibility'===type){var layerId=m.layerId;var visible=m.visible;if(this.layers[layerId]){this.layers[layerId].setVisibility(visible);};}else if('mapSwitchToEditMode'===type){this.switchToEditMode();};},_handleAddLayerToMap:function(m){var layerDef=m.layer;var isBaseLayer=false;if(typeof(m.isBaseLayer)!=='undefined'){isBaseLayer=m.isBaseLayer;};var olLayer=this.findLayerFromId(layerDef.id);if(!olLayer){this.addLayer(layerDef,isBaseLayer);olLayer=this.findLayerFromId(layerDef.id);};if(olLayer){olLayer.setVisibility(true);};if(m.options&&m.options.setExtent){var bounds=m.options.setExtent.bounds;var srsName=m.options.setExtent.crs;this.setNewExtent(bounds,srsName);};}});$n2.mapAndControls=function(opts_){return new MapAndControls(opts_);};$n2.mapAndControls.MapAndControls=MapAndControls;$n2.mapAndControls.DefaultPopupHtmlFunction=null;$n2.mapAndControls.BasicPopupHtmlFunction=basicPopupHtmlFunction;$n2.mapAndControls.SuppressPopupHtmlFunction=suppressPopupHtmlFunction;$n2.mapAndControls.ZoomInClusterClickCallback=zoomInClusterClickCallback;$n2.mapAndControls.MultiSelectClusterClickCallback=multiSelectClusterClickCallback;})(jQuery,nunaliit2);;(function($n2){var defaultDefinition={base:{normal:{fillColor:'#ffffff',strokeColor:'#ee9999',strokeWidth:2,fillOpacity:0.4,strokeOpacity:1,strokeLinecap:"round",strokeDashstyle:"solid",pointRadius:6,pointerEvents:"visiblePainted"},clicked:{strokeColor:"#ff2200"},hovered:{fillColor:"#0000ff"},hoveredClicked:{fillColor:"#0000ff",strokeColor:"#ff2200"}},point:null,line:{hovered:{strokeColor:"#0000ff"},hoveredClicked:{strokeColor:"#0000ff"}},polygon:null,layers:null,schemas:null,intents:{cluster:{base:{normal:{fillColor:'#ffff33',pointRadius:8,graphicName:'square'}}},find:{base:{normal:{strokeColor:"#ffff00"}}}}};var MapFeatureStyles=$n2.Class({activeStyles:null,initialize:function(userStyles){var descriptors=this._parseDefinition(userStyles);this.activeStyles={};for(var i=0,e=descriptors.length;i<e;++i){var descriptor=descriptors[i];var args=[];args.push(descriptor,this.activeStyles);if(descriptor.layer){args.push({category:'layers',name:descriptor.layer});};if(descriptor.schema){args.push({category:'schemas',name:descriptor.schema});};if(descriptor.intent){args.push({category:'intents',name:descriptor.intent});};this._installDefinition.apply(this,args);};},_parseDefinition:function(userDefinition){var descriptors=[];var initialDescriptor={layer:null,schema:null,intent:null,priority:-1,styleSet:this._computeStyleSet(userDefinition)};descriptors.push(initialDescriptor);this._parseDefinition2(initialDescriptor,[],defaultDefinition,descriptors);initialDescriptor=$n2.extend({},initialDescriptor,{priority:0});this._parseDefinition2(initialDescriptor,[userDefinition],userDefinition,descriptors);return descriptors;},_parseDefinition2:function(descriptor,accumulatedDefinitions,userDefinition,descriptorArray){if(userDefinition&&userDefinition.layers){for(var layerName in userDefinition.layers){var layerDescriptor=$n2.extend({},descriptor,{layer:layerName,priority:(descriptor.priority+1)});var layerDef=userDefinition.layers[layerName];var defs=accumulatedDefinitions.slice(0);if(defaultDefinition.layers&&defaultDefinition.layers[layerName]){defs.push(defaultDefinition.layers[layerName]);};defs.push(layerDef);layerDescriptor.styleSet=this._computeStyleSet.apply(this,defs);descriptorArray.push(layerDescriptor);this._parseDefinition2(layerDescriptor,defs,layerDef,descriptorArray);};};if(userDefinition&&userDefinition.schemas){for(var schemaName in userDefinition.schemas){var schemaDescriptor=$n2.extend({},descriptor,{schema:schemaName,priority:(descriptor.priority+1)});var schemaDef=userDefinition.schemas[schemaName];var defs=accumulatedDefinitions.slice(0);if(defaultDefinition.schemas&&defaultDefinition.schemas[schemaName]){defs.push(defaultDefinition.schemas[schemaName]);};defs.push(schemaDef);schemaDescriptor.styleSet=this._computeStyleSet.apply(this,defs);descriptorArray.push(schemaDescriptor);this._parseDefinition2(schemaDescriptor,defs,schemaDef,descriptorArray);};};if(userDefinition&&userDefinition.intents){for(var intentName in userDefinition.intents){var intentDescriptor=$n2.extend({},descriptor,{intent:intentName,priority:(descriptor.priority+1)});var intentDef=userDefinition.intents[intentName];var defs=accumulatedDefinitions.slice(0);if(defaultDefinition.intents&&defaultDefinition.intents[intentName]){defs.push(defaultDefinition.intents[intentName]);};defs.push(intentDef);intentDescriptor.styleSet=this._computeStyleSet.apply(this,defs);descriptorArray.push(intentDescriptor);this._parseDefinition2(intentDescriptor,defs,intentDef,descriptorArray);};};},_installDefinition:function(styleDescriptor,currentNode,routingInfo){if(!routingInfo){if(currentNode.descriptor&&currentNode.descriptor.priority<=styleDescriptor.priority){currentNode.descriptor=styleDescriptor;}else if(!currentNode.descriptor){currentNode.descriptor=styleDescriptor;};}else{var nextRoute=arguments[arguments.length-1];var category=nextRoute.category;var name=nextRoute.name;if(!currentNode[category]){currentNode[category]={};};if(!currentNode[category][name]){currentNode[category][name]={};};var nextLevelArgs=[styleDescriptor,currentNode[category][name]];for(var i=2,e=arguments.length-1;i<e;++i){nextLevelArgs.push(arguments[i]);};this._installDefinition.apply(this,nextLevelArgs);};},_retrieveStyleSet:function(intent,schema,layer){var currentNode=this.activeStyles;var currentDescriptor=this.activeStyles.descriptor;if(intent&&currentNode.intents&&currentNode.intents[intent]){currentNode=currentNode.intents[intent];if(currentNode.descriptor&&currentDescriptor.priority<currentNode.descriptor.priority){currentDescriptor=currentNode.descriptor;};};if(schema&&currentNode.schemas&&currentNode.schemas[schema]){currentNode=currentNode.schemas[schema];if(currentNode.descriptor&&currentDescriptor.priority<currentNode.descriptor.priority){currentDescriptor=currentNode.descriptor;};};if(layer&&currentNode.layers&&currentNode.layers[layer]){currentNode=currentNode.layers[layer];if(currentNode.descriptor&&currentDescriptor.priority<currentNode.descriptor.priority){currentDescriptor=currentNode.descriptor;};};return currentDescriptor.styleSet;},_computeStyleSet:function(){var computedSet={};var pointArgs=[defaultDefinition.base];var lineArgs=[defaultDefinition.base];var polygonArgs=[defaultDefinition.base];pointArgs.push(defaultDefinition.point);lineArgs.push(defaultDefinition.line);polygonArgs.push(defaultDefinition.polygon);for(var i=0,e=arguments.length;i<e;++i){var setDelta=arguments[i];if(setDelta){pointArgs.push(setDelta.base);lineArgs.push(setDelta.base);polygonArgs.push(setDelta.base);};};for(var i=0,e=arguments.length;i<e;++i){var setDelta=arguments[i];if(setDelta){pointArgs.push(setDelta.point);lineArgs.push(setDelta.line);polygonArgs.push(setDelta.polygon);};};computedSet.point=this._computeStateStyles.apply(this,pointArgs);computedSet.line=this._computeStateStyles.apply(this,lineArgs);computedSet.polygon=this._computeStateStyles.apply(this,polygonArgs);return computedSet;},_mergeStateStyles:function(baseStyle){var mergedStyle={};if(!baseStyle){baseStyle={};};mergedStyle.normal=$n2.extend({},baseStyle.normal);for(var i=1,e=arguments.length;i<e;++i){var delta=arguments[i];if(delta&&delta.normal){$n2.extend(mergedStyle.normal,delta.normal);};};mergedStyle.hovered=$n2.extend({},mergedStyle.normal,baseStyle.hovered);mergedStyle.clicked=$n2.extend({},mergedStyle.normal,baseStyle.clicked);mergedStyle.hoveredClicked=$n2.extend({},mergedStyle.normal,baseStyle.hoveredClicked);for(var i=1,e=arguments.length;i<e;++i){var delta=arguments[i];if(delta&&delta.hovered){$n2.extend(mergedStyle.hovered,delta.hovered);};if(delta&&delta.clicked){$n2.extend(mergedStyle.clicked,delta.clicked);};if(delta&&delta.hoveredClicked){$n2.extend(mergedStyle.hoveredClicked,delta.hoveredClicked);};};return mergedStyle;},_computeStateStyles:function(baseStyle){var mergedStyle=this._mergeStateStyles.apply(this,arguments);var computedStyle={normal:new OpenLayers.Style(mergedStyle.normal),hovered:new OpenLayers.Style(mergedStyle.hovered),clicked:new OpenLayers.Style(mergedStyle.clicked),hoveredClicked:new OpenLayers.Style(mergedStyle.hoveredClicked),_merged:mergedStyle};return computedStyle;},getStyleMapForLayerInfo:function(layerInfo){var _this=this;var styleMap=new OpenLayers.StyleMapCallback(function(feature,intent){var effectiveIntent=null;if(null==effectiveIntent&&feature.isHovered){if(feature.isClicked){effectiveIntent='hoveredClicked';}else{effectiveIntent='hovered';};};if(null==effectiveIntent&&feature.isClicked){effectiveIntent='clicked';};if(null==effectiveIntent){effectiveIntent='normal';};var geomType=feature.geometry._n2Type;if(!geomType){if(feature.geometry.CLASS_NAME.indexOf('Line')>=0){geomType=feature.geometry._n2Type='line';}else if(feature.geometry.CLASS_NAME.indexOf('Polygon')>=0){geomType=feature.geometry._n2Type='polygon';}else{geomType=feature.geometry._n2Type='point';};};var data=feature.data;if(feature&&feature.cluster&&1===feature.cluster.length){data=feature.cluster[0].data;};var n2Intent=feature.n2HoverIntent;if(!n2Intent){n2Intent=feature.n2SelectIntent;};if(!n2Intent){n2Intent=feature.n2Intent;};var layerId=layerInfo.id;var schemaName=null;if(data&&data.nunaliit_schema){schemaName=data.nunaliit_schema;};if(feature&&feature.cluster&&feature.cluster.length>1){n2Intent='cluster';};var styleSet=_this._retrieveStyleSet(n2Intent,schemaName,layerId);var style=styleSet[geomType][effectiveIntent];return style.createSymbolizer(feature);});return styleMap;}});$n2.mapStyles={MapFeatureStyles:MapFeatureStyles};})(nunaliit2);if(typeof(exports)==="undefined"){var patcher={};}
(function(){function clone(obj){if(obj===null){return null;}else if(typeof(obj)!="object"){return obj;}else if(obj instanceof Array){var result=new Array(obj.length);for(var i=0;i<result.length;++i){result[i]=clone(obj[i]);}
return result;}else{var result={}
for(var i in obj){result[i]=clone(obj[i]);}
return result;}}
function computePatch(prev,next,update_in_place){var updates={},has_updates=false;var processElement=function(id){var target_id=(typeof(id)=="string"&&id.charAt(0)=="_"?"_"+id:id);if(typeof(target_id)==='number'){target_id='_'+target_id;};if(id in prev&&typeof(prev[id])==typeof(next[id])){if(typeof(next[id])=="object"&&(prev[id]instanceof Array)==(next[id]instanceof Array)){var res=computePatch(prev[id],next[id],update_in_place);if(res!==null){has_updates=true;updates[target_id]=res;}
return;}
else if(prev[id]===next[id]){return;}}
has_updates=true;updates[target_id]=clone(next[id]);if(update_in_place){prev[id]=updates[target_id];}};if(next instanceof Array){if(prev.length!=next.length){if(update_in_place){prev.length=next.length;}
has_updates=true;updates["_r"]=next.length;}
for(var i=next.length-1;i>=0;--i){processElement(i);}}else{var removals=[];for(var i in prev){if(!(i in next)){removals.push(i);}}
if(removals.length>0){has_updates=true;updates["_r"]=(removals.length==1?removals[0]:removals);if(update_in_place){for(var i=removals.length-1;i>=0;--i){delete prev[removals[i]];}}}
for(var i in next){processElement(i);}}
if(has_updates){return updates;}
return null;};function applyPatch(obj,patch){var i;if("_r"in patch){if(obj instanceof Array){obj.length=patch["_r"];}
else{var removals=patch["_r"];if(removals instanceof Array){for(i=0;i<removals.length;++i){delete obj[removals[i]];}}else{delete obj[removals];}}
delete patch["_r"];}
for(i in patch){if(typeof(i)==='string'&&i.length>1&&i.charAt(0)=='_'&&i.charAt(1)=='_'){var t=i.substring(1);}else if(typeof(i)==='string'&&i.length>0&&i.charAt(0)=='_'){t=1*i.substring(1);}else{t=i;};if(typeof(obj[t])==typeof(patch[i])&&typeof(patch[i])=="object"&&patch[i]!=null){if((obj[t]instanceof Array)==(patch[i]instanceof Array)){applyPatch(obj[t],patch[i]);continue;}else if((obj[t]instanceof Array)&&false==(patch[i]instanceof Array)){applyPatch(obj[t],patch[i]);continue;};}
obj[t]=patch[i]}};if(typeof(exports)==="undefined"){patcher.computePatch=computePatch;patcher.applyPatch=applyPatch;}else{exports.computePatch=computePatch;exports.applyPatch=applyPatch;}})();;(function($n2){var DEFAULT_PRECISION=0.00001;var MIN_POSITIONS_LINEAR_RING=4;var MIN_POSITIONS_LINE_STRING=2;function compressCoordinateArray(ca,precision,sigDecimals){function compressCoordinate(c){var temp=Math.round(c/precision)*precision;var str=temp.toFixed(sigDecimals);return parseFloat(str);};var out=[];for(var i=0,len=ca.length;i<len;i++){out[i]=compressCoordinate(ca[i]);};return out;};function computeSignificantDecimalDigits(precision){var sigDecimals=0;if(precision<1.0){for(var temp=precision;temp<1.0;temp*=10,sigDecimals++){};};return sigDecimals;};var defaultOptions_GJCC={precision:DEFAULT_PRECISION,isLinearRing:false,isPoint:false,dropInnerRings:false};$n2.GeoJsonCoordinatesCompressor=$n2.Class({options:null,significantDigits:null,initialize:function(){this.options=$n2.extend({},defaultOptions_GJCC);for(var i=0;i<arguments.length;i++){var o=arguments[i];if($n2.isDefined(o)){this.options=$n2.extend(true,this.options,o);};};if(0.0===this.options.precision){this.options.precision=DEFAULT_PRECISION;};this.significantDigits=computeSignificantDecimalDigits(this.options.precision);},compress:function(coordinates){if(this.options.isPoint){return compressCoordinateArray(coordinates,this.options.precision,this.significantDigits);};if(!$n2.isArray(coordinates[0])){return coordinates;};var out=[];var last=compressCoordinateArray(coordinates[0],this.options.precision,this.significantDigits);out.push(last);for(var i=1,len=coordinates.length-1;i<len;i++){var curr=compressCoordinateArray(coordinates[i],this.options.precision,this.significantDigits);if(last[0]!==curr[0]||last[1]!==curr[1]){out.push(curr);last=curr;};};out.push(compressCoordinateArray(coordinates[len],this.options.precision,this.significantDigits));if(this.options.isLinearRing&&MIN_POSITIONS_LINEAR_RING>out.length){return null;}else if(MIN_POSITIONS_LINE_STRING>out.length){return null;};return out;}});function initialStatus(){return{original:{linestrings:0,positions:0},processed:{linestrings:0,positions:0}};};function accumulateStatus(accumulate,update){accumulate.original.positions+=update.original.positions;accumulate.original.linestrings+=update.original.linestrings;accumulate.processed.positions+=update.processed.positions;accumulate.processed.linestrings+=update.processed.linestrings;};function computeStatus(accumulate,inData,update){function isPointCase(coords){if(!$n2.isArray(coords[0])){return true;};return false;};var inLength,outLength;if(isPointCase(inData)){inLength=1;if($n2.isDefined(update)){outLength=1;}else{outLength=0;};}else{inLength=inData.length;if($n2.isDefined(update)){outLength=update.length}else{outLength=0;};};accumulate.original.positions+=inLength;accumulate.original.linestrings+=1;accumulate.processed.positions+=outLength;if(outLength>0){accumulate.processed.linestrings+=1;};};var defaultOptions_GJGC={precision:DEFAULT_PRECISION};$n2.GeoJsonGeometryCompressor=$n2.Class({options:null,linestringCoordCompressor:null,pointCoordCompressor:null,linearRingCoordCompressor:null,coordinateProcessors:null,featureProcessor:null,initialize:function(){this.options=$n2.extend({},defaultOptions_GJGC);for(var i=0;i<arguments.length;i++){var o=arguments[i];if($n2.isDefined(o)){this.options=$n2.extend(true,this.options,o);};};if(0.0===this.options.precision){this.options.precision=DEFAULT_PRECISION;};this.linestringCoordCompressor=new $n2.GeoJsonCoordinatesCompressor({precision:this.options.precision});this.pointCoordCompressor=new $n2.GeoJsonCoordinatesCompressor({precision:this.options.precision,isPoint:true});this.linearRingCoordCompressor=new $n2.GeoJsonCoordinatesCompressor({precision:this.options.precision,isLinearRing:true});function createCoordinateProcessors(that){that.coordinateProcessors={'point':function(coordinates,context){return that.pointCoordCompressor.compress(coordinates);},'multipoint':function(coordinates,context){return that.pointCoordCompressor.compress(coordinates);},'linestring':function(coordinates,context){return that.linestringCoordCompressor.compress(coordinates);},'multilinestring':function(coordinates,context){return that.linestringCoordCompressor.compress(coordinates);},'polygon':function(coordinates,context){if(that.options.dropInnerRings&&0!==context[context.length-1]){return null;};return that.linearRingCoordCompressor.compress(coordinates);},'multipolygon':function(coordinates,context){if(that.options.dropInnerRings&&0!==context[context.length-1]){return null;};return that.linearRingCoordCompressor.compress(coordinates);}};};createCoordinateProcessors(this);this.featureProcessor=new $n2.GeoJsonFeatureCoordinatesProcessor({coordinateProcessors:this.coordinateProcessors,initialStatus:initialStatus,computeStatus:computeStatus,accumulateStatus:accumulateStatus});},compressFeature:function(feature){var out=this.featureProcessor.process.feature(feature);return out;}});})(nunaliit2);;(function($n2){function wrapGeoOutput(type,data,status){var d;if(null===data){d=null;}else{d={'type':type,'coordinates':data};};return{data:d,status:status};};var defaultOptions={coordinateProcessors:{'point':function(coordinates){return coordinates;},'multipoint':function(coordinates){return coordinates;},'linestring':function(coordinates){return coordinates;},'multilinestring':function(coordinates){return coordinates;},'polygon':function(coordinates){return coordinates;},'multipolygon':function(coordinates){return coordinates;}},'initialStatus':function(){return null;},'computeStatus':function(accumulate,inData,update){},'accumulateStatus':function(accumulate,update){},"initialContext":function(){return[];},"adjustContext":function(context,direction){var temp;if('down'===direction){temp=context.slice(0);temp.push(0);}else{context[context.length-1]+=1;temp=context;};return temp;}};$n2.GeoJsonFeatureCoordinatesProcessor=$n2.Class({options:null,process:{},initialize:function(){this.options=$n2.extend({},defaultOptions);for(var i=0;i<arguments.length;i++){var o=arguments[i];if($n2.isDefined(o)){this.options=$n2.extend(true,this.options,o);};};var that=this;this.process.feature=function(feature){if(null===feature){return null;};var context=that.options.initialContext();var out={data:{},status:null};for(var p in feature){if(feature.hasOwnProperty(p)){if('geometry'==p){var geometryType=feature[p].type;var geo=that.process[geometryType.toLowerCase()].apply(that,[feature[p],that.options.adjustContext(context,'down')]);if(!$n2.isDefined(geo)||!$n2.isDefined(geo.data)){out.data=null;}else{out.data[p]=geo.data;};out.status=geo.status;}else{if($n2.isDefined(out.data)){out.data[p]=feature[p];};};};};return out;};this.process.point=function(point,context){if(null===point){return null;};var out={data:[],status:that.options.initialStatus()};var p=that.options.coordinateProcessors.point(point.coordinates,context);that.options.computeStatus(out.status,point.coordinates,p);return wrapGeoOutput(point.type,p,out.status);};this.process.multipoint=function(multipoint,context){if(null===multipoint){return null;};var out={data:[],status:that.options.initialStatus()};for(var i=0,len=multipoint.coordinates.length;i<len;++i){var p=that.options.coordinateProcessors.multipoint(multipoint.coordinates[i],context);if($n2.isDefined(p)){out.data.push(p);};that.options.computeStatus(out.status,multipoint.coordinates[i],p);that.options.adjustContext(context,'lateral');};if(0===out.data.length){out.data=null;};return wrapGeoOutput(multipoint.type,out.data,out.status);};this.process.linestring=function(linestring,context){if(null===linestring){return null;};var out={data:[],status:that.options.initialStatus()};var s=that.options.coordinateProcessors.linestring(linestring.coordinates,context);that.options.computeStatus(out.status,linestring.coordinates,s);return wrapGeoOutput(linestring.type,s,out.status);};this.process.multilinestring=function(multilinestring,context){if(null===multilinestring){return null;};var out={data:[],status:that.options.initialStatus()};for(var i=0,len=multilinestring.coordinates.length;i<len;++i){var s=that.options.coordinateProcessors.multilinestring(multilinestring.coordinates[i],context);if($n2.isDefined(s)){out.data.push(s);};that.options.computeStatus(out.status,multilinestring.coordinates[i],s);that.options.adjustContext(context,'lateral');};if(0===out.data.length){out.data=null;};return wrapGeoOutput(multilinestring.type,out.data,out.status);};this.process.polygon=function(polygon,context){if(null===polygon){return null;};var out={data:[],status:that.options.initialStatus()};for(var i=0,len=polygon.coordinates.length;i<len;++i){var p=that.options.coordinateProcessors.polygon(polygon.coordinates[i],context);if($n2.isDefined(p)){out.data.push(p);};that.options.computeStatus(out.status,polygon.coordinates[i],p);that.options.adjustContext(context,'lateral');};if(0===out.data.length){out.data=null;};return wrapGeoOutput(polygon.type,out.data,out.status);};this.process.multipolygon=function(multipolygon,context){if(null===multipolygon){return null;};var out={data:[],status:that.options.initialStatus()};for(var i=0,len=multipolygon.coordinates.length;i<len;++i){var data2=[];var ctxt=that.options.adjustContext(context,'down');for(var j=0,len2=multipolygon.coordinates[i].length;j<len2;j++){var p=that.options.coordinateProcessors.multipolygon(multipolygon.coordinates[i][j],ctxt);if($n2.isDefined(p)){data2.push(p);};that.options.computeStatus(out.status,multipolygon.coordinates[i][j],p);that.options.adjustContext(ctxt,'lateral');};if(0!==data2.length){out.data.push(data2);};that.options.adjustContext(context,'lateral');};if(0===out.data.length){out.data=null;};return wrapGeoOutput(multipolygon.type,out.data,out.status);};this.process.geometrycollection=function(geometrycollection,context){if(null===geometrycollection){return null;};var out={data:[],status:that.options.initialStatus()};for(var i=0,len=geometrycollection.geometries.length;i<len;i++){var geometryType=geometrycollection.geometries[i].type;var geo=that.process[geometryType.toLowerCase()].apply(that,[geometrycollection.geometries[i],that.options.adjustContext(context,'down')]);if($n2.isDefined(geo)&&$n2.isDefined(geo.data)){out.data.push(geo.data);};that.options.accumulateStatus(out.status,geo.status);that.options.adjustContext(context,'lateral');};var d;if(0===out.data.length){d=null;}else{d={"type":geometrycollection.type,"geometries":out.data};};return{data:d,status:out.status};};}});})(nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var DH='n2.languageSupport';var DEFAULT_LANGUAGES=[{code:'en',name:'English'},{code:'fr',name:'Français'}];var LanguageSwitcher=$n2.Class({elemId:null,dispatcher:null,languages:null,initialize:function(opts_){var opts=$n2.extend({elem:null,elemId:null,dispatcher:null,languages:null},opts_);this.elemId=opts.elemId;if(opts.elem){var $elem=$(opts.elem);var id=$elem.attr('id');if(!id){id=$n2.getUniqueId();$elem.attr('id',id);};this.elemId=id;};this.dispatcher=opts.dispatcher;this.languages=opts.languages;if(!this.languages){this.languages=DEFAULT_LANGUAGES;};this._display();},_getElem:function(){return $('#'+this.elemId);},_display:function(){var _this=this;var $elem=this._getElem();$elem.empty();var $a=$('<a/>').text(_loc('Language')).attr('href','#').appendTo($elem).click(function(){_this._dialog();return false;});},_dialog:function(){var _this=this;var diagId=$n2.getUniqueId();var $langDialog=$('<div id="'+diagId+'" class="n2lang_langSelect_dialog"></div>');var $langList=$('<div class="n2lang_langSelect_list"></div>').appendTo($langDialog);var onChange=function(e){var $input=$(this);if($input.is(':checked')){var code=$input.attr('n2Code');_this._selectLanguage(code);$('#'+diagId).dialog('close');};return false;};for(var i=0,e=this.languages.length;i<e;++i){var l=this.languages[i];addLanguage($langList,l.name,l.code);};addLanguage($langList,_loc('Default'),null);var dialogOptions={autoOpen:true,title:_loc('Select Language'),modal:true,width:740,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};$langDialog.dialog(dialogOptions);function addLanguage($list,name,code){var $div=$('<div/>').appendTo($list);var id=$n2.getUniqueId();var $input=$('<input type="radio" name="languageSelect"/>').attr('id',id).appendTo($div).change(onChange);if(code){$input.attr('n2Code',code)};$('<label/>').attr('for',id).text(name).appendTo($div);};},_selectLanguage:function(code){if(this.dispatcher){this.dispatcher.send(DH,{type:'languageSelect',lang:code});};}});var LanguageToggler=$n2.Class({elemId:null,dispatcher:null,languages:null,initialize:function(opts_){var opts=$n2.extend({elem:null,elemId:null,dispatcher:null,languages:null},opts_);this.elemId=opts.elemId;if(opts.elem){var $elem=$(opts.elem);var id=$elem.attr('id');if(!id){id=$n2.getUniqueId();$elem.attr('id',id);};this.elemId=id;};this.dispatcher=opts.dispatcher;this.languages=opts.languages;if(!this.languages){this.languages=DEFAULT_LANGUAGES;};this._display();},_getElem:function(){return $('#'+this.elemId);},_display:function(){var _this=this;var $elem=this._getElem();$elem.empty();var language=this._pickLanguageToDisplay();if(language){var $a=$('<a/>').text(language.name).attr('href','#').appendTo($elem).click(function(){_this._selectLanguage(language.code);return false;});};},_pickLanguageToDisplay:function(){var locale=$n2.l10n.getLocale();var lang=null;if(locale){lang=locale.lang;};for(var i=0,e=this.languages.length;i<e;++i){var l=this.languages[i];if(l.code!==lang){return l;};};return null;},_selectLanguage:function(code){if(this.dispatcher){this.dispatcher.send(DH,{type:'languageSelect',lang:code});};}});var LanguageService=$n2.Class({dispatcher:null,languages:null,useToggleWidget:null,initialize:function(opts_){var opts=$n2.extend({directory:null,languages:null},opts_);var _this=this;if(opts.directory){this.dispatcher=opts.directory.dispatchService;};this.languages=opts.languages;if(!this.languages){this.languages=[];for(var i=0,e=DEFAULT_LANGUAGES.length;i<e;++i){var l=DEFAULT_LANGUAGES[i];this.languages.push(l);};};this.useToggleWidget=false;var d=this.dispatcher;if(d){var f=function(m){_this._handle(m);};d.register(DH,'languageSelect',f);};},getLanguages:function(){this.languages;},addLanguage:function(language){if(language.name&&language.code){this.languages.push(language);};},setUseToggleWidget:function(f){this.useToggleWidget=f;},drawWidget:function(opts_){var opts=$n2.extend({elem:null,elemId:null},opts_,{dispatcher:this.dispatcher,languages:this.languages});if(this.useToggleWidget){return new LanguageToggler(opts);}else{return new LanguageSwitcher(opts);};},_send:function(msg){var d=this.dispatcher;if(d){d.send(DH,msg);};},_handle:function(msg){if('languageSelect'===msg.type){if(msg.lang){this._selectLanguage(msg.lang);}else{this._resetLanguage();};};},_selectLanguage:function(lang){$n2.cookie.setCookie({name:'nunaliit-l10n',value:lang,path:'/'});location.reload();},_resetLanguage:function(){$n2.cookie.deleteCookie('nunaliit-l10n');location.reload();}});$n2.languageSupport={LanguageService:LanguageService,LanguageSwitcher:LanguageSwitcher,LanguageToggler:LanguageToggler};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var FeatureClass={ADMIN:'A',HYDRO:'H',LANDMARKS:'L',PLACES:'P',ROADS:'R',SPOT:'S',MOUNTAINS:'T',UNDERSEA:'U'};var AutoComplete=$n2.Class({service:null,inputId:null,options:null,initialize:function(opts_){var opts=$n2.extend({service:null,input:null,autocomplete:null},opts_);var _this=this;this.service=opts.service;var $input=null;if(typeof(opts.input)==='string'){$input=$('#'+opts.input);this.inputId=opts.input;}else{$input=$(opts.input);var inputId=$input.attr('id');if(!inputId){inputId=$n2.getUniqueId();$input.attr('id',inputId);};this.inputId=inputId;};this.options={featureClass:$n2.GeoNames.FeatureClass.PLACES,maxRows:12};for(var key in opts){if('service'===key){}else if('input'===key){}else if('autocomplete'===key){}else{this.options[key]=opts[key];};};var autocompleteOptions=$n2.extend({minLength:3,open:function(){$(this).removeClass("ui-corner-all").addClass("ui-corner-top");},close:function(){$(this).removeClass("ui-corner-top").addClass("ui-corner-all");}},opts.autocomplete);autocompleteOptions.source=function(request,response){_this._autocompleteSource(request,response);};$input=this.getInput();$input.autocomplete(autocompleteOptions);},getInput:function(){return $('#'+this.inputId);},_autocompleteSource:function(request,response){if(request&&request.term&&request.term.length>2){var opts=$n2.extend({},this.options);opts.name=request.term;opts.onSuccess=function(results){var suggestions=[];var names={};for(var i=0,e=results.length;i<e;++i){var res=results[i];var name=res.name;if(!names[name]){var obj={label:res.name,value:res.name};suggestions[suggestions.length]=obj;names[name]=true;};};if(suggestions.length>0){response(suggestions);};};this.service.getNameStartsWith(opts);};}});var GeoNameService=$n2.Class({options:null,initialize:function(opts_){this.options=$n2.extend({geoNamesUrl:'http://api.geonames.org/',username:'nunaliit'},opts_);},getName:function(opts_){var opts=$n2.extend({name:null,featureClass:null,maxRows:null,country:null,countryBias:null,style:null,onSuccess:function(results){},onError:function(err){}},opts_);var data={name:opts.name};this._processGeoNamesSearchOptions(data,opts);this._getGeoNames('searchJSON',data,function(r){$n2.log('r',r);if(r.geonames){opts.onSuccess(r.geonames);}else{opts.onError(_loc('Invalid result returned by GeoNames'));};},opts.onError);},getNameStartsWith:function(opts_){var opts=$n2.extend({name:null,featureClass:null,maxRows:null,country:null,countryBias:null,style:null,onSuccess:function(results){},onError:function(err){}},opts_);var data={name_startsWith:opts.name};this._processGeoNamesSearchOptions(data,opts);this._getGeoNames('searchJSON',data,function(r){$n2.log('r',r);if(r.geonames){opts.onSuccess(r.geonames);}else{opts.onError(_loc('Invalid result returned by GeoNames'));};},opts.onError);},findNearby:function(opts_){var opts=$n2.extend({lng:null,lat:null,featureClass:null,featureCode:null,lang:null,radius:null,maxRows:null,style:null,localCountry:null,cities:null,onSuccess:function(results){},onError:function(err){}},opts_);var data={lng:opts.lng,lat:opts.lat};if(opts.maxRows){data.maxRows=opts.maxRows;};this._getGeoNames('findNearbyJSON',data,function(r){$n2.log('r',r);if(r.geonames){opts.onSuccess(r.geonames);}else{opts.onError(_loc('Invalid result returned by GeoNames'));};},opts.onError);},installAutoComplete:function(opts_){var opts=$n2.extend({input:null},opts_);opts.service=this;return new AutoComplete(opts);},_processGeoNamesSearchOptions:function(data,opts){if(opts.featureClass){data.featureClass=opts.featureClass;};if(typeof(opts.maxRows)==='number'){data.maxRows=opts.maxRows;};if(opts.country){data.country=opts.country;};if(opts.countryBias){data.countryBias=opts.countryBias;};if(opts.style){data.style=opts.style;};},_getGeoNames:function(method,data,success,error){var nonNullData={};for(var key in data){if(key&&data[key]){nonNullData[key]=data[key];};};nonNullData.username=this.options.username;$.ajax({url:this.options.geoNamesUrl+method,dataType:'json',data:nonNullData,traditional:true,success:success,error:function(xhr,textStatus){error(textStatus);}});}});$n2.GeoNames={Service:GeoNameService,FeatureClass:FeatureClass};})(jQuery,nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var dataSourceFromId={};function getDocumentSourceFromId(id){return dataSourceFromId[id];};var DocumentSource=$n2.Class({id:null,initialize:function(opts_){var opts=$n2.extend({id:null},opts_);this.id=opts.id;if(!this.id){this.id=$n2.getUniqueId();};if(this.id){dataSourceFromId[this.id]=this;};},getId:function(){return this.id;},createDocument:function(opts_){var opts=$n2.extend({doc:{},onSuccess:function(doc){},onError:function(errorMsg){}},opts_);opts.onError('Data source does not support the "createDocument" call.');},getDocument:function(opts_){var opts=$n2.extend({docId:null,rev:null,revs_info:false,revisions:false,conflicts:false,deleted_conflicts:false,onSuccess:function(doc){},onError:function(errorMsg){}},opts_);opts.onError('Data source does not support the "getDocument" call.');},getDocuments:function(opts_){var opts=$n2.extend({docIds:null,onSuccess:function(docs){},onError:function(errorMsg){}},opts_);opts.onError('Data source does not support the "getDocuments" call.');},getDocumentAttachmentUrl:function(doc,attachmentName){return null;},verifyDocumentExistence:function(opts_){var opts=$n2.extend({docIds:null,onSuccess:function(info){},onError:function(errorMsg){}},opts_);opts.onError('Data source does not support the "verifyDocumentExistence" call.');},updateDocument:function(opts_){var opts=$n2.extend({doc:null,onSuccess:function(doc){},onError:function(errorMsg){}},opts_);opts.onError('Data source does not support the "updateDocument" call.');},deleteDocument:function(opts_){var opts=$n2.extend({doc:null,onSuccess:function(){},onError:function(errorMsg){}},opts_);opts.onError('Data source does not support the "deleteDocument" call.');},getLayerDefinitions:function(opts_){var opts=$n2.extend({onSuccess:function(layerDefinitions){},onError:function(errorMsg){}},opts_);opts.onError('Data source does not support the "getLayerDefinitions" call.');},getDocumentInfoFromIds:function(opts_){var opts=$n2.extend({docIds:null,onSuccess:function(docInfos){},onError:function(errorMsg){}},opts_);opts.onError('Data source does not support the "getDocumentInfoFromIds" call.');},getReferencesFromId:function(opts_){var opts=$n2.extend({docId:null,onSuccess:function(referenceIds){},onError:function(errorMsg){}},opts_);opts.onError('Data source does not support the "getReferencesFromId" call.');},getProductFromId:function(opts_){var opts=$n2.extend({docId:null,onSuccess:function(referenceIds){},onError:function(errorMsg){}},opts_);opts.onError('Data source does not support the "getProductFromId" call.');},getDocumentsFromGeographicFilter:function(opts_){var opts=$n2.extend({docIds:null,layerId:null,bbox:null,projectionCode:null,onSuccess:function(docs){},onError:function(errorMsg){}},opts_);opts.onError('Data source does not support the "getDocumentsFromGeographicFilter" call.');},getGeographicBoundingBox:function(opts_){var opts=$n2.extend({layerId:null,bbox:null,onSuccess:function(bbox){},onError:function(errorMsg){}},opts_);opts.onError('Data source does not support the "getGeographicBoundingBox" call.');}});var DocumentWrapper=$n2.Class({doc:null,initialize:function(doc){this.doc=doc;},getDocumentSource:function(){var source=null;if(this.doc){source=this.doc.__n2Source;};return source;}});var clone=function(doc){var copy={};for(var key in doc){if('__n2Source'===key){copy[key]=doc[key];}else{copy[key]=$n2.deepCopy(doc[key]);};};return copy;};$n2.document={DocumentSource:DocumentSource,DocumentWrapper:DocumentWrapper,getDocumentSourceFromId:getDocumentSourceFromId,clone:clone};})(nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};function httpJsonError(XMLHttpRequest,defaultStr){if(!JSON||typeof(JSON.parse)!=='function'){return defaultStr;};var text=XMLHttpRequest.responseText;if(!text)return defaultStr;var error=JSON.parse(text);if(!error)return defaultStr;if(!error.reason)return defaultStr;return error.reason;};function fixUserName(userName){return userName.toLowerCase().replace(' ','');};function compareSessionContexts(s1,s2){if(s1===s2){return true;};if(!s1){return false;};if(!s2){return false;};if(s1.name!==s2.name){return false;};var s1Roles={};if(s1.roles){for(var i=0,e=s1.roles.length;i<e;++i){var role=s1.roles[i];s1Roles[role]=true;};};var s2Roles={};if(s2.roles){for(var i=0,e=s2.roles.length;i<e;++i){var role=s2.roles[i];s2Roles[role]=true;};};for(var role in s1Roles){if(!s2Roles[role]){return false;};};for(var role in s2Roles){if(!s1Roles[role]){return false;};};return true;};var Session=$n2.Class({server:null,pathToSession:null,changedContextListeners:null,lastSessionContext:null,initialize:function(server_,sessionInfo_){this.server=server_;this.changedContextListeners=[];this.lastSessionContext=null;if(sessionInfo_){if(sessionInfo_.ok){var context=sessionInfo_.userCtx;this.changeContext(context);};};},getUrl:function(){return this.server.getSessionUrl();},getContext:function(){return this.lastSessionContext;},addChangedContextListener:function(listener){if(typeof(listener)==='function'){this.changedContextListeners.push(listener);if(this.lastSessionContext){listener(this.lastSessionContext);};};},changeContext:function(context){this.lastSessionContext=context;if(this.lastSessionContext){for(var i=0,e=this.changedContextListeners.length;i<e;++i){var listener=this.changedContextListeners[i];try{listener(this.lastSessionContext);}catch(e){};};};},refreshContext:function(opts_){var opts=$.extend({onSuccess:function(context){},onError:$n2.reportErrorForced},opts_);var _this=this;var sessionUrl=this.getUrl();$.ajax({url:sessionUrl,type:'get',async:true,dataType:'json',success:function(res){if(res.ok){var context=res.userCtx;_this.changeContext(context);opts.onSuccess(context);}else{opts.onError('Malformed context reported');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining context: '+errStr);}});},login:function(opts_){var opts=$.extend({name:null,password:null,onSuccess:function(context){},onError:$n2.reportErrorForced},opts_);var _this=this;var sessionUrl=this.getUrl();if(opts.name){var name=fixUserName(opts.name);}else{opts.onError('A name must be supplied when logging in');return;};$.ajax({url:sessionUrl,type:'post',async:true,data:{name:name,password:opts.password},contentType:'application/x-www-form-urlencoded',dataType:'json',success:function(info){if(info&&info.ok){_this.refreshContext({onSuccess:opts.onSuccess,onError:opts.onError});}else{opts.onError('Unknown error during log in');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during log in: '+errStr);}});},logout:function(opts_){var opts=$.extend({onSuccess:function(context){},onError:$n2.reportErrorForced},opts_);var _this=this;var sessionUrl=this.getUrl();$.ajax({url:sessionUrl,type:'DELETE',async:true,dataType:'json',success:function(info){if(info&&info.ok){_this.refreshContext({onSuccess:opts.onSuccess,onError:opts.onError});}else{opts.onError('Unknown error during log out');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during log out: '+errStr);}});}});var designDoc=$n2.Class({ddUrl:null,ddName:null,initialize:function(opts_){var opts=$n2.extend({ddUrl:null,ddName:null,db:null},opts_);this.ddUrl=opts.ddUrl;this.ddName=opts.ddName;this.db=opts.db;},getQueryUrl:function(opts_){var opts=$.extend(true,{viewName:null,listName:null},opts_);if(opts.listName){return this.ddUrl+'_list/'+opts.listName+'/'+opts.viewName;}else{return this.ddUrl+'_view/'+opts.viewName;};},queryView:function(options_){var opts=$.extend(true,{viewName:null,listName:null,viewUrl:null,startkey:null,endkey:null,keys:null,group:null,include_docs:null,limit:null,onlyRows:true,rawResponse:false,reduce:false,onSuccess:function(rows){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to query a view');};var viewUrl=opts.viewUrl;if(!viewUrl){if(opts.listName){viewUrl=this.ddUrl+'_list/'+opts.listName+'/'+opts.viewName;}else{viewUrl=this.ddUrl+'_view/'+opts.viewName;};};var mustBePost=false;var queryCount=0;var query={};var data={};for(var k in opts){if(k==='viewName'||k==='listName'||k==='viewUrl'||k==='onlyRows'||k==='rawResponse'||k==='onSuccess'||k==='onError'||typeof(opts[k])==='undefined'||opts[k]===null){}else if(k==='keys'){mustBePost=true;data[k]=opts[k];}else{++queryCount;query[k]=JSON.stringify(opts[k]);};};var dataType='json';if(opts.rawResponse){dataType='text';};if(mustBePost){var jsonData=JSON.stringify(data);var effectiveUrl=viewUrl;if(queryCount>0){var params=$.param(query);effectiveUrl=viewUrl+'?'+params;};$.ajax({url:effectiveUrl,type:'POST',async:true,data:jsonData,contentType:'application/json',dataType:dataType,success:processResponse,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during view query '+opts.viewName+': '+errStr);}});}else{$.ajax({url:viewUrl,type:'GET',async:true,cache:false,data:query,dataType:dataType,success:processResponse,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during view query '+opts.viewName+': '+errStr);}});};function processResponse(queryResponse){if(opts.onlyRows){if(queryResponse.rows){opts.onSuccess(queryResponse.rows);}else{opts.onError('Unexpected response during view query '+opts.view);};}else{opts.onSuccess(queryResponse);};};}});var ChangeNotifier=$n2.Class({options:null,db:null,listeners:null,lastSequence:null,currentRequest:null,currentWait:null,onError:function(err){$n2.log(err);},initialize:function(db,opts_){this.options=$n2.extend({changeUrl:null,doNotReset:false,include_docs:false,pollInterval:5000,longPoll:false,timeout:20000,style:'all_docs',listeners:null,onSuccess:function(notifier){}},opts_);this.db=db;this.listeners=[];if(this.options.listeners){for(var i=0,e=this.options.listeners.length;i<e;++i){this.listeners.push(this.options.listeners[i]);};delete this.options.listeners;};var onSuccessFn=this.options.onSuccess;delete this.options.onSuccess;var _this=this;if(this.options.doNotReset){finishInitialization();}else{this.resetLastSequence({onSuccess:finishInitialization,onError:finishInitialization});};function finishInitialization(){_this.reschedule();_this.requestChanges();onSuccessFn(_this);};},addListener:function(listener){if(typeof(listener)==='function'){this.listeners.push(listener);this.requestChanges();};},resetLastSequence:function(opt_){var opt=$n2.extend({onSuccess:function(){},onError:function(err){}},opt_);var _this=this;this.db.getInfo({onSuccess:function(dbInfo){_this.lastSequence=dbInfo.update_seq;opt.onSuccess();},onError:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opt.onError('Error during a query of current update sequence: '+errStr);}});},getLastSequence:function(){return this.lastSequence;},_reportChanges:function(changes){if(changes.last_seq){this.lastSequence=changes.last_seq;};if(changes.results&&changes.results.length>0){for(var i=0,e=this.listeners.length;i<e;++i){this.listeners[i](changes);};};},requestChanges:function(){if(!this.listeners||this.listeners.length<1){return;};if(this.currentRequest){return;};if(this.currentWait){return;};var req={feed:'normal',style:this.options.style};if(typeof(this.lastSequence)==='number'){req.since=this.lastSequence;};if(this.options.include_docs){req.include_docs=this.options.include_docs;};if(this.options.longPoll){req.feed='longpoll';req.timeout=this.options.timeout;};this.currentRequest=req;var _this=this;$.ajax({url:this.options.changeUrl,type:'GET',async:true,data:req,dataType:'json',success:function(changes){_this.currentRequest=null;_this._reportChanges(changes);_this.reschedule();},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);_this.onError('Error during a server notifications: '+errStr);_this.reschedule();}});},reschedule:function(){var now=$n2.utils.getCurrentTime();var expected=now+this.options.pollInterval;if(this.currentWait){if(this.currentWait.expected>expected){if(typeof(clearTimeout)==='function'){clearTimeout(this.currentWait.timerId);}
this.currentWait=null;}else{return;};};this.currentWait={delayInMs:this.options.pollInterval,expected:expected};var _this=this;this.currentWait.timerId=setTimeout(function(){_this.currentWait=null;_this.requestChanges();},this.currentWait.delayInMs);}});var DatabaseCallbacks=$n2.Class({onCreatedCallbacks:null,onUpdatedCallbacks:null,onDeletedCallbacks:null,initialize:function(){this.onCreatedCallbacks=[];this.onUpdatedCallbacks=[];this.onDeletedCallbacks=[];},addOnCreatedCallback:function(f){if(typeof(f)==='function'){this.onCreatedCallbacks.push(f);}},addOnUpdatedCallback:function(f){if(typeof(f)==='function'){this.onUpdatedCallbacks.push(f);}},addOnDeletedCallback:function(f){if(typeof(f)==='function'){this.onDeletedCallbacks.push(f);}},_reportOnCreated:function(docInfo){for(var i=0,e=this.onCreatedCallbacks.length;i<e;++i){var f=this.onCreatedCallbacks[i];f(docInfo);};},_reportOnUpdated:function(docInfo){for(var i=0,e=this.onCreatedCallbacks.length;i<e;++i){var f=this.onUpdatedCallbacks[i];f(docInfo);};},_reportOnDeleted:function(docInfo){for(var i=0,e=this.onDeletedCallbacks.length;i<e;++i){var f=this.onUpdatedCallbacks[i];f(docInfo);};}});var Database=$n2.Class({dbUrl:null,dbName:null,server:null,callbacks:null,initialize:function(opts_,server_){var opts=$n2.extend({dbUrl:null,dbName:null},opts_);this.server=server_;this.dbUrl=opts.dbUrl;this.dbName=opts.dbName;if(!this.dbUrl){var pathToServer=server_.getPathToServer();this.dbUrl=pathToServer+this.dbName+'/';};this.callbacks=new DatabaseCallbacks();},getUrl:function(){return this.dbUrl;},getDesignDoc:function(opts_){var ddOpts=$.extend({ddUrl:null,ddName:null},opts_);if(!ddOpts.ddUrl){ddOpts.ddUrl=this.dbUrl+'_design/'+ddOpts.ddName+'/';};ddOpts.db=this;return new designDoc(ddOpts);},getChangeNotifier:function(opt_){var opt=$n2.extend({onSuccess:function(notifier){}},opt_);var changeNotifier=new ChangeNotifier(this,{changeUrl:this.dbUrl+'_changes',onSuccess:opt.onSuccess});return changeNotifier;},getChanges:function(opt_){var opt=$n2.extend({since:null,limit:null,descending:false,include_docs:false,onSuccess:function(changes){},onError:function(msg){$n2.reportErrorForced(msg);}},opt_);var req={feed:'normal'};if(opt.since){req.since=opt.since;};if(opt.limit){req.limit=opt.limit;};if(opt.descending){req.descending=opt.descending;};if(opt.include_docs){req.include_docs=opt.include_docs;};var changeUrl=this.dbUrl+'_changes';$.ajax({url:changeUrl,type:'GET',async:true,data:req,dataType:'json',success:opt.onSuccess,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining database changes: '+errStr);}});},getDocumentUrl:function(doc){if(typeof(doc)==='string'){var docId=doc;}else{docId=doc._id;};return this.dbUrl+docId;},getAttachmentUrl:function(doc,attName){var docUrl=this.getDocumentUrl(doc);var url=docUrl+'/'+encodeURIComponent(attName);return url;},getDocumentRevision:function(opts_){var opts=$.extend({docId:null,onSuccess:function(info){},onError:function(msg){$n2.reportErrorForced(msg);}},opts_);if(!opts.docId){opts.onError('No docId set. Can not retrieve document information');return;};$.ajax({url:this.dbUrl+'_all_docs',type:'get',async:true,data:{startkey:'"'+opts.docId+'"',endkey:'"'+opts.docId+'"',include_docs:false},dataType:'json',success:function(res){if(res.rows&&res.rows[0]&&res.rows[0].value&&res.rows[0].value.rev){opts.onSuccess(res.rows[0].value.rev);}else{opts.onError('Malformed document revision for: '+opts.docId);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining document revision for '+opts.docId+': '+errStr);}});},getDocumentRevisions:function(opts_){var opts=$.extend({docIds:null,onSuccess:function(info){},onError:function(msg){$n2.reportErrorForced(msg);}},opts_);if(!opts.docIds){opts.onError('No docIds set. Can not retrieve document revisions');return;};if(!$n2.isArray(opts.docIds)){opts.onError('docIds must ba an array. Can not retrieve document revisions');return;};var data={keys:opts.docIds};$.ajax({url:this.dbUrl+'_all_docs?include_docs=false',type:'POST',async:true,data:JSON.stringify(data),contentType:'application/json',dataType:'json',success:function(res){if(res.rows){var info={};for(var i=0,e=res.rows.length;i<e;++i){var row=res.rows[i];if(row.id&&row.value&&row.value.rev){if(!row.value.deleted){info[row.id]=row.value.rev;};};};opts.onSuccess(info);}else{opts.onError('Malformed document revisions');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining document revision for '+opts.docId+': '+errStr);}});},buildUploadFileForm:function(jQuerySet,options_){var _this=this;var opts=$.extend({docId:null,rev:null,doc:null,onSuccess:function(res){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);jQuerySet.empty();if(!$.fn.ajaxSubmit){opts.onError('Can not perform file uploads unless jquery.form.js is included');};if(null==opts.docId){if(opts.doc)opts.docId=opts.doc._id;};if(null==opts.docId){opts.onError('Must specify document id when performing file uploads');};if(null==opts.rev){if(opts.doc)opts.rev=opts.doc._rev;};if(null==opts.rev){this.getDocumentRevision({docId:opts.docId,onSuccess:function(docRev){jQuerySet.each(function(i,elem){installForm(elem,opts.docId,docRev);});},onError:opts.onError});}else{jQuerySet.each(function(i,elem){installForm(elem,opts.docId,opts.rev);});};function installForm(elem,docId,docRev){var $elem=$(elem),$form=$('<form method="post"></form>'),$button=$('<input class="n2CouchInputButton" type="button"/>');$form.append($('<input class="n2CouchInputFile" type="file" name="_attachments"/>'));$form.append($('<input type="hidden" name="_rev" value="'+docRev+'"/>'));$button.val(_loc('Upload'));$form.append($button);$elem.append($form);$button.click(function(){$form.ajaxSubmit({type:'post',url:_this.dbUrl+docId,dataType:'json',success:function(res){$elem.find('*').removeAttr('disabled');if(res.error){opts.onError(_loc('Error while uploading: ')+res.error,options_);}else{opts.onSuccess(res,options_);}},error:function(xhr,status,err){$elem.find('*').removeAttr('disabled');opts.onError(_loc('Error while uploading: ')+err,options_);}});$elem.find('.n2CouchInputButton').attr('disabled','disabled');});};},createDocument:function(options_){var opts=$.extend(true,{data:{},onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to create database documents');};var _s=this;var docId=opts.data._id;if(docId){onUuid(docId);}else{this.server.getUniqueId({onSuccess:onUuid,onError:opts.onError});};function onUuid(docId){$.ajax({url:_s.dbUrl+docId,type:'put',async:true,data:JSON.stringify(opts.data),contentType:'application/json',dataType:'json',success:function(docInfo){_s.callbacks._reportOnCreated(docInfo);opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error creating document: '+errStr);}});};},updateDocument:function(options_){var opts=$.extend(true,{data:null,onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to update database documents');return;};if(!opts.data||!opts.data._id||!opts.data._rev){opts.onError('On update, a valid document with _id and _rev attributes must be supplied');return;};var _s=this;$.ajax({url:_s.dbUrl+opts.data._id,type:'PUT',async:true,data:JSON.stringify(opts.data),contentType:'application/json',dataType:'json',success:function(docInfo){_s.callbacks._reportOnUpdated(docInfo);opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error updating document: '+errStr);}});},deleteDocument:function(options_){var opts=$.extend(true,{data:null,onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to delete database documents');return;};if(!opts.data||!opts.data._id||!opts.data._rev){opts.onError('On delete, a valid document with _id and _rev attributes must be supplied');return;};var _s=this;$.ajax({url:_s.dbUrl+opts.data._id+'?rev='+opts.data._rev,type:'DELETE',async:true,dataType:'json',success:function(docInfo){_s.callbacks._reportOnDeleted(docInfo);opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error deleting document: '+errStr);}});},bulkDocuments:function(documents,options_){var opts=$.extend(true,{onSuccess:function(docInfos){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to create database documents');};var data=JSON.stringify({docs:documents});var _s=this;$.ajax({url:_s.dbUrl+'_bulk_docs',type:'POST',async:true,data:data,contentType:'application/json',dataType:'json',success:function(docInfos){opts.onSuccess(docInfos);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error on bulk document operation: '+errStr);}});},getDocument:function(options_){var opts=$.extend(true,{docId:null,rev:null,revs_info:false,revisions:false,conflicts:false,deleted_conflicts:false,onSuccess:function(doc){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(!opts.docId){opts.onError('No docId set. Can not retrieve document');};var data={};if(opts.rev){data.rev=opts.rev;};if(opts.revs_info){data.revs_info='true';};if(opts.revisions){data.revs='true';};if(opts.conflicts){data.conflicts='true';};if(opts.deleted_conflicts){data.deleted_conflicts='true';};var url=this.dbUrl+opts.docId+'/';$.ajax({url:url,type:'get',async:true,data:data,dataType:'json',success:function(res){opts.onSuccess(res);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining document content for '+opts.docId+': '+errStr);}});},getDocuments:function(opts_){var opts=$.extend(true,{docIds:null,onSuccess:function(docs){},onError:function(errorMsg){$n2.log(errorMsg);}},opts_);if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to query multiple documents');return;};if(!opts.docIds){opts.onError('No docIds set. Can not retrieve documents');return;};var viewUrl=this.dbUrl+'_all_docs?include_docs=true';var data={keys:opts.docIds};$.ajax({url:viewUrl,type:'POST',async:true,data:JSON.stringify(data),contentType:'application/json',dataType:'json',success:function(queryResult){if(queryResult.rows){var docs=[];for(var i=0,e=queryResult.rows.length;i<e;++i){var row=queryResult.rows[i];if(row&&row.doc){docs.push(row.doc);}};opts.onSuccess(docs);}else{opts.onError('Unexpected response during query of multiple documents');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during query of multiple documents: '+errStr);}});},listAllDocuments:function(opts_){var opts=$.extend(true,{onSuccess:function(docIds){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);var viewUrl=this.dbUrl+'_all_docs?include_docs=false';$.ajax({url:viewUrl,type:'GET',async:true,dataType:'json',success:function(queryResult){if(queryResult.rows){var docIds=[];for(var i=0,e=queryResult.rows.length;i<e;++i){var row=queryResult.rows[i];if(row&&row.id){docIds.push(row.id);}};opts.onSuccess(docIds);}else{opts.onError('Unexpected response during listing of all documents');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during listing of all documents: '+errStr);}});},getAllDocuments:function(opts_){var opts=$.extend(true,{onSuccess:function(docs){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);var viewUrl=this.dbUrl+'_all_docs?include_docs=true';$.ajax({url:viewUrl,type:'GET',async:true,dataType:'json',success:function(queryResult){if(queryResult.rows){var docs=[];for(var i=0,e=queryResult.rows.length;i<e;++i){var row=queryResult.rows[i];if(row&&row.doc){docs.push(row.doc);}};opts.onSuccess(docs);}else{opts.onError('Unexpected response during retrieval of all documents');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during retrieval of all documents: '+errStr);}});},getInfo:function(opts_){var opts=$.extend(true,{onSuccess:function(dbInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);$.ajax({url:this.dbUrl,type:'GET',async:true,dataType:'json',success:function(dbInfo){if(dbInfo.error){opts.onError(dbInfo.error);}else{opts.onSuccess(dbInfo);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during databse infro: '+errStr);}});},queryTemporaryView:function(opts_){var opts=$n2.extend({map:null,reduce:null,onSuccess:function(rows){},onError:$n2.reportErrorForced},opts_);if(!opts.map){opts.onError('"map" must be provided in temporary view');};var data={map:opts.map};if(opts.reduce){data.reduce=opts.reduce;};var viewUrl=this.dbUrl+'_temp_view';$.ajax({url:viewUrl,type:'post',async:true,dataType:'json',data:JSON.stringify(data),contentType:'application/json',success:function(queryResult){if(queryResult.rows){opts.onSuccess(queryResult.rows);}else{opts.onError('Unexpected response during query of temporary view');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during query temporary view: '+errStr);}});}});var UserDb=$n2.Class(Database,{initialize:function(server_,dbName_){if(!dbName_){dbName='_users';};Database.prototype.initialize.call(this,{dbName:dbName_},server_);},createUser:function(opts_){var opts=$.extend({name:null,password:null,onSuccess:function(docInfo){},onError:$n2.reportErrorForced},opts_);var userDbUrl=this.getUrl();if(typeof(hex_sha1)!=='function'){opts.onError('SHA-1 must be installed');return;};if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to create database documents');return;};this.server.getUniqueId({onSuccess:onUuid});function onUuid(uuid){var id='org.couchdb.user:'+fixUserName(opts.name);var salt=uuid;var password_sha=hex_sha1(opts.password+salt);var doc={};for(var key in opts){if(key!=='name'&&key!=='password'&&key!=='onSuccess'&&key!=='onError'){doc[key]=opts[key];};};doc.type="user";doc.name=fixUserName(opts.name);doc.password_sha=password_sha;doc.salt=salt;if(!$n2.isArray(doc.roles)){doc.roles=[];};$.ajax({url:userDbUrl+id,type:'put',async:true,data:JSON.stringify(doc),contentType:'application/json',dataType:'json',success:opts.onSuccess,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during user creation: '+errStr);}});};},updateUser:function(options_){var opts=$.extend(true,{user:null,onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var userDbUrl=this.getUrl();if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to update user documents');return;};if(!opts.user||!opts.user._id){opts.onError('On update, a valid document with _id attribute must be supplied');return;};$.ajax({url:userDbUrl+opts.user._id,type:'PUT',async:true,data:JSON.stringify(opts.user),contentType:'application/json',dataType:'json',success:function(docInfo){opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error updating user: '+errStr);}});},setUserPassword:function(options_){var opts=$.extend(true,{user:null,password:null,onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var userDbUrl=this.getUrl();if(typeof(hex_sha1)!=='function'){opts.onError('SHA-1 must be installed');return;};if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to set user password');return;};if(!opts.user||!opts.user._id||!opts.user._rev){opts.onError('On password change, a valid user document with _id and _rev attributes must be supplied');return;};if(!opts.password){opts.onError('On password change, a valid password must be supplied');return;};this.computeUserPassword({userDoc:opts.user,password:opts.password,onSuccess:function(userDoc){$.ajax({url:userDbUrl+opts.user._id,type:'PUT',async:true,data:JSON.stringify(userDoc),contentType:'application/json',dataType:'json',success:function(docInfo){opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error changing user password: '+errStr);}});},onError:opts.onError});},computeUserPassword:function(options_){var opts=$.extend({userDoc:null,password:null,onSuccess:function(userDoc){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(typeof(hex_sha1)!=='function'){opts.onError('SHA-1 must be installed');return;};if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to set user password');return;};if(!opts.userDoc){opts.onError('On setting password, a user document must be provided');return;};if(!opts.password){opts.onError('On setting change, a valid password must be supplied');return;};this.server.getUniqueId({onSuccess:onUuid});function onUuid(uuid){var salt=uuid;var password_sha=hex_sha1(opts.password+salt);if(opts.userDoc.password)delete opts.userDoc.password;if(opts.userDoc.password_scheme)delete opts.userDoc.password_scheme;if(opts.userDoc.iterations)delete opts.userDoc.iterations;if(opts.userDoc.derived_key)delete opts.userDoc.derived_key;if(opts.userDoc.salt)delete opts.userDoc.salt;if(opts.userDoc.password_sha)delete opts.userDoc.password_sha;opts.userDoc.password_sha=password_sha;opts.userDoc.salt=salt;opts.onSuccess(opts.userDoc);};},deleteUser:function(opts_){var opts=$.extend({user:null,id:null,rev:null,name:null,onSuccess:function(docInfo){},onError:$n2.reportErrorForced},opts_);var userDbUrl=this.getUrl();var id=null;var rev=null;if(opts.user){id=opts.user._id;rev=opts.user._rev;}
if(!id&&opts.id){id=opts.id;}
if(!id&&opts.name){id='org.couchdb.user:'+fixUserName(opts.name);}
if(!rev&&opts.rev){rev=opts.rev;}
$.ajax({url:userDbUrl+id+'?rev='+rev,type:'DELETE',async:true,dataType:'json',success:opts.onSuccess,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during user deletion: '+errStr);}});},getUser:function(options_){var opts=$.extend(true,{name:null,id:null,onSuccess:function(user){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var userDbUrl=this.getUrl();var id=opts.id;if(!id){id='org.couchdb.user:'+fixUserName(opts.name);};$.ajax({url:userDbUrl+id,type:'get',async:true,dataType:'json',success:function(userDoc){opts.onSuccess(userDoc);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError(_loc('Error obtaining user document for {id}: {err}',{id:id,err:errStr}));}});},getUsers:function(options_){var opts=$.extend(true,{names:null,ids:null,onSuccess:function(users){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var _this=this;var effectiveUrl=this.getUrl()+'_all_docs?include_docs=true';var ids=null;if(opts.ids&&opts.ids.length){ids=opts.ids.slice(0);}else{ids=[];};if(opts.names&&opts.names.length){for(var i=0,e=opts.names.length;i<e;++i){ids.push('org.couchdb.user:'+fixUserName(opts.names[i]));};};if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to query multiple users');return;};var data={keys:ids};var users=[];var missingIds={};$.ajax({url:effectiveUrl,type:'POST',async:true,data:JSON.stringify(data),contentType:'application/json',dataType:'json',success:function(res){if(res.rows){var isMissing=false;for(var i=0,e=res.rows.length;i<e;++i){var row=res.rows[i];if(row&&row.doc){if(row.doc._id){users.push(row.doc);}else{isMissing=true;missingIds[row.id]=true;retrieveUser(row.id);};}};if(!isMissing){opts.onSuccess(users);};}else{opts.onError('Unexpected response during query of multiple users');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during query of multiple users: '+errStr);}});function retrieveUser(userId){_this.getUser({id:userId,onSuccess:function(user){if(user._id){users.push(user);};delete missingIds[userId];returnUsers();},onError:function(errorMsg){delete missingIds[userId];returnUsers();}});};function returnUsers(){for(var id in missingIds){return id;};opts.onSuccess(users);};},getAllUsers:function(opts_){var opts=$.extend({onSuccess:function(users){},onError:$n2.reportErrorForced},opts_);var _this=this;if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to query a view');return;};var viewUrl=this.getUrl()+'_all_docs';var data={startkey:JSON.stringify('org.couchdb.user:'),endkey:JSON.stringify('org.couchdb.user='),include_docs:true};var users=[];var missingIds={};$.ajax({url:viewUrl,type:'get',async:true,data:data,dataType:'json',success:function(queryResult){if(queryResult.rows){var isMissing=false;for(var i=0,e=queryResult.rows.length;i<e;++i){var row=queryResult.rows[i];if(row&&row.doc){if(row.doc._id){users.push(row.doc);}else{isMissing=true;missingIds[row.id]=true;retrieveUser(row.id);};}};if(!isMissing){opts.onSuccess(users);};}else{opts.onError('Unexpected response during query of all users');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during query of all users: '+errStr);}});function retrieveUser(userId){_this.getUser({id:userId,onSuccess:function(user){if(user._id){users.push(user);};delete missingIds[userId];returnUsers();},onError:function(errorMsg){delete missingIds[userId];returnUsers();}});};function returnUsers(){for(var id in missingIds){return id;};opts.onSuccess(users);};}});var Server=$n2.Class({options:null,isInitialized:false,uuids:null,userDbName:null,userDb:null,session:null,initListeners:null,initialize:function(options_,initListeners_){this.options=$n2.extend({pathToServer:'../',pathToSession:null,pathToUserDb:null,pathToUuids:null,pathToReplicate:null,pathToActiveTasks:null,pathToAllDbs:null,version:null,skipSessionInitialization:false,userDbName:null,onSuccess:function(server){},onError:function(err){}},options_);this.isInitialized=false;this.uuids=[];this.userDbName=this.options.userDbName;this.userDb=null;this.session=null;this.initListeners=initListeners_;if(!this.initListeners){this.initListeners=[];};var _this=this;getServerVersion();function getServerVersion(){if(_this.options.version){refreshContext();}else{$.ajax({url:_this.options.pathToServer,type:'get',async:true,dataType:'json',success:function(res){if(res.version){_this.options.version=res.version;getUserDbName();}else{errorInitialize('Malformed database welcome message.');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);errorInitialize('Error obtaining database welcome: '+errStr);}});};};function getUserDbName(){if(null!=_this.userDbName){refreshContext(null);}else{var sessionUrl=_this.getSessionUrl();$.ajax({url:sessionUrl,type:'get',async:true,dataType:'json',success:function(res){if(res.ok){if(res&&res.info&&res.info.authentication_db){_this.userDbName=res.info.authentication_db;};refreshContext(res);}else{errorInitialize('Malformed session information message.');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);errorInitialize('Error obtaining session information: '+errStr);}});};}
function refreshContext(sessionInfo){if(_this.options.skipSessionInitialization){finishInitialize();}else{_this.getSession().refreshContext({onSuccess:finishInitialize,onError:errorInitialize});};};function finishInitialize(){_this.isInitialized=true;for(var i=0,e=_this.initListeners;i<e;++i){var listener=_this.initListeners[i];try{listener();}catch(e){}};_this.initListeners=[];_this.options.onSuccess(_this);delete _this.options['onSuccess'];delete _this.options['onError'];};function errorInitialize(err){_this.options.onError(err);delete _this.options['onSuccess'];delete _this.options['onError'];};},getPathToServer:function(){return this.options.pathToServer;},getVersion:function(){return this.options.version;},getReplicateUrl:function(){if(null==this.options.pathToReplicate){return this.options.pathToServer+'_replicate';}
return this.options.pathToReplicate;},getActiveTasksUrl:function(){if(null==this.options.pathToActiveTasks){return this.options.pathToServer+'_active_tasks';}
return this.options.pathToActiveTasks;},getSessionUrl:function(){var result=this.options.pathToSession;if(!result){result=this.options.pathToServer+'_session';};return result;},getUniqueId:function(options_){var opts=$.extend({onSuccess:function(uuid){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var _this=this;if(this.uuids.length>0){var uuid=this.uuids.pop();opts.onSuccess(uuid);return;};var pathUUids=this.options.pathToUuids;if(!pathUUids){pathUUids=this.options.pathToServer+'_uuids';};$.ajax({url:pathUUids,type:'get',async:true,data:{count:10},dataType:'json',success:function(res){if(res.uuids){for(var i=0,e=res.uuids.length;i<e;++i){var uuid=res.uuids[i];_this.uuids.push(uuid);};var uuid=_this.uuids.pop();opts.onSuccess(uuid);return;}
opts.onError('Malformed uuids from database.');},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining new uuids from database: '+errStr);}});},listDatabases:function(options_){var opts=$.extend({onSuccess:function(dbNameArray){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var pathToAllDbs=this.options.pathToAllDbs;if(!pathToAllDbs){pathToAllDbs=this.options.pathToServer+'_all_dbs';};$.ajax({url:pathToAllDbs,type:'get',async:true,dataType:'json',success:opts.onSuccess,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining list of databases: '+errStr);}});},getUserDb:function(){if(!this.userDb){this.userDb=new UserDb(this,this.userDbName);};return this.userDb;},getSession:function(sessionInfo){if(!this.session){this.session=new Session(this,sessionInfo);};return this.session;},getDb:function(opts){return new Database(opts,this);},createDb:function(opts_){var opts=$n2.extend({dbName:null,onSuccess:function(db){},onError:$n2.reportErrorForced},opts_);if(!opts.dbName){opts.onError('"dbName" must be provided when creating a database');return;};var dbUrl=this.getPathToServer()+opts.dbName;var _s=this;$.ajax({url:dbUrl,type:'put',async:true,dataType:'json',success:function(creationInfo){if(creationInfo.ok){var db=_s.getDb({dbUrl:dbUrl});opts.onSuccess(db);}else{opts.onError('Error occurred when creating database: '+creationInfo.error);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error creating database: '+errStr);}});},deleteDb:function(opts_){var opts=$n2.extend({dbName:null,onSuccess:function(){},onError:$n2.reportErrorForced},opts_);if(!opts.dbName){opts.onError('"dbName" must be provided when deleting a database');return;};var dbUrl=this.getPathToServer()+opts.dbName;var _s=this;$.ajax({url:dbUrl,type:'DELETE',async:true,dataType:'json',success:function(info){if(info.ok){opts.onSuccess();}else{opts.onError('Error occurred when deleting database: '+info.error);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error deleting database: '+errStr);}});},replicate:function(opts_){var opts=$n2.extend({source:null,target:null,filter:null,docIds:null,continuous:false,onSuccess:function(db){},onError:$n2.reportErrorForced},opts_);if(!opts.source){opts.onError('"source" must be provided for replication');return;};if(!opts.target){opts.onError('"target" must be provided for replication');return;};var request={source:opts.source,target:opts.target};if(opts.filter){request.filter=opts.filter;};if(opts.continuous){request.continuous=true;};if(opts.docIds){request.doc_ids=opts.docIds;};var serverPath=this.getReplicateUrl();$.ajax({url:serverPath,type:'POST',async:true,data:JSON.stringify(request),contentType:'application/json',dataType:'json',success:function(res){if(res.error){opts.onError('Error while initiating replication: '+res.error);}else{opts.onSuccess(res);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error initiating replication: '+errStr);}});},addInitializedListener:function(listener){if(typeof(listener)==='function'){if(this.isInitialized){try{listener();}catch(e){}}else{this.initListeners.push(listener);};};}});function addAttachmentToDocument(opts_){var opts=$n2.extend({doc:null,data:null,attachmentName:null,contentType:'application/binary'},opts_);if(!opts.doc||!opts.data||!opts.attachmentName){return'Invalid parameters';};if(typeof($n2.Base64)=='undefined'){return'Base64 not included';};if(!opts.doc._attachments){opts.doc._attachments={};};opts.doc._attachments[opts.attachmentName]={};opts.doc._attachments[opts.attachmentName].content_type=opts.contentType;opts.doc._attachments[opts.attachmentName].data=$n2.Base64.encode(opts.data);return null;};$n2.couch=$.extend({},{getServer:function(opt_){return new Server(opt_);},DefaultServer:null,defaultInitializeListeners:[],getPathToServer:function(){return $n2.couch.DefaultServer.getPathToServer();},addInitializedListener:function(listener){if($n2.couch.DefaultServer){$n2.couch.DefaultServer.addInitializedListener(listener);}else{if(typeof(listener)==='function'){$n2.couch.defaultInitializeListeners.push(listener);};};},initialize:function(opts_){$n2.couch.DefaultServer=new Server(opts_,$n2.couch.defaultInitializeListeners);},getVersion:function(){return $n2.couch.DefaultServer.getVersion();},getSession:function(){return $n2.couch.DefaultServer.getSession();},getUserDb:function(){return $n2.couch.DefaultServer.getUserDb();},getReplicateUrl:function(){return $n2.couch.DefaultServer.getReplicateUrl();},getActiveTasksUrl:function(){return $n2.couch.DefaultServer.getActiveTasksUrl();},getDb:function(opts){return $n2.couch.DefaultServer.getDb(opts);},getUniqueId:function(options_){$n2.couch.DefaultServer.getUniqueId();},addAttachmentToDocument:addAttachmentToDocument,compareSessionContexts:compareSessionContexts});$.fn.couchUploadFile=function(opts){var db=$n2.couch.getDb(opts);db.buildUploadFileForm(this,opts);return this;};})(jQuery,nunaliit2);var n2utils={isArray:function(o){if(null===o)return false;if(typeof(o)!=='object')return false;if(typeof(o.length)!=='number')return false;if(typeof(o.push)!=='function')return false;if(typeof(o.pop)!=='function')return false;if(typeof(o.concat)!=='function')return false;if(typeof(o.join)!=='function')return false;if(typeof(o.slice)!=='function')return false;if(typeof(o.reverse)!=='function')return false;if(typeof(o.splice)!=='function')return false;if(typeof(o.sort)!=='function')return false;return true;},isArrayOfStrings:function(o){if(!n2utils.isArray(o))return false;for(var i=0,e=o.length;i<e;++i){if(typeof o[i]!=='string')return false;};return true;},isValidBounds:function(b){if(false==n2utils.isArray(b))return false;if(b.length!=4)return false;var minx=b[0],miny=b[1],maxx=b[2],maxy=b[3];if(typeof(minx)!=='number')return false;if(typeof(miny)!=='number')return false;if(typeof(maxx)!=='number')return false;if(typeof(maxy)!=='number')return false;return true;},isValidGeom:function(o){if(typeof(o)!=='object')return false;if(typeof(o.nunaliit_type)!=='string')return false;if(typeof(o.wkt)!=='string')return false;if(o.nunaliit_type!=='geometry')return false;if(o.bbox){if(false==n2utils.isValidBounds(o.bbox))return false;}else{return false;};return true;},geomSize:function(o){if(typeof(o)!=='object')return 0;if(typeof(o.wkt)==='string'){return o.wkt.length;};return 0;},extractLayers:function(doc){var result=null;if(doc.nunaliit_layers&&n2utils.isArray(doc.nunaliit_layers)){var layerMap={};for(var i=0,e=doc.nunaliit_layers.length;i<e;++i){var l=doc.nunaliit_layers[i];if(typeof(l)==='string'){layerMap[l]=true;};};for(var layerId in layerMap){if(!result)result=[];result.push(layerId);};};return result;},excludedSearchTerms:['a','the','of','an','and','or','by','in','to'],extractSearchTerms:function(doc,indexing){var strings=[];n2utils.extractStrings(doc,strings,null,n2utils.excludedSearchAttributes);var map={};for(var i=0,e=strings.length;i<e;++i){n2utils.extractWordsFromString(strings[i],map,indexing);};return map;},excludedSearchAttributes:['_rev','nunaliit_geom'],reWordSplit:/[\x00-\x26\x28-\x2f\x3a-\x40\x5b-\x5e\x60\x7b-\x7f]+/,addWordToMap:function(word,index,map){var word=word.toLowerCase();word=n2utils.removeApostrophe(word);if(word&&word!==''){if(map[word]){map[word].count++;if(index<map[word].index){map[word].index=index;};}else{var folded=n2utils.foldWord(word);map[word]={index:index,count:1,folded:folded};};};},extractWordsFromString:function(str,map,indexing){var words=str.split(n2utils.reWordSplit);for(var i=0,e=words.length;i<e;++i){n2utils.addWordToMap(words[i],i,map);if(indexing){var fragments=words[i].split('_');if(fragments.length>1){for(var j=0,k=fragments.length;j<k;++j){if(fragments[j].length>0){n2utils.addWordToMap(fragments[j],i,map);};};};};};},extractStrings:function(obj,strings,currentPath,excludedPaths){for(var i=0,e=excludedPaths.length;i<e;++i){if(excludedPaths[i]===currentPath)return;};if(null===obj){}else if(typeof(obj)==='string'){strings.push(obj);}else if(n2utils.isArray(obj)){for(var i=0,e=obj.length;i<e;++i){var p=currentPath?currentPath+'.'+i:''+i;n2utils.extractStrings(obj[i],strings,p,excludedPaths);};}else if(typeof(obj)==='object'){for(var key in obj){var p=currentPath?currentPath+'.'+key:''+key;n2utils.extractStrings(obj[key],strings,p,excludedPaths);};};},foldedChars:{0x60:0x27,0xc0:0x61,0xc1:0x61,0xc2:0x61,0xc3:0x61,0xc4:0x61,0xc7:0x63,0xc8:0x65,0xc9:0x65,0xca:0x65,0xcb:0x65,0xcc:0x69,0xcd:0x69,0xce:0x69,0xcf:0x69,0xd1:0x6e,0xd2:0x6f,0xd3:0x6f,0xd4:0x6f,0xd5:0x6f,0xd6:0x6f,0xd8:0x6f,0xd9:0x75,0xda:0x75,0xdb:0x75,0xdc:0x75,0xdd:0x79,0xe0:0x61,0xe1:0x61,0xe2:0x61,0xe3:0x61,0xe4:0x61,0xe7:0x63,0xe8:0x65,0xe9:0x65,0xea:0x65,0xeb:0x65,0xec:0x69,0xed:0x69,0xee:0x69,0xef:0x69,0xf1:0x6e,0xf1:0x6e,0xf2:0x6f,0xf3:0x6f,0xf4:0x6f,0xf5:0x6f,0xf6:0x6f,0xf8:0x6f,0xf9:0x75,0xfa:0x75,0xfb:0x75,0xfc:0x75,0xfd:0x79,0xff:0x79,0x0100:0x61,0x0101:0x61,0x0102:0x61,0x0103:0x61,0x0104:0x61,0x0105:0x61,0x0106:0x63,0x0107:0x63,0x0108:0x63,0x0109:0x63,0x010a:0x63,0x010b:0x63,0x010c:0x63,0x010d:0x63,0x010e:0x64,0x010f:0x64,0x0110:0x64,0x0111:0x64,0x0112:0x65,0x0113:0x65,0x0114:0x65,0x0115:0x65,0x0116:0x65,0x0117:0x65,0x0118:0x65,0x0119:0x65,0x011a:0x65,0x011b:0x65,0x011c:0x67,0x011d:0x67,0x011e:0x67,0x011f:0x67,0x0120:0x67,0x0121:0x67,0x0122:0x67,0x0123:0x67,0x0124:0x68,0x0125:0x68,0x0126:0x68,0x0127:0x68,0x0128:0x69,0x0129:0x69,0x012a:0x69,0x012b:0x69,0x012c:0x69,0x012d:0x69,0x012e:0x69,0x012f:0x69,0x0130:0x69,0x0131:0x69,0x0134:0x6a,0x0135:0x6a,0x0136:0x6b,0x0137:0x6b,0x0138:0x6b,0x0139:0x6c,0x013a:0x6c,0x013b:0x6c,0x013c:0x6c,0x013d:0x6c,0x013e:0x6c,0x013f:0x6c,0x0140:0x6c,0x0141:0x6c,0x0142:0x6c,0x0143:0x6e,0x0144:0x6e,0x0145:0x6e,0x0146:0x6e,0x0147:0x6e,0x0148:0x6e,0x0149:0x6e,0x014a:0x6e,0x014b:0x6e,0x014c:0x6f,0x014d:0x6f,0x014e:0x6f,0x014f:0x6f,0x0150:0x6f,0x0151:0x6f,0x0154:0x72,0x0155:0x72,0x0156:0x72,0x0157:0x72,0x0158:0x72,0x0159:0x72,0x015a:0x73,0x015b:0x73,0x015c:0x73,0x015d:0x73,0x015e:0x73,0x015f:0x73,0x0160:0x73,0x0161:0x73,0x0162:0x74,0x0163:0x74,0x0164:0x74,0x0165:0x74,0x0166:0x74,0x0167:0x74,0x0168:0x75,0x0169:0x75,0x016a:0x75,0x016b:0x75,0x016c:0x75,0x016d:0x75,0x016e:0x75,0x016f:0x75,0x0170:0x75,0x0171:0x75,0x0172:0x75,0x0173:0x75,0x0174:0x77,0x0175:0x77,0x0176:0x79,0x0177:0x79,0x0178:0x79,0x0179:0x7a,0x017a:0x7a,0x017b:0x7a,0x017c:0x7a,0x017d:0x7a,0x017e:0x7a,0x2018:0x27,0x2019:0x27,0x201b:0x27,0x2032:0x27,0x2035:0x27},foldWord:function(word){var r=[];word=word.toLowerCase();for(var i=0,e=word.length;i<e;++i){var c=word.charCodeAt(i);if(c===c){var s=n2utils.foldedChars[c];if(s){r.push(String.fromCharCode(s));}else{r.push(String.fromCharCode(c));};};};return r.join('');},removeApostrophe:function(word){if(word.length>1&&n2utils.isApostropheCodeChar(word.charCodeAt(0))){word=word.substr(1,word.length-1);};if(word.length>1&&n2utils.isApostropheCodeChar(word.charCodeAt(word.length-1))){word=word.substr(0,word.length-1);};if(word.length>2&&word[word.length-1]==='s'&&n2utils.isApostropheCodeChar(word.charCodeAt(word.length-2))){word=word.substr(0,word.length-2);};return word;},isApostropheCodeChar:function(code){return(code===0x27||code===0x60||code===0x2018||code===0x2019||code===0x201b||code===0x2032||code===0x2035);},extractTypes:function(obj,result,ancestors){ancestors=ancestors?ancestors:[];if(ancestors.indexOf(obj)>=0){return;};ancestors.push(obj);if(null===obj){}else if(n2utils.isArray(obj)){for(var i=0,e=obj.length;i<e;++i){n2utils.extractTypes(obj[i],result,ancestors);};}else if(typeof(obj)==='object'){if(obj.nunaliit_type){result[obj.nunaliit_type]=1;};for(var key in obj){var value=obj[key];n2utils.extractTypes(value,result,ancestors);};};ancestors.pop();},extractSpecificType:function(obj,type,result,ancestors){ancestors=ancestors?ancestors:[];if(ancestors.indexOf(obj)>=0){return;};ancestors.push(obj);if(null===obj){}else if(n2utils.isArray(obj)){for(var i=0,e=obj.length;i<e;++i){n2utils.extractSpecificType(obj[i],type,result,ancestors);};}else if(typeof(obj)==='object'){if(obj.nunaliit_type&&obj.nunaliit_type===type){result.push(obj);}else{for(var key in obj){if('__n2Source'===key)continue;var value=obj[key];n2utils.extractSpecificType(value,type,result,ancestors);};};};ancestors.pop();},extractLinks:function(obj,links){n2utils.extractSpecificType(obj,'reference',links);},extractGeometries:function(obj,geometries){n2utils.extractSpecificType(obj,'geometry',geometries);},getAtlasRole:function(n2Atlas,role){if(!n2Atlas){return role;}else if(typeof(n2Atlas.name)==='string'){return n2Atlas.name+'_'+role;};return role;},validateDocumentStructure:function(doc,errorFn){n2utils.validateTypes(doc,errorFn);if(doc.nunaliit_schema&&typeof doc.nunaliit_schema!=='string'){errorFn('If nunaliit_schema is specified, it must be a string');};var geometries=[];n2utils.extractGeometries(doc,geometries);for(var i=0,e=geometries.length;i<e;++i){var geometry=geometries[i];if(!n2utils.isValidGeom(geometry)){errorFn('Invalid geometry');}};if(doc.nunaliit_created){if(typeof doc.nunaliit_created!=='object'){errorFn('Field "nunaliit_created" must be an object');};if(doc.nunaliit_created.nunaliit_type!=='actionstamp'){errorFn('"nunaliit_created" must be of type "actionstamp"');};if(typeof doc.nunaliit_created.time!=='number'){errorFn('"nunaliit_created.time" must be a number');};if(doc.nunaliit_created.action!=='created'){errorFn('"nunaliit_created.action" must be a "created"');};};if(doc.nunaliit_last_updated){if(typeof doc.nunaliit_last_updated!=='object'){errorFn('Field "nunaliit_last_updated" must be an object');};if(doc.nunaliit_last_updated.nunaliit_type!=='actionstamp'){errorFn('"nunaliit_last_updated" must be of type "actionstamp"');};if(typeof doc.nunaliit_last_updated.time!=='number'){errorFn('"nunaliit_last_updated.time" must be a number');};if(doc.nunaliit_last_updated.action!=='updated'){errorFn('"nunaliit_last_updated.action" must be a "updated"');};};var actionStamps=[];n2utils.extractSpecificType(doc,'actionstamp',actionStamps);for(var i=0,e=actionStamps.length;i<e;++i){var as=actionStamps[i];if(typeof as.name!=='string'){errorFn('Action stamps must have a string field named: "name"');};if(typeof as.time!=='number'){errorFn('Action stamps must have a number field named: "time"');};};if(doc.nunaliit_layers){if(!n2utils.isArray(doc.nunaliit_layers)){errorFn('nunaliit_layers must be an array');};for(var i=0,e=doc.nunaliit_layers.length;i<e;++i){if(typeof(doc.nunaliit_layers[i])!=='string'){errorFn('nunaliit_layers must be an array of strings');};};};if('translationRequest'===doc.nunaliit_type){if(typeof doc.str!=='string'){errorFn('Translation requests must have a string "str"');}
if(typeof doc.lang!=='string'){errorFn('Translation requests must have a string "lang"');}
if(doc.trans){if(typeof doc.trans!=='string'){errorFn('Translation requests providing "trans" field must be string');}}};if(doc.nunaliit_css){if(typeof doc.nunaliit_css!=='object'){errorFn('CSS fragments must have an object structure');};if(doc.nunaliit_css.nunaliit_type!=='css'){errorFn('CSS fragments must have a type of "css"');};if(typeof(doc.nunaliit_css.name)!=='string'){errorFn('CSS fragments must have a string "name" property.');};if(typeof(doc.nunaliit_css.css)!=='undefined'&&typeof(doc.nunaliit_css.css)!=='string'){errorFn('CSS fragments must have a string "css" property.');};};if(doc.nunaliit_submission){if(typeof doc.nunaliit_submission!=='object'){errorFn('Submission documents must have an object structure');};if(typeof doc.nunaliit_submission.state!=='string'){errorFn('Submission documents must include a state');};if(typeof doc.nunaliit_submission.submitter_name!=='string'){errorFn('Submission documents must include the name of the submitter');};if(false==n2utils.isArrayOfStrings(doc.nunaliit_submission.submitter_roles)){errorFn('Submission documents must include the roles of the submitter');};if(doc.nunaliit_submission.original_reserved){if(typeof doc.nunaliit_submission.original_reserved!=='object'){errorFn('Submission documents must have an object for field "original_reserved"');};if(typeof doc.nunaliit_submission.original_reserved.id!=='string'){errorFn('Submission documents must include the original identifier');};};if(typeof doc.nunaliit_submission.original_doc!=='object'&&typeof doc.nunaliit_submission.original_doc!=='undefined'){errorFn('In a submission document, if specified, "original_doc" must be an object');};if(typeof doc.nunaliit_submission.submitted_reserved!=='object'&&typeof doc.nunaliit_submission.submitted_reserved!=='undefined'){errorFn('In a submission document, if specified, "submitted_reserved" must be an object');};if(typeof doc.nunaliit_submission.submitted_doc!=='object'&&typeof doc.nunaliit_submission.submitted_doc!=='undefined'){errorFn('In a submission document, if specified, "submitted_doc" must be an object');};if(typeof doc.nunaliit_submission.deletion!=='boolean'&&typeof doc.nunaliit_submission.deletion!=='undefined'){errorFn('In a submission document, if specified, "deletion" must be a boolean');};if(!doc.nunaliit_submission.deletion){if(!doc.nunaliit_submission.submitted_reserved){errorFn('In a submission document, if not a deletion, then "submitted_reserved" must be specified');};};if(!doc.nunaliit_submission.submitted_reserved&&!doc.nunaliit_submission.original_reserved){errorFn('In a submission document, one of "submitted_reserved" or "original_reserved" must be specified');};};if(doc.nunaliit_attachments){if(typeof doc.nunaliit_attachments!=='object'){errorFn('"nunaliit_attachments" must be an object structure');};if(doc.nunaliit_attachments.nunaliit_type!=='attachment_descriptions'){errorFn('"nunaliit_attachments" must be of type "attachment_descriptions"');};if(typeof doc.nunaliit_attachments.files!=='object'){errorFn('"nunaliit_attachments" must have an object structure named "files"');};for(var attName in doc.nunaliit_attachments.files){var att=doc.nunaliit_attachments.files[attName];if(typeof att!=='object'){errorFn('Attachment descriptors must be of type "object"');};if(att.attachmentName!==attName){errorFn('Attachment descriptors must have a duplicate name in "attachmentName"');};if(typeof att.status!=='string'){errorFn('Attachment descriptors must have a "status" string');};};};},validateTypes:function(obj,errorFn){if(null===obj){}else if(n2utils.isArray(obj)){for(var i=0,e=obj.length;i<e;++i){if(n2utils.validateTypes(obj[i],errorFn)){return true;};};}else if(typeof(obj)==='object'){if(obj.nunaliit_type){if(typeof obj.nunaliit_type!=='string'){errorFn('Fields named "nunaliit_type" must be strings');return true;};};for(var key in obj){var value=obj[key];if(n2utils.validateTypes(value,errorFn)){return true;};};};return false;}};if(typeof(exports)==='object'){exports.isArray=n2utils.isArray;exports.isArrayOfStrings=n2utils.isArrayOfStrings;exports.isValidBounds=n2utils.isValidBounds;exports.isValidGeom=n2utils.isValidGeom;exports.extractLayers=n2utils.extractLayers;exports.extractLinks=n2utils.extractLinks;exports.extractSearchTerms=n2utils.extractSearchTerms;exports.addWordToMap=n2utils.addWordToMap;exports.extractStrings=n2utils.extractStrings;exports.foldWord=n2utils.foldWord;exports.removeApostrophe=n2utils.removeApostrophe;exports.isApostropheCodeChar=n2utils.isApostropheCodeChar;exports.extractTypes=n2utils.extractTypes;exports.extractSpecificType=n2utils.extractSpecificType;exports.extractGeometries=n2utils.extractGeometries;exports.getAtlasRole=n2utils.getAtlasRole;exports.validateDocumentStructure=n2utils.validateDocumentStructure;exports.validateTypes=n2utils.validateTypes;};if(typeof(nunaliit2)==='function'){nunaliit2.couchUtils={};nunaliit2.couchUtils.isArray=n2utils.isArray;nunaliit2.couchUtils.isArrayOfStrings=n2utils.isArrayOfStrings;nunaliit2.couchUtils.isValidBounds=n2utils.isValidBounds;nunaliit2.couchUtils.isValidGeom=n2utils.isValidGeom;nunaliit2.couchUtils.extractLayers=n2utils.extractLayers;nunaliit2.couchUtils.extractLinks=n2utils.extractLinks;nunaliit2.couchUtils.extractSearchTerms=n2utils.extractSearchTerms;nunaliit2.couchUtils.addWordToMap=n2utils.addWordToMap;nunaliit2.couchUtils.extractStrings=n2utils.extractStrings;nunaliit2.couchUtils.foldWord=n2utils.foldWord;nunaliit2.couchUtils.removeApostrophe=n2utils.removeApostrophe;nunaliit2.couchUtils.isApostropheCodeChar=n2utils.isApostropheCodeChar;nunaliit2.couchUtils.extractTypes=n2utils.extractTypes;nunaliit2.couchUtils.extractSpecificType=n2utils.extractSpecificType;nunaliit2.couchUtils.extractGeometries=n2utils.extractGeometries;nunaliit2.couchUtils.getAtlasRole=n2utils.getAtlasRole;nunaliit2.couchUtils.validateDocumentStructure=n2utils.validateDocumentStructure;nunaliit2.couchUtils.validateTypes=n2utils.validateTypes;};var n2tiles={format4326_65K:null,format4326_200:null,format4326_25M:null,makeFormat:function(minx,miny,maxx,maxy,resx,resy){var tilesX=(maxx-minx)*resx;var tilesY=(maxy-miny)*resy;var tiles=tilesX*tilesY;var incx=(maxx-minx)/tilesX;var incy=(maxy-miny)/tilesY;return{minx:minx,miny:miny,maxx:maxx,maxy:maxy,resx:resx,resy:resy,tiles:tiles,nx:tilesX,ny:tilesY,incx:incx,incy:incy};},getBoundsFromTile:function(format,tileNumber){var coordX=tileNumber%format.nx;var coordY=(tileNumber-coordX)/format.nx;var minx=((coordX*format.incx)+format.minx);var miny=((coordY*format.incy)+format.miny);return{minx:minx,miny:miny,maxx:(minx+format.incx),maxy:(miny+format.incy)};},getTileFromPosition:function(format,x,y){return(y*format.nx)+x;},getTilePositionFromCoords:function(format,x,y){var coordX=Math.floor((x-format.minx)/format.incx);var coordY=Math.floor((y-format.miny)/format.incy);if(coordX<0)coordX=0;if(coordX>=format.nx)coordX=format.nx-1;if(coordY<0)coordY=0;if(coordY>=format.ny)coordY=format.ny-1;return{x:coordX,y:coordY,tile:n2tiles.getTileFromPosition(format,coordX,coordY)};},getTileFromCoords:function(format,x,y){var coordX=Math.floor((x-format.minx)/format.incx);var coordY=Math.floor((y-format.miny)/format.incy);if(coordX<0)coordX=0;if(coordX>=format.nx)coordX=format.nx-1;if(coordY<0)coordY=0;if(coordY>=format.ny)coordY=format.ny-1;return n2tiles.getTileFromPosition(format,coordX,coordY);},getTilesFromBounds:function(format,minx,miny,maxx,maxy,maxTiles){var blTilePosition=n2tiles.getTilePositionFromCoords(format,minx,miny);var trTilePosition=n2tiles.getTilePositionFromCoords(format,maxx,maxy);var leftX=blTilePosition.x;var rightX=trTilePosition.x;var trTile=trTilePosition.tile;if(minx>maxx&&leftX===rightX){--rightX;if(rightX<0){rightX=format.nx-1;};};var result=[];var done=0;var x=blTilePosition.x;var y=blTilePosition.y;var tile=n2tiles.getTileFromPosition(format,x,y);while(!done){result.push(tile);if(tile==trTile){done=1;}else if(x==rightX){x=leftX;y=y+1;while(y>=format.ny){y=y-format.ny;};}else{x=x+1;while(x>=format.nx){x=x-format.nx;};}
tile=n2tiles.getTileFromPosition(format,x,y);if(result.length>format.tiles)return[];if(maxTiles&&result.length>maxTiles)return[];};return result;},getApproxTilesForBounds:function(format,minx,miny,maxx,maxy){var cX=(maxx>minx)?((maxx-minx)/format.incx):(((format.maxx-maxx)+(minx-format.minx))/format.incx);var cY=(maxy>miny)?((maxy-miny)/format.incy):(((format.maxy-maxy)+(miny-format.miny))/format.incy);return(Math.floor(cX)+1)*(Math.floor(cY)+1);}};n2tiles.format4326_200={minx:-180,miny:-90,maxx:180,maxy:90,resx:0.05,resy:0.05,tiles:162,nx:18,ny:9,incx:20,incy:20};n2tiles.format4326_65K={minx:-180,miny:-90,maxx:180,maxy:90,resx:1,resy:1,tiles:64800,nx:360,ny:180,incx:1,incy:1};n2tiles.format4326_25M={minx:-180,miny:-90,maxx:180,maxy:90,resx:20,resy:20,tiles:25920000,nx:7200,ny:3600,incx:0.05,incy:0.05};if(typeof(exports)==='object'){exports.makeFormat=n2tiles.makeFormat;exports.getBoundsFromTile=n2tiles.getBoundsFromTile;exports.getTileFromCoords=n2tiles.getTileFromCoords;exports.getTilesFromBounds=n2tiles.getTilesFromBounds;exports.getApproxTilesForBounds=n2tiles.getApproxTilesForBounds;exports.format4326_65K=n2tiles.format4326_65K;exports.format4326_200=n2tiles.format4326_200;exports.format4326_25M=n2tiles.format4326_25M;};if(typeof(nunaliit2)==='function'){nunaliit2.tiles={};nunaliit2.tiles.makeFormat=n2tiles.makeFormat;nunaliit2.tiles.getBoundsFromTile=n2tiles.getBoundsFromTile;nunaliit2.tiles.getTilePositionFromCoords=n2tiles.getTilePositionFromCoords;nunaliit2.tiles.getTileFromCoords=n2tiles.getTileFromCoords;nunaliit2.tiles.getTilesFromBounds=n2tiles.getTilesFromBounds;nunaliit2.tiles.getApproxTilesForBounds=n2tiles.getApproxTilesForBounds;nunaliit2.tiles.format4326_65K=n2tiles.format4326_65K;nunaliit2.tiles.format4326_200=n2tiles.format4326_200;nunaliit2.tiles.format4326_25M=n2tiles.format4326_25M;};;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var CouchSchemaRepository=$n2.Class($n2.schema.SchemaRepository,{couchOptions:null,initialize:function(opts_){$n2.schema.SchemaRepository.prototype.initialize.apply(this);this.couchOptions=$n2.extend({db:null,designDoc:null,viewNameSchemas:'schemas',viewNameRootSchemas:'schemas-root',dispatchService:null,preload:false,preloadedCallback:function(){},onError:function(err){}},opts_);var _this=this;this.loadSchemasFn=function(o){_this._loadSchemas(o);};var dispatcher=this._getDispatcher();if(dispatcher){var dispatcherHandle=dispatcher.getHandle('n2.couchSchema');var f=function(m){_this._handle(m);};dispatcher.register(dispatcherHandle,'documentContentCreated',f);dispatcher.register(dispatcherHandle,'documentContentUpdated',f);};if(this.couchOptions.preload){this._preload();};},_loadSchemas:function(opt_){var opt=$n2.extend({names:null,rootSchemas:false,onSuccess:function(schemaDefinitions){},onError:function(err){$n2.reportError(err);}},opt_);var viewRequest={viewName:this.couchOptions.viewNameSchemas,include_docs:true,onSuccess:function(rows){var defs=[];for(var i=0,e=rows.length;i<e;++i){defs.push(rows[i].doc);};opt.onSuccess(defs);},onError:opt.onError};if(opt.names){viewRequest.keys=opt.names;};if(opt.rootSchemas){viewRequest.viewName=this.couchOptions.viewNameRootSchemas;};this.couchOptions.designDoc.queryView(viewRequest);},_handle:function(m){if('documentContentCreated'===m.type||'documentContentUpdated'===m.type){var doc=m.doc;if(doc.nunaliit_type==='schema'){this.addSchemas({schemas:[doc],onError:function(err){$n2.log('Error adding created/updated schema ('+doc._id+') to repository: '+err);}});};};},_getDispatcher:function(){return this.couchOptions.dispatchService;},_preload:function(){var _this=this;this.couchOptions.designDoc.queryView({viewName:this.couchOptions.viewNameSchemas,include_docs:true,onSuccess:function(rows){var defs=[];for(var i=0,e=rows.length;i<e;++i){defs.push(rows[i].doc);};_this.addSchemas({schemas:defs});_this.rootSchemasQueried=true;_this.couchOptions.preloadedCallback();},onError:function(err){_this.couchOptions.onError(_loc('Unable to preload schemas: {err}',{err:err}));}});}});$n2.couchSchema={CouchSchemaRepository:CouchSchemaRepository};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch-import',args);};var StatusLogger=$n2.Class({divId:null,initialize:function(opts_){var opts=$n2.extend({div:null},opts_);if(opts.div){var $div=$(opts.div);var id=$div.attr('id');if(!id){id=$n2.getUniqueId();$div.attr('id',id);};this.divId=id;};},log:function(text){var $log=this._getLog();var id=$n2.getUniqueId();$('<div class="data_import_status"></div>').attr('id',id).text(text).appendTo($log);return id;},error:function(text){var $log=this._getLog();var id=$n2.getUniqueId();$('<div class="data_import_status data_import_error"></div>').attr('id',id).text('Error: '+text).appendTo($log);return id;},empty:function(){var $log=this._getLog();$log.empty();},_getLog:function(){return $('#'+this.divId);}});$n2.OneToManyDataImporter=$n2.Class('$n2.OneToManyDataImporter',{options:{db:null,designDoc:null,atlasDesign:null,dataArray:[],statusDiv:null,logger:null,eraseStatusDiv:true,containsGeometry:[false],descriptiveLabels:[''],viewNames:[''],keyValueFns:[function(entry){return null;}],jsonPropertiesVerifyFn:function(entry){return true;},convertJsonForUpload:function(entry){return[entry];},incrementalUpdateFns:[function(docId,uploadArray){return;}]},statusId:1,initialize:function(opts_){this.options=$n2.extend({},this.options,opts_);if(this.options.logger){this.logger=this.options.logger;}else if(this.options.statusDiv){this.logger=new StatusLogger({div:this.options.statusDiv});};if(this.options.eraseStatusDiv&&this.logger){this.logger.empty();};},loadEntry:function(aIndex){if(aIndex>=this.options.dataArray.length){this.postStatusMsgImmediate(_loc('Done'));return;};var entry=this.options.dataArray[aIndex];var designDoc=this.options.designDoc;var _t_viewNames=this.options.viewNames.slice(0);var _t_keyValueFns=this.options.keyValueFns.slice(0);var _t_descriptiveLabels=this.options.descriptiveLabels.slice(0);var entryStatusId=this.allocateStatusMsgSpace();confirmDocumentsDoNotExist(this,entry,function(caller){caller.createEntry(aIndex,entry);});function confirmDocumentsDoNotExist(caller,entry,doNotExistFn){if(_t_viewNames.length<=0||_t_keyValueFns.length<=0||_t_descriptiveLabels.length<=0){doNotExistFn(caller);return;};var currKeyValFn=_t_keyValueFns.shift();var currViewName=_t_viewNames.shift();var currDescriptiveLabel=_t_descriptiveLabels.shift();if(!$n2.isDefined(currKeyValFn)||!$n2.isDefined(currViewName)){confirmDocumentsDoNotExist(caller,entry,doNotExistFn);return;};var keyVal=currKeyValFn(entry);if(null===keyVal){caller.loadEntry(aIndex+1);return;};designDoc.queryView({viewName:currViewName,startkey:keyVal,endkey:keyVal,onSuccess:function(rows){if(rows.length>0){var locStr=_loc('{label} definition ({key}) already exists - not loaded or updated',{label:_loc(currDescriptiveLabel),key:keyVal});caller.updateStatusMsgAsynch(locStr,entryStatusId);caller.loadEntry(aIndex+1);}else{confirmDocumentsDoNotExist(caller,entry,doNotExistFn);};},onError:function(errorMsg){var locStr=_loc('Error: query error while verifying {label} definition ({key})',{label:_loc(currDescriptiveLabel),key:keyVal});caller.updateStatusMsgAsynch(locStr,entryStatusId);caller.loadEntry(aIndex+1);}});};},createEntry:function(aIndex,entry){var uploadDataArray=[];var db=this.options.db;var atlasDesign=this.options.atlasDesign;if(this.options.jsonPropertiesVerifyFn(entry)){uploadDataArray=this.options.convertJsonForUpload(entry);if(!$n2.isArray(uploadDataArray)){uploadDataArray=[uploadDataArray];};var _t_descriptiveLabels=this.options.descriptiveLabels.slice(0);var _t_incrementalUpdateFns=this.options.incrementalUpdateFns.slice(0);var _t_containsGeometry=this.options.containsGeometry.slice(0);createEntryUpdateSubsequentEntries(this);}else{this.postStatusMsgImmediate(_loc('Required fields missing for ')+
this.options.descriptiveLabels[0]+_loc(' definition: ')+aIndex);next(this);};function next(caller){if(uploadDataArray.length>0){createEntryUpdateSubsequentEntries(caller);}else{caller.loadEntry(aIndex+1);};};function createEntryUpdateSubsequentEntries(caller){if(uploadDataArray.length<=0){return;};var entryStatusId=caller.allocateStatusMsgSpace();var nextUpload=uploadDataArray.shift();var currDescriptiveLabel=_t_descriptiveLabels.shift();var currContainsGeometry=_t_containsGeometry.shift();var currIncrementalUpdateFn=null;if(uploadDataArray.length>=1){currIncrementalUpdateFn=_t_incrementalUpdateFns.shift();};if(!$n2.isDefined(nextUpload)){caller.postStatusMsgImmediate(currDescriptiveLabel+_loc(' definition null and skipped.'));next(caller);return;};$n2.couchDocument.adjustDocument(nextUpload);db.createDocument({data:nextUpload,onSuccess:function(docInfo){caller.updateStatusMsgAsynch(currDescriptiveLabel+_loc(' definition (')+docInfo.id+')',entryStatusId);if($n2.isDefined(currIncrementalUpdateFn)){var uploadedDoc=$n2.extend({},nextUpload,{_id:docInfo.id,_rev:docInfo.rev});currIncrementalUpdateFn(docInfo.id,uploadDataArray,uploadedDoc);};queryViews(atlasDesign,caller,currContainsGeometry,next);},onError:function(err){$n2.log('Error creating document: '+err,nextUpload);caller.updateStatusMsgAsynch(_loc('Error creating ')+currDescriptiveLabel+
_loc(' definition (index: ')+aIndex+_loc('). STOPPING: ')+err,entryStatusId);}});};},setDataArray:function(data){this.options.dataArray=data;},postStatusMsgImmediate:function(msg){if(this.logger){return this.logger.log(msg);};return null;},allocateStatusMsgSpace:function(){if(this.logger){return this.logger.log('');};return null;},updateStatusMsgAsynch:function(msg,id){if(id)$('#'+id).text(msg);}});$n2.DataImporter=$n2.Class('$n2.DataImporter',{options:{db:null,designDoc:null,atlasDesign:null,dataArray:[],containsGeometry:false,statusDiv:null,logger:null,descriptiveLabel:'',viewName:'',keyValueFn:function(entry){return null;},jsonPropertiesVerifyFn:function(entry){return true;},convertJsonForUpload:function(entry){return entry;}},importer:null,initialize:function(opts_){this.options=$n2.extend({},this.options,opts_);this.importer=new $n2.OneToManyDataImporter({db:this.options.db,designDoc:this.options.designDoc,atlasDesign:this.options.atlasDesign,dataArray:this.options.dataArray,containsGeometry:[this.options.containsGeometry],statusDiv:this.options.statusDiv,logger:this.options.logger,descriptiveLabels:[this.options.descriptiveLabel],viewNames:[this.options.viewName],keyValueFns:[this.options.keyValueFn],jsonPropertiesVerifyFn:this.options.jsonPropertiesVerifyFn,convertJsonForUpload:this.options.convertJsonForUpload,incrementalUpdateFns:[]});},loadEntry:function(aIndex){this.importer.loadEntry(aIndex);},setDataArray:function(data){this.options.dataArray=data;this.importer.setDataArray(data);}});$n2.JSONInputPlugInForDataImport=$n2.Class('$n2.JSONInputPlugInForDataImport',{options:{jsonFile:'',importer:null,entriesFromData:function(data){return data;}},initialize:function(opts_){this.options=$n2.extend({},this.options,opts_);},loadJson:function(){var this_=this;$.getJSON(this.options.jsonFile,function(data,textStatus){var entries=null;if(data){entries=this_.options.entriesFromData(data);};if(entries&&$n2.isArray(entries)){this_.options.importer.setDataArray(entries);this_.options.importer.loadEntry(0);};});}});$n2.GeoJSONInputPlugInForDataImport=$n2.Class('$n2.GeoJSONInputPlugInForDataImport',{options:{jsonFile:'',importer:null,crs:'EPSG:4326'},geojsonParser:null,initialize:function(opts_){this.options=$n2.extend({},this.options,opts_);this.geojsonParser=new OpenLayers.Format.GeoJSON();},loadGeoJson:function(){var this_=this;$.getJSON(this.options.jsonFile,function(data,textStatus){if($n2.isDefined(data)&&$n2.isDefined(data.crs)&&$n2.isDefined(data.crs.type)&&'name'===data.crs.type&&$n2.isDefined(data.crs.properties)&&$n2.isDefined(data.crs.properties.name)){this_.options.crs=data.crs.properties.name;};if($n2.isDefined(data)&&$n2.isDefined(data.type)&&'featurecollection'===data.type.toLowerCase()&&$n2.isDefined(data.features)&&$n2.isArray(data.features)){var dataArray=[];for(var i=0,len=data.features.length;i<len;i++){var olVector=this_.geojsonParser.read(data.features[i],"Feature",null);dataArray.push(olVector);};this_.options.importer.setDataArray(dataArray);this_.options.importer.loadEntry(0);};});},convertGeomToWkt:function(olVector){var wkt=olVector.geometry.toString();var bounds=olVector.geometry.getBounds();var xmin=bounds.left;var xmax=bounds.right;var ymin=bounds.bottom;var ymax=bounds.top;return{nunaliit_geom:{nunaliit_type:"geometry",wkt:wkt,bbox:[xmin,ymin,xmax,ymax]}};}});function queryViews(atlasDesign,caller,containsGeometry,doNextEntryFn){var viewsToQuery;function doViewCheck(firstCall){if(firstCall){tilingViews=['geom-layer-tile200','geom-layer-tile25m','geom-layer-tile65k','geom-tile200','geom-tile25m','geom-tile65k'];};if(!containsGeometry||tilingViews.length<1){doNextEntryFn(caller);}else{var viewName=tilingViews.pop();atlasDesign.queryView({viewName:viewName,limit:1,onSuccess:function(){doViewCheck(false);},onError:function(err){$('#status').append($('<div>'+
_loc('STOPPING: Failed verifying view ')+
viewName+' ('+err+')'));}});};};doViewCheck(true);};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var ConfigService=$n2.Class('ConfigurationService',{serverUrl:null,initialize:function(opts_){var opts=$n2.extend({url:null},opts_);this.serverUrl=opts.url;},getNunaliitServerRoles:function(opts_){var opts=$n2.extend({onSuccess:function(roles){},onError:function(err){}},opts_);$.ajax({url:this.serverUrl+'getServerRoles',type:'GET',dataType:'json',success:function(data,textStatus,jqXHR){if(data&&data.roles){opts.onSuccess(data.roles);}else{opts.onError(_loc('Invalid server response'));};},error:function(jqXHR,textStatus,errorThrown){var err=$n2.utils.parseHttpJsonError(jqXHR,textStatus);opts.onError(err);}});}});function Configure(options_){var options=$n2.extend({couchServerUrl:null,atlasDbUrl:null,atlasDesignName:'atlas',siteDesignName:'site',progressServerUrl:null,mediaUrl:null,uploadServerUrl:null,exportServerUrl:null,configServerUrl:null,userServerUrl:null,submissionDbUrl:null,submissionServerUrl:null,dateServerUrl:null,onSuccess:function(config){}},options_);var configuration={directory:{}};configuration.start=function(){if(configuration.directory.dispatchService){configuration.directory.dispatchService.send('n2.couchConfiguration',{type:'start'});};};configuration.directory.dispatchService=new $n2.dispatch.Dispatcher();configuration.directory.historyMonitor=new $n2.history.Monitor({directory:configuration.directory});configuration.directory.historyTracker=new $n2.history.Tracker({directory:configuration.directory});configuration.directory.eventService=new $n2.couchEvents.EventSupport({directory:configuration.directory});configuration.directory.customService=new $n2.custom.CustomService({directory:configuration.directory});configuration.directory.configService=new ConfigService({url:options.configServerUrl});$.cometd={init:function(){},subscribe:function(){},publish:function(){}};$n2.couch.initialize({pathToServer:options.couchServerUrl,onSuccess:couchInitialized});function couchInitialized(){configuration.couchServer=$n2.couch.DefaultServer;configuration.directory.couchServer=configuration.couchServer;configuration.atlasDb=configuration.couchServer.getDb({dbUrl:options.atlasDbUrl});configuration.atlasDesign=configuration.atlasDb.getDesignDoc({ddName:options.atlasDesignName});configuration.siteDesign=configuration.atlasDb.getDesignDoc({ddName:options.siteDesignName});if(options.submissionDbUrl){configuration.submissionDb=configuration.couchServer.getDb({dbUrl:options.submissionDbUrl});};configuration.dataSources=[];var couchDbDs=null;if(configuration.submissionDb){couchDbDs=new $n2.couchDocument.CouchDocumentSourceWithSubmissionDb({id:'main',db:configuration.atlasDb,submissionDb:configuration.submissionDb,submissionServerUrl:options.submissionServerUrl,dispatchService:configuration.directory.dispatchService});}else{couchDbDs=new $n2.couchDocument.CouchDocumentSource({id:'main',db:configuration.atlasDb,dispatchService:configuration.directory.dispatchService});};configuration.dataSources.push(couchDbDs);configuration.documentSource=couchDbDs;if($n2.couchHelp&&$n2.couchHelp.CheckBrowserCompliance){$n2.couchHelp.CheckBrowserCompliance({db:configuration.atlasDb});};configuration.directory.schemaRepository=new $n2.couchSchema.CouchSchemaRepository({db:configuration.atlasDb,designDoc:configuration.atlasDesign,dispatchService:configuration.directory.dispatchService,preload:true,preloadedCallback:schemasPreloaded});};function schemasPreloaded(){configuration.directory.authService=new $n2.couchAuth.AuthService({onSuccess:authInitialized,atlasDb:configuration.atlasDb,schemaRepository:configuration.directory.schemaRepository,directory:configuration.directory,userServerUrl:options.userServerUrl});};function authInitialized(){configuration.atlasDb.getChangeNotifier({onSuccess:function(notifier){configuration.directory.notifierService=notifier;notifierInitialized();}});};function notifierInitialized(){$n2.couchL10n.Configure({db:configuration.atlasDb,designDoc:configuration.atlasDesign});configuration.directory.progressService=new $n2.progress.ProgressServer({url:options.progressServerUrl});configuration.directory.uploadService=new $n2.upload.Upload({url:options.uploadServerUrl,progressServer:configuration.directory.progressService});configuration.directory.exportService=new $n2.couchExport.Export({url:options.exportServerUrl});configuration.directory.dateService=new $n2.dateService.DateService({url:options.dateServerUrl});configuration.directory.searchService=new $n2.couchSearch.SearchServer({designDoc:configuration.atlasDesign,db:configuration.atlasDb,dateService:configuration.directory.dateService,directory:configuration.directory});configuration.mediaRelativePath=options.mediaUrl;configuration.directory.requestService=new $n2.couchRequests({documentSource:configuration.documentSource,userDb:$n2.couch.getUserDb(),dispatchService:configuration.directory.dispatchService,userServerUrl:options.userServerUrl});configuration.directory.dispatchSupport=new $n2.couchDispatchSupport.DispatchSupport({db:configuration.atlasDb,directory:configuration.directory});configuration.directory.languageService=new $n2.languageSupport.LanguageService({directory:configuration.directory});configuration.directory.attachmentService=new $n2.couchAttachment.AttachmentService({mediaRelativePath:options.mediaUrl});configuration.directory.displayImageSourceFactory=new $n2.couchDisplayBox.DisplayImageSourceFactory({documentSource:configuration.documentSource,attachmentService:configuration.directory.attachmentService});configuration.directory.showService=new $n2.couchShow.Show({db:configuration.atlasDb,documentSource:configuration.documentSource,requestService:configuration.directory.requestService,notifierService:configuration.directory.notifierService,dispatchService:configuration.directory.dispatchService,schemaRepository:configuration.directory.schemaRepository,customService:configuration.directory.customService,attachmentService:configuration.directory.attachmentService,displayImageSourceFactory:configuration.directory.displayImageSourceFactory});configuration.directory.dialogService=new $n2.couchDialogs.DialogService({dispatchService:configuration.directory.dispatchService,documentSource:configuration.documentSource,searchService:configuration.directory.searchService,showService:configuration.directory.showService,schemaRepository:configuration.directory.schemaRepository});configuration.directory.createDocProcess=new $n2.couchRelatedDoc.CreateRelatedDocProcess({documentSource:configuration.documentSource,schemaRepository:configuration.directory.schemaRepository,uploadService:configuration.directory.uploadService,showService:configuration.directory.showService,authService:configuration.directory.authService,dialogService:configuration.directory.dialogService,dispatchService:configuration.directory.dispatchService});configuration.directory.schemaEditorService=new $n2.CouchEditor.SchemaEditorService({documentSource:configuration.documentSource,showService:configuration.directory.showService,searchService:configuration.directory.searchService,dispatchService:configuration.directory.dispatchService,dialogService:configuration.directory.dialogService});configuration.couchEditor=new $n2.CouchEditor.Editor({documentSource:configuration.documentSource,schemaRepository:configuration.directory.schemaRepository,uploadService:configuration.directory.uploadService,showService:configuration.directory.showService,authService:configuration.directory.authService,dispatchService:configuration.directory.dispatchService,searchService:configuration.directory.searchService,schemaEditorService:configuration.directory.schemaEditorService,customService:configuration.directory.customService,dialogService:configuration.directory.dialogService,createDocProcess:configuration.directory.createDocProcess});configuration.directory.userService=new $n2.couchUser.UserService({userDb:$n2.couch.getUserDb(),configService:configuration.directory.configService,schemaRepository:configuration.directory.schemaRepository,schemaEditorService:configuration.directory.schemaEditorService,userServerUrl:options.userServerUrl});configuration.contributions=new $n2.couchContributions({db:configuration.atlasDb,designDoc:configuration.atlasDesign,showService:configuration.directory.showService,uploads:configuration.directory.uploadService});$n2.mapAndControls.DefaultPopupHtmlFunction=function(opt_){var feature=opt_.feature;if(feature.cluster&&feature.cluster.length===1){feature=feature.cluster[0];};if(feature.cluster){var $tmp=$('<span class="n2_popup"></span>');$tmp.text(_loc('This cluster contains {count} features',{count:feature.cluster.length}));var $wrapper=$('<div></div>');$wrapper.append($tmp);var html=$wrapper.html();opt_.onSuccess(html);}else{var doc=opt_.feature.data;var $tmp=$('<span class="n2_popup"></span>');configuration.directory.showService.displayBriefDescription($tmp,{},doc);var $wrapper=$('<div></div>');$wrapper.append($tmp);var html=$wrapper.html();opt_.onSuccess(html);};};configuration.directory.serverSideNotifier=new $n2.couchServerSide.Notifier({dbChangeNotifier:configuration.directory.notifierService,directory:configuration.directory});configuration.directory.hoverSoundService=new $n2.couchSound.HoverSoundService({db:configuration.atlasDb,serviceDirectory:configuration.directory});var geoNamesOptions={};if(window.nunaliit_custom&&window.nunaliit_custom.geoNames){if(window.nunaliit_custom.geoNames.username){geoNamesOptions.username=window.nunaliit_custom.geoNames.username;};};configuration.directory.geoNamesService=new $n2.GeoNames.Service(geoNamesOptions);configuration.directory.importProfileService=new $n2.couchImportProfile.ImportProfileService({atlasDb:configuration.atlasDb,atlasDesign:configuration.atlasDesign,schemaRepository:configuration.directory.schemaRepository});callCustomConfiguration();};function callCustomConfiguration(){if(window&&window.nunaliit_custom&&typeof(window.nunaliit_custom.configuration)==='function'){window.nunaliit_custom.configuration(configuration,configurationDone);}else{configurationDone();};};function configurationDone(){if(configuration.directory.showService){configuration.directory.showService.fixElementAndChildren($('body'));};$n2.log('nunaliit configuration',configuration);options.onSuccess(configuration);};};$n2.couchConfiguration={Configure:Configure,ConfigService:ConfigService};})(jQuery,nunaliit2);;(function($n2){$n2.couchGeom=$n2.extend({},{getCouchGeometry:function(geom){var bounds=geom.getBounds();var wkt=geom.toString();return{nunaliit_type:'geometry',wkt:wkt,bbox:[bounds.left,bounds.bottom,bounds.right,bounds.top]};},adjustBboxOnCouchGeom:function(couchGeom){if(OpenLayers&&OpenLayers.Geometry&&OpenLayers.Geometry.fromWKT){var olGeom=OpenLayers.Geometry.fromWKT(couchGeom.wkt);var bounds=olGeom.getBounds();couchGeom.bbox=[bounds.left,bounds.bottom,bounds.right,bounds.top];};},getOpenLayersGeometry:function(options_){var opts=$n2.extend({couchGeom:null,onError:function(errorMsg){$n2.reportError(errorMsg);}},options_);if(OpenLayers&&OpenLayers.Geometry&&OpenLayers.Geometry.fromWKT){var olGeom=OpenLayers.Geometry.fromWKT(opts.couchGeom.wkt);return olGeom;}else{opts.onError('OpenLayers must be installed to update document geometries');};},updateDocumentWithWktGeometry:function(doc,options_){var opts=$n2.extend({wkt:null,onError:function(errorMsg){$n2.reportError(errorMsg);}},options_);if(!opts.wkt){opts.onError('Attribute "wkt" not provided while updating a geometry document');return;}
if(OpenLayers&&OpenLayers.Geometry&&OpenLayers.Geometry.fromWKT){var olGeom=OpenLayers.Geometry.fromWKT(opts.wkt);}else{opts.onError('OpenLayers must be installed to update document geometries');return;};var couchGeom=$n2.couchGeom.getCouchGeometry(olGeom);doc.nunaliit_geom=couchGeom;},selectTileViewFromBounds:function(viewOptions,bb,layer,fids){var views=[{tile:$n2.tiles.format4326_25M,name:'geom-tile25m',list:'noduplicate',layer:false,fid:false},{tile:$n2.tiles.format4326_25M,name:'geom-layer-tile25m',list:'noduplicate',layer:true,fid:false},{tile:$n2.tiles.format4326_65K,name:'geom-tile65k',list:'noduplicate',layer:false,fid:false},{tile:$n2.tiles.format4326_65K,name:'geom-layer-tile65k',list:'noduplicate',layer:true,fid:false},{tile:$n2.tiles.format4326_200,name:'geom-tile200',list:'noduplicate',layer:false,fid:false},{tile:$n2.tiles.format4326_200,name:'geom-layer-tile200',list:'noduplicate',layer:true,fid:false},{tile:null,name:'geom-layer-fid',layer:true,fid:true},{tile:null,name:'geom-layer',layer:true,fid:false},{tile:null,name:'geom',layer:false,fid:true}];if(bb&&fids)bb=null;for(var i=0,e=views.length;i<e;++i){var v=views[i];if(bb&&v.tile&&layer&&v.layer){if($n2.tiles.getApproxTilesForBounds(v.tile,bb[0],bb[1],bb[2],bb[3])<500){viewOptions.viewName=v.name;var tiles=$n2.tiles.getTilesFromBounds(v.tile,bb[0],bb[1],bb[2],bb[3]);viewOptions.keys=[];for(var j=0,k=tiles.length;j<k;++j){viewOptions.keys.push([layer,tiles[j]]);};if(v.list)viewOptions.listName=v.list;return true;};}else if(bb&&v.tile&&!layer&&!v.layer){if($n2.tiles.getApproxTilesForBounds(v.tile,bb[0],bb[1],bb[2],bb[3])<500){viewOptions.viewName=v.name;viewOptions.keys=$n2.tiles.getTilesFromBounds(v.tile,bb[0],bb[1],bb[2],bb[3]);if(v.list)viewOptions.listName=v.list;return true;};}else if(fids&&v.fid&&layer&&v.layer){viewOptions.viewName=v.name;viewOptions.keys=[];for(var j=0,k=fids.length;j<k;++j){viewOptions.keys.push([layer,fids[j]]);};if(v.list)viewOptions.listName=v.list;return true;}else if(fids&&v.fid&&!layer&&!v.layer){viewOptions.viewName=v.name;viewOptions.keys=fids;if(v.list)viewOptions.listName=v.list;return true;}else if(!fids&&!v.fid&&layer&&v.layer){viewOptions.viewName=v.name;viewOptions.keys=[layer];if(v.list)viewOptions.listName=v.list;return true;}else if(!bb&&!fids&&!layer&&!v.fid&&!v.layer&&!v.tile){viewOptions.viewName=v.name;if(v.list)viewOptions.listName=v.list;return true;};};return false;},queryGeometries:function(atlasDesignDoc,viewOptions){var bounds=null;var data={};data.viewName='geom';data.listName='noduplicate';for(var key in viewOptions){if(key==='bounds'){bounds=viewOptions[key];}else{data[key]=viewOptions[key];};};if(bounds){$n2.couchGeom.selectTileViewFromBounds(data,bounds);};atlasDesignDoc.queryView(data);}});})(nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchShow';var couchUserPrefix='org.couchdb.user:';function noop(){};var reUrl=/(^|\s)(https?:\/\/[^\s]*)(\s|$)/;var DomStyler=$n2.Class({db:null,documentSource:null,showService:null,displayFunction:null,editFunction:null,deleteFunction:null,viewLayerFunction:null,initialize:function(opts_){var opts=$n2.extend({db:null,documentSource:null,showService:null,displayFunction:null,editFunction:null,deleteFunction:null,viewLayerFunction:null},opts_);this.db=opts.db;this.documentSource=opts.documentSource;this.showService=opts.showService;this.displayFunction=opts.displayFunction;this.editFunction=opts.editFunction;this.deleteFunction=opts.deleteFunction;this.viewLayerFunction=opts.viewLayerFunction;},fixElementAndChildren:function($elem,opt,contextDoc){var _this=this;var $set=$elem.find('*').addBack();$set.filter('.n2_localize').each(function(){var $jq=$(this);_this._localize($jq,opt);$jq.removeClass('n2_localize').addClass('n2_localized');});$set.filter('.n2s_localize').each(function(){var $jq=$(this);_this._localize($jq,opt);$jq.removeClass('n2s_localize').addClass('n2s_localized');});$set.filter('.n2_briefDisplay').each(function(){var $jq=$(this);_this._briefDisplay($jq,opt);$jq.removeClass('n2_briefDisplay').addClass('n2_briefDisplayed');});$set.filter('.n2s_referenceLink').each(function(){var $jq=$(this);_this._insertReferenceLink($jq,opt);$jq.removeClass('n2s_referenceLink').addClass('n2s_insertedReferenceLink');});$set.filter('.n2s_insertTime').each(function(){var $jq=$(this);_this._insertTime($jq,opt);$jq.removeClass('n2s_insertTime').addClass('n2s_insertedTime');});$set.filter('.n2s_insertUserName').each(function(){var $jq=$(this);_this._insertUserName($jq,opt);$jq.removeClass('n2s_insertUserName').addClass('n2s_insertedUserName');});$set.filter('.n2s_insertLayerName').each(function(){var $jq=$(this);_this._insertLayerName($jq,opt);$jq.removeClass('n2s_insertLayerName').addClass('n2s_insertedLayerName');});$set.filter('.n2s_insertMediaView').each(function(){var $jq=$(this);_this._insertMediaView(contextDoc,$jq,opt);$jq.removeClass('n2s_insertMediaView').addClass('n2s_insertedMediaView');});$set.filter('.n2s_insertFirstThumbnail').each(function(){var $jq=$(this);_this._insertFirstThumbnail(contextDoc,$jq,opt);$jq.removeClass('n2s_insertFirstThumbnail').addClass('n2s_insertedFirstThumbnail');});$set.filter('.n2s_insertHoverSoundIcon').each(function(){var $jq=$(this);_this._insertHoverSoundIcon(contextDoc,$jq,opt);$jq.removeClass('n2s_insertHoverSoundIcon').addClass('n2s_insertedHoverSoundIcon');});$set.filter('.n2s_externalMediaLink').each(function(){var $jq=$(this);_this._adjustExternalMediaLink(contextDoc,$jq,opt);$jq.removeClass('n2s_externalMediaLink').addClass('n2s_adjustedExternalMediaLink');});$set.filter('.n2s_insertExternalMediaLink').each(function(){var $jq=$(this);_this._insertExternalMediaLink(contextDoc,$jq,opt);$jq.removeClass('n2s_insertExternalMediaLink').addClass('n2s_insertedExternalMediaLink');});$set.filter('.n2s_convertTextUrlToLink').each(function(){var $jq=$(this);_this._convertTextUrlToLink(contextDoc,$jq,opt);$jq.removeClass('n2s_convertTextUrlToLink').addClass('n2s_convertedTextUrlToLink');});$set.filter('.n2s_clickFindGeometryOnMap').each(function(){var $jq=$(this);_this._clickFindGeometryOnMap(contextDoc,$jq,opt);$jq.removeClass('n2s_clickFindGeometryOnMap').addClass('n2s_findGeometryOnMap');});$set.filter('.n2s_clickAddLayerFromDefinition').each(function(){var $jq=$(this);_this._clickAddLayerFromDefinition(contextDoc,$jq,opt);$jq.removeClass('n2s_clickAddLayerFromDefinition').addClass('n2s_addLayerFromDefinition');});$set.filter('.n2s_clickEdit').each(function(){var $jq=$(this);_this._clickEdit(contextDoc,$jq,opt);$jq.removeClass('n2s_clickEdit').addClass('n2s_edit');});$set.filter('.n2s_clickDelete').each(function(){var $jq=$(this);_this._clickDelete(contextDoc,$jq,opt);$jq.removeClass('n2s_clickDelete').addClass('n2s_delete');});$set.filter('.n2s_handleHover').each(function(){var $jq=$(this);_this._handleHover(contextDoc,$jq,opt);$jq.removeClass('n2s_handleHover').addClass('n2s_handledHover');});$set.filter('.n2s_installMaxHeight').each(function(){var $jq=$(this);_this._installMaxHeight(contextDoc,$jq,opt);$jq.removeClass('n2s_installMaxHeight').addClass('n2s_installedMaxHeight');});$set.filter('.n2s_clickLogin').each(function(){var $jq=$(this);_this._clickLogin($jq,opt);$jq.removeClass('n2s_clickLogin').addClass('n2s_login');});$set.filter('.n2s_clickMapEdit').each(function(){var $jq=$(this);_this._clickMapEdit($jq,opt);$jq.removeClass('n2s_clickMapEdit').addClass('n2s_mapEdit');});$set.filter('.n2s_preserveSpaces').each(function(){var $jq=$(this);_this._preserveSpaces($jq,opt);$jq.removeClass('n2s_preserveSpaces').addClass('n2s_preservedSpaces');});},_localize:function($jq,opt_){var text=$jq.text();var locText=_loc(text);if(locText){$jq.text(locText);};},_preserveSpaces:function($jq,opt_){$jq.each(function(){performPreserveSpace(this);});function performPreserveSpace(parent){var node=parent.firstChild;while(node){if(node.nodeType===3){$(node.parentNode).css('white-space','pre-wrap');node=node.nextSibling;}else{performPreserveSpace(node);node=node.nextSibling;};};};},_briefDisplay:function($jq,opt_){var docId=$jq.text();this.showService.printBriefDescription($jq,docId);},_insertReferenceLink:function($jq,opt_){var _this=this;var docId=$jq.text();this.showService.printBriefDescription($jq,docId);$jq.click(function(){var dispatchService=_this.showService.dispatchService;if(dispatchService){dispatchService.send(DH,{type:'userSelect',docId:docId});};if(_this.displayFunction){_this.displayFunction(docId,opt_);};return false;});},_insertTime:function($jq,opt_){var time=1*$jq.text();var timeStr=(new Date(time)).toString();$jq.text(timeStr);},_insertUserName:function($jq,opt_){var userName=$jq.text();this.showService.printUserName($jq,userName,{showHandle:true});},_insertLayerName:function($jq,opt_){var layerIdentifier=$jq.text();this.showService.printLayerName($jq,layerIdentifier);},_insertMediaView:function(data,$insertView,opt_){var _this=this;var attachmentName=$insertView.attr('nunaliit-attachment');if(!attachmentName){attachmentName=$insertView.text();};$insertView.empty();var attachment=null;if(data._attachments&&data._attachments[attachmentName]){attachment=data._attachments[attachmentName];};var attDesc=null;if(data&&data.nunaliit_attachments&&data.nunaliit_attachments.files){attDesc=data.nunaliit_attachments.files[attachmentName];};if(attDesc&&attDesc.status==='attached'&&attachment){var attUrl=this.db.getAttachmentUrl(data,attachmentName);var linkDiv=null;if(attDesc.thumbnail&&data._attachments[attDesc.thumbnail]){var thumbUrl=this.db.getAttachmentUrl(data,attDesc.thumbnail);linkDiv=$('<div class="n2Show_thumb_wrapper"><img src="'+thumbUrl+'"/></div>');}else if(attDesc.fileClass==='image'){linkDiv=$('<div class="n2Show_icon_wrapper"><div class="n2Show_icon_image"></div></div>');}else if(attDesc.fileClass==='audio'){linkDiv=$('<div class="n2Show_icon_wrapper"><div class="n2Show_icon_audio"></div></div>');}else if(attDesc.fileClass==='video'){linkDiv=$('<div class="n2Show_icon_wrapper"><div class="n2Show_icon_video"></div></div>');}else{linkDiv=$('<div class="n2Show_icon_wrapper"><div class="n2Show_icon_file"></div></div>');};if(null!=linkDiv){$insertView.append(linkDiv);var cb=createMediaCallback(attDesc.fileClass,attUrl,data,attachmentName);linkDiv.click(cb);};};function createMediaCallback(uploadType,attachmentUrl,doc,attachmentName){return function(evt){var mediaOptions={url:attachmentUrl};var attachment=null;if(doc._attachments&&doc._attachments[attachmentName]){attachment=doc._attachments[attachmentName];};if(attachment){mediaOptions.mimeType=attachment.content_type;};var attDesc=doc.nunaliit_attachments.files[attachmentName];if(attDesc&&attDesc.data&&attDesc.data.title){mediaOptions.title=attDesc.data.title;}else if(doc.nunaliit_contribution&&doc.nunaliit_contribution.title){mediaOptions.title=doc.nunaliit_contribution.title;};if(attDesc){if(attDesc.width){mediaOptions.width=attDesc.width;};if(attDesc.height){mediaOptions.height=attDesc.height;};if('image'===uploadType&&attDesc.photosphere&&attDesc.photosphere.type==='panorama'){uploadType='photosphere';};};if('image'===uploadType||'photosphere'===uploadType){_this.showService.displayImageSourceFactory.getImageSourceForDoc({doc:doc,attName:attachmentName,showService:_this.showService,onSuccess:function(imageSource,doc){new nunaliit2.displayBox.DisplayBox({imageSource:imageSource});},onError:function(err){}});}else{var $temp=$('<div></div>');_this.showService._displayDocumentBrief($temp,doc,{onDisplayed:function(){var html=$temp.html();mediaOptions.metaDataHtml=html;mediaOptions.type=uploadType;$n2.mediaDisplay.displayMedia(mediaOptions);}});};return false;};};},_insertFirstThumbnail:function(doc,$insertElem,opt_){$insertElem.empty();var attachmentService=null;if(this.showService){attachmentService=this.showService.attachmentService;};var attachment=null;if(attachmentService){var attachments=attachmentService.getAttachments(doc);for(var i=0,e=attachments.length;i<e;++i){var att=attachments[i];if(att.isSource){var thumbnailAtt=att.getThumbnailAttachment();if(thumbnailAtt&&thumbnailAtt.isAttached()){attachment=thumbnailAtt;break;};};};};if(attachment){$('<img>').attr('src',attachment.getMediaFileUrl()).appendTo($insertElem);};},_insertHoverSoundIcon:function(data,$insertHoverSoundIcon,opt_){var _this=this;var playSound=false;if($n2.couchSound&&$n2.couchSound.DocumentContainsHoverSound&&$n2.couchSound.DocumentContainsHoverSound(data)){$insertHoverSoundIcon.append($('<div class="n2Show_icon_wrapper"><div class="n2Show_icon_speaker"></div></div>'));$insertHoverSoundIcon.find('.n2Show_icon_speaker').click(function(){toggleHoverSound();return false;});};function toggleHoverSound(){var dispatchService=_this.showService.dispatchService;if(dispatchService){if(!playSound){dispatchService.send(DH,{type:'playHoverSoundOn',doc:data});playSound=true;}else{dispatchService.send(DH,{type:'playHoverSoundOff',doc:data});playSound=false;};};};},_adjustExternalMediaLink:function(data,$externalLink,opt_){var attachmentName=$externalLink.attr('href');var attachment=null;if(data._attachments&&data._attachments[attachmentName]){attachment=data._attachments[attachmentName];};var attDesc=null;if(data&&data.nunaliit_attachments&&data.nunaliit_attachments.files){attDesc=data.nunaliit_attachments.files[attachmentName];};if(attDesc&&attDesc.status==='attached'&&attachment){var attUrl=this.db.getAttachmentUrl(data,attachmentName);$externalLink.attr('href',attUrl);$externalLink.click(function(e){if(confirm(_loc('You are about to leave this page. Do you wish to continue?'))){return true;};return false;});}else{$externalLink.click(function(e){alert(_loc('File is not currently available'));return false;});};},_insertExternalMediaLink:function(data,$div,opt_){var attachmentName=$div.attr('nunaliit-attachment');$div.empty();var attachment=null;if(data._attachments&&data._attachments[attachmentName]){attachment=data._attachments[attachmentName];};var attDesc=null;if(data&&data.nunaliit_attachments&&data.nunaliit_attachments.files){attDesc=data.nunaliit_attachments.files[attachmentName];};if(attDesc&&attDesc.status==='attached'&&attachment){var attUrl=this.db.getAttachmentUrl(data,attachmentName);if(attDesc.originalAttachment&&data._attachments[attDesc.originalAttachment]){attUrl=this.db.getAttachmentUrl(data,attDesc.originalAttachment);};var $a=$('<a></a>').addClass('n2s_adjustedExternalMediaLink').attr('href',attUrl).click(function(e){if(confirm(_loc('You are about to leave this page. Do you wish to continue?'))){return true;};return false;}).appendTo($div);var name=attDesc.originalName;if(!name){name=attachmentName;};$('<span></span>').addClass('n2s_externalMediaLinkName').text(name).appendTo($a);};},_convertTextUrlToLink:function(data,$jq,opt_){$jq.each(function(){performTextUrlToLink(this);});function performTextUrlToLink(parent){var node=parent.firstChild;while(node){if(node.nodeType===3){nextSibling=node.nextSibling;convertTextElement(parent,node);node=nextSibling;}else{performTextUrlToLink(node);node=node.nextSibling;};};};function convertTextElement(parent,textNode){var text=textNode.nodeValue;var m=reUrl.exec(text);var after=null;while(m){after=m[3]+text.substr(m.index+m[0].length);var before=text.substr(0,m.index)+m[1];if(before.length>0){var t2=parent.ownerDocument.createTextNode(before);parent.insertBefore(t2,textNode);};var aNode=parent.ownerDocument.createElement('a');aNode.setAttribute('href',m[2]);aNode.setAttribute('class','n2s_convertedUrl');var t1=parent.ownerDocument.createTextNode(m[2]);aNode.appendChild(t1);parent.insertBefore(aNode,textNode);text=after;m=reUrl.exec(text);};if(after){var t3=parent.ownerDocument.createTextNode(after);parent.insertBefore(t3,textNode);parent.removeChild(textNode);};};},_clickFindGeometryOnMap:function(data,$jq,opt){var dispatcher=this.showService.dispatchService;if(data&&data.nunaliit_geom&&dispatcher&&dispatcher.isEventTypeRegistered('find')){$jq.click(function(){dispatcher.send(DH,{type:'find',docId:data._id,doc:data});return false;});}else{$jq.remove();};},_clickAddLayerFromDefinition:function(contextDoc,$jq,opt){var _this=this;var viewLayerFunction=this.viewLayerFunction;var dispatchService=_this.showService.dispatchService;if(viewLayerFunction||dispatchService){if(contextDoc&&contextDoc.nunaliit_layer_definition){$jq.click(function(){var layerDefinition=contextDoc.nunaliit_layer_definition;if(viewLayerFunction){viewLayerFunction(contextDoc);};if(dispatchService){var layerId=layerDefinition.id;if(!layerId){layerId=contextDoc._id;};var layerDef={name:layerDefinition.name,type:'couchdb',options:{layerName:layerId,documentSource:_this.documentSource}};dispatchService.send(DH,{type:'addLayerToMap',layer:layerDef,options:{setExtent:{bounds:layerDefinition.bbox,crs:'EPSG:4326'}}});};return false;});}else{$jq.remove();};}else{$jq.remove();};},_clickEdit:function(contextDoc,$jq,opt){var _this=this;if(this.editFunction){$jq.click(function(){_this.editFunction(contextDoc,opt);return false;});}else{$jq.empty();};},_clickDelete:function(contextDoc,$jq,opt){var _this=this;if(this.deleteFunction){$jq.click(function(){_this.deleteFunction(contextDoc,opt);return false;});}else{$jq.empty();};},_clickLogin:function($jq,opt){var _this=this;$jq.click(function(){var dispatchService=_this.showService.dispatchService;if(dispatchService){dispatchService.send(DH,{type:'loginShowForm'});};return false;});},_clickMapEdit:function($jq,opt){var _this=this;$jq.click(function(){var dispatchService=_this.showService.dispatchService;if(dispatchService){dispatchService.send(DH,{type:'mapSwitchToEditMode'});};return false;});},_installMaxHeight:function(contextDoc,$jq,opt){var maxHeight=$jq.attr('_maxheight');if(!maxHeight){$jq.attr('n2s_error','Attribute _maxheight not found');$n2.log('n2Show installMaxHeight: Attribute _maxHeight not found');}else if($jq.height()>maxHeight){var showText=_loc('More');var hideText=_loc('Less');var id=$n2.getUniqueId();var $children=$jq.contents();var $content=$('<div class="n2show_maxHeightContent n2show_maxHeight_truncated"></div>').attr('id',id);$jq.append($content);$children.each(function(){$(this).appendTo($content);});$content.css({overflow:'hidden',height:maxHeight+'px'});var $link=$('<a href="#" class="n2show_maxHeightLink"></a>').text(showText).click(function(e){e.preventDefault();var $link=$(this);var $content=$('#'+id);if($content.height()>maxHeight){$link.text(showText);$content.css('height',maxHeight+'px').addClass('n2show_maxHeight_truncated').removeClass('n2show_maxHeight_full');}else{$link.text(hideText);$content.css('height','auto').addClass('n2show_maxHeight_full').removeClass('n2show_maxHeight_truncated');};return false;});$('<div class="n2show_maxHeightLinkContainer"></div>').append($link).appendTo($jq);};},_handleHover:function(contextDoc,$jq,opt){var dispatchService=this.showService.dispatchService;if(dispatchService){$jq.hover(function(){dispatchService.send(DH,{type:'userFocusOn',docId:contextDoc._id,doc:contextDoc});},function(){dispatchService.send(DH,{type:'userFocusOff',docId:contextDoc._id,doc:contextDoc});});};}});var Show=$n2.Class({options:null,db:null,documentSource:null,requestService:null,notifierService:null,dispatchService:null,schemaRepository:null,customService:null,attachmentService:null,displayImageSourceFactory:null,defaultSchema:null,displayFunction:null,editFunction:null,deleteFunction:null,viewLayerFunction:null,preprocessDocument:null,eliminateDeniedMedia:null,eliminateNonApprovedMedia:null,domStyler:null,postProcessDisplayFns:null,initialize:function(opts_){var opts=$n2.extend({db:null,documentSource:null,requestService:null,notifierService:null,dispatchService:null,schemaRepository:null,customService:null,attachmentService:null,displayImageSourceFactory:null,defaultSchema:null,displayFunction:null,editFunction:null,deleteFunction:null,viewLayerFunction:null,preprocessDocument:null,eliminateDeniedMedia:false,eliminateNonApprovedMedia:false},opts_);var _this=this;this.options={};this.db=opts.db;this.documentSource=opts.documentSource;this.requestService=opts.requestService;this.notifierService=opts.notifierService;this.dispatchService=opts.dispatchService;this.schemaRepository=opts.schemaRepository;this.customService=opts.customService;this.attachmentService=opts.attachmentService;this.displayImageSourceFactory=opts.displayImageSourceFactory;this.defaultSchema=opts.defaultSchema;this.displayFunction=opts.displayFunction;this.editFunction=opts.editFunction;this.deleteFunction=opts.deleteFunction;this.viewLayerFunction=opts.viewLayerFunction;this.options.preprocessDocument=opts.preprocessDocument;this.eliminateDeniedMedia=opts.eliminateDeniedMedia;this.eliminateNonApprovedMedia=opts.eliminateNonApprovedMedia;this.postProcessDisplayFns=[];this.domStyler=new DomStyler({db:this.db,documentSource:this.documentSource,showService:this,displayFunction:this.displayFunction,editFunction:this.editFunction,deleteFunction:this.deleteFunction,viewLayerFunction:this.viewLayerFunction});var requestService=this.requestService;if(requestService){requestService.addUserListener(function(userDoc){_this._displayUserDocument(userDoc);});requestService.addDocumentListener(function(doc){_this._displayDocument(doc);});};var notifierService=this.notifierService;if(notifierService){notifierService.addListener(function(change){_this._notifierUpdate(change);});};var dispatchService=this.dispatchService;if(dispatchService){var f=function(msg,address,dispatchService){_this._handleDispatch(msg,address,dispatchService);};dispatchService.register(DH,'start',f);};},addPostProcessDisplayFunction:function(fn){if(typeof(fn)==='function'){this.postProcessDisplayFns.push(fn);};},fixElementAndChildren:function($elem,opt,contextDoc){this.domStyler.fixElementAndChildren($elem,opt,contextDoc);},displayBriefDescription:function($elem,opt,doc){if(doc&&doc._id){$elem.addClass('n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(doc._id));$elem.addClass('n2ShowDocBrief');};this._displayDocumentBrief($elem,doc,opt);},displayDocument:function($elem,opt,doc){if(doc&&doc._id){$elem.addClass('n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(doc._id));};this._displayDocumentFull($elem,doc,opt);},printUserName:function($elem,userName,opts){$elem.addClass('n2ShowUser_'+$n2.utils.stringToHtmlId(userName));if(opts&&opts.showHandle){$elem.addClass('n2ShowUserDisplayAndHandle');}else{$elem.addClass('n2ShowUserDisplay');};$elem.text('('+userName+')');this._requestUser(userName);},printBriefDescription:function($elem,docId,opts){$elem.addClass('n2ShowDoc_'+$n2.utils.stringToHtmlId(docId));$elem.addClass('n2ShowDocBrief');$elem.text(docId);this._requestDocument(docId);},printDocument:function($elem,docId,opts_){var opts=$n2.extend({eliminateNonApprovedMedia:false,eliminateDeniedMedia:false},opts_);$elem.addClass('n2ShowDoc_'+$n2.utils.stringToHtmlId(docId));if(opts.eliminateNonApprovedMedia){$elem.addClass('n2NoShowNonApprovedMedia');};if(opts.eliminateDeniedMedia){$elem.addClass('n2NoShowDenied');};$elem.text(docId);this._requestDocument(docId);},printLayerName:function($elem,layerIdentifier,opts_){$elem.addClass('n2ShowLayerName_'+$n2.utils.stringToHtmlId(layerIdentifier));$elem.text(layerIdentifier);this._requestDocument(layerIdentifier);},_displayUserDocument:function(userDoc){var id=userDoc._id;var displayName=userDoc.display;var userName=null;if(id.substr(0,couchUserPrefix.length)===couchUserPrefix){userName=id.substr(couchUserPrefix.length);};if(userName){$('.n2ShowUser_'+$n2.utils.stringToHtmlId(userName)).each(function(i,elem){var $elem=$(elem);if($elem.hasClass('n2ShowUserDisplay')){if(displayName){$elem.text(displayName);};}else if($elem.hasClass('n2ShowUserDisplayAndHandle')){if(displayName&&userName){$elem.text(displayName+' ('+userName+')');};}else{if(displayName){$elem.text(displayName);};};});};},_displayDocument:function(doc){var _this=this;var id=doc._id;var showClass='n2ShowDoc_'+$n2.utils.stringToHtmlId(id);$('.'+showClass).each(function(i,elem){var $elem=$(elem);$elem.removeClass(showClass).addClass('n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(id));if(_this.eliminateNonApprovedMedia){if($n2.couchMap.documentContainsMedia(doc)&&false==$n2.couchMap.documentContainsApprovedMedia(doc)){$elem.empty();return;};}else if(_this.eliminateDeniedMedia){if($n2.couchMap.documentContainsMedia(doc)&&true==$n2.couchMap.documentContainsDeniedMedia(doc)){$elem.empty();return;};};if($elem.hasClass('n2ShowDocBrief')){_this._displayDocumentBrief($elem,doc);return;};_this._displayDocumentFull($elem,doc);});if(doc.nunaliit_layer_definition&&doc.nunaliit_layer_definition.name){var name=_loc(doc.nunaliit_layer_definition.name);var layerClass='n2ShowLayerName_'+$n2.utils.stringToHtmlId(id);$('.'+layerClass).each(function(i,elem){var $elem=$(elem);$elem.text(name);});};},_updateDocument:function(doc){var _this=this;var id=doc._id;var updateClass='n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(id);$('.'+updateClass).each(function(i,elem){var $elem=$(elem);if($elem.hasClass('n2ShowDocBrief')){_this._displayDocumentBrief($elem,doc);return;};_this._displayDocumentFull($elem,doc);});},_displayDocumentBrief:function($elem,doc,opt_){var opt=$n2.extend({onDisplayed:function($elem,doc,opt_){},schemaName:null},opt_);var _this=this;doc=this._preprocessDocument(doc);if(opt.schemaName){_this.schemaRepository.getSchema({name:opt.schemaName,onSuccess:function(schema_){printBrief($elem,schema_);},onError:function(){displayError($elem);}});}else if(doc.nunaliit_schema){_this.schemaRepository.getSchema({name:doc.nunaliit_schema,onSuccess:function(schema_){printBrief($elem,schema_);},onError:function(){displayError($elem);}});}else if(_this.defaultSchema){printBrief($elem,_this.defaultSchema);}else{displayError($elem);};function printBrief($elem,schema){schema.brief(doc,$elem);_this.fixElementAndChildren($elem,{},doc);_this._postProcessDisplay($elem,doc);opt.onDisplayed($elem,doc,schema,opt_);};function displayError($elem){$elem.text(_loc('Unable to display brief description'));opt.onDisplayed($elem,doc,null,opt_);};},_displayDocumentFull:function($elem,doc,opt_){var opt=$n2.extend({onDisplayed:function($elem,doc,opt_){},schemaName:null},opt_);var _this=this;doc=this._preprocessDocument(doc);if(opt.schemaName){_this.schemaRepository.getSchema({name:opt.schemaName,onSuccess:function(schema){displaySchema($elem,schema);},onError:function(){displayError($elem);}});}else if(doc.nunaliit_schema){_this.schemaRepository.getSchema({name:doc.nunaliit_schema,onSuccess:function(schema){displaySchema($elem,schema);},onError:function(){displayError($elem);}});}else if(_this.defaultSchema){displaySchema($elem,_this.defaultSchema);}else{displayError($elem);};function displaySchema($elem,schema){schema.display(doc,$elem);_this.fixElementAndChildren($elem,{},doc);_this._postProcessDisplay($elem,doc);opt.onDisplayed($elem,doc,schema,opt_);};function displayError($elem){$elem.text(_loc('Unable to display document'));};},_preprocessDocument:function(doc_){var doc=doc_;if(this.options&&this.options.preprocessDocument){doc=this.options.preprocessDocument(doc);};return doc;},_postProcessDisplay:function($sElem,data){for(var i=0,e=this.postProcessDisplayFns.length;i<e;++i){var fn=this.postProcessDisplayFns[i];fn(data,$sElem);};},_requestUser:function(userName){var requestService=this.requestService;if(requestService){requestService.requestUser(userName);};},_requestDocument:function(docId,cbFn){var requestService=this.requestService;if(requestService){requestService.requestDocument(docId,cbFn);};},_notifierUpdate:function(change){var _this=this;var updatedDocIds={};var deletedDocIds={};if(change&&change.results&&change.results.length){for(var i=0,e=change.results.length;i<e;++i){var docId=change.results[i].id;var isDeleted=false;if(change.results[i].deleted){isDeleted=true;};if(isDeleted){deletedDocIds[docId]=true;if(updatedDocIds[docId]){delete updatedDocIds[docId];};}else{updatedDocIds[docId]=true;};};};for(var docId in deletedDocIds){var escaped=$n2.utils.stringToHtmlId(docId);$('.n2ShowDoc_'+escaped).remove();$('.n2ShowUpdateDoc_'+escaped).remove();};var requestDocIds=[];for(var docId in updatedDocIds){var $elems=$('.n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(docId));if($elems.length>0){requestDocIds.push(docId);};};for(var i=0,e=requestDocIds.length;i<e;++i){this._requestDocument(requestDocIds[i],function(doc){_this._updateDocument(doc);});};},_handleDispatch:function(m,address,dispatchService){if('start'===m.type){var customService=this.customService;if(customService){var postProcessFns=customService.getOption('displayPostProcessFunctions');if(postProcessFns){for(var i=0,e=postProcessFns.length;i<e;++i){var fn=postProcessFns[i];this.addPostProcessDisplayFunction(fn);};};};};}});$n2.couchShow={Show:Show};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchEdit';function getDefaultCouchProjection(){var defaultCouchProj=null;if(typeof(OpenLayers)!=='undefined'&&OpenLayers.Projection){defaultCouchProj=new OpenLayers.Projection('EPSG:4326');};return defaultCouchProj;};function isKeyEditingAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;if(selectors[0]==='__n2Source')return false;return true;}
function isValueEditingAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;if(selectors[0]==='__n2Source')return false;return true;};function isKeyDeletionAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;if(selectors[0]==='__n2Source')return false;return true;};function searchForDocumentId(options_){var options=$n2.extend({searchServer:null,showService:null,onSelected:function(docId){},onReset:function(){}},options_);var shouldReset=true;var dialogId=$n2.getUniqueId();var inputId=$n2.getUniqueId();var searchButtonId=$n2.getUniqueId();var displayId=$n2.getUniqueId();var $dialog=$('<div id="'+dialogId+'" class="editorSelectDocumentDialog">'
+'<div><label for="'+inputId+'">'+_loc('Search:')+'</label>'
+'<input id="'+inputId+'" type="text"/>'
+'<button id="'+searchButtonId+'">'+_loc('Search')+'</button></div>'
+'<div  class="editorSelectDocumentDialogResults" id="'+displayId+'"></div>'
+'<div><button class="cancel">'+_loc('Cancel')+'</button></div>'
+'</div>');$dialog.find('button.cancel').button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);$dialog.dialog('close');return false;});var dialogOptions={autoOpen:true,title:_loc('Select Document'),modal:true,width:370,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();if(shouldReset){options.onReset();};}};$dialog.dialog(dialogOptions);options.searchServer.installSearch({textInput:$('#'+inputId),searchButton:$('#'+searchButtonId),displayFn:displaySearch,onlyFinalResults:true});function displaySearch(displayData){if(!displayData){reportError('Invalid search results returned');}else if('wait'===displayData.type){$('#'+displayId).empty();}else if('results'===displayData.type){var $table=$('<table></table>');$('#'+displayId).empty().append($table);for(var i=0,e=displayData.list.length;i<e;++i){var docId=displayData.list[i].id;var $tr=$('<tr></tr>');$table.append($tr);$td=$('<td class="n2_search_result olkitSearchMod2_'+(i%2)+'">'
+'<a href="#'+docId+'" alt="'+docId+'"></a></td>');$tr.append($td);if(options.showService){options.showService.printBriefDescription($td.find('a'),docId);}else{$td.find('a').text(docId);};$td.find('a').click(createClickHandler(docId));};}else{reportError('Invalid search results returned');};};function createClickHandler(docId){return function(e){options.onSelected(docId);shouldReset=false;var $dialog=$('#'+dialogId);$dialog.dialog('close');return false;};};};var CouchSimpleDocumentEditor=$n2.Class({elemId:null,editedDocument:null,schema:null,defaultEditSchema:null,schemaRepository:null,schemaEditorService:null,dispatchService:null,editors:null,geomName:null,couchProj:null,treeEditor:null,slideEditor:null,isInsert:null,editorsContainerId:null,initialize:function(opts_){var opts=$n2.extend({elem:null,elemId:null,doc:null,schema:null,defaultEditSchema:null,schemaRepository:null,schemaEditorService:null,dispatchService:null,editors:null,geomName:'nunaliit_geom',couchProj:null},opts_);this.elemId=opts.elemId;if(opts.elem){var $elem=$(opts.elem);this.elemId=$elem.attr('id');if(!this.elemId){this.elemId=$n2.getUniqueId();$elem.attr('id',this.elemId);};};this.schema=opts.schema;this.defaultEditSchema=opts.defaultEditSchema;this.schemaRepository=opts.schemaRepository;this.schemaEditorService=opts.schemaEditorService;this.dispatchService=opts.dispatchService;this.editors=opts.editors;this.geomName=opts.geomName;this.couchProj=opts.couchProj;if(opts.doc.__n2Source){this.editedDocument={};for(var key in opts.doc){if('__n2Source'===key){this.editedDocumentSource=opts.doc[key];}else{this.editedDocument[key]=opts.doc[key];};};}else{this.editedDocument=opts.doc;};this.isInsert=false;if(!this.couchProj){this.couchProj=getDefaultCouchProjection();};if(this.dispatchService){var f=function(m){_this._handle(m);};this.dispatchService.register(DH,'editGeometryModified',f);this.dispatchService.register(DH,'mapGeometryAdded',f);};if(!this.editors){this.editors=[$n2.CouchEditor.Constants.FORM_EDITOR,$n2.CouchEditor.Constants.TREE_EDITOR,$n2.CouchEditor.Constants.SLIDE_EDITOR,$n2.CouchEditor.Constants.RELATION_EDITOR];};this._edit();},getDocument:function(){return this.editedDocument;},_getDiv:function(){return $('#'+this.elemId);},_edit:function(){var _this=this;this.isInsert=(typeof this.editedDocument._id==='undefined'||this.editedDocument._id===null);this._selectSchema(schemaSelected);function schemaSelected(schema){if(_this.isInsert){if(schema){var template=schema.createObject({});$n2.extend(true,_this.editedDocument,template);};};_this._displayEditor(schema);};},_displayEditor:function(selectedSchema){var _this=this;var data=this.editedDocument;this._synchronousCall({type:'editorStartDocumentEdit',doc:data});$n2.couchDocument.adjustDocument(data);var accordionNeeded=false;var relationEditorNeeded=false;var editorCount=0;for(var i=0,e=this.editors.length;i<e;++i){var editorDesc=this.editors[i];if($n2.CouchEditor.Constants.FORM_EDITOR===editorDesc){if(selectedSchema&&this.schemaEditorService){++editorCount;};}else if($n2.CouchEditor.Constants.TREE_EDITOR===editorDesc){++editorCount;}else if($n2.CouchEditor.Constants.SLIDE_EDITOR===editorDesc){++editorCount;}else if($n2.CouchEditor.Constants.RELATION_EDITOR===editorDesc){relationEditorNeeded=true;};};if(editorCount>1){accordionNeeded=true;};var $div=this._getDiv();$div.empty();this.editorsContainerId=$n2.getUniqueId();var $editorsContainer=$('<div id="'+this.editorsContainerId+'" class="n2CouchEditor_container"></div>');$div.append($editorsContainer);for(var i=0,e=this.editors.length;i<e;++i){var editorDesc=this.editors[i];if($n2.CouchEditor.Constants.FORM_EDITOR===editorDesc&&selectedSchema&&this.schemaEditorService){$n2.schema.GlobalAttributes.disableKeyUpEvents=true;if(accordionNeeded){var $schemaHeader=$('<h3>').appendTo($editorsContainer);$('<a>').attr('href','#').text(_loc('Form View')).appendTo($schemaHeader);};var $schemaContainer=$('<div class="n2CouchEditor_schema"></div>').addClass('n2CouchEditor_schema').appendTo($editorsContainer);this.schemaEditor=this.schemaEditorService.editDocument({doc:data,schema:selectedSchema,$div:$schemaContainer,onChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.treeEditor){_this.treeEditor.refresh();};if(_this.slideEditor){_this.slideEditor.refresh();};_this._refreshRelations(data);_this._onEditorObjectChanged(data);}});}else if($n2.CouchEditor.Constants.TREE_EDITOR===editorDesc){if(accordionNeeded){var $treeHeader=$('<h3>').appendTo($editorsContainer);$('<a>').attr('href','#').text(_loc('Tree View')).appendTo($treeHeader);};var $treeContainer=$('<div>').addClass('n2CouchEditor_tree').appendTo($editorsContainer);var editorOptions={onObjectChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.slideEditor){_this.slideEditor.refresh();};if(_this.schemaEditor){_this.schemaEditor.refresh();};_this._refreshRelations(data);_this._onEditorObjectChanged(data);},isKeyEditingAllowed:isKeyEditingAllowed,isValueEditingAllowed:isValueEditingAllowed,isKeyDeletionAllowed:isKeyDeletionAllowed};var objectTree=new $n2.tree.ObjectTree($treeContainer,data,editorOptions);this.treeEditor=new $n2.tree.ObjectTreeEditor(objectTree,data,editorOptions);}else if($n2.CouchEditor.Constants.SLIDE_EDITOR===editorDesc){if(accordionNeeded){var $slideHeader=$('<h3>').appendTo($editorsContainer);$('<a>').attr('href','#').text(_loc('Editor View')).appendTo($slideHeader);};var $slideContainer=$('<div>').addClass('n2CouchEditor_slide').appendTo($editorsContainer);var slideEditorOptions={onObjectChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.treeEditor){_this.treeEditor.refresh();};if(_this.schemaEditor){_this.schemaEditor.refresh();};_this._refreshRelations(data);_this._onEditorObjectChanged(data);},isKeyEditingAllowed:isKeyEditingAllowed,isValueEditingAllowed:isValueEditingAllowed,isKeyDeletionAllowed:isKeyDeletionAllowed};this.slideEditor=new $n2.slideEditor.Editor($slideContainer,data,slideEditorOptions);};};if(accordionNeeded){$editorsContainer.accordion({collapsible:true});};if(relationEditorNeeded){var $displayRelationsDiv=$('<div class="editorDisplayRelations"></div>');$editorsContainer.append($displayRelationsDiv);this._refreshRelations(data);};},_selectSchema:function(callbackFn){var _this=this;if(this.editedDocument.nunaliit_schema){this.schemaRepository.getSchema({name:this.editedDocument.nunaliit_schema,onSuccess:function(schema){callbackFn(schema);},onError:function(err){$n2.log('Error fetching schema: '+_this.editedDocument.nunaliit_schema,err);callbackFn(null);}});}else if(this.schema&&this.isInsert){if($n2.CouchEditor.Constants.ALL_SCHEMAS===this.schema){this.schemaRepository.getRootSchemas({onSuccess:function(schemas){selectFromSchemas(schemas);},onError:function(err){$n2.log('Error fetching root schemas',err);callbackFn(null);}});}else if($n2.isArray(this.schema)){selectFromSchemas(this.schema);}else{callbackFn(this.schema);};}else if(this.defaultEditSchema&&!this.isInsert){callbackFn(this.defaultEditSchema);}else{callbackFn(null);};function selectFromSchemas(schemas){if(schemas.length<1){callbackFn(null);return;}else if(schemas.length==1){callbackFn(schemas[0]);return;};var dialogId=$n2.getUniqueId();var selectId=$n2.getUniqueId();var $dialog=$('<div id="'+dialogId+'" class="editorSelectSchemaDialog">'
+'<label for="'+selectId+'">'+_loc('Select a schema:')+'</label>'
+'<select id="'+selectId+'"></select>'
+'<div><button>'+_loc('OK')+'</button><button>'+_loc('Cancel')+'</button></div>'
+'</div>');var $select=$dialog.find('select');for(var i=0,e=schemas.length;i<e;++i){$select.append($('<option>'+schemas[i].name+'</option>'));}
var cancelOnClose=true;$dialog.find('button').first().button({icons:{primary:'ui-icon-check'}}).click(function(){var $dialog=$('#'+dialogId);var $select=$dialog.find('select');var schemaName=$select.val();$n2.log('schemaName',schemaName);_this.schemaRepository.getSchema({name:schemaName,onSuccess:function(schema){callbackFn(schema);},onError:function(err){reportError('Unable to get selected schema: '+err);_this._cancelEdit();}});cancelOnClose=false;$dialog.dialog('close');return false;}).next().button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);$dialog.dialog('close');return false;});var dialogOptions={autoOpen:true,title:_loc('Select Document Schema'),modal:true,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();if(cancelOnClose){_this._cancelEdit();};}};$dialog.dialog(dialogOptions);};},_dispatch:function(m){if(this.dispatchService){this.dispatchService.send(DH,m);};},_synchronousCall:function(m){if(this.dispatchService){this.dispatchService.send(DH,m);};},_handle:function(m,address,dispatcher){var $div=this._getDiv();if($div.length<1){dispatcher.deregister(address);};if(m.type==='editGeometryModified'){if(m._origin!==this){this._featureModified(m.docId,m.geom,m.proj);};}else if(m.type==='mapGeometryAdded'){this._addGeometry(m.geom,m.proj);};},_adjustInternalValues:function(obj){if(typeof(OpenLayers)!=='undefined'){var geomData=obj[this.geomName];if(geomData){if(this.currentGeometryWkt!=geomData.wkt){$n2.couchGeom.adjustBboxOnCouchGeom(geomData);};};};},_refreshRelations:function(data){var _this=this;var $div=this._getDiv();var $displayRelationsDiv=$div.find('.editorDisplayRelations');if($displayRelationsDiv.length<1)return;var showService=this.showService;if(!showService)return;var docIdMap={};if(data&&data.nunaliit_relations&&data.nunaliit_relations.length){for(var i=0,e=data.nunaliit_relations.length;i<e;++i){var ref=data.nunaliit_relations[i];if(ref.doc){docIdMap[ref.doc]=true;};};};if(data&&data.nunaliit_source&&data.nunaliit_source.doc){docIdMap[data.nunaliit_source.doc]=true;};$displayRelationsDiv.find('.editorDisplayRelation').each(function(){var $display=$(this);var relDocId=$display.attr('nunaliitRelationDocId');if(!docIdMap[relDocId]){$display.remove();}else{delete docIdMap[relDocId];};});var removeRelationFn=function(e){var $btn=$(this);var $removeRelationDiv=$btn.parents('.editorDisplayRelation');if($removeRelationDiv.length>0){var relDocId=$removeRelationDiv.attr('nunaliitRelationDocId');_this._removeRelation(relDocId);$removeRelationDiv.remove();};return false;};for(var relDocId in docIdMap){var $displayRelationDiv=$('<div class="editorDisplayRelation"></div>');$displayRelationsDiv.append($displayRelationDiv);$displayRelationDiv.attr('nunaliitRelationDocId',relDocId);$('<span></span>').text(_loc('Relation: ')).appendTo($displayRelationDiv);var $brief=$('<span></span>').text(relDocId).appendTo($displayRelationDiv);if(showService){showService.printBriefDescription($brief,relDocId);};$('<button class="editorDisplayRelationButton"></button>').text(_loc('Remove')).appendTo($displayRelationDiv).button({icons:{primary:'ui-icon-trash'}}).click(removeRelationFn);};},_onEditorObjectChanged:function(obj){var geomData=obj[this.geomName];if(!geomData)return;if(typeof(OpenLayers)==='undefined')return;if(this.currentGeometryWkt!==geomData.wkt){this.currentGeometryWkt=geomData.wkt;var olGeom=$n2.couchGeom.getOpenLayersGeometry({couchGeom:geomData});this._dispatch({type:'editGeometryModified',docId:obj._id,geom:olGeom,proj:this.couchProj,_origin:this});};},_featureModified:function(docId,geom,proj){if(proj.getCode()!=this.couchProj.getCode()){geom=geom.clone();geom.transform(proj,this.options.couchProj);};var geomData=this.editedDocument[this.geomName];geomData.wkt=geom.toString();this.currentGeometryWkt=geomData.wkt;if(this.schemaEditor){this.schemaEditor.refresh();};if(this.treeEditor){this.treeEditor.refresh();};if(this.slideEditor){this.slideEditor.refresh();};},_addGeometry:function(geom,proj){if(proj.getCode()!=this.couchProj.getCode()){geom=geom.clone();geom.transform(proj,this.couchProj);};var geomData=this.editedDocument[this.geomName];if(!geomData){geomData={nunaliit_type:'geometry'};this.editedDocument[this.geomName]=geomData;};geomData.wkt=geom.toString();$n2.couchGeom.adjustBboxOnCouchGeom(geomData);this.currentGeometryWkt=geomData.wkt;if(this.schemaEditor){this.schemaEditor.refresh();};if(this.treeEditor){this.treeEditor.refresh();};if(this.slideEditor){this.slideEditor.refresh();};}});var CouchDocumentEditor=$n2.Class({panelName:null,uploadService:null,searchService:null,showService:null,schemaEditorService:null,schemaRepository:null,customService:null,dispatchService:null,dialogService:null,geomName:null,initialLayers:null,schema:null,defaultEditSchema:null,documentSource:null,couchProj:null,onFeatureInsertedFn:null,onFeatureUpdatedFn:null,onFeatureDeletedFn:null,onCancelFn:null,onCloseFn:null,enableAddFile:null,relatedDocProcess:null,schemaEditor:null,treeEditor:null,slideEditor:null,attachmentEditor:null,editedDocument:null,editedFeature:null,currentGeometryWkt:null,editorContainerId:null,isInsert:null,userButtons:null,editorSuppressSlideView:null,editorSuppressTreeView:null,editorSuppressFormView:null,initialize:function(opts_){var opts=$n2.extend({panelName:null,uploadService:null,searchService:null,showService:null,schemaEditorService:null,schemaRepository:null,customService:null,dispatchService:null,dialogService:null,geomName:null,initialLayers:['public'],schema:null,defaultEditSchema:null,documentSource:null,couchProj:null,onFeatureInsertedFn:function(fid,feature){},onFeatureUpdatedFn:function(fid,feature){},onFeatureDeletedFn:function(fid,feature){},onCancelFn:function(feature){},onCloseFn:function(){},enableAddFile:false,relatedDocProcess:null},opts_);this.panelName=opts.panelName;this.uploadService=opts.uploadService;this.searchService=opts.searchService;this.showService=opts.showService;this.schemaEditorService=opts.schemaEditorService;this.schemaRepository=opts.schemaRepository;this.customService=opts.customService;this.dispatchService=opts.dispatchService;this.dialogService=opts.dialogService;this.geomName=opts.geomName;this.initialLayers=opts.initialLayers;this.schema=opts.schema;this.defaultEditSchema=opts.defaultEditSchema;this.documentSource=opts.documentSource;this.couchProj=opts.couchProj;this.onFeatureInsertedFn=opts.onFeatureInsertedFn;this.onFeatureUpdatedFn=opts.onFeatureUpdatedFn;this.onFeatureDeletedFn=opts.onFeatureDeletedFn;this.onCancelFn=opts.onCancelFn;this.onCloseFn=opts.onCloseFn;this.enableAddFile=opts.enableAddFile;this.relatedDocProcess=opts.relatedDocProcess;this.userButtons=[];var label='button';for(var key in opts){if(key.substr(0,label.length)===label){this.userButtons.push(opts[key]);};};this.editorSuppressSlideView=false;this.editorSuppressTreeView=false;this.editorSuppressFormView=false;var cs=this.customService;if(cs){this.editorSuppressSlideView=cs.getOption('editorSuppressSlideView',false);this.editorSuppressTreeView=cs.getOption('editorSuppressTreeView',false);this.editorSuppressFormView=cs.getOption('editorSuppressFormView',false);var flag=cs.getOption('editorEnableAddFile',false);if(flag){this.enableAddFile=true;};};},startFeatureEditing:function(feature_){var _this=this;this.editedFeature=feature_;this.editedDocument={};for(var key in feature_.data){if('__n2Source'===key){this.editedDocumentSource=feature_.data[key];}else{this.editedDocument[key]=feature_.data[key];};};this.currentGeometryWkt=null;if(this.editedDocument&&this.editedDocument[this.geomName]){this.currentGeometryWkt=this.editedDocument[this.geomName].wkt;};this.isInsert=(typeof(this.editedFeature.fid)==='undefined'||this.editedFeature.fid===null);if(this.isInsert){var geom=this.convertFeatureGeometryForDb(this.editedFeature);var g=$n2.couchGeom.getCouchGeometry(geom);this.editedDocument[this.geomName]=g;if(this.initialLayers&&this.initialLayers.length>0){this.editedDocument.nunaliit_layers=this.initialLayers;};};this._selectSchema(schemaSelected);function schemaSelected(schema){if(_this.isInsert){if(schema){var template=schema.createObject({});$n2.extend(true,_this.editedDocument,template);};var geom=_this.convertFeatureGeometryForDb(_this.editedFeature);var g=$n2.couchGeom.getCouchGeometry(geom);_this.editedDocument[_this.geomName]=g;if(_this.initialLayers&&_this.initialLayers.length>0){_this.editedDocument.nunaliit_layers=_this.initialLayers;};};_this._displayEditor(schema);};},startDocumentEditing:function(doc_){var _this=this;this.editedDocument={};for(var key in doc_){if('__n2Source'===key){this.editedDocumentSource=doc_[key];}else{this.editedDocument[key]=doc_[key];};};this.isInsert=(typeof(this.editedDocument._id)==='undefined'||this.editedDocument._id===null);this._selectSchema(schemaSelected);function schemaSelected(schema){if(_this.isInsert){if(schema){var template=schema.createObject({});$n2.extend(true,_this.editedDocument,template);};};_this._displayEditor(schema);};},_selectSchema:function(callbackFn){var _this=this;if(this.editedDocument.nunaliit_schema){this.schemaRepository.getSchema({name:this.editedDocument.nunaliit_schema,onSuccess:function(schema){callbackFn(schema);},onError:function(err){$n2.log('Error fetching schema: '+_this.editedDocument.nunaliit_schema,err);callbackFn(null);}});}else if(this.schema&&this.isInsert){if($n2.CouchEditor.Constants.ALL_SCHEMAS===this.schema){this.dialogService.selectSchema({onSelected:callbackFn});}else if($n2.isArray(this.schema)){this.dialogService.selectSchema({schemas:this.schema,onSelected:callbackFn});}else{callbackFn(this.schema);};}else if(this.defaultEditSchema&&!this.isInsert){callbackFn(this.defaultEditSchema);}else{callbackFn(null);};function selectFromSchemas(schemas){if(schemas.length<1){callbackFn(null);return;}else if(schemas.length==1){callbackFn(schemas[0]);return;};var dialogId=$n2.getUniqueId();var selectId=$n2.getUniqueId();var $dialog=$('<div id="'+dialogId+'" class="editorSelectSchemaDialog">'
+'<label for="'+selectId+'">'+_loc('Select a schema:')+'</label>'
+'<select id="'+selectId+'"></select>'
+'<div><button>'+_loc('OK')+'</button><button>'+_loc('Cancel')+'</button></div>'
+'</div>');var $select=$dialog.find('select');for(var i=0,e=schemas.length;i<e;++i){$select.append($('<option>'+schemas[i].name+'</option>'));};var cancelOnClose=true;$dialog.find('button').first().button({icons:{primary:'ui-icon-check'}}).click(function(){var $dialog=$('#'+dialogId);var $select=$dialog.find('select');var schemaName=$select.val();$n2.log('schemaName',schemaName);_this.schemaRepository.getSchema({name:schemaName,onSuccess:function(schema){callbackFn(schema);},onError:function(err){reportError('Unable to get selected schema: '+err);_this._cancelEdit();}});cancelOnClose=false;$dialog.dialog('close');return false;}).next().button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);$dialog.dialog('close');return false;});var dialogOptions={autoOpen:true,title:_loc('Select Document Schema'),modal:true,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();if(cancelOnClose){_this._cancelEdit();};}};$dialog.dialog(dialogOptions);};},_displayEditor:function(selectedSchema){var _this=this;$('body').addClass('nunaliit_editing');$('.n2_disable_on_edit').attr('disabled','disabled');var data=this.editedDocument;this._synchronousCall({type:'editorStartDocumentEdit',doc:data});$n2.couchDocument.adjustDocument(data);var showFormView=false;var showTreeView=false;var showSlideView=false;var viewCount=0;var showAccordion=false;var schemaEditorService=this.schemaEditorService;if(!this.editorSuppressFormView&&selectedSchema&&schemaEditorService){showFormView=true;++viewCount;};if(!this.editorSuppressTreeView){showTreeView=true;++viewCount;};if(!this.editorSuppressTreeView){showSlideView=true;++viewCount;};if(viewCount>1){showAccordion=true;};var attributeDialog=$('#'+this.panelName);attributeDialog.empty();this.editorContainerId=$n2.getUniqueId();var $editorContainer=$('<div id="'+this.editorContainerId+'" class="n2CouchEditor_container"></div>');attributeDialog.append($editorContainer);if(showFormView){$n2.schema.GlobalAttributes.disableKeyUpEvents=true;if(showAccordion){var $schemaHeader=$('<h3>').appendTo($editorContainer);$('<a>').attr('href','#').text(_loc('Form View')).appendTo($schemaHeader);};var $schemaContainer=$('<div>').addClass('n2CouchEditor_schema').appendTo($editorContainer);this.schemaEditor=schemaEditorService.editDocument({doc:data,schema:selectedSchema,$div:$schemaContainer,onChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.treeEditor){_this.treeEditor.refresh();};if(_this.slideEditor){_this.slideEditor.refresh();};if(_this.attachmentEditor){_this.attachmentEditor.refresh();};_this._refreshRelations(data);_this.onEditorObjectChanged(data);}});};if(showTreeView){if(showAccordion){var $treeHeader=$('<h3>').appendTo($editorContainer);$('<a>').attr('href','#').text(_loc('Tree View')).appendTo($treeHeader);};var $treeContainer=$('<div>').addClass('n2CouchEditor_tree').appendTo($editorContainer);var editorOptions={onObjectChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.slideEditor){_this.slideEditor.refresh();};if(_this.schemaEditor){_this.schemaEditor.refresh();};if(_this.attachmentEditor){_this.attachmentEditor.refresh();};_this._refreshRelations(data);_this.onEditorObjectChanged(data);},isKeyEditingAllowed:isKeyEditingAllowed,isValueEditingAllowed:isValueEditingAllowed,isKeyDeletionAllowed:isKeyDeletionAllowed};var objectTree=new $n2.tree.ObjectTree($treeContainer,data,editorOptions);this.treeEditor=new $n2.tree.ObjectTreeEditor(objectTree,data,editorOptions);};if(showSlideView){if(showAccordion){var $slideHeader=$('<h3>').appendTo($editorContainer);$('<a>').attr('href','#').text(_loc('Editor View')).appendTo($slideHeader);};var $slideContainer=$('<div>').addClass('n2CouchEditor_slide').appendTo($editorContainer);var slideEditorOptions={onObjectChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.treeEditor){_this.treeEditor.refresh();};if(_this.schemaEditor){_this.schemaEditor.refresh();};if(_this.attachmentEditor){_this.attachmentEditor.refresh();};_this._refreshRelations(data);_this.onEditorObjectChanged(data);},isKeyEditingAllowed:isKeyEditingAllowed,isValueEditingAllowed:isValueEditingAllowed,isKeyDeletionAllowed:isKeyDeletionAllowed};this.slideEditor=new $n2.slideEditor.Editor($slideContainer,data,slideEditorOptions);};if(showAccordion){$editorContainer.accordion({collapsible:true});};$('<div>').addClass('editorDisplayRelations').appendTo($editorContainer);this._refreshRelations(data);{var disableAttachmentEditorButtons=!this.enableAddFile;var $attachmentsDiv=$('<div>').addClass('editorAttachments').appendTo($editorContainer);this.attachmentEditor=new AttachmentEditor({doc:data,elem:$attachmentsDiv,documentSource:this.documentSource,uploadService:this.uploadService,disableAddFile:disableAttachmentEditorButtons,disableRemoveFile:disableAttachmentEditorButtons,onChangedFn:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.schemaEditor){_this.schemaEditor.refresh();};if(_this.treeEditor){_this.treeEditor.refresh();};if(_this.slideEditor){_this.slideEditor.refresh();};_this._refreshRelations(data);_this.onEditorObjectChanged(data);}});};var formButtons=$('<div class="editorButtons"></div>');$editorContainer.append(formButtons);var saveBtn=$('<button class="save">'+_loc('Save')+'</button>');formButtons.append(saveBtn);saveBtn.button({icons:{primary:'ui-icon-check'}});saveBtn.click(function(){_this._save();return false;});if(!this.isInsert&&$n2.couchMap.canDeleteDoc(data)){var deleteBtn=$('<button class="delete">'+_loc('Delete')+'</button>');formButtons.append(deleteBtn);deleteBtn.button({icons:{primary:'ui-icon-trash'}});deleteBtn.click(function(evt){if(confirm(_loc('Do you really want to delete this feature?'))){deletion(data);};return false;});};if(this.attachmentEditor){this.attachmentEditor.printButtons({elem:formButtons});};var addRelationBtn=$('<button class="relation">'+_loc('Add Relation')+'</button>');formButtons.append(addRelationBtn);addRelationBtn.button({icons:{primary:'ui-icon-plusthick'}});addRelationBtn.click(function(){_this._addRelationDialog();return false;});var layersBtn=$('<button class="layers">'+_loc('Layers')+'</button>');formButtons.append(layersBtn);layersBtn.button({icons:{primary:'ui-icon-link'}});layersBtn.click(function(){_this._manageLayersDialog();return false;});var cancelBtn=$('<button class="cancel">'+_loc('Cancel')+'</button>');formButtons.append(cancelBtn);cancelBtn.button({icons:{primary:'ui-icon-cancel'}});cancelBtn.click(function(){_this._cancelEdit();return false;});for(var i=0,e=this.userButtons.length;i<e;++i){var userButton=this.userButtons[i];var $uBtn=$('<button>'+_loc(''+userButton.label)+'</button>');if(userButton.buttonClass){$uBtn.addClass(userButton.buttonClass);};if(userButton.before){var $anchor=formButtons.find('button.'+userButton.before);$anchor.before($uBtn);}else if(userButton.after){var $anchor=formButtons.find('button.'+userButton.after);$anchor.after($uBtn);}else{formButtons.append($uBtn);};$uBtn.button(userButton.options);installUserButtonClick($uBtn,userButton);};function deletion(editedDocument){_this.documentSource.deleteDocument({doc:_this.editedDocument,onSuccess:function(){_this.onFeatureDeletedFn(editedDocument._id,_this.editedFeature);_this._discardEditor({deleted:true});},onError:function(err){_this._enableControls();$n2.reportErrorForced('Unable to delete document: '+err);}});};function installUserButtonClick($uBtn,userButton){$uBtn.click(function(){if(userButton.click){return userButton.click(_this.editedDocument,_this,userButton);};return false;});};},_save:function(){var _this=this;this._disableControls();if(this.uploadService){this.uploadService.getWelcome({onSuccess:function(){preSaveAttachmentEditor();},onError:function(err){_this._enableControls();$n2.reportErrorForced('Server is not available: '+err);}});}else{preSaveAttachmentEditor();};function preSaveAttachmentEditor(){if(_this.attachmentEditor){_this.attachmentEditor.performPreSavingActions({onSuccess:function(doc){removeCompulsoryAttachmentFlag();},onError:function(err){_this._enableControls();$n2.reportErrorForced(err);}});}else{removeCompulsoryAttachmentFlag();};};function removeCompulsoryAttachmentFlag(){if(_this.editedDocument&&_this.editedDocument.nunaliit_attachments){if(typeof _this.editedDocument.nunaliit_attachments._compulsory!=='undefined'){delete _this.editedDocument.nunaliit_attachments._compulsory;};if(_this.editedDocument.nunaliit_attachments.files){for(var attName in _this.editedDocument.nunaliit_attachments.files){var att=_this.editedDocument.nunaliit_attachments.files[attName];if(typeof att._compulsory!=='undefined'){delete att._compulsory;};};};};updateDocument();};function updateDocument(){if(_this.isInsert){var isSubmissionDs=false;if(_this.documentSource.isSubmissionDataSource){isSubmissionDs=true;};_this.documentSource.createDocument({doc:_this.editedDocument,onSuccess:function(updatedDoc){if(isSubmissionDs){postSaveAttachmentEditor(updatedDoc,false);}else{postSaveAttachmentEditor(updatedDoc,true);};},onError:function(err){_this._enableControls();$n2.reportErrorForced(_loc('Unable to submit document: {err}',{err:err}));}});}else{_this.documentSource.updateDocument({doc:_this.editedDocument,onSuccess:function(updatedDoc){postSaveAttachmentEditor(updatedDoc,false);},onError:function(err){_this._enableControls();$n2.reportErrorForced(_loc('Unable to submit document: {err}',{err:err}));}});};};function postSaveAttachmentEditor(editedDocument,inserted){if(_this.attachmentEditor){_this.attachmentEditor.performPostSavingActions({onSuccess:function(doc){completeSave(editedDocument,inserted);},onError:function(err){_this._enableControls();$n2.reportErrorForced(err);}});}else{completeSave(editedDocument,inserted);};};function completeSave(editedDocument,inserted){var discardOpts={saved:true};if(inserted){_this.onFeatureInsertedFn(editedDocument._id,_this.editedFeature);discardOpts.inserted=true;}else{_this.onFeatureUpdatedFn(editedDocument._id,_this.editedFeature);discardOpts.updated=true;};_this._discardEditor(discardOpts);};},_addRelationDialog:function(){var _this=this;if(this.dialogService){this.dialogService.searchForDocumentId({onSelected:function(docId){_this._addRelation(docId);}});};},_addRelation:function(relDocId){var data=this.editedDocument;if(data&&data.nunaliit_source&&data.nunaliit_source.doc===relDocId){return;};if(data&&data.nunaliit_relations&&data.nunaliit_relations.length){for(var i=0,e=data.nunaliit_relations.length;i<e;++i){var rel=data.nunaliit_relations[i];if(rel.doc===relDocId){return;};};};if(data){if(!data.nunaliit_relations){data.nunaliit_relations=[];};data.nunaliit_relations.push({nunaliit_type:'reference',doc:relDocId});this.refresh();};},_removeRelation:function(relDocId){var data=this.editedDocument;var refreshRequired=false;if(data&&data.nunaliit_source&&data.nunaliit_source.doc===relDocId){delete data.nunaliit_source;refreshRequired=true;};if(data&&data.nunaliit_relations&&data.nunaliit_relations.length){var relRemoved=false;var newRels=[];for(var i=0,e=data.nunaliit_relations.length;i<e;++i){var rel=data.nunaliit_relations[i];if(rel.doc===relDocId){relRemoved=true;}else{newRels.push(rel);};};if(newRels.length<1){delete data.nunaliit_relations;refreshRequired=true;}else if(relRemoved){data.nunaliit_relations=newRels;refreshRequired=true;};};if(refreshRequired){this.refresh();};},_manageLayersDialog:function(){var _this=this;var data=this.editedDocument;var layers=data.nunaliit_layers;if(!layers){layers=[];};if(this.dialogService){this.dialogService.selectLayersDialog({currentLayers:layers,onSelected:function(selectedLayers){if(selectedLayers.length<1){if(data.nunaliit_layers){delete data.nunaliit_layers;};}else{data.nunaliit_layers=selectedLayers;};_this.refresh();}});};},_removeAttachment:function(attNameToRemove){var data=this.editedDocument;var keys={};if(data&&data.nunaliit_attachments&&data.nunaliit_attachments.files){for(var attName in data.nunaliit_attachments.files){var att=data.nunaliit_attachments.files[attName];if(attName===attNameToRemove){keys[attName]=true;}else if(att.source===attNameToRemove){keys[attName]=true;};};};var refreshRequired=false;var attName=null;for(attName in keys){if(data._attachments&&data._attachments[attName]){delete data._attachments[attName];refreshRequired=true;};if(data.nunaliit_attachments.files[attName]){delete data.nunaliit_attachments.files[attName];refreshRequired=true;};};if(data._attachments){var empty=true;for(attName in data._attachments){empty=false;};if(empty){delete data._attachments;refreshRequired=true;};};if(data.nunaliit_attachments){var empty=true;if(data.nunaliit_attachments.files){for(attName in data.nunaliit_attachments.files){empty=false;};};if(empty){delete data.nunaliit_attachments;refreshRequired=true;};};if(refreshRequired){this.refresh();};},_cancelEdit:function(){this._dispatch({type:'editCancel',doc:this.editedDocument});},performCancellation:function(opts_){var opts=$n2.extend({suppressEvents:false},opts_);if(null==this.editedDocument){return;};this.onCancelFn(this.editedFeature);this._discardEditor({cancelled:true,suppressEvents:opts.suppressEvents});},_discardEditor:function(opts_){var opts=$n2.extend({saved:false,inserted:false,updated:false,deleted:false,cancelled:false,suppressEvents:false},opts_);if(null==this.editedDocument){return;};var $editorContainer=this._getEditorContainer();$editorContainer.remove();this.onCloseFn(this.editedDocument,this);if(!opts.suppressEvents){var docId=null;var doc=null;if(this.editedDocument._id){doc=this.editedDocument;docId=doc._id;};this._dispatch({type:'editClosed',docId:docId,doc:doc,saved:opts.saved,inserted:opts.inserted,updated:opts.updated,deleted:opts.deleted,cancelled:opts.cancelled});};this.editedDocument=null;this.editedFeature=null;this.editorContainerId=null;$('body').removeClass('nunaliit_editing');$('.n2_disable_on_edit').removeAttr('disabled');},refresh:function(){this._adjustInternalValues(this.editedDocument);if(this.treeEditor){this.treeEditor.refresh();};if(this.slideEditor){this.slideEditor.refresh();};if(this.schemaEditor){this.schemaEditor.refresh();};this._refreshRelations(this.editedDocument);this.onEditorObjectChanged(this.editedDocument);},_adjustInternalValues:function(obj){if(typeof(OpenLayers)!=='undefined'){var geomData=obj[this.geomName];if(geomData){if(this.currentGeometryWkt!=geomData.wkt){$n2.couchGeom.adjustBboxOnCouchGeom(geomData);};};};},_refreshRelations:function(data){var _this=this;var $editorContainer=this._getEditorContainer();var $displayRelationsDiv=$editorContainer.find('.editorDisplayRelations');if($displayRelationsDiv.length<1)return;var showService=this.showService;var docIdMap={};if(data&&data.nunaliit_relations&&data.nunaliit_relations.length){for(var i=0,e=data.nunaliit_relations.length;i<e;++i){var ref=data.nunaliit_relations[i];if(ref.doc){docIdMap[ref.doc]=true;};};};if(data&&data.nunaliit_source&&data.nunaliit_source.doc){docIdMap[data.nunaliit_source.doc]=true;};$displayRelationsDiv.find('.editorDisplayRelation').each(function(){var $display=$(this);var relDocId=$display.attr('nunaliitRelationDocId');if(!docIdMap[relDocId]){$display.remove();}else{delete docIdMap[relDocId];};});var removeRelationFn=function(e){var $btn=$(this);var $removeRelationDiv=$btn.parents('.editorDisplayRelation');if($removeRelationDiv.length>0){var relDocId=$removeRelationDiv.attr('nunaliitRelationDocId');_this._removeRelation(relDocId);$removeRelationDiv.remove();};return false;};for(var relDocId in docIdMap){var $displayRelationDiv=$('<div class="editorDisplayRelation"></div>');$displayRelationsDiv.append($displayRelationDiv);$displayRelationDiv.attr('nunaliitRelationDocId',relDocId);$('<span></span>').text(_loc('Relation: ')).appendTo($displayRelationDiv);var $brief=$('<span></span>').text(relDocId).appendTo($displayRelationDiv);if(showService){showService.printBriefDescription($brief,relDocId);};$('<button class="editorDisplayRelationButton"></button>').text(_loc('Remove')).appendTo($displayRelationDiv).button({icons:{primary:'ui-icon-trash'}}).click(removeRelationFn);};},onEditorObjectChanged:function(obj){var geomData=obj[this.geomName];if(!geomData)return;if(typeof(OpenLayers)==='undefined')return;if(this.currentGeometryWkt!==geomData.wkt){this.currentGeometryWkt=geomData.wkt;var olGeom=$n2.couchGeom.getOpenLayersGeometry({couchGeom:geomData});this._dispatch({type:'editGeometryModified',docId:obj._id,geom:olGeom,proj:this.couchProj,_origin:this});};},convertFeatureGeometryForDb:function(feature){var mapProj=feature.layer.map.projection;if(mapProj.getCode()!=this.couchProj.getCode()){var geom=feature.geometry.clone();geom.transform(mapProj,this.couchProj);return geom;};return feature.geometry;},_featureModified:function(docId,geom,proj){if(proj.getCode()!=this.couchProj.getCode()){geom=geom.clone();geom.transform(proj,this.couchProj);};var geomData=this.editedDocument[this.geomName];geomData.wkt=geom.toString();this.currentGeometryWkt=geomData.wkt;if(this.schemaEditor){this.schemaEditor.refresh();};if(this.treeEditor){this.treeEditor.refresh();};if(this.slideEditor){this.slideEditor.refresh();};},_addGeometry:function(geom,proj){if(proj.getCode()!=this.couchProj.getCode()){geom=geom.clone();geom.transform(proj,this.couchProj);};var geomData=this.editedDocument[this.geomName];if(!geomData){geomData={nunaliit_type:'geometry'};this.editedDocument[this.geomName]=geomData;};geomData.wkt=geom.toString();$n2.couchGeom.adjustBboxOnCouchGeom(geomData);this.currentGeometryWkt=geomData.wkt;if(this.schemaEditor){this.schemaEditor.refresh();};if(this.treeEditor){this.treeEditor.refresh();};if(this.slideEditor){this.slideEditor.refresh();};},_getEditorContainer:function(){var $editorContainer=$('#'+this.editorContainerId);return $editorContainer;},_disableControls:function(){var $editorContainer=this._getEditorContainer();$editorContainer.find('button').attr('disabled','disabled');$editorContainer.find('input:text').attr('disabled','disabled');$editorContainer.find('.editorAttachFile').find('input:text').removeAttr('disabled');},_enableControls:function(){var $editorContainer=this._getEditorContainer();$editorContainer.find('button').removeAttr('disabled');$editorContainer.find('input:text').removeAttr('disabled');},_dispatch:function(m){var dispatcher=this.dispatchService;if(dispatcher){dispatcher.send(DH,m);};},_synchronousCall:function(m){var dispatcher=this.dispatchService;if(dispatcher){dispatcher.synchronousCall(DH,m);};},_handle:function(m){if(m.type==='editGeometryModified'){if(m._origin!==this){this._featureModified(m.docId,m.geom,m.proj);};}else if(m.type==='mapGeometryAdded'){this._addGeometry(m.geom,m.proj);};}});var CouchEditor=$n2.Class({options:null,documentSource:null,panelName:null,geomName:null,couchProj:null,schema:null,defaultEditSchema:null,schemaRepository:null,uploadService:null,showService:null,authService:null,dispatchService:null,searchService:null,schemaEditorService:null,customService:null,dialogService:null,enableAddFile:null,initialLayers:null,userButtons:null,relatedDocProcess:null,isFormEditor:null,currentEditor:null,initialize:function(opts_){var opts=$n2.extend({documentSource:null,panelName:null,geomName:'nunaliit_geom',couchProj:null,schema:null,defaultEditSchema:null,schemaRepository:null,uploadService:null,showService:null,authService:null,dispatchService:null,searchService:null,schemaEditorService:null,customService:null,dialogService:null,createDocProcess:null,enableAddFile:false,initialLayers:['public']},opts_);var _this=this;this.options={};this.documentSource=opts.documentSource;this.panelName=opts.panelName;this.geomName=opts.geomName;this.couchProj=opts.couchProj;this.options.schema=opts.schema;this.defaultEditSchema=opts.defaultEditSchema;this.enableAddFile=opts.enableAddFile;this.initialLayers=opts.initialLayers;this.schemaRepository=opts.schemaRepository;this.uploadService=opts.uploadService;this.showService=opts.showService;this.authService=opts.authService;this.dispatchService=opts.dispatchService;this.searchService=opts.searchService;this.schemaEditorService=opts.schemaEditorService;this.customService=opts.customService;this.dialogService=opts.dialogService;this.isFormEditor=true;this.relatedDocProcess=opts.createDocProcess;if(!this.couchProj){this.couchProj=getDefaultCouchProjection();};var dispatcher=this.dispatchService;if(dispatcher){var f=function(m){_this._handle(m);};dispatcher.register(DH,'editGeometryModified',f);dispatcher.register(DH,'mapGeometryAdded',f);dispatcher.register(DH,'editInitiate',f);dispatcher.register(DH,'editCancel',f);};this.userButtons={};var label='button';for(var key in opts){if(key.substr(0,label.length)===label){this.userButtons[key]=opts[key];};};},_showAttributeForm:function(feature_,editorOptions_){if(null!=this.currentEditor){this.currentEditor.performCancellation();this.currentEditor=null;};this.currentEditor=this._createEditor(editorOptions_);this.currentEditor.startFeatureEditing(feature_);},showDocumentForm:function(document_,editorOptions_){if(null!=this.currentEditor){this.currentEditor.performCancellation();this.currentEditor=null;};this.currentEditor=this._createEditor(editorOptions_);this.currentEditor.startDocumentEditing(document_);},_createEditor:function(o_){o_=o_?o_:{};var opts={panelName:o_.panelName?o_.panelName:this.panelName,geomName:o_.geomName?o_.geomName:this.geomName,initialLayers:o_.initialLayers?o_.initialLayers:this.initialLayers,enableAddFile:o_.enableAddFile?o_.enableAddFile:this.enableAddFile,schema:o_.schema?o_.schema:this.options.schema,onFeatureInsertedFn:o_.onFeatureInsertedFn,onFeatureUpdatedFn:o_.onFeatureUpdatedFn,onFeatureDeletedFn:o_.onFeatureDeletedFn,onCancelFn:o_.onCancelFn,onCloseFn:o_.onCloseFn,uploadService:this.uploadService,searchService:this.searchService,showService:this.showService,schemaEditorService:this.schemaEditorService,schemaRepository:this.schemaRepository,customService:this.customService,dispatchService:this.dispatchService,dialogService:this.dialogService,defaultEditSchema:this.defaultEditSchema,documentSource:this.documentSource,couchProj:this.couchProj,relatedDocProcess:this.relatedDocProcess};for(var key in this.userButtons){opts[key]=this.userButtons[key];};var label='button';for(var key in o_){if(key.substr(0,label.length)===label){opts[key]=o_[key];};};var editor=new CouchDocumentEditor(opts);return editor;},cancelDocumentForm:function(opts){if(null!=this.currentEditor){this.currentEditor.performCancellation(opts);this.currentEditor=null;};},setPanelName:function(panelName){this.panelName=panelName;},setSchemas:function(schemas){this.options.schema=schemas;},getInitialLayerIds:function(){return this.initialLayers;},setInitialLayerIds:function(layerIds){this.initialLayers=layerIds;},_handle:function(m){if('editInitiate'===m.type){if(m.feature){this._showAttributeForm(m.feature);}else{this.showDocumentForm(m.doc);};}else if('editCancel'===m.type){this.cancelDocumentForm();}else if(null!=this.currentEditor){this.currentEditor._handle(m);};}});var SchemaEditor=$n2.Class({doc:null,schema:null,$div:null,onChanged:null,formEditor:null,postProcessFns:null,showService:null,initialize:function(opts_){var opts=$n2.extend({doc:null,schema:null,$div:null,onChanged:function(){},funcMap:null,postProcessFns:null,showService:null},opts_);var _this=this;this.doc=opts.doc;this.schema=opts.schema;this.$div=opts.$div;this.onChanged=opts.onChanged;this.postProcessFns=opts.postProcessFns;this.showService=opts.showService;this.formEditor=this.schema.form(this.doc,this.$div,{},function(){var showService=_this.showService;if(showService){showService.fixElementAndChildren(_this.$div,{},_this.doc);};_this.onChanged();},opts.funcMap);var showService=this.showService;if(showService){showService.fixElementAndChildren(this.$div,{},this.doc);};this._performPostProcess();},refresh:function(){this.formEditor.refresh();var showService=this.showService;if(showService){showService.fixElementAndChildren(this.$div,{},this.doc);};this._performPostProcess();},_performPostProcess:function(){for(var i=0,e=this.postProcessFns.length;i<e;++i){var fn=this.postProcessFns[i];if(typeof(fn)==='function'){fn(this.doc,this.$div);};};}});var _defaultOnChanged=function(){};var SchemaEditorService=$n2.Class({documentSource:null,showService:null,searchService:null,dispatchService:null,dialogService:null,funcMap:null,postProcessFunctions:null,documentSource:null,initialize:function(opts_){var opts=$n2.extend({postProcessFn:null,documentSource:null,showService:null,searchService:null,dispatchService:null,dialogService:null},opts_);var _this=this;this.postProcessFunctions=[];this.documentSource=opts.documentSource;this.showService=opts.showService;this.searchService=opts.searchService;this.dispatchService=opts.dispatchService;this.dialogService=opts.dialogService;this.funcMap={};if(this.dialogService){this.funcMap=this.dialogService.getFunctionMap();};if(opts.postProcessFn){this.postProcessFunctions.push(opts.postProcessFn);};},editDocument:function(opts_){var opts=$n2.extend({doc:null,schema:null,$div:null,onChanged:_defaultOnChanged},opts_);var editor=new SchemaEditor({doc:opts.doc,schema:opts.schema,$div:opts.$div,onChanged:opts.onChanged,funcMap:this.funcMap,postProcessFns:this.postProcessFunctions,showService:this.showService});return editor;},addPostProcessFunction:function(fn){if(typeof(fn)==='function'){this.postProcessFunctions.push(fn);};}});var AttachmentEditor=$n2.Class({doc:null,elemId:null,documentSource:null,uploadService:null,onChangedFn:null,creationAttachmentNames:null,compulsoryAttachmentNames:null,disableAddFile:null,disableRemoveFile:null,initialize:function(opts_){var opts=$n2.extend({doc:null,elem:null,documentSource:null,uploadService:null,onChangedFn:function(){},disableAddFile:false,disableRemoveFile:false},opts_);this.doc=opts.doc;this.documentSource=opts.documentSource;this.uploadService=opts.uploadService;this.onChangedFn=opts.onChangedFn;this.disableAddFile=opts.disableAddFile;this.disableRemoveFile=opts.disableRemoveFile;this.creationAttachmentNames=[];this.compulsoryAttachmentNames=[];var $elem=$(opts.elem);$elem.addClass('attachmentEditor');this.elemId=$n2.utils.getElementIdentifier($elem);var compulsory=true;if(this.doc&&!this.doc._rev&&this.doc.nunaliit_attachments){if(typeof this.doc.nunaliit_attachments._compulsory!=='undefined'){compulsory=this.doc.nunaliit_attachments._compulsory;};if(this.doc.nunaliit_attachments.files){for(var attName in this.doc.nunaliit_attachments.files){var att=this.doc.nunaliit_attachments.files[attName];var attCompulsory=compulsory;if(typeof att._compulsory!=='undefined'){attCompulsory=att._compulsory;};this.creationAttachmentNames.push(attName);if(attCompulsory){this.compulsoryAttachmentNames.push(attName);};att.attachmentName=attName;att.status="waiting for upload";if(!att.data){att.data={};};};};};this.refresh();},refresh:function(){var $elem=this._getElem();if($elem.length<1)return;var _this=this;var attachments={};if(this.doc.nunaliit_attachments&&this.doc.nunaliit_attachments.files){for(var attName in this.doc.nunaliit_attachments.files){var att=this.doc.nunaliit_attachments.files[attName];attachments[attName]=att;};};var discountAttNames=[];for(var attName in attachments){var att=attachments[attName];var sourceName=att.source;if(sourceName&&attachments[sourceName]){discountAttNames.push(attName);};};for(var i=0,e=discountAttNames.length;i<e;++i){var attName=discountAttNames[i];delete attachments[attName];};var attNames=[];for(var attName in attachments){attNames.push(attName);};attNames.sort();$elem.find('.attachmentEditor_att').each(function(){var $div=$(this);var attName=$div.attr('n2AttName');if(!attName){$div.remove();}else if(!attachments[attName]){$div.remove();};});for(var i=0,e=attNames.length;i<e;++i){var attName=attNames[i];var className='attachmentEditor_att_'+$n2.utils.stringToHtmlId(attName);var $div=$elem.find('.'+className);if($div.length<1){var label=_loc('File');if(this.creationAttachmentNames.indexOf(attName)>=0){this._addCreationAttachmentElement({attName:attName,label:label});}else if(!this.disableRemoveFile){this._addFileElement({attName:attName,label:label});};};};},printButtons:function(opts_){var opts=$n2.extend({elem:null,classNames:null},opts_);var _this=this;if(this.disableAddFile){return;};var $elem=$(opts.elem);var attachBtn=$('<button>').text(_loc('Add File')).appendTo($elem).click(function(){_this._openAddFileDialog();return false;});if(opts.classNames){attachBtn.addClass(opts.classNames);};attachBtn.button({icons:{primary:'ui-icon-plusthick'}});},performPreSavingActions:function(opts_){var opts=$n2.extend({onSuccess:function(){},onError:function(err){}},opts_);var _this=this;var documentSource=this.documentSource;var $elem=this._getElem();var missingAttachment=null;for(var i=0,e=this.compulsoryAttachmentNames.length;i<e;++i){var attName=this.compulsoryAttachmentNames[i];var $form=$elem.find('.attachmentEditor_att_'+$n2.utils.stringToHtmlId(attName));var $file=$form.find('input[type="file"]');var fileName=$file.val();if(!fileName){missingAttachment=attName;};};if(missingAttachment){opts.onError(_loc('A file must be selected'));return;};var $forms=$elem.find('form');var formCount=$forms.length;if(formCount<1){opts.onSuccess();return;};var uuids=[];getUuids();function getUuids(){if(uuids.length>=formCount){onUuids();}else{documentSource.getUniqueIdentifier({onSuccess:function(uuid){uuids.push(uuid);getUuids();},onError:function(err){opts.onError(_loc('Unable to reach server: {err}',{err:err}));}});};};function onUuids(){var doc=_this.doc;$forms.each(function(){var $form=$(this);var attName=$form.attr('n2AttName');var uuid=uuids.pop();var att=null;if(doc&&doc.nunaliit_attachments&&doc.nunaliit_attachments.files){att=doc.nunaliit_attachments.files[attName];};if(att){att.uploadId=uuid;if(doc._id){$('<input type="hidden">').attr('name','id').attr('value',doc._id).prependTo($form);};if(doc._rev){$('<input type="hidden">').attr('name','rev').attr('value',doc._rev).prependTo($form);};if(uuid){$('<input type="hidden">').attr('name','uploadId').attr('value',uuid).prependTo($form);};}else{$form.remove();};});opts.onSuccess();};},performPostSavingActions:function(opts_){var opts=$n2.extend({onSuccess:function(doc){},onError:function(err){}},opts_);var _this=this;var $elem=this._getElem();var $forms=$elem.find('form');var formCount=$forms.length;if(formCount<1){opts.onSuccess();return;};var $form=$forms.first();var attName=$form.attr('n2AttName');var uploadId=null;var att=null;if(this.doc&&this.doc.nunaliit_attachments&&this.doc.nunaliit_attachments.files&&attName&&this.doc.nunaliit_attachments.files[attName]){att=this.doc.nunaliit_attachments.files[attName];uploadId=att.uploadId;};var $fileInput=$form.find('input[type="file"]');var filename=$fileInput.val();if(!filename||!att||!uploadId){$form.remove();continueUpload();}else{this.uploadService.submitForm({form:$form,suppressInformationDialog:true,onSuccess:function(){$form.remove();continueUpload();},onError:function(err){opts.onError(_loc('Unable to upload file. Cause: {err}',{err:err}));}});};function continueUpload(){_this.performPostSavingActions(opts_);};},_getElem:function(){return $('#'+this.elemId);},_openAddFileDialog:function(){var _this=this;var $elem=this._getElem();if($elem.length<1){return;};var dialogId=$n2.getUniqueId();var addFileFormId=$n2.getUniqueId();var $addFileDialog=$('<div>').attr('id',dialogId).addClass('attachmentEditor_dialog');var $content=$('<div>').addClass('attachmentEditor_dialog_content').appendTo($addFileDialog);var $addFileForm=$('<form>').attr('id',addFileFormId).addClass('attachmentEditor_form').appendTo($content);$('<input type="file">').attr('name','media').appendTo($addFileForm);var $buttons=$('<div>').addClass('attachmentEditor_dialog_buttons').appendTo($addFileDialog);var $addBtn=$('<button>').text(_loc('Attach')).appendTo($buttons).click(function(){var $addFileDialog=$('#'+dialogId);var $addFileForm=$('#'+addFileFormId);var $input=$addFileForm.find('input');var filename=$input.val();if(filename){_this._addFileForm($addFileForm);$addFileDialog.dialog('close');}else{alert(_loc('You must select a file'));};return false;});$addBtn.button({icons:{primary:'ui-icon-plusthick'}});var $cancelBtn=$('<button>').text(_loc('Cancel')).appendTo($buttons).click(function(){var $addFileDialog=$('#'+dialogId);$addFileDialog.dialog('close');return false;});$cancelBtn.button({icons:{primary:'ui-icon-cancel'}});$addFileDialog.dialog({autoOpen:true,title:_loc('Add File'),modal:true,width:740,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}});},_addFileForm:function($addFileForm){if(!this.doc){return;};if(!this.doc.nunaliit_attachments){this.doc.nunaliit_attachments={nunaliit_type:'attachment_descriptions',files:{}};};if(!this.doc.nunaliit_attachments.files){this.doc.nunaliit_attachments.files={};};var attName='media';if(this.doc.nunaliit_attachments.files[attName]){var prefix='media_';var count=0;while(this.doc.nunaliit_attachments.files[attName]){++count;attName=prefix+count;if(count>100){$n2.log('Unable to compute attachment name for new attachment');return;};};};this.doc.nunaliit_attachments.files[attName]={attachmentName:attName,status:"waiting for upload",data:{}};$addFileForm.attr('n2AttName',attName);$addFileForm.addClass('attachmentEditor_form');this._addFileElement({attName:attName,label:_loc('New File'),form:$addFileForm});this.onChangedFn();},_removeAttachment:function(attName){var docChanged=false;var derivedNames=[];if(this.doc&&this.doc.nunaliit_attachments&&this.doc.nunaliit_attachments.files){if(this.doc.nunaliit_attachments.files[attName]){delete this.doc.nunaliit_attachments.files[attName];docChanged=true;};for(var otherName in this.doc.nunaliit_attachments.files){var att=this.doc.nunaliit_attachments.files[otherName];if(attName===att.source){derivedNames.push(otherName);};};for(var i=0,e=derivedNames.length;i<e;++i){var derivedName=derivedNames[i];delete this.doc.nunaliit_attachments.files[derivedName];docChanged=true;};var count=0;for(otherName in this.doc.nunaliit_attachments.files){++count;};if(count<1){delete this.doc.nunaliit_attachments;};};if(this.doc&&this.doc._attachments){if(this.doc._attachments[attName]){delete this.doc._attachments[attName];docChanged=true;};for(var i=0,e=derivedNames.length;i<e;++i){var derivedName=derivedNames[i];if(this.doc._attachments[derivedName]){delete this.doc._attachments[derivedName];docChanged=true;};};};if(docChanged){this.refresh();this.onChangedFn();};},_addCreationAttachmentElement:function(opts_){var opts=$n2.extend({attName:null,label:null},opts_);var _this=this;var $elem=this._getElem();var attName=opts.attName;var className='attachmentEditor_att_'+$n2.utils.stringToHtmlId(attName);var $div=$('<div>').addClass('attachmentEditor_att').addClass(className).attr('n2AttName',attName).appendTo($elem);var $form=$('<form>').addClass('attachmentEditor_creationForm').attr('n2AttName',attName).appendTo($div);$('<span>').addClass('attachmentEditor_label').text(opts.label).appendTo($form);$('<input type="file">').attr('name','media').appendTo($form);},_addFileElement:function(opts_){var opts=$n2.extend({attName:null,label:null,form:null},opts_);var _this=this;var $elem=this._getElem();var attName=opts.attName;var className='attachmentEditor_att_'+$n2.utils.stringToHtmlId(attName);var $div=$('<div>').addClass('attachmentEditor_att').addClass(className).attr('n2AttName',attName).appendTo($elem);$('<span>').addClass('attachmentEditor_label').text(opts.label).appendTo($div);if(opts.form){var fileName=opts.form.find('input[type="file"]').val();if(fileName){var index=fileName.lastIndexOf('/');if(index>=0){fileName=fileName.substr(index+1);};};if(fileName){var index=fileName.lastIndexOf('\\');if(index>=0){fileName=fileName.substr(index+1);};};$('<span>').addClass('attachmentEditor_attName').text(fileName).appendTo($div);}else{$('<span>').addClass('attachmentEditor_attName').text(attName).appendTo($div);};$('<a>').attr('href','#').attr('n2AttName',attName).addClass('attachmentEditor_delete').text(_loc('Remove')).appendTo($div).click(function(){var $a=$(this);var attName=$a.attr('n2AttName');if(attName){_this._removeAttachment(attName);};return false;});if(opts.form){opts.form.appendTo($div);};}});$n2.CouchEditor={Editor:CouchEditor,SchemaEditorService:SchemaEditorService,CouchSimpleDocumentEditor:CouchSimpleDocumentEditor,Constants:{ALL_SCHEMAS:{},FORM_EDITOR:{},TREE_EDITOR:{},SLIDE_EDITOR:{},RELATION_EDITOR:{}},AttachmentEditor:AttachmentEditor};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchRelatedDoc';var CreateDocWidget=$n2.Class({elemId:null,schemaNames:null,allSchemas:null,label:null,dialogPrompt:null,createDocProcess:null,initialize:function(opts_){var opts=$n2.extend({elem:null,schemaNames:null,allSchemas:false,label:null,dialogPrompt:null,createDocProcess:null},opts_);this.createDocProcess=opts.createDocProcess;this.schemaNames=opts.schemaNames;this.allSchemas=opts.allSchemas;this.label=opts.label;this.dialogPrompt=opts.dialogPrompt;this.elemId=$n2.utils.getElementIdentifier(opts.elem);if(!this.label){this.label=_loc('Create Document');};this._refresh();},_getElem:function(){return $('#'+this.elemId);},_refresh:function(){var _this=this;var $elem=this._getElem();$elem.empty();$('<button>').text(this.label).appendTo($elem).click(function(){_this._createDocClicked();});},_createDocClicked:function(){this.createDocProcess.createDocumentFromSchemaNames({schemaNames:this.schemaNames,allSchemas:this.allSchemas,prompt:this.dialogPrompt});}});var Editor=$n2.Class({documentSource:null,uploadService:null,showService:null,dialogService:null,obj:null,schema:null,prompt:null,onSuccess:null,onError:null,onCancel:null,diagId:null,attachmentUploadHandler:null,initialize:function(opts_){var opts=$n2.extend({documentSource:null,uploadService:null,showService:null,dialogService:null,obj:null,schema:null,prompt:null,onSuccess:function(docId){},onError:$n2.reportErrorForced,onCancel:function(){}},opts_);this.documentSource=opts.documentSource;this.uploadService=opts.uploadService;this.showService=opts.showService;this.dialogService=opts.dialogService;this.schema=opts.schema;this.prompt=opts.prompt;this.onSuccess=opts.onSuccess;this.onError=opts.onError;this.onCancel=opts.onCancel;this.obj={};for(var key in opts.obj){if('__n2Source'===key){}else{this.obj[key]=opts.obj[key];};};var _this=this;var diagId=$n2.getUniqueId();this.diagId=diagId;var $dialog=$('<div>').attr('id',diagId).addClass('n2RelatedDoc_dialog').appendTo($('body'));var obj=this.obj;var schema=this.schema;var funcMap={};if(this.dialogService){funcMap=this.dialogService.getFunctionMap();};var $form=$('<div></div>');$dialog.append($form);schema.form(obj,$form,null,function(){if(_this.showService){_this.showService.fixElementAndChildren($form,{},obj);};},funcMap);if(this.showService){this.showService.fixElementAndChildren($form,{},obj);};var $fileElement=$('<div></div>');$dialog.append($fileElement);this.attachmentUploadHandler=new $n2.CouchEditor.AttachmentEditor({doc:obj,elem:$fileElement,documentSource:this.documentSource,uploadService:this.uploadService,disableAddFile:true,disableRemoveFile:true});var $ok=$('<button></button>');$ok.text(_loc('OK'));$ok.button({icons:{primary:'ui-icon-check'}});$dialog.append($ok);$ok.click(function(){_this._clickOK();return false;});var $cancel=$('<button></button>');$cancel.text(_loc('Cancel'));$cancel.button({icons:{primary:'ui-icon-cancel'}});$dialog.append($cancel);$cancel.click(function(){_this._clickCancel();return false;});var dialogOptions={autoOpen:true,title:_loc('Fill Out Related Document'),modal:true,width:740,close:function(event,ui){var diag=$('#'+diagId);diag.remove();}};$dialog.dialog(dialogOptions);},_clickOK:function(){var _this=this;var obj=this.obj;this.attachmentUploadHandler.performPreSavingActions({doc:obj,documentSource:this.documentSource,onSuccess:function(){_this._saveObj();},onError:function(err){alert(err);}});},_clickCancel:function(){$('#'+this.diagId).dialog('close');this.onCancel();},_saveObj:function(){var _this=this;var obj=this.obj;$n2.couchDocument.adjustDocument(obj);this.documentSource.createDocument({doc:obj,onSuccess:function(updatedDoc){_this._uploadFile(updatedDoc);},onError:function(err){_this.onError(_loc('Unable to reach database to submit document: {err}',{err:err}));}});},_uploadFile:function(doc){var _this=this;this.attachmentUploadHandler.performPostSavingActions({doc:doc,onSuccess:function(){_this._success(doc._id);},onError:function(err){_this.onError(_loc('Error occurred after related document was created. Error: {err}',{err:err}));}});},_success:function(docId){$('#'+this.diagId).dialog('close');this.onSuccess(docId);}});var CreateRelatedDocProcess=$n2.Class({documentSource:null,schemaRepository:null,uploadService:null,showService:null,authService:null,dialogService:null,initialize:function(opts_){var opts=$n2.extend({documentSource:null,schemaRepository:null,dispatchService:null,uploadService:null,showService:null,authService:null,dialogService:null,dispatchService:null},opts_);this.documentSource=opts.documentSource;this.schemaRepository=opts.schemaRepository;this.uploadService=opts.uploadService;this.showService=opts.showService;this.authService=opts.authService;this.dialogService=opts.dialogService;this.dispatchService=opts.dispatchService;},getCreateWidget:function(opts_){var opts=$n2.extend({elem:null,schemaNames:null,allSchemas:false,label:null,dialogPrompt:null},opts_);return new CreateDocWidget({elem:opts.elem,schemaNames:opts.schemaNames,allSchemas:opts.allSchemas,label:opts.label,dialogPrompt:opts.dialogPrompt,createDocProcess:this});},createDocumentFromSchema:function(opt_){var _this=this;var authService=this.authService;if(authService&&false==authService.isLoggedIn()){authService.showLoginForm({onSuccess:function(result,options){_this.createDocumentFromSchema(opt_);}});return;};var opt=$n2.extend({schema:null,relatedDoc:null,originDocId:null,prompt:null,onSuccess:function(docId){},onError:$n2.reportErrorForced,onCancel:function(){}},opt_);if(opt.schema&&opt.schema.isSchema){}else{opt.onError(_loc('A valid schema must be provided'));return;};this.uploadService.checkWelcome({onSuccess:uploadServiceAvailable,onError:function(err){alert(_loc('Upload service can not be reached. Unable to submit a related document.'));}});function uploadServiceAvailable(){var obj=opt.schema.createObject();if(opt.relatedDoc){obj.nunaliit_source={nunaliit_type:'reference',doc:opt.relatedDoc._id,category:'attachment'};};if(opt.originDocId){obj.nunaliit_origin={nunaliit_type:'reference',doc:opt.originDocId};};_this._dispatch({type:'preDocCreation',doc:obj,relatedDoc:opt.relatedDoc});var prompt=opt.prompt;if(!prompt){if(opt.originDocId){prompt=_loc('Fill Out Reply');}else if(opt.relatedDoc){prompt=_loc('Fill Out Related Document');}else{prompt=_loc('Fill out content of new document');};};new Editor({documentSource:_this.documentSource,uploadService:_this.uploadService,showService:_this.showService,dialogService:_this.dialogService,obj:obj,schema:opt.schema,prompt:prompt,onSuccess:opt.onSuccess,onError:opt.onError,onCancel:opt.onCancel});};},createDocumentFromSchemaNames:function(opt_){var _this=this;var authService=this.authService;if(authService&&false==authService.isLoggedIn()){authService.showLoginForm({onSuccess:function(result,options){_this.createDocumentFromSchemaNames(opt_);}});return;};var opt=$n2.extend({schemaNames:[],allSchemas:false,relatedDoc:null,originDocId:null,prompt:null,onSuccess:function(docId){},onError:$n2.reportErrorForced,onCancel:function(){}},opt_);if(opt.allSchemas){this.dialogService.selectSchema({onSelected:selectedSchema,onError:opt.onError,onReset:opt.onCancel});}else{this.dialogService.selectSchemaFromNames({schemaNames:opt.schemaNames,onSelected:selectedSchema,onError:opt.onError,onReset:opt.onCancel});};function selectedSchema(schema){_this.createDocumentFromSchema({schema:schema,relatedDoc:opt.relatedDoc,originDocId:opt.originDocId,prompt:opt.prompt,onSuccess:opt.onSuccess,onError:opt.onError,onCancel:opt.onCancel});};},replyToDocument:function(opt_){var _this=this;var authService=this.authService;if(authService&&false==authService.isLoggedIn()){authService.showLoginForm({onSuccess:function(result,options){_this.replyToDocument(opt_);}});return;};var opt=$n2.extend({doc:null,schema:null,originDocId:null,onSuccess:function(docId){},onError:$n2.reportErrorForced,onCancel:function(){}},opt_);if(opt.schema&&opt.schema.isSchema){}else{opt.onError(_loc('A valid schema must be provided'));return;};var originDocId=null;if(opt.originDocId){originDocId=opt.originDocId;}else if(opt.doc.nunaliit_origin&&opt.doc.nunaliit_origin.doc){originDocId=opt.doc.nunaliit_origin.doc;}else if(opt.doc.nunaliit_source&&opt.doc.nunaliit_source.doc){originDocId=opt.doc.nunaliit_source.doc;};this.createDocumentFromSchema({schema:opt.schema,relatedDoc:opt.doc,originDocId:originDocId,onSuccess:opt.onSuccess,onError:opt.onError,onCancel:opt.onCancel});},_dispatch:function(msg){if(this.dispatchService){this.dispatchService.synchronousCall(DH,msg);};}});$n2.couchRelatedDoc={CreateRelatedDocProcess:CreateRelatedDocProcess};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchDisplay';function docCreationTimeSort(lhs,rhs){var timeLhs=0;var timeRhs=0;if(lhs&&lhs.doc&&lhs.doc.nunaliit_created&&lhs.doc.nunaliit_created.time){timeLhs=lhs.doc.nunaliit_created.time;}
if(rhs&&rhs.doc&&rhs.doc.nunaliit_created&&rhs.doc.nunaliit_created.time){timeRhs=rhs.doc.nunaliit_created.time;}
if(timeLhs<timeRhs)return-1;if(timeLhs>timeRhs)return 1;return 0;};function startsWith(s,prefix){var left=s.substr(0,prefix.length);return(left===prefix);};function boolOption(optionName,options,customService){var flag=false;if(options[optionName]){flag=true;};if(customService&&!flag){var o=customService.getOption(optionName);if(o){flag=true;};};return flag;};var Display=$n2.Class({options:null,documentSource:null,displayPanelName:null,currentFeature:null,createRelatedDocProcess:null,defaultSchema:null,displayRelatedInfoProcess:null,displayOnlyRelatedSchemas:null,displayBriefInRelatedInfo:null,restrictAddRelatedButtonToLoggedIn:null,restrictReplyButtonToLoggedIn:null,classDisplayFunctions:null,showService:null,uploadService:null,customService:null,authService:null,requestService:null,dispatchService:null,schemaRepository:null,initialize:function(opts_){var _this=this;var opts=$n2.extend({documentSource:null,displayPanelName:null,showService:null,uploadService:null,createDocProcess:null,serviceDirectory:null,displayRelatedInfoFunction:null,displayRelatedInfoProcess:null,classDisplayFunctions:{},displayOnlyRelatedSchemas:false,displayBriefInRelatedInfo:false,restrictAddRelatedButtonToLoggedIn:false,restrictReplyButtonToLoggedIn:false},opts_);this.documentSource=opts.documentSource;this.displayPanelName=opts.displayPanelName;this.uploadService=opts.uploadService;this.classDisplayFunctions=opts.classDisplayFunctions;this.createRelatedDocProcess=opts.createDocProcess;if(opts.serviceDirectory){this.showService=opts.serviceDirectory.showService;this.customService=opts.serviceDirectory.customService;this.authService=opts.serviceDirectory.authService;this.requestService=opts.serviceDirectory.requestService;this.schemaRepository=opts.serviceDirectory.schemaRepository;this.dispatchService=opts.serviceDirectory.dispatchService;};if(!this.showService){this.showService=opts.showService;};this.displayOnlyRelatedSchemas=boolOption('displayOnlyRelatedSchemas',opts,this.customService);this.displayBriefInRelatedInfo=boolOption('displayBriefInRelatedInfo',opts,this.customService);this.restrictAddRelatedButtonToLoggedIn=boolOption('restrictAddRelatedButtonToLoggedIn',opts,this.customService);this.restrictReplyButtonToLoggedIn=boolOption('restrictReplyButtonToLoggedIn',opts,this.customService);var customService=this.customService;var dispatcher=this.dispatchService;if(dispatcher){var f=function(msg){_this._handleDispatch(msg);};dispatcher.register(DH,'selected',f);dispatcher.register(DH,'searchResults',f);dispatcher.register(DH,'documentDeleted',f);dispatcher.register(DH,'authLoggedIn',f);dispatcher.register(DH,'authLoggedOut',f);dispatcher.register(DH,'editClosed',f);dispatcher.register(DH,'documentContentCreated',f);dispatcher.register(DH,'documentContentUpdated',f);};if(this.requestService){this.requestService.addDocumentListener(function(doc){_this._refreshDocument(doc);_this._populateWaitingDocument(doc);});};if(opts.displayRelatedInfoProcess){this.displayRelatedInfoProcess=opts.displayRelatedInfoProcess;};if(!this.displayRelatedInfoProcess&&opts.displayRelatedInfoFunction){this.displayRelatedInfoProcess=new LegacyDisplayRelatedFunctionAdapter(opts.displayRelatedInfoFunction);};if(!this.displayRelatedInfoProcess&&customService){var displayRelatedProcess=customService.getOption('displayRelatedInfoProcess');if(displayRelatedProcess){this.displayRelatedInfoProcess=displayRelatedProcess;};};if(!this.displayRelatedInfoProcess&&customService){var displayRelatedFn=customService.getOption('displayRelatedInfoFunction');if(typeof displayRelatedFn==='function'){this.displayRelatedInfoProcess=new LegacyDisplayRelatedFunctionAdapter(displayRelatedFn);};};if(!this.displayRelatedInfoProcess){if(this.displayOnlyRelatedSchemas){this.displayRelatedInfoProcess=new LegacyDisplayRelatedFunctionAdapter(DisplayRelatedInfo);}else{this.displayRelatedInfoProcess=new LegacyDisplayRelatedFunctionAdapter(DisplayLinkedInfo);};};},setSchema:function(schema){this.defaultSchema=schema;},_displayDocument:function($set,doc){var _this=this;$set.empty();this._displayObject($set,doc,{onUpdated:function(){_this._displayDocument($set,doc);},onDeleted:function(){$set.empty();}});},_shouldSuppressNonApprovedMedia:function(){return this.showService.eliminateNonApprovedMedia;},_shouldSuppressDeniedMedia:function(){return this.showService.eliminateDeniedMedia;},_getDisplayDiv:function(){var divId=this.displayPanelName;return $('#'+divId);},_displayObject:function($side,data,opt_){var _this=this;var opt=$n2.extend({onUpdated:function(){},onDeleted:function(){},suppressContributionReferences:false,showContributionReplyButton:false,showAddContributionButton:false,showRelatedContributions:false},opt_);var docId=data._id;var $elem=$('<div class="couchDisplay_'+$n2.utils.stringToHtmlId(docId)+'"></div>');$side.append($elem);var $sElem=$('<div class="n2s_handleHover"></div>');$elem.append($sElem);this.showService.displayDocument($sElem,{onDisplayed:onDisplayed},data);if(data.nunaliit_schema){var schemaRepository=_this.schemaRepository;if(schemaRepository){schemaRepository.getSchema({name:data.nunaliit_schema,onSuccess:function(schema){continueDisplay(schema);},onError:function(){continueDisplay(null);}});}else{continueDisplay(null);};}else{continueDisplay(null);};function continueDisplay(schema){_this._addAttachmentProgress($elem,data);_this._addButtons($elem,data,{schema:schema,related:true,reply:true,geom:true,edit:true,'delete':true,addLayer:true,treeView:true});var $div=$('<div>').addClass('n2Display_relatedInfo couchDisplayRelated_'+$n2.utils.stringToHtmlId(data._id)).appendTo($elem);var relatedInfoId=$n2.utils.getElementIdentifier($div);_this.displayRelatedInfoProcess.display({divId:relatedInfoId,display:_this,doc:data,schema:schema});};function onDisplayed($sElem,data,schema,opt_){if(_this.classDisplayFunctions){for(var className in _this.classDisplayFunctions){var fn=_this.classDisplayFunctions[className];var jqCallback=eachFunctionForClass(className,fn,data,opt);$sElem.find('.'+className).each(jqCallback);};};};function eachFunctionForClass(className,fn,data,opt){return function(){var $jq=$(this);fn(data,$jq,opt);$jq.removeClass(className);};};},_addButtons:function($elem,data,opt_){var _this=this;var opt=$n2.extend({schema:null,focus:false,related:false,reply:false,geom:false,edit:false,'delete':false,addLayer:false,treeView:false},opt_);var $buttons=$('<div></div>');$buttons.addClass('n2Display_buttons');$buttons.addClass('n2Display_buttons_'+$n2.utils.stringToHtmlId(data._id));$elem.append($buttons);var optionClass='options';if(opt.focus)optionClass+='_focus';if(opt.edit)optionClass+='_edit';if(opt.related)optionClass+='_related';if(opt.reply)optionClass+='_reply';if(opt.geom)optionClass+='_geom';if(opt['delete'])optionClass+='_delete';if(opt.addLayer)optionClass+='_addLayer';if(opt.treeView)optionClass+='_treeView';$buttons.addClass(optionClass);var opts={doc:data,schema:opt.schema,focus:opt.focus,edit:opt.edit,related:opt.related,reply:opt.reply,geom:opt.geom,addLayer:opt.addLayer,treeView:opt.treeView};opts['delete']=opt['delete'];this._displayButtons($buttons,opts);},_refreshButtons:function($elem){var _this=this;var docId=null;var fFocus=false;var fEdit=false;var fRelated=false;var fReply=false;var fGeom=false;var fDelete=false;var fAddLayer=false;var fTreeView=false;var classAttr=$elem.attr('class');var classes=classAttr.split(' ');for(var i=0,e=classes.length;i<e;++i){var className=classes[i];if(startsWith(className,'n2Display_buttons_')){var escapedDocId=className.substr('n2Display_buttons_'.length);docId=$n2.utils.unescapeHtmlId(escapedDocId);}else if(startsWith(className,'options')){var options=className.split('_');for(var j=0,k=options.length;j<k;++j){var o=options[j];if('focus'===o){fFocus=true;}
else if('edit'===o){fEdit=true;}
else if('related'===o){fRelated=true;}
else if('reply'===o){fReply=true;}
else if('geom'===o){fGeom=true;}
else if('addLayer'===o){fAddLayer=true;}
else if('treeView'===o){fTreeView=true;}
else if('delete'===o){fDelete=true;};};};};if(docId){this.documentSource.getDocument({docId:docId,onSuccess:getSchema,onError:function(){}});};function getSchema(doc){if(doc.nunaliit_schema){var schemaRepository=_this.schemaRepository;if(schemaRepository){schemaRepository.getSchema({name:doc.nunaliit_schema,onSuccess:function(schema){drawButtons(doc,schema);},onError:function(){drawButtons(doc,null);}});}else{drawButtons(doc,null);};}else{drawButtons(doc,null);};};function drawButtons(doc,schema){var opts={doc:doc,schema:schema,focus:fFocus,edit:fEdit,related:fRelated,reply:fReply,geom:fGeom,addLayer:fAddLayer,treeView:fTreeView};opts['delete']=fDelete;$elem.empty();_this._displayButtons($elem,opts);};},_displayButtons:function($buttons,opt){var _this=this;var data=opt.doc;var schema=opt.schema;var dispatcher=this.dispatchService;var schemaRepository=_this.schemaRepository;if(opt.focus&&data&&data._id){var $focusButton=$('<a href="#"></a>');var focusText=_loc('More Info');$focusButton.text(focusText);$buttons.append($focusButton);$focusButton.click(function(){_this._dispatch({type:'userSelect',docId:data._id})
return false;});addClasses($focusButton,focusText);};if(opt.edit&&$n2.couchMap.canEditDoc(data)){var $editButton=$('<a href="#"></a>');var editText=_loc('Edit');$editButton.text(editText);$buttons.append($editButton);$editButton.click(function(){_this._performDocumentEdit(data,opt);return false;});addClasses($editButton,editText);};if(opt['delete']&&$n2.couchMap.canDeleteDoc(data)){var $deleteButton=$('<a href="#"></a>');var deleteText=_loc('Delete');$deleteButton.text(deleteText);$buttons.append($deleteButton);$deleteButton.click(function(){_this._performDocumentDelete(data,opt);return false;});addClasses($deleteButton,deleteText);};if(opt.related&&this.displayRelatedInfoProcess){this.displayRelatedInfoProcess.addButton({display:this,div:$buttons[0],doc:data,schema:opt.schema});};if(opt.reply&&opt.schema&&opt.schema.options&&opt.schema.options.enableReplies){var showReplyButton=true;if(this.restrictReplyButtonToLoggedIn){var sessionContext=$n2.couch.getSession().getContext();if(!sessionContext||!sessionContext.name){showReplyButton=false;};};if(showReplyButton){var $replyButton=$('<a href="#"></a>');var replyText=_loc('Reply');$replyButton.text(replyText);$buttons.append($replyButton);$replyButton.click(function(){_this._replyToDocument(data,opt.schema);return false;});addClasses($replyButton,'reply');};};if(dispatcher&&opt.geom&&data&&dispatcher.isEventTypeRegistered('findIsAvailable')&&dispatcher.isEventTypeRegistered('find')){var showFindOnMapButton=false;var m={type:'findIsAvailable',doc:data,isAvailable:false};dispatcher.synchronousCall(DH,m);if(m.isAvailable){showFindOnMapButton=true;};if(showFindOnMapButton){var $findGeomButton=$('<a href="#"></a>');var findGeomText=_loc('Find on Map');$findGeomButton.text(findGeomText);$buttons.append($findGeomButton);$findGeomButton.click(function(){_this._dispatch({type:'find',docId:data._id,doc:data});return false;});addClasses($findGeomButton,findGeomText);};};if(opt.addLayer&&data&&data.nunaliit_layer_definition&&dispatcher&&dispatcher.isEventTypeRegistered('addLayerToMap')){var $addLayerButton=$('<a href="#"></a>');var btnText=_loc('Add Layer');$addLayerButton.text(btnText);$buttons.append($addLayerButton);var layerDefinition=data.nunaliit_layer_definition;var layerId=layerDefinition.id;if(!layerId){layerId=data._id;};var layerDef={name:layerDefinition.name,type:'couchdb',options:{layerName:layerId,documentSource:this.documentSource}};$addLayerButton.click(function(){_this._dispatch({type:'addLayerToMap',layer:layerDef,options:{setExtent:{bounds:layerDefinition.bbox,crs:'EPSG:4326'}}});return false;});addClasses($addLayerButton,btnText);};if(opt.treeView&&data){var $treeViewButton=$('<a>').attr('href','#').text(_loc('Tree View')).appendTo($buttons).click(function(){_this._performDocumentTreeView(data);return false;});addClasses($treeViewButton,'tree_view');};function addClasses(elem,tag){elem.addClass('nunaliit_form_link');var compactTag=tag;var spaceIndex=compactTag.indexOf(' ');while(-1!==spaceIndex){compactTag=compactTag.slice(0,spaceIndex)+'_'+
compactTag.slice(spaceIndex+1);spaceIndex=compactTag.indexOf(' ');};elem.addClass('nunaliit_form_link_'+compactTag.toLowerCase());};},_addAttachmentProgress:function($elem,data){var $progress=$('<div></div>').addClass('n2Display_attProgress').addClass('n2Display_attProgress_'+$n2.utils.stringToHtmlId(data._id)).appendTo($elem);this._refreshAttachmentProgress($progress,data);},_refreshAttachmentProgress:function($progress,data){var status=null;$progress.empty();if(data.nunaliit_attachments&&data.nunaliit_attachments.files){for(var attName in data.nunaliit_attachments.files){var att=data.nunaliit_attachments.files[attName];if(!att.source){if(att.status&&'attached'!==att.status){if(!status){status={};};status[att.status]=true;};};};};if(status){var $outer=$('<div></div>').addClass('n2Display_attProgress_outer').appendTo($progress);$('<div></div>').addClass('n2Display_attProgress_icon').appendTo($outer);if(status['waiting for approval']){$outer.addClass('n2Display_attProgress_waiting');$('<div></div>').addClass('n2Display_attProgress_message').text(_loc('Attachment is waiting for approval')).appendTo($outer);}else if(status['denied']){$outer.addClass('n2Display_attProgress_denied');$('<div></div>').addClass('n2Display_attProgress_message').text(_loc('Attachment has been denied')).appendTo($outer);}else{$outer.addClass('n2Display_attProgress_busy');$('<div></div>').addClass('n2Display_attProgress_message').text(_loc('Attachment is being processed')).appendTo($outer);};$('<div></div>').addClass('n2Display_attProgress_outer_end').appendTo($outer);};},_addRelatedDocument:function(doc,relatedSchemaNames){var _this=this;this.createRelatedDocProcess.createDocumentFromSchemaNames({schemaNames:relatedSchemaNames,relatedDoc:doc,onSuccess:function(docId){}});},_getAllReferences:function(opts_){var opts=$n2.extend({doc:null,onSuccess:function(refInfo){},onError:function(err){}},opts_);var _this=this;var doc=opts.doc;var refInfo={};var references=[];$n2.couchUtils.extractLinks(doc,references);for(var i=0,e=references.length;i<e;++i){var linkDocId=references[i].doc;if(!refInfo[linkDocId]){refInfo[linkDocId]={};};refInfo[linkDocId].forward=true;};this.documentSource.getReferencesFromId({docId:doc._id,onSuccess:function(refIds){for(var i=0,e=refIds.length;i<e;++i){var id=refIds[i];if(!refInfo[id]){refInfo[id]={};};refInfo[id].reverse=true;};getRefSchemas();},onError:getRefSchemas});function getRefSchemas(){var requestDocIds=[];for(var requestDocId in refInfo){requestDocIds.push(requestDocId);};_this.documentSource.getDocumentInfoFromIds({docIds:requestDocIds,onSuccess:function(infos){for(var i=0,e=infos.length;i<e;++i){var requestDocId=infos[i].id;refInfo[requestDocId].exists=true;if(infos[i].schema){refInfo[requestDocId].schema=infos[i].schema;};};opts.onSuccess(refInfo);},onError:opts.onError});};},_replyToDocument:function(doc,schema){var _this=this;this.createRelatedDocProcess.replyToDocument({doc:doc,schema:schema,onSuccess:function(docId){}});},_refreshDocument:function(doc){var _this=this;var schemaRepository=this.schemaRepository;if(doc.nunaliit_schema&&schemaRepository){schemaRepository.getSchema({name:doc.nunaliit_schema,onSuccess:function(schema){refreshDocWithSchema(doc,schema);},onError:function(){refreshDocWithSchema(doc,null);}});}else{refreshDocWithSchema(doc,null);};function refreshDocWithSchema(doc,schema){var docId=doc._id;$('.displayRelatedButton_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $buttonDiv=$(this);$buttonDiv.empty();_this._addButtons($buttonDiv,doc,{schema:schema,focus:true,geom:true,reply:true,treeView:true});});$('.n2Display_attProgress_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $progress=$(this);_this._refreshAttachmentProgress($progress,doc);});if(_this._shouldSuppressNonApprovedMedia()){if($n2.couchMap.documentContainsMedia(doc)&&false==$n2.couchMap.documentContainsApprovedMedia(doc)){$('.n2SupressNonApprovedMedia_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $div=$(this);var $parent=$div.parent();$div.remove();_this._fixDocumentList($parent);});};}else if(_this._shouldSuppressDeniedMedia()){if($n2.couchMap.documentContainsMedia(doc)&&$n2.couchMap.documentContainsDeniedMedia(doc)){$('.n2SupressDeniedMedia_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $div=$(this);var $parent=$div.parent();$div.remove();_this._fixDocumentList($parent);});};};};},_populateWaitingDocument:function(doc){var _this=this;if(doc){var docId=doc._id;var escaped=$n2.utils.stringToHtmlId(docId);var cName='couchDisplayWait_'+escaped;$('.'+cName).each(function(){var $set=$(this);$set.removeClass(cName).addClass('couchDisplayAdded_'+escaped);_this._displayDocument($set,doc);});};},_fixDocumentList:function($elem){if($elem.hasClass('_n2DocumentListParent')){var $relatedDiv=$elem;}else{$relatedDiv=$elem.parents('._n2DocumentListParent');};if($relatedDiv.length>0){var $docDiv=$relatedDiv.find('._n2DocumentListEntry');var count=$docDiv.length;$relatedDiv.find('._n2DisplayDocCount').text(''+count);$docDiv.each(function(i){var $doc=$(this);$doc.removeClass('olkitSearchMod2_0');$doc.removeClass('olkitSearchMod2_1');$doc.addClass('olkitSearchMod2_'+(i%2));});};},_performDocumentEdit:function(data,options_){var _this=this;this.documentSource.getDocument({docId:data._id,onSuccess:function(doc){_this._dispatch({type:'editInitiate',docId:doc._id,doc:doc});},onError:function(errorMsg){$n2.log('Unable to load document: '+errorMsg);}});},_performDocumentDelete:function(data,options_){var _this=this;if(confirm(_loc('You are about to delete this document. Do you want to proceed?'))){this.documentSource.deleteDocument({doc:data,onSuccess:function(){if(options_.onDeleted){options_.onDeleted();};}});};},_performDocumentTreeView:function(data){new TreeDocumentViewer({doc:data});},_displayDocumentId:function($set,docId){var _this=this;$set.empty();this.documentSource.getDocument({docId:docId,onSuccess:function(doc){_this._displayDocument($set,doc);},onError:function(err){$set.empty();$('<div>').addClass('couchDisplayWait_'+$n2.utils.stringToHtmlId(docId)).text(_loc('Unable to retrieve document')).appendTo($set);}});},_handleDispatch:function(msg){var _this=this;var $div=this._getDisplayDiv();if($div.length<1){dispatcher.deregister(addr);return;};if(msg.type==='selected'){if(msg.doc){this._displayDocument($div,msg.doc);}else if(msg.docId){this._displayDocumentId($div,msg.docId);}else if(msg.docs){this._displayMultipleDocuments($div,msg.docs);}else if(msg.docIds){$div.empty();this._displayMultipleDocumentIds($div,msg.docIds)};}else if(msg.type==='searchResults'){this._displaySearchResults(msg.results);}else if(msg.type==='documentDeleted'){var docId=msg.docId;this._handleDocumentDeletion(docId);}else if(msg.type==='authLoggedIn'||msg.type==='authLoggedOut'){$('.n2Display_buttons').each(function(){var $elem=$(this);_this._refreshButtons($elem);});}else if(msg.type==='editClosed'){var deleted=msg.deleted;if(!deleted){var doc=msg.doc;if(doc){this._displayDocument($div,doc);};};}else if(msg.type==='documentContentCreated'){this._handleDocumentCreation(msg.doc);this._populateWaitingDocument(msg.doc);}else if(msg.type==='documentContentUpdated'){this._refreshDocument(msg.doc);this._populateWaitingDocument(msg.doc);};},_displayMultipleDocuments:function($container,docs){var _this=this;var $list=$('<div class="_n2DocumentListParent"></div>');$container.append($list);for(var i=0,e=docs.length;i<e;++i){var doc=docs[i];var $div=$('<div></div>').addClass('_n2DocumentListEntry').addClass('_n2DocumentListEntry_'+$n2.utils.stringToHtmlId(docId)).addClass('olkitSearchMod2_'+(i%2)).addClass('n2SupressNonApprovedMedia_'+$n2.utils.stringToHtmlId(docId)).addClass('n2SupressDeniedMedia_'+$n2.utils.stringToHtmlId(docId));$list.append($div);var $contentDiv=$('<div class="n2s_handleHover"></div>');$div.append($contentDiv);this.showService.displayBriefDescription($contentDiv,{},doc);var $buttonDiv=$('<div></div>');$div.append($buttonDiv);this._addButtons($buttonDiv,doc,{focus:true,geom:true});};},_displayMultipleDocumentIds:function($container,docIds){var _this=this;var $list=$('<div class="_n2DocumentListParent"></div>');$container.append($list);for(var i=0,e=docIds.length;i<e;++i){var docId=docIds[i];var $div=$('<div></div>').addClass('_n2DocumentListEntry').addClass('_n2DocumentListEntry_'+$n2.utils.stringToHtmlId(docId)).addClass('olkitSearchMod2_'+(i%2)).addClass('n2SupressNonApprovedMedia_'+$n2.utils.stringToHtmlId(docId)).addClass('n2SupressDeniedMedia_'+$n2.utils.stringToHtmlId(docId));$list.append($div);var $contentDiv=$('<div class="n2s_handleHover"></div>');$div.append($contentDiv);this.showService.printBriefDescription($contentDiv,docId);if(this.requestService){var $progressDiv=$('<div class="n2Display_attProgress n2Display_attProgress_'+$n2.utils.stringToHtmlId(docId)+'"></div>');$div.append($progressDiv);var $buttonDiv=$('<div class="displayRelatedButton displayRelatedButton_'+$n2.utils.stringToHtmlId(docId)+'"></div>');$div.append($buttonDiv);this.requestService.requestDocument(docId);};};},_displaySearchResults:function(results){var ids=[];if(results&&results.sorted&&results.sorted.length){for(var i=0,e=results.sorted.length;i<e;++i){ids.push(results.sorted[i].id);};};var $div=this._getDisplayDiv();$div.empty();if(ids.length<1){$div.append($('<div>'+_loc('Search results empty')+'</div>'));}else{var $results=$('<div class="n2_search_result"></div>').appendTo($div);this._displayMultipleDocumentIds($results,ids);};},_dispatch:function(m){var dispatcher=this.dispatchService;if(dispatcher){dispatcher.send(DH,m);};},_handleDocumentDeletion:function(docId){var _this=this;var $elems=$('.couchDisplay_'+$n2.utils.stringToHtmlId(docId));$elems.remove();var $elems=$('.couchDisplayWait_'+$n2.utils.stringToHtmlId(docId));$elems.remove();var $entries=$('._n2DocumentListEntry_'+$n2.utils.stringToHtmlId(docId));$entries.each(function(){var $entry=$(this);var $p=$entry.parent();$entry.remove();_this._fixDocumentList($p);});},_handleDocumentCreation:function(doc){var _this=this;var links=[];$n2.couchUtils.extractLinks(doc,links);for(var i=0,e=links.length;i<e;++i){var refDocId=links[i].doc;if(refDocId){var $elems=$('.couchDisplayRelated_'+$n2.utils.stringToHtmlId(refDocId));if($elems.length>0){refreshRelatedInfo(refDocId,$elems);};};};function refreshRelatedInfo(docId,$elems){var request=_this.requestService;if(request){request.requestDocument(docId,function(d){loadedData(d,$elems);});};};function loadedData(data,$elems){var schemaName=data.nunaliit_schema?data.nunaliit_schema:null;var schemaRepository=_this.schemaRepository;if(schemaName&&schemaRepository){schemaRepository.getSchema({name:schemaName,onSuccess:function(schema){loadedSchema(data,schema,$elems);},onError:function(){loadedSchema(data,null,$elems);}});}else{loadedSchema(data,null,$elems);};};function loadedSchema(data,schema,$elems){$elems.each(function(){var $e=$(this);$e.empty();_this.displayRelatedInfoProcess.display({div:$e,display:_this,doc:data,schema:schema});});};}});var LegacyDisplayRelatedFunctionAdapter=$n2.Class({legacyFunction:null,initialize:function(legacyFunction){this.legacyFunction=legacyFunction;},display:function(opts_){return this.legacyFunction(opts_);},addButton:function(opts_){var opts=$n2.extend({display:null,div:null,doc:null,schema:null},opts_);var display=opts.display;var data=opts.doc;var schema=opts.schema;var $buttons=$(opts.div);var schemaRepository=display.schemaRepository;if(schema&&schema.relatedSchemaNames&&schema.relatedSchemaNames.length){var showRelatedButton=true;if(display.restrictAddRelatedButtonToLoggedIn){var sessionContext=$n2.couch.getSession().getContext();if(!sessionContext||!sessionContext.name){showRelatedButton=false;};};if(showRelatedButton){var selectId=$n2.getUniqueId();var $addRelatedButton=$('<select>').attr('id',selectId).appendTo($buttons);$('<option>').text(_loc('Add Related Item')).val('').appendTo($addRelatedButton);for(var i=0,e=schema.relatedSchemaNames.length;i<e;++i){var schemaName=schema.relatedSchemaNames[i];$('<option>').text(schemaName).val(schemaName).appendTo($addRelatedButton);if(schemaRepository){schemaRepository.getSchema({name:schemaName,onSuccess:function(schema){$('#'+selectId).find('option').each(function(){var $option=$(this);if($option.val()===schema.name){$option.text(schema.getLabel());};});}});};};$addRelatedButton.change(function(){var val=$(this).val();$(this).val('');display._addRelatedDocument(data,[val]);return false;});$addRelatedButton.addClass('nunaliit_form_link');$addRelatedButton.addClass('nunaliit_form_link_add_related_item');$addRelatedButton.menuselector();};};}});function _displayRelatedDocuments(display_,contId,relatedSchemaName,relatedDocIds){var $container=$('#'+contId);if(!relatedDocIds||relatedDocIds.length<1){$container.remove();return;};blindDisplay();function blindDisplay(){var blindId=$n2.getUniqueId();var $blindWidget=$('<div id="'+blindId+'" class="_n2DocumentListParent"><h3></h3><div style="padding-left:0px;padding-right:0px;"></div></div>');$container.append($blindWidget);var bw=$n2.blindWidget($blindWidget,{data:relatedDocIds,onBeforeOpen:beforeOpen});bw.setHtml('<span class="_n2DisplaySchemaName"></span> (<span class="_n2DisplayDocCount"></span>)');if(null==relatedSchemaName){$blindWidget.find('._n2DisplaySchemaName').text(_loc('Uncategorized'));}else{$blindWidget.find('._n2DisplaySchemaName').text(relatedSchemaName);};$blindWidget.find('._n2DisplayDocCount').text(''+relatedDocIds.length);var schemaRepository=display_.schemaRepository;if(schemaRepository&&relatedSchemaName){schemaRepository.getSchema({name:relatedSchemaName,onSuccess:function(schema){var $blindWidget=$('#'+blindId);$blindWidget.find('._n2DisplaySchemaName').text(_loc(schema.getLabel()));}});};function beforeOpen(info){var $div=info.content;var $dataloaded=$div.find('.___n2DataLoaded');if($dataloaded.length>0){return;};var docIds=info.data;$div.empty();$div.append($('<div class="___n2DataLoaded" style="display:none;"></div>'));for(var i=0,e=docIds.length;i<e;++i){var docId=docIds[i];var $docWrapper=$('<div></div>');$div.append($docWrapper);if(0===i){$docWrapper.addClass('_n2DocumentListStart');};if((e-1)===i){$docWrapper.addClass('_n2DocumentListEnd');};$docWrapper.addClass('_n2DocumentListEntry').addClass('_n2DocumentListEntry_'+$n2.utils.stringToHtmlId(docId)).addClass('olkitSearchMod2_'+(i%2)).addClass('n2SupressNonApprovedMedia_'+$n2.utils.stringToHtmlId(docId)).addClass('n2SupressDeniedMedia_'+$n2.utils.stringToHtmlId(docId));var $doc=$('<div></div>');$docWrapper.append($doc);if(display_.showService){if(display_.displayBriefInRelatedInfo){display_.showService.printBriefDescription($doc,docId);}else{display_.showService.printDocument($doc,docId);};}else{$doc.text(docId);};if(display_.requestService){var $progressDiv=$('<div class="n2Display_attProgress n2Display_attProgress_'+$n2.utils.stringToHtmlId(docId)+'"></div>');$docWrapper.append($progressDiv);var $buttonDiv=$('<div class="displayRelatedButton displayRelatedButton_'+$n2.utils.stringToHtmlId(docId)+'"></div>');$docWrapper.append($buttonDiv);display_.requestService.requestDocument(docId);};};};};};function DisplayRelatedInfo(opts_){var opts=$n2.extend({divId:null,div:null,display:null,doc:null,schema:null},opts_);var doc=opts.doc;var docId=doc._id;var display=opts.display;var schema=opts.schema;var $elem=opts.div;if(!$elem){$elem=$('#'+opts.divId);};if(!$elem.length){return;};if(!schema||!schema.relatedSchemaNames||!schema.relatedSchemaNames.length){return;};var schemaInfoByName={};for(var i=0,e=schema.relatedSchemaNames.length;i<e;++i){var relatedSchemaName=schema.relatedSchemaNames[i];schemaInfoByName[relatedSchemaName]={docIds:[]};};display._getAllReferences({doc:doc,onSuccess:showSections});function showSections(refInfo){for(var requestDocId in refInfo){if(refInfo[requestDocId].exists&&refInfo[requestDocId].reverse&&refInfo[requestDocId].schema){var schemaName=refInfo[requestDocId].schema;var schemaInfo=schemaInfoByName[schemaName];if(schemaInfo){schemaInfo.docIds.push(requestDocId);};};};for(var schemaName in schemaInfoByName){var schemaInfo=schemaInfoByName[schemaName];if(schemaInfo.docIds.length>0){var contId=$n2.getUniqueId();var $div=$('<div id="'+contId+'"></div>');$elem.append($div);var relatedDocIds=schemaInfo.docIds;_displayRelatedDocuments(display,contId,schemaName,relatedDocIds);};};};};function DisplayLinkedInfo(opts_){var opts=$n2.extend({divId:null,div:null,display:null,doc:null,schema:null},opts_);var display=opts.display;var doc=opts.doc;var docId=doc._id;var $elem=opts.div;if(!$elem){$elem=$('#'+opts.divId);};if(!$elem.length){return;};display._getAllReferences({doc:doc,onSuccess:showSections});function showSections(refInfo){var relatedDocsFromSchemas={};var uncategorizedDocIds=[];for(var requestDocId in refInfo){if(refInfo[requestDocId].exists){var schemaName=refInfo[requestDocId].schema;if(schemaName){if(!relatedDocsFromSchemas[schemaName]){relatedDocsFromSchemas[schemaName]={docIds:[]};};relatedDocsFromSchemas[schemaName].docIds.push(requestDocId);}else{uncategorizedDocIds.push(requestDocId);};};};for(var schemaName in relatedDocsFromSchemas){var contId=$n2.getUniqueId();var $div=$('<div id="'+contId+'"></div>');$elem.append($div);var relatedDocIds=relatedDocsFromSchemas[schemaName].docIds;_displayRelatedDocuments(display,contId,schemaName,relatedDocIds);};if(uncategorizedDocIds.length>0){var contId=$n2.getUniqueId();var $div=$('<div id="'+contId+'"></div>');$elem.append($div);_displayRelatedDocuments(display,contId,null,uncategorizedDocIds);};};};var CommentRelatedInfo=$n2.Class({commentSchema:null,dispatchService:null,lastDoc:null,lastDivId:null,lastDisplay:null,initialize:function(opts_){var opts=$n2.extend({schema:null,dispatchService:null},opts_);var _this=this;this.commentSchema=opts.schema;this.dispatchService=opts.dispatchService;if(this.dispatchService){var f=function(msg,addr,dispatcher){_this._handleDispatch(msg,addr,dispatcher);};this.dispatchService.register(DH,'documentContent',f);};},display:function(opts_){var opts=$n2.extend({divId:null,div:null,display:null,doc:null,schema:null},opts_);var _this=this;var display=opts.display;var doc=opts.doc;var docId=doc._id;var documentSource=display.documentSource;var showService=display.showService;var $elem=opts.div;if(!$elem){$elem=$('#'+opts.divId);};if(!$elem.length){return;};if(!showService){$n2.log('Show service not available for comment process');return;};this.lastDoc=doc;this.lastDivId=$n2.utils.getElementIdentifier($elem);this.lastDisplay=display;documentSource.getReferencesFromOrigin({docId:docId,onSuccess:loadedDocIds});function loadedDocIds(refDocIds){documentSource.getDocumentInfoFromIds({docIds:refDocIds,onSuccess:loadedDocInfos});};function loadedDocInfos(docInfos){docInfos.sort(function(a,b){var aTime=a.updatedTime;if(!aTime){aTime=a.createdTime;};var bTime=b.updatedTime;if(!bTime){bTime=b.createdTime;};if(aTime&&bTime){return bTime-aTime;};if(aTime)return-1;if(bTime)return 1;if(a.id>b.id){return 1;}
return-1;});$elem.empty();for(var i=0,e=docInfos.length;i<e;++i){var docInfo=docInfos[i];var docId=docInfo.id;var $commentDiv=$('<div>').addClass('n2DisplayComment_doc n2DisplayComment_doc_'+$n2.utils.stringToHtmlId(docId)).attr('n2DocId',docId).appendTo($elem);var $content=$('<div>').addClass('n2DisplayComment_content').appendTo($commentDiv);showService.printDocument($content,docId);var $buttons=$('<div>').addClass('n2DisplayComment_buttons').appendTo($commentDiv);$('<a>').attr('href','#').text(_loc('Reply')).addClass('n2DisplayComment_button_reply').appendTo($buttons).click(function(){var docId=$(this).parents('.n2DisplayComment_doc').attr('n2DocId');_this._addReply(docId,display);return false;});$('<a>').attr('href','#').text(_loc('More Details')).addClass('n2DisplayComment_button_focus').appendTo($buttons).click(function(){var docId=$(this).parents('.n2DisplayComment_doc').attr('n2DocId');_this._changeFocus(docId,display);return false;});};};},addButton:function(opts_){var opts=$n2.extend({display:null,div:null,doc:null,schema:null},opts_);var _this=this;var display=opts.display;var doc=opts.doc;var $buttons=$(opts.div);var $button=$('<a href="#"></a>').text(_loc('Add Comment')).appendTo($buttons).click(function(){_this._addComment(doc,display);return false;});$button.addClass('nunaliit_form_link');$button.addClass('nunaliit_form_link_add_related_item');},_addComment:function(doc,display){var createRelatedDocProcess=display.createRelatedDocProcess;createRelatedDocProcess.replyToDocument({doc:doc,schema:this.commentSchema,origin:doc._id});},_addReply:function(docId,display){var _this=this;var documentSource=display.documentSource;var createRelatedDocProcess=display.createRelatedDocProcess;documentSource.getDocument({docId:docId,onSuccess:function(doc){createRelatedDocProcess.replyToDocument({doc:doc,schema:_this.commentSchema});}});},_changeFocus:function(docId,display){var _this=this;display._dispatch({type:'userSelect',docId:docId});},_handleDispatch:function(m,address,dispatcher){if('documentContent'===m.type){var doc=m.doc;this._handleDocumentContent(doc);};},_handleDocumentContent:function(doc){if(doc.nunaliit_origin){if(doc.nunaliit_origin.doc===this.lastDoc._id){var $section=$('#'+this.lastDivId);if($section.length>0){var $entry=$section.find('.n2DisplayComment_doc_'+$n2.utils.stringToHtmlId(doc._id));if($entry.length<1){this.display({divId:this.lastDivId,display:this.lastDisplay,doc:this.lastDoc,schema:null});};};};};}});var TreeDocumentViewer=$n2.Class({doc:null,initialize:function(opts_){var opts=$n2.extend({doc:null},opts_);this.doc={};for(var key in opts.doc){if(key!=='__n2Source'){this.doc[key]=opts.doc[key];};};this._display();},_display:function(){var $dialog=$('<div>').addClass('n2Display_treeViewer_dialog');var diagId=$n2.utils.getElementIdentifier($dialog);var $container=$('<div>').addClass('n2Display_treeViewer_content').appendTo($dialog);new $n2.tree.ObjectTree($container,this.doc);var $buttons=$('<div>').addClass('n2Display_treeViewer_buttons').appendTo($dialog);$('<button>').text(_loc('Close')).appendTo($buttons).click(function(){var $diag=$('#'+diagId);$diag.dialog('close');return false;});$dialog.dialog({autoOpen:true,title:_loc('Tree View'),modal:true,width:370,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}});}});$n2.couchDisplay={Display:Display,CommentRelatedInfo:CommentRelatedInfo,TreeDocumentViewer:TreeDocumentViewer};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchDisplayTiles';function docCreationTimeSort(lhs,rhs){var timeLhs=0;var timeRhs=0;if(lhs&&lhs.doc&&lhs.doc.nunaliit_created&&lhs.doc.nunaliit_created.time){timeLhs=lhs.doc.nunaliit_created.time;}
if(rhs&&rhs.doc&&rhs.doc.nunaliit_created&&rhs.doc.nunaliit_created.time){timeRhs=rhs.doc.nunaliit_created.time;}
if(timeLhs<timeRhs)return-1;if(timeLhs>timeRhs)return 1;return 0;};function startsWith(s,prefix){var left=s.substr(0,prefix.length);return(left===prefix);};var GridTemplateDocument=$n2.Class({height:null,tileHeight:null,initialize:function(height,tileHeight){this.height=(height?height:0);this.tileHeight=(tileHeight?tileHeight:150);},get:function(numCols,targetTiles){targetTiles=targetTiles+12;var numRows=Math.ceil(targetTiles/numCols),rects=[],x,y,i;var firstTileHeight=Math.max(1,Math.ceil(this.height/this.tileHeight));var firstTileWidth=2;rects.push(new Tiles.Rectangle(0,0,firstTileWidth,firstTileHeight));x=firstTileWidth-1;y=0;for(i=1;i<targetTiles;++i){x=x+1;while(x>=numCols){y=y+1;x=0;if(y<firstTileHeight){x=firstTileWidth;};};rects.push(new Tiles.Rectangle(x,y,1,1));};return new Tiles.Template(rects,numCols,numRows);}});var TiledDisplay=$n2.Class({documentSource:null,displayPanelName:null,showService:null,editor:null,uploadService:null,authService:null,requestService:null,schemaRepository:null,customService:null,dispatchService:null,boolOptions:null,restrictAddRelatedButtonToLoggedIn:null,currentDetails:null,displayedDocumentsOrder:null,displayedDocuments:null,grid:null,createRelatedDocProcess:null,requestService:null,defaultSchema:null,relatedDocumentDiscoveryProcess:null,documentInfoFunction:null,sortFunction:null,filterFactory:null,filter:null,hoverInFn:null,hoverOutFn:null,hoverDocId:null,initialize:function(opts_){var opts=$n2.extend({documentSource:null,displayPanelName:null,showService:null,editor:null,uploadService:null,authService:null,requestService:null,schemaRepository:null,customService:null,dispatchService:null,createDocProcess:null,displayRelatedInfoFunction:null,displayOnlyRelatedSchemas:false,displayBriefInRelatedInfo:false,restrictAddRelatedButtonToLoggedIn:false,relatedDocumentDiscoveryProcess:null,documentInfoFunction:null,sortFunction:null,filterFactory:null},opts_);var _this=this;this.currentDetails={};this.displayedDocuments={};this.displayedDocumentsOrder=null;this.documentSource=opts.documentSource;this.displayPanelName=opts.displayPanelName;this.showService=opts.showService;this.editor=opts.editor;this.uploadService=opts.uploadService;this.authService=opts.authService;this.requestService=opts.requestService;this.schemaRepository=opts.schemaRepository;this.customService=opts.customService;this.dispatchService=opts.dispatchService;this.createRelatedDocProcess=opts.createDocProcess;this._getDisplayDiv();this.boolOptions={displayOnlyRelatedSchemas:opts.displayOnlyRelatedSchemas,displayBriefInRelatedInfo:opts.displayBriefInRelatedInfo};this.restrictAddRelatedButtonToLoggedIn=opts.restrictAddRelatedButtonToLoggedIn;if(!this.restrictAddRelatedButtonToLoggedIn&&this.customService){this.restrictAddRelatedButtonToLoggedIn=this.customService.getOption('restrictAddRelatedButtonToLoggedIn',false);};var dispatcher=this.dispatchService;if(dispatcher){var f=function(msg,addr,d){_this._handleDispatch(msg,addr,d);};dispatcher.register(DH,'selected',f);dispatcher.register(DH,'searchResults',f);dispatcher.register(DH,'documentDeleted',f);dispatcher.register(DH,'authLoggedIn',f);dispatcher.register(DH,'authLoggedOut',f);dispatcher.register(DH,'editClosed',f);dispatcher.register(DH,'documentContent',f);dispatcher.register(DH,'documentContentCreated',f);dispatcher.register(DH,'documentContentUpdated',f);};if(!opts.displayRelatedInfoFunction){var flag=this._getBooleanOption('displayOnlyRelatedSchemas');if(flag){opts.displayRelatedInfoFunction=function(opts_){_this._displayRelatedInfo(opts_);};}else{opts.displayRelatedInfoFunction=function(opts_){_this._displayLinkedInfo(opts_);};};};this.relatedDocumentDiscoveryProcess=opts.relatedDocumentDiscoveryProcess;if(!this.relatedDocumentDiscoveryProcess&&this.customService){this.relatedDocumentDiscoveryProcess=this.customService.getOption('relatedDocumentDiscoveryProcess',null);};if(!this.relatedDocumentDiscoveryProcess){this.relatedDocumentDiscoveryProcess=new ReferenceRelatedDocumentDiscovery({documentSource:this.documentSource});};this.documentInfoFunction=opts.documentInfoFunction;if(!this.documentInfoFunction&&this.customService){var docInfoFn=this.customService.getOption('displayDocumentInfoFunction');if(typeof docInfoFn==='function'){this.documentInfoFunction=docInfoFn;};};if(!this.documentInfoFunction){this.documentInfoFunction=function(opts_){var opts=$n2.extend({docIds:null,display:null,onSuccess:function(docInfos){},onError:function(err){}},opts_);var ds=opts.display.documentSource;ds.getDocumentInfoFromIds({docIds:opts.docIds,onSuccess:opts.onSuccess,onError:opts.onError});};};this.sortFunction=opts.sortFunction;if(!this.sortFunction&&this.customService){var sortFn=this.customService.getOption('displaySortFunction');if(typeof sortFn==='function'){this.sortFunction=sortFn;};};if(!this.sortFunction){this.sortFunction=function(infos){infos.sort(function(a,b){if(a.updatedTime&&b.updatedTime){if(a.updatedTime>b.updatedTime){return-1;};if(a.updatedTime<b.updatedTime){return 1;};};if(a.id>b.id){return-1;};if(a.id<b.id){return 1;};return 0;});};};this.filterFactory=opts.filterFactory;if(!this.filterFactory&&this.customService){var factory=this.customService.getOption('displayFilterFactory');if(factory&&typeof factory.get==='function'){this.filterFactory=factory;};};if(!this.filterFactory){this.filterFactory=new SchemaFilterFactory({schemaRepository:this.schemaRepository});};this.hoverInFn=function(){var $tile=$(this);var docId=$tile.attr('n2DocId');if(docId&&docId!==_this.hoverDocId){_this.hoverDocId=docId;_this._dispatch({type:'userFocusOn',docId:docId});};};this.hoverOutFn=function(){var $tile=$(this);var docId=$tile.attr('n2DocId');if(docId&&docId===_this.hoverDocId){_this.hoverDocId=null;_this._dispatch({type:'userFocusOff',docId:docId});};};var intervalID=window.setInterval(function(){var $set=_this._getDisplayDiv();if($set.length<0){window.clearInterval(intervalID);}else{_this._performIntervalTask();};},500);},setSchema:function(schema){this.defaultSchema=schema;},_handleDispatch:function(msg,addr,dispatcher){var $div=this._getDisplayDiv();if($div.length<1){dispatcher.deregister(addr);return;};if(msg.type==='selected'){if(msg.doc){this._displayDocument(msg.doc._id,msg.doc);}else if(msg.docId){this._displayDocument(msg.docId,null);}else if(msg.docs){var ids=[];for(var i=0,e=msg.docs.length;i<e;++i){ids.push(msg.docs[i]._id);};this._displayMultipleDocuments(ids,msg.docs);}else if(msg.docIds){this._displayMultipleDocuments(msg.docIds,null);};}else if(msg.type==='searchResults'){this._displaySearchResults(msg.results);}else if(msg.type==='documentDeleted'){}else if(msg.type==='authLoggedIn'||msg.type==='authLoggedOut'){if(this.currentDetails&&this.currentDetails.docId&&this.currentDetails.doc){this._receiveDocumentContent(this.currentDetails.doc);this._displayDocumentButtons(this.currentDetails.doc,this.currentDetails.schema);};}else if(msg.type==='editClosed'){var deleted=msg.deleted;if(!deleted){var doc=msg.doc;if(doc){this._displayDocument(doc._id,doc);};};}else if(msg.type==='documentContent'){this._receiveDocumentContent(msg.doc);}else if(msg.type==='documentContentCreated'){this._receiveDocumentContent(msg.doc);}else if(msg.type==='documentContentUpdated'){this._receiveDocumentContent(msg.doc);};},_displayDocument:function(docId,doc){this._reclaimDisplayDiv();if(this.currentDetails&&this.currentDetails.docId===docId){return;};this.currentDetails={docId:docId};this._addDisplayedDocument(docId,doc);var $set=this._getDisplayDiv();var $current=$set.find('.n2DisplayTiled_info');$current.hide();this.grid.template=null;this.grid.templateFactory=new GridTemplateDocument();this._adjustCurrentTile(docId);if(doc){this._receiveDocumentContent(doc);}else{this._requestDocumentWithId(docId);};},_displaySearchResults:function(results){this._reclaimDisplayDiv();var ids=[];if(results&&results.sorted&&results.sorted.length){for(var i=0,e=results.sorted.length;i<e;++i){ids.push(results.sorted[i].id);};};this._displayMultipleDocuments(ids,null);if(ids.length<1){var $set=this._getDisplayDiv();var $current=$set.find('.n2DisplayTiled_info');$current.text(_loc('Empty search results')).show();};},_displayMultipleDocuments:function(ids,docs){this._reclaimDisplayDiv();var $set=this._getDisplayDiv();var $current=$set.find('.n2DisplayTiled_info');$current.hide();this.currentDetails={docIds:ids,docs:{}};this.grid.template=null;this.grid.templateFactory=Tiles.UniformTemplates;this._adjustCurrentTile(null);var docsById={};if(docs){for(var i=0,e=docs.length;i<e;++i){var doc=docs[i];this.currentDetails.docs[doc._id]=doc;docsById[doc._id]=doc;};};this._changeDisplayedDocuments(ids,docsById);},_displayDocumentButtons:function(doc,schema){var _this=this;if(doc&&doc._id&&this.currentDetails.docId===doc._id){var $set=this._getDisplayDiv();var $btnDiv=$set.find('.n2DisplayTiled_current_buttons').empty();if($n2.couchMap.canEditDoc(doc)){$('<a href="#"></a>').addClass('n2DisplayTiled_current_button n2DisplayTiled_current_button_edit').text(_loc('Edit')).appendTo($btnDiv).click(function(){_this._performDocumentEdit(doc);return false;});};if($n2.couchMap.canDeleteDoc(doc)){$('<a href="#"></a>').addClass('n2DisplayTiled_current_button n2DisplayTiled_current_button_delete').text(_loc('Delete')).appendTo($btnDiv).click(function(){_this._performDocumentDelete(doc);return false;});};if(schema&&schema.relatedSchemaNames&&schema.relatedSchemaNames.length){var showAddRelatedButton=true;if(this.restrictAddRelatedButtonToLoggedIn){var isLoggedIn=false;if(this.dispatchService){var m={type:'authIsLoggedIn',isLoggedIn:false};this.dispatchService.synchronousCall(DH,m);isLoggedIn=m.isLoggedIn;};if(!isLoggedIn){showAddRelatedButton=false;};};if(showAddRelatedButton){var selectId=$n2.getUniqueId();var $addRelatedButton=$('<select>').addClass('n2DisplayTiled_current_button n2DisplayTiled_current_button_add_related_item').attr('id',selectId).appendTo($btnDiv);$('<option>').text(_loc('Add Related Item')).val('').appendTo($addRelatedButton);for(var i=0,e=schema.relatedSchemaNames.length;i<e;++i){var schemaName=schema.relatedSchemaNames[i];$('<option>').text(schemaName).val(schemaName).appendTo($addRelatedButton);if(this.schemaRepository){this.schemaRepository.getSchema({name:schemaName,onSuccess:function(schema){$('#'+selectId).find('option').each(function(){var $option=$(this);if($option.val()===schema.name){$option.text(schema.getLabel());};});}});};};$addRelatedButton.change(function(){var val=$(this).val();$(this).val('');if(val){_this._addRelatedDocument(doc,val);};return false;});};};if(this.dispatchService&&this.dispatchService.isEventTypeRegistered('findIsAvailable')&&this.dispatchService.isEventTypeRegistered('find')){var showFindOnMapButton=false;var m={type:'findIsAvailable',doc:doc,isAvailable:false};this.dispatchService.synchronousCall(DH,m);if(m.isAvailable){showFindOnMapButton=true;};if(showFindOnMapButton){$('<a href="#"></a>').addClass('n2DisplayTiled_current_button n2DisplayTiled_current_button_find_on_map').text(_loc('Find on Map')).appendTo($btnDiv).click(function(){_this._dispatch({type:'find',docId:doc._id,doc:doc});return false;});};};if(doc&&doc.nunaliit_layer_definition&&this.dispatchService&&this.dispatchService.isEventTypeRegistered('addLayerToMap')){$('<a href="#"></a>').addClass('n2DisplayTiled_current_button n2DisplayTiled_current_button_add_layer').text(_loc('Add Layer')).appendTo($btnDiv).click(function(){_this._performAddLayerToMap(doc);return false;});};if(doc){$('<a href="#"></a>').addClass('n2DisplayTiled_current_button n2DisplayTiled_current_button_tree_view').text(_loc('Tree View')).appendTo($btnDiv).click(function(){_this._performTreeView(doc);return false;});};};},_currentDocReferencesUpdated:function(){if(this.currentDetails&&this.currentDetails.doc&&this.currentDetails.referenceDocIds){var refDocIds={};for(var i=0,e=this.currentDetails.referenceDocIds.length;i<e;++i){var linkDocId=this.currentDetails.referenceDocIds[i];refDocIds[linkDocId]=true;};var idsToRemove=[];for(var docId in this.displayedDocuments){if(docId===this.currentDetails.docId){}else if(!refDocIds[docId]){idsToRemove.push(docId);};};for(var i=0,e=idsToRemove.length;i<e;++i){this._removeDisplayedDocument(idsToRemove[i]);};for(var docId in refDocIds){this._addDisplayedDocument(docId);};this.displayedDocumentsOrder=null;this._updateDisplayedDocuments();};},_updateDisplayedDocuments:function(){var _this=this;var neededInfoIds=[];for(var docId in this.displayedDocuments){if(!this.displayedDocuments[docId].info){neededInfoIds.push(docId);};};if(neededInfoIds.length>0){this.documentInfoFunction({docIds:neededInfoIds,display:this,onSuccess:function(docInfos){for(var i=0,e=docInfos.length;i<e;++i){var docInfo=docInfos[i];var docId=docInfo.id;if(_this.displayedDocuments[docId]){_this.displayedDocuments[docId].info=docInfo;};};performUpdate();},onError:function(errorMsg){$n2.log('Unable to obtain document information',errorMsg);}});}else{performUpdate();};function performUpdate(){_this._getDisplayDiv();var sortedDocIds=null;if(_this.displayedDocumentsOrder){sortedDocIds=_this.displayedDocumentsOrder;var infos=[];for(var i=0,e=sortedDocIds.length;i<e;++i){var docId=sortedDocIds[i];if(_this.displayedDocuments[docId]&&_this.displayedDocuments[docId].info){infos.push(_this.displayedDocuments[docId].info);};};_this.filter.display(infos,_this);infos=_this.filter.filter(infos,_this);sortedDocIds=[];for(var i=0,e=infos.length;i<e;++i){var info=infos[i];sortedDocIds.push(info.id);};}else{var infos=[];for(var docId in _this.displayedDocuments){if(_this.displayedDocuments[docId].info){infos.push(_this.displayedDocuments[docId].info);};};_this.filter.display(infos,_this);infos=_this.filter.filter(infos,_this);_this.sortFunction(infos);var alreadySorted={};sortedDocIds=[];if(_this.currentDetails&&_this.currentDetails.docId){sortedDocIds.push(_this.currentDetails.docId);alreadySorted[_this.currentDetails.docId]=true;};for(var i=0,e=infos.length;i<e;++i){var docId=infos[i].id;if(!alreadySorted[docId]){sortedDocIds.push(docId);alreadySorted[docId]=true;};};};_this.grid.updateTiles(sortedDocIds);_this.grid.isDirty=true;_this.grid.redraw(true);for(var i=0,e=sortedDocIds.length;i<e;++i){var docId=sortedDocIds[i];_this._requestDocumentWithId(docId);};};},_changeDisplayedDocuments:function(docIds,docsById){var displayDocsByIds={};for(var i=0,e=docIds.length;i<e;++i){var docId=docIds[i];displayDocsByIds[docId]=true;};for(var docId in this.displayedDocuments){if(!displayDocsByIds[docId]){this._removeDisplayedDocument(docId);};};for(var i=0,e=docIds.length;i<e;++i){var docId=docIds[i];var doc=null;if(docsById&&docsById[docId]){doc=docsById[docId];};this._addDisplayedDocument(docId,doc);};this.displayedDocumentsOrder=docIds;this._updateDisplayedDocuments();},_addDisplayedDocument:function(docId,doc){if(!this.displayedDocuments[docId]){this.displayedDocuments[docId]={id:docId};};if(doc){this.displayedDocuments[docId].doc=doc;};},_removeDisplayedDocument:function(docId){if(this.displayedDocuments[docId]){delete this.displayedDocuments[docId];};},_receiveDocumentContent:function(doc){var _this=this;var $set=this._getDisplayDiv();var docId=doc._id;if(this.displayedDocuments[docId]){this.displayedDocuments[docId].doc=doc;};if(doc._id===this.currentDetails.docId){var update=false;if(!this.currentDetails.doc){this.currentDetails.doc=doc;update=true;}else{if(doc._rev!==this.currentDetails.doc._rev){this.currentDetails.doc=doc;update=true;};};if(update){this.relatedDocumentDiscoveryProcess.getRelatedDocumentIds({doc:doc,onSuccess:function(doc,refDocIds){if(_this.currentDetails.docId===doc._id){_this.currentDetails.referenceDocIds=refDocIds;_this._currentDocReferencesUpdated();};},onError:function(err){$n2.log('Error obtaining reference ids',err);}});};};var waitClassName='n2DisplayTiled_wait_brief_'+$n2.utils.stringToHtmlId(docId);$set.find('.'+waitClassName).each(function(){var $div=$(this);if(_this.showService){_this.showService.displayBriefDescription($div,{},doc);};$div.removeClass(waitClassName);});var waitClassName='n2DisplayTiled_wait_current_'+$n2.utils.stringToHtmlId(docId);$set.find('.'+waitClassName).each(function(){var $div=$(this).empty();$('<div>').addClass('n2DisplayTiled_current_buttons').appendTo($div);var $content=$('<div>').appendTo($div);if(_this.showService){_this.showService.displayDocument($content,{},doc);}else{$content.text(doc._id);};_this._displayDocumentButtons(doc,_this.currentDetails.schema);$div.removeClass(waitClassName);});var includesImage=false;var includesAudio=false;var includesVideo=false;var thumbnailName=null;var schemaName=null;if(doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){var att=doc.nunaliit_attachments.files[attName];if(att.source){}else{if('image'===att.fileClass){includesImage=true;}else if('audio'===att.fileClass){includesAudio=true;}else if('video'===att.fileClass){includesVideo=true;};if(att.thumbnail){thumbnailName=att.thumbnail;};};};};if(doc.nunaliit_schema){schemaName=doc.nunaliit_schema;};$set.find('.n2DisplayTiled_tile_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $tile=$(this);$tile.removeClass('n2DisplayTiled_tile_image n2DisplayTiled_tile_audio n2DisplayTiled_tile_video');if(includesVideo){$tile.addClass('n2DisplayTiled_tile_video');}else if(includesAudio){$tile.addClass('n2DisplayTiled_tile_audio');}else if(includesImage){$tile.addClass('n2DisplayTiled_tile_image');};if(schemaName){$tile.addClass('n2DisplayTiled_tile_schema_'+$n2.utils.stringToHtmlId(schemaName));};});if(thumbnailName){if(doc.nunaliit_attachments.files[thumbnailName]&&doc.nunaliit_attachments.files[thumbnailName].status==='attached'){}else{thumbnailName=null;};};if(thumbnailName){var url=this.documentSource.getDocumentAttachmentUrl(doc,thumbnailName);if(url){$set.find('.n2DisplayTiled_wait_thumb_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $div=$(this);$div.empty();$('<img>').attr('src',url).appendTo($div);});};};if(doc.nunaliit_schema&&this.schemaRepository){this.schemaRepository.getSchema({name:doc.nunaliit_schema,onSuccess:function(schema){schemaLoaded(doc,schema);},onError:function(err){schemaLoaded(doc,null);}});}else{schemaLoaded(doc,null);};if(this.currentDetails.doc&&doc._id!==this.currentDetails.docId){this.relatedDocumentDiscoveryProcess.areDocumentsRelated({selectedDoc:this.currentDetails.doc,relatedDoc:doc,onRelated:function(selectedDoc,relatedDoc){if(selectedDoc._id===_this.currentDetails.docId){var refIndex=-1;if(_this.currentDetails.referenceDocIds){refIndex=_this.currentDetails.referenceDocIds.indexOf(doc._id);};if(refIndex<0){if(!_this.currentDetails.referenceDocIds){_this.currentDetails.referenceDocIds=[];};_this.currentDetails.referenceDocIds.push(doc._id);_this._currentDocReferencesUpdated();};};},onNotRelated:function(selectedDoc,relatedDoc){if(selectedDoc._id===_this.currentDetails.docId){var refIndex=-1;if(_this.currentDetails.referenceDocIds){refIndex=_this.currentDetails.referenceDocIds.indexOf(doc._id);};if(refIndex>=0){_this.currentDetails.referenceDocIds.splice(refIndex,1);_this._currentDocReferencesUpdated();};};},onError:function(err){$n2.log('Error in displayTiled. Unable to check relation.',err);}});};function schemaLoaded(doc,schema){if(_this.currentDetails.docId===doc._id){if(schema&&!_this.currentDetails.schema){_this.currentDetails.schema=schema;_this._displayDocumentButtons(doc,schema);}else if(_this.currentDetails.schema&&!schema){_this.currentDetails.schema=null;_this._displayDocumentButtons(doc,null);}else if(_this.currentDetails.schema&&schema&&_this.currentDetails.schema.name!==schema.name){_this.currentDetails.schema=schema;_this._displayDocumentButtons(doc,schema);};};};},_addRelatedDocument:function(doc,schemaName){this.createRelatedDocProcess.createDocumentFromSchemaNames({schemaNames:[schemaName],relatedDoc:doc,onSuccess:function(docId){}});},_performDocumentEdit:function(doc){var _this=this;this.documentSource.getDocument({docId:doc._id,onSuccess:function(doc){_this._dispatch({type:'editInitiate',docId:doc._id,doc:doc});},onError:function(errorMsg){$n2.log('Unable to load document: '+errorMsg);}});},_performDocumentDelete:function(doc){if(confirm(_loc('You are about to delete this document. Do you want to proceed?'))){this.documentSource.deleteDocument({doc:doc,onSuccess:function(){}});};},_performAddLayerToMap:function(doc){var layerDefinition=doc.nunaliit_layer_definition;var layerId=layerDefinition.id;if(!layerId){layerId=doc._id;};var layerDef={name:layerDefinition.name,type:'couchdb',options:{layerName:layerId,documentSource:this.documentSource}};this._dispatch({type:'addLayerToMap',layer:layerDef,options:{setExtent:{bounds:layerDefinition.bbox,crs:'EPSG:4326'}}});},_performTreeView:function(doc){new $n2.couchDisplay.TreeDocumentViewer({doc:doc});},_reclaimDisplayDiv:function(){var _this=this;var $set=this._getDisplayDiv();var $filters=$set.find('.n2DisplayTiled_filters');var $current=$set.find('.n2DisplayTiled_info');var $docs=$set.find('.n2DisplayTiled_documents');if($filters.length<1||$current.length<1||$docs.length<1){$set.empty();$filters=$('<div>').addClass('n2DisplayTiled_filters').appendTo($set);$current=$('<div>').addClass('n2DisplayTiled_info').appendTo($set);$docs=$('<div>').addClass('n2DisplayTiled_documents').appendTo($set);this.currentDetails={};this.grid=new Tiles.Grid($docs);this.grid.createTile=function(docId){var $elem=$('<div>').addClass('n2DisplayTiled_tile').addClass('n2DisplayTiled_tile_'+$n2.utils.stringToHtmlId(docId)).attr('n2DocId',docId);$elem.hover(_this.hoverInFn,_this.hoverOutFn);var tile=new Tiles.Tile(docId,$elem);if(_this.currentDetails&&_this.currentDetails.docId===docId){$elem.addClass('n2DisplayTiled_tile_current');_this._generateCurrentDocumentContent($elem,docId);}else{_this._generateDocumentContent($elem,docId);};return tile;};this.filter=this.filterFactory.get($filters,function(){_this._documentFilterChanged();});};},_adjustCurrentTile:function(docId){var _this=this;var $set=this._getDisplayDiv();var $docs=$set.find('.n2DisplayTiled_documents');var targetClass=null;if(docId){targetClass='n2DisplayTiled_tile_'+$n2.utils.stringToHtmlId(docId);};$docs.find('.n2DisplayTiled_tile_current').each(function(){var $elem=$(this);if(targetClass&&$elem.hasClass(targetClass)){}else{$elem.removeClass('n2DisplayTiled_tile_current');var id=$elem.attr('n2DocId');_this._generateDocumentContent($elem,id);};});if(targetClass){$docs.find('.'+targetClass).each(function(){var $elem=$(this);if($elem.hasClass('n2DisplayTiled_tile_current')){}else{$elem.addClass('n2DisplayTiled_tile_current');var id=$elem.attr('n2DocId');_this._generateCurrentDocumentContent($elem,id);};});};},_getDisplayDiv:function(){var divId=this.displayPanelName;return $('#'+divId);},_dispatch:function(m){var dispatcher=this.dispatchService;if(dispatcher){dispatcher.send(DH,m);};},_getBooleanOption:function(optionName){var flag=false;if(this.boolOptions[optionName]){flag=true;};var cs=this.customService;if(cs&&!flag){var o=cs.getOption(optionName);if(o){flag=true;};};return flag;},_getCachedDocumentFromId:function(docId){if(this.displayedDocuments&&this.displayedDocuments[docId]&&this.displayedDocuments[docId].doc){return this.displayedDocuments[docId].doc;};if(this.currentDetails&&this.currentDetails.docId===docId&&this.currentDetails.doc){return this.currentDetails.doc;};return null;},_requestDocumentWithId:function(docId){var doc=this._getCachedDocumentFromId(docId);if(doc){this._receiveDocumentContent(doc);return;};if(this.requestService){this.requestService.requestDocument(docId);};},_generateCurrentDocumentContent:function($elem,docId){$elem.empty();var waitClassName='n2DisplayTiled_wait_current_'+$n2.utils.stringToHtmlId(docId);$('<div>').addClass(waitClassName).addClass('n2DisplayTiled_tile_content').text(docId).appendTo($elem);},_generateDocumentContent:function($elem,docId){var _this=this;$elem.empty();$('<div>').addClass('n2DisplayTiled_thumb n2DisplayTiled_wait_thumb_'+$n2.utils.stringToHtmlId(docId)).appendTo($elem);$('<div>').addClass('n2DisplayTiled_wait_brief_'+$n2.utils.stringToHtmlId(docId)).addClass('n2DisplayTiled_tile_brief').text(docId).appendTo($elem);var clickInstalled=$elem.attr('n2Click');if(!clickInstalled){$elem.click(function(){_this._dispatch({type:'userSelect',docId:docId});});$elem.attr('n2Click','installed');};},_performIntervalTask:function(){var $set=this._getDisplayDiv();var $docs=$set.find('.n2DisplayTiled_documents');if(this.currentDetails&&this.currentDetails.docId){var $currentTile=$docs.find('.n2DisplayTiled_tile_current').find('.n2DisplayTiled_tile_content');if($currentTile.length>0){var height=$currentTile.height();if(height!=this.currentDetails.height){this.currentDetails.height=height;var cellSize=this.grid.cellSize;this.grid.template=null;this.grid.templateFactory=new GridTemplateDocument(height,cellSize);this.grid.redraw(true);};};};},_documentFilterChanged:function(){this._updateDisplayedDocuments();}});var SchemaFilter=$n2.Class({elemId:null,changeCallback:null,schemaRepository:null,selectedSchema:null,initialize:function(elem,changeCallback,schemaRepository){var $elem=$(elem);this.elemId=$elem.attr('id');if(!this.elemId){this.elemId=$n2.getUniqueId();$elem.attr('id',this.elemId);};this.changeCallback=changeCallback;this.schemaRepository=schemaRepository;},display:function(infos){var _this=this;var schemas={};if(infos){for(var i=0,e=infos.length;i<e;++i){var info=infos[i];if(info.schema){schemas[info.schema]=true;};};};var schemaNames=[];for(var schemaName in schemas){schemaNames.push(schemaName);};this.schemaRepository.getSchemas({names:schemaNames,onSuccess:function(schemas){_this._displaySchemas(schemas);},onError:function(err){$n2.log('Error getting schemas for displaying schema filter',err);}});},filter:function(infos){if(this.selectedSchema){var filteredInfos=[];for(var i=0,e=infos.length;i<e;++i){var info=infos[i];if(info.schema===this.selectedSchema){filteredInfos.push(info);};};return filteredInfos;}else{return infos;};},_getElem:function(){return $('#'+this.elemId);},_displaySchemas:function(schemas){var _this=this;var $elem=this._getElem();$elem.empty();var clickFn=function(){var $a=$(this);var schemaName=$a.attr('n2SchemaName');schemaName=schemaName?schemaName:null;_this._schemaSelected(schemaName);return false;};$('<a>').attr('href','#').text(_loc('All')).addClass('n2DisplayTiled_filter').addClass('n2DisplayTiled_filter_all').appendTo($elem).click(clickFn);var keepCurrentSelection=false;for(var i=0,e=schemas.length;i<e;++i){var schema=schemas[i];if(schema.name===this.selectedSchema){keepCurrentSelection=true;};var schemaLabel=schema.name;if(schema.label){schemaLabel=_loc(schema.label);};$('<a>').attr('href','#').attr('n2SchemaName',schema.name).text(schemaLabel).addClass('n2DisplayTiled_filter_schema').addClass('n2DisplayTiled_filter_schema_'+$n2.utils.stringToHtmlId(schema.name)).appendTo($elem).click(clickFn);};if(!keepCurrentSelection){this.selectedSchema=null;};this._adjustSelection();},_adjustSelection:function(){var $elem=this._getElem();$elem.find('.n2DisplayTiled_filter_selected').removeClass('n2DisplayTiled_filter_selected');if(this.selectedSchema){$elem.find('.n2DisplayTiled_filter_schema_'+$n2.utils.stringToHtmlId(this.selectedSchema)).addClass('n2DisplayTiled_filter_selected');}else{$elem.find('.n2DisplayTiled_filter_all').addClass('n2DisplayTiled_filter_selected');};},_schemaSelected:function(schemaName){this.selectedSchema=schemaName;this._adjustSelection();this.changeCallback();}});var SchemaFilterFactory=$n2.Class({schemaRepository:null,initialize:function(opts_){var opts=$n2.extend({schemaRepository:null},opts_);this.schemaRepository=opts.schemaRepository;},get:function(elem,changeCallback){return new SchemaFilter(elem,changeCallback,this.schemaRepository);}});var ReferenceRelatedDocumentDiscovery=$n2.Class({documentSource:null,initialize:function(opts_){var opts=$n2.extend({documentSource:null},opts_);this.documentSource=opts.documentSource;},getRelatedDocumentIds:function(opts_){var opts=$n2.extend({doc:null,onSuccess:function(doc,refDocIds){},onError:function(err){}},opts_);var doc=opts.doc;this.documentSource.getReferencesFromId({docId:doc._id,onSuccess:loadedRefIds,onError:function(errorMsg){opts.onError(errorMsg);}});function loadedRefIds(referenceIds){var docIdMap={};var references=[];$n2.couchUtils.extractLinks(doc,references);for(var i=0,e=references.length;i<e;++i){var linkDocId=references[i].doc;docIdMap[linkDocId]=true;};for(var i=0,e=referenceIds.length;i<e;++i){var linkDocId=referenceIds[i];docIdMap[linkDocId]=true;};var refDocIds=[];for(var docId in docIdMap){refDocIds.push(docId);};opts.onSuccess(doc,refDocIds);};},areDocumentsRelated:function(opts_){var opts=$n2.extend({selectedDoc:null,relatedDoc:null,onRelated:function(selectedDoc,relatedDoc){},onNotRelated:function(selectedDoc,relatedDoc){},onError:function(err){}},opts_);var selectedDoc=opts.selectedDoc;var relatedDoc=opts.relatedDoc;var references=[];$n2.couchUtils.extractLinks(selectedDoc,references);for(var i=0,e=references.length;i<e;++i){var linkDocId=references[i].doc;if(linkDocId===relatedDoc._id){opts.onRelated(selectedDoc,relatedDoc);return;};};var references=[];$n2.couchUtils.extractLinks(relatedDoc,references);for(var i=0,e=references.length;i<e;++i){var linkDocId=references[i].doc;if(linkDocId===selectedDoc._id){opts.onRelated(selectedDoc,relatedDoc);return;};};opts.onNotRelated(selectedDoc,relatedDoc);}});$n2.couchDisplayTiles={TiledDisplay:TiledDisplay,SchemaFilterFactory:SchemaFilterFactory,ReferenceRelatedDocumentDiscovery:ReferenceRelatedDocumentDiscovery};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchSearch';function SplitSearchTerms(line){if(!line)return null;var map=$n2.couchUtils.extractSearchTerms(line,false);var searchTerms=[];for(var term in map){var folded=map[term].folded;if(folded){searchTerms.push(folded);};};return searchTerms;};var SearchRequest=$n2.Class({options:null,searchResults:null,initialize:function(searchTermsLine,opts_){this.options=$n2.extend({designDoc:null,db:null,dateService:null,searchView:'text-search',searchLimit:25,onlyFinalResults:false,strict:false,onSuccess:function(searchResults){},onError:function(err){$n2.reportErrorForced(err);}},opts_);var searchTerms=searchTermsLine;if(typeof(searchTermsLine)==='string'){searchTerms=SplitSearchTerms(searchTerms);}else if($n2.isArray(searchTermsLine)){searchTermsLine=searchTerms.join(' ');}else{this.options.onError('Search terms must be a string or an array');return;};var dateIntervals=null;if(this.options.dateService){var dateStrings=$n2.date.findAllDateStrings(searchTermsLine);if(dateStrings&&dateStrings.length){dateIntervals=[];for(var i=0,e=dateStrings.length;i<e;++i){dateIntervals.push(dateStrings[i].interval);};};};this.searchResults={terms:[],actionReturnedCount:0,pending:searchTerms.length,map:{},sorted:[],list:[]};if(dateIntervals){this.searchResults.pending+=dateIntervals.length;};if(!searchTerms.length){this._returnSearchResults();return;};for(var i=0,e=searchTerms.length;i<e;++i){var t=searchTerms[i].toLowerCase();this.searchResults.terms.push(t);};var _this=this;for(var i=0,e=this.searchResults.terms.length;i<e;++i){var term=this.searchResults.terms[i];this.options.designDoc.queryView({viewName:this.options.searchView,startkey:[term,0],endkey:[term,{}],onSuccess:function(rows){var termResults=[];for(var i=0,e=rows.length;i<e;++i){termResults.push({docId:rows[i].id,index:rows[i].key[1]});};_this._receiveSearchResults(termResults);},onError:function(err){_this.searchResults=null;_this.options.onError(err);}});};if(dateIntervals){for(var i=0,e=dateIntervals.length;i<e;++i){this.options.dateService.getDocIdsFromInterval({interval:dateIntervals[i],onSuccess:function(docIds){var dateResults=[];for(var i=0,e=docIds.length;i<e;++i){dateResults.push({docId:docIds[i],index:0});};_this._receiveSearchResults(dateResults);},onError:function(err){_this.searchResults=null;_this.options.onError(err);}});};};},abortSearch:function(){this.searchResults=null;},_receiveSearchResults:function(interimResults){var searchResults=this.searchResults;if(!searchResults)return;--searchResults.pending;++searchResults.actionReturnedCount;if(this.options.strict&&searchResults.actionReturnedCount>1){var docIdsReturned={};for(var i=0,e=interimResults.length;i<e;++i){var docId=interimResults[i].docId;var index=interimResults[i].index;docIdsReturned[docId]=true;if(searchResults.map[docId]){var m=searchResults.map[docId];++m.terms;if(m.index>index)m.index=index;}else{};};var docIdsToDelete=[];for(var docId in searchResults.map){if(!docIdsReturned[docId]){docIdsToDelete.push(docId);};};for(var i=0,e=docIdsToDelete.length;i<e;++i){delete searchResults.map[docIdsToDelete[i]];};searchResults.sorted=[];for(var docId in searchResults.map){searchResults.sorted.push(searchResults.map[docId]);};}else{for(var i=0,e=interimResults.length;i<e;++i){var docId=interimResults[i].docId;var index=interimResults[i].index;if(searchResults.map[docId]){var m=searchResults.map[docId];++m.terms;if(m.index>index)m.index=index;}else{var m={id:docId,index:index,terms:1,contentRequested:false};searchResults.map[docId]=m;searchResults.sorted.push(m);};};};this._returnSearchResults();},_returnSearchResults:function(){var searchResults=this.searchResults;if(!searchResults)return;var _this=this;if(this.options.onlyFinalResults){if(searchResults.pending>0){return;};};searchResults.sorted.sort(function(a,b){if(a.terms>b.terms){return-1;}else if(a.terms<b.terms){return 1;}else{if(a.index<b.index){return-1;}else if(a.index>b.index){return 1;};};return 0;});if((searchResults.terms.length-searchResults.pending)<=1){searchResults.list=searchResults.sorted;}else{searchResults.list=[];if(searchResults.sorted.length>0){var termCount=searchResults.sorted[0].terms;for(var i=0,e=searchResults.sorted.length;i<e;++i){var r=searchResults.sorted[i];if(r.terms>=termCount){searchResults.list.push(r);};};};};this.options.onSuccess(searchResults);}});var LookAheadService=$n2.Class({options:null,lookAheadMap:null,lookAheadCounter:null,initialize:function(opts_){this.options=opts_;this.lookAheadMap={};this.lookAheadCounter=0;},queryPrefix:function(prefix,callback){var _this=this;var words=this._retrievePrefix(prefix);if(words){callback(prefix,words);return;};this.options.designDoc.queryView({viewName:this.options.lookAheadView,listName:this.options.lookAheadList,startkey:[prefix,null],endkey:[prefix+'\u9999',{}],top:this.options.lookAheadLimit,group:true,onlyRows:false,reduce:true,onSuccess:function(response){var rows=response.rows;var words=[];for(var i=0,e=rows.length;i<e;++i){words.push(rows[i][0]);};_this._cachePrefix({prefix:prefix,words:words,full:response.all_rows});if(0==words.length){callback(prefix,null);}else{callback(prefix,words);};},onError:function(){callback(prefix,null);}});},queryTerms:function(terms,callback){if(null===terms||0==terms.length){callback(null);return;};var index=terms.length-1;while(index>=0){var lastTerm=terms[index];if(''===lastTerm){--index;}else{var previousWords=null;if(index>0){previousWords=terms.slice(0,index);};break;};};lastTerm=lastTerm.toLowerCase();if(!lastTerm){callback(null);return;};if(lastTerm.length<this.options.lookAheadPrefixMin){callback(null);return;};var previousWordsString='';if(previousWords){previousWordsString=previousWords.join(' ')+' ';};this.queryPrefix(lastTerm,function(prefix,words){if(null===words){callback(null);}else{var results=[];for(var i=0,e=words.length;i<e;++i){results.push(previousWordsString+words[i]);};callback(results);};});},_cachePrefix:function(prefixResult){this.lookAheadMap[prefixResult.prefix]=prefixResult;prefixResult.counter=this.lookAheadCounter;++(this.lookAheadCounter);var keysToDelete=[];var cachedMap=this.lookAheadMap;var limit=this.lookAheadCounter-this.options.lookAheadCacheSize;for(var key in cachedMap){if(cachedMap[key].counter<limit){keysToDelete.push(key);};};for(var i=0,e=keysToDelete.length;i<e;++i){delete cachedMap[keysToDelete[i]];};},_retrievePrefix:function(prefix){if(this.lookAheadMap[prefix]){return this.lookAheadMap[prefix].words;};var sub=prefix.substring(0,prefix.length-1);while(sub.length>=this.options.lookAheadPrefixMin){if(this.lookAheadMap[sub]&&this.lookAheadMap[sub].full){var cachedWords=this.lookAheadMap[sub].words;var words=[];for(var i=0,e=cachedWords.length;i<e;++i){var word=cachedWords[i];if(word.length>=prefix.length){if(word.substr(0,prefix.length)===prefix){words.push(word);};};};return words;};sub=sub.substring(0,sub.length-1);};return null;},getJqAutoCompleteSource:function(){var _this=this;return function(request,cb){_this._jqAutoComplete(request,cb);};},_jqAutoComplete:function(request,cb){var terms=SplitSearchTerms(request.term);var callback=cb;this.queryTerms(terms,callback);}});var SearchInput=$n2.Class({options:null,searchServer:null,textInputId:null,searchButtonId:null,keyPressedSinceLastSearch:null,dispatchHandle:null,initialize:function(opts_,server_){this.options=$n2.extend({textInput:null,searchButton:null,initialSearchText:null,displayFn:null,dispatchService:null},opts_);var _this=this;this.searchServer=server_;this.keyPressedSinceLastSearch=false;if(this.options.dispatchService){var f=function(m){_this._handle(m);};this.options.dispatchService.register(DH,'searchInitiate',f);this.options.dispatchService.register(DH,'selected',f);this.options.dispatchService.register(DH,'unselected',f);};var $textInput=this.options.textInput;this.textInputId=$n2.utils.getElementIdentifier($textInput);this.options.textInput=null;if(this.options.searchButton){var $searchButton=this.options.searchButton;var searchButtonId=$searchButton.attr('id');if(!searchButtonId){searchButtonId=$n2.getUniqueId();$searchButton.attr('id',searchButtonId);};this.searchButtonId=searchButtonId;this.options.searchButton=null;};if(!this.options.initialSearchText){this.options.initialSearchText='';};this._install();},getTextInput:function(){return $('#'+this.textInputId);},getSearchButton:function(){if(this.searchButtonId){return $('#'+this.searchButtonId);};return null;},getSearchLine:function(){var $textInput=this.getTextInput();var line=$textInput.val();if(line&&line.length>0){if(line===this.options.initialSearchText){return'';}else{return line;};}else{return'';};},performSearch:function(line){var _this=this;if(this.options.dispatchService){this.options.dispatchService.send(DH,{type:'searchInitiate',searchLine:line});}else if(this.searchServer){this.searchServer.submitRequest(line,{onSuccess:function(searchResults){_this._processSearchResults(searchResults);},onError:function(err){_this._processSearchError(err);}});};this.keyPressedSinceLastSearch=false;this._displayWait();},_install:function(){var _this=this;var $textInput=this.getTextInput();if(this.options.initialSearchText){$textInput.val(this.options.initialSearchText);};if($textInput.autocomplete){$textInput.autocomplete({source:this._getJqAutoCompleteSource()});};$textInput.keydown(function(e){_this._keyDown(e);});$textInput.focus(function(e){_this._focus(e);});$textInput.blur(function(e){_this._blur(e);});var $searchButton=this.getSearchButton();if($searchButton){$searchButton.click(function(e){_this._clickSearch(e);});};},_focus:function(e){var $textInput=this.getTextInput();if(this.options.initialSearchText){var value=$textInput.val();if(this.options.initialSearchText===value){$textInput.val('');};};$textInput.select();},_blur:function(e){if(this.options.initialSearchText){var $textInput=this.getTextInput();var value=$textInput.val();if(''===value){$textInput.val(this.options.initialSearchText);};};},_keyDown:function(e){var charCode=null;if(null===e){e=window.event;};if(null!==e){if(e.keyCode){charCode=e.keyCode;};};this.keyPressedSinceLastSearch=true;if(13===charCode||null===charCode){var line=this.getSearchLine();if(line.length>0){this._closeLookAhead();this.performSearch(line);this._closeLookAhead();};};},_clickSearch:function(e){var line=this.getSearchLine();if(line.length>0){this._closeLookAhead();this.performSearch(line);this._closeLookAhead();};},_closeLookAhead:function($textInput){if(!$textInput){$textInput=this.getTextInput();};if($textInput.autocomplete){$textInput.autocomplete('close');};},_processSearchResults:function(searchResults){var _this=this;if(this.options.displayFn){searchResults.type='results';this.options.displayFn(searchResults);}else if(this.options.dispatchService){this.options.dispatchService.send(DH,{type:'searchResults',results:searchResults});}else{$n2.log('Unable to return search results');};},_processSearchError:function(err){if(this.options.displayFn){var display={type:'error',error:err};this.options.displayFn(display);}else if(this.options.dispatchService){this.options.dispatchService.send(DH,{type:'searchResults',error:err});};},_displayWait:function(){if(this.options.displayFn){this.options.displayFn({type:'wait'});};},_getJqAutoCompleteSource:function(){var _this=this;return function(request,cb){_this._jqAutoComplete(request,cb);};},_jqAutoComplete:function(request,cb){var _this=this;var lookAheadService=this.searchServer.getLookAheadService();lookAheadService._jqAutoComplete(request,function(res){if(_this.keyPressedSinceLastSearch){cb(res);}else{cb(null);};});},_handle:function(m){if('searchInitiate'===m.type){var $textInput=this.getTextInput();$textInput.val(m.searchLine);}else if('selected'===m.type||'unselected'===m.type){var $textInput=this.getTextInput();if(this.options.initialSearchText){$textInput.val(this.options.initialSearchText);}else{$textInput.val('');};};}});var SearchServer=$n2.Class({options:null,lookAheadService:null,initialize:function(opts_){this.options=$n2.extend({designDoc:null,db:null,dateService:null,directory:null,searchView:'text-search',searchLimit:25,lookAheadView:'text-lookahead',lookAheadList:'text-lookahead',lookAheadLimit:5,lookAheadPrefixMin:3,lookAheadCacheSize:10},opts_);var _this=this;this.lookAheadService=null;var d=this._getDispatcher();if(d){var f=function(m){_this._handle(m);};var h=d.getHandle('n2.couchSearch');d.register(h,'searchInitiate',f);};},getLookAheadService:function(){if(null===this.lookAheadService){this.lookAheadService=new LookAheadService(this.options);};return this.lookAheadService;},submitRequest:function(searchTerms,opts_){var requestOptions=$n2.extend({designDoc:this.options.designDoc,db:this.options.db,dateService:this.options.dateService,searchView:this.options.searchView,searchLimit:this.options.searchLimit},opts_);return new SearchRequest(searchTerms,requestOptions);},getJqAutoCompleteSource:function(){return this.getLookAheadService().getJqAutoCompleteSource();},installSearch:function(opts_){return new SearchInput(opts_,this);},installSearchWidget:function(opts_){var opts=$n2.extend({elem:null,label:null,useButton:false,buttonLabel:null,doNotDisable:false},opts_);var customService=this._getCustomService();var $elem=$(opts.elem);var searchWidgetLabel=opts.label;if(null===searchWidgetLabel&&customService){searchWidgetLabel=customService.getOption('searchWidgetText',null);};if(null===searchWidgetLabel){searchWidgetLabel=_loc('search the atlas');};$elem.empty();var searchInput=$('<input type="text">').addClass('search_panel_input').val(searchWidgetLabel).appendTo($elem);if(opts.doNotDisable){}else{searchInput.addClass('n2_disable_on_edit');};var searchButtonLabel=opts.buttonLabel;if(null===searchButtonLabel&&customService){searchButtonLabel=customService.getOption('searchButtonText',null);};if(null===searchButtonLabel){searchButtonLabel=_loc('Search');};var searchButton=null;if(opts.useButton){searchButton=$('<input type="button">').val(searchButtonLabel).appendTo($elem);};return new SearchInput({textInput:searchInput,initialSearchText:searchWidgetLabel,dispatchService:this._getDispatcher(),searchButton:searchButton},this);},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;},_getCustomService:function(){var cs=null;if(this.options.directory){cs=this.options.directory.customService;};return cs;},_handle:function(m){if('searchInitiate'===m.type){var searchTerms=m.searchLine;var dispatcher=this._getDispatcher();var h=dispatcher.getHandle('n2.couchSearch');this.submitRequest(searchTerms,{onSuccess:function(searchResults){dispatcher.send(h,{type:'searchResults',results:searchResults});},onError:function(err){dispatcher.send(h,{type:'searchError',error:err});}});};}});$n2.couchSearch={SearchServer:SearchServer,SearchRequest:SearchRequest};})(jQuery,nunaliit2);;(function($,$n2){if(typeof(OpenLayers)==='undefined')return;OpenLayers.Format.Couch=OpenLayers.Class(OpenLayers.Format,{initialize:function(options){OpenLayers.Format.prototype.initialize.apply(this,[options]);},read:function(docs){try{var results=[];for(var i=0,e=docs.length;i<e;++i){var doc=docs[i];var id=null;var geom=null;if(doc._id){id=doc._id;};if(doc.nunaliit_geom.wkt){geom=OpenLayers.Geometry.fromWKT(doc.nunaliit_geom.wkt);if(geom){if(!$n2.olUtils.isValidGeom(geom)){geom=null;};};if(!geom){$n2.log('Invalid WKT('+doc._id+'): '+doc.nunaliit_geom.wkt);};};if(id&&geom){var f=new OpenLayers.Feature.Vector(geom,doc);f.fid=id;results.push(f);}else{$n2.log('Invalid feature',doc);};};return results;}catch(e){$n2.log('Error during CouchDB format read',e);}
return null;},write:function(features){var result=[];for(var i=0,e=features.length;i<e;++i){var f=features[i];var data=f.data;if(null==data){data={};};if(f.fid){data._id=f.fid;};var geom=f.geometry;if(f.layer.projection&&f.layer.map.projection&&f.layer.projection.getCode()!=f.layer.map.projection.getCode()){geom=geom.clone();geom.transform(f.layer.map.projection,f.layer.projection);};if(!data.nunaliit_geom)data.nunaliit_geom={nunaliit_type:'geometry'};data.nunaliit_geom.wkt=geom.toString();var bbox=geom.getBounds();data.nunaliit_geom.bbox=[bbox.left,bbox.bottom,bbox.right,bbox.top];result.push(data);};return result;},CLASS_NAME:"OpenLayers.Format.Couch"});OpenLayers.Protocol.Couch=OpenLayers.Class(OpenLayers.Protocol,{documentSource:null,layerName:null,callback:null,scope:null,notifications:null,wildcarded:false,sourceProjection:null,dbProjection:null,initialize:function(options){options=options||{};if(!options.format){options.format=new OpenLayers.Format.Couch();};if(!options.dbProjection){options.dbProjection=new OpenLayers.Projection('EPSG:4326');};OpenLayers.Protocol.prototype.initialize.apply(this,arguments);},destroy:function(){OpenLayers.Protocol.prototype.destroy.apply(this);},read:function(options){var _this=this;if(this.notifications&&this.notifications.readStart){this.notifications.readStart();};OpenLayers.Protocol.prototype.read.apply(this,arguments);options=OpenLayers.Util.applyDefaults(options,this.options);var resp=new OpenLayers.Protocol.Response({requestType:'read'});var bounds=this.getBboxFromFilter(options.filter);var fids=this.getFidsFromFilter(options.filter);var layerName=('string'===typeof(options.layerName)?options.layerName:null);var projectionCode=null;if(this.sourceProjection){projectionCode=this.sourceProjection.getCode();};this.documentSource.getDocumentsFromGeographicFilter({docIds:fids,layerId:layerName,bbox:bounds,projectionCode:projectionCode,onSuccess:function(docs){_this.handleRead(resp,options,docs);},onError:function(errorMsg){$n2.log(errorMsg);if(_this.notifications&&_this.notifications.readEnd){_this.notifications.readEnd();};}});return resp;},handleRead:function(resp,options,docs){var _this=this;if(options.callback){resp.features=this.format.read(docs);if(this.sourceProjection&&this.dbProjection&&this.sourceProjection.getCode()!==this.dbProjection.getCode()){for(var i=0,e=resp.features.length;i<e;++i){resp.features[i].geometry.transform(this.dbProjection,this.sourceProjection);};};$n2.olUtils.sortFeatures(resp.features);resp.code=OpenLayers.Protocol.Response.SUCCESS;options.callback.call(options.scope,resp);window.setTimeout(function(){if(_this.notifications&&_this.notifications.readEnd){_this.notifications.readEnd();};},0);};},create:function(features,options){options=OpenLayers.Util.applyDefaults(options,this.options);var documents=this.format.write(features);if(options.layerName){for(var i=0,e=documents.length;i<e;++i){var doc=documents[i];if(!doc.nunaliit_layers){doc.nunaliit_layers=[];};if(jQuery.inArray(options.layerName,doc.nunaliit_layers)<0){doc.nunaliit_layers.push(options.layerName);};};};var resp=new OpenLayers.Protocol.Response({reqFeatures:features,requestType:"create"});var _this=this;this.db.bulkDocuments(documents,{onSuccess:function(docIds){_this.handleCreate(resp,options,docIds);},onError:function(errorMsg){$n2.reportError(errorMsg);}});return resp;},handleCreate:function(resp,options,docIds){var features=resp.reqFeatures;var insertedFeatures=[];if(features.length!=docIds.length){$n2.reportError($n2.ERROR_NO_SUPRESS,'Invalid feature bulk create');}else{for(var i=0,e=docIds.length;i<e;++i){var f=features[i];var d=docIds[i];if(d.error){if(d.reason){$n2.reportError($n2.ERROR_NO_SUPRESS,d.error+' : '+d.reason);}else{$n2.reportError($n2.ERROR_NO_SUPRESS,d.error);};}else{f.fid=d.id;if(f.data){f.data._id=d.id;f.data._rev=d.rev;};if(f.attribute){f.attribute._id=d.id;f.attribute._rev=d.rev;};insertedFeatures.push(f);};};};if(options.callback&&insertedFeatures.length>0){resp.features=insertedFeatures;resp.code=OpenLayers.Protocol.Response.SUCCESS;options.callback.call(options.scope,resp);}},update:function(feature,options){options=options||{};options=OpenLayers.Util.applyDefaults(options,this.options);var documents=this.format.write([feature]);var resp=new OpenLayers.Protocol.Response({reqFeatures:feature,requestType:"update"});var _this=this;this.db.updateDocument({data:documents[0],onSuccess:function(docInfo){_this.handleUpdate(resp,options,docInfo);},onError:function(errorMsg){$n2.reportError(errorMsg);}});return resp;},handleUpdate:function(resp,options,docInfo){var feature=resp.reqFeatures;if(feature.data){feature.data._rev=docInfo.rev;};if(feature.attribute){feature.attribute._rev=docInfo.rev;};if(options.callback){resp.features=[feature];resp.code=OpenLayers.Protocol.Response.SUCCESS;options.callback.call(options.scope,resp);}},"delete":function(feature,options){options=options||{};options=OpenLayers.Util.applyDefaults(options,this.options);var resp=new OpenLayers.Protocol.Response({reqFeatures:feature,requestType:"delete"});var _this=this;this.db.deleteDocument({data:feature.data,onSuccess:function(docInfo){_this.handleDelete(resp,options,docInfo);},onError:function(errorMsg){$n2.reportError(errorMsg);}});return resp;},handleDelete:function(resp,options){if(options.callback){resp.code=OpenLayers.Protocol.Response.SUCCESS;options.callback.call(options.scope,resp);}},commit:function(features,options){options=OpenLayers.Util.applyDefaults(options,this.options);var resp=[],nResponses=0;var types={};types[OpenLayers.State.INSERT]=[];types[OpenLayers.State.UPDATE]=[];types[OpenLayers.State.DELETE]=[];var feature,list,requestFeatures=[];for(var i=0,len=features.length;i<len;++i){feature=features[i];list=types[feature.state];if(list){list.push(feature);requestFeatures.push(feature);}}
var nRequests=(types[OpenLayers.State.INSERT].length>0?1:0)+
types[OpenLayers.State.UPDATE].length+
types[OpenLayers.State.DELETE].length;var success=true;var finalResponse=new OpenLayers.Protocol.Response({reqFeatures:requestFeatures});function insertCallback(response){var len=response.features?response.features.length:0;var fids=new Array(len);for(var i=0;i<len;++i){fids[i]=response.features[i].fid;}
finalResponse.insertIds=fids;callback.apply(this,[response]);}
function callback(response){this.callUserCallback(response,options);success=success&&response.success();nResponses++;if(nResponses>=nRequests){if(options.callback){finalResponse.code=success?OpenLayers.Protocol.Response.SUCCESS:OpenLayers.Protocol.Response.FAILURE;options.callback.apply(options.scope,[finalResponse]);}}}
var queue=types[OpenLayers.State.INSERT];if(queue.length>0){resp.push(this.create(queue,OpenLayers.Util.applyDefaults({callback:insertCallback,scope:this},options.create)));}
queue=types[OpenLayers.State.UPDATE];for(var i=queue.length-1;i>=0;--i){resp.push(this.update(queue[i],OpenLayers.Util.applyDefaults({callback:callback,scope:this},options.update)));}
queue=types[OpenLayers.State.DELETE];for(var i=queue.length-1;i>=0;--i){resp.push(this["delete"](queue[i],OpenLayers.Util.applyDefaults({callback:callback,scope:this},options["delete"])));}
return resp;},abort:function(response){if(response){}},callUserCallback:function(resp,options){var opt=options[resp.requestType];if(opt&&opt.callback){opt.callback.call(opt.scope,resp);}},getBboxFromFilter:function(filter){if(!filter)return null;if(filter.type===OpenLayers.Filter.Spatial.BBOX){return[filter.value.left,filter.value.bottom,filter.value.right,filter.value.top]}
if(filter.filters){for(var i=0,e=filter.filters.length;i<e;++i){var bounds=this.getBboxFromFilter(filter.filters[i]);if(bounds)return bounds;}}
return null;},getFidsFromFilter:function(filter){if(!filter)return null;if(filter.CLASS_NAME==='OpenLayers.Filter.FeatureId'){return filter.fids;}
if(filter.filters){for(var i=0,e=filter.filters.length;i<e;++i){var fids=this.getFidsFromFilter(filter.filters[i]);if(fids)return fids;}}
return null;},CLASS_NAME:"OpenLayers.Protocol.Couch"});(function(){var o=OpenLayers.Protocol.Couch.COMP_TYPE_TO_OP_STR={};o[OpenLayers.Filter.Comparison.EQUAL_TO]="eq";o[OpenLayers.Filter.Comparison.NOT_EQUAL_TO]="ne";o[OpenLayers.Filter.Comparison.LESS_THAN]="lt";o[OpenLayers.Filter.Comparison.LESS_THAN_OR_EQUAL_TO]="lte";o[OpenLayers.Filter.Comparison.GREATER_THAN]="gt";o[OpenLayers.Filter.Comparison.GREATER_THAN_OR_EQUAL_TO]="gte";o[OpenLayers.Filter.Comparison.LIKE]="ilike";})();})(jQuery,nunaliit2);;(function($n2){var configuration=null;var pendingRequests=[];var processingRequests=false;function uploadRequest(request){var userName=null;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext){userName=sessionContext.name;};var nowTime=(new Date()).getTime();var data={nunaliit_type:'translationRequest',nunaliit_schema:'translationRequest',str:request.str,lang:request.lang,packageName:request.packageName};if(userName){data.nunaliit_created={nunaliit_type:'actionstamp',name:userName,time:nowTime,action:'created'};data.nunaliit_last_updated={nunaliit_type:'actionstamp',name:userName,time:nowTime,action:'updated'};configuration.db.createDocument({data:data,onSuccess:verifyRequests,onError:function(errorMsg){$n2.reportError(errorMsg);verifyRequests();}});}else{$n2.log('User not logged in. Translation requests ignored.');};};function verifyRequests(){if(pendingRequests.length<1){processingRequests=false;return;};var request=pendingRequests.shift();var startkey=[request.lang,request.str];configuration.designDoc.queryView({viewName:configuration.lookupViewName,startkey:startkey,endkey:startkey,onSuccess:function(results){if(results.length<1){uploadRequest(request);}else{verifyRequests();}},onError:function(errorMsg){$n2.log(errorMsg);verifyRequests();}});};function processPendingRequests(){if(configuration&&pendingRequests.length>0&&false==processingRequests){processingRequests=true;verifyRequests();};};function sendTranslationRequest(request){$n2.log('Translate '+request.str+' to '+request.lang+' ('+request.packageName+')');pendingRequests.push(request);processPendingRequests();};function loadTranslatedStrings(){var lang=$n2.l10n.getLocale().lang;var url=configuration.designDoc.ddUrl
+'_list/'+configuration.scriptList
+'/'+configuration.translatedViewName
+'?startkey="'+lang
+'"&endkey="'+lang
+'"'
+'&include_docs=true&reduce=false';if($n2.scripts){var coreLocation=$n2.scripts.getCoreScriptLocation();$n2.scripts.loadScript(url,coreLocation);};};var defaultOptions={db:null,designDoc:null,lookupViewName:'l10n-all',translatedViewName:'l10n-translated',scriptList:'l10n'};function Configure(opt_){configuration=$n2.extend({},defaultOptions,opt_);loadTranslatedStrings();processPendingRequests();};function getLocalizedString(str,packageName,args){if(typeof(str)==='string'){return $n2.l10n.getLocalizedString(str,packageName,args);};if(str.nunaliit_type==='localized'){var locale=$n2.l10n.getLocale();var lang=locale.lang;if(typeof(str[lang])==='string'){var result=str[lang];if(args&&args.length>0){result=$n2.utils.formatString(result,args);};result.nunaliit_lang=lang;return result;};if(typeof(str.en)==='string'){var result=str.en;if(args&&args.length>0){result=$n2.utils.formatString(result,args);};result.nunaliit_lang='en';result.nunaliit_lang_fallback=true;return result;};for(var fbLang in str){if('nunaliit_type'===fbLang){}else{var result=str[fbLang];if(args&&args.length>0){result=$n2.utils.formatString(result,args);};result.nunaliit_lang=fbLang;result.nunaliit_lang_fallback=true;return result;};};};return null;};$n2.l10n.sendTranslationRequest=sendTranslationRequest;$n2.couchL10n={Configure:Configure,getLocalizedString:getLocalizedString};})(nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};function adjustDocument(doc){$n2.couchDocument.adjustDocument(doc);};function isAdmin(){var admin=false;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext&&sessionContext.roles){if($n2.inArray('_admin',sessionContext.roles)!==-1){admin=true;};if($n2.inArray('administrator',sessionContext.roles)!==-1){admin=true;};if(typeof(n2atlas)==='object'&&typeof(n2atlas.name)==='string'){var dbAdmin=n2atlas.name+'_administrator';if($n2.inArray(dbAdmin,sessionContext.roles)!==-1){admin=true;};};};return admin;};function canEditDoc(data){if(isAdmin()){return true;};var userName=null;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext){userName=sessionContext.name;};if(data.nunaliit_created&&data.nunaliit_created.nunaliit_type&&data.nunaliit_created.nunaliit_type==='actionstamp'&&data.nunaliit_created.name===userName){return true;};return false;};function canDeleteDoc(data){if(isAdmin()){return true;};var userName=null;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext){userName=sessionContext.name;};if(data.nunaliit_created&&data.nunaliit_created.nunaliit_type&&data.nunaliit_created.nunaliit_type==='actionstamp'&&data.nunaliit_created.name===userName){return true;};return false;};function documentContainsMedia(doc){var containsMedia=false;if(doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){containsMedia=true;};};return containsMedia;};function documentContainsApprovedMedia(doc){var containsApprovedMedia=false;if(doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){var att=doc.nunaliit_attachments.files[attName];if(att.status==='approved'||att.status==='attached'){containsApprovedMedia=true;};};};return containsApprovedMedia;};function documentContainsDeniedMedia(doc){var containsDeniedMedia=false;if(doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){var att=doc.nunaliit_attachments.files[attName];if(att.status==='denied'){containsDeniedMedia=true;};};};return containsDeniedMedia;};$n2.couchMap={adjustDocument:adjustDocument,isAdmin:isAdmin,canEditDoc:canEditDoc,canDeleteDoc:canDeleteDoc,documentContainsMedia:documentContainsMedia,documentContainsApprovedMedia:documentContainsApprovedMedia,documentContainsDeniedMedia:documentContainsDeniedMedia};})(nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var addContributionSchema=new $n2.form.Schema({title:null,okButton:true,cancelButton:true,attributes:[{name:'title',label:_loc('Title'),selector:'nunaliit_contribution.title',type:'text',className:'contributionTitle',description:'The title of the contribution'},{name:'description',label:_loc('Description'),selector:'nunaliit_contribution.description',type:'textarea',className:'contributionDescription',description:'The creator of the entity'},{name:'media',label:_loc('Media'),type:'file',description:'Media associated with contribution'}]});var defaultOptions={db:null,designDoc:null,showService:null,uploads:null,searchView:'upload-type-text-search',contributionFromReferenceView:'contributions',addContributionSchema:addContributionSchema};$n2.couchContributions=$n2.Class({options:null,lookAheadCounter:null,lookAheadMap:null,initialize:function(options_){this.options=$n2.extend({},defaultOptions,options_);this.lookAheadCounter=0;this.lookAheadMap={};},performContributionSearch:function(opts_){var opt=$n2.extend({searchTerms:null,uploadType:null,searchLimit:25,docsOnly:true,onSuccess:function(docs){},onError:function(error){}},opts_);var searchTerms=opt.searchTerms;var searchResults={pending:searchTerms.length,map:{},sorted:[]};for(var i=0,e=searchTerms.length;i<e;++i){this.options.designDoc.queryView({viewName:this.options.searchView,startkey:[opt.uploadType,searchTerms[i],0],endkey:[opt.uploadType,searchTerms[i],{}],limit:opt.searchLimit,onSuccess:function(rows){ReportSearchResults(rows);}});};function ReportSearchResults(rows){--searchResults.pending;for(var i=0,e=rows.length;i<e;++i){var doc=rows[i].value;var index=rows[i].key[2];if(searchResults.map[doc._id]){var m=searchResults.map[doc._id];++m.terms;if(m.index>index)m.index=index;}else{var m={doc:doc,id:doc._id,index:index,terms:1};searchResults.map[doc._id]=m;searchResults.sorted.push(m);}};if(searchResults.pending>0)return;searchResults.sorted.sort(function(a,b){if(a.terms>b.terms){return-1;}else if(a.terms<b.terms){return 1;}else{if(a.index<b.index){return-1;}else if(a.index>b.index){return 1;};};return 0;});var result=[];for(var i=0,e=searchResults.sorted.length;i<e;++i){if(i>opt.searchLimit)break;var m=searchResults.sorted[i];if(opt.docsOnly){result.push(m.doc);}else{result.push(m);};};opt.onSuccess(result);};},displayContributionSelection:function($elem,contributionDocs,opts_){var opt=$n2.extend({onSuccess:function(doc){},onError:function(error){}},opts_);$elem.empty();for(var i=0,e=contributionDocs.length;i<e;++i){var contributionDoc=contributionDocs[i];var $div=$('<div class="couchContributionSelect" style="border:1px solid #000000"></div>');$elem.append($div);this.displayContribution($div,contributionDoc);installSelection($div,contributionDoc);}
function installSelection($div,contributionDoc){$div.click(function(){opt.onSuccess(contributionDoc);});}},displayContribution:function($elem,contributionDoc){$elem.empty();var docUrl=this.options.db.getDocumentUrl(contributionDoc);if(contributionDoc.converted){var linkDiv=null;if(contributionDoc.gcrc_upload_type==='image'&&contributionDoc.thumbnail){linkDiv=$('<div class="contribution_media_icon_wrapper"><img src="'+docUrl+'/thumbnail"/></div>');}else if(contributionDoc.gcrc_upload_type==='image'){linkDiv=$('<div class="contribution_media_icon_wrapper"><div class="contribution_media_icon contribution_image_icon"></div></div>');}else if(contributionDoc.gcrc_upload_type==='audio'){linkDiv=$('<div class="contribution_media_icon_wrapper"><div class="contribution_media_icon contribution_audio_icon"></div></div>');}else if(contributionDoc.gcrc_upload_type==='video'&&contributionDoc.thumbnail){linkDiv=$('<div class="contribution_media_icon_wrapper"><img src="'+docUrl+'/thumbnail"/></div>');}else if(contributionDoc.gcrc_upload_type==='video'){linkDiv=$('<div class="contribution_media_icon_wrapper"><div class="contribution_media_icon contribution_video_icon"></div></div>');};if(null!=linkDiv){$elem.append(linkDiv);var cb=createMediaCallback(contributionDoc.gcrc_upload_type,docUrl,contributionDoc);linkDiv.click(cb);};};if(contributionDoc.nunaliit_contribution&&contributionDoc.nunaliit_contribution.nunaliit_type&&contributionDoc.nunaliit_contribution.nunaliit_type=='contribution'){if(contributionDoc.nunaliit_contribution.title){$elem.append($('<div>'+_loc('Title')+': '+contributionDoc.nunaliit_contribution.title+'</div>'));};if(contributionDoc.nunaliit_contribution.description){$elem.append($('<div>'+_loc('Description')+': '+contributionDoc.nunaliit_contribution.description+'</div>'));};};$elem.append($('<div>'+_loc('id')+': '+contributionDoc._id+'</div>'));if(contributionDoc.original){$elem.append($('<div>file: '+contributionDoc.original.name+' ('+contributionDoc.original.mimeType+')</div>'));};var createdByUser=null;var createdTime=null;if(contributionDoc.nunaliit_created){if(contributionDoc.nunaliit_created.name){createdByUser=contributionDoc.nunaliit_created.name;var $createdByDiv=$('<div>'+_loc('Created by')+': <span></span></div>');if(this.options.showService){this.options.showService.printUserName($createdByDiv.find('span'),createdByUser,{showHandle:true});}else{$createdByDiv.find('span').text(createdByUser);};if(contributionDoc.nunaliit_created.time){createdTime=contributionDoc.nunaliit_created.time;var dateStr=(new Date(createdTime)).toString();$createdByDiv.append($('<span> on '+dateStr+'</span>'));};$elem.append($createdByDiv);};};if(contributionDoc.nunaliit_last_updated){if(contributionDoc.nunaliit_last_updated.name){var lastUpdatedByUser=contributionDoc.nunaliit_last_updated.name;var lastUpdatedTime=contributionDoc.nunaliit_last_updated.time;if(lastUpdatedByUser!=createdByUser||lastUpdatedTime!=createdTime){var $lastUpdatedDiv=$('<div>'+_loc('Last updated by')+': <span></span></div>');if(this.options.showService){this.options.showService.printUserName($lastUpdatedDiv.find('span'),lastUpdatedByUser,{showHandle:true});}else{$lastUpdatedDiv.find('span').text(lastUpdatedByUser);};if(lastUpdatedTime){var dateStr=(new Date(lastUpdatedTime)).toString();$lastUpdatedDiv.append($('<span> on '+dateStr+'</span>'));};$elem.append($lastUpdatedDiv);};};};$elem.append($('<div style="clear:both"></div>'));function createMediaCallback(uploadType,docUrl,doc){return function(){var mediaOptions={url:docUrl+'/converted'};if(doc.nunaliit_contribution&&doc.nunaliit_contribution.title){mediaOptions.title=doc.nunaliit_contribution.title;};if(doc.nunaliit_created&&doc.nunaliit_created.name){mediaOptions.author=doc.nunaliit_created.name;};if(doc.nunaliit_contribution&&doc.nunaliit_contribution.description){mediaOptions.description=doc.nunaliit_contribution.description;};if(uploadType==='image'){mediaOptions.type='image';$n2.mediaDisplay.displayMedia(mediaOptions);}else if(uploadType==='video'){mediaOptions.type='video';$n2.mediaDisplay.displayMedia(mediaOptions);}else if(uploadType==='audio'){mediaOptions.type='audio';$n2.mediaDisplay.displayMedia(mediaOptions);};};};},searchTextBox:function(opt_){var _this=this;var opt=$n2.extend({elem:null,lookAheadView:'text-lookahead',lookAheadList:'text-lookahead',lookAheadLimit:5,lookAheadPrefixMin:3,lookAheadCacheSize:10,onSuccess:function(terms){}},opt_);var $elem=opt.elem;if(typeof($elem)==='string'){$elem=$('#'+$elem);}else{$elem=$($elem);};var $lookUpDiv=$('<div class="couchLookahead"></div>');var divider=$('<div class="couchLookaheadDivider"></div>');divider.append($lookUpDiv);var $input=$('<input type="text"/>');var holder=$('<div></div>');holder.append($input).append(divider);$elem.empty().append(holder);var skipKeyUp=false;$input.keypress(SearchInputKeyPressed);$input.keyup(SearchInputKeyUp);function SearchInputKeyPressed(evt){var charCode=null;if(null!=evt&&null!=evt.which){charCode=evt.which;}else if(null!=window.event&&null!=window.event.keyCode){charCode=window.event.keyCode;};if(13==charCode||null==charCode){ProcessSearchInput();};};function SearchInputKeyUp(evt){if(skipKeyUp){skipKeyUp=false;}else{ProcessLookAhead();};};function ProcessSearchInput(){skipKeyUp=true;var searchTerms=GetSearchTerms();opt.onSuccess(searchTerms);CloseLookAhead();};function ProcessLookAhead(){var searchTerms=GetSearchTerms();var index=searchTerms.length-1;if(index>=0){var lastTerm=searchTerms[index];var previousWords=null;if(index>0){previousWords=searchTerms.slice(0,index);};};if(!lastTerm){CloseLookAhead();return;};if(lastTerm.length<opt.lookAheadPrefixMin){CloseLookAhead();return;};var previousWordsString='';if(previousWords){previousWordsString=previousWords.join(' ')+' ';};QueryLookAhead(lastTerm,function(prefix,words){$lookUpDiv.empty();if(words.length>0){$lookUpDiv.css('display','block');}else{$lookUpDiv.css('display','none');};for(var i=0,e=words.length;i<e;++i){var offered=words[i].substring(prefix.length);var line=$('<div class="couchLookaheadLine '
+(i%2?'couchLookaheadLineOdd':'couchLookaheadLineEven')+'">'
+'<span class="couchLookaheadTyped">'
+previousWordsString+prefix+'</span>'
+'<span class="offered">'+offered+'</span>'
+'</div>');installClick(line,previousWordsString+words[i]);$lookUpDiv.append(line);};});function installClick($elem,wordString){$elem.click(function(){$input.val(wordString);var terms=wordString.split(' ');opt.onSuccess(terms);CloseLookAhead();});};};function CloseLookAhead(){$lookUpDiv.css('display','none');};function GetSearchTerms(){var searchTerms=$input.val();searchTerms=searchTerms.split(/[ \t\r\n]+/);return searchTerms;};function QueryLookAhead(prefix,callback){if(_this.lookAheadMap[prefix]){callback(prefix,_this.lookAheadMap[prefix].words);return;};var sub=prefix.substring(0,prefix.length-1);while(sub.length>=opt.lookAheadPrefixMin){if(_this.lookAheadMap[sub]&&_this.lookAheadMap[sub].full){callback(prefix,_this.lookAheadMap[sub].words);return;};sub=sub.substring(0,sub.length-1);};_this.options.designDoc.queryView({viewName:opt.lookAheadView,listName:opt.lookAheadList,startkey:prefix,endkey:prefix+'\u9999',top:opt.lookAheadLimit,group:true,onlyRows:false,reduce:true,onSuccess:function(response){var rows=response.rows;var words=[];for(var i=0,e=rows.length;i<e;++i){words.push(rows[i][0]);};_this.lookAheadMap[prefix]={prefix:prefix,words:words,full:response.all_rows,counter:_this.lookAheadCounter};++_this.lookAheadCounter;var keysToDelete=[];for(var key in _this.lookAheadMap){if(_this.lookAheadMap[key].counter<(_this.lookAheadCounter-opt.lookAheadCacheSize)){keysToDelete.push(key);};};for(var i=0,e=keysToDelete.length;i<e;++i){delete _this.lookAheadMap[keysToDelete[i]];};callback(prefix,words);}});};},searchContributions:function(opt_){var _this=this;var opt=$n2.extend({elem:null,uploadType:null,onSuccess:function(selectedContribution){}},opt_);var $elem=opt.elem;if(typeof($elem)==='string'){$elem=$('#'+$elem);}else{$elem=$($elem);};var $search=$('<div></div>');var $result=$('<div></div>');$elem.empty().append($search).append($result);this.searchTextBox({elem:$search,onSuccess:function(terms){_this.performContributionSearch({searchTerms:terms,uploadType:opt.uploadType,onSuccess:receiveContributions});}});function receiveContributions(contributions){_this.displayContributionSelection($result,contributions,{onSuccess:selectedContribution});}
function selectedContribution(contribution){$elem.empty();opt.onSuccess(contribution);}},getContributionsForReference:function(opt_){var _this=this;var opt=$n2.extend({docId:null,onSuccess:function(contributions){},onError:function(err){$n2.reportError(err);}},opt_);var docId=opt.docId;if(null==docId){opt.onError('DocId must be supplied when contributions are retrieved');return;};this.options.designDoc.queryView({viewName:this.options.contributionFromReferenceView,startkey:docId,endkey:docId,onSuccess:function(rows){var contributions=[];for(var i=0,e=rows.length;i<e;++i){contributions.push(rows[i].value);};opt.onSuccess(contributions);},onError:opt.onError});},buildAddContributionForm:function(opt_){var _this=this;var opt=$n2.extend({elem:null,referenceDocId:null,replyContributionId:null,onSuccess:function(){},onCancel:function(){}},opt_);var $elem=opt.elem;if(typeof($elem)==='string'){$elem=$('#'+$elem);}else{$elem=$($elem);};var contributionDoc={nunaliit_contribution:{nunaliit_type:'contribution'}};if(opt.referenceDocId){contributionDoc.nunaliit_contribution.reference={nunaliit_type:'reference',doc:opt.referenceDocId};};if(opt.replyContributionId){contributionDoc.nunaliit_contribution.reply={nunaliit_type:'reference',doc:opt.replyContributionId};};$n2.couchDocument.adjustDocument(contributionDoc);var form=this.options.addContributionSchema.createForm($elem,contributionDoc,{preOK:function(){_this.options.uploads.getWelcome({onSuccess:function(welcomeData){_this.options.db.createDocument({data:contributionDoc,onSuccess:function(docInfo){var $form=$(form.form);$form.prepend($('<input type="hidden" name="id" value="'+docInfo.id+'"/>'));$form.prepend($('<input type="hidden" name="rev" value="'+docInfo.rev+'"/>'));_this.options.uploads.submitForm({form:$form,onSuccess:opt.onSuccess,onError:function(err){$n2.reportError('Error uploading file: '+err);}});},onError:function(err){$n2.reportError('Unable to reach database to submit document: '+err);}});},onError:function(){$n2.reportError('Unable to reach atlas server');}});return false;},postCancel:opt.onCancel});}});})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchRequests';$n2.couchRequests=$n2.Class({options:null,currentRequests:null,scheduled:null,userListeners:null,documentListeners:null,initialize:function(options_){this.options=$n2.extend({},{documentSource:null,userDb:null,dispatchService:null,userServerUrl:null},options_);var _this=this;this.currentRequests={};this.scheduled=false;this.userListeners=[];this.documentListeners=[];if(this.options.dispatchService){var f=function(m){_this._handleMessage(m);};this.options.dispatchService.register(DH,'requestDocument',f);this.options.dispatchService.register(DH,'requestUserDocument',f);this.options.dispatchService.register(DH,'requestUserDocumentComplete',f);};},addUserListener:function(listener){if(typeof(listener)==='function'){this.userListeners.push(listener);};},addDocumentListener:function(listener){if(typeof(listener)==='function'){this.documentListeners.push(listener);};},requestUser:function(userName){if(!this.currentRequests.users){this.currentRequests.users={};};this.currentRequests.users[userName]=1;this._schedule();},requestCompleteUserDocument:function(userName){if(!this.currentRequests.completeUsers){this.currentRequests.completeUsers={};};this.currentRequests.completeUsers[userName]=1;this._schedule();},requestDocument:function(docId,cbFn){if(!this.currentRequests.docs){this.currentRequests.docs={};};if(!this.currentRequests.docs[docId]){this.currentRequests.docs[docId]=[];};if(cbFn){this.currentRequests.docs[docId].push(cbFn);};this._schedule();},_schedule:function(){if(this.scheduled)return;var _this=this;this.scheduled=true;setTimeout(function(){_this.scheduled=false;_this._performRequests();},0);},_performRequests:function(){var _this=this;var requests=this.currentRequests;this.currentRequests={};if(requests.users&&this.options.userServerUrl){var params=[];for(var userName in requests.users){params.push({name:'user',value:userName});};var url=this.options.userServerUrl+'getUsers';$.ajax({url:url,type:'GET',async:true,traditional:true,data:params,dataType:'json',success:function(result){if(result.users){for(var i=0,e=result.users.length;i<e;++i){var user=result.users[i];_this._callUserListeners(user);};};},error:function(XMLHttpRequest,textStatus,errorThrown){}});}else if(requests.users&&this.options.userDb){for(var userName in requests.users){this.options.userDb.getUser({name:userName,onSuccess:function(user){_this._callUserListeners(user);},onError:function(err){}});};};if(requests.completeUsers&&this.options.userServerUrl){var params=[];for(var userName in requests.completeUsers){params.push({name:'user',value:userName});};var url=this.options.userServerUrl+'getUserDocuments';$.ajax({url:url,type:'GET',async:true,traditional:true,data:params,dataType:'json',success:function(result){if(result.users){for(var i=0,e=result.users.length;i<e;++i){var user=result.users[i];_this._callCompleteUserListeners(user);};};},error:function(XMLHttpRequest,textStatus,errorThrown){}});};var cachedDocs=null;if(requests.docs&&this.options.documentSource){var docIds=[];for(var docId in requests.docs){var cachedDoc=this._getCachedDoc(docId);if(cachedDoc){if(!cachedDocs){cachedDocs=[];};cachedDocs.push(cachedDoc);}else{docIds.push(docId);};};if(docIds.length){this.options.documentSource.getDocuments({docIds:docIds,onSuccess:function(docs){_this._callDocumentListeners(docs,requests);}});};};if(null!==cachedDocs){this._callDocumentListeners(cachedDocs,requests);};},_callUserListeners:function(userDoc){this._dispatch({type:'userInfo',userInfo:userDoc});for(var j=0,f=this.userListeners.length;j<f;++j){var listener=this.userListeners[j];listener(userDoc);};},_callCompleteUserListeners:function(userDoc){this._dispatch({type:'userDocument',userDoc:userDoc});},_callDocumentListeners:function(docs,requests){for(var i=0,e=docs.length;i<e;++i){var doc=docs[i];this._dispatch({type:'documentVersion',docId:doc._id,rev:doc._rev});this._dispatch({type:'documentContent',docId:doc._id,doc:doc});for(var j=0,f=this.documentListeners.length;j<f;++j){var listener=this.documentListeners[j];listener(doc);};var docId=doc._id;if(requests.docs&&requests.docs[docId]){for(var j=0,f=requests.docs[docId].length;j<f;++j){var listener=requests.docs[docId][j];listener(doc);};};};},_getDispatcher:function(){var d=null;if(this.options.dispatchService){d=this.options.dispatchService;};return d;},_dispatch:function(m){var dispatcher=this._getDispatcher();if(dispatcher){dispatcher.send(DH,m);};},_handleMessage:function(m){if('requestDocument'===m.type){var docId=m.docId;this.requestDocument(docId);}else if('requestUserDocument'===m.type){var userId=m.userId;this.requestUser(userId);}else if('requestUserDocumentComplete'===m.type){var userId=m.userId;this.requestCompleteUserDocument(userId);};},_getCachedDoc:function(docId){var dispatcher=this._getDispatcher();if(dispatcher){var m={type:'cacheRetrieveDocument',docId:docId,doc:null};dispatcher.synchronousCall(DH,m);if(m.doc){return m.doc;};};return null;}});})(jQuery,nunaliit2);;(function($,$n2){var DH='n2.couch.sound';function defaultInstallSound(info){};function defaultHandleDocumentSound(info_,cb_){cb_(info_);};var HoverSoundService=$n2.Class({options:null,dispatcher:null,requestService:null,currentFocusSoundDocId:null,initialize:function(options_){var _this=this;this.options=$n2.extend({db:null,serviceDirectory:null,handleDocumentSound:defaultHandleDocumentSound},options_);this.currentFocusSoundDocId=null;if(this.options.serviceDirectory){this.dispatcher=this.options.serviceDirectory.dispatchService;this.requestService=this.options.serviceDirectory.requestService;};if(this.dispatcher){var f=function(m){_this._handleDispatch(m);};this.dispatcher.register(DH,'focusOn',f);this.dispatcher.register(DH,'focusOff',f);this.dispatcher.register(DH,'playHoverSoundOn',f);this.dispatcher.register(DH,'playHoverSoundOff',f);this.dispatcher.register(DH,'playSoundOn',f);this.dispatcher.register(DH,'playSoundOff',f);};},handleFeatureHover:function(feature,opts_){if(!feature)return;var data=feature.attributes;if(!data){data=feature.data;};if(!data){return;};this.findDocumentHoverSound(data,opts_);},findDocumentHoverSound:function(data,opts_){var opts=$n2.extend({installSoundFn:defaultInstallSound,handleDocumentSound:this.options.handleDocumentSound},opts_);var _this=this;if(!data)return;var info={docId:data._id,doc:data,soundUrl:null,installSoundFn:opts.installSoundFn};opts.handleDocumentSound(info,function(info_){_this._defaultDocumentSound(info_);});},_defaultDocumentSound:function(info){var _this=this;if(info.soundUrl){info.installSoundFn(info);}else{GetHoverSoundUrlFromDocument({db:this.options.db,serviceDirectory:this.options.serviceDirectory,doc:info.doc,onSuccess:function(soundUrl){info.soundUrl=soundUrl;info.installSoundFn(info);}});};},_handleDispatch:function(m){var _this=this;if(m.type==='focusOn'){if(m.doc){if(this.currentFocusSoundDocId){this._removeFocusSound(this.currentFocusSoundDocId);};this.currentFocusSoundDocId=m.doc._id;this.findDocumentHoverSound(m.doc,{installSoundFn:function(info){_this._installFocusSound(info);}});}else if(m.docId){if(this.currentFocusSoundDocId){this._removeFocusSound(this.currentFocusSoundDocId);};this.currentFocusSoundDocId=m.docId;if(this.requestService){this.requestService.requestDocument(m.docId,function(doc){_this.findDocumentHoverSound(doc,{installSoundFn:function(info){_this._installFocusSound(info);}});});};};}else if(m.type==='focusOff'){if(m.doc){this._removeFocusSound(m.doc._id);}else if(m.docId){this._removeFocusSound(m.docId);};}else if(m.type==='playHoverSoundOn'){if(m.doc){this._initiatePlaySound(m.doc._id);this.findDocumentHoverSound(m.doc,{installSoundFn:function(info){_this._installPlaySound(info);}});};}else if(m.type==='playHoverSoundOff'){if(m.doc){this._removePlaySound(m.doc._id);};}else if(m.type==='playSoundOn'){if(m.id&&m.url){this._initiatePlaySound(m.id);var info={docId:m.id,soundUrl:m.url};this._installPlaySound(info);};}else if(m.type==='playSoundOff'){if(m.id){this._removePlaySound(m.id);};};},_installFocusSound:function(info){var docId=info.docId;var url=info.soundUrl;if(url&&this.currentFocusSoundDocId===docId){var $div=this._getFocusSoundDiv();this._insertSoundElement($div,url);};},_removeFocusSound:function(docId){if(this.currentFocusSoundDocId===docId){var $div=this._getFocusSoundDiv();$div.empty();this.currentFocusSoundDocId=null;};},_initiatePlaySound:function(docId){var divId='n2CouchPlaySound_'+$n2.utils.stringToHtmlId(docId);var $div=$('#'+divId);if($div.length<1){$div=$('<div id="'+divId+'"></div>');this._getSoundDiv().append($div);};},_installPlaySound:function(info){var docId=info.docId;var url=info.soundUrl;var $div=$('#n2CouchPlaySound_'+$n2.utils.stringToHtmlId(docId));this._insertSoundElement($div,url);},_removePlaySound:function(docId){var $div=$('#n2CouchPlaySound_'+$n2.utils.stringToHtmlId(docId));$div.remove();},_getSoundDiv:function(){var $div=$('#n2CouchSound');if($div.length<1){$div=$('<div id="n2CouchSound"></div>');$('body').append($div);};return $div;},_getFocusSoundDiv:function(){var $div=$('#n2CouchFocusSound');if($div.length<1){var $parent=this._getSoundDiv();$div=$('<div id="n2CouchFocusSound"></div>');$parent.append($div);};return $div;},_insertSoundElement:function($div,url){$div.html('<embed src="'+url+'" hidden="true" autostart="true" loop="false"/>');}});var GetHoverSoundUrlFromDocument=function(opts_){var opts=$n2.extend({db:null,serviceDirectory:null,doc:null,onSuccess:function(soundUrl){},onError:function(err){}},opts_);var data=opts.doc;var requestService=null;if(opts&&opts.serviceDirectory){requestService=opts.serviceDirectory.requestService;};if(!requestService){opts.onError('Request service not available');return;};if(data.sound&&data.sound.nunaliit_type&&data.sound.nunaliit_type==='reference'&&data.sound.doc){var soundUrl=opts.db.getAttachmentUrl(data.sound.doc,'converted');opts.onSuccess(soundUrl);return;};if(data.nunaliit_attachments&&data.nunaliit_attachments.nunaliit_type==='attachment_descriptions'&&data.nunaliit_attachments.files){var hoverSoundAttName=null;for(var attName in data.nunaliit_attachments.files){var attDesc=data.nunaliit_attachments.files[attName];if(attDesc&&attDesc.data&&attDesc.data.hoverSound){hoverSoundAttName=attName;break;};};if(hoverSoundAttName){var soundUrl=opts.db.getAttachmentUrl(data,attName);opts.onSuccess(soundUrl);return;};};if(data.nunaliit_hoverSound&&data.nunaliit_hoverSound.nunaliit_type==='reference'&&data.nunaliit_hoverSound.doc){var soundDocId=data.nunaliit_hoverSound.doc;requestService.requestDocument(soundDocId,function(doc){if(doc&&doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){var attDesc=doc.nunaliit_attachments.files[attName];if(doc._attachments&&doc._attachments[attName]&&attDesc.fileClass=='audio'){var soundUrl=opts.db.getAttachmentUrl(doc._id,attName);opts.onSuccess(soundUrl);return;};};};opts.onError('Can not find sound url');});return;};opts.onError('Can not find sound url');};var DocumentContainsHoverSound=function(data){if(data.sound&&data.sound.nunaliit_type&&data.sound.nunaliit_type==='reference'&&data.sound.doc){return true;};if(data.nunaliit_attachments&&data.nunaliit_attachments.nunaliit_type==='attachment_descriptions'&&data.nunaliit_attachments.files){var hoverSoundAttName=null;for(var attName in data.nunaliit_attachments.files){var attDesc=data.nunaliit_attachments.files[attName];if(attDesc&&attDesc.data&&attDesc.data.hoverSound){hoverSoundAttName=attName;break;};};if(hoverSoundAttName){return true;};};if(data.nunaliit_hoverSound&&data.nunaliit_hoverSound.nunaliit_type==='reference'&&data.nunaliit_hoverSound.doc){return true;};return false;};$n2.couchSound={HoverSoundService:HoverSoundService,GetHoverSoundUrlFromDocument:GetHoverSoundUrlFromDocument,DocumentContainsHoverSound:DocumentContainsHoverSound};})(jQuery,nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var Notifier=$n2.Class({options:null,initialize:function(options_){this.options=$n2.extend({dbChangeNotifier:null,directory:null},options_);var _this=this;if(this.options.dbChangeNotifier){this.options.dbChangeNotifier.addListener(function(changes){_this._dbChanges(changes);});};},_dbChanges:function(changes){$n2.log('update',changes);var lastSeq=changes.last_seq;var results=changes.results;var dispatcher=this._getDispatcher();if(dispatcher){var dHandle=dispatcher.getHandle('n2.couchServerSide');for(var i=0,e=results.length;i<e;++i){var updateRecord=results[i];var isAdded=false;var latestRev=null;if(updateRecord.changes){for(var l=0,k=updateRecord.changes.length;l<k;++l){latestRev=updateRecord.changes[l].rev;if(latestRev.substr(0,2)==='1-'){isAdded=true;};};};if(latestRev){dispatcher.send(dHandle,{type:'documentVersion',docId:updateRecord.id,rev:latestRev});};if(updateRecord.deleted){dispatcher.send(dHandle,{type:'documentDeleted',docId:updateRecord.id});}else if(isAdded){dispatcher.send(dHandle,{type:'documentCreated',docId:updateRecord.id});}else{dispatcher.send(dHandle,{type:'documentUpdated',docId:updateRecord.id});};};};},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;}});$n2.couchServerSide={Notifier:Notifier,DefaultNotifier:null};})(nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchAuth';var defaultError=function(err,options){var acc=[];if(err){acc.push(''+err.message);var cause=err.cause;while(cause){acc.push('\n>'+cause.message);cause=cause.cause;};}else{acc.push(_loc('<Unknown error>'));};alert(acc.join(''));};var AuthService=$n2.Class({options:null,couchServer:null,loginStateListeners:null,lastAuthSessionCookie:null,lastSessionContext:null,userServiceAvailable:null,autoRegistrationAvailable:null,currentUserDoc:null,initialize:function(options_){var _this=this;this.options=$n2.extend({onSuccess:function(result,options){},onError:defaultError,atlasDb:null,schemaRepository:null,disableCreateUserButton:false,directory:null,listeners:null,autoRefresh:true,prompt:_loc('Please login'),refreshIntervalInSec:2,userServerUrl:null},options_);this.loginStateListeners=[];this.lastAuthSessionCookie=null;this.lastSessionContext=null;this.userServiceAvailable=false;this.autoRegistrationAvailable=false;if(this.options.atlasDb){this.couchServer=this.options.atlasDb.server;}else{$n2.log('Couch Server must be specified for CouchDb AuthService');this.options.onError(_loc('Server must be specified for CouchDb AuthService'));return;};if(this.options.listeners){this.addListeners(this.options.listeners);delete this.options.listeners;};var initOnSuccess=this.options.onSuccess;delete this.options.onSuccess;var initOnError=this.options.onError;delete this.options.onError;var optWithCallbacks=$n2.extend({},this.options,{onSuccess:initOnSuccess,onError:initOnError});this.couchServer.getSession().refreshContext({onSuccess:onSuccess,onError:onError});this.couchServer.getSession().addChangedContextListener(function(sessionContext){_this._handleSessionContextChange(sessionContext);});if(this.options.autoRefresh&&this.options.refreshIntervalInSec>0&&typeof(setInterval)==='function'){setInterval(function(){_this.couchServer.getSession().refreshContext({onError:function(){}});},(1000*this.options.refreshIntervalInSec));setInterval(function(){var cookie=$n2.cookie.getCookie('NunaliitAuth');if(cookie!==_this.lastAuthSessionCookie){_this.lastAuthSessionCookie=cookie;_this.couchServer.getSession().refreshContext({onError:function(){}});};},2000);};var dispatcher=this._getDispatcher();if(dispatcher){var fn=function(m){_this._handleEvent(m);};dispatcher.register(DH,'login',fn);dispatcher.register(DH,'loginShowForm',fn);dispatcher.register(DH,'logout',fn);dispatcher.register(DH,'authIsLoggedIn',fn);};if(this.options.userServerUrl){var url=this.options.userServerUrl;$.ajax({url:url,type:'GET',async:true,traditional:true,data:null,dataType:'json',success:function(result){_this.userServiceAvailable=true;if(result.autoRegistration){_this.autoRegistrationAvailable=true;};},error:function(XMLHttpRequest,textStatus,errorThrown){}});};function onSuccess(context){$n2.log("Login(adjustCookies) successful",context,_this.options);initOnSuccess(context,optWithCallbacks);_this._notifyListeners();};function onError(error){$n2.log('Login(adjustCookies) error: '+error);var err={message:'Problem initializing authentication library',cause:{message:error}};initOnError(err,optWithCallbacks);_this._notifyListeners();};},addListeners:function(listeners){var _this=this;var cUser=this._getCurrentListenerInfo();if(typeof(listeners)=='function'){addListener(listeners);}else if($n2.isArray(listeners)){for(var loop=0;loop<listeners.length;++loop){var listener=listeners[loop];if(typeof(listener)==='function'){addListener(listener);};};};function addListener(listener){_this.loginStateListeners.push(listener);try{listener(cUser);}catch(e){$n2.log('CouchAuthService: EXCEPTION caught in listener (add)',e);};};},_notifyListeners:function(){var context=this._getAuthContext();var userName=null;if(context){userName=context.name;};var isAdmin=false;if(context&&context.roles&&this.doRolesContainAdmin(context.roles)){isAdmin=true;};$n2.cookie.setCookie({name:'NunaliitAuth',value:userName,path:'/'});var $body=$('body');if(userName){$body.removeClass('nunaliit_logged_out');$body.addClass('nunaliit_logged_in');}else{$body.removeClass('nunaliit_logged_in');$body.addClass('nunaliit_logged_out');};if(isAdmin){$body.addClass('nunaliit_user_administrator');}else{$body.removeClass('nunaliit_user_administrator');};if(userName){this._dispatch({type:'authLoggedIn',user:context});}else{this._dispatch({type:'authLoggedOut'});};var cUser=this._getCurrentListenerInfo();for(var loop=0;loop<this.loginStateListeners.length;++loop){var listener=this.loginStateListeners[loop];if(listener){try{listener(cUser);}catch(e){$n2.log('CouchAuthService: EXCEPTION caught in listener (notify)',e);};};};},_getCurrentListenerInfo:function(){var context=this._getAuthContext();var info=null;if(context&&context.name){info={name:context.name,roles:context.roles};};return info;},login:function(opts_){var opts=$n2.extend({username:null,password:null,onSuccess:function(context){},onError:function(errMsg){}},opts_);var _this=this;var username=opts.username;var password=opts.password;if(typeof(username)!=='string'||typeof(password)!=='string'){opts.onError('Name and password must be provided when logging in');return;};if(this.userServiceAvailable){var url=this.options.userServerUrl+'getUser';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{email:username},dataType:'json',success:function(userDoc){if(userDoc.name){username=userDoc.name;};doLogin();},error:doLogin});}else{doLogin();};function doLogin(){_this.couchServer.getSession().login({name:username,password:password,onSuccess:checkUserAgreement,onError:function(err){$n2.log('Unable to log in: '+err);onError(_loc('Invalid e-mail and/or password'));}});};function checkUserAgreement(sessionResult){_this.couchServer.getUserDb().getUser({name:username,onSuccess:function(userDoc){var atlasName=_this._getAtlasName();var agreementRole='nunaliit_agreement_'+atlasName;if(userDoc&&userDoc.roles){for(var i=0,e=userDoc.roles.length;i<e;++i){var role=userDoc.roles[i];if(role===agreementRole){checkUserQuestionnaire(sessionResult,userDoc);return;};};};proposeNewUserAgreement(sessionResult,userDoc);},onError:function(err){var isAdmin=false;if(sessionResult&&sessionResult.roles){for(var i=0,e=sessionResult.roles.length;i<e;++i){var role=sessionResult.roles[i];if('_admin'===role){isAdmin=true;break;};};};if(isAdmin){checkUserQuestionnaire(sessionResult,null);}else{$n2.log('Unable to obtain user information: '+err);onError(_loc('Unable to obtain information about user'));};}});};function proposeNewUserAgreement(sessionResult,userDoc){_this.options.atlasDb.getDocument({docId:'org.nunaliit.user_agreement',onSuccess:function(doc){if(doc&&doc.nunaliit_user_agreement&&doc.nunaliit_user_agreement.content&&doc.nunaliit_user_agreement.enabled){var agreementContent=doc.nunaliit_user_agreement.content;if(typeof doc.nunaliit_user_agreement.content==='object'&&doc.nunaliit_user_agreement.content.nunaliit_type==='localized'){agreementContent=_loc(doc.nunaliit_user_agreement.content);};var accepted=false;var diagId=$n2.getUniqueId();var $diag=$('<div>').attr('id',diagId);var $content=$('<div>').addClass('n2Auth_user_agreement_dialog').appendTo($diag);$('<div>').addClass('n2Auth_user_agreement_label').text(_loc('User agreement has changed. You must accept before you can authenticate.')).appendTo($content);$('<textarea>').addClass('n2Auth_user_agreement_content').attr('readonly','readonly').val(agreementContent).appendTo($content);var $buttons=$('<div>').addClass('n2Auth_user_agreement_buttons').appendTo($content);$('<button>').addClass('n2_button_ok').text(_loc('Accept')).click(function(){accepted=true;var $diag=$('#'+diagId);$diag.dialog('close');acceptUserAgreement(agreementContent,sessionResult,userDoc);}).appendTo($buttons);$('<button>').addClass('n2_button_cancel').text(_loc('Reject')).click(function(){var $diag=$('#'+diagId);$diag.dialog('close');}).appendTo($buttons);$diag.dialog({autoOpen:true,title:_loc('User Agreement and Terms of Service'),modal:true,width:'auto',close:function(event,ui){var $diag=$('#'+diagId);$diag.remove();if(!accepted){onError(_loc('User refused agreement'));};}});}else{acceptUserAgreement('',sessionResult,userDoc);};},onError:function(err){$n2.log('Error getting user agreement: '+err);onError(_loc('Unable to obtain user agreement'));}});};function acceptUserAgreement(userAgreement,sessionResult,userDoc){var url=_this.options.userServerUrl+'acceptUserAgreement';$.ajax({url:url,type:'POST',async:true,traditional:true,data:{userAgreement:userAgreement},dataType:'json',success:function(){checkUserQuestionnaire(sessionResult,userDoc);},error:function(XMLHttpRequest,textStatus,errorThrown){onError(_loc('Error attempting to accept user agreement'));}});};function checkUserQuestionnaire(sessionResult,userDoc){if(!userDoc){onLoginCompleted(sessionResult,userDoc);return;};if(_this.options.schemaRepository){_this.options.schemaRepository.getSchema({name:'nunaliit_user_questions',onSuccess:function(schema){var defaultAnswers=schema.createObject();if(!defaultAnswers.version){$n2.log('User questions found without a version number. Ignored.');onLoginCompleted(sessionResult,userDoc);return;};var atlasName=_this._getAtlasName();var answers=null;if(userDoc&&userDoc.nunaliit_answers){answers=userDoc.nunaliit_answers[atlasName];};var interventionRequired=false;if(!answers){interventionRequired=true;answers=defaultAnswers;}else if(answers.version!=defaultAnswers.version){interventionRequired=true;};if(interventionRequired){gatherUserAnswers(sessionResult,userDoc,schema,answers);}else{onLoginCompleted(sessionResult,userDoc);};},onError:function(err){onLoginCompleted(sessionResult,userDoc);}});}else{onLoginCompleted(sessionResult,userDoc);};};function gatherUserAnswers(sessionResult,userDoc,schema,answers){var diagId=$n2.getUniqueId();var $diag=$('<div>').attr('id',diagId);var $content=$('<div>').addClass('n2Auth_user_questions_dialog').appendTo($diag);var $elem=$('<div>').addClass('n2Auth_user_questions_form').appendTo($content);schema.form(answers,$elem);var $buttons=$('<div>').addClass('n2Auth_user_questions_buttons').appendTo($content);$('<button>').addClass('n2_button_ok').text(_loc('OK')).click(function(){var $diag=$('#'+diagId);$diag.dialog('close');saveUserAnswers(sessionResult,userDoc,answers);}).appendTo($buttons);$('<button>').addClass('n2_button_cancel').text(_loc('Remind me later')).click(function(){var $diag=$('#'+diagId);$diag.dialog('close');onLoginCompleted(sessionResult,userDoc);}).appendTo($buttons);$diag.dialog({autoOpen:true,title:_loc('User Questionnaire'),modal:true,width:'auto',close:function(event,ui){var $diag=$('#'+diagId);$diag.remove();}});};function saveUserAnswers(sessionResult,userDoc,answers){_this.couchServer.getUserDb().getUser({name:userDoc.name,onSuccess:function(userDoc){var atlasName=_this._getAtlasName();if(!userDoc.nunaliit_answers){userDoc.nunaliit_answers={};};userDoc.nunaliit_answers[atlasName]=answers;_this.couchServer.getUserDb().updateDocument({data:userDoc,onSuccess:reloadUserDoc,onError:errorSavingAnswers});},onError:errorSavingAnswers});function errorSavingAnswers(err){$n2.log('Error saving user answers',err);alert(_loc('There was a problem saving your answers. You will be prompted again next time you log in.'));onLoginCompleted(sessionResult);};function reloadUserDoc(){_this.couchServer.getUserDb().getUser({id:userDoc._id,onSuccess:function(updatedUserDoc){onLoginCompleted(sessionResult,updatedUserDoc);},onError:function(err){$n2.log('Error retrieving updated version of user document',err);onLoginCompleted(sessionResult,userDoc);}});};};function onLoginCompleted(result,userDoc){var context=_this.couchServer.getSession().getContext();$n2.log('Login successful',context,opts);if(context&&context.name){opts.onSuccess(context);_this._notifyListeners();}else{doErrorNotification();};};function onError(err){_this.couchServer.getSession().logout({onError:function(){}});$n2.log('Login error',err);doErrorNotification(err);};function doErrorNotification(err){if(err){opts.onError(err);}else{opts.onError(_loc('Invalid e-mail and/or password'));};_this._notifyListeners();};},_fillDialogWithLogin:function(dialogId,opts_){var opts=$n2.extend({prompt:null,userName:null,onSuccess:function(context){},onError:function(err){}},opts_);var _this=this;var $dialog=$('#'+dialogId);var $authDiag=$('<div class="n2Auth_login"></div>');var $authForm=$('<form></form>').appendTo($authDiag);var $userLine=$('<div class="n2Auth_login_user_line"></div>').appendTo($authForm);var nameLabel=_loc('user name');if(this.autoRegistrationAvailable){nameLabel=_loc('e-mail address');};var nameValue='';if(opts.userName){nameValue=opts.userName;};$('<div class="n2Auth_login_label"></div>').text(nameLabel).appendTo($userLine);var $labelDiv=$('<div class="n2Auth_login_input"></div>').appendTo($userLine);$('<input class="n2Auth_user_input n2Auth_input_field" type="text" name="username"/>').val(nameValue).appendTo($labelDiv);$('<div class="n2Auth_login_end"></div>').appendTo($userLine);var $pwLine=$('<div class="n2Auth_login_pw_line"></div>').appendTo($authForm);$('<div class="n2Auth_login_label"></div>').text(_loc('password')).appendTo($pwLine);$('<div class="n2Auth_login_input"><input class="n2Auth_pw_input n2Auth_input_field" type="password" name="password"/></div>').appendTo($pwLine);$('<div class="n2Auth_login_end"></div>').appendTo($pwLine);var $buttonLine=$('<div class="n2Auth_login_button_line"></div>').appendTo($authForm);$('<input type="submit" class="n2Auth_button_login"></input>').appendTo($buttonLine).val(_loc('Login')).click(function(){performLogin();return false;});$('<input type="button" class="n2Auth_button_cancel"></input>').appendTo($buttonLine).val(_loc('Cancel')).click(function(){var $dialog=$('#'+dialogId);$dialog.dialog('close');});$('<div class="n2Auth_login_end"></div>').appendTo($buttonLine);if(!this._shouldDisableCreateUserButton()){var $createLine=$('<div class="n2Auth_login_create_line"></div>').appendTo($authDiag);$('<a class="n2Auth_button_createUser" href="#"></a>').appendTo($createLine).text(_loc('Create a new user')).click(function(){var $dialog=$('#'+dialogId);var userName=$dialog.find('.n2Auth_user_input').val();opts.userName=userName;_this._fillDialogWithUserCreation(dialogId,opts);return false;});$('<div class="n2Auth_login_end"></div>').appendTo($createLine);};if(this.autoRegistrationAvailable){var $recoverLine=$('<div class="n2Auth_login_recover_line"></div>').appendTo($authDiag);$('<a class="n2Auth_button_recoverPassword" href="#"></a>').appendTo($recoverLine).text(_loc('I have forgotten my password')).click(function(){var $dialog=$('#'+dialogId);var userName=$dialog.find('.n2Auth_user_input').val();opts.userName=userName;_this._fillDialogWithPasswordRecovery(dialogId,opts);return false;});$('<div class="n2Auth_login_end"></div>').appendTo($recoverLine);};$dialog.empty().append($authDiag);if(opts.prompt){$dialog.dialog('option','title',opts.prompt);}else{$dialog.dialog('option','title',_loc('Please login'));};function performLogin(){var $dialog=$('#'+dialogId);var user=$dialog.find('.n2Auth_user_input').val();var password=$dialog.find('.n2Auth_pw_input').val();_this.login({username:user,password:password,onSuccess:opts.onSuccess,onError:opts.onError});};},_fillDialogWithUserCreation:function(dialogId,opts_){if(this.autoRegistrationAvailable){this._fillDialogWithUserAutoRegistration(dialogId,opts_);return;};var opts=$n2.extend({prompt:null,userName:null,onSuccess:function(context){},onError:function(err){}},opts_);var _this=this;var $dialog=$('#'+dialogId);$dialog.html(['<div class="n2Auth_create">','<div class="n2Auth_create_user_line">','<div class="n2Auth_create_label"></div>','<div class="n2Auth_create_input"><input class="n2Auth_user_input n2Auth_input_field" type="text"/></div>','<div class="n2Auth_create_end"></div>','</div>','<div class="n2Auth_create_display_line">','<div class="n2Auth_create_label"></div>','<div class="n2Auth_create_input"><input class="n2Auth_display_input n2Auth_input_field" type="text"/></div>','<div class="n2Auth_create_end"></div>','</div>','<div class="n2Auth_create_pw_line">','<div class="n2Auth_create_label"></div>','<div class="n2Auth_create_input"><input class="n2Auth_pw_input n2Auth_input_field" type="password"/></div>','<div class="n2Auth_create_end"></div>','</div>','<div class="n2Auth_create_pw2_line">','<div class="n2Auth_create_label"></div>','<div class="n2Auth_create_input"><input class="n2Auth_pw_input2 n2Auth_input_field" type="password"/></div>','<div class="n2Auth_create_end"></div>','</div>','<div class="n2Auth_create_button_line">','<button class="n2Auth_button_create"></button>','<button class="n2Auth_button_cancel"></button>','</div>','</div>'].join(''));$dialog.find('.n2Auth_create_user_line .n2Auth_create_label').text(_loc('user name'));$dialog.find('.n2Auth_create_display_line .n2Auth_create_label').text(_loc('display name'));$dialog.find('.n2Auth_create_pw_line .n2Auth_create_label').text(_loc('password'));$dialog.find('.n2Auth_create_pw2_line .n2Auth_create_label').text(_loc('confirm password'));if(opts.userName){$dialog.find('.n2Auth_user_input').val(opts.userName);};$dialog.find('.n2Auth_button_create').text(_loc('Create User')).button({icons:{primary:'ui-icon-check'}}).click(function(){performUserCreation();return false;});$dialog.find('.n2Auth_button_cancel').text(_loc('Cancel')).button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);var userName=$dialog.find('.n2Auth_user_input').val();opts.userName=userName;_this._fillDialogWithLogin(dialogId,opts);return false;});$dialog.find('.n2Auth_input_field').keydown(function(e){var charCode=null;if(null===e){e=window.event;};if(null!==e){if(e.keyCode){charCode=e.keyCode;};};if(13===charCode){performUserCreation();};});$dialog.dialog('option','title',_loc('User Creation'));function performUserCreation(){var $dialog=$('#'+dialogId);var user=$dialog.find('.n2Auth_user_input').val();var display=$dialog.find('.n2Auth_display_input').val();var password=$dialog.find('.n2Auth_pw_input').val();var password2=$dialog.find('.n2Auth_pw_input2').val();if(null==user||user.length<3){alert(_loc('User name should have at least 3 characters'));return false;};if(password!=password2){alert(_loc('The two passwords should match'));return false;};if(null==password||password.length<6){alert(_loc('Password should have at least 6 characters'));return false;};if(null==display||display.length<1){display=user;};_this.couchServer.getUserDb().createUser({name:user,password:password,display:display,onSuccess:function(){_this.login({username:user,password:password,onSuccess:opts.onSuccess,onError:function(err){alert(_loc('User created but unable to log in: ')+err);}});},onError:function(err){alert(_loc('Unable to create user: ')+err);}});};},_fillDialogWithUserAutoRegistration:function(dialogId,opts_){var opts=$n2.extend({prompt:null,userName:null,onSuccess:function(context){},onError:function(err){}},opts_);var _this=this;var $dialog=$('#'+dialogId);$dialog.empty();var $form=$('<div>').addClass('n2Auth_create').appendTo($dialog);var emailValue='';if(opts.userName){emailValue=opts.userName;};var $line=$('<div>').addClass('n2Auth_create_email_line').appendTo($form);$('<div>').addClass('n2Auth_create_label').text(_loc('e-mail address')).appendTo($line);var $input=$('<div>').addClass('n2Auth_create_input').appendTo($line);$('<input type="text">').addClass('n2Auth_email_input n2Auth_input_field').appendTo($input).val(emailValue).keydown(function(e){var charCode=null;if(null===e){e=window.event;};if(null!==e){if(e.keyCode){charCode=e.keyCode;};};if(13===charCode){performUserRegistration();};});$('<div>').addClass('n2Auth_create_end').appendTo($line);var $line=$('<div>').addClass('n2Auth_create_button_line').appendTo($form);$('<button>').addClass('n2Auth_button_create').text(_loc('Create User')).appendTo($line).button({icons:{primary:'ui-icon-check'}}).click(function(){performUserRegistration();return false;});$('<button>').addClass('n2Auth_button_cancel').text(_loc('Cancel')).appendTo($line).button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);var email=$dialog.find('.n2Auth_email_input').val();opts.userName=email;_this._fillDialogWithLogin(dialogId,opts);return false;});$dialog.dialog('option','title',_loc('User Registration'));function performUserRegistration(){var $dialog=$('#'+dialogId);var email=$dialog.find('.n2Auth_email_input').val();if(email){email=$n2.trim(email);};if(!email){alert(_loc('E-Mail address must be specified'));return false;};var url=_this.options.userServerUrl+'initUserCreation';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{email:email},dataType:'json',success:function(result){if(result.error){alert(_loc('Unable to register user: ')+result.error);}else{reportSuccess();};},error:function(XMLHttpRequest,textStatus,errorThrown){alert(_loc('Unable to register user: ')+textStatus);}});};function reportSuccess(){var $dialog=$('#'+dialogId);$dialog.empty();var $form=$('<div>').addClass('n2Auth_registered').appendTo($dialog);var $line=$('<div>').addClass('n2Auth_registered_line').appendTo($form).text(_loc('User registration initiated. Check for e-mail to complete user creation'));var $line=$('<div>').addClass('n2Auth_registered_button_line').appendTo($form);$('<button>').addClass('n2Auth_button_ok').text(_loc('OK')).appendTo($line).button({icons:{primary:'ui-icon-check'}}).click(function(){opts.onSuccess();return false;});$dialog.dialog('option','title',_loc('Registration Initiated'));};},_fillDialogWithPasswordRecovery:function(dialogId,opts_){var opts=$n2.extend({prompt:null,userName:null,onSuccess:function(context){},onError:function(err){}},opts_);var _this=this;var $dialog=$('#'+dialogId);$dialog.empty();var $form=$('<div>').addClass('n2Auth_recoverPassword').appendTo($dialog);var userName='';if(opts.userName){userName=opts.userName;};var $line=$('<div>').addClass('n2Auth_recoverPassword_email_line').appendTo($form);$('<div>').addClass('n2Auth_recoverPassword_label').text(_loc('e-mail address')).appendTo($line);var $input=$('<div>').addClass('n2Auth_recoverPassword_input').appendTo($line);$('<input type="text">').addClass('n2Auth_email_input n2Auth_input_field').appendTo($input).val(userName).keydown(function(e){var charCode=null;if(null===e){e=window.event;};if(null!==e){if(e.keyCode){charCode=e.keyCode;};};if(13===charCode){performPasswordRecovery();};});$('<div>').addClass('n2Auth_recoverPassword_end').appendTo($line);var $line=$('<div>').addClass('n2Auth_recoverPassword_button_line').appendTo($form);$('<button>').addClass('n2Auth_button_recover').text(_loc('Reset Password')).appendTo($line).button({icons:{primary:'ui-icon-check'}}).click(function(){performPasswordRecovery();return false;});$('<button>').addClass('n2Auth_button_cancel').text(_loc('Cancel')).appendTo($line).button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);var email=$dialog.find('.n2Auth_email_input').val();opts.userName=email;_this._fillDialogWithLogin(dialogId,opts);return false;});$dialog.dialog('option','title',_loc('Recover Password'));function performPasswordRecovery(){var $dialog=$('#'+dialogId);var email=$dialog.find('.n2Auth_email_input').val();if(email){email=$n2.trim(email);};if(!email){alert(_loc('E-Mail address must be specified'));return false;};var url=_this.options.userServerUrl+'initPasswordRecovery';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{email:email},dataType:'json',success:function(result){if(result.error){alert(_loc('Unable to recover password: ')+result.error);}else{reportSuccess();};},error:function(XMLHttpRequest,textStatus,errorThrown){alert(_loc('Unable to recover password: ')+textStatus);}});};function reportSuccess(){var $dialog=$('#'+dialogId);$dialog.empty();var $form=$('<div>').addClass('n2Auth_registered').appendTo($dialog);var $line=$('<div>').addClass('n2Auth_registered_line').appendTo($form).text(_loc('Password recovery initiated. Check for an e-mail to complete password recovery'));var $line=$('<div>').addClass('n2Auth_registered_button_line').appendTo($form);$('<button>').addClass('n2Auth_button_ok').text(_loc('OK')).appendTo($line).button({icons:{primary:'ui-icon-check'}}).click(function(){opts.onSuccess();return false;});$dialog.dialog('option','title',_loc('Password Recovery Initiated'));};},showLoginForm:function(opts_){var opts=$.extend({prompt:this.options.prompt,onSuccess:function(context){},onError:$n2.reportErrorForced},opts_);var dialogId=$n2.getUniqueId();var $dialog=$('<div id="'+dialogId+'"></div>');$(document.body).append($dialog);this._fillDialogWithLogin(dialogId,{prompt:opts.prompt,onSuccess:function(context){$('#'+dialogId).dialog('close');opts.onSuccess(context);},onError:function(err){$('#'+dialogId).dialog('close');opts.onError(err);}});var dialogOptions={autoOpen:true,modal:true,width:'auto',close:function(event,ui){var diag=$('#'+dialogId);diag.remove();}};if(opts.prompt){dialogOptions.title=opts.prompt;}
$dialog.dialog(dialogOptions);},logout:function(opts_){var opts=$n2.extend({onSuccess:function(context){},onError:function(err){}},opts_);var _this=this;this.couchServer.getSession().logout({onSuccess:onSuccess,onError:opts.onError});function onSuccess(result){$n2.log("Logout successful",result);opts.onSuccess(result);_this._notifyListeners();};},editUser:function(opts_){var opts=$n2.extend({userName:null,onSuccess:function(context){},onError:function(err){}},opts_);var _this=this;var userName=opts.userName;if(!userName){var context=this._getAuthContext();if(context&&context.name){userName=context.name;};};if(!userName){opts.onError('No user name provided');return;};this.couchServer.getUserDb().getUser({name:userName,onSuccess:userDocLoaded,onError:function(err){var userDoc={_id:'org.couchdb.user:'+userName,name:userName,display:'',nunaliit_emails:[],roles:[],type:'user'};userDocLoaded(userDoc);}});function userDocLoaded(userDoc){var userService=_this._getUserService();if(userService){var $dialog=$('<div>').addClass('n2Auth_userEdit').appendTo($(document.body));var dialogId=$n2.utils.getElementIdentifier($dialog);userService.startEdit({userDoc:userDoc,elem:$dialog,onSavedFn:function(userDoc){var requestService=_this._getRequestService();if(requestService&&userDoc&&userDoc.name){requestService.requestUser(userDoc.name);};},onFinishedFn:function(){var diag=$('#'+dialogId);diag.dialog('close');}});var dialogOptions={autoOpen:true,modal:true,width:'auto',title:_loc('Edit User'),close:function(event,ui){var diag=$('#'+dialogId);diag.remove();}};$dialog.dialog(dialogOptions);};};},getCurrentUserName:function(){var context=this._getAuthContext();if(context&&context.name){return context.name;};return null;},getCurrentUserRoles:function(){var context=this._getAuthContext();if(context&&context.roles){return context.roles;};return null;},doRolesContainAdmin:function(roles){var admin=false;if(roles&&roles.length){if($.inArray('_admin',roles)>=0){admin=true;};if($.inArray('administrator',roles)>=0){admin=true;};if(typeof(n2atlas)==='object'&&typeof(n2atlas.name)==='string'){var dbAdmin=n2atlas.name+'_administrator';if($.inArray(dbAdmin,roles)>=0){admin=true;};};};return admin;},_getAuthContext:function(){return this.couchServer.getSession().getContext();},isLoggedIn:function(){var authContext=this._getAuthContext();if(authContext&&authContext.name){return true;};return false;},createAuthWidget:function(opts_){var dispatchService=null;var customService=null;if(this.options.directory){dispatchService=this.options.directory.dispatchService;customService=this.options.directory.customService;};var widgetOptions={elemId:null,elem:null,authService:this,dispatchService:dispatchService};if(customService){var label=customService.getOption('authWidgetLoginLabel');if(label)widgetOptions.labelLogin=label;label=customService.getOption('authWidgetLogoutLabel');if(label)widgetOptions.labelLogout=label;label=customService.getOption('authWidgetWelcomeLabel');if(label)widgetOptions.labelWelcome=label;};var opts=$n2.extend(widgetOptions,opts_);return new AuthWidget(opts);},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;},_getUserService:function(){var us=null;if(this.options.directory){us=this.options.directory.userService;};return us;},_getRequestService:function(){var rs=null;if(this.options.directory){rs=this.options.directory.requestService;};return rs;},_dispatch:function(m){var dispatcher=this._getDispatcher();if(dispatcher){var h=dispatcher.getHandle('n2.couchAuth');dispatcher.send(h,m);};},_handleSessionContextChange:function(sessionContext){var _this=this;var same=$n2.couch.compareSessionContexts(this.lastSessionContext,sessionContext);if(!same){this.lastSessionContext=sessionContext;this.currentUserDoc=null;this._notifyListeners();if(sessionContext.name){this.couchServer.getUserDb().getUser({name:sessionContext.name,onSuccess:function(userDoc){if(userDoc.name===_this.lastSessionContext.name){_this._handleCurrentUserDoc(userDoc);};},onError:function(err){if(sessionContext.name===_this.lastSessionContext.name){_this._handleCurrentUserDoc(null);};}});};};},_handleCurrentUserDoc:function(userDoc){this.currentUserDoc=userDoc;var $body=$('body');if(this.currentUserDoc&&this.currentUserDoc.nunaliit_options&&this.currentUserDoc.nunaliit_options.advanced){$body.addClass('nunaliit_user_advanced');}else{$body.removeClass('nunaliit_user_advanced');};if(userDoc){this._dispatch({type:'authCurrentUserDoc',userDoc:userDoc});};this._updateUserDocWithLoggedIn();},_handleEvent:function(m){if(m&&m.type==='login'){this.login({username:m.username,password:m.password});}else if(m&&m.type==='loginShowForm'){this.showLoginForm();}else if(m&&m.type==='logout'){this.logout();}else if(m&&m.type==='authIsLoggedIn'){if(this.isLoggedIn()){m.isLoggedIn=true;m.context=this.lastSessionContext;m.userDoc=this.currentUserDoc;};};},_getCustomService:function(){var cs=null;if(this.options.directory){cs=this.options.directory.customService;};return cs;},_shouldDisableCreateUserButton:function(){var flag=this.options.disableCreateUserButton;var customService=this._getCustomService();if(customService&&!flag){var o=customService.getOption('disableCreateUserButton');if(typeof(o)!=='undefined'){flag=o;};};return flag;},_updateUserDocWithLoggedIn:function(){var userDoc=this.currentUserDoc;if(userDoc&&n2atlas&&n2atlas.name){if(userDoc.nunaliit_atlases&&userDoc.nunaliit_atlases[n2atlas.name]&&userDoc.nunaliit_atlases[n2atlas.name].auth){}else{if(!userDoc.nunaliit_atlases){userDoc.nunaliit_atlases={};};if(!userDoc.nunaliit_atlases[n2atlas.name]){userDoc.nunaliit_atlases[n2atlas.name]={name:n2atlas.name};};userDoc.nunaliit_atlases[n2atlas.name].auth=true;this.couchServer.getUserDb().updateDocument({data:userDoc,onSuccess:function(){},onError:function(err){$n2.log('Unable to save user\'s authentication flag to user db',err);}});};};},_getAtlasName:function(){var atlasName='atlas';if(typeof n2atlas==='object'&&n2atlas.name){atlasName=n2atlas.name;};return atlasName;}});var AuthWidget=$n2.Class({authService:null,elemId:null,currentUserName:null,currentUserDisplay:null,labelLogin:null,labelLogout:null,labelWelcome:null,initialize:function(options_){var opts=$n2.extend({elemId:null,elem:null,authService:null,dispatchService:null,labelLogin:null,labelLogout:null,labelWelcome:null},options_);var _this=this;this.authService=opts.authService;this.dispatchService=opts.dispatchService;this.labelLogin=opts.labelLogin;this.labelLogout=opts.labelLogout;this.labelWelcome=opts.labelWelcome;this.elemId=opts.elemId;if(!this.elemId&&opts.elem){this.elemId=$n2.utils.getElementIdentifier(opts.elem);};if(this.dispatchService){var f=function(m,addr,d){_this._handleDispatch(m,addr,d);};this.dispatchService.register(DH,'authLoggedIn',f);this.dispatchService.register(DH,'authLoggedOut',f);this.dispatchService.register(DH,'authCurrentUserDoc',f);this.dispatchService.register(DH,'userInfo',f);this.dispatchService.register(DH,'userDocument',f);var m={type:'authIsLoggedIn',isLoggedIn:false};this.dispatchService.synchronousCall(DH,m);if(m.isLoggedIn){if(m.context&&m.context.name){this.currentUserName=m.context.name;};if(m.userDoc&&m.userDoc.display){this.currentUserDisplay=m.userDoc.display;};}else{this.currentUserName=null;this.currentUserDisplay=null;};this._loginStateChanged();};},_getElem:function(){return $('#'+this.elemId);},_handleDispatch:function(m,addr,dispatcher){var $elem=this._getElem();if($elem.length<1){dispatcher.deregister(addr);return;};if('authLoggedIn'===m.type){var ctxt=m.user;if(this.currentUserName!==ctxt.name){this.currentUserName=ctxt.name;this.currentUserDisplay=null;this._loginStateChanged();};}else if('authLoggedOut'===m.type){this.currentUserName=null;this.currentUserDisplay=null;this._loginStateChanged();}else if('authCurrentUserDoc'===m.type){var userDoc=m.userDoc;if(userDoc&&userDoc.display!==this.currentUserDisplay){this.currentUserDisplay=userDoc.display;this._loginStateChanged();};}else if('userInfo'===m.type){if(m.userInfo&&this.currentUserName===m.userInfo.name){this.currentUserDisplay=m.userInfo.display;this._loginStateChanged();};}else if('userDocument'===m.type){if(m.userDoc&&this.currentUserName===m.userDoc.name){this.currentUserDisplay=m.userDoc.display;this._loginStateChanged();};};},_loginStateChanged:function(){var $login=this._getElem();if($login.length<1)return;$login.empty();var authService=this.authService;if(authService){var href=null;var displayName=null;var buttonText=null;var clickFn=null;var greetingFn=null;var greetingClass=null;if(this.currentUserName){href='javascript:Logout';displayName=this.currentUserDisplay;if(!displayName)displayName=this.currentUserName;greetingClass='nunaliit_login_greeting_name';buttonText=this.labelLogout?this.labelLogout:_loc('Logout');clickFn=function(){authService.logout();return false;};greetingFn=function(){authService.editUser({userName:null});return false;};}else{href='javascript:Login';displayName=this.labelWelcome?this.labelWelcome:_loc('Welcome');greetingClass='nunaliit_login_greeting_welcome';buttonText=this.labelLogin?this.labelLogin:_loc('Login');clickFn=function(){authService.showLoginForm();return false;};};var aElem=$('<a class="nunaliit_login_link"></a>').attr("href",href).text(buttonText);var linkInnerContainer=$('<div class="nunaliit_login_link_inner_container"></div>').append(aElem);var linkOuterContainer=$('<div class="nunaliit_login_link_outer_container"></div>').append(linkInnerContainer).click(clickFn);var nameElem=$('<span></span>').text(displayName);var greetingInner=$('<div class="nunaliit_login_greeting_inner_container"></div>').append(nameElem);var greetingOuter=$('<div class="nunaliit_login_greeting_outer_container"></div>').addClass(greetingClass).append(greetingInner);if(greetingFn){greetingOuter.addClass('nunaliit_login_greeting_with_editor').click(greetingFn);};$login.empty().append(greetingOuter).append(linkOuterContainer);};}});$n2.couchAuth={AuthService:AuthService,AuthWidget:AuthWidget};})(jQuery,nunaliit2);;(function($,$n2){var DH='n2.couchModule';var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};function isSrsNameSupported(srsName){if(typeof(OpenLayers)!=='undefined'&&OpenLayers.Projection&&OpenLayers.Projection.transforms&&OpenLayers.Projection.transforms[srsName]){return true;};if(typeof(Proj4js)!=='undefined'&&Proj4js.Proj){var proj=new Proj4js.Proj(srsName);if(proj.readyToUse){return true;};};return false;};var Module=$n2.Class({moduleDoc:null,atlasDb:null,initialize:function(moduleDoc,atlasDb){this.moduleDoc=moduleDoc;this.atlasDb=atlasDb;},getModuleInfo:function(){var moduleInfo=null;if(this.moduleDoc){moduleInfo=this.moduleDoc.nunaliit_module;};return moduleInfo;},getMapInfo:function(){var mapInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){mapInfo=moduleInfo.map;};return mapInfo;},getCanvasInfo:function(){var canvasInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){canvasInfo=moduleInfo.canvas;};return canvasInfo;},getDisplayInfo:function(){var displayInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){displayInfo=moduleInfo.display;};return displayInfo;},getEditInfo:function(){var editInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){editInfo=moduleInfo.edit;};return editInfo;},getSearchInfo:function(){var searchInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){searchInfo=moduleInfo.search;};return searchInfo;},getWidgetInfos:function(){var widgetInfos=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){widgetInfos=moduleInfo.widgets;};if(!widgetInfos){widgetInfos=[];};return widgetInfos;},displayIntro:function(opts_){var opts=$n2.extend({elem:null,showService:null,onLoaded:function(){}},opts_);var $elem=opts.elem;var introInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){introInfo=moduleInfo.introduction;};if(!introInfo){$elem.empty();return false;}else{if('html'===introInfo.type&&introInfo.content){$elem.empty();var $outer=$('<div>').addClass('n2ModuleIntro n2ModuleIntro_html').appendTo($elem);var content=$n2.couchL10n.getLocalizedString(introInfo.content);if(content){$outer.html(content);if(opts.showService){opts.showService.fixElementAndChildren($outer);};};opts.onLoaded();return true;}else if('text'===introInfo.type&&introInfo.content){$elem.empty();var $outer=$('<div>').addClass('n2ModuleIntro n2ModuleIntro_text').appendTo($elem);var content=$n2.couchL10n.getLocalizedString(introInfo.content);if(content){var $wrapper=$('<div>').text(content);$outer.empty().append($wrapper);if(opts.showService){$wrapper.addClass('n2s_preserveSpaces');opts.showService.fixElementAndChildren($wrapper);};};opts.onLoaded();return true;}else if('attachment'===introInfo.type&&introInfo.attachmentName&&this.atlasDb){var displayId=$n2.getUniqueId();$elem.empty();$('<div>').attr('id',displayId).addClass('n2ModuleIntro n2ModuleIntro_attachment').appendTo($elem);var localeStr=$n2.l10n.getStringForLocale(introInfo.attachmentName);if(localeStr.str){var attUrl=this.atlasDb.getAttachmentUrl(this.moduleDoc,localeStr.str);$.ajax({url:attUrl,type:'get',async:true,success:function(intro){if(localeStr.fallback){var $inner=$('<span class="n2_localized_string n2_localize_fallback"></span>');$('<span class="n2_localize_fallback_lang"></span>').text('('+localeStr.lang+')').appendTo($inner);$('<span></span>').html(intro).appendTo($inner);$('#'+displayId).empty().append($inner);}else{$('#'+displayId).html(intro);};if(opts.showService){opts.showService.fixElementAndChildren($('#'+displayId));};opts.onLoaded();},error:function(XMLHttpRequest,textStatus,errorThrown){$n2.log('Unable to obtain module intro: '+textStatus);}});};return true;}else{$elem.empty();return false;};}}});var ModuleDisplay=$n2.Class({config:null,module:null,mapControl:null,displayControl:null,titleName:null,moduleTitleName:null,contentName:null,mapName:null,mapInteractionName:null,sidePanelName:null,filterPanelName:null,searchPanelName:null,loginPanelNames:null,navigationName:null,navigationDoc:null,languageSwitcherName:null,helpButtonName:null,helpDialogId:null,styleMapFn:null,styles:null,initialize:function(opts_){var opts=$n2.extend({moduleName:null,moduleDoc:null,config:null,titleName:'title',moduleTitleName:'module_title',contentName:null,mapName:'map',mapInteractionName:'map_interaction_div',sidePanelName:'side',filterPanelName:'filters',searchPanelName:null,loginPanelName:'login',loginPanels:null,navigationName:'navigation',navigationDoc:null,languageSwitcherName:null,helpButtonName:null,styleMapFn:null,onSuccess:function(moduleDisplay){},onError:function(err){$n2.reportErrorForced(errorMsg);}},opts_);var _this=this;if(!opts.moduleName&&!opts.moduleDoc){opts.onError('"moduleName" or "moduleDoc" must be specified');return;};this.config=opts.config;if(!this.config){opts.onError('"config" must be specified');return;};this.contentName=opts.contentName;this.mapName=opts.mapName;this.mapInteractionName=opts.mapInteractionName;this.sidePanelName=opts.sidePanelName;this.filterPanelName=opts.filterPanelName;this.searchPanelName=opts.searchPanelName;this.navigationName=opts.navigationName;this.navigationDoc=opts.navigationDoc;this.titleName=opts.titleName;this.moduleTitleName=opts.moduleTitleName;this.languageSwitcherName=opts.languageSwitcherName;this.helpButtonName=opts.helpButtonName;this.styleMapFn=opts.styleMapFn;this.loginPanelNames=[];if(opts.loginPanels){$(opts.loginPanels).each(function(){var $loginPanel=$(this);var id=$loginPanel.attr('id');if(!id){id=$n2.getUniqueId();$loginPanel.attr('id',id);};_this.loginPanelNames.push(id);});}else if(opts.loginPanelName){this.loginPanelNames.push(opts.loginPanelName);};var config=this.config;var atlasDb=config.atlasDb;var atlasDesign=config.atlasDesign;var documentSource=config.documentSource;var customService=this._getCustomService();var d=this._getDispatcher();if(d){d.register(DH,'unselected',function(m){_this._initSidePanel();});};for(var i=0,e=this.loginPanelNames.length;i<e;++i){var loginPanelName=this.loginPanelNames[i];config.directory.authService.createAuthWidget({elemId:loginPanelName});};if(!$n2.isDefined(opts.moduleDoc)){atlasDb.getDocument({docId:opts.moduleName,onSuccess:moduleDocumentLoaded,onError:function(err){opts.onError('Unable to load module: '+err);}});}else{moduleDocumentLoaded(opts.moduleDoc);};if(this.navigationDoc){var navDocNeeded=false;if($('#'+this.navigationName).length>0){$('#'+this.navigationName).empty();navDocNeeded=true;};if($('#'+this.titleName).length>0){$('#'+this.titleName).empty();navDocNeeded=true;};if(navDocNeeded){atlasDb.getDocument({docId:this.navigationDoc,onSuccess:function(doc){_this._navigationDocumentLoaded(doc);},onError:function(err){$n2.log('Error obtaining navigation document '+_this.navigationDoc,err);}});};};function moduleDocumentLoaded(moduleDoc){if(!moduleDoc.nunaliit_module){opts.onError('Loaded document does not include module information');return;};_this.module=new Module(moduleDoc,atlasDb);_this._sendDispatchMessage({type:'reportModuleDocument',doc:moduleDoc,module:_this.module,moduleDisplay:_this});var moduleInfo=_this.module.getModuleInfo();var mapInfo=_this.module.getMapInfo();var canvasInfo=_this.module.getCanvasInfo();var displayInfo=_this.module.getDisplayInfo();var editInfo=_this.module.getEditInfo();var searchInfo=_this.module.getSearchInfo();var widgetInfos=_this.module.getWidgetInfos();var canvasHandlerAvailable=false;if(canvasInfo&&canvasInfo.type){var msg={type:'canvasIsTypeAvailable',canvasType:canvasInfo.type,canvasOptions:canvasInfo,isAvailable:false};_this._sendSynchronousMessage(msg);if(msg.isAvailable){canvasHandlerAvailable=true;};};if(canvasInfo&&!canvasHandlerAvailable){$n2.log('Canvas handler not found for type: '+canvasInfo.type);canvasInfo=null;};var availableWidgets=[];if(widgetInfos){for(var i=0,e=widgetInfos.length;i<e;++i){var widgetInfo=widgetInfos[i];var widgetHandlerAvailable=false;if(widgetInfo&&widgetInfo.type){msg={type:'widgetIsTypeAvailable',widgetType:widgetInfo.type,widgetOptions:widgetInfo,isAvailable:false};_this._sendSynchronousMessage(msg);if(msg.isAvailable){widgetHandlerAvailable=true;};};if(widgetInfo&&!widgetHandlerAvailable){$n2.log('Widget handler not found for type: '+widgetInfo.type);}else{availableWidgets.push(widgetInfo);};};};if(_this.contentName){var $contentDiv=$('#'+_this.contentName).empty();if(mapInfo||canvasInfo){_this.mapName=$n2.getUniqueId();$('<div></div>').attr('id',_this.mapName).addClass('n2_content_map').appendTo($contentDiv);$contentDiv.addClass('n2_content_contains_map');_this.mapInteractionName=$n2.getUniqueId();$('<div></div>').attr('id',_this.mapInteractionName).addClass('n2_content_map_interaction').appendTo($contentDiv);}else{_this.mapName=null;_this.mapInteractionName=null;$contentDiv.addClass('n2_content_contains_no_map');};if(searchInfo&&searchInfo.disabled){_this.searchPanelName=null;$contentDiv.addClass('n2_content_contains_no_search');}else if(_this.searchPanelName){$contentDiv.addClass('n2_content_contains_no_search');}else{_this.searchPanelName=$n2.getUniqueId();$('<div></div>').attr('id',_this.searchPanelName).addClass('n2_content_searchInput').appendTo($contentDiv);$contentDiv.addClass('n2_content_contains_search');};_this.sidePanelName=$n2.getUniqueId();$('<div></div>').attr('id',_this.sidePanelName).addClass('n2_content_text').appendTo($contentDiv);$contentDiv.addClass('n2_content_contains_text');};_this.styles=new $n2.mapStyles.MapFeatureStyles((mapInfo?mapInfo.styles:null));_this._initSidePanel();if(moduleInfo&&moduleInfo.title){var title=$n2.couchL10n.getLocalizedString(moduleInfo.title);if(title){document.title=title;_this._installModuleTitle($('#'+opts.moduleTitleName),title);};}else{var title=_loc('Nunaliit Atlas');document.title=title;_this._installModuleTitle($('#'+opts.moduleTitleName),title);};if(_this.languageSwitcherName&&_this.config.directory.languageService){_this.config.directory.languageService.drawWidget({elemId:_this.languageSwitcherName});};if(moduleInfo.help&&_this.helpButtonName){_this._installHelpButton();};var displayFormat='classic';if(customService){displayFormat=customService.getOption('displayFormat',displayFormat);};if(displayFormat==='tiled'){$('body').addClass('n2_display_format_tiled');_this.displayControl=new $n2.couchDisplayTiles.TiledDisplay({documentSource:documentSource,displayPanelName:_this.sidePanelName,showService:config.directory.showService,editor:config.couchEditor,uploadService:config.directory.uploadService,authService:config.directory.authService,requestService:config.directory.requestService,schemaRepository:config.directory.schemaRepository,customService:config.directory.customService,dispatchService:config.directory.dispatchService,createDocProcess:config.directory.createDocProcess});}else{if('classic'!==displayFormat){$n2.log('Unknown display format: '+displayFormat+' Reverting to classic display.');};var displayOptions={documentSource:documentSource,displayPanelName:_this.sidePanelName,showService:config.directory.showService,editor:config.couchEditor,uploadService:config.directory.uploadService,serviceDirectory:config.directory,createDocProcess:config.directory.createDocProcess};if(displayInfo&&displayInfo.displayOnlyRelatedSchemas){displayOptions.displayOnlyRelatedSchemas=displayInfo.displayOnlyRelatedSchemas;};if(displayInfo&&displayInfo.displayBriefInRelatedInfo){displayOptions.displayBriefInRelatedInfo=displayInfo.displayBriefInRelatedInfo;};_this.displayControl=new $n2.couchDisplay.Display(displayOptions);var defaultDisplaySchemaName='object';if(displayInfo&&displayInfo.defaultSchemaName){defaultDisplaySchemaName=displayInfo.defaultSchemaName;};config.directory.schemaRepository.getSchema({name:defaultDisplaySchemaName,onSuccess:function(schema){if(_this.displayControl.setSchema){_this.displayControl.setSchema(schema);};}});};config.couchEditor.setPanelName(_this.sidePanelName);var defaultEditSchemaName='object';if(editInfo&&editInfo.defaultSchemaName){defaultEditSchemaName=editInfo.defaultSchemaName;};config.directory.schemaRepository.getSchema({name:defaultEditSchemaName,onSuccess:function(schema){config.couchEditor.options.defaultEditSchema=schema;}});if(editInfo&&editInfo.newDocumentSchemaNames){if('ALL_SCHEMAS'===editInfo.newDocumentSchemaNames){config.couchEditor.setSchemas($n2.CouchEditor.Constants.ALL_SCHEMAS);}else if(editInfo.newDocumentSchemaNames.length){config.directory.schemaRepository.getSchemas({names:editInfo.newDocumentSchemaNames,onSuccess:function(schemas){config.couchEditor.setSchemas(schemas);},onError:function(err){$n2.log('Error obtaining new edit document schemas: '+err);}});};};if(_this.searchPanelName){config.directory.searchService.installSearchWidget({elem:$('#'+_this.searchPanelName)});};for(i=0,e=availableWidgets.length;i<e;++i){widgetInfo=availableWidgets[i];_this._sendDispatchMessage({type:'widgetDisplay',widgetType:widgetInfo.type,widgetOptions:widgetInfo,contentId:_this.contentName,config:config,moduleDisplay:_this});};if(mapInfo){_this._initializeMap({config:config,onSuccess:opts.onSuccess,onError:opts.onError});}else if(canvasInfo){_this._sendDispatchMessage({type:'canvasDisplay',canvasType:canvasInfo.type,canvasOptions:canvasInfo,canvasId:_this.mapName,interactionId:_this.mapInteractionName,config:config,moduleDisplay:_this,onSuccess:function(){opts.onSuccess(_this);},onError:opts.onError});}else{_this._sendDispatchMessage({type:'reportModuleDisplay',moduleDisplay:_this});opts.onSuccess(_this);};};},_initializeMap:function(opts_){var opts=$n2.extend({config:null,onSuccess:function(moduleDisplay){},onError:function(err){}},opts_);var _this=this;var mapInfo=_this.module.getMapInfo();var customService=this._getCustomService();var addPointsOnly=false;if(mapInfo&&mapInfo.addPointsOnly){addPointsOnly=mapInfo.addPointsOnly;};var toggleClick=false;if(mapInfo&&mapInfo.toggleClick){toggleClick=mapInfo.toggleClick;};var dbSearchEngine={relMediaPath:'./'};if(mapInfo&&mapInfo.dbSearchEngine){dbSearchEngine=mapInfo.dbSearchEngine;};var mapOptions={dbSearchEngine:dbSearchEngine,mapIdentifier:_this.mapName,mapInteractionDivName:_this.mapInteractionName,mapCoordinateSpecifications:{initialBounds:null},uniqueIdentifier:'_id',addPointsOnly:addPointsOnly,overlays:[],toggleClick:toggleClick,sidePanelName:_this.sidePanelName,filterPanelName:_this.filterPanelName,saveFeature:_this.config.couchEditor,mapDisplay:{},directory:_this.config.directory,layerSwitcher:{suppress:false,initiallyOpened:false}};if(mapInfo&&mapInfo.layerSelector){if(mapInfo.layerSelector.suppress){mapOptions.layerSwitcher.suppress=true;};if(mapInfo.layerSelector.initiallyOpened){mapOptions.layerSwitcher.initiallyOpened=true;};};var initialBounds=null;if(mapInfo&&mapInfo.coordinates){initialBounds=mapInfo.coordinates.initialBounds;if(mapInfo.coordinates.srsName){if(false==isSrsNameSupported(mapInfo.coordinates.srsName)){var msg=_loc('The projection {srsName} is not supported. Atlas may no function properly.',{srsName:mapInfo.coordinates.srsName});alert(msg);};mapOptions.mapDisplay.srsName=mapInfo.coordinates.srsName;mapOptions.mapCoordinateSpecifications.srsName=mapInfo.coordinates.srsName;}else{mapOptions.mapDisplay.srsName='EPSG:4326';mapOptions.mapCoordinateSpecifications.srsName='EPSG:4326';};if(mapInfo.backgrounds){for(var i=0,e=mapInfo.backgrounds.length;i<e;++i){if('Google Maps'===mapInfo.backgrounds[i].type){mapOptions.mapDisplay.srsName='EPSG:900913';}else if('osm'===mapInfo.backgrounds[i].type){mapOptions.mapDisplay.srsName='EPSG:900913';}else if('stamen'===mapInfo.backgrounds[i].type){mapOptions.mapDisplay.srsName='EPSG:900913';};};};};if(mapInfo&&mapInfo.backgrounds){mapOptions.mapDisplay.backgrounds=[];for(var i=0,e=mapInfo.backgrounds.length;i<e;++i){var l=$n2.extend({},mapInfo.backgrounds[i]);if(l.type==='image'){if(l.options&&l.options.attachmentName){var url=_this.config.atlasDb.getAttachmentUrl(this.module.moduleDoc,l.options.attachmentName);l.options.url=url;};if(l.options&&l.options.extent&&mapOptions.mapDisplay.srsName!=mapOptions.mapCoordinateSpecifications.srsName){var defProj=new OpenLayers.Projection(mapOptions.mapCoordinateSpecifications.srsName);var mapProj=new OpenLayers.Projection(mapOptions.mapDisplay.srsName);var bl=new OpenLayers.Geometry.Point(l.options.extent[0],l.options.extent[1]);var tr=new OpenLayers.Geometry.Point(l.options.extent[2],l.options.extent[3]);bl.transform(defProj,mapProj);tr.transform(defProj,mapProj);l.options.extent[0]=bl.x;l.options.extent[1]=bl.y;l.options.extent[2]=tr.x;l.options.extent[3]=tr.y;};};mapOptions.mapDisplay.backgrounds.push(l);};};if(mapInfo&&mapInfo.overlays){var styleMapFn=_this.styleMapFn;if(!styleMapFn&&customService){styleMapFn=customService.getOption('mapGetStyleFunctionForLayer');if(typeof styleMapFn!=='function'){styleMapFn=null;};};if(!styleMapFn){styleMapFn=function(layerInfo_){return _this.styles.getStyleMapForLayerInfo(layerInfo_);};};for(var i=0,e=mapInfo.overlays.length;i<e;++i){var layerInfo=mapInfo.overlays[i];var layerDefinition={id:layerInfo.id,name:layerInfo.name,type:layerInfo.type,visibility:layerInfo.visibility,featurePopupHtmlFn:_this.config.popupHtmlFn,featurePopupDelay:0,styleMapFn:styleMapFn,useHoverSound:true,clustering:false};if($n2.isDefined(layerInfo.gutter)){layerDefinition.gutter=layerInfo.gutter;};if($n2.isDefined(layerInfo.displayInLayerSwitcher)){layerDefinition.displayInLayerSwitcher=layerInfo.displayInLayerSwitcher;};if('couchdb'===layerInfo.type){layerDefinition.options=$n2.extend({viewName:'geom',layerName:null,documentSource:_this.config.documentSource},layerInfo.options);if(!layerDefinition.options.layerName){layerDefinition.options.layerName=layerDefinition.id;};if(!layerDefinition.id&&layerDefinition.options&&layerDefinition.options.layerName){layerDefinition.id=layerDefinition.options.layerName;};}else{layerDefinition.options=layerInfo.options;};if(layerInfo.featurePopupDelayMs){layerDefinition.featurePopupDelay=layerInfo.featurePopupDelayMs;};if(typeof(layerInfo.useHoverSound)==='boolean'){layerDefinition.useHoverSound=layerInfo.useHoverSound;};if(layerInfo.clustering){layerDefinition.clustering=layerInfo.clustering;};mapOptions.overlays.push(layerDefinition);};};for(var i=0,e=mapOptions.overlays.length;i<e;++i){var layerDefinition=mapOptions.overlays[i];if(layerDefinition.type==='couchdb'){layerDefinition.sourceSrsName=mapOptions.mapDisplay.srsName;};};if(!initialBounds){opts.onError('Initial map extent not specified');return;};if(mapInfo&&mapInfo.coordinates&&mapInfo.coordinates.autoInitialBounds){computeAutoInitialBounds(mapOptions,initialBounds,mapInfo.coordinates.autoInitialBounds);}else{initialBoundsComputed(mapOptions,initialBounds);};function computeAutoInitialBounds(mapOptions,initialBounds,autoInitialBounds){var layerBoundingBox=null;var layersPending=0;for(var i=0,e=mapOptions.overlays.length;i<e;++i){var layerDef=mapOptions.overlays[i];if(layerDef.type==='couchdb'){++layersPending;var documentSource=layerDef.options.documentSource;var layerName=layerDef.options.layerName;documentSource.getGeographicBoundingBox({layerId:layerName,onSuccess:function(bbox){reportLayer(bbox);},onError:function(errorMsg){$n2.log('Error computing bounds for layer '+layerName+': '+errorMsg);reportLayer(null);}});};};testDone();function reportLayer(bounds){--layersPending;if(null==bounds){}else if(false==_this._isValidBounds(bounds)){}else{if(null==layerBoundingBox){layerBoundingBox=bounds;}else{if(layerBoundingBox[0]>bounds[0])layerBoundingBox[0]=bounds[0];if(layerBoundingBox[1]>bounds[1])layerBoundingBox[1]=bounds[1];if(layerBoundingBox[2]<bounds[2])layerBoundingBox[2]=bounds[2];if(layerBoundingBox[3]<bounds[3])layerBoundingBox[3]=bounds[3];};};testDone();};function testDone(){if(layersPending>0){return;};if(null==layerBoundingBox){initialBoundsComputed(mapOptions,initialBounds);return;};if(false==_this._isValidBounds(layerBoundingBox)){$n2.log('Invalid bounding box reported for layer in database.',layerBoundingBox);initialBoundsComputed(mapOptions,initialBounds);return;};var userInitialBounds=new OpenLayers.Bounds(initialBounds[0],initialBounds[1],initialBounds[2],initialBounds[3]);var layerInitialBounds=new OpenLayers.Bounds(layerBoundingBox[0],layerBoundingBox[1],layerBoundingBox[2],layerBoundingBox[3]);if(mapOptions.mapCoordinateSpecifications.srsName!=='EPSG:4326'){var userProj=new OpenLayers.Projection(mapOptions.mapCoordinateSpecifications.srsName);var dbProj=new OpenLayers.Projection('EPSG:4326');layerInitialBounds.transform(dbProj,userProj);};if(userInitialBounds.containsBounds(layerInitialBounds)){initialBoundsComputed(mapOptions,initialBounds);}else if(layerInitialBounds.getWidth()<userInitialBounds.getWidth()||layerInitialBounds.getHeight()<userInitialBounds.getHeight()){if(layerInitialBounds.getWidth()<userInitialBounds.getWidth()){var l=userInitialBounds.getWidth()/2;var m=(layerInitialBounds.left+layerInitialBounds.right)/2;layerInitialBounds.left=m-l;layerInitialBounds.right=m+l;};if(layerInitialBounds.getHeight()<userInitialBounds.getHeight()){var l=userInitialBounds.getHeight()/2;var m=(layerInitialBounds.bottom+layerInitialBounds.top)/2;layerInitialBounds.bottom=m-l;layerInitialBounds.top=m+l;};initialBoundsComputed(mapOptions,[layerInitialBounds.left,layerInitialBounds.bottom,layerInitialBounds.right,layerInitialBounds.top]);}else{initialBoundsComputed(mapOptions,[layerInitialBounds.left,layerInitialBounds.bottom,layerInitialBounds.right,layerInitialBounds.top]);};};};function initialBoundsComputed(mapOptions,initialBounds){mapOptions.mapCoordinateSpecifications.initialBounds=initialBounds;var mapInfo=_this.module.getMapInfo();if(mapInfo&&mapInfo.coordinates&&mapInfo.coordinates.maxExtent){mapOptions.mapCoordinateSpecifications.maxExtent=mapInfo.coordinates.maxExtent;}else if(mapOptions.mapDisplay.srsName!==null&&mapOptions.mapDisplay.srsName!=='EPSG:4326'){mapOptions.mapCoordinateSpecifications.maxExtent=mapOptions.mapCoordinateSpecifications.initialBounds;};_this.mapControl=nunaliit2.mapAndControls(mapOptions);$n2.log('module',_this);_this.mapControl.contributions=_this.config.contributions;_this.mapControl.requests=_this.config.directory.requestService;_this._sendDispatchMessage({type:'reportModuleDisplay',moduleDisplay:_this});opts.onSuccess(_this);};},_navigationDocumentLoaded:function(doc){if(doc&&doc.nunaliit_navigation){var $title=$('#'+this.titleName);if($title.length>0){if(doc.nunaliit_navigation.title){var title=$n2.couchL10n.getLocalizedString(doc.nunaliit_navigation.title);$title.text(title);}else{$title.empty();};};var $nav=$('#'+this.navigationName);if($nav.length>0){$nav.empty();if(doc.nunaliit_navigation.items&&doc.nunaliit_navigation.items.length>0){var $ul=$('<ul></ul>');$nav.append($ul);insertItems($ul,doc.nunaliit_navigation.items);};};};function insertItems($ul,items){for(var i=0,e=items.length;i<e;++i){var item=items[i];var $li=$('<li></li>');$ul.append($li);if(item.title&&item.href){var $a=$('<a></a>');$a.attr('href',item.href);var title=$n2.couchL10n.getLocalizedString(item.title);$a.text(title);$li.append($a);}else if(item.title){var $span=$('<span></span>');var title=$n2.couchL10n.getLocalizedString(item.title);$span.text(title);$li.append($span);};if(item.items&&item.items.length>0){var $innerUl=$('<ul></ul>');$li.append($innerUl);insertItems($innerUl,item.items);};};};},_initSidePanel:function(){var _this=this;var customService=this._getCustomService();var $elem=$('#'+this.sidePanelName);var displayIntroFn=customService.getOption('moduleDisplayIntroFunction',null);if(displayIntroFn){displayIntroFn({elem:$elem,config:this.config,moduleDisplay:this});}else{this.module.displayIntro({elem:$elem,showService:this._getShowService(),onLoaded:function(){_this._sendDispatchMessage({type:'loadedModuleContent'});}});};},_getDispatcher:function(){var d=null;if(this.config.directory){d=this.config.directory.dispatchService;};return d;},_getShowService:function(){var ss=null;if(this.config.directory){ss=this.config.directory.showService;};return ss;},_getCustomService:function(){var cs=null;if(this.config.directory){cs=this.config.directory.customService;};return cs;},_sendDispatchMessage:function(m){var d=this._getDispatcher();if(d){d.send(DH,m);};},_sendSynchronousMessage:function(m){var d=this._getDispatcher();if(d){d.synchronousCall(DH,m);};},_isValidBounds:function(bounds){if(!bounds.length)return false;if(bounds.length<4)return false;if(bounds[0]<-180||bounds[0]>180)return false;if(bounds[2]<-180||bounds[2]>180)return false;if(bounds[1]<-90||bounds[1]>90)return false;if(bounds[3]<-90||bounds[3]>90)return false;return true;},_installModuleTitle:function($elem,text){var _this=this;var $a=$('<a class="nunaliit_module_title_link" href="#"></a>');$a.text(text);$elem.empty().append($a);$a.click(function(e){var d=_this._getDispatcher();if(d){d.send(DH,{type:'mapResetExtent'});};return true;});},_installHelpButton:function(){var _this=this;var $elem=$('#'+this.helpButtonName);if($elem.length<1)return;$elem.empty();var moduleInfo=this.module.getModuleInfo();if(moduleInfo.help&&moduleInfo.help.nunaliit_type==='reference'&&moduleInfo.help.doc){this.config.atlasDb.getDocument({docId:moduleInfo.help.doc,onSuccess:function(doc){if(doc&&doc.nunaliit_help&&doc.nunaliit_help.type==='html'&&doc.nunaliit_help.content){helpContentHtml(doc.nunaliit_help.content);}else{$n2.log('Do not know how to interpret help document');$elem.attr('n2_error','Do not know how to interpret help document');};},onError:function(err){$n2.log('Unable to load help document',err);$elem.attr('n2_error','Unable to load help document'+err);}});}else{$n2.log('Do not know how to handle help information');$elem.attr('n2_error','Do not know how to handle help information');};function helpContentHtml(baseContent){var content=_loc(baseContent);var $a=$('<a class="nunaliit_module_help_button" href="#"></a>');$a.text(_loc('Help'));$('#'+_this.helpButtonName).empty().append($a);$a.click(function(){if(!_this.helpDialogId){_this.helpDialogId=$n2.getUniqueId();};var $dialog=$('#'+_this.helpDialogId);if($dialog.length>0){var isOpen=$dialog.dialog('isOpen');if(isOpen){$dialog.dialog('close');}else{$dialog.dialog('open');};}else{$dialog=$('<div id="'+_this.helpDialogId+'" class="n2module_help_content"></div>');$dialog.html(content).appendTo($('body'));var initialHeight=$dialog.height();var windowHeight=$(window).height();var diagMaxHeight=Math.floor(windowHeight*0.8);var dialogOptions={autoOpen:true,dialogClass:'n2module_help_dialog',title:_loc('Help'),modal:false,width:400,position:{my:'right top',at:'right bottom',of:$('#'+_this.helpButtonName+' .nunaliit_module_help_button')},close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};if(initialHeight>diagMaxHeight){dialogOptions.height=diagMaxHeight;};$dialog.dialog(dialogOptions);};});};}});$n2.couchModule={ModuleDisplay:ModuleDisplay};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var Export=$n2.Class('Export',{serverUrl:null,initialize:function(opts_){var opts=$n2.extend({url:null},opts_);this.serverUrl=opts.url;},checkAvailable:function(opts_){var opts=$n2.extend({onAvailable:function(){},onNotAvailable:function(){}},opts_);if(!this.serverUrl){opts.onNotAvailable();return;};var _this=this;$.ajax({url:this.serverUrl+'welcome',type:'GET',dataType:'json',success:function(data,textStatus,jqXHR){if(data&&data.ok){opts.onAvailable();}else{opts.onNotAvailable();};},error:function(jqXHR,textStatus,errorThrown){opts.onNotAvailable();}});},exportByDocIds:function(opts_){var opts=$n2.extend({docIds:null,targetWindow:null,geometryType:'all',contentType:null,fileName:null,onError:$n2.reportError},opts_);if(!opts.docIds){onError('docIds must be provided when exporting by docIds');};var target='';if(opts.targetWindow){target=' target="'+opts.targetWindow+'"';};var url=this.serverUrl+'export';if(opts.fileName){url=url+'/'+opts.fileName;};var $form=$('<form action="'+url+'" method="POST"'+target+'></form>');$('<input type="hidden" name="format" value="geojson"></input>').appendTo($form);$('<input type="hidden" name="method" value="doc-id"></input>').appendTo($form);$('<input type="hidden" name="filter"></input>').val(opts.geometryType).appendTo($form);if(opts.contentType){$('<input type="hidden" name="contentType"></input>').val(opts.contentType).appendTo($form);};for(var i=0,e=opts.docIds.length;i<e;++i){var docId=opts.docIds[i];$('<input type="hidden" name="name"></input>').val(docId).appendTo($form);};$('body').append($form);$form.submit();}});$n2.couchExport={Export:Export};})(jQuery,nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DispatchSupport=$n2.Class('DispatchSupport',{options:null,dispatcherHandle:null,docCreatedCb:null,docUpdatedCb:null,docRevisionMap:null,initialize:function(opts_){this.options=$n2.extend({db:null,directory:null},opts_);var _this=this;this.docRevisionMap={};this.docCreatedCb=function(doc){_this._docUploaded(doc,true);};this.docUpdatedCb=function(doc){_this._docUploaded(doc,false);};var dispatcher=this._getDispatcher();if(dispatcher){this.dispatcherHandle=dispatcher.getHandle('n2.couchDispatchSupport');var f=function(m){_this._handleDispatch(m);};dispatcher.register(this.dispatcherHandle,'documentCreated',f);dispatcher.register(this.dispatcherHandle,'documentUpdated',f);dispatcher.register(this.dispatcherHandle,'editClosed',f);$(window).resize(function(){_this._windowResized();});};},_handleDispatch:function(m){if('documentCreated'===m.type){var requestService=this._getRequestService();if(requestService){requestService.requestDocument(m.docId,this.docCreatedCb);};}else if('documentUpdated'===m.type){var requestService=this._getRequestService();if(requestService){requestService.requestDocument(m.docId,this.docUpdatedCb);};}else if('editClosed'===m.type){};},_docUploaded:function(doc,created){if(doc.nunaliit_geom){var type=created?'featureCreated':'featureUpdated';this._dispatch({type:type,docId:doc._id,doc:doc});};var type=created?'documentContentCreated':'documentContentUpdated';this._dispatch({type:type,docId:doc._id,doc:doc});},_windowResized:function(){var d=this._getDispatcher();d.send(this.dispatcherHandle,{type:'windowResized'});},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;},_dispatch:function(m){var dispatcher=this._getDispatcher();if(dispatcher){dispatcher.send(this.dispatcherHandle,m);};},_getRequestService:function(){var r=null;if(this.options.directory){r=this.options.directory.requestService;};return r;}});$n2.couchDispatchSupport={DispatchSupport:DispatchSupport};})(nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchEvents';var EventSupport=$n2.Class('EventSupport',{options:null,dispatchCallback:null,handler:null,registeredEvents:null,initialize:function(opts_){this.options=$n2.extend({directory:null},opts_);var _this=this;this.registeredEvents={};this.handler=function(m){_this._defaultHandler(m);};this.dispatchCallback=function(m){_this.handler(m);};this.register('userSelect');this.register('userUnselect');this.register('userFocusOn');this.register('userFocusOff');},register:function(type){if(!this.registeredEvents[type]){var d=this._getDispatcher();if(d){d.register(DH,type,this.dispatchCallback);};this.registeredEvents[type]=true;};},setHandler:function(handler){if(typeof(handler)==='function'){this.handler=handler;};},getHandler:function(){return this.handler;},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;},_dispatch:function(m){var d=this._getDispatcher();if(d){d.send(DH,m);};},_defaultHandler:function(m){if('userSelect'===m.type){var forward={type:'selected'};for(var key in m){if('type'===key){forward.type='selected';}else{forward[key]=m[key];};};this._dispatch(forward);}else if('userUnselect'===m.type){this._dispatch({type:'unselected',docId:m.docId,doc:m.doc,feature:m.feature});}else if('userFocusOn'===m.type){this._dispatch({type:'focusOn',docId:m.docId,doc:m.doc,feature:m.feature});}else if('userFocusOff'===m.type){this._dispatch({type:'focusOff',docId:m.docId,doc:m.doc,feature:m.feature});};}});$n2.couchEvents={EventSupport:EventSupport};})(nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};function isKeyEditingAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;return true;}
function isValueEditingAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;return true;};function isKeyDeletionAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;return true;};function _parseError(XMLHttpRequest,textStatus){var err=$n2.utils.parseHttpJsonError(XMLHttpRequest,textStatus);if(err.tokenExpired){return _loc('The information is expired.');};if(err.userUpdated){return _loc('Unable to complete operation because the user information has been updated.');};return _loc('Unable to complete operation : {err}',{err:err.error});};var UserEditor=$n2.Class({userDoc:null,userSchema:null,schemaEditorService:null,configService:null,originalDoc:null,userDb:null,elemId:null,schemaEditor:null,treeEditor:null,onPreSaveFn:null,onSavedFn:null,onPreDeleteFn:null,onDeletedFn:null,onCancelledFn:null,onFinishedFn:null,initialize:function(opts_){var opts=$n2.extend({userDoc:null,userDb:null,elem:null,elemId:null,userSchema:null,schemaRepository:null,schemaEditorService:null,configService:null,onPreSaveFn:function(userDoc){return true;},onSavedFn:function(userDoc){},onPreDeleteFn:function(userDoc){return true;},onDeletedFn:function(userDoc){},onCancelledFn:function(userDoc){},onFinishedFn:function(userDoc){}},opts_);var _this=this;this.userDoc=opts.userDoc;this.userDb=opts.userDb;this.onPreSaveFn=opts.onPreSaveFn;this.onSavedFn=opts.onSavedFn;this.onPreDeleteFn=opts.onPreDeleteFn;this.onDeletedFn=opts.onDeletedFn;this.onCancelledFn=opts.onCancelledFn;this.onFinishedFn=opts.onFinishedFn;this.schemaEditorService=opts.schemaEditorService;this.configService=opts.configService;this.originalDoc=$n2.extend(true,{},this.userDoc);if(!this.userDoc.nunaliit_emails){this.userDoc.nunaliit_emails=[];};this.elemId=opts.elemId;if(opts.elem){var $elem=$(opts.elem);var id=$elem.attr('id');if(!id){id=$n2.getUniqueId();$elem.attr('id',id);};this.elemId=id;};if(opts.userSchema){userSchemaLoaded(opts.userSchema);}else if(opts.schemaRepository){opts.schemaRepository.getSchema({name:'user',onSuccess:function(schema){userSchemaLoaded(schema);},onError:function(){userSchemaLoaded(null);}});}else{userSchemaLoaded(null);};function userSchemaLoaded(userSchema){_this.userSchema=userSchema;_this._display();};},documentUpdated:function(){this._refresh();},_getElem:function(){return $('#'+this.elemId);},_getCouchServer:function(){return this.userDb.server;},_display:function(){var _this=this;var doc=this.userDoc;var $elem=this._getElem();$elem.empty();var $editor=$('<div class="n2UserEdit_editor"></div>').appendTo($elem);var $editorsContainer=$('<div class="n2UserEdit_editorContainer"></div>').appendTo($editor);var usingAccordion=false;if(this.userSchema&&this.schemaEditorService){usingAccordion=true;$n2.schema.GlobalAttributes.disableKeyUpEvents=true;$('<h3><a href="#">'+_loc('Form View')+'</a></h3>').appendTo($editorsContainer);var $schemaContainer=$('<div class="n2UserEdit_schemaEditor"></div>').appendTo($editorsContainer);this.schemaEditor=this.schemaEditorService.editDocument({doc:doc,schema:this.userSchema,$div:$schemaContainer,onChanged:function(){if(_this.treeEditor){_this.treeEditor.refresh();};}});};if(usingAccordion){$('<h3><a href="#">'+_loc('Tree View')+'</a></h3>').appendTo($editorsContainer);};var $treeContainer=$('<div class="n2UserEdit_treeEditor"></div>').appendTo($editorsContainer);var objectTree=new $n2.tree.ObjectTree($treeContainer,doc);this.treeEditor=new $n2.tree.ObjectTreeEditor(objectTree,doc,{onObjectChanged:function(){if(_this.schemaEditor){_this.schemaEditor.refresh();};},isKeyEditingAllowed:isKeyEditingAllowed,isValueEditingAllowed:isValueEditingAllowed,isKeyDeletionAllowed:isKeyDeletionAllowed});if(usingAccordion){$editorsContainer.accordion({heightStyle:'content',autoHeight:false,clearStyle:true});};var $buttons=$('<div class="n2UserEdit_buttons"></div>').appendTo($editor);$('<input type="button"/>').addClass('n2UserEdit_saveButton').val(_loc('Save')).appendTo($buttons).click(function(){_this._save();return false;});$('<input type="button"/>').addClass('n2UserEdit_deleteButton').val(_loc('Delete')).appendTo($buttons).click(function(){_this._delete();return false;});$('<input type="button"/>').addClass('n2UserEdit_rolesButton').val(_loc('Roles')).appendTo($buttons).click(function(e){_this._rolesDialog(doc,function(roles){if(roles.length>0){doc.roles=roles;}else if(doc.roles){delete doc.roles;};_this.treeEditor.refresh();});return false;});$('<input type="button"/>').addClass('n2UserEdit_passwordButton').val(_loc('Set Password')).appendTo($buttons).click(function(e){_this._passwordDialog();return false;});$('<input type="button"/>').addClass('n2UserEdit_cancelButton').val(_loc('Cancel')).appendTo($buttons).click(function(e){_this._cancel();return false;});},_refresh:function(){this.treeEditor.refresh();},_rolesDialog:function(userDoc,selectedRolesFn){var diagId=$n2.getUniqueId();var $rolesDialog=$('<div id="'+diagId+'" class="n2_roles_dialog"></div>');$('<div class="n2_roles_list"></div>').appendTo($rolesDialog).append($('<div class="olkit_wait"></div>'));var $buttons=$('<div class="n2_roles_buttons"></div>').appendTo($rolesDialog);$('<input type="button"/>').val(_loc('OK')).appendTo($buttons).click(function(){var $dialog=$('#'+diagId);var roles=[];$dialog.find('input[type=checkbox]:checked').each(function(){var $input=$(this);roles.push($input.attr('name'));});selectedRolesFn(roles);$dialog.dialog('close');});$('<input type="button"/>').val(_loc('Cancel')).appendTo($buttons).click(function(){$('#'+diagId).dialog('close');});var dialogOptions={autoOpen:true,title:_loc('Select Roles'),modal:true,width:740,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};$rolesDialog.dialog(dialogOptions);if(this.configService){this.configService.getNunaliitServerRoles({onSuccess:function(roles){loadedRoles(roles);},onError:function(err){loadedRoles([]);}});}else{loadedRoles([]);};function loadedRoles(roles){var roleMap={};for(var i=0,e=roles.length;i<e;++i){roleMap[roles[i]]=false;};if(userDoc.roles){for(var i=0,e=userDoc.roles.length;i<e;++i){roleMap[userDoc.roles[i]]=true;};};roles=[];for(var role in roleMap){roles.push(role);};roles.sort();var $list=$('#'+diagId).find('.n2_roles_list');$list.empty();for(var i=0,e=roles.length;i<e;++i){var role=roles[i];var $div=$('<div></div>');var id=$n2.getUniqueId();var $input=$('<input type="checkbox"/>').attr('name',role).attr('id',id).appendTo($div);if(roleMap[role]){$input.attr('checked',"checked");};$('<label/>').attr('for',id).text(role).appendTo($div);$list.append($div);};};},_passwordDialog:function(){var _this=this;var diagId=$n2.getUniqueId();var $passwordDialog=$('<div id="'+diagId+'" class="n2User_setPassword_dialog"></div>');var $passwordInputs=$('<div class="n2User_setPassword_inputs"></div>').appendTo($passwordDialog);var id=$n2.getUniqueId();var $div=$('<div></div>').appendTo($passwordInputs);$('<label/>').attr('for',id).text(_loc('Enter password:')).appendTo($div);$('<input type="password" name="password"/>').attr('id',id).appendTo($div);var id=$n2.getUniqueId();var $div=$('<div></div>').appendTo($passwordInputs);$('<label/>').attr('for',id).text(_loc('Confirm password:')).appendTo($div);$('<input type="password" name="confirm"/>').attr('id',id).appendTo($div);var $buttons=$('<div class="n2User_setPassword_buttons"></div>').appendTo($passwordDialog);$('<input type="button"/>').val(_loc('OK')).appendTo($buttons).click(function(){var $dialog=$('#'+diagId);var pw1=$dialog.find('input[name=password]').val();var pw2=$dialog.find('input[name=confirm]').val();if(pw1!=pw2){alert(_loc('Passwords do not match'));}else if(pw1.length<6){alert(_loc('Password is too short'));}else{_this.userDb.computeUserPassword({userDoc:_this.userDoc,password:pw1,onSuccess:function(){_this._refresh();$dialog.dialog('close');},onError:function(errMsg){alert(_loc('Unable to set password: ')+errMsg);}});};});$('<input type="button"/>').val(_loc('Cancel')).appendTo($buttons).click(function(){$('#'+diagId).dialog('close');});var dialogOptions={autoOpen:true,title:_loc('Change Password'),modal:true,width:740,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};$passwordDialog.dialog(dialogOptions);},_save:function(){var _this=this;this.onPreSaveFn(this.userDoc);this.userDb.updateUser({user:this.userDoc,onSuccess:function(docInfo){_this.userDoc._rev=docInfo.rev;_this.originalDoc=$n2.extend(true,{},_this.userDoc);_this._refresh();_this.onSavedFn(_this.userDoc);_this.onFinishedFn(_this.userDoc);},onError:function(errMsg){alert(_loc('Unable to save user document: ')+errMsg);}});},_delete:function(){var _this=this;if(false==confirm('You are about delete a user configuration object. Do you wish to proceed?')){return;};this.onPreDeleteFn(this.userDoc);this.userDb.deleteUser({user:this.userDoc,onSuccess:function(){var $elem=_this._getElem();$elem.empty();_this.onDeletedFn(_this.userDoc);_this.onFinishedFn(_this.userDoc);},onError:function(errMsg){alert(_loc('Unable to delete user document: ')+errMsg);}});},_cancel:function(){var patch=patcher.computePatch(this.originalDoc,this.userDoc);if(patch){if(false==confirm(_loc('Document was modified and changes will be lost. Do you wish to continue?'))){return;};};var $elem=this._getElem();$elem.empty();this.onCancelledFn(this.userDoc);this.onFinishedFn(this.userDoc);}});var UserService=$n2.Class({userDb:null,userServerUrl:null,userSchema:null,schemaRepository:null,schemaEditorService:null,configService:null,initialize:function(opts_){var opts=$n2.extend({userDb:null,userServerUrl:null,configService:null,userSchema:null,schemaRepository:null,schemaEditorService:null},opts_);this.userDb=opts.userDb;this.userServerUrl=opts.userServerUrl;this.configService=opts.configService;this.userSchema=opts.userSchema;this.schemaRepository=opts.schemaRepository;this.schemaEditorService=opts.schemaEditorService;},startEdit:function(opts_){var opts=$n2.extend({userSchema:this.userSchema,schemaRepository:this.schemaRepository,schemaEditorService:this.schemaEditorService},opts_,{userDb:this.userDb,configService:this.configService});return new UserEditor(opts);},initiateUserCreation:function(opts_){var opts=$n2.extend({emailAddress:null,onSuccess:function(){},onError:function(err){}},opts_);var url=this.userServerUrl+'initUserCreation';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{email:opts.emailAddress},dataType:'json',success:function(result){if(result.error){opts.onError(result.error);}else{opts.onSuccess(result);};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});},validateUserCreation:function(opts_){var opts=$n2.extend({token:null,onSuccess:function(){},onError:function(err){}},opts_);var url=this.userServerUrl+'validateUserCreation';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{token:opts.token},dataType:'json',success:function(result){if(result.error){opts.onError(result.error);}else{opts.onSuccess(result);};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});},completeUserCreation:function(opts_){var opts=$n2.extend({token:null,displayName:null,password:null,sendEmailPasswordReminder:false,userAgreement:null,onSuccess:function(){},onError:function(err){}},opts_);var url=this.userServerUrl+'completeUserCreation';$.ajax({url:url,type:'POST',async:true,traditional:true,data:{token:opts.token,display:opts.displayName,password:opts.password,emailPassword:opts.sendEmailPasswordReminder,userAgreement:opts.userAgreement},dataType:'json',success:function(result){if(result.error){opts.onError(result.error);}else{opts.onSuccess(result);};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});},initiatePasswordRecovery:function(opts_){var opts=$n2.extend({emailAddress:null,onSuccess:function(){},onError:function(err){}},opts_);var url=this.userServerUrl+'initPasswordRecovery';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{email:opts.emailAddress},dataType:'json',success:function(result){if(result.error){opts.onError(result.error);}else{opts.onSuccess(result);};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});},validatePasswordRecovery:function(opts_){var opts=$n2.extend({token:null,onSuccess:function(){},onError:function(err){}},opts_);var url=this.userServerUrl+'validatePasswordRecovery';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{token:opts.token},dataType:'json',success:function(result){if(result.error){opts.onError(result.error);}else{opts.onSuccess(result);};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});},completePasswordRecovery:function(opts_){var opts=$n2.extend({token:null,password:null,sendEmailPasswordReminder:false,onSuccess:function(){},onError:function(err){}},opts_);var url=this.userServerUrl+'completePasswordRecovery';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{token:opts.token,password:opts.password,emailPassword:opts.sendEmailPasswordReminder},dataType:'json',success:function(result){if(result.error){opts.onError(result.error);}else{opts.onSuccess(result);};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});},generatePassword:function(opts_){var opts=$n2.extend({onSuccess:function(password){},onError:function(err){}},opts_);var url=this.userServerUrl+'generatePassword';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{},dataType:'json',success:function(result){if(result.error){opts.onError(result.error);}else{opts.onSuccess(result.password);};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});},acceptUserAgreement:function(opts_){var opts=$n2.extend({userAgreement:null,onSuccess:function(){},onError:function(err){}},opts_);var url=this.userServerUrl+'acceptUserAgreement';$.ajax({url:url,type:'POST',async:true,traditional:true,data:{userAgreement:opts.userAgreement},dataType:'json',success:function(result){opts.onSuccess();},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});}});$n2.couchUser={UserEditor:UserEditor,UserService:UserService};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var HelpDocument=$n2.Class({db:null,doc:null,initialize:function(opts_){var opts=$n2.extend({db:null,doc:null},opts_);this.db=opts.db;this.doc=opts.doc;},getHtmlDescription:function(opts_){var opts=$n2.extend({onSuccess:function(html){},onError:function(err){}},opts_);var doc=this.doc;if(doc&&doc.nunaliit_help&&doc.nunaliit_help.nunaliit_type==='help'){var help=doc.nunaliit_help;if('attachment'===help.type){this._getAttachment(opts);return;}else if('html'===help.type){this._getHtml(opts);return;}else if('text'===help.type){this._getText(opts);return;}};opts.onError(_loc('Invalid help document content'));},_getAttachment:function(opts){var doc=this.doc;if(doc.nunaliit_help.attachmentName){var localeStr=$n2.l10n.getStringForLocale(doc.nunaliit_help.attachmentName);if(localeStr.str){var attUrl=this.db.getAttachmentUrl(doc,localeStr.str);$.ajax({url:attUrl,type:'get',async:true,success:function(intro){if(localeStr.fallback){var $outer=$('<span class="n2_localized_string n2_localize_fallback"></span>');$('<span class="n2_localize_fallback_lang"></span>').text('('+localeStr.lang+')').appendTo($outer);$('<span></span>').html(intro).appendTo($outer);opts.onSuccess($outer.html());}else{opts.onSuccess(intro);};},error:function(XMLHttpRequest,textStatus,errorThrown){opts.onError(_loc('Error fetching attachment from help document'));}});return;};};opts.onError(_loc('Invalid attachment in help document'));},_getHtml:function(opts){var doc=this.doc;if(doc.nunaliit_help.content){var localeStr=$n2.l10n.getStringForLocale(doc.nunaliit_help.content);if(localeStr.str){if(localeStr.fallback){var $outer=$('<span class="n2_localized_string n2_localize_fallback"></span>');$('<span class="n2_localize_fallback_lang"></span>').text('('+localeStr.lang+')').appendTo($outer);$('<span></span>').html(localeStr.str).appendTo($outer);opts.onSuccess($outer.html());}else{opts.onSuccess(localeStr.str);};return;};};opts.onError(_loc('Invalid content in help document'));},_getText:function(opts){var doc=this.doc;if(doc.nunaliit_help.content){var localeStr=$n2.l10n.getStringForLocale(doc.nunaliit_help.content);if(localeStr.str){if(localeStr.fallback){var $outer=$('<span class="n2_localized_string n2_localize_fallback"></span>');$('<span class="n2_localize_fallback_lang"></span>').text('('+localeStr.lang+')').appendTo($outer);$('<span></span>').text(localeStr.str).appendTo($outer);opts.onSuccess($outer.html());}else{var $outer=$('<span class="n2_localized_string"></span>').text(localeStr.str);opts.onSuccess($outer.html());};return;};};opts.onError(_loc('Invalid content in help document'));}});var LoadHelpDocument=function(opts_){var opts=$n2.extend({db:null,id:null,onSuccess:function(helpDoc){},onError:function(err){}},opts_);if(!opts.db){opts.onError(_loc('A database must be provided'));};if(!opts.id){opts.onError(_loc('A document identifier must be provided'));};opts.db.getDocument({docId:opts.id,onSuccess:function(doc){var hd=new HelpDocument({db:opts.db,doc:doc});opts.onSuccess(hd);},onError:function(errorMsg){opts.onError(_loc('Unable to access help document: {{docId}}',{docId:opts.id}));}});};var CheckBrowserCompliance=function(opts_){var opts=$n2.extend({db:null,helpDocumentId:'help.browsers'},opts_);var browserInfo=$n2.utils.getBrowserInfo();if(browserInfo&&browserInfo.browser==='Explorer'){if(typeof(browserInfo.version)==='number'){if(browserInfo.version==9||browserInfo.version<8){reportUnsupportedBrowser(opts);};};};function reportUnsupportedBrowser(opts){LoadHelpDocument({db:opts.db,id:opts.helpDocumentId,onSuccess:function(helpDoc){helpDoc.getHtmlDescription({onSuccess:function(html){openDialog(html);},onError:error});},onError:error});function error(){alert(_loc('Your browser is not supported by this web site.'));};};function openDialog(htmlContent){var helpDialogId=$n2.getUniqueId();var $dialog=$('<div id="'+helpDialogId+'" class="n2module_help_content"></div>');$dialog.html(htmlContent).appendTo($('body'));var initialHeight=$dialog.height();var windowHeight=$(window).height();var diagMaxHeight=Math.floor(windowHeight*0.8);var dialogOptions={autoOpen:true,dialogClass:'n2module_help_dialog',title:_loc('Unsupported Browser'),modal:true,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};if(initialHeight>diagMaxHeight){dialogOptions.height=diagMaxHeight;};$dialog.dialog(dialogOptions);};};$n2.couchHelp={LoadHelpDocument:LoadHelpDocument,CheckBrowserCompliance:CheckBrowserCompliance};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchDocument';function adjustDocument(doc){var userName=null;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext){userName=sessionContext.name;};var nowTime=(new Date()).getTime();if(userName){if(null==doc.nunaliit_created){doc.nunaliit_created={nunaliit_type:'actionstamp',name:userName,time:nowTime,action:'created'};};doc.nunaliit_last_updated={nunaliit_type:'actionstamp',name:userName,time:nowTime,action:'updated'};};var dates=[];$n2.couchUtils.extractSpecificType(doc,'date',dates);for(var i=0,e=dates.length;i<e;++i){var d=dates[i];if(d.date){try{var dateInt=$n2.date.parseUserDate(d.date);d.min=dateInt.min;d.max=dateInt.max;}catch(e){if(d.min)delete d.min;if(d.max)delete d.max;};};};}
var CouchDocumentSource=$n2.Class($n2.document.DocumentSource,{db:null,designDoc:null,dispatchService:null,geometryRepository:null,initialize:function(opts_){var opts=$n2.extend({id:null,db:null,dispatchService:null},opts_);$n2.document.DocumentSource.prototype.initialize.call(this,opts);this.db=opts.db;this.dispatchService=opts.dispatchService;this.designDoc=this.db.getDesignDoc({ddName:'atlas'});this.geometryRepository=new GeometryRepository({db:this.db,designDoc:this.designDoc,dispatchService:this.dispatchService});},createDocument:function(opts_){var opts=$n2.extend({doc:{},onSuccess:function(doc){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);var _this=this;var doc=opts.doc;adjustDocument(doc);this.db.createDocument({data:doc,onSuccess:function(docInfo){doc._id=docInfo.id;doc._rev=docInfo.rev;doc.__n2Source=_this;_this._dispatch({type:'documentVersion',docId:docInfo.id,rev:docInfo.rev});_this._dispatch({type:'documentCreated',docId:docInfo.id});opts.onSuccess(doc);},onError:opts.onError});},getDocument:function(opts_){var opts=$n2.extend({docId:null,rev:null,revs_info:false,revisions:false,conflicts:false,deleted_conflicts:false,onSuccess:function(doc){},onError:function(errorMsg){}},opts_);var _this=this;this.db.getDocument({docId:opts.docId,rev:opts.rev,revs_info:opts.revs_info,revisions:opts.revisions,conflicts:opts.conflicts,deleted_conflicts:opts.deleted_conflicts,onSuccess:function(doc){doc.__n2Source=_this;opts.onSuccess(doc);},onError:opts.onError});},getDocuments:function(opts_){var opts=$n2.extend({docIds:null,onSuccess:function(docs){},onError:function(errorMsg){}},opts_);var _this=this;this.db.getDocuments({docIds:opts.docIds,onSuccess:function(docs){for(var i=0,e=docs.length;i<e;++i){var doc=docs[i];doc.__n2Source=_this;};opts.onSuccess(docs);},onError:opts.onError});},getDocumentAttachmentUrl:function(doc,attachmentName){return this.db.getAttachmentUrl(doc,attachmentName);},verifyDocumentExistence:function(opts_){var opts=$n2.extend({docIds:null,onSuccess:function(info){},onError:function(errorMsg){}},opts_);var docIds=opts.docIds;this.db.getDocumentRevisions({docIds:docIds,onSuccess:function(info){var result={};for(var id in info){result[id]={rev:info[id]};};opts.onSuccess(result);},onError:opts.onError});},updateDocument:function(opts_){var opts=$n2.extend({doc:null,onSuccess:function(doc){},onError:function(errorMsg){}},opts_);var _this=this;var doc=opts.doc;adjustDocument(doc);var copy={};for(var key in doc){if(key==='__n2Source'){}else{copy[key]=doc[key];};};this.db.updateDocument({data:copy,onSuccess:function(docInfo){doc._rev=docInfo.rev;_this._dispatch({type:'documentVersion',docId:docInfo.id,rev:docInfo.rev});_this._dispatch({type:'documentUpdated',docId:docInfo.id});opts.onSuccess(doc);},onError:opts.onError});},deleteDocument:function(opts_){var opts=$n2.extend({doc:null,onSuccess:function(){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);var _this=this;var doc=opts.doc;var copy={};for(var key in doc){if(key==='__n2Source'){}else{copy[key]=doc[key];};};this.db.deleteDocument({data:copy,onSuccess:function(docInfo){_this._dispatch({type:'documentDeleted',docId:doc._id});opts.onSuccess();},onError:opts.onError});},getLayerDefinitions:function(opts_){var opts=$n2.extend({onSuccess:function(layerDefinitions){},onError:function(errorMsg){}},opts_);this.designDoc.queryView({viewName:'layer-definitions',include_docs:true,onSuccess:function(rows){var layerIdentifiers=[];for(var i=0,e=rows.length;i<e;++i){var doc=rows[i].doc;if(doc.nunaliit_layer_definition){var d=doc.nunaliit_layer_definition;if(!d.id){d.id=doc._id;};layerIdentifiers.push(d);};};opts.onSuccess(layerIdentifiers);},onError:opts.onError});},getDocumentInfoFromIds:function(opts_){var opts=$n2.extend({docIds:null,onSuccess:function(docInfos){},onError:function(errorMsg){}},opts_);this.designDoc.queryView({viewName:'info',keys:opts.docIds,onSuccess:function(rows){var infos=[];for(var i=0,e=rows.length;i<e;++i){infos.push(rows[i].value);};opts.onSuccess(infos);},onError:opts.onError});},getReferencesFromId:function(opts_){var opts=$n2.extend({docId:null,onSuccess:function(referenceIds){},onError:function(errorMsg){}},opts_);this.designDoc.queryView({viewName:'link-references',startkey:opts.docId,endkey:opts.docId,onSuccess:function(rows){var refIdMap={};for(var i=0,e=rows.length;i<e;++i){refIdMap[rows[i].id]=true;};var refIds=[];for(var refId in refIdMap){refIds.push(refId);};opts.onSuccess(refIds);},onError:opts.onError});},getProductFromId:function(opts_){var opts=$n2.extend({docId:null,onSuccess:function(referenceIds){},onError:function(errorMsg){}},opts_);this.designDoc.queryView({viewName:'nunaliit-source',startkey:opts.docId,endkey:opts.docId,onSuccess:function(rows){var refIdMap={};for(var i=0,e=rows.length;i<e;++i){refIdMap[rows[i].id]=true;};var refIds=[];for(var refId in refIdMap){refIds.push(refId);};opts.onSuccess(refIds);},onError:opts.onError});},getDocumentsFromGeographicFilter:function(opts_){var opts=$n2.extend({docIds:null,layerId:null,bbox:null,projectionCode:null,onSuccess:function(docs){},onError:function(errorMsg){}},opts_);var _this=this;var callerSuccess=opts.onSuccess;opts.onSuccess=function(docs){for(var i=0,e=docs.length;i<e;++i){docs[i].__n2Source=_this;};callerSuccess(docs);};this.geometryRepository.getDocumentsFromGeographicFilter(opts);},getGeographicBoundingBox:function(opts_){this.geometryRepository.getGeographicBoundingBox(opts_);},getReferencesFromOrigin:function(opts_){var opts=$n2.extend({docId:null,onSuccess:function(originReferenceIds){},onError:function(errorMsg){}},opts_);this.designDoc.queryView({viewName:'nunaliit-origin',startkey:opts.docId,endkey:opts.docId,onSuccess:function(rows){var refIdMap={};for(var i=0,e=rows.length;i<e;++i){refIdMap[rows[i].id]=true;};var refIds=[];for(var refId in refIdMap){refIds.push(refId);};opts.onSuccess(refIds);},onError:opts.onError});},getUniqueIdentifier:function(opts_){var opts=$n2.extend({onSuccess:function(uuid){},onError:function(errorMsg){}},opts_);var server=this.db.server;server.getUniqueId(opts);},_dispatch:function(m){if(this.dispatchService){this.dispatchService.send(DH,m);};}});var GeometryRepository=$n2.Class({db:null,designDoc:null,dispatchService:null,dbProjection:null,poles:null,mapProjectionMaxWidth:null,initialize:function(opts_){var opts=$n2.extend({db:null,designDoc:null,dispatchService:null},opts_);this.db=opts.db;this.designDoc=opts.designDoc;this.dispatchService=opts.dispatchService;this.dbProjection=new OpenLayers.Projection('EPSG:4326');this.poles={n:{},s:{}};this.mapProjectionMaxWidth={};},getDocumentsFromGeographicFilter:function(opts_){var opts=$n2.extend({docIds:null,layerId:null,bbox:null,projectionCode:null,onSuccess:function(docs){},onError:function(errorMsg){}},opts_);var _this=this;var viewQuery={viewName:'geom',onSuccess:handleDocs,onError:opts.onError};var bounds=opts.bbox;var fids=opts.docIds;var layerName=('string'===typeof(opts.layerId)?opts.layerId:null);if(bounds&&opts.projectionCode&&opts.projectionCode!=this.dbProjection.getCode()){var mapProjection=new OpenLayers.Projection(opts.projectionCode);var mapBounds=new OpenLayers.Bounds(bounds[0],bounds[1],bounds[2],bounds[3]);var dbBounds=mapBounds.clone().transform(mapProjection,this.dbProjection);var np=this._getPole(true,mapProjection);if(np&&mapBounds.contains(np.x,np.y)){var northBoundary=new OpenLayers.Bounds(-180,90,180,90);dbBounds.extend(northBoundary);};var sp=this._getPole(false,mapProjection);if(sp&&mapBounds.contains(sp.x,sp.y)){var southBoundary=new OpenLayers.Bounds(-180,-90,180,-90);dbBounds.extend(southBoundary);};bounds=[dbBounds.left,dbBounds.bottom,dbBounds.right,dbBounds.top];var maxWidth=this._getMapMaxWidth(mapProjection);if(maxWidth&&maxWidth<=(mapBounds.right-mapBounds.left)){bounds[0]=-180;bounds[2]=180;};};$n2.couchGeom.selectTileViewFromBounds(viewQuery,bounds,layerName,fids);this.designDoc.queryView(viewQuery);function handleDocs(rows){var docIds=[];var docs=[];while(rows.length>0){var row=rows.pop();var docId=row.id;if(_this.dispatchService){var m={type:'cacheRetrieveDocument',docId:docId,doc:null};_this.dispatchService.synchronousCall(DH,m);if(m.doc){docs.push(m.doc);}else{docIds.push(docId);};}else{docIds.push(docId);};};if(docIds.length>0){_this.db.getDocuments({docIds:docIds,onSuccess:function(docs_){for(var i=0,e=docs_.length;i<e;++i){docs.push(docs_[i]);};opts.onSuccess(docs);},onError:opts.onError});}else{opts.onSuccess(docs);};};},getGeographicBoundingBox:function(opts_){var opts=$n2.extend({layerId:null,bbox:null,onSuccess:function(bbox){},onError:function(errorMsg){}},opts_);this.designDoc.queryView({viewName:'geom-layer-bbox',startkey:opts.layerId,endkey:opts.layerId,onlyRows:true,reduce:true,onSuccess:function(rows){if(rows.length>0){opts.onSuccess(rows[0].value);}else{opts.onSuccess(null);};},onError:opts.onError});},_getPole:function(isNorth,mapProjection){var projCode=mapProjection.getCode();var label=isNorth?'n':'s';if(this.poles[label][projCode])return this.poles[label][projCode];if(isNorth){var p=new OpenLayers.Geometry.Point(0,90);}else{var p=new OpenLayers.Geometry.Point(0,-90);};var error=false;var previousFn=null;if(typeof(Proj4js)!=='undefined'){previousFn=Proj4js.reportError;Proj4js.reportError=function(m){error=true;};};p.transform(this.dbProjection,mapProjection);if(error){p=null;};if(previousFn){Proj4js.reportError=previousFn;};this.poles[label][projCode]=p;return p;},_getMapMaxWidth:function(proj){var projCode=proj.getCode();if(this.mapProjectionMaxWidth[projCode]){return this.mapProjectionMaxWidth[projCode];};if(proj&&proj.proj&&proj.proj.projName==='merc'){var w=new OpenLayers.Geometry.Point(-180,0);var e=new OpenLayers.Geometry.Point(180,0);var error=false;var previousFn=null;if(typeof(Proj4js)!=='undefined'){previousFn=Proj4js.reportError;Proj4js.reportError=function(m){error=true;};};w.transform(this.dbProjection,proj);e.transform(this.dbProjection,proj);if(error){w=null;e=null;};if(previousFn){Proj4js.reportError=previousFn;};if(e&&w){this.mapProjectionMaxWidth[projCode]=w.x-e.x;};};return this.mapProjectionMaxWidth[projCode];}});var CouchDocumentSourceWithSubmissionDb=$n2.Class(CouchDocumentSource,{submissionDb:null,submissionServerUrl:null,submissionServerDb:null,isSubmissionDataSource:null,initialize:function(opts_){var opts=$n2.extend({submissionDb:null,submissionServletUrl:null},opts_);CouchDocumentSource.prototype.initialize.call(this,opts);var _this=this;this.isSubmissionDataSource=true;this.submissionDb=opts.submissionDb;this.submissionServerUrl=opts.submissionServerUrl;var submissionServer=$n2.couch.getServer({pathToServer:this.submissionServerUrl,skipSessionInitialization:true,userDbName:'_users',onSuccess:function(server){_this.submissionServerDb=server.getDb({dbName:'submissionDb'});},onError:function(err){$n2.log("Unable to initialize submission server",err);alert(_loc('Unable to initialize submission database'));}});},createDocument:function(opts_){var opts=$n2.extend({doc:{},onSuccess:function(doc){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);var _this=this;if(!opts.doc){opts.onError('Document must be provided');};if(opts.doc._id){onUuidComputed(opts.doc._id);}else{var server=this.db.server;if(server){server.getUniqueId({onSuccess:onUuidComputed,onError:opts.onError});};};function onUuidComputed(docId){var doc=opts.doc;doc._id=docId;adjustDocument(doc);_this.submissionServerDb.createDocument({data:doc,onSuccess:function(docInfo){_this._warnUser();doc.__n2Source=_this;opts.onSuccess(doc);},onError:opts.onError});};},updateDocument:function(opts_){var opts=$n2.extend({doc:null,onSuccess:function(doc){},onError:function(errorMsg){}},opts_);var _this=this;var doc=opts.doc;adjustDocument(doc);var copy={};for(var key in doc){if(key==='__n2Source'){}else{copy[key]=doc[key];};};this.submissionServerDb.updateDocument({data:copy,onSuccess:function(docInfo){_this._warnUser();opts.onSuccess(doc);},onError:opts.onError});},deleteDocument:function(opts_){var opts=$n2.extend({doc:null,onSuccess:function(){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);var _this=this;var doc=opts.doc;this.submissionServerDb.deleteDocument({data:doc,onSuccess:function(docInfo){_this._warnUser();opts.onSuccess(doc);},onError:opts.onError});},_warnUser:function(){var shouldWarnUser=true;var c=$n2.cookie.getCookie('nunaliit_submissions');if(c){shouldWarnUser=false;};if(shouldWarnUser){var diagId=$n2.getUniqueId();var $diag=$('<div>').attr('id',diagId).addClass('n2_submission_warning_dialog');var $text=$('<div>').addClass('n2_submission_warning_text').appendTo($diag);$('<span>').text(_loc('Submissions to the database will not appear until they are approved')).appendTo($diag);var $mem=$('<div>').addClass('n2_submission_warning_memory').appendTo($diag);var cbId=$n2.getUniqueId();$('<input type="checkbox">').attr('id',cbId).appendTo($mem);$('<label>').attr('for',cbId).text(_loc('Do not show this warning again')).appendTo($mem);var $buttons=$('<div>').addClass('n2_submission_warning_buttons').appendTo($diag);$('<button>').addClass('n2_button_ok').appendTo($buttons).text(_loc('OK')).click(function(){var $diag=$('#'+diagId);$diag.dialog('close');});$diag.dialog({autoOpen:true,title:_loc('Warning on Database Submissions'),modal:true,width:'auto',close:function(event,ui){var $diag=$('#'+diagId);var $cb=$diag.find('input[type=checkbox]');var disable=false;if($cb.length>0){disable=$cb.is(':checked')};$diag.remove();if(disable){$n2.cookie.setCookie({name:'nunaliit_submissions',value:'do not warn',end:(60*60*24*365),path:'/'});};}});};}});$n2.couchDocument={CouchDocumentSource:CouchDocumentSource,CouchDocumentSourceWithSubmissionDb:CouchDocumentSourceWithSubmissionDb,adjustDocument:adjustDocument};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var Attachment=$n2.Class({doc:null,attName:null,mediaRelativePath:null,initialize:function(opts_){var opts=$n2.extend({doc:null,attName:null,mediaRelativePath:null},opts_);this.doc=opts_.doc;this.attName=opts_.attName;this.mediaRelativePath=opts_.mediaRelativePath;},getName:function(){return this.attName;},getStatus:function(){var att=this._getAtt();return att.status;},isAttached:function(){if('attached'!==this.getStatus()){return false;};if(this.doc&&this.doc._attachments&&this.doc._attachments[this.attName]){return true;};return false;},getFileClass:function(){var att=this._getAtt();return att.fileClass;},getMediaFileUrl:function(){var att=this._getAtt();if(att&&att.mediaFile&&this.mediaRelativePath){return this.mediaRelativePath+att.mediaFile;};return null;},getStructure:function(){return this._getAtt();},isSource:function(){var att=this._getAtt();return!att.source;},getThumbnailAttachment:function(){var thumbAtt=null;var att=this._getAtt();if(att){var thumbName=att.thumbnail;if(thumbName){var otherAtt=this._getAtt(thumbName);if(otherAtt){thumbAtt=new Attachment({doc:this.doc,attName:thumbName,mediaRelativePath:this.mediaRelativePath});};};};return thumbAtt;},getOriginalAttachment:function(){var originalAtt=null;var att=this._getAtt();if(att){var originalName=att.originalAttachment;if(originalName){var otherAtt=this._getAtt(originalName);if(otherAtt){originalAtt=new Attachment({doc:this.doc,attName:originalName,mediaRelativePath:this.mediaRelativePath});};};};return originalAtt;},getSourceAttachment:function(){var originalAtt=null;var att=this._getAtt();if(att){var sourceName=att.source;if(sourceName){var otherAtt=this._getAtt(sourceName);if(otherAtt){originalAtt=new Attachment({doc:this.doc,attName:sourceName,mediaRelativePath:this.mediaRelativePath});};};};return originalAtt;},changeStatus:function(status){var att=this._getAtt();if(att){att.status=status;var thumbName=att.thumbnail;if(null!=thumbName){var thumbAtt=this._getAtt(thumbName);if(thumbAtt){thumbAtt.status=status;};};var originalName=att.originalAttachment;if(null!=originalName){var originalAtt=this._getAtt(originalName);if(originalAtt){originalAtt.status=status;};};};},_getAtt:function(name){name=name?name:this.attName;if(this.doc&&this.doc.nunaliit_attachments&&this.doc.nunaliit_attachments.files&&this.doc.nunaliit_attachments.files[name]){return this.doc.nunaliit_attachments.files[name];};return null;}});function getAttachmentFromName(doc,attachmentName,mediaRelativePath){var att=null;if(doc&&doc.nunaliit_attachments&&doc.nunaliit_attachments.files&&doc.nunaliit_attachments.files[attachmentName]){att=new Attachment({doc:doc,attName:attachmentName,mediaRelativePath:mediaRelativePath});};return att;};function getAttachments(doc,mediaRelativePath){var result=[];if(doc&&doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){var att=new Attachment({doc:doc,attName:attName,mediaRelativePath:mediaRelativePath});if(att){result.push(att);};};};return result;};var AttachmentService=$n2.Class({mediaRelativePath:null,initialize:function(opts_){var opts=$n2.extend({mediaRelativePath:null},opts_);this.mediaRelativePath=opts.mediaRelativePath;},getAttachments:function(doc){return getAttachments(doc,this.mediaRelativePath);},getAttachment:function(doc,attachmentName){return getAttachmentFromName(doc,attachmentName,this.mediaRelativePath);}});$n2.couchAttachment={AttachmentService:AttachmentService,getAttachments:getAttachments,getAttachmentFromName:getAttachmentFromName};})(jQuery,nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-mobile',args);};function Configure(opts_){var opts=$n2.extend({couchDbUrl:null,onSuccess:function(config){},onError:function(err){}},opts_);var config={directory:{}};config.directory.dispatchService=new $n2.dispatch.Dispatcher();$n2.couch.getServer({pathToServer:opts.couchDbUrl,onSuccess:couchServerCreated,onError:function(err){opts.onError('unable to connect to couchDb server: '+err);}});function couchServerCreated(server){config.directory.couchServer=server;config.directory.configDb=new $n2.mobileConfigDb.ConfigDb({couchServer:config.directory.couchServer});config.directory.configDb.createDb({onSuccess:configDbCreated,onError:function(err){opts.onError('unable to create config database: '+err);}})};function configDbCreated(){done();};function done(){opts.onSuccess(config);};};$n2.mobileConfig={Configure:Configure};})(nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-mobile',args);};var HTTP='http://';var HTTPS='https://';var PROT_SEPARATOR='://';var Connection=$n2.Class({doc:null,configDb:null,initialize:function(doc,configDb){this.doc=doc;this.configDb=configDb;},getConnectionId:function(){return this.doc._id;},getLabel:function(){return this.doc.label;},getLocalDbName:function(){return this.doc.local.dbName;},getRemoteDbName:function(){return this.doc.remote.dbName;},getRemoteProtocol:function(){return this.doc.remote.protocol;},getRemoteServer:function(){return this.doc.remote.server;},getRemoteUser:function(){return this.doc.remote.user;},getRemotePassword:function(){return this.doc.remote.password;},getRemoteServerUrl:function(){var url=this.getRemoteServer();var user=this.getRemoteUser();var pw=this.getRemotePassword();var index=url.indexOf(PROT_SEPARATOR);if(index>=0&&user&&pw){var prot=url.substr(0,index+PROT_SEPARATOR.length);var suffix=url.substr(index+PROT_SEPARATOR.length);url=prot+user+':'+pw+'@'+suffix;};return url;},getRemoteDbUrl:function(){return this.getRemoteServerUrl()+this.getRemoteDbName();},save:function(opts_){var opts=$n2.extend({onSuccess:function(){},onError:function(err){}},opts_);var _this=this;if(this.doc._id&&this.doc._rev){this._getDb().updateDocument({data:this.doc,onSuccess:function(docInfo){_this.doc._rev=docInfo.rev;opts.onSuccess();},onError:function(err){opts.onError('Unable to save connection: '+err);}});}else{this._getDb().createDocument({data:this.doc,onSuccess:function(docInfo){_this.doc._id=docInfo.id;_this.doc._rev=docInfo.rev;opts.onSuccess();},onError:function(err){opts.onError('Unable to save connection: '+err);}});};},deleteConnection:function(opts_){var opts=$n2.extend({onSuccess:function(){},onError:function(err){},onProgress:function(str){}},opts_);this.configDb.removeConnection({connection:this,onSuccess:opts.onSuccess,onError:opts.onError,onProgress:opts.onProgress});},createLocalDb:function(opts_){var opts=$n2.extend({dbName:null,onSuccess:function(db){},onError:function(err){}},opts_);var _this=this;var couchServer=this._getCouchServer();var baseName=opts.dbName;var count=0;var limit=30;var currentName=baseName;findAvailableDbName();function findAvailableDbName(){var testDb=couchServer.getDb({dbName:currentName});testDb.getInfo({onError:createDb,onSuccess:function(){--limit;if(limit<=0){opts.onError('Unable to find available local name');}else{++count;currentName=baseName+'_'+count;findAvailableDbName();};}});};function createDb(){$n2.log('Creating local database: '+currentName);couchServer.createDb({dbName:currentName,onSuccess:function(db){_this.doc.local.dbName=currentName;opts.onSuccess(db,currentName);},onError:function(err){opts.onError('Unable to create local database: '+err)}});};},getLocalDb:function(){var couchServer=this._getCouchServer();var db=couchServer.getDb({dbName:this.doc.local.dbName});return db;},deleteLocalDb:function(opts_){var opts=$n2.extend({onSuccess:function(){},onError:function(err){}},opts_);var _this=this;var localDbName=this.getLocalDbName();if(!localDbName){opts.onSuccess();}else{var couchServer=this._getCouchServer();couchServer.deleteDb({dbName:localDbName,onSuccess:function(){_this.doc.local.dbName=null;opts.onSuccess();},onError:opts.onError});};},verifyRemoteCommunications:function(opts_){var opts=$n2.extend({authenticate:false,verifyDbName:false,verifyDesignDoc:false,onSuccess:function(remoteServer,remoteDb){},onError:function(err){},onProgress:function(str){}},opts_);var remoteServerUrl=this.getRemoteServerUrl();var remoteUser=this.getRemoteUser();var remotePassword=this.getRemotePassword();var remoteDbName=this.getRemoteDbName();var remoteDb=null;opts.onProgress('verifyRemoteCommunications: remoteServerUrl='+remoteServerUrl);var remoteServer=$n2.couch.getServer({pathToServer:remoteServerUrl+'/',skipSessionInitialization:true,onSuccess:function(){var version=remoteServer.getVersion();opts.onProgress('Remote Server contacted. Version: '+version);remoteAuthenticate();},onError:function(err){remoteServerError('Can not reach remote server: '+err);}});function remoteAuthenticate(){if(!opts.authenticate){checkRemoteDatabaseName();}else if(remoteUser&&remotePassword){opts.onProgress('Authenticating with remote server...');remoteServer.getSession().login({name:remoteUser,password:remotePassword,onSuccess:checkRemoteDatabaseName,onError:remoteServerError});}else{checkRemoteDatabaseName();};};function checkRemoteDatabaseName(){remoteDb=remoteServer.getDb({dbName:remoteDbName});if(!opts.verifyDbName){communicationsOK();}else{opts.onProgress('Connecting to remote database...');remoteDb.getInfo({onSuccess:checkRemoteDatabaseDesignDocument,onError:function(){remoteServerError('Can not find database on remote server');}});};};function checkRemoteDatabaseDesignDocument(){if(!opts.verifyDesignDoc){communicationsOK();}else{opts.onProgress('Verifying remote database...');remoteDb.getDocumentRevision({docId:'_design/mobile',onSuccess:communicationsOK,onError:function(){remoteServerError('Unable to detect proper design in remote database');}});};};function communicationsOK(){opts.onSuccess(remoteServer,remoteDb);};function remoteServerError(err){opts.onProgress('Error: '+err);opts.onError(err);};},syncConnection:function(opts_){var opts=$n2.extend({onSuccess:function(){},onError:function(err){},onProgress:function(str){}},opts_);var _this=this;var currentDb=this._getDb();var couchServer=this._getCouchServer();var remoteServer=null;var remoteDb=null;var allDocIds=null;var downloadDocIds=null;var purgeDocIds=null;var remoteDocIdsToDelete=null;var purgedDocIdsNotOnRemote=null;var remoteDbUrl=this.getRemoteDbUrl();opts.onProgress('Trying to reach remote server');this.verifyRemoteCommunications({authenticate:true,verifyDbName:true,onSuccess:function(remoteServer_,remoteDb_){remoteServer=remoteServer_;remoteDb=remoteDb_;obtainListOfUploads();},onError:opts.onError,onProgress:opts.onProgress});function obtainListOfUploads(){opts.onProgress('Computing list of documents to synchronize');currentDb.listAllDocuments({onSuccess:function(docIds_){allDocIds=docIds_;upgrade();},onError:function(err){opts.onError('Error during replication to remote server: '+err);}});};function upgrade(){opts.onProgress('Updating design documents from remote server');opts.onProgress('remoteDbUrl='+remoteDbUrl);opts.onProgress('_this.getLocalDbName()='+_this.getLocalDbName());couchServer.replicate({source:remoteDbUrl,target:_this.getLocalDbName(),filter:'mobile/onlyMobileApplication',onSuccess:getRemoteDownloadList,onError:function(err){opts.onError('Error during replication from remote server: '+err);}});};function getRemoteDownloadList(){opts.onProgress('Get remote download document list');var remoteMobileDesignDoc=remoteDb.getDesignDoc({ddName:'mobile'});remoteMobileDesignDoc.queryView({viewName:'download-list',onSuccess:function(rows){downloadDocIds=[];for(var i=0,e=rows.length;i<e;++i){downloadDocIds.push(rows[i].key);};download();},onError:function(err){opts.onError('Error getting remote list of documents to download: '+err);}});};function download(){opts.onProgress('Downloading from remote server');var docIds=[];for(var i=0,e=allDocIds.length;i<e;++i){docIds.push(allDocIds[i]);};for(var i=0,e=downloadDocIds.length;i<e;++i){docIds.push(downloadDocIds[i]);};couchServer.replicate({source:remoteDbUrl,target:_this.getLocalDbName(),docIds:docIds,onSuccess:upload,onError:function(err){opts.onError('Error during replication from remote server: '+err);}});};function upload(){opts.onProgress('Uploading to remote server');couchServer.replicate({source:_this.getLocalDbName(),target:remoteDbUrl,filter:'mobile/notDeleted',onSuccess:forceViewCheckpoint,onError:function(err){opts.onError('Error during replication to remote server: '+err);}});};function forceViewCheckpoint(){opts.onProgress('Force view checkpoint');_this._getDesignDoc().queryView({viewName:'text-search',limit:25,onSuccess:done,onError:function(err){done();}});};function done(){opts.onProgress('Completed');opts.onSuccess();};},getConfiguration:function(opts_){var opts=$n2.extend({onSuccess:function(config){},onError:function(err){}},opts_);var configuration={directory:{}};alert('Get configuration');configuration.couchServer=this._getCouchServer();configuration.directory.couchServer=configuration.couchServer;configuration.atlasDb=this.getLocalDb();configuration.atlasDesign=configuration.atlasDb.getDesignDoc({ddName:'mobile'});configuration.documentSource=new $n2.couchDocument.CouchDocumentSource({id:'main',db:configuration.atlasDb,dispatchService:configuration.directory.dispatchService});configuration.directory.schemaRepository=new $n2.couchSchema.CouchSchemaRepository({db:configuration.atlasDb,designDoc:configuration.atlasDesign,dispatchService:configuration.directory.dispatchService,preload:true,preloadedCallback:schemasPreloaded,onError:function(err){opts.onError(err);}});function schemasPreloaded(){alert('Get configuration');configuration.atlasDb.getChangeNotifier({onSuccess:function(notifier){configuration.directory.notifierService=notifier;notifierInitialized();}});};function notifierInitialized(){configuration.directory.searchService=new $n2.couchSearch.SearchServer({designDoc:configuration.atlasDesign,db:configuration.atlasDb,dateService:null,directory:configuration.directory});configuration.directory.requestService=new $n2.couchRequests({db:configuration.atlasDb,userDb:null,designDoc:configuration.atlasDesign,dispatchService:configuration.directory.dispatchService,userServerUrl:null});configuration.directory.dispatchSupport=new $n2.couchDispatchSupport.DispatchSupport({db:configuration.atlasDb,directory:configuration.directory});configuration.directory.attachmentService=new $n2.couchAttachment.AttachmentService({mediaRelativePath:options.mediaUrl});configuration.directory.showService=new $n2.couchShow.Show({db:configuration.atlasDb,documentSource:configuration.documentSource,requestService:configuration.directory.requestService,notifierService:configuration.directory.notifierService,dispatchService:configuration.directory.dispatchService,schemaRepository:configuration.directory.schemaRepository,customService:configuration.directory.customService});configuration.directory.createDocProcess=new $n2.couchRelatedDoc.CreateRelatedDocProcess({documentSource:configuration.documentSource,schemaRepository:configuration.directory.schemaRepository,uploadService:configuration.directory.uploadService,showService:configuration.directory.showService,authService:configuration.directory.authService});configuration.directory.schemaEditorService=new $n2.CouchEditor.SchemaEditorService({documentSource:configuration.documentSource,showService:configuration.directory.showService,searchService:configuration.directory.searchService,dispatchService:configuration.directory.dispatchService});configuration.couchEditor=new $n2.CouchEditor.Editor({documentSource:configuration.documentSource,schemaRepository:configuration.directory.schemaRepository,uploadService:configuration.directory.uploadService,showService:configuration.directory.showService,authService:configuration.directory.authService,dispatchService:configuration.directory.dispatchService,searchService:configuration.directory.searchService,schemaEditorService:configuration.directory.schemaEditorService,customService:configuration.directory.customService});configuration.directory.serverSideNotifier=new $n2.couchServerSide.Notifier({dbChangeNotifier:configuration.directory.notifierService,directory:configuration.directory});configuration.directory.hoverSoundService=new $n2.couchSound.HoverSoundService({db:configuration.atlasDb,serviceDirectory:configuration.directory});var geoNamesOptions={};if(window.nunaliit_custom&&window.nunaliit_custom.geoNames){if(window.nunaliit_custom.geoNames.username){geoNamesOptions.username=window.nunaliit_custom.geoNames.username;};};configuration.directory.geoNamesService=new $n2.GeoNames.Service(geoNamesOptions);done();};function done(){opts.onSuccess(configuration);};},_getCouchServer:function(){return this.configDb.couchServer;},_getDb:function(){return this.configDb.db;},_getDesignDoc:function(){var db=this._getDb();var dd=db.getDesignDoc({ddName:'nunaliit'});return dd;}});var ConfigDb=$n2.Class({couchServer:null,dbName:null,db:null,designDoc:null,initialize:function(opts_){var opts=$n2.extend({couchServer:null,dbName:'nunaliit_mobile_config'},opts_);this.couchServer=opts.couchServer;this.dbName=opts.dbName;this.db=this.couchServer.getDb({dbName:opts.dbName});this.designDoc=this.db.getDesignDoc({ddName:'nunaliit'});},createDb:function(opts_){var opts=$n2.extend({onSuccess:function(){},onError:function(err){}},opts_);var _this=this;this.couchServer.listDatabases({onSuccess:function(dbNames){if(dbNames.indexOf(_this.dbName)>=0){$n2.log('nunaliit2 configDb already exists');loadDesignDoc();}else{performCreateDb();};},onError:opts.onError});function performCreateDb(){$n2.log('creating nunaliit2 configDb');_this.couchServer.createDb({dbName:_this.dbName,onSuccess:loadDesignDoc,onError:opts.onError});};function loadDesignDoc(){var designDoc={_id:'_design/nunaliit',language:'javascript',n2Version:1,views:{identity:{map:"function(doc){emit(doc._id,null);}"},connections:{map:"function(doc){if(doc.nunaliit_type==='connection'){emit(doc._id,null);};}"}}};_this.db.getDocument({docId:designDoc._id,onSuccess:function(dbDoc){if(designDoc.n2Version===dbDoc.n2Version){initDocs();}else{$n2.log('updating configDb design document');designDoc._rev=dbDoc._rev;_this.db.updateDocument({data:designDoc,onSuccess:initDocs,onError:function(err){opts.onError('Unable to update configuration design document: '+err);}});};},onError:function(errorMsg){$n2.log('creating configDb design document');_this.db.createDocument({data:designDoc,onSuccess:initDocs,onError:function(err){opts.onError('Unable to create configuration design document: '+err);}});}});}
function initDocs(){var docs=[{_id:'currentDb',nunaliit_type:'currentDb',connectionId:null}];nextDoc();function nextDoc(){if(docs.length<1){done();return;};var doc=docs.pop();var docId=doc._id;_this.db.getDocument({docId:docId,onSuccess:nextDoc,onError:function(errorMsg){$n2.log('creating configDb document: '+docId);_this.db.createDocument({data:doc,onSuccess:nextDoc,onError:function(err){opts.onError('Unable to upload default documents to configDb: '+err);}});}});};};function done(){opts.onSuccess();};},getConnections:function(opts_){var opts=$n2.extend({onSuccess:function(connections){},onError:function(err){}},opts_);var _this=this;this.designDoc.queryView({viewName:'connections',include_docs:true,onSuccess:function(rows){var conns=[];for(var i=0,e=rows.length;i<e;++i){var connDoc=rows[i].doc;console.log('connDoc : '+connDoc);var conn=new Connection(connDoc,_this);conns.push(conn);};opts.onSuccess(conns);},onError:opts.onError});},getConnection:function(opts_){var opts=$n2.extend({id:null,onSuccess:function(connection){},onError:function(err){}},opts_);var _this=this;this.db.getDocument({docId:opts.id,onSuccess:function(doc){var conn=new Connection(doc,_this);opts.onSuccess(conn);},onError:function(err){opts.onError('Can not find connection document: '+err);}});},addConnection:function(opts_){var opts=$n2.extend({remoteAtlasUrl:null,remoteUser:null,remotePassword:null,onSuccess:function(connection){},onError:function(err){},onProgress:function(str){}},opts_);var _this=this;var connDoc={nunaliit_type:'connection',label:'???',local:{dbName:null},remote:{protocol:'http',server:null,dbName:null,atlasServer:null,user:opts.remoteUser,password:opts.remotePassword}};var remoteAtlasUrl=opts.remoteAtlasUrl;var remoteAtlasUrl=opts.remoteAtlasUrl.toLowerCase();if(remoteAtlasUrl.substr(0,HTTP.length)===HTTP){remoteAtlasUrl=remoteAtlasUrl.substr(HTTP.length);}else if(remoteAtlasUrl.substr(0,HTTPS.length)===HTTPS){remoteAtlasUrl=remoteAtlasUrl.substr(HTTPS.length);connDoc.remote.protocol='https';};if(remoteAtlasUrl[remoteAtlasUrl.length-1]==='/'){remoteAtlasUrl=remoteAtlasUrl.substr(0,server.length-1);};connDoc.remote.atlasServer=remoteAtlasUrl;var effectiveRemoteAtlasUrl=connDoc.remote.protocol+'://'+remoteAtlasUrl+'/';this.findRemoteServerParameters({serverUrl:effectiveRemoteAtlasUrl,onSuccess:parametersLoaded,onError:function(err){opts.onError('Unable to find remote parameters: '+err);},onProgress:opts.onProgress});var connection=null;function parametersLoaded(serverUrl,dbName){opts.onProgress('Parameters: '+serverUrl+' '+dbName);connDoc.remote.server=serverUrl;connDoc.remote.dbName=dbName;_this.computeNewConnectionLabel({remoteDbName:connDoc.remote.dbName,remoteServerName:connDoc.remote.atlasServer,onSuccess:function(label){connDoc.label=label;opts.onProgress(label);connection=new Connection(connDoc,_this);checkCommunications();},onError:opts.onError});};function checkCommunications(){opts.onProgress('checkCommunications');connection.verifyRemoteCommunications({authenticate:true,verifyDbName:true,verifyDesignDoc:true,onSuccess:createLocalDb,onError:opts.onError,onProgress:opts.onProgress});};function createLocalDb(){opts.onProgress('createLocalDb');connection.createLocalDb({dbName:connDoc.remote.dbName,onSuccess:saveConnection,onError:opts.onError});};function saveConnection(){opts.onProgress('saveConnection');connection.save({onSuccess:replicate,onError:function(){connection.deleteLocalDb({onSuccess:opts.onError,onError:opts.onError,onProgress:opts.onProgress});}});};function replicate(){opts.onProgress('replicate');connection.syncConnection({onSuccess:setCurrent,onError:function(err){opts.onError('Error synchronizing database: '+err);},onProgress:opts.onProgress});};function setCurrent(){opts.onProgress('Set new connection as current one');_this.setCurrentConnection({connection:connection,onSuccess:done,onError:function(err){opts.onError('Error while saving current connection: '+err);}});};function done(){opts.onProgress('Completed');opts.onSuccess(connection);};},removeConnection:function(opts_){var opts=$n2.extend({connection:null,onSuccess:function(){},onError:function(err){},onProgress:function(str){}},opts_);var _this=this;var connId=opts.connection.getConnectionId();this.db.getDocument({docId:connId,onSuccess:connDocLoaded,onError:function(err){opts.onError('Unable to find connection document: '+connId);}});function connDocLoaded(connDoc){var dbName=connDoc.local.dbName;_this.couchServer.deleteDb({dbName:dbName,onSuccess:function(){dbDeleted(connDoc);},onError:function(err){opts.onError('Unable to delete local database');}});};function dbDeleted(connDoc){var dbName=connDoc.local.dbName;_this.db.deleteDocument({data:connDoc,onSuccess:opts.onSuccess,onError:function(err){opts.onError('Unable to delete connection document');}});};},findRemoteServerParameters:function(opts_){var opts=$n2.extend({serverUrl:null,onSuccess:function(serverUrl,dbName){},onError:function(err){},onProgress:function(str){}},opts_);var dbName=null;var remoteServerUrl=null;opts.onProgress('Find remote database');var dbUrl=opts.serverUrl+'db';opts.onProgress('dbUrl: '+dbUrl);$.ajax({url:dbUrl,type:'get',async:true,dataType:'json'}).done(function(data){dbName=data.db_name;if(dbName){findRemoteServer();}else{opts.onError('Can not find name of remote database');};}).fail(function(jqXHR,textStatus,errorThrown){opts.onError('Can not reach remote database');});function findRemoteServer(){opts.onProgress('Find remote server');remoteServerUrl=opts.serverUrl+'server/';$.ajax({url:remoteServerUrl,type:'get',async:true,dataType:'json'}).done(function(data){if(data.couchdb){opts.onSuccess(remoteServerUrl,dbName);}else{opts.onError('Can not find remote server');};}).fail(function(jqXHR,textStatus,errorThrown){opts.onError('Can not reach remote server');});};},computeNewConnectionLabel:function(opts_){var opts=$n2.extend({remoteDbName:null,remoteServerName:null,onSuccess:function(label){},onError:function(err){}},opts_);var _this=this;var labels={};this.getConnections({onSuccess:function(connections){for(var i=0,e=connections.length;i<e;++i){var connection=connections[i];var label=connection.getLabel();labels[label]=true;};pickLabel();},onError:opts.onError});function pickLabel(){var baseLabel=opts.remoteDbName+' ('+opts.remoteServerName+')';var index=0;var limit=30;var currentLabel=baseLabel;while(labels[currentLabel]){++index;--limit;if(limit<=0){opts.onError('Unable to find a unique label');};currentLabel=baseLabel+' - '+index;};opts.onSuccess(currentLabel);};},setCurrentConnection:function(opts_){var opts=$n2.extend({connection:null,onSuccess:function(){},onError:function(err){}},opts_);var connectionId=null;if(opts.connection){connectionId=opts.connection.getConnectionId();};var db=this.db;db.getDocument({docId:'currentDb',onSuccess:function(currentDoc){currentDoc.connectionId=connectionId;db.updateDocument({data:currentDoc,onSuccess:success,onError:opts.onError});},onError:function(){var currentDoc={_id:'currentDb',nunaliit_type:'currentDb',connectionId:connectionId};db.createDocument({data:currentDoc,onSuccess:success,onError:opts.onError});}});function success(){opts.onSuccess();};}});$n2.mobileConfigDb={ConfigDb:ConfigDb};})(nunaliit2);